/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(306), /*)*//*default:*//*Label 78*/ GIMT_Encode4(130914),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1022),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10349),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13593),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15297),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15393), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15489),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18669),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24478), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26173), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26560), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35572),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35868), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 12*/ GIMT_Encode4(36131), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 13*/ GIMT_Encode4(36294), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 14*/ GIMT_Encode4(36315),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 15*/ GIMT_Encode4(91487), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 16*/ GIMT_Encode4(99149),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 17*/ GIMT_Encode4(99307),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 18*/ GIMT_Encode4(99465),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 19*/ GIMT_Encode4(99786), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 20*/ GIMT_Encode4(99882),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 21*/ GIMT_Encode4(100040),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 22*/ GIMT_Encode4(100645),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 23*/ GIMT_Encode4(100803),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 24*/ GIMT_Encode4(101019),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 25*/ GIMT_Encode4(101127), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 26*/ GIMT_Encode4(101400), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 27*/ GIMT_Encode4(101732),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 28*/ GIMT_Encode4(101980),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 29*/ GIMT_Encode4(102349),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 30*/ GIMT_Encode4(102994),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 31*/ GIMT_Encode4(104294),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 32*/ GIMT_Encode4(104939), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 33*/ GIMT_Encode4(105959),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 34*/ GIMT_Encode4(108312),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 35*/ GIMT_Encode4(109989),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 36*/ GIMT_Encode4(110970), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 37*/ GIMT_Encode4(113061), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 38*/ GIMT_Encode4(113226),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 39*/ GIMT_Encode4(114757),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 40*/ GIMT_Encode4(114993),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 41*/ GIMT_Encode4(115265),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 42*/ GIMT_Encode4(116599),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 43*/ GIMT_Encode4(117933),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 44*/ GIMT_Encode4(118585), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 45*/ GIMT_Encode4(119237), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 46*/ GIMT_Encode4(120013),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 47*/ GIMT_Encode4(120605), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 48*/ GIMT_Encode4(121197),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 49*/ GIMT_Encode4(121931),
     /*    662 */ /*TargetOpcode::G_GET_FPENV*//*Label 50*/ GIMT_Encode4(122665),
     /*    666 */ /*TargetOpcode::G_SET_FPENV*//*Label 51*/ GIMT_Encode4(122698),
     /*    670 */ /*TargetOpcode::G_RESET_FPENV*//*Label 52*/ GIMT_Encode4(122734),
     /*    674 */ /*TargetOpcode::G_GET_FPMODE*//*Label 53*/ GIMT_Encode4(122863), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    694 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(122896),
     /*    698 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(123439),
     /*    702 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(123982),
     /*    706 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(124903),
     /*    710 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(125824), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    722 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(126295), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    742 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 60*/ GIMT_Encode4(126368),
     /*    746 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126668), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTLZ*//*Label 62*/ GIMT_Encode4(126725), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTPOP*//*Label 63*/ GIMT_Encode4(127286),
     /*    786 */ /*TargetOpcode::G_BSWAP*//*Label 64*/ GIMT_Encode4(127394),
     /*    790 */ /*TargetOpcode::G_BITREVERSE*//*Label 65*/ GIMT_Encode4(127684),
     /*    794 */ /*TargetOpcode::G_FCEIL*//*Label 66*/ GIMT_Encode4(128116), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    842 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(128379),
     /*    846 */ /*TargetOpcode::G_FFLOOR*//*Label 68*/ GIMT_Encode4(128517),
     /*    850 */ /*TargetOpcode::G_FRINT*//*Label 69*/ GIMT_Encode4(128780),
     /*    854 */ /*TargetOpcode::G_FNEARBYINT*//*Label 70*/ GIMT_Encode4(129076), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    942 */ /*TargetOpcode::G_TRAP*//*Label 71*/ GIMT_Encode4(129214),
     /*    946 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 72*/ GIMT_Encode4(129260), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 73*/ GIMT_Encode4(129347), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 74*/ GIMT_Encode4(129768),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 75*/ GIMT_Encode4(130048),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 76*/ GIMT_Encode4(130337),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 77*/ GIMT_Encode4(130618),
     /*   1022 */ // Label 0: @1022
     /*   1022 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 88*/ GIMT_Encode4(10348),
     /*   1033 */ /*GILLT_s32*//*Label 79*/ GIMT_Encode4(1093),
     /*   1037 */ /*GILLT_s64*//*Label 80*/ GIMT_Encode4(6869), GIMT_Encode4(0),
     /*   1045 */ /*GILLT_v2s32*//*Label 81*/ GIMT_Encode4(6916),
     /*   1049 */ /*GILLT_v2s64*//*Label 82*/ GIMT_Encode4(7101), GIMT_Encode4(0),
     /*   1057 */ /*GILLT_v4s16*//*Label 83*/ GIMT_Encode4(7812),
     /*   1061 */ /*GILLT_v4s32*//*Label 84*/ GIMT_Encode4(7997), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1073 */ /*GILLT_v8s8*//*Label 85*/ GIMT_Encode4(8953),
     /*   1077 */ /*GILLT_v8s16*//*Label 86*/ GIMT_Encode4(9138), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1089 */ /*GILLT_v16s8*//*Label 87*/ GIMT_Encode4(10094),
     /*   1093 */ // Label 79: @1093
     /*   1093 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(6868),
     /*   1098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1104 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1179), // Rule ID 5667 //
     /*   1109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1137 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1154 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1177 */     GIR_RootConstrainSelectedInstOperands,
     /*   1178 */     // GIR_Coverage, 5667,
     /*   1178 */     GIR_EraseRootFromParent_Done,
     /*   1179 */   // Label 90: @1179
     /*   1179 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1254), // Rule ID 5668 //
     /*   1184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1212 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1229 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1252 */     GIR_RootConstrainSelectedInstOperands,
     /*   1253 */     // GIR_Coverage, 5668,
     /*   1253 */     GIR_EraseRootFromParent_Done,
     /*   1254 */   // Label 91: @1254
     /*   1254 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1329), // Rule ID 5702 //
     /*   1259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1287 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1304 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1327 */     GIR_RootConstrainSelectedInstOperands,
     /*   1328 */     // GIR_Coverage, 5702,
     /*   1328 */     GIR_EraseRootFromParent_Done,
     /*   1329 */   // Label 92: @1329
     /*   1329 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1404), // Rule ID 5703 //
     /*   1334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1362 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1379 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1402 */     GIR_RootConstrainSelectedInstOperands,
     /*   1403 */     // GIR_Coverage, 5703,
     /*   1403 */     GIR_EraseRootFromParent_Done,
     /*   1404 */   // Label 93: @1404
     /*   1404 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1479), // Rule ID 1997 //
     /*   1409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1441 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1454 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1477 */     GIR_RootConstrainSelectedInstOperands,
     /*   1478 */     // GIR_Coverage, 1997,
     /*   1478 */     GIR_EraseRootFromParent_Done,
     /*   1479 */   // Label 94: @1479
     /*   1479 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1554), // Rule ID 1998 //
     /*   1484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1516 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1529 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1552 */     GIR_RootConstrainSelectedInstOperands,
     /*   1553 */     // GIR_Coverage, 1998,
     /*   1553 */     GIR_EraseRootFromParent_Done,
     /*   1554 */   // Label 95: @1554
     /*   1554 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1629), // Rule ID 2236 //
     /*   1559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1591 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1604 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1627 */     GIR_RootConstrainSelectedInstOperands,
     /*   1628 */     // GIR_Coverage, 2236,
     /*   1628 */     GIR_EraseRootFromParent_Done,
     /*   1629 */   // Label 96: @1629
     /*   1629 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1704), // Rule ID 2237 //
     /*   1634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1657 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1666 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1679 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1702 */     GIR_RootConstrainSelectedInstOperands,
     /*   1703 */     // GIR_Coverage, 2237,
     /*   1703 */     GIR_EraseRootFromParent_Done,
     /*   1704 */   // Label 97: @1704
     /*   1704 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1832), // Rule ID 5678 //
     /*   1709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1760 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1765 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1769 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1773 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1777 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1781 */     // MIs[4] Rm
     /*   1781 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1786 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1790 */     // MIs[1] Operand 2
     /*   1790 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1805 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1807 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1830 */     GIR_RootConstrainSelectedInstOperands,
     /*   1831 */     // GIR_Coverage, 5678,
     /*   1831 */     GIR_EraseRootFromParent_Done,
     /*   1832 */   // Label 98: @1832
     /*   1832 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1960), // Rule ID 5679 //
     /*   1837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1864 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1868 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1880 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1884 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1888 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1893 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1901 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1905 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1909 */     // MIs[4] Rm
     /*   1909 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1914 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1918 */     // MIs[1] Operand 2
     /*   1918 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1933 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1935 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1958 */     GIR_RootConstrainSelectedInstOperands,
     /*   1959 */     // GIR_Coverage, 5679,
     /*   1959 */     GIR_EraseRootFromParent_Done,
     /*   1960 */   // Label 99: @1960
     /*   1960 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2088), // Rule ID 2103 //
     /*   1965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2025 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2029 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2033 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2037 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2041 */     // MIs[4] Rm
     /*   2041 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2046 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2050 */     // MIs[1] Operand 2
     /*   2050 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2061 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2063 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2086 */     GIR_RootConstrainSelectedInstOperands,
     /*   2087 */     // GIR_Coverage, 2103,
     /*   2087 */     GIR_EraseRootFromParent_Done,
     /*   2088 */   // Label 100: @2088
     /*   2088 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2216), // Rule ID 5677 //
     /*   2093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2140 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2144 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2148 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2153 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2157 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2161 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2165 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2169 */     // MIs[4] Rm
     /*   2169 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2174 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2178 */     // MIs[1] Operand 2
     /*   2178 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2191 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2214 */     GIR_RootConstrainSelectedInstOperands,
     /*   2215 */     // GIR_Coverage, 5677,
     /*   2215 */     GIR_EraseRootFromParent_Done,
     /*   2216 */   // Label 101: @2216
     /*   2216 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2326), // Rule ID 5446 //
     /*   2221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2265 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2269 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2273 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2277 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2281 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2285 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2290 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2300 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2324 */     GIR_RootConstrainSelectedInstOperands,
     /*   2325 */     // GIR_Coverage, 5446,
     /*   2325 */     GIR_EraseRootFromParent_Done,
     /*   2326 */   // Label 102: @2326
     /*   2326 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2436), // Rule ID 5483 //
     /*   2331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2375 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2383 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2387 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2391 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2395 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2400 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2410 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2434 */     GIR_RootConstrainSelectedInstOperands,
     /*   2435 */     // GIR_Coverage, 5483,
     /*   2435 */     GIR_EraseRootFromParent_Done,
     /*   2436 */   // Label 103: @2436
     /*   2436 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2546), // Rule ID 192 //
     /*   2441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2480 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2489 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2501 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2505 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2509 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2514 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2520 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2544 */     GIR_RootConstrainSelectedInstOperands,
     /*   2545 */     // GIR_Coverage, 192,
     /*   2545 */     GIR_EraseRootFromParent_Done,
     /*   2546 */   // Label 104: @2546
     /*   2546 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2656), // Rule ID 521 //
     /*   2551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2574 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2590 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2599 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2611 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2615 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2619 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2624 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2630 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2654 */     GIR_RootConstrainSelectedInstOperands,
     /*   2655 */     // GIR_Coverage, 521,
     /*   2655 */     GIR_EraseRootFromParent_Done,
     /*   2656 */   // Label 105: @2656
     /*   2656 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2769), // Rule ID 5445 //
     /*   2661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2705 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2717 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2721 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2726 */     // MIs[3] Operand 2
     /*   2726 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2743 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2767 */     GIR_RootConstrainSelectedInstOperands,
     /*   2768 */     // GIR_Coverage, 5445,
     /*   2768 */     GIR_EraseRootFromParent_Done,
     /*   2769 */   // Label 106: @2769
     /*   2769 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2882), // Rule ID 5482 //
     /*   2774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2809 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2818 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2826 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2830 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2834 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2839 */     // MIs[3] Operand 2
     /*   2839 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2856 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2880 */     GIR_RootConstrainSelectedInstOperands,
     /*   2881 */     // GIR_Coverage, 5482,
     /*   2881 */     GIR_EraseRootFromParent_Done,
     /*   2882 */   // Label 107: @2882
     /*   2882 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2995), // Rule ID 5444 //
     /*   2887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2927 */     // MIs[2] Operand 2
     /*   2927 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2946 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2950 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2954 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2959 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2967 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2969 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2993 */     GIR_RootConstrainSelectedInstOperands,
     /*   2994 */     // GIR_Coverage, 5444,
     /*   2994 */     GIR_EraseRootFromParent_Done,
     /*   2995 */   // Label 108: @2995
     /*   2995 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3108), // Rule ID 5481 //
     /*   3000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3040 */     // MIs[2] Operand 2
     /*   3040 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3059 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3063 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3067 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3072 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3082 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3106 */     GIR_RootConstrainSelectedInstOperands,
     /*   3107 */     // GIR_Coverage, 5481,
     /*   3107 */     GIR_EraseRootFromParent_Done,
     /*   3108 */   // Label 109: @3108
     /*   3108 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3221), // Rule ID 191 //
     /*   3113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3161 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3173 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3177 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3182 */     // MIs[3] Operand 2
     /*   3182 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3208 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3219 */     GIR_RootConstrainSelectedInstOperands,
     /*   3220 */     // GIR_Coverage, 191,
     /*   3220 */     GIR_EraseRootFromParent_Done,
     /*   3221 */   // Label 110: @3221
     /*   3221 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3334), // Rule ID 520 //
     /*   3226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3265 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3274 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3286 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3290 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3295 */     // MIs[3] Operand 2
     /*   3295 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3308 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3332 */     GIR_RootConstrainSelectedInstOperands,
     /*   3333 */     // GIR_Coverage, 520,
     /*   3333 */     GIR_EraseRootFromParent_Done,
     /*   3334 */   // Label 111: @3334
     /*   3334 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3447), // Rule ID 190 //
     /*   3339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3383 */     // MIs[2] Operand 2
     /*   3383 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3406 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3410 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3415 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3421 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3445 */     GIR_RootConstrainSelectedInstOperands,
     /*   3446 */     // GIR_Coverage, 190,
     /*   3446 */     GIR_EraseRootFromParent_Done,
     /*   3447 */   // Label 112: @3447
     /*   3447 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3560), // Rule ID 519 //
     /*   3452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3496 */     // MIs[2] Operand 2
     /*   3496 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3515 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3519 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3523 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3528 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3534 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3558 */     GIR_RootConstrainSelectedInstOperands,
     /*   3559 */     // GIR_Coverage, 519,
     /*   3559 */     GIR_EraseRootFromParent_Done,
     /*   3560 */   // Label 113: @3560
     /*   3560 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3651), // Rule ID 5676 //
     /*   3565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3609 */     // MIs[1] Operand 2
     /*   3609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3626 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3649 */     GIR_RootConstrainSelectedInstOperands,
     /*   3650 */     // GIR_Coverage, 5676,
     /*   3650 */     GIR_EraseRootFromParent_Done,
     /*   3651 */   // Label 114: @3651
     /*   3651 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3742), // Rule ID 2102 //
     /*   3656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3700 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3704 */     // MIs[1] Operand 2
     /*   3704 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3717 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3740 */     GIR_RootConstrainSelectedInstOperands,
     /*   3741 */     // GIR_Coverage, 2102,
     /*   3741 */     GIR_EraseRootFromParent_Done,
     /*   3742 */   // Label 115: @3742
     /*   3742 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3858), // Rule ID 5443 //
     /*   3747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3787 */     // MIs[2] Operand 2
     /*   3787 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3810 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3815 */     // MIs[3] Operand 2
     /*   3815 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3832 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3856 */     GIR_RootConstrainSelectedInstOperands,
     /*   3857 */     // GIR_Coverage, 5443,
     /*   3857 */     GIR_EraseRootFromParent_Done,
     /*   3858 */   // Label 116: @3858
     /*   3858 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3974), // Rule ID 5480 //
     /*   3863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3903 */     // MIs[2] Operand 2
     /*   3903 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3922 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3926 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3931 */     // MIs[3] Operand 2
     /*   3931 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3948 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3966 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3972 */     GIR_RootConstrainSelectedInstOperands,
     /*   3973 */     // GIR_Coverage, 5480,
     /*   3973 */     GIR_EraseRootFromParent_Done,
     /*   3974 */   // Label 117: @3974
     /*   3974 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(4090), // Rule ID 189 //
     /*   3979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4018 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4023 */     // MIs[2] Operand 2
     /*   4023 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4042 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4046 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4051 */     // MIs[3] Operand 2
     /*   4051 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4064 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4088 */     GIR_RootConstrainSelectedInstOperands,
     /*   4089 */     // GIR_Coverage, 189,
     /*   4089 */     GIR_EraseRootFromParent_Done,
     /*   4090 */   // Label 118: @4090
     /*   4090 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4206), // Rule ID 518 //
     /*   4095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4139 */     // MIs[2] Operand 2
     /*   4139 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4162 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4167 */     // MIs[3] Operand 2
     /*   4167 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4180 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4198 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4204 */     GIR_RootConstrainSelectedInstOperands,
     /*   4205 */     // GIR_Coverage, 518,
     /*   4205 */     GIR_EraseRootFromParent_Done,
     /*   4206 */   // Label 119: @4206
     /*   4206 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4294), // Rule ID 3245 //
     /*   4211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4262 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4267 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4292 */     GIR_RootConstrainSelectedInstOperands,
     /*   4293 */     // GIR_Coverage, 3245,
     /*   4293 */     GIR_EraseRootFromParent_Done,
     /*   4294 */   // Label 120: @4294
     /*   4294 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4382), // Rule ID 3246 //
     /*   4299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4330 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4350 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4355 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4380 */     GIR_RootConstrainSelectedInstOperands,
     /*   4381 */     // GIR_Coverage, 3246,
     /*   4381 */     GIR_EraseRootFromParent_Done,
     /*   4382 */   // Label 121: @4382
     /*   4382 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4470), // Rule ID 3249 //
     /*   4387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4406 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4410 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4438 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4443 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4468 */     GIR_RootConstrainSelectedInstOperands,
     /*   4469 */     // GIR_Coverage, 3249,
     /*   4469 */     GIR_EraseRootFromParent_Done,
     /*   4470 */   // Label 122: @4470
     /*   4470 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4558), // Rule ID 5947 //
     /*   4475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4510 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4519 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4526 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4531 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4556 */     GIR_RootConstrainSelectedInstOperands,
     /*   4557 */     // GIR_Coverage, 5947,
     /*   4557 */     GIR_EraseRootFromParent_Done,
     /*   4558 */   // Label 123: @4558
     /*   4558 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4646), // Rule ID 5948 //
     /*   4563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4614 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4619 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4644 */     GIR_RootConstrainSelectedInstOperands,
     /*   4645 */     // GIR_Coverage, 5948,
     /*   4645 */     GIR_EraseRootFromParent_Done,
     /*   4646 */   // Label 124: @4646
     /*   4646 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4734), // Rule ID 5951 //
     /*   4651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4682 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4686 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4695 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4702 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4707 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4732 */     GIR_RootConstrainSelectedInstOperands,
     /*   4733 */     // GIR_Coverage, 5951,
     /*   4733 */     GIR_EraseRootFromParent_Done,
     /*   4734 */   // Label 125: @4734
     /*   4734 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4791), // Rule ID 72 //
     /*   4739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4762 */     // MIs[1] Operand 1
     /*   4762 */     // No operand predicates
     /*   4762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4764 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4789 */     GIR_RootConstrainSelectedInstOperands,
     /*   4790 */     // GIR_Coverage, 72,
     /*   4790 */     GIR_EraseRootFromParent_Done,
     /*   4791 */   // Label 126: @4791
     /*   4791 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4848), // Rule ID 303 //
     /*   4796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4819 */     // MIs[1] Operand 1
     /*   4819 */     // No operand predicates
     /*   4819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4821 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4846 */     GIR_RootConstrainSelectedInstOperands,
     /*   4847 */     // GIR_Coverage, 303,
     /*   4847 */     GIR_EraseRootFromParent_Done,
     /*   4848 */   // Label 127: @4848
     /*   4848 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4905), // Rule ID 304 //
     /*   4853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4872 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4876 */     // MIs[1] Operand 1
     /*   4876 */     // No operand predicates
     /*   4876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4878 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4903 */     GIR_RootConstrainSelectedInstOperands,
     /*   4904 */     // GIR_Coverage, 304,
     /*   4904 */     GIR_EraseRootFromParent_Done,
     /*   4905 */   // Label 128: @4905
     /*   4905 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4962), // Rule ID 407 //
     /*   4910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4933 */     // MIs[1] Operand 1
     /*   4933 */     // No operand predicates
     /*   4933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4935 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4960 */     GIR_RootConstrainSelectedInstOperands,
     /*   4961 */     // GIR_Coverage, 407,
     /*   4961 */     GIR_EraseRootFromParent_Done,
     /*   4962 */   // Label 129: @4962
     /*   4962 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(5013), // Rule ID 408 //
     /*   4967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4990 */     // MIs[1] Operand 1
     /*   4990 */     // No operand predicates
     /*   4990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4992 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   4995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5011 */     GIR_RootConstrainSelectedInstOperands,
     /*   5012 */     // GIR_Coverage, 408,
     /*   5012 */     GIR_EraseRootFromParent_Done,
     /*   5013 */   // Label 130: @5013
     /*   5013 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5089), // Rule ID 171 //
     /*   5018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5057 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5087 */     GIR_RootConstrainSelectedInstOperands,
     /*   5088 */     // GIR_Coverage, 171,
     /*   5088 */     GIR_EraseRootFromParent_Done,
     /*   5089 */   // Label 131: @5089
     /*   5089 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5165), // Rule ID 172 //
     /*   5094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5133 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5163 */     GIR_RootConstrainSelectedInstOperands,
     /*   5164 */     // GIR_Coverage, 172,
     /*   5164 */     GIR_EraseRootFromParent_Done,
     /*   5165 */   // Label 132: @5165
     /*   5165 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5235), // Rule ID 503 //
     /*   5170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5209 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5233 */     GIR_RootConstrainSelectedInstOperands,
     /*   5234 */     // GIR_Coverage, 503,
     /*   5234 */     GIR_EraseRootFromParent_Done,
     /*   5235 */   // Label 133: @5235
     /*   5235 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5306), // Rule ID 5669 //
     /*   5240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5264 */     // MIs[1] Operand 2
     /*   5264 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5281 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5304 */     GIR_RootConstrainSelectedInstOperands,
     /*   5305 */     // GIR_Coverage, 5669,
     /*   5305 */     GIR_EraseRootFromParent_Done,
     /*   5306 */   // Label 134: @5306
     /*   5306 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5377), // Rule ID 5670 //
     /*   5311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5335 */     // MIs[1] Operand 2
     /*   5335 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5352 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5375 */     GIR_RootConstrainSelectedInstOperands,
     /*   5376 */     // GIR_Coverage, 5670,
     /*   5376 */     GIR_EraseRootFromParent_Done,
     /*   5377 */   // Label 135: @5377
     /*   5377 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5448), // Rule ID 5704 //
     /*   5382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5406 */     // MIs[1] Operand 2
     /*   5406 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5423 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5440 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5446 */     GIR_RootConstrainSelectedInstOperands,
     /*   5447 */     // GIR_Coverage, 5704,
     /*   5447 */     GIR_EraseRootFromParent_Done,
     /*   5448 */   // Label 136: @5448
     /*   5448 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5519), // Rule ID 5705 //
     /*   5453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5477 */     // MIs[1] Operand 2
     /*   5477 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5494 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5517 */     GIR_RootConstrainSelectedInstOperands,
     /*   5518 */     // GIR_Coverage, 5705,
     /*   5518 */     GIR_EraseRootFromParent_Done,
     /*   5519 */   // Label 137: @5519
     /*   5519 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5589), // Rule ID 180 //
     /*   5524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5563 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5587 */     GIR_RootConstrainSelectedInstOperands,
     /*   5588 */     // GIR_Coverage, 180,
     /*   5588 */     GIR_EraseRootFromParent_Done,
     /*   5589 */   // Label 138: @5589
     /*   5589 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5659), // Rule ID 509 //
     /*   5594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5633 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5657 */     GIR_RootConstrainSelectedInstOperands,
     /*   5658 */     // GIR_Coverage, 509,
     /*   5658 */     GIR_EraseRootFromParent_Done,
     /*   5659 */   // Label 139: @5659
     /*   5659 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5722), // Rule ID 3050 //
     /*   5664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5694 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5699 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5720 */     GIR_RootConstrainSelectedInstOperands,
     /*   5721 */     // GIR_Coverage, 3050,
     /*   5721 */     GIR_EraseRootFromParent_Done,
     /*   5722 */   // Label 140: @5722
     /*   5722 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5785), // Rule ID 3078 //
     /*   5727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5757 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5762 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5783 */     GIR_RootConstrainSelectedInstOperands,
     /*   5784 */     // GIR_Coverage, 3078,
     /*   5784 */     GIR_EraseRootFromParent_Done,
     /*   5785 */   // Label 141: @5785
     /*   5785 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5848), // Rule ID 3088 //
     /*   5790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5820 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5825 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5846 */     GIR_RootConstrainSelectedInstOperands,
     /*   5847 */     // GIR_Coverage, 3088,
     /*   5847 */     GIR_EraseRootFromParent_Done,
     /*   5848 */   // Label 142: @5848
     /*   5848 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5924), // Rule ID 5440 //
     /*   5853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5892 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5922 */     GIR_RootConstrainSelectedInstOperands,
     /*   5923 */     // GIR_Coverage, 5440,
     /*   5923 */     GIR_EraseRootFromParent_Done,
     /*   5924 */   // Label 143: @5924
     /*   5924 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(6000), // Rule ID 5441 //
     /*   5929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5968 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5998 */     GIR_RootConstrainSelectedInstOperands,
     /*   5999 */     // GIR_Coverage, 5441,
     /*   5999 */     GIR_EraseRootFromParent_Done,
     /*   6000 */   // Label 144: @6000
     /*   6000 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6070), // Rule ID 5478 //
     /*   6005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6044 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6068 */     GIR_RootConstrainSelectedInstOperands,
     /*   6069 */     // GIR_Coverage, 5478,
     /*   6069 */     GIR_EraseRootFromParent_Done,
     /*   6070 */   // Label 145: @6070
     /*   6070 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6141), // Rule ID 2001 //
     /*   6075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6103 */     // MIs[1] Operand 2
     /*   6103 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6116 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6139 */     GIR_RootConstrainSelectedInstOperands,
     /*   6140 */     // GIR_Coverage, 2001,
     /*   6140 */     GIR_EraseRootFromParent_Done,
     /*   6141 */   // Label 146: @6141
     /*   6141 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6212), // Rule ID 2002 //
     /*   6146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6174 */     // MIs[1] Operand 2
     /*   6174 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6187 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6210 */     GIR_RootConstrainSelectedInstOperands,
     /*   6211 */     // GIR_Coverage, 2002,
     /*   6211 */     GIR_EraseRootFromParent_Done,
     /*   6212 */   // Label 147: @6212
     /*   6212 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6283), // Rule ID 2240 //
     /*   6217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6245 */     // MIs[1] Operand 2
     /*   6245 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6258 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6281 */     GIR_RootConstrainSelectedInstOperands,
     /*   6282 */     // GIR_Coverage, 2240,
     /*   6282 */     GIR_EraseRootFromParent_Done,
     /*   6283 */   // Label 148: @6283
     /*   6283 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6354), // Rule ID 2241 //
     /*   6288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6316 */     // MIs[1] Operand 2
     /*   6316 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6329 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6352 */     GIR_RootConstrainSelectedInstOperands,
     /*   6353 */     // GIR_Coverage, 2241,
     /*   6353 */     GIR_EraseRootFromParent_Done,
     /*   6354 */   // Label 149: @6354
     /*   6354 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6424), // Rule ID 5442 //
     /*   6359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6398 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6416 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6422 */     GIR_RootConstrainSelectedInstOperands,
     /*   6423 */     // GIR_Coverage, 5442,
     /*   6423 */     GIR_EraseRootFromParent_Done,
     /*   6424 */   // Label 150: @6424
     /*   6424 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6494), // Rule ID 5479 //
     /*   6429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6468 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6492 */     GIR_RootConstrainSelectedInstOperands,
     /*   6493 */     // GIR_Coverage, 5479,
     /*   6493 */     GIR_EraseRootFromParent_Done,
     /*   6494 */   // Label 151: @6494
     /*   6494 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6557), // Rule ID 5923 //
     /*   6499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6529 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6534 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6555 */     GIR_RootConstrainSelectedInstOperands,
     /*   6556 */     // GIR_Coverage, 5923,
     /*   6556 */     GIR_EraseRootFromParent_Done,
     /*   6557 */   // Label 152: @6557
     /*   6557 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6620), // Rule ID 5937 //
     /*   6562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6592 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6597 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6618 */     GIR_RootConstrainSelectedInstOperands,
     /*   6619 */     // GIR_Coverage, 5937,
     /*   6619 */     GIR_EraseRootFromParent_Done,
     /*   6620 */   // Label 153: @6620
     /*   6620 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6683), // Rule ID 5942 //
     /*   6625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6655 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6660 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6681 */     GIR_RootConstrainSelectedInstOperands,
     /*   6682 */     // GIR_Coverage, 5942,
     /*   6682 */     GIR_EraseRootFromParent_Done,
     /*   6683 */   // Label 154: @6683
     /*   6683 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6729), // Rule ID 73 //
     /*   6688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6727 */     GIR_RootConstrainSelectedInstOperands,
     /*   6728 */     // GIR_Coverage, 73,
     /*   6728 */     GIR_EraseRootFromParent_Done,
     /*   6729 */   // Label 155: @6729
     /*   6729 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6775), // Rule ID 305 //
     /*   6734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6773 */     GIR_RootConstrainSelectedInstOperands,
     /*   6774 */     // GIR_Coverage, 305,
     /*   6774 */     GIR_EraseRootFromParent_Done,
     /*   6775 */   // Label 156: @6775
     /*   6775 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6821), // Rule ID 409 //
     /*   6780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6795 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6819 */     GIR_RootConstrainSelectedInstOperands,
     /*   6820 */     // GIR_Coverage, 409,
     /*   6820 */     GIR_EraseRootFromParent_Done,
     /*   6821 */   // Label 157: @6821
     /*   6821 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6867), // Rule ID 5460 //
     /*   6826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6865 */     GIR_RootConstrainSelectedInstOperands,
     /*   6866 */     // GIR_Coverage, 5460,
     /*   6866 */     GIR_EraseRootFromParent_Done,
     /*   6867 */   // Label 158: @6867
     /*   6867 */   GIM_Reject,
     /*   6868 */ // Label 89: @6868
     /*   6868 */ GIM_Reject,
     /*   6869 */ // Label 80: @6869
     /*   6869 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6915), // Rule ID 759 //
     /*   6874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6900 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6902 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6907 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6913 */   GIR_RootConstrainSelectedInstOperands,
     /*   6914 */   // GIR_Coverage, 759,
     /*   6914 */   GIR_EraseRootFromParent_Done,
     /*   6915 */ // Label 159: @6915
     /*   6915 */ GIM_Reject,
     /*   6916 */ // Label 81: @6916
     /*   6916 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(7100),
     /*   6921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6931 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(6997), // Rule ID 5529 //
     /*   6936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6971 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6995 */     GIR_RootConstrainSelectedInstOperands,
     /*   6996 */     // GIR_Coverage, 5529,
     /*   6996 */     GIR_EraseRootFromParent_Done,
     /*   6997 */   // Label 161: @6997
     /*   6997 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7063), // Rule ID 886 //
     /*   7002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7025 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7037 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7042 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7061 */     GIR_RootConstrainSelectedInstOperands,
     /*   7062 */     // GIR_Coverage, 886,
     /*   7062 */     GIR_EraseRootFromParent_Done,
     /*   7063 */   // Label 162: @7063
     /*   7063 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7099), // Rule ID 755 //
     /*   7068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7079 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7097 */     GIR_RootConstrainSelectedInstOperands,
     /*   7098 */     // GIR_Coverage, 755,
     /*   7098 */     GIR_EraseRootFromParent_Done,
     /*   7099 */   // Label 163: @7099
     /*   7099 */   GIM_Reject,
     /*   7100 */ // Label 160: @7100
     /*   7100 */ GIM_Reject,
     /*   7101 */ // Label 82: @7101
     /*   7101 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7811),
     /*   7106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7116 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7184), // Rule ID 779 //
     /*   7121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7153 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7158 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7160 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7182 */     GIR_RootConstrainSelectedInstOperands,
     /*   7183 */     // GIR_Coverage, 779,
     /*   7183 */     GIR_EraseRootFromParent_Done,
     /*   7184 */   // Label 165: @7184
     /*   7184 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7252), // Rule ID 778 //
     /*   7189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7228 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7250 */     GIR_RootConstrainSelectedInstOperands,
     /*   7251 */     // GIR_Coverage, 778,
     /*   7251 */     GIR_EraseRootFromParent_Done,
     /*   7252 */   // Label 166: @7252
     /*   7252 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7320), // Rule ID 767 //
     /*   7257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7296 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7318 */     GIR_RootConstrainSelectedInstOperands,
     /*   7319 */     // GIR_Coverage, 767,
     /*   7319 */     GIR_EraseRootFromParent_Done,
     /*   7320 */   // Label 167: @7320
     /*   7320 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7388), // Rule ID 777 //
     /*   7325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7364 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7386 */     GIR_RootConstrainSelectedInstOperands,
     /*   7387 */     // GIR_Coverage, 777,
     /*   7387 */     GIR_EraseRootFromParent_Done,
     /*   7388 */   // Label 168: @7388
     /*   7388 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7456), // Rule ID 776 //
     /*   7393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7408 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7432 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7454 */     GIR_RootConstrainSelectedInstOperands,
     /*   7455 */     // GIR_Coverage, 776,
     /*   7455 */     GIR_EraseRootFromParent_Done,
     /*   7456 */   // Label 169: @7456
     /*   7456 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7509), // Rule ID 5508 //
     /*   7461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7487 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7507 */     GIR_RootConstrainSelectedInstOperands,
     /*   7508 */     // GIR_Coverage, 5508,
     /*   7508 */     GIR_EraseRootFromParent_Done,
     /*   7509 */   // Label 170: @7509
     /*   7509 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7562), // Rule ID 5502 //
     /*   7514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7540 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7560 */     GIR_RootConstrainSelectedInstOperands,
     /*   7561 */     // GIR_Coverage, 5502,
     /*   7561 */     GIR_EraseRootFromParent_Done,
     /*   7562 */   // Label 171: @7562
     /*   7562 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7615), // Rule ID 5507 //
     /*   7567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7593 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7613 */     GIR_RootConstrainSelectedInstOperands,
     /*   7614 */     // GIR_Coverage, 5507,
     /*   7614 */     GIR_EraseRootFromParent_Done,
     /*   7615 */   // Label 172: @7615
     /*   7615 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7668), // Rule ID 788 //
     /*   7620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7646 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7666 */     GIR_RootConstrainSelectedInstOperands,
     /*   7667 */     // GIR_Coverage, 788,
     /*   7667 */     GIR_EraseRootFromParent_Done,
     /*   7668 */   // Label 173: @7668
     /*   7668 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7721), // Rule ID 782 //
     /*   7673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7699 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7719 */     GIR_RootConstrainSelectedInstOperands,
     /*   7720 */     // GIR_Coverage, 782,
     /*   7720 */     GIR_EraseRootFromParent_Done,
     /*   7721 */   // Label 174: @7721
     /*   7721 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7774), // Rule ID 787 //
     /*   7726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7752 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7772 */     GIR_RootConstrainSelectedInstOperands,
     /*   7773 */     // GIR_Coverage, 787,
     /*   7773 */     GIR_EraseRootFromParent_Done,
     /*   7774 */   // Label 175: @7774
     /*   7774 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7810), // Rule ID 760 //
     /*   7779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7790 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7808 */     GIR_RootConstrainSelectedInstOperands,
     /*   7809 */     // GIR_Coverage, 760,
     /*   7809 */     GIR_EraseRootFromParent_Done,
     /*   7810 */   // Label 176: @7810
     /*   7810 */   GIM_Reject,
     /*   7811 */ // Label 164: @7811
     /*   7811 */ GIM_Reject,
     /*   7812 */ // Label 83: @7812
     /*   7812 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(7996),
     /*   7817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(7893), // Rule ID 5528 //
     /*   7832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7867 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7872 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7891 */     GIR_RootConstrainSelectedInstOperands,
     /*   7892 */     // GIR_Coverage, 5528,
     /*   7892 */     GIR_EraseRootFromParent_Done,
     /*   7893 */   // Label 178: @7893
     /*   7893 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7959), // Rule ID 885 //
     /*   7898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7933 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7957 */     GIR_RootConstrainSelectedInstOperands,
     /*   7958 */     // GIR_Coverage, 885,
     /*   7958 */     GIR_EraseRootFromParent_Done,
     /*   7959 */   // Label 179: @7959
     /*   7959 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7995), // Rule ID 754 //
     /*   7964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7975 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7993 */     GIR_RootConstrainSelectedInstOperands,
     /*   7994 */     // GIR_Coverage, 754,
     /*   7994 */     GIR_EraseRootFromParent_Done,
     /*   7995 */   // Label 180: @7995
     /*   7995 */   GIM_Reject,
     /*   7996 */ // Label 177: @7996
     /*   7996 */ GIM_Reject,
     /*   7997 */ // Label 84: @7997
     /*   7997 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8952),
     /*   8002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8008 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8080), // Rule ID 775 //
     /*   8013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8056 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8078 */     GIR_RootConstrainSelectedInstOperands,
     /*   8079 */     // GIR_Coverage, 775,
     /*   8079 */     GIR_EraseRootFromParent_Done,
     /*   8080 */   // Label 182: @8080
     /*   8080 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8152), // Rule ID 774 //
     /*   8085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8128 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8150 */     GIR_RootConstrainSelectedInstOperands,
     /*   8151 */     // GIR_Coverage, 774,
     /*   8151 */     GIR_EraseRootFromParent_Done,
     /*   8152 */   // Label 183: @8152
     /*   8152 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8224), // Rule ID 766 //
     /*   8157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8200 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8222 */     GIR_RootConstrainSelectedInstOperands,
     /*   8223 */     // GIR_Coverage, 766,
     /*   8223 */     GIR_EraseRootFromParent_Done,
     /*   8224 */   // Label 184: @8224
     /*   8224 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8296), // Rule ID 773 //
     /*   8229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8272 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8294 */     GIR_RootConstrainSelectedInstOperands,
     /*   8295 */     // GIR_Coverage, 773,
     /*   8295 */     GIR_EraseRootFromParent_Done,
     /*   8296 */   // Label 185: @8296
     /*   8296 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8368), // Rule ID 772 //
     /*   8301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8344 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8360 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8366 */     GIR_RootConstrainSelectedInstOperands,
     /*   8367 */     // GIR_Coverage, 772,
     /*   8367 */     GIR_EraseRootFromParent_Done,
     /*   8368 */   // Label 186: @8368
     /*   8368 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8438), // Rule ID 5532 //
     /*   8373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8412 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8417 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8436 */     GIR_RootConstrainSelectedInstOperands,
     /*   8437 */     // GIR_Coverage, 5532,
     /*   8437 */     GIR_EraseRootFromParent_Done,
     /*   8438 */   // Label 187: @8438
     /*   8438 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8495), // Rule ID 5506 //
     /*   8443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8473 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8493 */     GIR_RootConstrainSelectedInstOperands,
     /*   8494 */     // GIR_Coverage, 5506,
     /*   8494 */     GIR_EraseRootFromParent_Done,
     /*   8495 */   // Label 188: @8495
     /*   8495 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8552), // Rule ID 5501 //
     /*   8500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8530 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8550 */     GIR_RootConstrainSelectedInstOperands,
     /*   8551 */     // GIR_Coverage, 5501,
     /*   8551 */     GIR_EraseRootFromParent_Done,
     /*   8552 */   // Label 189: @8552
     /*   8552 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8609), // Rule ID 5505 //
     /*   8557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8587 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8607 */     GIR_RootConstrainSelectedInstOperands,
     /*   8608 */     // GIR_Coverage, 5505,
     /*   8608 */     GIR_EraseRootFromParent_Done,
     /*   8609 */   // Label 190: @8609
     /*   8609 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8679), // Rule ID 889 //
     /*   8614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8653 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8658 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8677 */     GIR_RootConstrainSelectedInstOperands,
     /*   8678 */     // GIR_Coverage, 889,
     /*   8678 */     GIR_EraseRootFromParent_Done,
     /*   8679 */   // Label 191: @8679
     /*   8679 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8736), // Rule ID 786 //
     /*   8684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8714 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8734 */     GIR_RootConstrainSelectedInstOperands,
     /*   8735 */     // GIR_Coverage, 786,
     /*   8735 */     GIR_EraseRootFromParent_Done,
     /*   8736 */   // Label 192: @8736
     /*   8736 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8793), // Rule ID 781 //
     /*   8741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8771 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8791 */     GIR_RootConstrainSelectedInstOperands,
     /*   8792 */     // GIR_Coverage, 781,
     /*   8792 */     GIR_EraseRootFromParent_Done,
     /*   8793 */   // Label 193: @8793
     /*   8793 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8850), // Rule ID 785 //
     /*   8798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8828 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8848 */     GIR_RootConstrainSelectedInstOperands,
     /*   8849 */     // GIR_Coverage, 785,
     /*   8849 */     GIR_EraseRootFromParent_Done,
     /*   8850 */   // Label 194: @8850
     /*   8850 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8890), // Rule ID 758 //
     /*   8855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8888 */     GIR_RootConstrainSelectedInstOperands,
     /*   8889 */     // GIR_Coverage, 758,
     /*   8889 */     GIR_EraseRootFromParent_Done,
     /*   8890 */   // Label 195: @8890
     /*   8890 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8951), // Rule ID 3493 //
     /*   8895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8949 */     GIR_RootConstrainSelectedInstOperands,
     /*   8950 */     // GIR_Coverage, 3493,
     /*   8950 */     GIR_EraseRootFromParent_Done,
     /*   8951 */   // Label 196: @8951
     /*   8951 */   GIM_Reject,
     /*   8952 */ // Label 181: @8952
     /*   8952 */ GIM_Reject,
     /*   8953 */ // Label 85: @8953
     /*   8953 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(9137),
     /*   8958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8968 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9034), // Rule ID 5527 //
     /*   8973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9008 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9013 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9032 */     GIR_RootConstrainSelectedInstOperands,
     /*   9033 */     // GIR_Coverage, 5527,
     /*   9033 */     GIR_EraseRootFromParent_Done,
     /*   9034 */   // Label 198: @9034
     /*   9034 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9100), // Rule ID 884 //
     /*   9039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9074 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9079 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9098 */     GIR_RootConstrainSelectedInstOperands,
     /*   9099 */     // GIR_Coverage, 884,
     /*   9099 */     GIR_EraseRootFromParent_Done,
     /*   9100 */   // Label 199: @9100
     /*   9100 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9136), // Rule ID 753 //
     /*   9105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9116 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9134 */     GIR_RootConstrainSelectedInstOperands,
     /*   9135 */     // GIR_Coverage, 753,
     /*   9135 */     GIR_EraseRootFromParent_Done,
     /*   9136 */   // Label 200: @9136
     /*   9136 */   GIM_Reject,
     /*   9137 */ // Label 197: @9137
     /*   9137 */ GIM_Reject,
     /*   9138 */ // Label 86: @9138
     /*   9138 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(10093),
     /*   9143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9149 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(9221), // Rule ID 771 //
     /*   9154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9197 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9219 */     GIR_RootConstrainSelectedInstOperands,
     /*   9220 */     // GIR_Coverage, 771,
     /*   9220 */     GIR_EraseRootFromParent_Done,
     /*   9221 */   // Label 202: @9221
     /*   9221 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9293), // Rule ID 770 //
     /*   9226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9269 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9291 */     GIR_RootConstrainSelectedInstOperands,
     /*   9292 */     // GIR_Coverage, 770,
     /*   9292 */     GIR_EraseRootFromParent_Done,
     /*   9293 */   // Label 203: @9293
     /*   9293 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9365), // Rule ID 765 //
     /*   9298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9341 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9363 */     GIR_RootConstrainSelectedInstOperands,
     /*   9364 */     // GIR_Coverage, 765,
     /*   9364 */     GIR_EraseRootFromParent_Done,
     /*   9365 */   // Label 204: @9365
     /*   9365 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9437), // Rule ID 769 //
     /*   9370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9413 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9435 */     GIR_RootConstrainSelectedInstOperands,
     /*   9436 */     // GIR_Coverage, 769,
     /*   9436 */     GIR_EraseRootFromParent_Done,
     /*   9437 */   // Label 205: @9437
     /*   9437 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9509), // Rule ID 768 //
     /*   9442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9485 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9507 */     GIR_RootConstrainSelectedInstOperands,
     /*   9508 */     // GIR_Coverage, 768,
     /*   9508 */     GIR_EraseRootFromParent_Done,
     /*   9509 */   // Label 206: @9509
     /*   9509 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9579), // Rule ID 5531 //
     /*   9514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9553 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9558 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9577 */     GIR_RootConstrainSelectedInstOperands,
     /*   9578 */     // GIR_Coverage, 5531,
     /*   9578 */     GIR_EraseRootFromParent_Done,
     /*   9579 */   // Label 207: @9579
     /*   9579 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9636), // Rule ID 5504 //
     /*   9584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9614 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9628 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9634 */     GIR_RootConstrainSelectedInstOperands,
     /*   9635 */     // GIR_Coverage, 5504,
     /*   9635 */     GIR_EraseRootFromParent_Done,
     /*   9636 */   // Label 208: @9636
     /*   9636 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9693), // Rule ID 5500 //
     /*   9641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9671 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9691 */     GIR_RootConstrainSelectedInstOperands,
     /*   9692 */     // GIR_Coverage, 5500,
     /*   9692 */     GIR_EraseRootFromParent_Done,
     /*   9693 */   // Label 209: @9693
     /*   9693 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9750), // Rule ID 5503 //
     /*   9698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9728 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9748 */     GIR_RootConstrainSelectedInstOperands,
     /*   9749 */     // GIR_Coverage, 5503,
     /*   9749 */     GIR_EraseRootFromParent_Done,
     /*   9750 */   // Label 210: @9750
     /*   9750 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9820), // Rule ID 888 //
     /*   9755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9778 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9794 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9799 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9818 */     GIR_RootConstrainSelectedInstOperands,
     /*   9819 */     // GIR_Coverage, 888,
     /*   9819 */     GIR_EraseRootFromParent_Done,
     /*   9820 */   // Label 211: @9820
     /*   9820 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9877), // Rule ID 784 //
     /*   9825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9855 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9875 */     GIR_RootConstrainSelectedInstOperands,
     /*   9876 */     // GIR_Coverage, 784,
     /*   9876 */     GIR_EraseRootFromParent_Done,
     /*   9877 */   // Label 212: @9877
     /*   9877 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9934), // Rule ID 780 //
     /*   9882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9912 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9932 */     GIR_RootConstrainSelectedInstOperands,
     /*   9933 */     // GIR_Coverage, 780,
     /*   9933 */     GIR_EraseRootFromParent_Done,
     /*   9934 */   // Label 213: @9934
     /*   9934 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9991), // Rule ID 783 //
     /*   9939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9962 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9969 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9989 */     GIR_RootConstrainSelectedInstOperands,
     /*   9990 */     // GIR_Coverage, 783,
     /*   9990 */     GIR_EraseRootFromParent_Done,
     /*   9991 */   // Label 214: @9991
     /*   9991 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(10031), // Rule ID 757 //
     /*   9996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10029 */     GIR_RootConstrainSelectedInstOperands,
     /*  10030 */     // GIR_Coverage, 757,
     /*  10030 */     GIR_EraseRootFromParent_Done,
     /*  10031 */   // Label 215: @10031
     /*  10031 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10092), // Rule ID 3489 //
     /*  10036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10068 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10090 */     GIR_RootConstrainSelectedInstOperands,
     /*  10091 */     // GIR_Coverage, 3489,
     /*  10091 */     GIR_EraseRootFromParent_Done,
     /*  10092 */   // Label 216: @10092
     /*  10092 */   GIM_Reject,
     /*  10093 */ // Label 201: @10093
     /*  10093 */ GIM_Reject,
     /*  10094 */ // Label 87: @10094
     /*  10094 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10347),
     /*  10099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10105 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10175), // Rule ID 5530 //
     /*  10110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10149 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10154 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10173 */     GIR_RootConstrainSelectedInstOperands,
     /*  10174 */     // GIR_Coverage, 5530,
     /*  10174 */     GIR_EraseRootFromParent_Done,
     /*  10175 */   // Label 218: @10175
     /*  10175 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10245), // Rule ID 887 //
     /*  10180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10219 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10224 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10243 */     GIR_RootConstrainSelectedInstOperands,
     /*  10244 */     // GIR_Coverage, 887,
     /*  10244 */     GIR_EraseRootFromParent_Done,
     /*  10245 */   // Label 219: @10245
     /*  10245 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10285), // Rule ID 756 //
     /*  10250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10283 */     GIR_RootConstrainSelectedInstOperands,
     /*  10284 */     // GIR_Coverage, 756,
     /*  10284 */     GIR_EraseRootFromParent_Done,
     /*  10285 */   // Label 220: @10285
     /*  10285 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10346), // Rule ID 3485 //
     /*  10290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10322 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10344 */     GIR_RootConstrainSelectedInstOperands,
     /*  10345 */     // GIR_Coverage, 3485,
     /*  10345 */     GIR_EraseRootFromParent_Done,
     /*  10346 */   // Label 221: @10346
     /*  10346 */   GIM_Reject,
     /*  10347 */ // Label 217: @10347
     /*  10347 */ GIM_Reject,
     /*  10348 */ // Label 88: @10348
     /*  10348 */ GIM_Reject,
     /*  10349 */ // Label 1: @10349
     /*  10349 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 231*/ GIMT_Encode4(13592),
     /*  10360 */ /*GILLT_s32*//*Label 222*/ GIMT_Encode4(10420),
     /*  10364 */ /*GILLT_s64*//*Label 223*/ GIMT_Encode4(11034), GIMT_Encode4(0),
     /*  10372 */ /*GILLT_v2s32*//*Label 224*/ GIMT_Encode4(11081),
     /*  10376 */ /*GILLT_v2s64*//*Label 225*/ GIMT_Encode4(11196), GIMT_Encode4(0),
     /*  10384 */ /*GILLT_v4s16*//*Label 226*/ GIMT_Encode4(11748),
     /*  10388 */ /*GILLT_v4s32*//*Label 227*/ GIMT_Encode4(11863), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10400 */ /*GILLT_v8s8*//*Label 228*/ GIMT_Encode4(12578),
     /*  10404 */ /*GILLT_v8s16*//*Label 229*/ GIMT_Encode4(12693), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10416 */ /*GILLT_v16s8*//*Label 230*/ GIMT_Encode4(13408),
     /*  10420 */ // Label 222: @10420
     /*  10420 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(11033),
     /*  10425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10431 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10475), // Rule ID 330 //
     /*  10436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10473 */     GIR_RootConstrainSelectedInstOperands,
     /*  10474 */     // GIR_Coverage, 330,
     /*  10474 */     GIR_EraseRootFromParent_Done,
     /*  10475 */   // Label 233: @10475
     /*  10475 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10532), // Rule ID 96 //
     /*  10480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10499 */     // MIs[1] Operand 1
     /*  10499 */     // No operand predicates
     /*  10499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10505 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10530 */     GIR_RootConstrainSelectedInstOperands,
     /*  10531 */     // GIR_Coverage, 96,
     /*  10531 */     GIR_EraseRootFromParent_Done,
     /*  10532 */   // Label 234: @10532
     /*  10532 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10589), // Rule ID 427 //
     /*  10537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10556 */     // MIs[1] Operand 1
     /*  10556 */     // No operand predicates
     /*  10556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10562 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10587 */     GIR_RootConstrainSelectedInstOperands,
     /*  10588 */     // GIR_Coverage, 427,
     /*  10588 */     GIR_EraseRootFromParent_Done,
     /*  10589 */   // Label 235: @10589
     /*  10589 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10646), // Rule ID 76 //
     /*  10594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10617 */     // MIs[1] Operand 1
     /*  10617 */     // No operand predicates
     /*  10617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10619 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10644 */     GIR_RootConstrainSelectedInstOperands,
     /*  10645 */     // GIR_Coverage, 76,
     /*  10645 */     GIR_EraseRootFromParent_Done,
     /*  10646 */   // Label 236: @10646
     /*  10646 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10703), // Rule ID 411 //
     /*  10651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10674 */     // MIs[1] Operand 1
     /*  10674 */     // No operand predicates
     /*  10674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10676 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10701 */     GIR_RootConstrainSelectedInstOperands,
     /*  10702 */     // GIR_Coverage, 411,
     /*  10702 */     GIR_EraseRootFromParent_Done,
     /*  10703 */   // Label 237: @10703
     /*  10703 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10754), // Rule ID 412 //
     /*  10708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10731 */     // MIs[1] Operand 1
     /*  10731 */     // No operand predicates
     /*  10731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10733 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10752 */     GIR_RootConstrainSelectedInstOperands,
     /*  10753 */     // GIR_Coverage, 412,
     /*  10753 */     GIR_EraseRootFromParent_Done,
     /*  10754 */   // Label 238: @10754
     /*  10754 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10824), // Rule ID 173 //
     /*  10759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10798 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10822 */     GIR_RootConstrainSelectedInstOperands,
     /*  10823 */     // GIR_Coverage, 173,
     /*  10823 */     GIR_EraseRootFromParent_Done,
     /*  10824 */   // Label 239: @10824
     /*  10824 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10894), // Rule ID 504 //
     /*  10829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10852 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10868 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10892 */     GIR_RootConstrainSelectedInstOperands,
     /*  10893 */     // GIR_Coverage, 504,
     /*  10893 */     GIR_EraseRootFromParent_Done,
     /*  10894 */   // Label 240: @10894
     /*  10894 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10940), // Rule ID 77 //
     /*  10899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10938 */     GIR_RootConstrainSelectedInstOperands,
     /*  10939 */     // GIR_Coverage, 77,
     /*  10939 */     GIR_EraseRootFromParent_Done,
     /*  10940 */   // Label 241: @10940
     /*  10940 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10986), // Rule ID 333 //
     /*  10945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10984 */     GIR_RootConstrainSelectedInstOperands,
     /*  10985 */     // GIR_Coverage, 333,
     /*  10985 */     GIR_EraseRootFromParent_Done,
     /*  10986 */   // Label 242: @10986
     /*  10986 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(11032), // Rule ID 413 //
     /*  10991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11006 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11030 */     GIR_RootConstrainSelectedInstOperands,
     /*  11031 */     // GIR_Coverage, 413,
     /*  11031 */     GIR_EraseRootFromParent_Done,
     /*  11032 */   // Label 243: @11032
     /*  11032 */   GIM_Reject,
     /*  11033 */ // Label 232: @11033
     /*  11033 */ GIM_Reject,
     /*  11034 */ // Label 223: @11034
     /*  11034 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11080), // Rule ID 963 //
     /*  11039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11065 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11067 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11078 */   GIR_RootConstrainSelectedInstOperands,
     /*  11079 */   // GIR_Coverage, 963,
     /*  11079 */   GIR_EraseRootFromParent_Done,
     /*  11080 */ // Label 244: @11080
     /*  11080 */ GIM_Reject,
     /*  11081 */ // Label 224: @11081
     /*  11081 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11195),
     /*  11086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11100 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11162), // Rule ID 914 //
     /*  11105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11136 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11141 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11160 */     GIR_RootConstrainSelectedInstOperands,
     /*  11161 */     // GIR_Coverage, 914,
     /*  11161 */     GIR_EraseRootFromParent_Done,
     /*  11162 */   // Label 246: @11162
     /*  11162 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11194), // Rule ID 959 //
     /*  11167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11174 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11192 */     GIR_RootConstrainSelectedInstOperands,
     /*  11193 */     // GIR_Coverage, 959,
     /*  11193 */     GIR_EraseRootFromParent_Done,
     /*  11194 */   // Label 247: @11194
     /*  11194 */   GIM_Reject,
     /*  11195 */ // Label 245: @11195
     /*  11195 */ GIM_Reject,
     /*  11196 */ // Label 225: @11196
     /*  11196 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11747),
     /*  11201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11211 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11279), // Rule ID 983 //
     /*  11216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11255 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11277 */     GIR_RootConstrainSelectedInstOperands,
     /*  11278 */     // GIR_Coverage, 983,
     /*  11278 */     GIR_EraseRootFromParent_Done,
     /*  11279 */   // Label 249: @11279
     /*  11279 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11347), // Rule ID 982 //
     /*  11284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11323 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11345 */     GIR_RootConstrainSelectedInstOperands,
     /*  11346 */     // GIR_Coverage, 982,
     /*  11346 */     GIR_EraseRootFromParent_Done,
     /*  11347 */   // Label 250: @11347
     /*  11347 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11415), // Rule ID 971 //
     /*  11352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11391 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11413 */     GIR_RootConstrainSelectedInstOperands,
     /*  11414 */     // GIR_Coverage, 971,
     /*  11414 */     GIR_EraseRootFromParent_Done,
     /*  11415 */   // Label 251: @11415
     /*  11415 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11483), // Rule ID 981 //
     /*  11420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11459 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11481 */     GIR_RootConstrainSelectedInstOperands,
     /*  11482 */     // GIR_Coverage, 981,
     /*  11482 */     GIR_EraseRootFromParent_Done,
     /*  11483 */   // Label 252: @11483
     /*  11483 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11551), // Rule ID 980 //
     /*  11488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11527 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11549 */     GIR_RootConstrainSelectedInstOperands,
     /*  11550 */     // GIR_Coverage, 980,
     /*  11550 */     GIR_EraseRootFromParent_Done,
     /*  11551 */   // Label 253: @11551
     /*  11551 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11604), // Rule ID 992 //
     /*  11556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11582 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11602 */     GIR_RootConstrainSelectedInstOperands,
     /*  11603 */     // GIR_Coverage, 992,
     /*  11603 */     GIR_EraseRootFromParent_Done,
     /*  11604 */   // Label 254: @11604
     /*  11604 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11657), // Rule ID 986 //
     /*  11609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11635 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11655 */     GIR_RootConstrainSelectedInstOperands,
     /*  11656 */     // GIR_Coverage, 986,
     /*  11656 */     GIR_EraseRootFromParent_Done,
     /*  11657 */   // Label 255: @11657
     /*  11657 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11710), // Rule ID 991 //
     /*  11662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11688 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11708 */     GIR_RootConstrainSelectedInstOperands,
     /*  11709 */     // GIR_Coverage, 991,
     /*  11709 */     GIR_EraseRootFromParent_Done,
     /*  11710 */   // Label 256: @11710
     /*  11710 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11746), // Rule ID 964 //
     /*  11715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11726 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11731 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11744 */     GIR_RootConstrainSelectedInstOperands,
     /*  11745 */     // GIR_Coverage, 964,
     /*  11745 */     GIR_EraseRootFromParent_Done,
     /*  11746 */   // Label 257: @11746
     /*  11746 */   GIM_Reject,
     /*  11747 */ // Label 248: @11747
     /*  11747 */ GIM_Reject,
     /*  11748 */ // Label 226: @11748
     /*  11748 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11862),
     /*  11753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11767 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11829), // Rule ID 913 //
     /*  11772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11803 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11808 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11827 */     GIR_RootConstrainSelectedInstOperands,
     /*  11828 */     // GIR_Coverage, 913,
     /*  11828 */     GIR_EraseRootFromParent_Done,
     /*  11829 */   // Label 259: @11829
     /*  11829 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11861), // Rule ID 958 //
     /*  11834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11841 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11859 */     GIR_RootConstrainSelectedInstOperands,
     /*  11860 */     // GIR_Coverage, 958,
     /*  11860 */     GIR_EraseRootFromParent_Done,
     /*  11861 */   // Label 260: @11861
     /*  11861 */   GIM_Reject,
     /*  11862 */ // Label 258: @11862
     /*  11862 */ GIM_Reject,
     /*  11863 */ // Label 227: @11863
     /*  11863 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(12577),
     /*  11868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11874 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11946), // Rule ID 979 //
     /*  11879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11922 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11944 */     GIR_RootConstrainSelectedInstOperands,
     /*  11945 */     // GIR_Coverage, 979,
     /*  11945 */     GIR_EraseRootFromParent_Done,
     /*  11946 */   // Label 262: @11946
     /*  11946 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12018), // Rule ID 978 //
     /*  11951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11994 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12016 */     GIR_RootConstrainSelectedInstOperands,
     /*  12017 */     // GIR_Coverage, 978,
     /*  12017 */     GIR_EraseRootFromParent_Done,
     /*  12018 */   // Label 263: @12018
     /*  12018 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12090), // Rule ID 970 //
     /*  12023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12059 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12066 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12088 */     GIR_RootConstrainSelectedInstOperands,
     /*  12089 */     // GIR_Coverage, 970,
     /*  12089 */     GIR_EraseRootFromParent_Done,
     /*  12090 */   // Label 264: @12090
     /*  12090 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12162), // Rule ID 977 //
     /*  12095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12138 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12160 */     GIR_RootConstrainSelectedInstOperands,
     /*  12161 */     // GIR_Coverage, 977,
     /*  12161 */     GIR_EraseRootFromParent_Done,
     /*  12162 */   // Label 265: @12162
     /*  12162 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12234), // Rule ID 976 //
     /*  12167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12210 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12232 */     GIR_RootConstrainSelectedInstOperands,
     /*  12233 */     // GIR_Coverage, 976,
     /*  12233 */     GIR_EraseRootFromParent_Done,
     /*  12234 */   // Label 266: @12234
     /*  12234 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12304), // Rule ID 917 //
     /*  12239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12278 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12283 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12302 */     GIR_RootConstrainSelectedInstOperands,
     /*  12303 */     // GIR_Coverage, 917,
     /*  12303 */     GIR_EraseRootFromParent_Done,
     /*  12304 */   // Label 267: @12304
     /*  12304 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12361), // Rule ID 990 //
     /*  12309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12339 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12359 */     GIR_RootConstrainSelectedInstOperands,
     /*  12360 */     // GIR_Coverage, 990,
     /*  12360 */     GIR_EraseRootFromParent_Done,
     /*  12361 */   // Label 268: @12361
     /*  12361 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12418), // Rule ID 985 //
     /*  12366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12396 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12416 */     GIR_RootConstrainSelectedInstOperands,
     /*  12417 */     // GIR_Coverage, 985,
     /*  12417 */     GIR_EraseRootFromParent_Done,
     /*  12418 */   // Label 269: @12418
     /*  12418 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12475), // Rule ID 989 //
     /*  12423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12453 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12473 */     GIR_RootConstrainSelectedInstOperands,
     /*  12474 */     // GIR_Coverage, 989,
     /*  12474 */     GIR_EraseRootFromParent_Done,
     /*  12475 */   // Label 270: @12475
     /*  12475 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12515), // Rule ID 962 //
     /*  12480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12513 */     GIR_RootConstrainSelectedInstOperands,
     /*  12514 */     // GIR_Coverage, 962,
     /*  12514 */     GIR_EraseRootFromParent_Done,
     /*  12515 */   // Label 271: @12515
     /*  12515 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12576), // Rule ID 3505 //
     /*  12520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12574 */     GIR_RootConstrainSelectedInstOperands,
     /*  12575 */     // GIR_Coverage, 3505,
     /*  12575 */     GIR_EraseRootFromParent_Done,
     /*  12576 */   // Label 272: @12576
     /*  12576 */   GIM_Reject,
     /*  12577 */ // Label 261: @12577
     /*  12577 */ GIM_Reject,
     /*  12578 */ // Label 228: @12578
     /*  12578 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12692),
     /*  12583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12597 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12659), // Rule ID 912 //
     /*  12602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12633 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12638 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12657 */     GIR_RootConstrainSelectedInstOperands,
     /*  12658 */     // GIR_Coverage, 912,
     /*  12658 */     GIR_EraseRootFromParent_Done,
     /*  12659 */   // Label 274: @12659
     /*  12659 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12691), // Rule ID 957 //
     /*  12664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12671 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12689 */     GIR_RootConstrainSelectedInstOperands,
     /*  12690 */     // GIR_Coverage, 957,
     /*  12690 */     GIR_EraseRootFromParent_Done,
     /*  12691 */   // Label 275: @12691
     /*  12691 */   GIM_Reject,
     /*  12692 */ // Label 273: @12692
     /*  12692 */ GIM_Reject,
     /*  12693 */ // Label 229: @12693
     /*  12693 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13407),
     /*  12698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12704 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(12776), // Rule ID 975 //
     /*  12709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12752 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12774 */     GIR_RootConstrainSelectedInstOperands,
     /*  12775 */     // GIR_Coverage, 975,
     /*  12775 */     GIR_EraseRootFromParent_Done,
     /*  12776 */   // Label 277: @12776
     /*  12776 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12848), // Rule ID 974 //
     /*  12781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12824 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12846 */     GIR_RootConstrainSelectedInstOperands,
     /*  12847 */     // GIR_Coverage, 974,
     /*  12847 */     GIR_EraseRootFromParent_Done,
     /*  12848 */   // Label 278: @12848
     /*  12848 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12920), // Rule ID 969 //
     /*  12853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12896 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12918 */     GIR_RootConstrainSelectedInstOperands,
     /*  12919 */     // GIR_Coverage, 969,
     /*  12919 */     GIR_EraseRootFromParent_Done,
     /*  12920 */   // Label 279: @12920
     /*  12920 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(12992), // Rule ID 973 //
     /*  12925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12966 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12968 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12990 */     GIR_RootConstrainSelectedInstOperands,
     /*  12991 */     // GIR_Coverage, 973,
     /*  12991 */     GIR_EraseRootFromParent_Done,
     /*  12992 */   // Label 280: @12992
     /*  12992 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13064), // Rule ID 972 //
     /*  12997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13040 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13062 */     GIR_RootConstrainSelectedInstOperands,
     /*  13063 */     // GIR_Coverage, 972,
     /*  13063 */     GIR_EraseRootFromParent_Done,
     /*  13064 */   // Label 281: @13064
     /*  13064 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13134), // Rule ID 916 //
     /*  13069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13108 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13132 */     GIR_RootConstrainSelectedInstOperands,
     /*  13133 */     // GIR_Coverage, 916,
     /*  13133 */     GIR_EraseRootFromParent_Done,
     /*  13134 */   // Label 282: @13134
     /*  13134 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13191), // Rule ID 988 //
     /*  13139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13169 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13189 */     GIR_RootConstrainSelectedInstOperands,
     /*  13190 */     // GIR_Coverage, 988,
     /*  13190 */     GIR_EraseRootFromParent_Done,
     /*  13191 */   // Label 283: @13191
     /*  13191 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13248), // Rule ID 984 //
     /*  13196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13226 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13246 */     GIR_RootConstrainSelectedInstOperands,
     /*  13247 */     // GIR_Coverage, 984,
     /*  13247 */     GIR_EraseRootFromParent_Done,
     /*  13248 */   // Label 284: @13248
     /*  13248 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13305), // Rule ID 987 //
     /*  13253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13283 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13303 */     GIR_RootConstrainSelectedInstOperands,
     /*  13304 */     // GIR_Coverage, 987,
     /*  13304 */     GIR_EraseRootFromParent_Done,
     /*  13305 */   // Label 285: @13305
     /*  13305 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13345), // Rule ID 961 //
     /*  13310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13343 */     GIR_RootConstrainSelectedInstOperands,
     /*  13344 */     // GIR_Coverage, 961,
     /*  13344 */     GIR_EraseRootFromParent_Done,
     /*  13345 */   // Label 286: @13345
     /*  13345 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13406), // Rule ID 3501 //
     /*  13350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13404 */     GIR_RootConstrainSelectedInstOperands,
     /*  13405 */     // GIR_Coverage, 3501,
     /*  13405 */     GIR_EraseRootFromParent_Done,
     /*  13406 */   // Label 287: @13406
     /*  13406 */   GIM_Reject,
     /*  13407 */ // Label 276: @13407
     /*  13407 */ GIM_Reject,
     /*  13408 */ // Label 230: @13408
     /*  13408 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13591),
     /*  13413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13419 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13489), // Rule ID 915 //
     /*  13424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13463 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13468 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13487 */     GIR_RootConstrainSelectedInstOperands,
     /*  13488 */     // GIR_Coverage, 915,
     /*  13488 */     GIR_EraseRootFromParent_Done,
     /*  13489 */   // Label 289: @13489
     /*  13489 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13529), // Rule ID 960 //
     /*  13494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13527 */     GIR_RootConstrainSelectedInstOperands,
     /*  13528 */     // GIR_Coverage, 960,
     /*  13528 */     GIR_EraseRootFromParent_Done,
     /*  13529 */   // Label 290: @13529
     /*  13529 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13590), // Rule ID 3497 //
     /*  13534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13588 */     GIR_RootConstrainSelectedInstOperands,
     /*  13589 */     // GIR_Coverage, 3497,
     /*  13589 */     GIR_EraseRootFromParent_Done,
     /*  13590 */   // Label 291: @13590
     /*  13590 */   GIM_Reject,
     /*  13591 */ // Label 288: @13591
     /*  13591 */ GIM_Reject,
     /*  13592 */ // Label 231: @13592
     /*  13592 */ GIM_Reject,
     /*  13593 */ // Label 2: @13593
     /*  13593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 299*/ GIMT_Encode4(15296),
     /*  13604 */ /*GILLT_s32*//*Label 292*/ GIMT_Encode4(13664), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13616 */ /*GILLT_v2s32*//*Label 293*/ GIMT_Encode4(14583), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13628 */ /*GILLT_v4s16*//*Label 294*/ GIMT_Encode4(14630),
     /*  13632 */ /*GILLT_v4s32*//*Label 295*/ GIMT_Encode4(14677), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13644 */ /*GILLT_v8s8*//*Label 296*/ GIMT_Encode4(14906),
     /*  13648 */ /*GILLT_v8s16*//*Label 297*/ GIMT_Encode4(14953), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13660 */ /*GILLT_v16s8*//*Label 298*/ GIMT_Encode4(15182),
     /*  13664 */ // Label 292: @13664
     /*  13664 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(14582),
     /*  13669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13675 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(13763), // Rule ID 186 //
     /*  13680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13708 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13724 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13728 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13733 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13739 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13761 */     GIR_RootConstrainSelectedInstOperands,
     /*  13762 */     // GIR_Coverage, 186,
     /*  13762 */     GIR_EraseRootFromParent_Done,
     /*  13763 */   // Label 301: @13763
     /*  13763 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13851), // Rule ID 515 //
     /*  13768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13796 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13812 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13821 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13827 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13849 */     GIR_RootConstrainSelectedInstOperands,
     /*  13850 */     // GIR_Coverage, 515,
     /*  13850 */     GIR_EraseRootFromParent_Done,
     /*  13851 */   // Label 302: @13851
     /*  13851 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13942), // Rule ID 185 //
     /*  13856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13884 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13905 */     // MIs[2] Operand 2
     /*  13905 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13918 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13940 */     GIR_RootConstrainSelectedInstOperands,
     /*  13941 */     // GIR_Coverage, 185,
     /*  13941 */     GIR_EraseRootFromParent_Done,
     /*  13942 */   // Label 303: @13942
     /*  13942 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(14033), // Rule ID 514 //
     /*  13947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13975 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13996 */     // MIs[2] Operand 2
     /*  13996 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14009 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14031 */     GIR_RootConstrainSelectedInstOperands,
     /*  14032 */     // GIR_Coverage, 514,
     /*  14032 */     GIR_EraseRootFromParent_Done,
     /*  14033 */   // Label 304: @14033
     /*  14033 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14124), // Rule ID 184 //
     /*  14038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14062 */     // MIs[1] Operand 2
     /*  14062 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14094 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14100 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14122 */     GIR_RootConstrainSelectedInstOperands,
     /*  14123 */     // GIR_Coverage, 184,
     /*  14123 */     GIR_EraseRootFromParent_Done,
     /*  14124 */   // Label 305: @14124
     /*  14124 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14215), // Rule ID 513 //
     /*  14129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14153 */     // MIs[1] Operand 2
     /*  14153 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14185 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14191 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14213 */     GIR_RootConstrainSelectedInstOperands,
     /*  14214 */     // GIR_Coverage, 513,
     /*  14214 */     GIR_EraseRootFromParent_Done,
     /*  14215 */   // Label 306: @14215
     /*  14215 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14309), // Rule ID 183 //
     /*  14220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14244 */     // MIs[1] Operand 2
     /*  14244 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14272 */     // MIs[2] Operand 2
     /*  14272 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14285 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14307 */     GIR_RootConstrainSelectedInstOperands,
     /*  14308 */     // GIR_Coverage, 183,
     /*  14308 */     GIR_EraseRootFromParent_Done,
     /*  14309 */   // Label 307: @14309
     /*  14309 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14403), // Rule ID 512 //
     /*  14314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14338 */     // MIs[1] Operand 2
     /*  14338 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14366 */     // MIs[2] Operand 2
     /*  14366 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14379 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14401 */     GIR_RootConstrainSelectedInstOperands,
     /*  14402 */     // GIR_Coverage, 512,
     /*  14402 */     GIR_EraseRootFromParent_Done,
     /*  14403 */   // Label 308: @14403
     /*  14403 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14449), // Rule ID 169 //
     /*  14408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14428 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14447 */     GIR_RootConstrainSelectedInstOperands,
     /*  14448 */     // GIR_Coverage, 169,
     /*  14448 */     GIR_EraseRootFromParent_Done,
     /*  14449 */   // Label 309: @14449
     /*  14449 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14495), // Rule ID 170 //
     /*  14454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14493 */     GIR_RootConstrainSelectedInstOperands,
     /*  14494 */     // GIR_Coverage, 170,
     /*  14494 */     GIR_EraseRootFromParent_Done,
     /*  14495 */   // Label 310: @14495
     /*  14495 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14541), // Rule ID 323 //
     /*  14500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14539 */     GIR_RootConstrainSelectedInstOperands,
     /*  14540 */     // GIR_Coverage, 323,
     /*  14540 */     GIR_EraseRootFromParent_Done,
     /*  14541 */   // Label 311: @14541
     /*  14541 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14581), // Rule ID 502 //
     /*  14546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14566 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14579 */     GIR_RootConstrainSelectedInstOperands,
     /*  14580 */     // GIR_Coverage, 502,
     /*  14580 */     GIR_EraseRootFromParent_Done,
     /*  14581 */   // Label 312: @14581
     /*  14581 */   GIM_Reject,
     /*  14582 */ // Label 300: @14582
     /*  14582 */ GIM_Reject,
     /*  14583 */ // Label 293: @14583
     /*  14583 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14629), // Rule ID 834 //
     /*  14588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14614 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14616 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14621 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14627 */   GIR_RootConstrainSelectedInstOperands,
     /*  14628 */   // GIR_Coverage, 834,
     /*  14628 */   GIR_EraseRootFromParent_Done,
     /*  14629 */ // Label 313: @14629
     /*  14629 */ GIM_Reject,
     /*  14630 */ // Label 294: @14630
     /*  14630 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14676), // Rule ID 833 //
     /*  14635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14661 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14663 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14668 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14674 */   GIR_RootConstrainSelectedInstOperands,
     /*  14675 */   // GIR_Coverage, 833,
     /*  14675 */   GIR_EraseRootFromParent_Done,
     /*  14676 */ // Label 314: @14676
     /*  14676 */ GIM_Reject,
     /*  14677 */ // Label 295: @14677
     /*  14677 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14905),
     /*  14682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14688 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14803), // Rule ID 4418 //
     /*  14693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14717 */     // MIs[1] Operand 2
     /*  14717 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14745 */     // MIs[2] Operand 2
     /*  14745 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14758 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14786 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14801 */     GIR_RootConstrainSelectedInstOperands,
     /*  14802 */     // GIR_Coverage, 4418,
     /*  14802 */     GIR_EraseRootFromParent_Done,
     /*  14803 */   // Label 316: @14803
     /*  14803 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14843), // Rule ID 837 //
     /*  14808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14841 */     GIR_RootConstrainSelectedInstOperands,
     /*  14842 */     // GIR_Coverage, 837,
     /*  14842 */     GIR_EraseRootFromParent_Done,
     /*  14843 */   // Label 317: @14843
     /*  14843 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14904), // Rule ID 3463 //
     /*  14848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14902 */     GIR_RootConstrainSelectedInstOperands,
     /*  14903 */     // GIR_Coverage, 3463,
     /*  14903 */     GIR_EraseRootFromParent_Done,
     /*  14904 */   // Label 318: @14904
     /*  14904 */   GIM_Reject,
     /*  14905 */ // Label 315: @14905
     /*  14905 */ GIM_Reject,
     /*  14906 */ // Label 296: @14906
     /*  14906 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14952), // Rule ID 832 //
     /*  14911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14937 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14939 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14944 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14950 */   GIR_RootConstrainSelectedInstOperands,
     /*  14951 */   // GIR_Coverage, 832,
     /*  14951 */   GIR_EraseRootFromParent_Done,
     /*  14952 */ // Label 319: @14952
     /*  14952 */ GIM_Reject,
     /*  14953 */ // Label 297: @14953
     /*  14953 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(15181),
     /*  14958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14964 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15079), // Rule ID 4423 //
     /*  14969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14993 */     // MIs[1] Operand 2
     /*  14993 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15021 */     // MIs[2] Operand 2
     /*  15021 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15034 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15077 */     GIR_RootConstrainSelectedInstOperands,
     /*  15078 */     // GIR_Coverage, 4423,
     /*  15078 */     GIR_EraseRootFromParent_Done,
     /*  15079 */   // Label 321: @15079
     /*  15079 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15119), // Rule ID 836 //
     /*  15084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15117 */     GIR_RootConstrainSelectedInstOperands,
     /*  15118 */     // GIR_Coverage, 836,
     /*  15118 */     GIR_EraseRootFromParent_Done,
     /*  15119 */   // Label 322: @15119
     /*  15119 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15180), // Rule ID 3459 //
     /*  15124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15178 */     GIR_RootConstrainSelectedInstOperands,
     /*  15179 */     // GIR_Coverage, 3459,
     /*  15179 */     GIR_EraseRootFromParent_Done,
     /*  15180 */   // Label 323: @15180
     /*  15180 */   GIM_Reject,
     /*  15181 */ // Label 320: @15181
     /*  15181 */ GIM_Reject,
     /*  15182 */ // Label 298: @15182
     /*  15182 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15295),
     /*  15187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15193 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15233), // Rule ID 835 //
     /*  15198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15231 */     GIR_RootConstrainSelectedInstOperands,
     /*  15232 */     // GIR_Coverage, 835,
     /*  15232 */     GIR_EraseRootFromParent_Done,
     /*  15233 */   // Label 325: @15233
     /*  15233 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15294), // Rule ID 3455 //
     /*  15238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15292 */     GIR_RootConstrainSelectedInstOperands,
     /*  15293 */     // GIR_Coverage, 3455,
     /*  15293 */     GIR_EraseRootFromParent_Done,
     /*  15294 */   // Label 326: @15294
     /*  15294 */   GIM_Reject,
     /*  15295 */ // Label 324: @15295
     /*  15295 */ GIM_Reject,
     /*  15296 */ // Label 299: @15296
     /*  15296 */ GIM_Reject,
     /*  15297 */ // Label 3: @15297
     /*  15297 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15392),
     /*  15302 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15311 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15351), // Rule ID 195 //
     /*  15316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15349 */     GIR_RootConstrainSelectedInstOperands,
     /*  15350 */     // GIR_Coverage, 195,
     /*  15350 */     GIR_EraseRootFromParent_Done,
     /*  15351 */   // Label 328: @15351
     /*  15351 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15391), // Rule ID 532 //
     /*  15356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15389 */     GIR_RootConstrainSelectedInstOperands,
     /*  15390 */     // GIR_Coverage, 532,
     /*  15390 */     GIR_EraseRootFromParent_Done,
     /*  15391 */   // Label 329: @15391
     /*  15391 */   GIM_Reject,
     /*  15392 */ // Label 327: @15392
     /*  15392 */ GIM_Reject,
     /*  15393 */ // Label 4: @15393
     /*  15393 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15488),
     /*  15398 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15407 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15447), // Rule ID 196 //
     /*  15412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15432 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15445 */     GIR_RootConstrainSelectedInstOperands,
     /*  15446 */     // GIR_Coverage, 196,
     /*  15446 */     GIR_EraseRootFromParent_Done,
     /*  15447 */   // Label 331: @15447
     /*  15447 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15487), // Rule ID 533 //
     /*  15452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15485 */     GIR_RootConstrainSelectedInstOperands,
     /*  15486 */     // GIR_Coverage, 533,
     /*  15486 */     GIR_EraseRootFromParent_Done,
     /*  15487 */   // Label 332: @15487
     /*  15487 */   GIM_Reject,
     /*  15488 */ // Label 330: @15488
     /*  15488 */ GIM_Reject,
     /*  15489 */ // Label 5: @15489
     /*  15489 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 346*/ GIMT_Encode4(18668),
     /*  15500 */ /*GILLT_s32*//*Label 333*/ GIMT_Encode4(15560),
     /*  15504 */ /*GILLT_s64*//*Label 334*/ GIMT_Encode4(17552),
     /*  15508 */ /*GILLT_v2s1*//*Label 335*/ GIMT_Encode4(17599),
     /*  15512 */ /*GILLT_v2s32*//*Label 336*/ GIMT_Encode4(17717),
     /*  15516 */ /*GILLT_v2s64*//*Label 337*/ GIMT_Encode4(17764),
     /*  15520 */ /*GILLT_v4s1*//*Label 338*/ GIMT_Encode4(17878),
     /*  15524 */ /*GILLT_v4s16*//*Label 339*/ GIMT_Encode4(17996),
     /*  15528 */ /*GILLT_v4s32*//*Label 340*/ GIMT_Encode4(18043), GIMT_Encode4(0),
     /*  15536 */ /*GILLT_v8s1*//*Label 341*/ GIMT_Encode4(18157),
     /*  15540 */ /*GILLT_v8s8*//*Label 342*/ GIMT_Encode4(18275),
     /*  15544 */ /*GILLT_v8s16*//*Label 343*/ GIMT_Encode4(18322), GIMT_Encode4(0),
     /*  15552 */ /*GILLT_v16s1*//*Label 344*/ GIMT_Encode4(18436),
     /*  15556 */ /*GILLT_v16s8*//*Label 345*/ GIMT_Encode4(18554),
     /*  15560 */ // Label 333: @15560
     /*  15560 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(17551),
     /*  15565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15571 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(15644), // Rule ID 1852 //
     /*  15576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15604 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15608 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15621 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15642 */     GIR_RootConstrainSelectedInstOperands,
     /*  15643 */     // GIR_Coverage, 1852,
     /*  15643 */     GIR_EraseRootFromParent_Done,
     /*  15644 */   // Label 348: @15644
     /*  15644 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15717), // Rule ID 2109 //
     /*  15649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15677 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15681 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15694 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15715 */     GIR_RootConstrainSelectedInstOperands,
     /*  15716 */     // GIR_Coverage, 2109,
     /*  15716 */     GIR_EraseRootFromParent_Done,
     /*  15717 */   // Label 349: @15717
     /*  15717 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15765), // Rule ID 1994 //
     /*  15722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15733 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15744 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15763 */     GIR_RootConstrainSelectedInstOperands,
     /*  15764 */     // GIR_Coverage, 1994,
     /*  15764 */     GIR_EraseRootFromParent_Done,
     /*  15765 */   // Label 350: @15765
     /*  15765 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15813), // Rule ID 1995 //
     /*  15770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15781 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15792 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15811 */     GIR_RootConstrainSelectedInstOperands,
     /*  15812 */     // GIR_Coverage, 1995,
     /*  15812 */     GIR_EraseRootFromParent_Done,
     /*  15813 */   // Label 351: @15813
     /*  15813 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15861), // Rule ID 1996 //
     /*  15818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15829 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15840 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15859 */     GIR_RootConstrainSelectedInstOperands,
     /*  15860 */     // GIR_Coverage, 1996,
     /*  15860 */     GIR_EraseRootFromParent_Done,
     /*  15861 */   // Label 352: @15861
     /*  15861 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15909), // Rule ID 2233 //
     /*  15866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15877 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15888 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15907 */     GIR_RootConstrainSelectedInstOperands,
     /*  15908 */     // GIR_Coverage, 2233,
     /*  15908 */     GIR_EraseRootFromParent_Done,
     /*  15909 */   // Label 353: @15909
     /*  15909 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15957), // Rule ID 2234 //
     /*  15914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15925 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15936 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15955 */     GIR_RootConstrainSelectedInstOperands,
     /*  15956 */     // GIR_Coverage, 2234,
     /*  15956 */     GIR_EraseRootFromParent_Done,
     /*  15957 */   // Label 354: @15957
     /*  15957 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(16005), // Rule ID 2235 //
     /*  15962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15973 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15984 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16003 */     GIR_RootConstrainSelectedInstOperands,
     /*  16004 */     // GIR_Coverage, 2235,
     /*  16004 */     GIR_EraseRootFromParent_Done,
     /*  16005 */   // Label 355: @16005
     /*  16005 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16082), // Rule ID 5436 //
     /*  16010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16049 */     // MIs[2] Operand 1
     /*  16049 */     // No operand predicates
     /*  16049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16055 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16080 */     GIR_RootConstrainSelectedInstOperands,
     /*  16081 */     // GIR_Coverage, 5436,
     /*  16081 */     GIR_EraseRootFromParent_Done,
     /*  16082 */   // Label 356: @16082
     /*  16082 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16159), // Rule ID 5469 //
     /*  16087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16110 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16126 */     // MIs[2] Operand 1
     /*  16126 */     // No operand predicates
     /*  16126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16132 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16157 */     GIR_RootConstrainSelectedInstOperands,
     /*  16158 */     // GIR_Coverage, 5469,
     /*  16158 */     GIR_EraseRootFromParent_Done,
     /*  16159 */   // Label 357: @16159
     /*  16159 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16236), // Rule ID 5435 //
     /*  16164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16199 */     // MIs[2] Operand 1
     /*  16199 */     // No operand predicates
     /*  16199 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16209 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16234 */     GIR_RootConstrainSelectedInstOperands,
     /*  16235 */     // GIR_Coverage, 5435,
     /*  16235 */     GIR_EraseRootFromParent_Done,
     /*  16236 */   // Label 358: @16236
     /*  16236 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16313), // Rule ID 5468 //
     /*  16241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16272 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16276 */     // MIs[2] Operand 1
     /*  16276 */     // No operand predicates
     /*  16276 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16286 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16311 */     GIR_RootConstrainSelectedInstOperands,
     /*  16312 */     // GIR_Coverage, 5468,
     /*  16312 */     GIR_EraseRootFromParent_Done,
     /*  16313 */   // Label 359: @16313
     /*  16313 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16390), // Rule ID 5434 //
     /*  16318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16345 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16361 */     // MIs[2] Operand 1
     /*  16361 */     // No operand predicates
     /*  16361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16363 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16388 */     GIR_RootConstrainSelectedInstOperands,
     /*  16389 */     // GIR_Coverage, 5434,
     /*  16389 */     GIR_EraseRootFromParent_Done,
     /*  16390 */   // Label 360: @16390
     /*  16390 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16467), // Rule ID 5467 //
     /*  16395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16422 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16434 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16438 */     // MIs[2] Operand 1
     /*  16438 */     // No operand predicates
     /*  16438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16440 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16465 */     GIR_RootConstrainSelectedInstOperands,
     /*  16466 */     // GIR_Coverage, 5467,
     /*  16466 */     GIR_EraseRootFromParent_Done,
     /*  16467 */   // Label 361: @16467
     /*  16467 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16544), // Rule ID 159 //
     /*  16472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16507 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16511 */     // MIs[2] Operand 1
     /*  16511 */     // No operand predicates
     /*  16511 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16517 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16542 */     GIR_RootConstrainSelectedInstOperands,
     /*  16543 */     // GIR_Coverage, 159,
     /*  16543 */     GIR_EraseRootFromParent_Done,
     /*  16544 */   // Label 362: @16544
     /*  16544 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16621), // Rule ID 490 //
     /*  16549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16584 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16588 */     // MIs[2] Operand 1
     /*  16588 */     // No operand predicates
     /*  16588 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16594 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16619 */     GIR_RootConstrainSelectedInstOperands,
     /*  16620 */     // GIR_Coverage, 490,
     /*  16620 */     GIR_EraseRootFromParent_Done,
     /*  16621 */   // Label 363: @16621
     /*  16621 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16692), // Rule ID 5437 //
     /*  16626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16654 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16664 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16690 */     GIR_RootConstrainSelectedInstOperands,
     /*  16691 */     // GIR_Coverage, 5437,
     /*  16691 */     GIR_EraseRootFromParent_Done,
     /*  16692 */   // Label 364: @16692
     /*  16692 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16763), // Rule ID 5458 //
     /*  16697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16725 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16735 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16761 */     GIR_RootConstrainSelectedInstOperands,
     /*  16762 */     // GIR_Coverage, 5458,
     /*  16762 */     GIR_EraseRootFromParent_Done,
     /*  16763 */   // Label 365: @16763
     /*  16763 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16834), // Rule ID 5470 //
     /*  16768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16796 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16806 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16832 */     GIR_RootConstrainSelectedInstOperands,
     /*  16833 */     // GIR_Coverage, 5470,
     /*  16833 */     GIR_EraseRootFromParent_Done,
     /*  16834 */   // Label 366: @16834
     /*  16834 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16905), // Rule ID 160 //
     /*  16839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16871 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16877 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16903 */     GIR_RootConstrainSelectedInstOperands,
     /*  16904 */     // GIR_Coverage, 160,
     /*  16904 */     GIR_EraseRootFromParent_Done,
     /*  16905 */   // Label 367: @16905
     /*  16905 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16976), // Rule ID 313 //
     /*  16910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16942 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16948 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16974 */     GIR_RootConstrainSelectedInstOperands,
     /*  16975 */     // GIR_Coverage, 313,
     /*  16975 */     GIR_EraseRootFromParent_Done,
     /*  16976 */   // Label 368: @16976
     /*  16976 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(17047), // Rule ID 491 //
     /*  16981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17013 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17019 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17045 */     GIR_RootConstrainSelectedInstOperands,
     /*  17046 */     // GIR_Coverage, 491,
     /*  17046 */     GIR_EraseRootFromParent_Done,
     /*  17047 */   // Label 369: @17047
     /*  17047 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17092), // Rule ID 345 //
     /*  17052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17063 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17074 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17090 */     GIR_RootConstrainSelectedInstOperands,
     /*  17091 */     // GIR_Coverage, 345,
     /*  17091 */     GIR_EraseRootFromParent_Done,
     /*  17092 */   // Label 370: @17092
     /*  17092 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17137), // Rule ID 346 //
     /*  17097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17108 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17119 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17135 */     GIR_RootConstrainSelectedInstOperands,
     /*  17136 */     // GIR_Coverage, 346,
     /*  17136 */     GIR_EraseRootFromParent_Done,
     /*  17137 */   // Label 371: @17137
     /*  17137 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17196), // Rule ID 1891 //
     /*  17142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17165 */     // MIs[1] Operand 1
     /*  17165 */     // No operand predicates
     /*  17165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17167 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17172 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17174 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17194 */     GIR_RootConstrainSelectedInstOperands,
     /*  17195 */     // GIR_Coverage, 1891,
     /*  17195 */     GIR_EraseRootFromParent_Done,
     /*  17196 */   // Label 372: @17196
     /*  17196 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17253), // Rule ID 147 //
     /*  17201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17224 */     // MIs[1] Operand 1
     /*  17224 */     // No operand predicates
     /*  17224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17226 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17251 */     GIR_RootConstrainSelectedInstOperands,
     /*  17252 */     // GIR_Coverage, 147,
     /*  17252 */     GIR_EraseRootFromParent_Done,
     /*  17253 */   // Label 373: @17253
     /*  17253 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17310), // Rule ID 481 //
     /*  17258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17281 */     // MIs[1] Operand 1
     /*  17281 */     // No operand predicates
     /*  17281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17283 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17308 */     GIR_RootConstrainSelectedInstOperands,
     /*  17309 */     // GIR_Coverage, 481,
     /*  17309 */     GIR_EraseRootFromParent_Done,
     /*  17310 */   // Label 374: @17310
     /*  17310 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17361), // Rule ID 163 //
     /*  17315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17334 */     // MIs[1] Operand 1
     /*  17334 */     // No operand predicates
     /*  17334 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17340 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17345 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17359 */     GIR_RootConstrainSelectedInstOperands,
     /*  17360 */     // GIR_Coverage, 163,
     /*  17360 */     GIR_EraseRootFromParent_Done,
     /*  17361 */   // Label 375: @17361
     /*  17361 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17412), // Rule ID 493 //
     /*  17366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17385 */     // MIs[1] Operand 1
     /*  17385 */     // No operand predicates
     /*  17385 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17391 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17396 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17410 */     GIR_RootConstrainSelectedInstOperands,
     /*  17411 */     // GIR_Coverage, 493,
     /*  17411 */     GIR_EraseRootFromParent_Done,
     /*  17412 */   // Label 376: @17412
     /*  17412 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17458), // Rule ID 148 //
     /*  17417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17456 */     GIR_RootConstrainSelectedInstOperands,
     /*  17457 */     // GIR_Coverage, 148,
     /*  17457 */     GIR_EraseRootFromParent_Done,
     /*  17458 */   // Label 377: @17458
     /*  17458 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17504), // Rule ID 310 //
     /*  17463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17502 */     GIR_RootConstrainSelectedInstOperands,
     /*  17503 */     // GIR_Coverage, 310,
     /*  17503 */     GIR_EraseRootFromParent_Done,
     /*  17504 */   // Label 378: @17504
     /*  17504 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17550), // Rule ID 482 //
     /*  17509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17548 */     GIR_RootConstrainSelectedInstOperands,
     /*  17549 */     // GIR_Coverage, 482,
     /*  17549 */     GIR_EraseRootFromParent_Done,
     /*  17550 */   // Label 379: @17550
     /*  17550 */   GIM_Reject,
     /*  17551 */ // Label 347: @17551
     /*  17551 */ GIM_Reject,
     /*  17552 */ // Label 334: @17552
     /*  17552 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17598), // Rule ID 2523 //
     /*  17557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17583 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17585 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17590 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17596 */   GIR_RootConstrainSelectedInstOperands,
     /*  17597 */   // GIR_Coverage, 2523,
     /*  17597 */   GIR_EraseRootFromParent_Done,
     /*  17598 */ // Label 380: @17598
     /*  17598 */ GIM_Reject,
     /*  17599 */ // Label 335: @17599
     /*  17599 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17716), // Rule ID 1823 //
     /*  17604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17625 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17628 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17632 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17637 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17641 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17646 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17649 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17653 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17658 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17662 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17679 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17682 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17685 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17688 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17694 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17715 */   // GIR_Coverage, 1823,
     /*  17715 */   GIR_EraseRootFromParent_Done,
     /*  17716 */ // Label 381: @17716
     /*  17716 */ GIM_Reject,
     /*  17717 */ // Label 336: @17717
     /*  17717 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17763), // Rule ID 1130 //
     /*  17722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17748 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17750 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17755 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17761 */   GIR_RootConstrainSelectedInstOperands,
     /*  17762 */   // GIR_Coverage, 1130,
     /*  17762 */   GIR_EraseRootFromParent_Done,
     /*  17763 */ // Label 382: @17763
     /*  17763 */ GIM_Reject,
     /*  17764 */ // Label 337: @17764
     /*  17764 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17877),
     /*  17769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17775 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17815), // Rule ID 2526 //
     /*  17780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17800 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17802 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17813 */     GIR_RootConstrainSelectedInstOperands,
     /*  17814 */     // GIR_Coverage, 2526,
     /*  17814 */     GIR_EraseRootFromParent_Done,
     /*  17815 */   // Label 384: @17815
     /*  17815 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17876), // Rule ID 3367 //
     /*  17820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17874 */     GIR_RootConstrainSelectedInstOperands,
     /*  17875 */     // GIR_Coverage, 3367,
     /*  17875 */     GIR_EraseRootFromParent_Done,
     /*  17876 */   // Label 385: @17876
     /*  17876 */   GIM_Reject,
     /*  17877 */ // Label 383: @17877
     /*  17877 */ GIM_Reject,
     /*  17878 */ // Label 338: @17878
     /*  17878 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17995), // Rule ID 1824 //
     /*  17883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17904 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17907 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17911 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17916 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17920 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17925 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17928 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17932 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17937 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17941 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17958 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17961 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17964 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17967 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17973 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17994 */   // GIR_Coverage, 1824,
     /*  17994 */   GIR_EraseRootFromParent_Done,
     /*  17995 */ // Label 386: @17995
     /*  17995 */ GIM_Reject,
     /*  17996 */ // Label 339: @17996
     /*  17996 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18042), // Rule ID 2522 //
     /*  18001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18027 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18029 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18034 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18040 */   GIR_RootConstrainSelectedInstOperands,
     /*  18041 */   // GIR_Coverage, 2522,
     /*  18041 */   GIR_EraseRootFromParent_Done,
     /*  18042 */ // Label 387: @18042
     /*  18042 */ GIM_Reject,
     /*  18043 */ // Label 340: @18043
     /*  18043 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18156),
     /*  18048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18054 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18094), // Rule ID 1131 //
     /*  18059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18092 */     GIR_RootConstrainSelectedInstOperands,
     /*  18093 */     // GIR_Coverage, 1131,
     /*  18093 */     GIR_EraseRootFromParent_Done,
     /*  18094 */   // Label 389: @18094
     /*  18094 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18155), // Rule ID 3363 //
     /*  18099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18153 */     GIR_RootConstrainSelectedInstOperands,
     /*  18154 */     // GIR_Coverage, 3363,
     /*  18154 */     GIR_EraseRootFromParent_Done,
     /*  18155 */   // Label 390: @18155
     /*  18155 */   GIM_Reject,
     /*  18156 */ // Label 388: @18156
     /*  18156 */ GIM_Reject,
     /*  18157 */ // Label 341: @18157
     /*  18157 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18274), // Rule ID 1825 //
     /*  18162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18183 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18186 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18190 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18195 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18199 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18204 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18207 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18211 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18216 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18220 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18225 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18228 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18232 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18237 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18240 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18243 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18246 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18252 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18265 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18268 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18273 */   // GIR_Coverage, 1825,
     /*  18273 */   GIR_EraseRootFromParent_Done,
     /*  18274 */ // Label 391: @18274
     /*  18274 */ GIM_Reject,
     /*  18275 */ // Label 342: @18275
     /*  18275 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18321), // Rule ID 2521 //
     /*  18280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18306 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18308 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18313 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18319 */   GIR_RootConstrainSelectedInstOperands,
     /*  18320 */   // GIR_Coverage, 2521,
     /*  18320 */   GIR_EraseRootFromParent_Done,
     /*  18321 */ // Label 392: @18321
     /*  18321 */ GIM_Reject,
     /*  18322 */ // Label 343: @18322
     /*  18322 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18435),
     /*  18327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18333 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18373), // Rule ID 2525 //
     /*  18338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18358 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18360 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18371 */     GIR_RootConstrainSelectedInstOperands,
     /*  18372 */     // GIR_Coverage, 2525,
     /*  18372 */     GIR_EraseRootFromParent_Done,
     /*  18373 */   // Label 394: @18373
     /*  18373 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18434), // Rule ID 3359 //
     /*  18378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18432 */     GIR_RootConstrainSelectedInstOperands,
     /*  18433 */     // GIR_Coverage, 3359,
     /*  18433 */     GIR_EraseRootFromParent_Done,
     /*  18434 */   // Label 395: @18434
     /*  18434 */   GIM_Reject,
     /*  18435 */ // Label 393: @18435
     /*  18435 */ GIM_Reject,
     /*  18436 */ // Label 344: @18436
     /*  18436 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18553), // Rule ID 1826 //
     /*  18441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18462 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18465 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18469 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18474 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18478 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18495 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18499 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18516 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18519 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18522 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18525 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18531 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18552 */   // GIR_Coverage, 1826,
     /*  18552 */   GIR_EraseRootFromParent_Done,
     /*  18553 */ // Label 396: @18553
     /*  18553 */ GIM_Reject,
     /*  18554 */ // Label 345: @18554
     /*  18554 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18667),
     /*  18559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18565 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18605), // Rule ID 2524 //
     /*  18570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18590 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18592 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18603 */     GIR_RootConstrainSelectedInstOperands,
     /*  18604 */     // GIR_Coverage, 2524,
     /*  18604 */     GIR_EraseRootFromParent_Done,
     /*  18605 */   // Label 398: @18605
     /*  18605 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18666), // Rule ID 3355 //
     /*  18610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18664 */     GIR_RootConstrainSelectedInstOperands,
     /*  18665 */     // GIR_Coverage, 3355,
     /*  18665 */     GIR_EraseRootFromParent_Done,
     /*  18666 */   // Label 399: @18666
     /*  18666 */   GIM_Reject,
     /*  18667 */ // Label 397: @18667
     /*  18667 */ GIM_Reject,
     /*  18668 */ // Label 346: @18668
     /*  18668 */ GIM_Reject,
     /*  18669 */ // Label 6: @18669
     /*  18669 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 413*/ GIMT_Encode4(24477),
     /*  18680 */ /*GILLT_s32*//*Label 400*/ GIMT_Encode4(18740),
     /*  18684 */ /*GILLT_s64*//*Label 401*/ GIMT_Encode4(23361),
     /*  18688 */ /*GILLT_v2s1*//*Label 402*/ GIMT_Encode4(23408),
     /*  18692 */ /*GILLT_v2s32*//*Label 403*/ GIMT_Encode4(23526),
     /*  18696 */ /*GILLT_v2s64*//*Label 404*/ GIMT_Encode4(23573),
     /*  18700 */ /*GILLT_v4s1*//*Label 405*/ GIMT_Encode4(23687),
     /*  18704 */ /*GILLT_v4s16*//*Label 406*/ GIMT_Encode4(23805),
     /*  18708 */ /*GILLT_v4s32*//*Label 407*/ GIMT_Encode4(23852), GIMT_Encode4(0),
     /*  18716 */ /*GILLT_v8s1*//*Label 408*/ GIMT_Encode4(23966),
     /*  18720 */ /*GILLT_v8s8*//*Label 409*/ GIMT_Encode4(24084),
     /*  18724 */ /*GILLT_v8s16*//*Label 410*/ GIMT_Encode4(24131), GIMT_Encode4(0),
     /*  18732 */ /*GILLT_v16s1*//*Label 411*/ GIMT_Encode4(24245),
     /*  18736 */ /*GILLT_v16s8*//*Label 412*/ GIMT_Encode4(24363),
     /*  18740 */ // Label 400: @18740
     /*  18740 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(23360),
     /*  18745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18751 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(18878), // Rule ID 5652 //
     /*  18756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18791 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18800 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18804 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18831 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18835 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18839 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18843 */     // MIs[4] Rm
     /*  18843 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18848 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18852 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18856 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18858 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18870 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18876 */     GIR_RootConstrainSelectedInstOperands,
     /*  18877 */     // GIR_Coverage, 5652,
     /*  18877 */     GIR_EraseRootFromParent_Done,
     /*  18878 */   // Label 415: @18878
     /*  18878 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(19005), // Rule ID 5694 //
     /*  18883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18927 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18931 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18950 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18954 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18958 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18962 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18966 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18970 */     // MIs[4] Rm
     /*  18970 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18975 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18979 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18983 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18985 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19003 */     GIR_RootConstrainSelectedInstOperands,
     /*  19004 */     // GIR_Coverage, 5694,
     /*  19004 */     GIR_EraseRootFromParent_Done,
     /*  19005 */   // Label 416: @19005
     /*  19005 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19132), // Rule ID 1911 //
     /*  19010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19045 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19054 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19058 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19070 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19086 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19090 */     // MIs[4] Rm
     /*  19090 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19095 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19099 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19112 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19130 */     GIR_RootConstrainSelectedInstOperands,
     /*  19131 */     // GIR_Coverage, 1911,
     /*  19131 */     GIR_EraseRootFromParent_Done,
     /*  19132 */   // Label 417: @19132
     /*  19132 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19259), // Rule ID 2193 //
     /*  19137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19172 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19181 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19185 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19189 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19193 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19197 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19201 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19205 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19209 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19213 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19217 */     // MIs[4] Rm
     /*  19217 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19222 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19226 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19237 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19239 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19257 */     GIR_RootConstrainSelectedInstOperands,
     /*  19258 */     // GIR_Coverage, 2193,
     /*  19258 */     GIR_EraseRootFromParent_Done,
     /*  19259 */   // Label 418: @19259
     /*  19259 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19392), // Rule ID 5450 //
     /*  19264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19316 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19320 */     // MIs[3] Operand 1
     /*  19320 */     // No operand predicates
     /*  19320 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19331 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19335 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19339 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19343 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19347 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19352 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19365 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19390 */     GIR_RootConstrainSelectedInstOperands,
     /*  19391 */     // GIR_Coverage, 5450,
     /*  19391 */     GIR_EraseRootFromParent_Done,
     /*  19392 */   // Label 419: @19392
     /*  19392 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19525), // Rule ID 5487 //
     /*  19397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19441 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19445 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19449 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19453 */     // MIs[3] Operand 1
     /*  19453 */     // No operand predicates
     /*  19453 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19468 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19472 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19476 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19480 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19485 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19496 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19498 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19523 */     GIR_RootConstrainSelectedInstOperands,
     /*  19524 */     // GIR_Coverage, 5487,
     /*  19524 */     GIR_EraseRootFromParent_Done,
     /*  19525 */   // Label 420: @19525
     /*  19525 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19658), // Rule ID 5657 //
     /*  19530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19574 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19578 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19582 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19586 */     // MIs[3] Operand 1
     /*  19586 */     // No operand predicates
     /*  19586 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19597 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19601 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19605 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19609 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19613 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19618 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19629 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19631 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19656 */     GIR_RootConstrainSelectedInstOperands,
     /*  19657 */     // GIR_Coverage, 5657,
     /*  19657 */     GIR_EraseRootFromParent_Done,
     /*  19658 */   // Label 421: @19658
     /*  19658 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19791), // Rule ID 5699 //
     /*  19663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19715 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19719 */     // MIs[3] Operand 1
     /*  19719 */     // No operand predicates
     /*  19719 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19734 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19738 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19742 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19746 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19751 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19762 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19764 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19789 */     GIR_RootConstrainSelectedInstOperands,
     /*  19790 */     // GIR_Coverage, 5699,
     /*  19790 */     GIR_EraseRootFromParent_Done,
     /*  19791 */   // Label 422: @19791
     /*  19791 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19924), // Rule ID 5449 //
     /*  19796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19835 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19848 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19852 */     // MIs[3] Operand 1
     /*  19852 */     // No operand predicates
     /*  19852 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19863 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19867 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19871 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19875 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19879 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19884 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19895 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19897 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19922 */     GIR_RootConstrainSelectedInstOperands,
     /*  19923 */     // GIR_Coverage, 5449,
     /*  19923 */     GIR_EraseRootFromParent_Done,
     /*  19924 */   // Label 423: @19924
     /*  19924 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20057), // Rule ID 5486 //
     /*  19929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19948 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19964 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19973 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19977 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19981 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19985 */     // MIs[3] Operand 1
     /*  19985 */     // No operand predicates
     /*  19985 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19996 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20000 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20004 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20008 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20012 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20017 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20028 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20030 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20055 */     GIR_RootConstrainSelectedInstOperands,
     /*  20056 */     // GIR_Coverage, 5486,
     /*  20056 */     GIR_EraseRootFromParent_Done,
     /*  20057 */   // Label 424: @20057
     /*  20057 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20190), // Rule ID 203 //
     /*  20062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20090 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20113 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20125 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20133 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20146 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20150 */     // MIs[4] Operand 1
     /*  20150 */     // No operand predicates
     /*  20150 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20161 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20163 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20188 */     GIR_RootConstrainSelectedInstOperands,
     /*  20189 */     // GIR_Coverage, 203,
     /*  20189 */     GIR_EraseRootFromParent_Done,
     /*  20190 */   // Label 425: @20190
     /*  20190 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20323), // Rule ID 540 //
     /*  20195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20223 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20246 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20254 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20258 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20262 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20266 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20271 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20275 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20279 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20283 */     // MIs[4] Operand 1
     /*  20283 */     // No operand predicates
     /*  20283 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20294 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20296 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20321 */     GIR_RootConstrainSelectedInstOperands,
     /*  20322 */     // GIR_Coverage, 540,
     /*  20322 */     GIR_EraseRootFromParent_Done,
     /*  20323 */   // Label 426: @20323
     /*  20323 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20456), // Rule ID 1916 //
     /*  20328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20356 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20379 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20383 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20387 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20391 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20395 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20399 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20404 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20408 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20412 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20416 */     // MIs[4] Operand 1
     /*  20416 */     // No operand predicates
     /*  20416 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20427 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20429 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20454 */     GIR_RootConstrainSelectedInstOperands,
     /*  20455 */     // GIR_Coverage, 1916,
     /*  20455 */     GIR_EraseRootFromParent_Done,
     /*  20456 */   // Label 427: @20456
     /*  20456 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20589), // Rule ID 2198 //
     /*  20461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20489 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20508 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20512 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20520 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20524 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20528 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20532 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20537 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20541 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20545 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20549 */     // MIs[4] Operand 1
     /*  20549 */     // No operand predicates
     /*  20549 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20562 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20587 */     GIR_RootConstrainSelectedInstOperands,
     /*  20588 */     // GIR_Coverage, 2198,
     /*  20588 */     GIR_EraseRootFromParent_Done,
     /*  20589 */   // Label 428: @20589
     /*  20589 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20722), // Rule ID 202 //
     /*  20594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20622 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20653 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20657 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20661 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20665 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20670 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20674 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20678 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20682 */     // MIs[4] Operand 1
     /*  20682 */     // No operand predicates
     /*  20682 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20693 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20695 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20720 */     GIR_RootConstrainSelectedInstOperands,
     /*  20721 */     // GIR_Coverage, 202,
     /*  20721 */     GIR_EraseRootFromParent_Done,
     /*  20722 */   // Label 429: @20722
     /*  20722 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20855), // Rule ID 539 //
     /*  20727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20755 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20798 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20811 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20815 */     // MIs[4] Operand 1
     /*  20815 */     // No operand predicates
     /*  20815 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20826 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20828 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20853 */     GIR_RootConstrainSelectedInstOperands,
     /*  20854 */     // GIR_Coverage, 539,
     /*  20854 */     GIR_EraseRootFromParent_Done,
     /*  20855 */   // Label 430: @20855
     /*  20855 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20960), // Rule ID 1912 //
     /*  20860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20888 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20911 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20920 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20933 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20958 */     GIR_RootConstrainSelectedInstOperands,
     /*  20959 */     // GIR_Coverage, 1912,
     /*  20959 */     GIR_EraseRootFromParent_Done,
     /*  20960 */   // Label 431: @20960
     /*  20960 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21065), // Rule ID 2194 //
     /*  20965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21012 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21016 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21025 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21038 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21063 */     GIR_RootConstrainSelectedInstOperands,
     /*  21064 */     // GIR_Coverage, 2194,
     /*  21064 */     GIR_EraseRootFromParent_Done,
     /*  21065 */   // Label 432: @21065
     /*  21065 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21170), // Rule ID 5653 //
     /*  21070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21130 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21143 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21168 */     GIR_RootConstrainSelectedInstOperands,
     /*  21169 */     // GIR_Coverage, 5653,
     /*  21169 */     GIR_EraseRootFromParent_Done,
     /*  21170 */   // Label 433: @21170
     /*  21170 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21275), // Rule ID 5695 //
     /*  21175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21203 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21226 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21235 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21248 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21273 */     GIR_RootConstrainSelectedInstOperands,
     /*  21274 */     // GIR_Coverage, 5695,
     /*  21274 */     GIR_EraseRootFromParent_Done,
     /*  21275 */   // Label 434: @21275
     /*  21275 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21381), // Rule ID 1915 //
     /*  21280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21308 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21340 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21344 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21348 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21352 */     // MIs[3] Operand 1
     /*  21352 */     // No operand predicates
     /*  21352 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21354 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21379 */     GIR_RootConstrainSelectedInstOperands,
     /*  21380 */     // GIR_Coverage, 1915,
     /*  21380 */     GIR_EraseRootFromParent_Done,
     /*  21381 */   // Label 435: @21381
     /*  21381 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21487), // Rule ID 2197 //
     /*  21386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21414 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21437 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21441 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21454 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21458 */     // MIs[3] Operand 1
     /*  21458 */     // No operand predicates
     /*  21458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21460 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21485 */     GIR_RootConstrainSelectedInstOperands,
     /*  21486 */     // GIR_Coverage, 2197,
     /*  21486 */     GIR_EraseRootFromParent_Done,
     /*  21487 */   // Label 436: @21487
     /*  21487 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21593), // Rule ID 1914 //
     /*  21492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21520 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21560 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21564 */     // MIs[3] Operand 1
     /*  21564 */     // No operand predicates
     /*  21564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21566 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21591 */     GIR_RootConstrainSelectedInstOperands,
     /*  21592 */     // GIR_Coverage, 1914,
     /*  21592 */     GIR_EraseRootFromParent_Done,
     /*  21593 */   // Label 437: @21593
     /*  21593 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21699), // Rule ID 2196 //
     /*  21598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21626 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21649 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21666 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21670 */     // MIs[3] Operand 1
     /*  21670 */     // No operand predicates
     /*  21670 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21672 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21697 */     GIR_RootConstrainSelectedInstOperands,
     /*  21698 */     // GIR_Coverage, 2196,
     /*  21698 */     GIR_EraseRootFromParent_Done,
     /*  21699 */   // Label 438: @21699
     /*  21699 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21805), // Rule ID 1913 //
     /*  21704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21732 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21768 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21772 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21776 */     // MIs[3] Operand 1
     /*  21776 */     // No operand predicates
     /*  21776 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21778 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21803 */     GIR_RootConstrainSelectedInstOperands,
     /*  21804 */     // GIR_Coverage, 1913,
     /*  21804 */     GIR_EraseRootFromParent_Done,
     /*  21805 */   // Label 439: @21805
     /*  21805 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21911), // Rule ID 2195 //
     /*  21810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21838 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21849 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21853 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21857 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21861 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21878 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21882 */     // MIs[3] Operand 1
     /*  21882 */     // No operand predicates
     /*  21882 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21884 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21909 */     GIR_RootConstrainSelectedInstOperands,
     /*  21910 */     // GIR_Coverage, 2195,
     /*  21910 */     GIR_EraseRootFromParent_Done,
     /*  21911 */   // Label 440: @21911
     /*  21911 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(22017), // Rule ID 5656 //
     /*  21916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21952 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21956 */     // MIs[2] Operand 1
     /*  21956 */     // No operand predicates
     /*  21956 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21960 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21964 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21968 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21977 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21990 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  21999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22015 */     GIR_RootConstrainSelectedInstOperands,
     /*  22016 */     // GIR_Coverage, 5656,
     /*  22016 */     GIR_EraseRootFromParent_Done,
     /*  22017 */   // Label 441: @22017
     /*  22017 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22123), // Rule ID 5698 //
     /*  22022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22058 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22062 */     // MIs[2] Operand 1
     /*  22062 */     // No operand predicates
     /*  22062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22070 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22078 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22083 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22094 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22096 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22121 */     GIR_RootConstrainSelectedInstOperands,
     /*  22122 */     // GIR_Coverage, 5698,
     /*  22122 */     GIR_EraseRootFromParent_Done,
     /*  22123 */   // Label 442: @22123
     /*  22123 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22229), // Rule ID 5655 //
     /*  22128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22164 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22168 */     // MIs[2] Operand 1
     /*  22168 */     // No operand predicates
     /*  22168 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22172 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22176 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22180 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22184 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22189 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22202 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22227 */     GIR_RootConstrainSelectedInstOperands,
     /*  22228 */     // GIR_Coverage, 5655,
     /*  22228 */     GIR_EraseRootFromParent_Done,
     /*  22229 */   // Label 443: @22229
     /*  22229 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22335), // Rule ID 5697 //
     /*  22234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22270 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22274 */     // MIs[2] Operand 1
     /*  22274 */     // No operand predicates
     /*  22274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22286 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22290 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22295 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22308 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22333 */     GIR_RootConstrainSelectedInstOperands,
     /*  22334 */     // GIR_Coverage, 5697,
     /*  22334 */     GIR_EraseRootFromParent_Done,
     /*  22335 */   // Label 444: @22335
     /*  22335 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22441), // Rule ID 5654 //
     /*  22340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22380 */     // MIs[2] Operand 1
     /*  22380 */     // No operand predicates
     /*  22380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22392 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22396 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22401 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22414 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22439 */     GIR_RootConstrainSelectedInstOperands,
     /*  22440 */     // GIR_Coverage, 5654,
     /*  22440 */     GIR_EraseRootFromParent_Done,
     /*  22441 */   // Label 445: @22441
     /*  22441 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22547), // Rule ID 5696 //
     /*  22446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22482 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22486 */     // MIs[2] Operand 1
     /*  22486 */     // No operand predicates
     /*  22486 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22490 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22494 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22498 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22502 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22507 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22518 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22520 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22545 */     GIR_RootConstrainSelectedInstOperands,
     /*  22546 */     // GIR_Coverage, 5696,
     /*  22546 */     GIR_EraseRootFromParent_Done,
     /*  22547 */   // Label 446: @22547
     /*  22547 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22624), // Rule ID 5474 //
     /*  22552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22575 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22587 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22591 */     // MIs[2] Operand 1
     /*  22591 */     // No operand predicates
     /*  22591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22597 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22622 */     GIR_RootConstrainSelectedInstOperands,
     /*  22623 */     // GIR_Coverage, 5474,
     /*  22623 */     GIR_EraseRootFromParent_Done,
     /*  22624 */   // Label 447: @22624
     /*  22624 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22701), // Rule ID 5473 //
     /*  22629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22660 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22664 */     // MIs[2] Operand 1
     /*  22664 */     // No operand predicates
     /*  22664 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22674 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22699 */     GIR_RootConstrainSelectedInstOperands,
     /*  22700 */     // GIR_Coverage, 5473,
     /*  22700 */     GIR_EraseRootFromParent_Done,
     /*  22701 */   // Label 448: @22701
     /*  22701 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22778), // Rule ID 5472 //
     /*  22706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22745 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22749 */     // MIs[2] Operand 1
     /*  22749 */     // No operand predicates
     /*  22749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22751 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22776 */     GIR_RootConstrainSelectedInstOperands,
     /*  22777 */     // GIR_Coverage, 5472,
     /*  22777 */     GIR_EraseRootFromParent_Done,
     /*  22778 */   // Label 449: @22778
     /*  22778 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22855), // Rule ID 496 //
     /*  22783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22818 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22822 */     // MIs[2] Operand 1
     /*  22822 */     // No operand predicates
     /*  22822 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22828 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22853 */     GIR_RootConstrainSelectedInstOperands,
     /*  22854 */     // GIR_Coverage, 496,
     /*  22854 */     GIR_EraseRootFromParent_Done,
     /*  22855 */   // Label 450: @22855
     /*  22855 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22926), // Rule ID 5475 //
     /*  22860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22879 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22888 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22898 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22924 */     GIR_RootConstrainSelectedInstOperands,
     /*  22925 */     // GIR_Coverage, 5475,
     /*  22925 */     GIR_EraseRootFromParent_Done,
     /*  22926 */   // Label 451: @22926
     /*  22926 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(22997), // Rule ID 497 //
     /*  22931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22963 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22969 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22995 */     GIR_RootConstrainSelectedInstOperands,
     /*  22996 */     // GIR_Coverage, 497,
     /*  22996 */     GIR_EraseRootFromParent_Done,
     /*  22997 */   // Label 452: @22997
     /*  22997 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23052), // Rule ID 1845 //
     /*  23002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23013 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23024 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23029 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23031 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23050 */     GIR_RootConstrainSelectedInstOperands,
     /*  23051 */     // GIR_Coverage, 1845,
     /*  23051 */     GIR_EraseRootFromParent_Done,
     /*  23052 */   // Label 453: @23052
     /*  23052 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23107), // Rule ID 2091 //
     /*  23057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23068 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23079 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23084 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23086 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23105 */     GIR_RootConstrainSelectedInstOperands,
     /*  23106 */     // GIR_Coverage, 2091,
     /*  23106 */     GIR_EraseRootFromParent_Done,
     /*  23107 */   // Label 454: @23107
     /*  23107 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23164), // Rule ID 151 //
     /*  23112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23135 */     // MIs[1] Operand 1
     /*  23135 */     // No operand predicates
     /*  23135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23137 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23162 */     GIR_RootConstrainSelectedInstOperands,
     /*  23163 */     // GIR_Coverage, 151,
     /*  23163 */     GIR_EraseRootFromParent_Done,
     /*  23164 */   // Label 455: @23164
     /*  23164 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23221), // Rule ID 484 //
     /*  23169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23192 */     // MIs[1] Operand 1
     /*  23192 */     // No operand predicates
     /*  23192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23194 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23219 */     GIR_RootConstrainSelectedInstOperands,
     /*  23220 */     // GIR_Coverage, 484,
     /*  23220 */     GIR_EraseRootFromParent_Done,
     /*  23221 */   // Label 456: @23221
     /*  23221 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23267), // Rule ID 152 //
     /*  23226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23265 */     GIR_RootConstrainSelectedInstOperands,
     /*  23266 */     // GIR_Coverage, 152,
     /*  23266 */     GIR_EraseRootFromParent_Done,
     /*  23267 */   // Label 457: @23267
     /*  23267 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23313), // Rule ID 325 //
     /*  23272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23311 */     GIR_RootConstrainSelectedInstOperands,
     /*  23312 */     // GIR_Coverage, 325,
     /*  23312 */     GIR_EraseRootFromParent_Done,
     /*  23313 */   // Label 458: @23313
     /*  23313 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23359), // Rule ID 485 //
     /*  23318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23357 */     GIR_RootConstrainSelectedInstOperands,
     /*  23358 */     // GIR_Coverage, 485,
     /*  23358 */     GIR_EraseRootFromParent_Done,
     /*  23359 */   // Label 459: @23359
     /*  23359 */   GIM_Reject,
     /*  23360 */ // Label 414: @23360
     /*  23360 */ GIM_Reject,
     /*  23361 */ // Label 401: @23361
     /*  23361 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23407), // Rule ID 2529 //
     /*  23366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23392 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23394 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23399 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23405 */   GIR_RootConstrainSelectedInstOperands,
     /*  23406 */   // GIR_Coverage, 2529,
     /*  23406 */   GIR_EraseRootFromParent_Done,
     /*  23407 */ // Label 460: @23407
     /*  23407 */ GIM_Reject,
     /*  23408 */ // Label 402: @23408
     /*  23408 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23525), // Rule ID 1831 //
     /*  23413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23434 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23437 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23441 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23446 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23450 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23455 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23458 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23462 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23467 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23471 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23488 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23491 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23494 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23497 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23503 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23509 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23516 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23524 */   // GIR_Coverage, 1831,
     /*  23524 */   GIR_EraseRootFromParent_Done,
     /*  23525 */ // Label 461: @23525
     /*  23525 */ GIM_Reject,
     /*  23526 */ // Label 403: @23526
     /*  23526 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23572), // Rule ID 1134 //
     /*  23531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23557 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23559 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23564 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23570 */   GIR_RootConstrainSelectedInstOperands,
     /*  23571 */   // GIR_Coverage, 1134,
     /*  23571 */   GIR_EraseRootFromParent_Done,
     /*  23572 */ // Label 462: @23572
     /*  23572 */ GIM_Reject,
     /*  23573 */ // Label 404: @23573
     /*  23573 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23686),
     /*  23578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23584 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23624), // Rule ID 2532 //
     /*  23589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23609 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23611 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23622 */     GIR_RootConstrainSelectedInstOperands,
     /*  23623 */     // GIR_Coverage, 2532,
     /*  23623 */     GIR_EraseRootFromParent_Done,
     /*  23624 */   // Label 464: @23624
     /*  23624 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23685), // Rule ID 3381 //
     /*  23629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23683 */     GIR_RootConstrainSelectedInstOperands,
     /*  23684 */     // GIR_Coverage, 3381,
     /*  23684 */     GIR_EraseRootFromParent_Done,
     /*  23685 */   // Label 465: @23685
     /*  23685 */   GIM_Reject,
     /*  23686 */ // Label 463: @23686
     /*  23686 */ GIM_Reject,
     /*  23687 */ // Label 405: @23687
     /*  23687 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23804), // Rule ID 1832 //
     /*  23692 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23705 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23713 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23716 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23720 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23725 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23729 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23734 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23737 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23741 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23746 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23750 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23755 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23758 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23762 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23767 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23770 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23773 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23776 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23782 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23798 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23803 */   // GIR_Coverage, 1832,
     /*  23803 */   GIR_EraseRootFromParent_Done,
     /*  23804 */ // Label 466: @23804
     /*  23804 */ GIM_Reject,
     /*  23805 */ // Label 406: @23805
     /*  23805 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23851), // Rule ID 2528 //
     /*  23810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23836 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23838 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23843 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23849 */   GIR_RootConstrainSelectedInstOperands,
     /*  23850 */   // GIR_Coverage, 2528,
     /*  23850 */   GIR_EraseRootFromParent_Done,
     /*  23851 */ // Label 467: @23851
     /*  23851 */ GIM_Reject,
     /*  23852 */ // Label 407: @23852
     /*  23852 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23965),
     /*  23857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23863 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23903), // Rule ID 1135 //
     /*  23868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23901 */     GIR_RootConstrainSelectedInstOperands,
     /*  23902 */     // GIR_Coverage, 1135,
     /*  23902 */     GIR_EraseRootFromParent_Done,
     /*  23903 */   // Label 469: @23903
     /*  23903 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23964), // Rule ID 3377 //
     /*  23908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23962 */     GIR_RootConstrainSelectedInstOperands,
     /*  23963 */     // GIR_Coverage, 3377,
     /*  23963 */     GIR_EraseRootFromParent_Done,
     /*  23964 */   // Label 470: @23964
     /*  23964 */   GIM_Reject,
     /*  23965 */ // Label 468: @23965
     /*  23965 */ GIM_Reject,
     /*  23966 */ // Label 408: @23966
     /*  23966 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24083), // Rule ID 1833 //
     /*  23971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23992 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23995 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23999 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24004 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24008 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24013 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24016 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24020 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24025 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24029 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24034 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24037 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24041 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24046 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24049 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24052 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24055 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24061 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24074 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24082 */   // GIR_Coverage, 1833,
     /*  24082 */   GIR_EraseRootFromParent_Done,
     /*  24083 */ // Label 471: @24083
     /*  24083 */ GIM_Reject,
     /*  24084 */ // Label 409: @24084
     /*  24084 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24130), // Rule ID 2527 //
     /*  24089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24115 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24117 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24122 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24128 */   GIR_RootConstrainSelectedInstOperands,
     /*  24129 */   // GIR_Coverage, 2527,
     /*  24129 */   GIR_EraseRootFromParent_Done,
     /*  24130 */ // Label 472: @24130
     /*  24130 */ GIM_Reject,
     /*  24131 */ // Label 410: @24131
     /*  24131 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24244),
     /*  24136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24142 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24182), // Rule ID 2531 //
     /*  24147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24167 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24169 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24180 */     GIR_RootConstrainSelectedInstOperands,
     /*  24181 */     // GIR_Coverage, 2531,
     /*  24181 */     GIR_EraseRootFromParent_Done,
     /*  24182 */   // Label 474: @24182
     /*  24182 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24243), // Rule ID 3373 //
     /*  24187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24226 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24241 */     GIR_RootConstrainSelectedInstOperands,
     /*  24242 */     // GIR_Coverage, 3373,
     /*  24242 */     GIR_EraseRootFromParent_Done,
     /*  24243 */   // Label 475: @24243
     /*  24243 */   GIM_Reject,
     /*  24244 */ // Label 473: @24244
     /*  24244 */ GIM_Reject,
     /*  24245 */ // Label 411: @24245
     /*  24245 */ GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24362), // Rule ID 1834 //
     /*  24250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24271 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24274 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24278 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24283 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24287 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24292 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24295 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24299 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24304 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24308 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24313 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24316 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24320 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24325 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24328 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24331 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24334 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24340 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24346 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24361 */   // GIR_Coverage, 1834,
     /*  24361 */   GIR_EraseRootFromParent_Done,
     /*  24362 */ // Label 476: @24362
     /*  24362 */ GIM_Reject,
     /*  24363 */ // Label 412: @24363
     /*  24363 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24476),
     /*  24368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24374 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24414), // Rule ID 2530 //
     /*  24379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24399 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24401 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24412 */     GIR_RootConstrainSelectedInstOperands,
     /*  24413 */     // GIR_Coverage, 2530,
     /*  24413 */     GIR_EraseRootFromParent_Done,
     /*  24414 */   // Label 478: @24414
     /*  24414 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24475), // Rule ID 3369 //
     /*  24419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24473 */     GIR_RootConstrainSelectedInstOperands,
     /*  24474 */     // GIR_Coverage, 3369,
     /*  24474 */     GIR_EraseRootFromParent_Done,
     /*  24475 */   // Label 479: @24475
     /*  24475 */   GIM_Reject,
     /*  24476 */ // Label 477: @24476
     /*  24476 */ GIM_Reject,
     /*  24477 */ // Label 413: @24477
     /*  24477 */ GIM_Reject,
     /*  24478 */ // Label 7: @24478
     /*  24478 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 493*/ GIMT_Encode4(26172),
     /*  24489 */ /*GILLT_s32*//*Label 480*/ GIMT_Encode4(24549),
     /*  24493 */ /*GILLT_s64*//*Label 481*/ GIMT_Encode4(25056),
     /*  24497 */ /*GILLT_v2s1*//*Label 482*/ GIMT_Encode4(25103),
     /*  24501 */ /*GILLT_v2s32*//*Label 483*/ GIMT_Encode4(25221),
     /*  24505 */ /*GILLT_v2s64*//*Label 484*/ GIMT_Encode4(25268),
     /*  24509 */ /*GILLT_v4s1*//*Label 485*/ GIMT_Encode4(25382),
     /*  24513 */ /*GILLT_v4s16*//*Label 486*/ GIMT_Encode4(25500),
     /*  24517 */ /*GILLT_v4s32*//*Label 487*/ GIMT_Encode4(25547), GIMT_Encode4(0),
     /*  24525 */ /*GILLT_v8s1*//*Label 488*/ GIMT_Encode4(25661),
     /*  24529 */ /*GILLT_v8s8*//*Label 489*/ GIMT_Encode4(25779),
     /*  24533 */ /*GILLT_v8s16*//*Label 490*/ GIMT_Encode4(25826), GIMT_Encode4(0),
     /*  24541 */ /*GILLT_v16s1*//*Label 491*/ GIMT_Encode4(25940),
     /*  24545 */ /*GILLT_v16s8*//*Label 492*/ GIMT_Encode4(26058),
     /*  24549 */ // Label 480: @24549
     /*  24549 */ GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(25055),
     /*  24554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24560 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(24615), // Rule ID 5477 //
     /*  24565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24572 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24588 */     // MIs[1] Operand 1
     /*  24588 */     // No operand predicates
     /*  24588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24590 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24613 */     GIR_RootConstrainSelectedInstOperands,
     /*  24614 */     // GIR_Coverage, 5477,
     /*  24614 */     GIR_EraseRootFromParent_Done,
     /*  24615 */   // Label 495: @24615
     /*  24615 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24670), // Rule ID 499 //
     /*  24620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24639 */     // MIs[1] Operand 1
     /*  24639 */     // No operand predicates
     /*  24639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24645 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24668 */     GIR_RootConstrainSelectedInstOperands,
     /*  24669 */     // GIR_Coverage, 499,
     /*  24669 */     GIR_EraseRootFromParent_Done,
     /*  24670 */   // Label 496: @24670
     /*  24670 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24714), // Rule ID 500 //
     /*  24675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24690 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24712 */     GIR_RootConstrainSelectedInstOperands,
     /*  24713 */     // GIR_Coverage, 500,
     /*  24713 */     GIR_EraseRootFromParent_Done,
     /*  24714 */   // Label 497: @24714
     /*  24714 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24758), // Rule ID 165 //
     /*  24719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24734 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24756 */     GIR_RootConstrainSelectedInstOperands,
     /*  24757 */     // GIR_Coverage, 165,
     /*  24757 */     GIR_EraseRootFromParent_Done,
     /*  24758 */   // Label 498: @24758
     /*  24758 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24802), // Rule ID 324 //
     /*  24763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24774 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24778 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24800 */     GIR_RootConstrainSelectedInstOperands,
     /*  24801 */     // GIR_Coverage, 324,
     /*  24801 */     GIR_EraseRootFromParent_Done,
     /*  24802 */   // Label 499: @24802
     /*  24802 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24859), // Rule ID 155 //
     /*  24807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24830 */     // MIs[1] Operand 1
     /*  24830 */     // No operand predicates
     /*  24830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24832 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24857 */     GIR_RootConstrainSelectedInstOperands,
     /*  24858 */     // GIR_Coverage, 155,
     /*  24858 */     GIR_EraseRootFromParent_Done,
     /*  24859 */   // Label 500: @24859
     /*  24859 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24916), // Rule ID 487 //
     /*  24864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24887 */     // MIs[1] Operand 1
     /*  24887 */     // No operand predicates
     /*  24887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24889 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24914 */     GIR_RootConstrainSelectedInstOperands,
     /*  24915 */     // GIR_Coverage, 487,
     /*  24915 */     GIR_EraseRootFromParent_Done,
     /*  24916 */   // Label 501: @24916
     /*  24916 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24962), // Rule ID 156 //
     /*  24921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24960 */     GIR_RootConstrainSelectedInstOperands,
     /*  24961 */     // GIR_Coverage, 156,
     /*  24961 */     GIR_EraseRootFromParent_Done,
     /*  24962 */   // Label 502: @24962
     /*  24962 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(25008), // Rule ID 317 //
     /*  24967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25006 */     GIR_RootConstrainSelectedInstOperands,
     /*  25007 */     // GIR_Coverage, 317,
     /*  25007 */     GIR_EraseRootFromParent_Done,
     /*  25008 */   // Label 503: @25008
     /*  25008 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25054), // Rule ID 488 //
     /*  25013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25052 */     GIR_RootConstrainSelectedInstOperands,
     /*  25053 */     // GIR_Coverage, 488,
     /*  25053 */     GIR_EraseRootFromParent_Done,
     /*  25054 */   // Label 504: @25054
     /*  25054 */   GIM_Reject,
     /*  25055 */ // Label 494: @25055
     /*  25055 */ GIM_Reject,
     /*  25056 */ // Label 481: @25056
     /*  25056 */ GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25102), // Rule ID 2535 //
     /*  25061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25087 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25089 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25094 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25100 */   GIR_RootConstrainSelectedInstOperands,
     /*  25101 */   // GIR_Coverage, 2535,
     /*  25101 */   GIR_EraseRootFromParent_Done,
     /*  25102 */ // Label 505: @25102
     /*  25102 */ GIM_Reject,
     /*  25103 */ // Label 482: @25103
     /*  25103 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25220), // Rule ID 1827 //
     /*  25108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25129 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25132 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25136 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25141 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25145 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25150 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25153 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25157 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25162 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25166 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25171 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25174 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25178 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25183 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25186 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25189 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25192 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25198 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25211 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25219 */   // GIR_Coverage, 1827,
     /*  25219 */   GIR_EraseRootFromParent_Done,
     /*  25220 */ // Label 506: @25220
     /*  25220 */ GIM_Reject,
     /*  25221 */ // Label 483: @25221
     /*  25221 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25267), // Rule ID 1132 //
     /*  25226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25252 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25254 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25259 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25265 */   GIR_RootConstrainSelectedInstOperands,
     /*  25266 */   // GIR_Coverage, 1132,
     /*  25266 */   GIR_EraseRootFromParent_Done,
     /*  25267 */ // Label 507: @25267
     /*  25267 */ GIM_Reject,
     /*  25268 */ // Label 484: @25268
     /*  25268 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25381),
     /*  25273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25279 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25319), // Rule ID 2538 //
     /*  25284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25304 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25306 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25317 */     GIR_RootConstrainSelectedInstOperands,
     /*  25318 */     // GIR_Coverage, 2538,
     /*  25318 */     GIR_EraseRootFromParent_Done,
     /*  25319 */   // Label 509: @25319
     /*  25319 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25380), // Rule ID 3395 //
     /*  25324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25378 */     GIR_RootConstrainSelectedInstOperands,
     /*  25379 */     // GIR_Coverage, 3395,
     /*  25379 */     GIR_EraseRootFromParent_Done,
     /*  25380 */   // Label 510: @25380
     /*  25380 */   GIM_Reject,
     /*  25381 */ // Label 508: @25381
     /*  25381 */ GIM_Reject,
     /*  25382 */ // Label 485: @25382
     /*  25382 */ GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25499), // Rule ID 1828 //
     /*  25387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25408 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25411 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25415 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25420 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25424 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25429 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25432 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25436 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25441 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25445 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25462 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25465 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25468 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25471 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25477 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25493 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25498 */   // GIR_Coverage, 1828,
     /*  25498 */   GIR_EraseRootFromParent_Done,
     /*  25499 */ // Label 511: @25499
     /*  25499 */ GIM_Reject,
     /*  25500 */ // Label 486: @25500
     /*  25500 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25546), // Rule ID 2534 //
     /*  25505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25531 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25533 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25538 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25544 */   GIR_RootConstrainSelectedInstOperands,
     /*  25545 */   // GIR_Coverage, 2534,
     /*  25545 */   GIR_EraseRootFromParent_Done,
     /*  25546 */ // Label 512: @25546
     /*  25546 */ GIM_Reject,
     /*  25547 */ // Label 487: @25547
     /*  25547 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25660),
     /*  25552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25558 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25598), // Rule ID 1133 //
     /*  25563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25596 */     GIR_RootConstrainSelectedInstOperands,
     /*  25597 */     // GIR_Coverage, 1133,
     /*  25597 */     GIR_EraseRootFromParent_Done,
     /*  25598 */   // Label 514: @25598
     /*  25598 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25659), // Rule ID 3391 //
     /*  25603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25657 */     GIR_RootConstrainSelectedInstOperands,
     /*  25658 */     // GIR_Coverage, 3391,
     /*  25658 */     GIR_EraseRootFromParent_Done,
     /*  25659 */   // Label 515: @25659
     /*  25659 */   GIM_Reject,
     /*  25660 */ // Label 513: @25660
     /*  25660 */ GIM_Reject,
     /*  25661 */ // Label 488: @25661
     /*  25661 */ GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25778), // Rule ID 1829 //
     /*  25666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25687 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25690 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25694 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25699 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25703 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25708 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25711 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25715 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25720 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25724 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25741 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25744 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25747 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25750 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25756 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25772 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25777 */   // GIR_Coverage, 1829,
     /*  25777 */   GIR_EraseRootFromParent_Done,
     /*  25778 */ // Label 516: @25778
     /*  25778 */ GIM_Reject,
     /*  25779 */ // Label 489: @25779
     /*  25779 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25825), // Rule ID 2533 //
     /*  25784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25810 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25812 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25817 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25823 */   GIR_RootConstrainSelectedInstOperands,
     /*  25824 */   // GIR_Coverage, 2533,
     /*  25824 */   GIR_EraseRootFromParent_Done,
     /*  25825 */ // Label 517: @25825
     /*  25825 */ GIM_Reject,
     /*  25826 */ // Label 490: @25826
     /*  25826 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25939),
     /*  25831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25837 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25877), // Rule ID 2537 //
     /*  25842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25862 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25864 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25875 */     GIR_RootConstrainSelectedInstOperands,
     /*  25876 */     // GIR_Coverage, 2537,
     /*  25876 */     GIR_EraseRootFromParent_Done,
     /*  25877 */   // Label 519: @25877
     /*  25877 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25938), // Rule ID 3387 //
     /*  25882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25936 */     GIR_RootConstrainSelectedInstOperands,
     /*  25937 */     // GIR_Coverage, 3387,
     /*  25937 */     GIR_EraseRootFromParent_Done,
     /*  25938 */   // Label 520: @25938
     /*  25938 */   GIM_Reject,
     /*  25939 */ // Label 518: @25939
     /*  25939 */ GIM_Reject,
     /*  25940 */ // Label 491: @25940
     /*  25940 */ GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(26057), // Rule ID 1830 //
     /*  25945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25966 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25969 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25973 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25978 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25982 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25987 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25990 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25994 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25999 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26003 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26020 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26023 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26026 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26029 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26035 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26048 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26056 */   // GIR_Coverage, 1830,
     /*  26056 */   GIR_EraseRootFromParent_Done,
     /*  26057 */ // Label 521: @26057
     /*  26057 */ GIM_Reject,
     /*  26058 */ // Label 492: @26058
     /*  26058 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26171),
     /*  26063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26069 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26109), // Rule ID 2536 //
     /*  26074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26094 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26096 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26107 */     GIR_RootConstrainSelectedInstOperands,
     /*  26108 */     // GIR_Coverage, 2536,
     /*  26108 */     GIR_EraseRootFromParent_Done,
     /*  26109 */   // Label 523: @26109
     /*  26109 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26170), // Rule ID 3383 //
     /*  26114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26168 */     GIR_RootConstrainSelectedInstOperands,
     /*  26169 */     // GIR_Coverage, 3383,
     /*  26169 */     GIR_EraseRootFromParent_Done,
     /*  26170 */   // Label 524: @26170
     /*  26170 */   GIM_Reject,
     /*  26171 */ // Label 522: @26171
     /*  26171 */ GIM_Reject,
     /*  26172 */ // Label 493: @26172
     /*  26172 */ GIM_Reject,
     /*  26173 */ // Label 8: @26173
     /*  26173 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26559),
     /*  26178 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26181 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 530*/ GIMT_Encode4(26558),
     /*  26192 */   /*GILLT_v2s64*//*Label 526*/ GIMT_Encode4(26236), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26204 */   /*GILLT_v4s32*//*Label 527*/ GIMT_Encode4(26294), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26220 */   /*GILLT_v8s16*//*Label 528*/ GIMT_Encode4(26397), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26232 */   /*GILLT_v16s8*//*Label 529*/ GIMT_Encode4(26500),
     /*  26236 */   // Label 526: @26236
     /*  26236 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(26293), // Rule ID 3021 //
     /*  26241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26244 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26262 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26269 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26274 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26292 */     // GIR_Coverage, 3021,
     /*  26292 */     GIR_EraseRootFromParent_Done,
     /*  26293 */   // Label 531: @26293
     /*  26293 */   GIM_Reject,
     /*  26294 */   // Label 527: @26294
     /*  26294 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26396),
     /*  26299 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26317 */     GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26356), // Rule ID 3022 //
     /*  26322 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26325 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26325 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26328 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26330 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26332 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26335 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26337 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26340 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26345 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26350 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26355 */       // GIR_Coverage, 3022,
     /*  26355 */       GIR_EraseRootFromParent_Done,
     /*  26356 */     // Label 533: @26356
     /*  26356 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26395), // Rule ID 3025 //
     /*  26361 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26364 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26364 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26367 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26369 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26371 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26374 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26376 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26379 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26384 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26389 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26394 */       // GIR_Coverage, 3025,
     /*  26394 */       GIR_EraseRootFromParent_Done,
     /*  26395 */     // Label 534: @26395
     /*  26395 */     GIM_Reject,
     /*  26396 */   // Label 532: @26396
     /*  26396 */   GIM_Reject,
     /*  26397 */   // Label 528: @26397
     /*  26397 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26499),
     /*  26402 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26420 */     GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26459), // Rule ID 3023 //
     /*  26425 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26428 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26428 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26431 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26433 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26435 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26438 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26440 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26443 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26448 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26453 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26458 */       // GIR_Coverage, 3023,
     /*  26458 */       GIR_EraseRootFromParent_Done,
     /*  26459 */     // Label 536: @26459
     /*  26459 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26498), // Rule ID 3026 //
     /*  26464 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26467 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26467 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26470 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26472 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26474 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26477 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26479 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26482 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26487 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26492 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26497 */       // GIR_Coverage, 3026,
     /*  26497 */       GIR_EraseRootFromParent_Done,
     /*  26498 */     // Label 537: @26498
     /*  26498 */     GIM_Reject,
     /*  26499 */   // Label 535: @26499
     /*  26499 */   GIM_Reject,
     /*  26500 */   // Label 529: @26500
     /*  26500 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26557), // Rule ID 3024 //
     /*  26505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26508 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26526 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26533 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26538 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26556 */     // GIR_Coverage, 3024,
     /*  26556 */     GIR_EraseRootFromParent_Done,
     /*  26557 */   // Label 538: @26557
     /*  26557 */   GIM_Reject,
     /*  26558 */   // Label 530: @26558
     /*  26558 */   GIM_Reject,
     /*  26559 */ // Label 525: @26559
     /*  26559 */ GIM_Reject,
     /*  26560 */ // Label 9: @26560
     /*  26560 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 548*/ GIMT_Encode4(35571),
     /*  26571 */ /*GILLT_s32*//*Label 539*/ GIMT_Encode4(26631),
     /*  26575 */ /*GILLT_s64*//*Label 540*/ GIMT_Encode4(26779), GIMT_Encode4(0),
     /*  26583 */ /*GILLT_v2s32*//*Label 541*/ GIMT_Encode4(27534),
     /*  26587 */ /*GILLT_v2s64*//*Label 542*/ GIMT_Encode4(28289), GIMT_Encode4(0),
     /*  26595 */ /*GILLT_v4s16*//*Label 543*/ GIMT_Encode4(30008),
     /*  26599 */ /*GILLT_v4s32*//*Label 544*/ GIMT_Encode4(30763), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26611 */ /*GILLT_v8s8*//*Label 545*/ GIMT_Encode4(32482),
     /*  26615 */ /*GILLT_v8s16*//*Label 546*/ GIMT_Encode4(32897), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26627 */ /*GILLT_v16s8*//*Label 547*/ GIMT_Encode4(34616),
     /*  26631 */ // Label 539: @26631
     /*  26631 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(26778),
     /*  26636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26639 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26673), // Rule ID 689 //
     /*  26644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26655 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26671 */     GIR_RootConstrainSelectedInstOperands,
     /*  26672 */     // GIR_Coverage, 689,
     /*  26672 */     GIR_EraseRootFromParent_Done,
     /*  26673 */   // Label 550: @26673
     /*  26673 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26707), // Rule ID 690 //
     /*  26678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26689 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26694 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26705 */     GIR_RootConstrainSelectedInstOperands,
     /*  26706 */     // GIR_Coverage, 690,
     /*  26706 */     GIR_EraseRootFromParent_Done,
     /*  26707 */   // Label 551: @26707
     /*  26707 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26777), // Rule ID 2715 //
     /*  26712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26723 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26735 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26739 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26743 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26746 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26759 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26776 */     // GIR_Coverage, 2715,
     /*  26776 */     GIR_EraseRootFromParent_Done,
     /*  26777 */   // Label 552: @26777
     /*  26777 */   GIM_Reject,
     /*  26778 */ // Label 549: @26778
     /*  26778 */ GIM_Reject,
     /*  26779 */ // Label 540: @26779
     /*  26779 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26811), // Rule ID 2717 //
     /*  26784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26798 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26810 */   // GIR_Coverage, 2717,
     /*  26810 */   GIR_EraseRootFromParent_Done,
     /*  26811 */ // Label 553: @26811
     /*  26811 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26843), // Rule ID 2718 //
     /*  26816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26830 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26833 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26835 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26842 */   // GIR_Coverage, 2718,
     /*  26842 */   GIR_EraseRootFromParent_Done,
     /*  26843 */ // Label 554: @26843
     /*  26843 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26875), // Rule ID 2729 //
     /*  26848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26862 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26865 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26867 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26874 */   // GIR_Coverage, 2729,
     /*  26874 */   GIR_EraseRootFromParent_Done,
     /*  26875 */ // Label 555: @26875
     /*  26875 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26907), // Rule ID 2730 //
     /*  26880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26894 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26897 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26899 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26906 */   // GIR_Coverage, 2730,
     /*  26906 */   GIR_EraseRootFromParent_Done,
     /*  26907 */ // Label 556: @26907
     /*  26907 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26939), // Rule ID 2731 //
     /*  26912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26926 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26929 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26931 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26938 */   // GIR_Coverage, 2731,
     /*  26938 */   GIR_EraseRootFromParent_Done,
     /*  26939 */ // Label 557: @26939
     /*  26939 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26971), // Rule ID 2732 //
     /*  26944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26958 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26961 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26970 */   // GIR_Coverage, 2732,
     /*  26970 */   GIR_EraseRootFromParent_Done,
     /*  26971 */ // Label 558: @26971
     /*  26971 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(27003), // Rule ID 2733 //
     /*  26976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26990 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26993 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26995 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27002 */   // GIR_Coverage, 2733,
     /*  27002 */   GIR_EraseRootFromParent_Done,
     /*  27003 */ // Label 559: @27003
     /*  27003 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27035), // Rule ID 2734 //
     /*  27008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27022 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27025 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27027 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27034 */   // GIR_Coverage, 2734,
     /*  27034 */   GIR_EraseRootFromParent_Done,
     /*  27035 */ // Label 560: @27035
     /*  27035 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27067), // Rule ID 2735 //
     /*  27040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27054 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27057 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27059 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27066 */   // GIR_Coverage, 2735,
     /*  27066 */   GIR_EraseRootFromParent_Done,
     /*  27067 */ // Label 561: @27067
     /*  27067 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27099), // Rule ID 2736 //
     /*  27072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27086 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27089 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27091 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27093 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27098 */   // GIR_Coverage, 2736,
     /*  27098 */   GIR_EraseRootFromParent_Done,
     /*  27099 */ // Label 562: @27099
     /*  27099 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27131), // Rule ID 2737 //
     /*  27104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27118 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27121 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27130 */   // GIR_Coverage, 2737,
     /*  27130 */   GIR_EraseRootFromParent_Done,
     /*  27131 */ // Label 563: @27131
     /*  27131 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27163), // Rule ID 2738 //
     /*  27136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27150 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27153 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27155 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27162 */   // GIR_Coverage, 2738,
     /*  27162 */   GIR_EraseRootFromParent_Done,
     /*  27163 */ // Label 564: @27163
     /*  27163 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27200), // Rule ID 2801 //
     /*  27168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27182 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27187 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27192 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27198 */   GIR_RootConstrainSelectedInstOperands,
     /*  27199 */   // GIR_Coverage, 2801,
     /*  27199 */   GIR_EraseRootFromParent_Done,
     /*  27200 */ // Label 565: @27200
     /*  27200 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27237), // Rule ID 2802 //
     /*  27205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27219 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27224 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27229 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27235 */   GIR_RootConstrainSelectedInstOperands,
     /*  27236 */   // GIR_Coverage, 2802,
     /*  27236 */   GIR_EraseRootFromParent_Done,
     /*  27237 */ // Label 566: @27237
     /*  27237 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27274), // Rule ID 2803 //
     /*  27242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27256 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27261 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27266 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27272 */   GIR_RootConstrainSelectedInstOperands,
     /*  27273 */   // GIR_Coverage, 2803,
     /*  27273 */   GIR_EraseRootFromParent_Done,
     /*  27274 */ // Label 567: @27274
     /*  27274 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27311), // Rule ID 2804 //
     /*  27279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27293 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27303 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27309 */   GIR_RootConstrainSelectedInstOperands,
     /*  27310 */   // GIR_Coverage, 2804,
     /*  27310 */   GIR_EraseRootFromParent_Done,
     /*  27311 */ // Label 568: @27311
     /*  27311 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27348), // Rule ID 2805 //
     /*  27316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27330 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27335 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27340 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27346 */   GIR_RootConstrainSelectedInstOperands,
     /*  27347 */   // GIR_Coverage, 2805,
     /*  27347 */   GIR_EraseRootFromParent_Done,
     /*  27348 */ // Label 569: @27348
     /*  27348 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27385), // Rule ID 2806 //
     /*  27353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27367 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27372 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27377 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27383 */   GIR_RootConstrainSelectedInstOperands,
     /*  27384 */   // GIR_Coverage, 2806,
     /*  27384 */   GIR_EraseRootFromParent_Done,
     /*  27385 */ // Label 570: @27385
     /*  27385 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27422), // Rule ID 2807 //
     /*  27390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27404 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27420 */   GIR_RootConstrainSelectedInstOperands,
     /*  27421 */   // GIR_Coverage, 2807,
     /*  27421 */   GIR_EraseRootFromParent_Done,
     /*  27422 */ // Label 571: @27422
     /*  27422 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27459), // Rule ID 2808 //
     /*  27427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27441 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27446 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27457 */   GIR_RootConstrainSelectedInstOperands,
     /*  27458 */   // GIR_Coverage, 2808,
     /*  27458 */   GIR_EraseRootFromParent_Done,
     /*  27459 */ // Label 572: @27459
     /*  27459 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27496), // Rule ID 2809 //
     /*  27464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27478 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27488 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27494 */   GIR_RootConstrainSelectedInstOperands,
     /*  27495 */   // GIR_Coverage, 2809,
     /*  27495 */   GIR_EraseRootFromParent_Done,
     /*  27496 */ // Label 573: @27496
     /*  27496 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27533), // Rule ID 2810 //
     /*  27501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27515 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27520 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27525 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27531 */   GIR_RootConstrainSelectedInstOperands,
     /*  27532 */   // GIR_Coverage, 2810,
     /*  27532 */   GIR_EraseRootFromParent_Done,
     /*  27533 */ // Label 574: @27533
     /*  27533 */ GIM_Reject,
     /*  27534 */ // Label 541: @27534
     /*  27534 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27566), // Rule ID 2719 //
     /*  27539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27553 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27556 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27558 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27565 */   // GIR_Coverage, 2719,
     /*  27565 */   GIR_EraseRootFromParent_Done,
     /*  27566 */ // Label 575: @27566
     /*  27566 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27598), // Rule ID 2720 //
     /*  27571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27585 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27588 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27590 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27592 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27597 */   // GIR_Coverage, 2720,
     /*  27597 */   GIR_EraseRootFromParent_Done,
     /*  27598 */ // Label 576: @27598
     /*  27598 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27630), // Rule ID 2739 //
     /*  27603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27617 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27620 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27622 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27629 */   // GIR_Coverage, 2739,
     /*  27629 */   GIR_EraseRootFromParent_Done,
     /*  27630 */ // Label 577: @27630
     /*  27630 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27662), // Rule ID 2740 //
     /*  27635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27645 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27649 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27652 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27654 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27661 */   // GIR_Coverage, 2740,
     /*  27661 */   GIR_EraseRootFromParent_Done,
     /*  27662 */ // Label 578: @27662
     /*  27662 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27694), // Rule ID 2741 //
     /*  27667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27681 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27684 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27686 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27688 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27693 */   // GIR_Coverage, 2741,
     /*  27693 */   GIR_EraseRootFromParent_Done,
     /*  27694 */ // Label 579: @27694
     /*  27694 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27726), // Rule ID 2742 //
     /*  27699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27713 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27716 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27718 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27720 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27725 */   // GIR_Coverage, 2742,
     /*  27725 */   GIR_EraseRootFromParent_Done,
     /*  27726 */ // Label 580: @27726
     /*  27726 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27758), // Rule ID 2743 //
     /*  27731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27745 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27748 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27750 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27752 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27757 */   // GIR_Coverage, 2743,
     /*  27757 */   GIR_EraseRootFromParent_Done,
     /*  27758 */ // Label 581: @27758
     /*  27758 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27790), // Rule ID 2744 //
     /*  27763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27777 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27780 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27782 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27789 */   // GIR_Coverage, 2744,
     /*  27789 */   GIR_EraseRootFromParent_Done,
     /*  27790 */ // Label 582: @27790
     /*  27790 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27822), // Rule ID 2745 //
     /*  27795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27809 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27812 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27814 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27816 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27821 */   // GIR_Coverage, 2745,
     /*  27821 */   GIR_EraseRootFromParent_Done,
     /*  27822 */ // Label 583: @27822
     /*  27822 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27854), // Rule ID 2746 //
     /*  27827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27841 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27844 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27848 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27853 */   // GIR_Coverage, 2746,
     /*  27853 */   GIR_EraseRootFromParent_Done,
     /*  27854 */ // Label 584: @27854
     /*  27854 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27886), // Rule ID 2747 //
     /*  27859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27873 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27876 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27878 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27885 */   // GIR_Coverage, 2747,
     /*  27885 */   GIR_EraseRootFromParent_Done,
     /*  27886 */ // Label 585: @27886
     /*  27886 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27918), // Rule ID 2748 //
     /*  27891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27905 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27908 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27910 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27917 */   // GIR_Coverage, 2748,
     /*  27917 */   GIR_EraseRootFromParent_Done,
     /*  27918 */ // Label 586: @27918
     /*  27918 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27955), // Rule ID 2811 //
     /*  27923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27937 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27942 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27947 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27953 */   GIR_RootConstrainSelectedInstOperands,
     /*  27954 */   // GIR_Coverage, 2811,
     /*  27954 */   GIR_EraseRootFromParent_Done,
     /*  27955 */ // Label 587: @27955
     /*  27955 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(27992), // Rule ID 2812 //
     /*  27960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27974 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27979 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27984 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27990 */   GIR_RootConstrainSelectedInstOperands,
     /*  27991 */   // GIR_Coverage, 2812,
     /*  27991 */   GIR_EraseRootFromParent_Done,
     /*  27992 */ // Label 588: @27992
     /*  27992 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28029), // Rule ID 2813 //
     /*  27997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28011 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28016 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28021 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28027 */   GIR_RootConstrainSelectedInstOperands,
     /*  28028 */   // GIR_Coverage, 2813,
     /*  28028 */   GIR_EraseRootFromParent_Done,
     /*  28029 */ // Label 589: @28029
     /*  28029 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28066), // Rule ID 2814 //
     /*  28034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28048 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28053 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28058 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28064 */   GIR_RootConstrainSelectedInstOperands,
     /*  28065 */   // GIR_Coverage, 2814,
     /*  28065 */   GIR_EraseRootFromParent_Done,
     /*  28066 */ // Label 590: @28066
     /*  28066 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28103), // Rule ID 2815 //
     /*  28071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28085 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28090 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28095 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28101 */   GIR_RootConstrainSelectedInstOperands,
     /*  28102 */   // GIR_Coverage, 2815,
     /*  28102 */   GIR_EraseRootFromParent_Done,
     /*  28103 */ // Label 591: @28103
     /*  28103 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28140), // Rule ID 2816 //
     /*  28108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28122 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28132 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28138 */   GIR_RootConstrainSelectedInstOperands,
     /*  28139 */   // GIR_Coverage, 2816,
     /*  28139 */   GIR_EraseRootFromParent_Done,
     /*  28140 */ // Label 592: @28140
     /*  28140 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28177), // Rule ID 2817 //
     /*  28145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28159 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28164 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28169 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28175 */   GIR_RootConstrainSelectedInstOperands,
     /*  28176 */   // GIR_Coverage, 2817,
     /*  28176 */   GIR_EraseRootFromParent_Done,
     /*  28177 */ // Label 593: @28177
     /*  28177 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28214), // Rule ID 2818 //
     /*  28182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28196 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28201 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28212 */   GIR_RootConstrainSelectedInstOperands,
     /*  28213 */   // GIR_Coverage, 2818,
     /*  28213 */   GIR_EraseRootFromParent_Done,
     /*  28214 */ // Label 594: @28214
     /*  28214 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28251), // Rule ID 2819 //
     /*  28219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28233 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28238 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28240 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28243 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28249 */   GIR_RootConstrainSelectedInstOperands,
     /*  28250 */   // GIR_Coverage, 2819,
     /*  28250 */   GIR_EraseRootFromParent_Done,
     /*  28251 */ // Label 595: @28251
     /*  28251 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28288), // Rule ID 2820 //
     /*  28256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28270 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28275 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28280 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28286 */   GIR_RootConstrainSelectedInstOperands,
     /*  28287 */   // GIR_Coverage, 2820,
     /*  28287 */   GIR_EraseRootFromParent_Done,
     /*  28288 */ // Label 596: @28288
     /*  28288 */ GIM_Reject,
     /*  28289 */ // Label 542: @28289
     /*  28289 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28321), // Rule ID 2723 //
     /*  28294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28308 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28311 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28315 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28320 */   // GIR_Coverage, 2723,
     /*  28320 */   GIR_EraseRootFromParent_Done,
     /*  28321 */ // Label 597: @28321
     /*  28321 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28353), // Rule ID 2724 //
     /*  28326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28340 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28343 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28345 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28347 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28352 */   // GIR_Coverage, 2724,
     /*  28352 */   GIR_EraseRootFromParent_Done,
     /*  28353 */ // Label 598: @28353
     /*  28353 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28385), // Rule ID 2765 //
     /*  28358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28372 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28375 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28377 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28379 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28384 */   // GIR_Coverage, 2765,
     /*  28384 */   GIR_EraseRootFromParent_Done,
     /*  28385 */ // Label 599: @28385
     /*  28385 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28417), // Rule ID 2766 //
     /*  28390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28404 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28407 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28411 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28416 */   // GIR_Coverage, 2766,
     /*  28416 */   GIR_EraseRootFromParent_Done,
     /*  28417 */ // Label 600: @28417
     /*  28417 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28449), // Rule ID 2767 //
     /*  28422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28436 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28439 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28441 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28443 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28448 */   // GIR_Coverage, 2767,
     /*  28448 */   GIR_EraseRootFromParent_Done,
     /*  28449 */ // Label 601: @28449
     /*  28449 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28481), // Rule ID 2768 //
     /*  28454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28468 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28471 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28473 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28475 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28480 */   // GIR_Coverage, 2768,
     /*  28480 */   GIR_EraseRootFromParent_Done,
     /*  28481 */ // Label 602: @28481
     /*  28481 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28513), // Rule ID 2769 //
     /*  28486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28500 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28503 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28505 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28512 */   // GIR_Coverage, 2769,
     /*  28512 */   GIR_EraseRootFromParent_Done,
     /*  28513 */ // Label 603: @28513
     /*  28513 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28545), // Rule ID 2770 //
     /*  28518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28532 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28535 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28537 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28544 */   // GIR_Coverage, 2770,
     /*  28544 */   GIR_EraseRootFromParent_Done,
     /*  28545 */ // Label 604: @28545
     /*  28545 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28577), // Rule ID 2771 //
     /*  28550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28564 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28567 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28569 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28571 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28576 */   // GIR_Coverage, 2771,
     /*  28576 */   GIR_EraseRootFromParent_Done,
     /*  28577 */ // Label 605: @28577
     /*  28577 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28609), // Rule ID 2772 //
     /*  28582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28596 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28599 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28603 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28608 */   // GIR_Coverage, 2772,
     /*  28608 */   GIR_EraseRootFromParent_Done,
     /*  28609 */ // Label 606: @28609
     /*  28609 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28641), // Rule ID 2773 //
     /*  28614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28628 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28631 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28633 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28635 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28640 */   // GIR_Coverage, 2773,
     /*  28640 */   GIR_EraseRootFromParent_Done,
     /*  28641 */ // Label 607: @28641
     /*  28641 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28673), // Rule ID 2774 //
     /*  28646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28660 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28663 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28665 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28667 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28672 */   // GIR_Coverage, 2774,
     /*  28672 */   GIR_EraseRootFromParent_Done,
     /*  28673 */ // Label 608: @28673
     /*  28673 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28710), // Rule ID 2837 //
     /*  28678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28692 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28697 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28702 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28708 */   GIR_RootConstrainSelectedInstOperands,
     /*  28709 */   // GIR_Coverage, 2837,
     /*  28709 */   GIR_EraseRootFromParent_Done,
     /*  28710 */ // Label 609: @28710
     /*  28710 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28747), // Rule ID 2838 //
     /*  28715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28729 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28739 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28745 */   GIR_RootConstrainSelectedInstOperands,
     /*  28746 */   // GIR_Coverage, 2838,
     /*  28746 */   GIR_EraseRootFromParent_Done,
     /*  28747 */ // Label 610: @28747
     /*  28747 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28784), // Rule ID 2839 //
     /*  28752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28766 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28769 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28771 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28776 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28782 */   GIR_RootConstrainSelectedInstOperands,
     /*  28783 */   // GIR_Coverage, 2839,
     /*  28783 */   GIR_EraseRootFromParent_Done,
     /*  28784 */ // Label 611: @28784
     /*  28784 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28821), // Rule ID 2840 //
     /*  28789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28803 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28813 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28819 */   GIR_RootConstrainSelectedInstOperands,
     /*  28820 */   // GIR_Coverage, 2840,
     /*  28820 */   GIR_EraseRootFromParent_Done,
     /*  28821 */ // Label 612: @28821
     /*  28821 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28858), // Rule ID 2841 //
     /*  28826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28840 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28845 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28850 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28856 */   GIR_RootConstrainSelectedInstOperands,
     /*  28857 */   // GIR_Coverage, 2841,
     /*  28857 */   GIR_EraseRootFromParent_Done,
     /*  28858 */ // Label 613: @28858
     /*  28858 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28895), // Rule ID 2842 //
     /*  28863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28877 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28877 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28880 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28882 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28887 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28893 */   GIR_RootConstrainSelectedInstOperands,
     /*  28894 */   // GIR_Coverage, 2842,
     /*  28894 */   GIR_EraseRootFromParent_Done,
     /*  28895 */ // Label 614: @28895
     /*  28895 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28932), // Rule ID 2843 //
     /*  28900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28914 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28924 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28930 */   GIR_RootConstrainSelectedInstOperands,
     /*  28931 */   // GIR_Coverage, 2843,
     /*  28931 */   GIR_EraseRootFromParent_Done,
     /*  28932 */ // Label 615: @28932
     /*  28932 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28969), // Rule ID 2844 //
     /*  28937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28951 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28956 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28961 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28967 */   GIR_RootConstrainSelectedInstOperands,
     /*  28968 */   // GIR_Coverage, 2844,
     /*  28968 */   GIR_EraseRootFromParent_Done,
     /*  28969 */ // Label 616: @28969
     /*  28969 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(29006), // Rule ID 2845 //
     /*  28974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28988 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29004 */   GIR_RootConstrainSelectedInstOperands,
     /*  29005 */   // GIR_Coverage, 2845,
     /*  29005 */   GIR_EraseRootFromParent_Done,
     /*  29006 */ // Label 617: @29006
     /*  29006 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29043), // Rule ID 2846 //
     /*  29011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29025 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29028 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29030 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29035 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29041 */   GIR_RootConstrainSelectedInstOperands,
     /*  29042 */   // GIR_Coverage, 2846,
     /*  29042 */   GIR_EraseRootFromParent_Done,
     /*  29043 */ // Label 618: @29043
     /*  29043 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29075), // Rule ID 5280 //
     /*  29048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29062 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29074 */   // GIR_Coverage, 5280,
     /*  29074 */   GIR_EraseRootFromParent_Done,
     /*  29075 */ // Label 619: @29075
     /*  29075 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29107), // Rule ID 5281 //
     /*  29080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29094 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29106 */   // GIR_Coverage, 5281,
     /*  29106 */   GIR_EraseRootFromParent_Done,
     /*  29107 */ // Label 620: @29107
     /*  29107 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29139), // Rule ID 5286 //
     /*  29112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29126 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29138 */   // GIR_Coverage, 5286,
     /*  29138 */   GIR_EraseRootFromParent_Done,
     /*  29139 */ // Label 621: @29139
     /*  29139 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29171), // Rule ID 5287 //
     /*  29144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29158 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29170 */   // GIR_Coverage, 5287,
     /*  29170 */   GIR_EraseRootFromParent_Done,
     /*  29171 */ // Label 622: @29171
     /*  29171 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29203), // Rule ID 5288 //
     /*  29176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29190 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29193 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29197 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29202 */   // GIR_Coverage, 5288,
     /*  29202 */   GIR_EraseRootFromParent_Done,
     /*  29203 */ // Label 623: @29203
     /*  29203 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29235), // Rule ID 5289 //
     /*  29208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29222 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29225 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29227 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29229 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29234 */   // GIR_Coverage, 5289,
     /*  29234 */   GIR_EraseRootFromParent_Done,
     /*  29235 */ // Label 624: @29235
     /*  29235 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29267), // Rule ID 5290 //
     /*  29240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29254 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29257 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29259 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29261 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29266 */   // GIR_Coverage, 5290,
     /*  29266 */   GIR_EraseRootFromParent_Done,
     /*  29267 */ // Label 625: @29267
     /*  29267 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29299), // Rule ID 5291 //
     /*  29272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29286 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29289 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29291 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29293 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29298 */   // GIR_Coverage, 5291,
     /*  29298 */   GIR_EraseRootFromParent_Done,
     /*  29299 */ // Label 626: @29299
     /*  29299 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29331), // Rule ID 5292 //
     /*  29304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29318 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29321 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29323 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29325 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29330 */   // GIR_Coverage, 5292,
     /*  29330 */   GIR_EraseRootFromParent_Done,
     /*  29331 */ // Label 627: @29331
     /*  29331 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29363), // Rule ID 5293 //
     /*  29336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29350 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29353 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29355 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29357 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29362 */   // GIR_Coverage, 5293,
     /*  29362 */   GIR_EraseRootFromParent_Done,
     /*  29363 */ // Label 628: @29363
     /*  29363 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29395), // Rule ID 5294 //
     /*  29368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29382 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29385 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29394 */   // GIR_Coverage, 5294,
     /*  29394 */   GIR_EraseRootFromParent_Done,
     /*  29395 */ // Label 629: @29395
     /*  29395 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29427), // Rule ID 5295 //
     /*  29400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29414 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29426 */   // GIR_Coverage, 5295,
     /*  29426 */   GIR_EraseRootFromParent_Done,
     /*  29427 */ // Label 630: @29427
     /*  29427 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29485), // Rule ID 5322 //
     /*  29432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29446 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29446 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29449 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29453 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29463 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29468 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29474 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29480 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29483 */   GIR_RootConstrainSelectedInstOperands,
     /*  29484 */   // GIR_Coverage, 5322,
     /*  29484 */   GIR_EraseRootFromParent_Done,
     /*  29485 */ // Label 631: @29485
     /*  29485 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29543), // Rule ID 5323 //
     /*  29490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29504 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29521 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29526 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29532 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29541 */   GIR_RootConstrainSelectedInstOperands,
     /*  29542 */   // GIR_Coverage, 5323,
     /*  29542 */   GIR_EraseRootFromParent_Done,
     /*  29543 */ // Label 632: @29543
     /*  29543 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29601), // Rule ID 5324 //
     /*  29548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29562 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29584 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29590 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29599 */   GIR_RootConstrainSelectedInstOperands,
     /*  29600 */   // GIR_Coverage, 5324,
     /*  29600 */   GIR_EraseRootFromParent_Done,
     /*  29601 */ // Label 633: @29601
     /*  29601 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29659), // Rule ID 5325 //
     /*  29606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29620 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29637 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29639 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29642 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29648 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29657 */   GIR_RootConstrainSelectedInstOperands,
     /*  29658 */   // GIR_Coverage, 5325,
     /*  29658 */   GIR_EraseRootFromParent_Done,
     /*  29659 */ // Label 634: @29659
     /*  29659 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29717), // Rule ID 5326 //
     /*  29664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29678 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29678 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29681 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29685 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29695 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29700 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29706 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29715 */   GIR_RootConstrainSelectedInstOperands,
     /*  29716 */   // GIR_Coverage, 5326,
     /*  29716 */   GIR_EraseRootFromParent_Done,
     /*  29717 */ // Label 635: @29717
     /*  29717 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29775), // Rule ID 5327 //
     /*  29722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29736 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29753 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29758 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29764 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29770 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29773 */   GIR_RootConstrainSelectedInstOperands,
     /*  29774 */   // GIR_Coverage, 5327,
     /*  29774 */   GIR_EraseRootFromParent_Done,
     /*  29775 */ // Label 636: @29775
     /*  29775 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29833), // Rule ID 5328 //
     /*  29780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29794 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29794 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29797 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29801 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29813 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29816 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29828 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29831 */   GIR_RootConstrainSelectedInstOperands,
     /*  29832 */   // GIR_Coverage, 5328,
     /*  29832 */   GIR_EraseRootFromParent_Done,
     /*  29833 */ // Label 637: @29833
     /*  29833 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29891), // Rule ID 5329 //
     /*  29838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29852 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29874 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29880 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29889 */   GIR_RootConstrainSelectedInstOperands,
     /*  29890 */   // GIR_Coverage, 5329,
     /*  29890 */   GIR_EraseRootFromParent_Done,
     /*  29891 */ // Label 638: @29891
     /*  29891 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29949), // Rule ID 5330 //
     /*  29896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29910 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29910 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29913 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29917 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29938 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29947 */   GIR_RootConstrainSelectedInstOperands,
     /*  29948 */   // GIR_Coverage, 5330,
     /*  29948 */   GIR_EraseRootFromParent_Done,
     /*  29949 */ // Label 639: @29949
     /*  29949 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(30007), // Rule ID 5331 //
     /*  29954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29968 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29985 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29990 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29996 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30002 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30005 */   GIR_RootConstrainSelectedInstOperands,
     /*  30006 */   // GIR_Coverage, 5331,
     /*  30006 */   GIR_EraseRootFromParent_Done,
     /*  30007 */ // Label 640: @30007
     /*  30007 */ GIM_Reject,
     /*  30008 */ // Label 543: @30008
     /*  30008 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30040), // Rule ID 2721 //
     /*  30013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30027 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30030 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30032 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30039 */   // GIR_Coverage, 2721,
     /*  30039 */   GIR_EraseRootFromParent_Done,
     /*  30040 */ // Label 641: @30040
     /*  30040 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30072), // Rule ID 2722 //
     /*  30045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30059 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30062 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30064 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30066 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30071 */   // GIR_Coverage, 2722,
     /*  30071 */   GIR_EraseRootFromParent_Done,
     /*  30072 */ // Label 642: @30072
     /*  30072 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30104), // Rule ID 2749 //
     /*  30077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30091 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30091 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30094 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30096 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30103 */   // GIR_Coverage, 2749,
     /*  30103 */   GIR_EraseRootFromParent_Done,
     /*  30104 */ // Label 643: @30104
     /*  30104 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30136), // Rule ID 2750 //
     /*  30109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30123 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30126 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30128 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30130 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30135 */   // GIR_Coverage, 2750,
     /*  30135 */   GIR_EraseRootFromParent_Done,
     /*  30136 */ // Label 644: @30136
     /*  30136 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30168), // Rule ID 2751 //
     /*  30141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30151 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30155 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30158 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30160 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30162 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30167 */   // GIR_Coverage, 2751,
     /*  30167 */   GIR_EraseRootFromParent_Done,
     /*  30168 */ // Label 645: @30168
     /*  30168 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30200), // Rule ID 2752 //
     /*  30173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30187 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30190 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30192 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30194 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30199 */   // GIR_Coverage, 2752,
     /*  30199 */   GIR_EraseRootFromParent_Done,
     /*  30200 */ // Label 646: @30200
     /*  30200 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30232), // Rule ID 2753 //
     /*  30205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30219 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30222 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30224 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30226 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30231 */   // GIR_Coverage, 2753,
     /*  30231 */   GIR_EraseRootFromParent_Done,
     /*  30232 */ // Label 647: @30232
     /*  30232 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30264), // Rule ID 2754 //
     /*  30237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30251 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30254 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30256 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30258 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30263 */   // GIR_Coverage, 2754,
     /*  30263 */   GIR_EraseRootFromParent_Done,
     /*  30264 */ // Label 648: @30264
     /*  30264 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30296), // Rule ID 2755 //
     /*  30269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30283 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30286 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30288 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30295 */   // GIR_Coverage, 2755,
     /*  30295 */   GIR_EraseRootFromParent_Done,
     /*  30296 */ // Label 649: @30296
     /*  30296 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30328), // Rule ID 2756 //
     /*  30301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30315 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30318 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30320 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30327 */   // GIR_Coverage, 2756,
     /*  30327 */   GIR_EraseRootFromParent_Done,
     /*  30328 */ // Label 650: @30328
     /*  30328 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30360), // Rule ID 2757 //
     /*  30333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30347 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30350 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30352 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30359 */   // GIR_Coverage, 2757,
     /*  30359 */   GIR_EraseRootFromParent_Done,
     /*  30360 */ // Label 651: @30360
     /*  30360 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30392), // Rule ID 2758 //
     /*  30365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30379 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30382 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30384 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30386 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30391 */   // GIR_Coverage, 2758,
     /*  30391 */   GIR_EraseRootFromParent_Done,
     /*  30392 */ // Label 652: @30392
     /*  30392 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30429), // Rule ID 2821 //
     /*  30397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30411 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30416 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30421 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30427 */   GIR_RootConstrainSelectedInstOperands,
     /*  30428 */   // GIR_Coverage, 2821,
     /*  30428 */   GIR_EraseRootFromParent_Done,
     /*  30429 */ // Label 653: @30429
     /*  30429 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30466), // Rule ID 2822 //
     /*  30434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30448 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30458 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30464 */   GIR_RootConstrainSelectedInstOperands,
     /*  30465 */   // GIR_Coverage, 2822,
     /*  30465 */   GIR_EraseRootFromParent_Done,
     /*  30466 */ // Label 654: @30466
     /*  30466 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30503), // Rule ID 2823 //
     /*  30471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30485 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30495 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30501 */   GIR_RootConstrainSelectedInstOperands,
     /*  30502 */   // GIR_Coverage, 2823,
     /*  30502 */   GIR_EraseRootFromParent_Done,
     /*  30503 */ // Label 655: @30503
     /*  30503 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30540), // Rule ID 2824 //
     /*  30508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30522 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30527 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30532 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30538 */   GIR_RootConstrainSelectedInstOperands,
     /*  30539 */   // GIR_Coverage, 2824,
     /*  30539 */   GIR_EraseRootFromParent_Done,
     /*  30540 */ // Label 656: @30540
     /*  30540 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30577), // Rule ID 2825 //
     /*  30545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30559 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30564 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30569 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30575 */   GIR_RootConstrainSelectedInstOperands,
     /*  30576 */   // GIR_Coverage, 2825,
     /*  30576 */   GIR_EraseRootFromParent_Done,
     /*  30577 */ // Label 657: @30577
     /*  30577 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30614), // Rule ID 2826 //
     /*  30582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30596 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30612 */   GIR_RootConstrainSelectedInstOperands,
     /*  30613 */   // GIR_Coverage, 2826,
     /*  30613 */   GIR_EraseRootFromParent_Done,
     /*  30614 */ // Label 658: @30614
     /*  30614 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30651), // Rule ID 2827 //
     /*  30619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30633 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30643 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30649 */   GIR_RootConstrainSelectedInstOperands,
     /*  30650 */   // GIR_Coverage, 2827,
     /*  30650 */   GIR_EraseRootFromParent_Done,
     /*  30651 */ // Label 659: @30651
     /*  30651 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30688), // Rule ID 2828 //
     /*  30656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30670 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30680 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30686 */   GIR_RootConstrainSelectedInstOperands,
     /*  30687 */   // GIR_Coverage, 2828,
     /*  30687 */   GIR_EraseRootFromParent_Done,
     /*  30688 */ // Label 660: @30688
     /*  30688 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30725), // Rule ID 2829 //
     /*  30693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30707 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30717 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30723 */   GIR_RootConstrainSelectedInstOperands,
     /*  30724 */   // GIR_Coverage, 2829,
     /*  30724 */   GIR_EraseRootFromParent_Done,
     /*  30725 */ // Label 661: @30725
     /*  30725 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30762), // Rule ID 2830 //
     /*  30730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30744 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30749 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30754 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30760 */   GIR_RootConstrainSelectedInstOperands,
     /*  30761 */   // GIR_Coverage, 2830,
     /*  30761 */   GIR_EraseRootFromParent_Done,
     /*  30762 */ // Label 662: @30762
     /*  30762 */ GIM_Reject,
     /*  30763 */ // Label 544: @30763
     /*  30763 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30795), // Rule ID 2725 //
     /*  30768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30782 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30785 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30787 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30794 */   // GIR_Coverage, 2725,
     /*  30794 */   GIR_EraseRootFromParent_Done,
     /*  30795 */ // Label 663: @30795
     /*  30795 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30827), // Rule ID 2726 //
     /*  30800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30814 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30817 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30826 */   // GIR_Coverage, 2726,
     /*  30826 */   GIR_EraseRootFromParent_Done,
     /*  30827 */ // Label 664: @30827
     /*  30827 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30859), // Rule ID 2775 //
     /*  30832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30846 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30858 */   // GIR_Coverage, 2775,
     /*  30858 */   GIR_EraseRootFromParent_Done,
     /*  30859 */ // Label 665: @30859
     /*  30859 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30891), // Rule ID 2776 //
     /*  30864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30878 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30881 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30883 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30890 */   // GIR_Coverage, 2776,
     /*  30890 */   GIR_EraseRootFromParent_Done,
     /*  30891 */ // Label 666: @30891
     /*  30891 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30923), // Rule ID 2777 //
     /*  30896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30910 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30913 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30915 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30917 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30922 */   // GIR_Coverage, 2777,
     /*  30922 */   GIR_EraseRootFromParent_Done,
     /*  30923 */ // Label 667: @30923
     /*  30923 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30955), // Rule ID 2778 //
     /*  30928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30942 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30945 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30947 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30949 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30954 */   // GIR_Coverage, 2778,
     /*  30954 */   GIR_EraseRootFromParent_Done,
     /*  30955 */ // Label 668: @30955
     /*  30955 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30987), // Rule ID 2779 //
     /*  30960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30974 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30977 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30979 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30986 */   // GIR_Coverage, 2779,
     /*  30986 */   GIR_EraseRootFromParent_Done,
     /*  30987 */ // Label 669: @30987
     /*  30987 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(31019), // Rule ID 2780 //
     /*  30992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31006 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31009 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31011 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31013 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31018 */   // GIR_Coverage, 2780,
     /*  31018 */   GIR_EraseRootFromParent_Done,
     /*  31019 */ // Label 670: @31019
     /*  31019 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31051), // Rule ID 2781 //
     /*  31024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31038 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31041 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31043 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31045 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31050 */   // GIR_Coverage, 2781,
     /*  31050 */   GIR_EraseRootFromParent_Done,
     /*  31051 */ // Label 671: @31051
     /*  31051 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31083), // Rule ID 2782 //
     /*  31056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31070 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31082 */   // GIR_Coverage, 2782,
     /*  31082 */   GIR_EraseRootFromParent_Done,
     /*  31083 */ // Label 672: @31083
     /*  31083 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31115), // Rule ID 2783 //
     /*  31088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31102 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31114 */   // GIR_Coverage, 2783,
     /*  31114 */   GIR_EraseRootFromParent_Done,
     /*  31115 */ // Label 673: @31115
     /*  31115 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31147), // Rule ID 2784 //
     /*  31120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31134 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31146 */   // GIR_Coverage, 2784,
     /*  31146 */   GIR_EraseRootFromParent_Done,
     /*  31147 */ // Label 674: @31147
     /*  31147 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31184), // Rule ID 2847 //
     /*  31152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31166 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31176 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31182 */   GIR_RootConstrainSelectedInstOperands,
     /*  31183 */   // GIR_Coverage, 2847,
     /*  31183 */   GIR_EraseRootFromParent_Done,
     /*  31184 */ // Label 675: @31184
     /*  31184 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31221), // Rule ID 2848 //
     /*  31189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31203 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31208 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31213 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31219 */   GIR_RootConstrainSelectedInstOperands,
     /*  31220 */   // GIR_Coverage, 2848,
     /*  31220 */   GIR_EraseRootFromParent_Done,
     /*  31221 */ // Label 676: @31221
     /*  31221 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31258), // Rule ID 2849 //
     /*  31226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31240 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31245 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31250 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31256 */   GIR_RootConstrainSelectedInstOperands,
     /*  31257 */   // GIR_Coverage, 2849,
     /*  31257 */   GIR_EraseRootFromParent_Done,
     /*  31258 */ // Label 677: @31258
     /*  31258 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31295), // Rule ID 2850 //
     /*  31263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31277 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31282 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31287 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31293 */   GIR_RootConstrainSelectedInstOperands,
     /*  31294 */   // GIR_Coverage, 2850,
     /*  31294 */   GIR_EraseRootFromParent_Done,
     /*  31295 */ // Label 678: @31295
     /*  31295 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31332), // Rule ID 2851 //
     /*  31300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31314 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31319 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31324 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31330 */   GIR_RootConstrainSelectedInstOperands,
     /*  31331 */   // GIR_Coverage, 2851,
     /*  31331 */   GIR_EraseRootFromParent_Done,
     /*  31332 */ // Label 679: @31332
     /*  31332 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31369), // Rule ID 2852 //
     /*  31337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31351 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31356 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31361 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31367 */   GIR_RootConstrainSelectedInstOperands,
     /*  31368 */   // GIR_Coverage, 2852,
     /*  31368 */   GIR_EraseRootFromParent_Done,
     /*  31369 */ // Label 680: @31369
     /*  31369 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31406), // Rule ID 2853 //
     /*  31374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31388 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31398 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31404 */   GIR_RootConstrainSelectedInstOperands,
     /*  31405 */   // GIR_Coverage, 2853,
     /*  31405 */   GIR_EraseRootFromParent_Done,
     /*  31406 */ // Label 681: @31406
     /*  31406 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31443), // Rule ID 2854 //
     /*  31411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31425 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31430 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31435 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31441 */   GIR_RootConstrainSelectedInstOperands,
     /*  31442 */   // GIR_Coverage, 2854,
     /*  31442 */   GIR_EraseRootFromParent_Done,
     /*  31443 */ // Label 682: @31443
     /*  31443 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31480), // Rule ID 2855 //
     /*  31448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31462 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31478 */   GIR_RootConstrainSelectedInstOperands,
     /*  31479 */   // GIR_Coverage, 2855,
     /*  31479 */   GIR_EraseRootFromParent_Done,
     /*  31480 */ // Label 683: @31480
     /*  31480 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31517), // Rule ID 2856 //
     /*  31485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31499 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31504 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31515 */   GIR_RootConstrainSelectedInstOperands,
     /*  31516 */   // GIR_Coverage, 2856,
     /*  31516 */   GIR_EraseRootFromParent_Done,
     /*  31517 */ // Label 684: @31517
     /*  31517 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31549), // Rule ID 5282 //
     /*  31522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31536 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31539 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31541 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31548 */   // GIR_Coverage, 5282,
     /*  31548 */   GIR_EraseRootFromParent_Done,
     /*  31549 */ // Label 685: @31549
     /*  31549 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31581), // Rule ID 5283 //
     /*  31554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31568 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31571 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31573 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31580 */   // GIR_Coverage, 5283,
     /*  31580 */   GIR_EraseRootFromParent_Done,
     /*  31581 */ // Label 686: @31581
     /*  31581 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31613), // Rule ID 5296 //
     /*  31586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31600 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31603 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31612 */   // GIR_Coverage, 5296,
     /*  31612 */   GIR_EraseRootFromParent_Done,
     /*  31613 */ // Label 687: @31613
     /*  31613 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31645), // Rule ID 5297 //
     /*  31618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31632 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31635 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31637 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31644 */   // GIR_Coverage, 5297,
     /*  31644 */   GIR_EraseRootFromParent_Done,
     /*  31645 */ // Label 688: @31645
     /*  31645 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31677), // Rule ID 5298 //
     /*  31650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31664 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31667 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31669 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31671 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31676 */   // GIR_Coverage, 5298,
     /*  31676 */   GIR_EraseRootFromParent_Done,
     /*  31677 */ // Label 689: @31677
     /*  31677 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31709), // Rule ID 5299 //
     /*  31682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31696 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31699 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31701 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31703 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31708 */   // GIR_Coverage, 5299,
     /*  31708 */   GIR_EraseRootFromParent_Done,
     /*  31709 */ // Label 690: @31709
     /*  31709 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31741), // Rule ID 5300 //
     /*  31714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31728 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31731 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31733 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31740 */   // GIR_Coverage, 5300,
     /*  31740 */   GIR_EraseRootFromParent_Done,
     /*  31741 */ // Label 691: @31741
     /*  31741 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31773), // Rule ID 5301 //
     /*  31746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31760 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31763 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31765 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31767 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31772 */   // GIR_Coverage, 5301,
     /*  31772 */   GIR_EraseRootFromParent_Done,
     /*  31773 */ // Label 692: @31773
     /*  31773 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31805), // Rule ID 5302 //
     /*  31778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31792 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31795 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31797 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31799 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31804 */   // GIR_Coverage, 5302,
     /*  31804 */   GIR_EraseRootFromParent_Done,
     /*  31805 */ // Label 693: @31805
     /*  31805 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31837), // Rule ID 5303 //
     /*  31810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31824 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31824 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31827 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31829 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31831 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31836 */   // GIR_Coverage, 5303,
     /*  31836 */   GIR_EraseRootFromParent_Done,
     /*  31837 */ // Label 694: @31837
     /*  31837 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31869), // Rule ID 5304 //
     /*  31842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31856 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31859 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31861 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31863 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31868 */   // GIR_Coverage, 5304,
     /*  31868 */   GIR_EraseRootFromParent_Done,
     /*  31869 */ // Label 695: @31869
     /*  31869 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31901), // Rule ID 5305 //
     /*  31874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31888 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31891 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31893 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31895 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31900 */   // GIR_Coverage, 5305,
     /*  31900 */   GIR_EraseRootFromParent_Done,
     /*  31901 */ // Label 696: @31901
     /*  31901 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31959), // Rule ID 5332 //
     /*  31906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31920 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31942 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31948 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31957 */   GIR_RootConstrainSelectedInstOperands,
     /*  31958 */   // GIR_Coverage, 5332,
     /*  31958 */   GIR_EraseRootFromParent_Done,
     /*  31959 */ // Label 697: @31959
     /*  31959 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(32017), // Rule ID 5333 //
     /*  31964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31978 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31995 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32000 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32012 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32015 */   GIR_RootConstrainSelectedInstOperands,
     /*  32016 */   // GIR_Coverage, 5333,
     /*  32016 */   GIR_EraseRootFromParent_Done,
     /*  32017 */ // Label 698: @32017
     /*  32017 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32075), // Rule ID 5334 //
     /*  32022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32036 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32053 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32058 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32064 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32073 */   GIR_RootConstrainSelectedInstOperands,
     /*  32074 */   // GIR_Coverage, 5334,
     /*  32074 */   GIR_EraseRootFromParent_Done,
     /*  32075 */ // Label 699: @32075
     /*  32075 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32133), // Rule ID 5335 //
     /*  32080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32094 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32094 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32097 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32101 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32116 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32122 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32128 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32131 */   GIR_RootConstrainSelectedInstOperands,
     /*  32132 */   // GIR_Coverage, 5335,
     /*  32132 */   GIR_EraseRootFromParent_Done,
     /*  32133 */ // Label 700: @32133
     /*  32133 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32191), // Rule ID 5336 //
     /*  32138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32152 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32152 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32155 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32159 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32169 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32174 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32180 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32189 */   GIR_RootConstrainSelectedInstOperands,
     /*  32190 */   // GIR_Coverage, 5336,
     /*  32190 */   GIR_EraseRootFromParent_Done,
     /*  32191 */ // Label 701: @32191
     /*  32191 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32249), // Rule ID 5337 //
     /*  32196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32210 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32227 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32232 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32238 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32247 */   GIR_RootConstrainSelectedInstOperands,
     /*  32248 */   // GIR_Coverage, 5337,
     /*  32248 */   GIR_EraseRootFromParent_Done,
     /*  32249 */ // Label 702: @32249
     /*  32249 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32307), // Rule ID 5338 //
     /*  32254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32268 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32268 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32271 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32275 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32285 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32290 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32296 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32305 */   GIR_RootConstrainSelectedInstOperands,
     /*  32306 */   // GIR_Coverage, 5338,
     /*  32306 */   GIR_EraseRootFromParent_Done,
     /*  32307 */ // Label 703: @32307
     /*  32307 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32365), // Rule ID 5339 //
     /*  32312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32326 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32326 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32329 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32333 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32354 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32363 */   GIR_RootConstrainSelectedInstOperands,
     /*  32364 */   // GIR_Coverage, 5339,
     /*  32364 */   GIR_EraseRootFromParent_Done,
     /*  32365 */ // Label 704: @32365
     /*  32365 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32423), // Rule ID 5340 //
     /*  32370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32384 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32384 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32387 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32391 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32412 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32418 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32421 */   GIR_RootConstrainSelectedInstOperands,
     /*  32422 */   // GIR_Coverage, 5340,
     /*  32422 */   GIR_EraseRootFromParent_Done,
     /*  32423 */ // Label 705: @32423
     /*  32423 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32481), // Rule ID 5341 //
     /*  32428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32442 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32464 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32470 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32479 */   GIR_RootConstrainSelectedInstOperands,
     /*  32480 */   // GIR_Coverage, 5341,
     /*  32480 */   GIR_EraseRootFromParent_Done,
     /*  32481 */ // Label 706: @32481
     /*  32481 */ GIM_Reject,
     /*  32482 */ // Label 545: @32482
     /*  32482 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32514), // Rule ID 2759 //
     /*  32487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32501 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32504 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32506 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32508 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32513 */   // GIR_Coverage, 2759,
     /*  32513 */   GIR_EraseRootFromParent_Done,
     /*  32514 */ // Label 707: @32514
     /*  32514 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32546), // Rule ID 2760 //
     /*  32519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32533 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32536 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32538 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32540 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32545 */   // GIR_Coverage, 2760,
     /*  32545 */   GIR_EraseRootFromParent_Done,
     /*  32546 */ // Label 708: @32546
     /*  32546 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32578), // Rule ID 2761 //
     /*  32551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32565 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32568 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32570 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32572 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32577 */   // GIR_Coverage, 2761,
     /*  32577 */   GIR_EraseRootFromParent_Done,
     /*  32578 */ // Label 709: @32578
     /*  32578 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32610), // Rule ID 2762 //
     /*  32583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32597 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32600 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32602 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32604 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32609 */   // GIR_Coverage, 2762,
     /*  32609 */   GIR_EraseRootFromParent_Done,
     /*  32610 */ // Label 710: @32610
     /*  32610 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32642), // Rule ID 2763 //
     /*  32615 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32629 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32632 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32634 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32636 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32641 */   // GIR_Coverage, 2763,
     /*  32641 */   GIR_EraseRootFromParent_Done,
     /*  32642 */ // Label 711: @32642
     /*  32642 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32674), // Rule ID 2764 //
     /*  32647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32661 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32664 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32666 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32668 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32673 */   // GIR_Coverage, 2764,
     /*  32673 */   GIR_EraseRootFromParent_Done,
     /*  32674 */ // Label 712: @32674
     /*  32674 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32711), // Rule ID 2831 //
     /*  32679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32693 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32698 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32703 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32709 */   GIR_RootConstrainSelectedInstOperands,
     /*  32710 */   // GIR_Coverage, 2831,
     /*  32710 */   GIR_EraseRootFromParent_Done,
     /*  32711 */ // Label 713: @32711
     /*  32711 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32748), // Rule ID 2832 //
     /*  32716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32730 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32740 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32746 */   GIR_RootConstrainSelectedInstOperands,
     /*  32747 */   // GIR_Coverage, 2832,
     /*  32747 */   GIR_EraseRootFromParent_Done,
     /*  32748 */ // Label 714: @32748
     /*  32748 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32785), // Rule ID 2833 //
     /*  32753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32767 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32772 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32777 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32783 */   GIR_RootConstrainSelectedInstOperands,
     /*  32784 */   // GIR_Coverage, 2833,
     /*  32784 */   GIR_EraseRootFromParent_Done,
     /*  32785 */ // Label 715: @32785
     /*  32785 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32822), // Rule ID 2834 //
     /*  32790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32804 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32811 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32814 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32820 */   GIR_RootConstrainSelectedInstOperands,
     /*  32821 */   // GIR_Coverage, 2834,
     /*  32821 */   GIR_EraseRootFromParent_Done,
     /*  32822 */ // Label 716: @32822
     /*  32822 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32859), // Rule ID 2835 //
     /*  32827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32841 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32846 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32857 */   GIR_RootConstrainSelectedInstOperands,
     /*  32858 */   // GIR_Coverage, 2835,
     /*  32858 */   GIR_EraseRootFromParent_Done,
     /*  32859 */ // Label 717: @32859
     /*  32859 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32896), // Rule ID 2836 //
     /*  32864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32878 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32883 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32894 */   GIR_RootConstrainSelectedInstOperands,
     /*  32895 */   // GIR_Coverage, 2836,
     /*  32895 */   GIR_EraseRootFromParent_Done,
     /*  32896 */ // Label 718: @32896
     /*  32896 */ GIM_Reject,
     /*  32897 */ // Label 546: @32897
     /*  32897 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32929), // Rule ID 2727 //
     /*  32902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32916 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32919 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32921 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32923 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32928 */   // GIR_Coverage, 2727,
     /*  32928 */   GIR_EraseRootFromParent_Done,
     /*  32929 */ // Label 719: @32929
     /*  32929 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32961), // Rule ID 2728 //
     /*  32934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32948 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32951 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32953 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32960 */   // GIR_Coverage, 2728,
     /*  32960 */   GIR_EraseRootFromParent_Done,
     /*  32961 */ // Label 720: @32961
     /*  32961 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(32993), // Rule ID 2785 //
     /*  32966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32980 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32983 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32985 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32987 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32992 */   // GIR_Coverage, 2785,
     /*  32992 */   GIR_EraseRootFromParent_Done,
     /*  32993 */ // Label 721: @32993
     /*  32993 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33025), // Rule ID 2786 //
     /*  32998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33012 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33015 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33024 */   // GIR_Coverage, 2786,
     /*  33024 */   GIR_EraseRootFromParent_Done,
     /*  33025 */ // Label 722: @33025
     /*  33025 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33057), // Rule ID 2787 //
     /*  33030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33044 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33047 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33049 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33056 */   // GIR_Coverage, 2787,
     /*  33056 */   GIR_EraseRootFromParent_Done,
     /*  33057 */ // Label 723: @33057
     /*  33057 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33089), // Rule ID 2788 //
     /*  33062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33076 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33079 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33081 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33088 */   // GIR_Coverage, 2788,
     /*  33088 */   GIR_EraseRootFromParent_Done,
     /*  33089 */ // Label 724: @33089
     /*  33089 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33121), // Rule ID 2789 //
     /*  33094 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33108 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33111 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33113 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33120 */   // GIR_Coverage, 2789,
     /*  33120 */   GIR_EraseRootFromParent_Done,
     /*  33121 */ // Label 725: @33121
     /*  33121 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33153), // Rule ID 2790 //
     /*  33126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33140 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33143 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33145 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33152 */   // GIR_Coverage, 2790,
     /*  33152 */   GIR_EraseRootFromParent_Done,
     /*  33153 */ // Label 726: @33153
     /*  33153 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33185), // Rule ID 2791 //
     /*  33158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33172 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33175 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33179 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33184 */   // GIR_Coverage, 2791,
     /*  33184 */   GIR_EraseRootFromParent_Done,
     /*  33185 */ // Label 727: @33185
     /*  33185 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33217), // Rule ID 2792 //
     /*  33190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33204 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33207 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33211 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33216 */   // GIR_Coverage, 2792,
     /*  33216 */   GIR_EraseRootFromParent_Done,
     /*  33217 */ // Label 728: @33217
     /*  33217 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33249), // Rule ID 2793 //
     /*  33222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33236 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33239 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33241 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33243 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33248 */   // GIR_Coverage, 2793,
     /*  33248 */   GIR_EraseRootFromParent_Done,
     /*  33249 */ // Label 729: @33249
     /*  33249 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33281), // Rule ID 2794 //
     /*  33254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33268 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33271 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33273 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33275 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33280 */   // GIR_Coverage, 2794,
     /*  33280 */   GIR_EraseRootFromParent_Done,
     /*  33281 */ // Label 730: @33281
     /*  33281 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33318), // Rule ID 2857 //
     /*  33286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33300 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33305 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33310 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33316 */   GIR_RootConstrainSelectedInstOperands,
     /*  33317 */   // GIR_Coverage, 2857,
     /*  33317 */   GIR_EraseRootFromParent_Done,
     /*  33318 */ // Label 731: @33318
     /*  33318 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33355), // Rule ID 2858 //
     /*  33323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33337 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33342 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33347 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33353 */   GIR_RootConstrainSelectedInstOperands,
     /*  33354 */   // GIR_Coverage, 2858,
     /*  33354 */   GIR_EraseRootFromParent_Done,
     /*  33355 */ // Label 732: @33355
     /*  33355 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33392), // Rule ID 2859 //
     /*  33360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33374 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33379 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33384 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33390 */   GIR_RootConstrainSelectedInstOperands,
     /*  33391 */   // GIR_Coverage, 2859,
     /*  33391 */   GIR_EraseRootFromParent_Done,
     /*  33392 */ // Label 733: @33392
     /*  33392 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33429), // Rule ID 2860 //
     /*  33397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33411 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33416 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33421 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33427 */   GIR_RootConstrainSelectedInstOperands,
     /*  33428 */   // GIR_Coverage, 2860,
     /*  33428 */   GIR_EraseRootFromParent_Done,
     /*  33429 */ // Label 734: @33429
     /*  33429 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33466), // Rule ID 2861 //
     /*  33434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33448 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33458 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33464 */   GIR_RootConstrainSelectedInstOperands,
     /*  33465 */   // GIR_Coverage, 2861,
     /*  33465 */   GIR_EraseRootFromParent_Done,
     /*  33466 */ // Label 735: @33466
     /*  33466 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33503), // Rule ID 2862 //
     /*  33471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33485 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33495 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33501 */   GIR_RootConstrainSelectedInstOperands,
     /*  33502 */   // GIR_Coverage, 2862,
     /*  33502 */   GIR_EraseRootFromParent_Done,
     /*  33503 */ // Label 736: @33503
     /*  33503 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33540), // Rule ID 2863 //
     /*  33508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33522 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33527 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33532 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33538 */   GIR_RootConstrainSelectedInstOperands,
     /*  33539 */   // GIR_Coverage, 2863,
     /*  33539 */   GIR_EraseRootFromParent_Done,
     /*  33540 */ // Label 737: @33540
     /*  33540 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33577), // Rule ID 2864 //
     /*  33545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33559 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33564 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33569 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33575 */   GIR_RootConstrainSelectedInstOperands,
     /*  33576 */   // GIR_Coverage, 2864,
     /*  33576 */   GIR_EraseRootFromParent_Done,
     /*  33577 */ // Label 738: @33577
     /*  33577 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33614), // Rule ID 2865 //
     /*  33582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33596 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33612 */   GIR_RootConstrainSelectedInstOperands,
     /*  33613 */   // GIR_Coverage, 2865,
     /*  33613 */   GIR_EraseRootFromParent_Done,
     /*  33614 */ // Label 739: @33614
     /*  33614 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33651), // Rule ID 2866 //
     /*  33619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33633 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33643 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33649 */   GIR_RootConstrainSelectedInstOperands,
     /*  33650 */   // GIR_Coverage, 2866,
     /*  33650 */   GIR_EraseRootFromParent_Done,
     /*  33651 */ // Label 740: @33651
     /*  33651 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33683), // Rule ID 5284 //
     /*  33656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33670 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33673 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33682 */   // GIR_Coverage, 5284,
     /*  33682 */   GIR_EraseRootFromParent_Done,
     /*  33683 */ // Label 741: @33683
     /*  33683 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33715), // Rule ID 5285 //
     /*  33688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33702 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33705 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33707 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33714 */   // GIR_Coverage, 5285,
     /*  33714 */   GIR_EraseRootFromParent_Done,
     /*  33715 */ // Label 742: @33715
     /*  33715 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33747), // Rule ID 5306 //
     /*  33720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33734 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33737 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33739 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33746 */   // GIR_Coverage, 5306,
     /*  33746 */   GIR_EraseRootFromParent_Done,
     /*  33747 */ // Label 743: @33747
     /*  33747 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33779), // Rule ID 5307 //
     /*  33752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33766 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33769 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33771 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33778 */   // GIR_Coverage, 5307,
     /*  33778 */   GIR_EraseRootFromParent_Done,
     /*  33779 */ // Label 744: @33779
     /*  33779 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33811), // Rule ID 5308 //
     /*  33784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33798 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33810 */   // GIR_Coverage, 5308,
     /*  33810 */   GIR_EraseRootFromParent_Done,
     /*  33811 */ // Label 745: @33811
     /*  33811 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33843), // Rule ID 5309 //
     /*  33816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33830 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33833 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33835 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33842 */   // GIR_Coverage, 5309,
     /*  33842 */   GIR_EraseRootFromParent_Done,
     /*  33843 */ // Label 746: @33843
     /*  33843 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33875), // Rule ID 5310 //
     /*  33848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33862 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33865 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33867 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33874 */   // GIR_Coverage, 5310,
     /*  33874 */   GIR_EraseRootFromParent_Done,
     /*  33875 */ // Label 747: @33875
     /*  33875 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33907), // Rule ID 5311 //
     /*  33880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33894 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33897 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33899 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33906 */   // GIR_Coverage, 5311,
     /*  33906 */   GIR_EraseRootFromParent_Done,
     /*  33907 */ // Label 748: @33907
     /*  33907 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33939), // Rule ID 5312 //
     /*  33912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33926 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33929 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33931 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33938 */   // GIR_Coverage, 5312,
     /*  33938 */   GIR_EraseRootFromParent_Done,
     /*  33939 */ // Label 749: @33939
     /*  33939 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33971), // Rule ID 5313 //
     /*  33944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33958 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33961 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33970 */   // GIR_Coverage, 5313,
     /*  33970 */   GIR_EraseRootFromParent_Done,
     /*  33971 */ // Label 750: @33971
     /*  33971 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(34003), // Rule ID 5314 //
     /*  33976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33990 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33993 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33995 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34002 */   // GIR_Coverage, 5314,
     /*  34002 */   GIR_EraseRootFromParent_Done,
     /*  34003 */ // Label 751: @34003
     /*  34003 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34035), // Rule ID 5315 //
     /*  34008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34022 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34025 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34027 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34034 */   // GIR_Coverage, 5315,
     /*  34034 */   GIR_EraseRootFromParent_Done,
     /*  34035 */ // Label 752: @34035
     /*  34035 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34093), // Rule ID 5342 //
     /*  34040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34054 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34076 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34082 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34091 */   GIR_RootConstrainSelectedInstOperands,
     /*  34092 */   // GIR_Coverage, 5342,
     /*  34092 */   GIR_EraseRootFromParent_Done,
     /*  34093 */ // Label 753: @34093
     /*  34093 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34151), // Rule ID 5343 //
     /*  34098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34112 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34112 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34115 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34119 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34129 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34134 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34149 */   GIR_RootConstrainSelectedInstOperands,
     /*  34150 */   // GIR_Coverage, 5343,
     /*  34150 */   GIR_EraseRootFromParent_Done,
     /*  34151 */ // Label 754: @34151
     /*  34151 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34209), // Rule ID 5344 //
     /*  34156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34170 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34187 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34192 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34198 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34207 */   GIR_RootConstrainSelectedInstOperands,
     /*  34208 */   // GIR_Coverage, 5344,
     /*  34208 */   GIR_EraseRootFromParent_Done,
     /*  34209 */ // Label 755: @34209
     /*  34209 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34267), // Rule ID 5345 //
     /*  34214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34228 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34245 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34250 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34256 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34262 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34265 */   GIR_RootConstrainSelectedInstOperands,
     /*  34266 */   // GIR_Coverage, 5345,
     /*  34266 */   GIR_EraseRootFromParent_Done,
     /*  34267 */ // Label 756: @34267
     /*  34267 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34325), // Rule ID 5346 //
     /*  34272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34286 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34286 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34289 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34293 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34303 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34308 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34314 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34323 */   GIR_RootConstrainSelectedInstOperands,
     /*  34324 */   // GIR_Coverage, 5346,
     /*  34324 */   GIR_EraseRootFromParent_Done,
     /*  34325 */ // Label 757: @34325
     /*  34325 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34383), // Rule ID 5347 //
     /*  34330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34344 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34366 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34372 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34381 */   GIR_RootConstrainSelectedInstOperands,
     /*  34382 */   // GIR_Coverage, 5347,
     /*  34382 */   GIR_EraseRootFromParent_Done,
     /*  34383 */ // Label 758: @34383
     /*  34383 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34441), // Rule ID 5348 //
     /*  34388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34402 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34424 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34430 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34439 */   GIR_RootConstrainSelectedInstOperands,
     /*  34440 */   // GIR_Coverage, 5348,
     /*  34440 */   GIR_EraseRootFromParent_Done,
     /*  34441 */ // Label 759: @34441
     /*  34441 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34499), // Rule ID 5349 //
     /*  34446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34460 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34460 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34463 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34467 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34477 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34488 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34497 */   GIR_RootConstrainSelectedInstOperands,
     /*  34498 */   // GIR_Coverage, 5349,
     /*  34498 */   GIR_EraseRootFromParent_Done,
     /*  34499 */ // Label 760: @34499
     /*  34499 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34557), // Rule ID 5350 //
     /*  34504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34518 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34555 */   GIR_RootConstrainSelectedInstOperands,
     /*  34556 */   // GIR_Coverage, 5350,
     /*  34556 */   GIR_EraseRootFromParent_Done,
     /*  34557 */ // Label 761: @34557
     /*  34557 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34615), // Rule ID 5351 //
     /*  34562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34576 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34604 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34613 */   GIR_RootConstrainSelectedInstOperands,
     /*  34614 */   // GIR_Coverage, 5351,
     /*  34614 */   GIR_EraseRootFromParent_Done,
     /*  34615 */ // Label 762: @34615
     /*  34615 */ GIM_Reject,
     /*  34616 */ // Label 547: @34616
     /*  34616 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34648), // Rule ID 2795 //
     /*  34621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34635 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34638 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34640 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34642 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34647 */   // GIR_Coverage, 2795,
     /*  34647 */   GIR_EraseRootFromParent_Done,
     /*  34648 */ // Label 763: @34648
     /*  34648 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34680), // Rule ID 2796 //
     /*  34653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34667 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34670 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34679 */   // GIR_Coverage, 2796,
     /*  34679 */   GIR_EraseRootFromParent_Done,
     /*  34680 */ // Label 764: @34680
     /*  34680 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34712), // Rule ID 2797 //
     /*  34685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34699 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34702 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34704 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34711 */   // GIR_Coverage, 2797,
     /*  34711 */   GIR_EraseRootFromParent_Done,
     /*  34712 */ // Label 765: @34712
     /*  34712 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34744), // Rule ID 2798 //
     /*  34717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34731 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34734 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34736 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34743 */   // GIR_Coverage, 2798,
     /*  34743 */   GIR_EraseRootFromParent_Done,
     /*  34744 */ // Label 766: @34744
     /*  34744 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34776), // Rule ID 2799 //
     /*  34749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34763 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34775 */   // GIR_Coverage, 2799,
     /*  34775 */   GIR_EraseRootFromParent_Done,
     /*  34776 */ // Label 767: @34776
     /*  34776 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34808), // Rule ID 2800 //
     /*  34781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34795 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34798 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34800 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34807 */   // GIR_Coverage, 2800,
     /*  34807 */   GIR_EraseRootFromParent_Done,
     /*  34808 */ // Label 768: @34808
     /*  34808 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34845), // Rule ID 2867 //
     /*  34813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34827 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34832 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34837 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34843 */   GIR_RootConstrainSelectedInstOperands,
     /*  34844 */   // GIR_Coverage, 2867,
     /*  34844 */   GIR_EraseRootFromParent_Done,
     /*  34845 */ // Label 769: @34845
     /*  34845 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34882), // Rule ID 2868 //
     /*  34850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34864 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34874 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34880 */   GIR_RootConstrainSelectedInstOperands,
     /*  34881 */   // GIR_Coverage, 2868,
     /*  34881 */   GIR_EraseRootFromParent_Done,
     /*  34882 */ // Label 770: @34882
     /*  34882 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34919), // Rule ID 2869 //
     /*  34887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34901 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34906 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34911 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34917 */   GIR_RootConstrainSelectedInstOperands,
     /*  34918 */   // GIR_Coverage, 2869,
     /*  34918 */   GIR_EraseRootFromParent_Done,
     /*  34919 */ // Label 771: @34919
     /*  34919 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34956), // Rule ID 2870 //
     /*  34924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34938 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34943 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34948 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34954 */   GIR_RootConstrainSelectedInstOperands,
     /*  34955 */   // GIR_Coverage, 2870,
     /*  34955 */   GIR_EraseRootFromParent_Done,
     /*  34956 */ // Label 772: @34956
     /*  34956 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(34993), // Rule ID 2871 //
     /*  34961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34975 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34985 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34991 */   GIR_RootConstrainSelectedInstOperands,
     /*  34992 */   // GIR_Coverage, 2871,
     /*  34992 */   GIR_EraseRootFromParent_Done,
     /*  34993 */ // Label 773: @34993
     /*  34993 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35030), // Rule ID 2872 //
     /*  34998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35012 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35017 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35022 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35028 */   GIR_RootConstrainSelectedInstOperands,
     /*  35029 */   // GIR_Coverage, 2872,
     /*  35029 */   GIR_EraseRootFromParent_Done,
     /*  35030 */ // Label 774: @35030
     /*  35030 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35062), // Rule ID 5316 //
     /*  35035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35049 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35052 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35054 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35061 */   // GIR_Coverage, 5316,
     /*  35061 */   GIR_EraseRootFromParent_Done,
     /*  35062 */ // Label 775: @35062
     /*  35062 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35094), // Rule ID 5317 //
     /*  35067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35081 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35081 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35084 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35086 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35093 */   // GIR_Coverage, 5317,
     /*  35093 */   GIR_EraseRootFromParent_Done,
     /*  35094 */ // Label 776: @35094
     /*  35094 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35126), // Rule ID 5318 //
     /*  35099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35113 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35116 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35118 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35120 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35125 */   // GIR_Coverage, 5318,
     /*  35125 */   GIR_EraseRootFromParent_Done,
     /*  35126 */ // Label 777: @35126
     /*  35126 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35158), // Rule ID 5319 //
     /*  35131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35145 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35148 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35150 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35157 */   // GIR_Coverage, 5319,
     /*  35157 */   GIR_EraseRootFromParent_Done,
     /*  35158 */ // Label 778: @35158
     /*  35158 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35190), // Rule ID 5320 //
     /*  35163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35177 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35180 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35182 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35184 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35189 */   // GIR_Coverage, 5320,
     /*  35189 */   GIR_EraseRootFromParent_Done,
     /*  35190 */ // Label 779: @35190
     /*  35190 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35222), // Rule ID 5321 //
     /*  35195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35209 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35212 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35214 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35216 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35221 */   // GIR_Coverage, 5321,
     /*  35221 */   GIR_EraseRootFromParent_Done,
     /*  35222 */ // Label 780: @35222
     /*  35222 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35280), // Rule ID 5352 //
     /*  35227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35241 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35263 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35269 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35278 */   GIR_RootConstrainSelectedInstOperands,
     /*  35279 */   // GIR_Coverage, 5352,
     /*  35279 */   GIR_EraseRootFromParent_Done,
     /*  35280 */ // Label 781: @35280
     /*  35280 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35338), // Rule ID 5353 //
     /*  35285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35299 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35299 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35302 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35306 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35316 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35327 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35336 */   GIR_RootConstrainSelectedInstOperands,
     /*  35337 */   // GIR_Coverage, 5353,
     /*  35337 */   GIR_EraseRootFromParent_Done,
     /*  35338 */ // Label 782: @35338
     /*  35338 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35396), // Rule ID 5354 //
     /*  35343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35357 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35374 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35379 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35391 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35394 */   GIR_RootConstrainSelectedInstOperands,
     /*  35395 */   // GIR_Coverage, 5354,
     /*  35395 */   GIR_EraseRootFromParent_Done,
     /*  35396 */ // Label 783: @35396
     /*  35396 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35454), // Rule ID 5355 //
     /*  35401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35415 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35432 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35437 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35449 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35452 */   GIR_RootConstrainSelectedInstOperands,
     /*  35453 */   // GIR_Coverage, 5355,
     /*  35453 */   GIR_EraseRootFromParent_Done,
     /*  35454 */ // Label 784: @35454
     /*  35454 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35512), // Rule ID 5356 //
     /*  35459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35473 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35473 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35476 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35480 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35490 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35495 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35501 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35510 */   GIR_RootConstrainSelectedInstOperands,
     /*  35511 */   // GIR_Coverage, 5356,
     /*  35511 */   GIR_EraseRootFromParent_Done,
     /*  35512 */ // Label 785: @35512
     /*  35512 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35570), // Rule ID 5357 //
     /*  35517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35531 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35548 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35553 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35559 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35568 */   GIR_RootConstrainSelectedInstOperands,
     /*  35569 */   // GIR_Coverage, 5357,
     /*  35569 */   GIR_EraseRootFromParent_Done,
     /*  35570 */ // Label 786: @35570
     /*  35570 */ GIM_Reject,
     /*  35571 */ // Label 548: @35571
     /*  35571 */ GIM_Reject,
     /*  35572 */ // Label 10: @35572
     /*  35572 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 792*/ GIMT_Encode4(35867),
     /*  35583 */ /*GILLT_s16*//*Label 787*/ GIMT_Encode4(35635),
     /*  35587 */ /*GILLT_s32*//*Label 788*/ GIMT_Encode4(35673),
     /*  35591 */ /*GILLT_s64*//*Label 789*/ GIMT_Encode4(35711), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35615 */ /*GILLT_v4s32*//*Label 790*/ GIMT_Encode4(35749), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35631 */ /*GILLT_v8s16*//*Label 791*/ GIMT_Encode4(35808),
     /*  35635 */ // Label 787: @35635
     /*  35635 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(35672), // Rule ID 665 //
     /*  35640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35654 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35659 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35664 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35670 */   GIR_RootConstrainSelectedInstOperands,
     /*  35671 */   // GIR_Coverage, 665,
     /*  35671 */   GIR_EraseRootFromParent_Done,
     /*  35672 */ // Label 793: @35672
     /*  35672 */ GIM_Reject,
     /*  35673 */ // Label 788: @35673
     /*  35673 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(35710), // Rule ID 666 //
     /*  35678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35692 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35697 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35702 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35708 */   GIR_RootConstrainSelectedInstOperands,
     /*  35709 */   // GIR_Coverage, 666,
     /*  35709 */   GIR_EraseRootFromParent_Done,
     /*  35710 */ // Label 794: @35710
     /*  35710 */ GIM_Reject,
     /*  35711 */ // Label 789: @35711
     /*  35711 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(35748), // Rule ID 667 //
     /*  35716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35730 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35735 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35740 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35746 */   GIR_RootConstrainSelectedInstOperands,
     /*  35747 */   // GIR_Coverage, 667,
     /*  35747 */   GIR_EraseRootFromParent_Done,
     /*  35748 */ // Label 795: @35748
     /*  35748 */ GIM_Reject,
     /*  35749 */ // Label 790: @35749
     /*  35749 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35807), // Rule ID 3979 //
     /*  35754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35768 */   // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35785 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35790 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35796 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35802 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35805 */   GIR_RootConstrainSelectedInstOperands,
     /*  35806 */   // GIR_Coverage, 3979,
     /*  35806 */   GIR_EraseRootFromParent_Done,
     /*  35807 */ // Label 796: @35807
     /*  35807 */ GIM_Reject,
     /*  35808 */ // Label 791: @35808
     /*  35808 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35866), // Rule ID 3967 //
     /*  35813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35827 */   // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35844 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35849 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35855 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35864 */   GIR_RootConstrainSelectedInstOperands,
     /*  35865 */   // GIR_Coverage, 3967,
     /*  35865 */   GIR_EraseRootFromParent_Done,
     /*  35866 */ // Label 797: @35866
     /*  35866 */ GIM_Reject,
     /*  35867 */ // Label 792: @35867
     /*  35867 */ GIM_Reject,
     /*  35868 */ // Label 11: @35868
     /*  35868 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 803*/ GIMT_Encode4(36130),
     /*  35879 */ /*GILLT_s16*//*Label 798*/ GIMT_Encode4(35931),
     /*  35883 */ /*GILLT_s32*//*Label 799*/ GIMT_Encode4(35958),
     /*  35887 */ /*GILLT_s64*//*Label 800*/ GIMT_Encode4(35985), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35911 */ /*GILLT_v4s32*//*Label 801*/ GIMT_Encode4(36012), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35927 */ /*GILLT_v8s16*//*Label 802*/ GIMT_Encode4(36071),
     /*  35931 */ // Label 798: @35931
     /*  35931 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(35957), // Rule ID 674 //
     /*  35936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35950 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  35955 */   GIR_RootConstrainSelectedInstOperands,
     /*  35956 */   // GIR_Coverage, 674,
     /*  35956 */   GIR_Done,
     /*  35957 */ // Label 804: @35957
     /*  35957 */ GIM_Reject,
     /*  35958 */ // Label 799: @35958
     /*  35958 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35984), // Rule ID 675 //
     /*  35963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35977 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  35982 */   GIR_RootConstrainSelectedInstOperands,
     /*  35983 */   // GIR_Coverage, 675,
     /*  35983 */   GIR_Done,
     /*  35984 */ // Label 805: @35984
     /*  35984 */ GIM_Reject,
     /*  35985 */ // Label 800: @35985
     /*  35985 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(36011), // Rule ID 676 //
     /*  35990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36004 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36009 */   GIR_RootConstrainSelectedInstOperands,
     /*  36010 */   // GIR_Coverage, 676,
     /*  36010 */   GIR_Done,
     /*  36011 */ // Label 806: @36011
     /*  36011 */ GIM_Reject,
     /*  36012 */ // Label 801: @36012
     /*  36012 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(36070), // Rule ID 3977 //
     /*  36017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36031 */   // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36048 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36053 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36059 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36065 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36068 */   GIR_RootConstrainSelectedInstOperands,
     /*  36069 */   // GIR_Coverage, 3977,
     /*  36069 */   GIR_EraseRootFromParent_Done,
     /*  36070 */ // Label 807: @36070
     /*  36070 */ GIM_Reject,
     /*  36071 */ // Label 802: @36071
     /*  36071 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(36129), // Rule ID 3965 //
     /*  36076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36090 */   // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36107 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36112 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36118 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36124 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36127 */   GIR_RootConstrainSelectedInstOperands,
     /*  36128 */   // GIR_Coverage, 3965,
     /*  36128 */   GIR_EraseRootFromParent_Done,
     /*  36129 */ // Label 808: @36129
     /*  36129 */ GIM_Reject,
     /*  36130 */ // Label 803: @36130
     /*  36130 */ GIM_Reject,
     /*  36131 */ // Label 12: @36131
     /*  36131 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(36293),
     /*  36136 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36142 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(36217), // Rule ID 2050 //
     /*  36147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36150 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36161 */     // MIs[0] Rn
     /*  36161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36169 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36181 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36187 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36190 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36193 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36206 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36215 */     GIR_RootConstrainSelectedInstOperands,
     /*  36216 */     // GIR_Coverage, 2050,
     /*  36216 */     GIR_EraseRootFromParent_Done,
     /*  36217 */   // Label 810: @36217
     /*  36217 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(36292), // Rule ID 2051 //
     /*  36222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36225 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36236 */     // MIs[0] Rn
     /*  36236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36244 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36256 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36268 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36290 */     GIR_RootConstrainSelectedInstOperands,
     /*  36291 */     // GIR_Coverage, 2051,
     /*  36291 */     GIR_EraseRootFromParent_Done,
     /*  36292 */   // Label 811: @36292
     /*  36292 */   GIM_Reject,
     /*  36293 */ // Label 809: @36293
     /*  36293 */ GIM_Reject,
     /*  36294 */ // Label 13: @36294
     /*  36294 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(36314), // Rule ID 5418 //
     /*  36299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36302 */   // MIs[0] Operand 0
     /*  36302 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36305 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36309 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36312 */   GIR_RootConstrainSelectedInstOperands,
     /*  36313 */   // GIR_Coverage, 5418,
     /*  36313 */   GIR_EraseRootFromParent_Done,
     /*  36314 */ // Label 812: @36314
     /*  36314 */ GIM_Reject,
     /*  36315 */ // Label 14: @36315
     /*  36315 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(42130),
     /*  36320 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36323 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(36371), // Rule ID 1853 //
     /*  36328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36350 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36369 */     GIR_RootConstrainSelectedInstOperands,
     /*  36370 */     // GIR_Coverage, 1853,
     /*  36370 */     GIR_EraseRootFromParent_Done,
     /*  36371 */   // Label 814: @36371
     /*  36371 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36419), // Rule ID 2107 //
     /*  36376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36398 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36417 */     GIR_RootConstrainSelectedInstOperands,
     /*  36418 */     // GIR_Coverage, 2107,
     /*  36418 */     GIR_EraseRootFromParent_Done,
     /*  36419 */   // Label 815: @36419
     /*  36419 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36455), // Rule ID 677 //
     /*  36424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36446 */     // (intrinsic_wo_chain:{ *:[f16] } 3804:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36453 */     GIR_RootConstrainSelectedInstOperands,
     /*  36454 */     // GIR_Coverage, 677,
     /*  36454 */     GIR_EraseRootFromParent_Done,
     /*  36455 */   // Label 816: @36455
     /*  36455 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36491), // Rule ID 678 //
     /*  36460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36482 */     // (intrinsic_wo_chain:{ *:[f32] } 3804:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36489 */     GIR_RootConstrainSelectedInstOperands,
     /*  36490 */     // GIR_Coverage, 678,
     /*  36490 */     GIR_EraseRootFromParent_Done,
     /*  36491 */   // Label 817: @36491
     /*  36491 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36527), // Rule ID 679 //
     /*  36496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36518 */     // (intrinsic_wo_chain:{ *:[f64] } 3804:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  36523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36525 */     GIR_RootConstrainSelectedInstOperands,
     /*  36526 */     // GIR_Coverage, 679,
     /*  36526 */     GIR_EraseRootFromParent_Done,
     /*  36527 */   // Label 818: @36527
     /*  36527 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36572), // Rule ID 693 //
     /*  36532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36554 */     // (intrinsic_wo_chain:{ *:[f32] } 3919:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  36557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36570 */     GIR_RootConstrainSelectedInstOperands,
     /*  36571 */     // GIR_Coverage, 693,
     /*  36571 */     GIR_EraseRootFromParent_Done,
     /*  36572 */   // Label 819: @36572
     /*  36572 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36617), // Rule ID 694 //
     /*  36577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36599 */     // (intrinsic_wo_chain:{ *:[f32] } 3919:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  36602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36615 */     GIR_RootConstrainSelectedInstOperands,
     /*  36616 */     // GIR_Coverage, 694,
     /*  36616 */     GIR_EraseRootFromParent_Done,
     /*  36617 */   // Label 820: @36617
     /*  36617 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(36662), // Rule ID 695 //
     /*  36622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36644 */     // (intrinsic_wo_chain:{ *:[f32] } 3920:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  36647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36654 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36660 */     GIR_RootConstrainSelectedInstOperands,
     /*  36661 */     // GIR_Coverage, 695,
     /*  36661 */     GIR_EraseRootFromParent_Done,
     /*  36662 */   // Label 821: @36662
     /*  36662 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36707), // Rule ID 696 //
     /*  36667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36689 */     // (intrinsic_wo_chain:{ *:[f32] } 3920:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  36692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36705 */     GIR_RootConstrainSelectedInstOperands,
     /*  36706 */     // GIR_Coverage, 696,
     /*  36706 */     GIR_EraseRootFromParent_Done,
     /*  36707 */   // Label 822: @36707
     /*  36707 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36752), // Rule ID 1239 //
     /*  36712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  36723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  36726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36734 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3770:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  36734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  36737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36750 */     GIR_RootConstrainSelectedInstOperands,
     /*  36751 */     // GIR_Coverage, 1239,
     /*  36751 */     GIR_EraseRootFromParent_Done,
     /*  36752 */   // Label 823: @36752
     /*  36752 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36797), // Rule ID 1240 //
     /*  36757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  36768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  36771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36779 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3770:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  36779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  36782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36795 */     GIR_RootConstrainSelectedInstOperands,
     /*  36796 */     // GIR_Coverage, 1240,
     /*  36796 */     GIR_EraseRootFromParent_Done,
     /*  36797 */   // Label 824: @36797
     /*  36797 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36842), // Rule ID 1241 //
     /*  36802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  36816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36824 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3770:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  36824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  36827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36840 */     GIR_RootConstrainSelectedInstOperands,
     /*  36841 */     // GIR_Coverage, 1241,
     /*  36841 */     GIR_EraseRootFromParent_Done,
     /*  36842 */   // Label 825: @36842
     /*  36842 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(36887), // Rule ID 1242 //
     /*  36847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  36858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36869 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3770:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  36869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  36872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36885 */     GIR_RootConstrainSelectedInstOperands,
     /*  36886 */     // GIR_Coverage, 1242,
     /*  36886 */     GIR_EraseRootFromParent_Done,
     /*  36887 */   // Label 826: @36887
     /*  36887 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(36932), // Rule ID 1243 //
     /*  36892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  36903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  36906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36914 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3770:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  36914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  36917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36930 */     GIR_RootConstrainSelectedInstOperands,
     /*  36931 */     // GIR_Coverage, 1243,
     /*  36931 */     GIR_EraseRootFromParent_Done,
     /*  36932 */   // Label 827: @36932
     /*  36932 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(36977), // Rule ID 1244 //
     /*  36937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  36948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36959 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3770:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  36959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  36962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36975 */     GIR_RootConstrainSelectedInstOperands,
     /*  36976 */     // GIR_Coverage, 1244,
     /*  36976 */     GIR_EraseRootFromParent_Done,
     /*  36977 */   // Label 828: @36977
     /*  36977 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(37022), // Rule ID 1245 //
     /*  36982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  36990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  36993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  36996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37004 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3771:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37020 */     GIR_RootConstrainSelectedInstOperands,
     /*  37021 */     // GIR_Coverage, 1245,
     /*  37021 */     GIR_EraseRootFromParent_Done,
     /*  37022 */   // Label 829: @37022
     /*  37022 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(37067), // Rule ID 1246 //
     /*  37027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37049 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3771:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37065 */     GIR_RootConstrainSelectedInstOperands,
     /*  37066 */     // GIR_Coverage, 1246,
     /*  37066 */     GIR_EraseRootFromParent_Done,
     /*  37067 */   // Label 830: @37067
     /*  37067 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(37112), // Rule ID 1247 //
     /*  37072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37094 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3771:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37110 */     GIR_RootConstrainSelectedInstOperands,
     /*  37111 */     // GIR_Coverage, 1247,
     /*  37111 */     GIR_EraseRootFromParent_Done,
     /*  37112 */   // Label 831: @37112
     /*  37112 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(37157), // Rule ID 1248 //
     /*  37117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37139 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3771:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37155 */     GIR_RootConstrainSelectedInstOperands,
     /*  37156 */     // GIR_Coverage, 1248,
     /*  37156 */     GIR_EraseRootFromParent_Done,
     /*  37157 */   // Label 832: @37157
     /*  37157 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(37202), // Rule ID 1249 //
     /*  37162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37184 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3771:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37200 */     GIR_RootConstrainSelectedInstOperands,
     /*  37201 */     // GIR_Coverage, 1249,
     /*  37201 */     GIR_EraseRootFromParent_Done,
     /*  37202 */   // Label 833: @37202
     /*  37202 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(37247), // Rule ID 1250 //
     /*  37207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37229 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3771:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37245 */     GIR_RootConstrainSelectedInstOperands,
     /*  37246 */     // GIR_Coverage, 1250,
     /*  37246 */     GIR_EraseRootFromParent_Done,
     /*  37247 */   // Label 834: @37247
     /*  37247 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(37292), // Rule ID 1279 //
     /*  37252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37274 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37290 */     GIR_RootConstrainSelectedInstOperands,
     /*  37291 */     // GIR_Coverage, 1279,
     /*  37291 */     GIR_EraseRootFromParent_Done,
     /*  37292 */   // Label 835: @37292
     /*  37292 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(37337), // Rule ID 1280 //
     /*  37297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37319 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37335 */     GIR_RootConstrainSelectedInstOperands,
     /*  37336 */     // GIR_Coverage, 1280,
     /*  37336 */     GIR_EraseRootFromParent_Done,
     /*  37337 */   // Label 836: @37337
     /*  37337 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(37382), // Rule ID 1281 //
     /*  37342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37364 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37380 */     GIR_RootConstrainSelectedInstOperands,
     /*  37381 */     // GIR_Coverage, 1281,
     /*  37381 */     GIR_EraseRootFromParent_Done,
     /*  37382 */   // Label 837: @37382
     /*  37382 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(37427), // Rule ID 1282 //
     /*  37387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37409 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3798:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37425 */     GIR_RootConstrainSelectedInstOperands,
     /*  37426 */     // GIR_Coverage, 1282,
     /*  37426 */     GIR_EraseRootFromParent_Done,
     /*  37427 */   // Label 838: @37427
     /*  37427 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(37472), // Rule ID 1283 //
     /*  37432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37454 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37470 */     GIR_RootConstrainSelectedInstOperands,
     /*  37471 */     // GIR_Coverage, 1283,
     /*  37471 */     GIR_EraseRootFromParent_Done,
     /*  37472 */   // Label 839: @37472
     /*  37472 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(37517), // Rule ID 1284 //
     /*  37477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37499 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3798:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37515 */     GIR_RootConstrainSelectedInstOperands,
     /*  37516 */     // GIR_Coverage, 1284,
     /*  37516 */     GIR_EraseRootFromParent_Done,
     /*  37517 */   // Label 840: @37517
     /*  37517 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(37562), // Rule ID 1289 //
     /*  37522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37544 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  37547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37560 */     GIR_RootConstrainSelectedInstOperands,
     /*  37561 */     // GIR_Coverage, 1289,
     /*  37561 */     GIR_EraseRootFromParent_Done,
     /*  37562 */   // Label 841: @37562
     /*  37562 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(37607), // Rule ID 1290 //
     /*  37567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37589 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3811:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  37592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37605 */     GIR_RootConstrainSelectedInstOperands,
     /*  37606 */     // GIR_Coverage, 1290,
     /*  37606 */     GIR_EraseRootFromParent_Done,
     /*  37607 */   // Label 842: @37607
     /*  37607 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(37652), // Rule ID 1291 //
     /*  37612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37634 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  37637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37650 */     GIR_RootConstrainSelectedInstOperands,
     /*  37651 */     // GIR_Coverage, 1291,
     /*  37651 */     GIR_EraseRootFromParent_Done,
     /*  37652 */   // Label 843: @37652
     /*  37652 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(37697), // Rule ID 1292 //
     /*  37657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37679 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3811:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  37682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37695 */     GIR_RootConstrainSelectedInstOperands,
     /*  37696 */     // GIR_Coverage, 1292,
     /*  37696 */     GIR_EraseRootFromParent_Done,
     /*  37697 */   // Label 844: @37697
     /*  37697 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(37742), // Rule ID 1293 //
     /*  37702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37724 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3811:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  37727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37740 */     GIR_RootConstrainSelectedInstOperands,
     /*  37741 */     // GIR_Coverage, 1293,
     /*  37741 */     GIR_EraseRootFromParent_Done,
     /*  37742 */   // Label 845: @37742
     /*  37742 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37787), // Rule ID 1294 //
     /*  37747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37769 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3811:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  37772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37785 */     GIR_RootConstrainSelectedInstOperands,
     /*  37786 */     // GIR_Coverage, 1294,
     /*  37786 */     GIR_EraseRootFromParent_Done,
     /*  37787 */   // Label 846: @37787
     /*  37787 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37832), // Rule ID 1515 //
     /*  37792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  37803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37814 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3776:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  37814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  37817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37830 */     GIR_RootConstrainSelectedInstOperands,
     /*  37831 */     // GIR_Coverage, 1515,
     /*  37831 */     GIR_EraseRootFromParent_Done,
     /*  37832 */   // Label 847: @37832
     /*  37832 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37877), // Rule ID 1516 //
     /*  37837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37859 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3776:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  37859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  37862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37875 */     GIR_RootConstrainSelectedInstOperands,
     /*  37876 */     // GIR_Coverage, 1516,
     /*  37876 */     GIR_EraseRootFromParent_Done,
     /*  37877 */   // Label 848: @37877
     /*  37877 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37922), // Rule ID 1517 //
     /*  37882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37904 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3776:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  37907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37920 */     GIR_RootConstrainSelectedInstOperands,
     /*  37921 */     // GIR_Coverage, 1517,
     /*  37921 */     GIR_EraseRootFromParent_Done,
     /*  37922 */   // Label 849: @37922
     /*  37922 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37967), // Rule ID 1518 //
     /*  37927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  37938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37949 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3776:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  37949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  37952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37965 */     GIR_RootConstrainSelectedInstOperands,
     /*  37966 */     // GIR_Coverage, 1518,
     /*  37966 */     GIR_EraseRootFromParent_Done,
     /*  37967 */   // Label 850: @37967
     /*  37967 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(38012), // Rule ID 1519 //
     /*  37972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37994 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3776:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  37994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  37997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38010 */     GIR_RootConstrainSelectedInstOperands,
     /*  38011 */     // GIR_Coverage, 1519,
     /*  38011 */     GIR_EraseRootFromParent_Done,
     /*  38012 */   // Label 851: @38012
     /*  38012 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(38057), // Rule ID 1520 //
     /*  38017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38039 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3776:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38055 */     GIR_RootConstrainSelectedInstOperands,
     /*  38056 */     // GIR_Coverage, 1520,
     /*  38056 */     GIR_EraseRootFromParent_Done,
     /*  38057 */   // Label 852: @38057
     /*  38057 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(38102), // Rule ID 1531 //
     /*  38062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38084 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3782:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38100 */     GIR_RootConstrainSelectedInstOperands,
     /*  38101 */     // GIR_Coverage, 1531,
     /*  38101 */     GIR_EraseRootFromParent_Done,
     /*  38102 */   // Label 853: @38102
     /*  38102 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(38147), // Rule ID 1532 //
     /*  38107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38129 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3782:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38145 */     GIR_RootConstrainSelectedInstOperands,
     /*  38146 */     // GIR_Coverage, 1532,
     /*  38146 */     GIR_EraseRootFromParent_Done,
     /*  38147 */   // Label 854: @38147
     /*  38147 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(38192), // Rule ID 1533 //
     /*  38152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38174 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3782:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38190 */     GIR_RootConstrainSelectedInstOperands,
     /*  38191 */     // GIR_Coverage, 1533,
     /*  38191 */     GIR_EraseRootFromParent_Done,
     /*  38192 */   // Label 855: @38192
     /*  38192 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(38237), // Rule ID 1534 //
     /*  38197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38219 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3782:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38235 */     GIR_RootConstrainSelectedInstOperands,
     /*  38236 */     // GIR_Coverage, 1534,
     /*  38236 */     GIR_EraseRootFromParent_Done,
     /*  38237 */   // Label 856: @38237
     /*  38237 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(38282), // Rule ID 1535 //
     /*  38242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38264 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3782:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38280 */     GIR_RootConstrainSelectedInstOperands,
     /*  38281 */     // GIR_Coverage, 1535,
     /*  38281 */     GIR_EraseRootFromParent_Done,
     /*  38282 */   // Label 857: @38282
     /*  38282 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(38327), // Rule ID 1536 //
     /*  38287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38309 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3782:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38325 */     GIR_RootConstrainSelectedInstOperands,
     /*  38326 */     // GIR_Coverage, 1536,
     /*  38326 */     GIR_EraseRootFromParent_Done,
     /*  38327 */   // Label 858: @38327
     /*  38327 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(38372), // Rule ID 1537 //
     /*  38332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38354 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3723:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38370 */     GIR_RootConstrainSelectedInstOperands,
     /*  38371 */     // GIR_Coverage, 1537,
     /*  38371 */     GIR_EraseRootFromParent_Done,
     /*  38372 */   // Label 859: @38372
     /*  38372 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(38417), // Rule ID 1538 //
     /*  38377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38399 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3723:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38415 */     GIR_RootConstrainSelectedInstOperands,
     /*  38416 */     // GIR_Coverage, 1538,
     /*  38416 */     GIR_EraseRootFromParent_Done,
     /*  38417 */   // Label 860: @38417
     /*  38417 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(38462), // Rule ID 1539 //
     /*  38422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38444 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3723:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38460 */     GIR_RootConstrainSelectedInstOperands,
     /*  38461 */     // GIR_Coverage, 1539,
     /*  38461 */     GIR_EraseRootFromParent_Done,
     /*  38462 */   // Label 861: @38462
     /*  38462 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(38507), // Rule ID 1540 //
     /*  38467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38489 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3723:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38505 */     GIR_RootConstrainSelectedInstOperands,
     /*  38506 */     // GIR_Coverage, 1540,
     /*  38506 */     GIR_EraseRootFromParent_Done,
     /*  38507 */   // Label 862: @38507
     /*  38507 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(38552), // Rule ID 1541 //
     /*  38512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38534 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3723:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  38537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38550 */     GIR_RootConstrainSelectedInstOperands,
     /*  38551 */     // GIR_Coverage, 1541,
     /*  38551 */     GIR_EraseRootFromParent_Done,
     /*  38552 */   // Label 863: @38552
     /*  38552 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(38597), // Rule ID 1542 //
     /*  38557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38579 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3723:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  38582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38595 */     GIR_RootConstrainSelectedInstOperands,
     /*  38596 */     // GIR_Coverage, 1542,
     /*  38596 */     GIR_EraseRootFromParent_Done,
     /*  38597 */   // Label 864: @38597
     /*  38597 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(38642), // Rule ID 1586 //
     /*  38602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38624 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3779:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  38627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38640 */     GIR_RootConstrainSelectedInstOperands,
     /*  38641 */     // GIR_Coverage, 1586,
     /*  38641 */     GIR_EraseRootFromParent_Done,
     /*  38642 */   // Label 865: @38642
     /*  38642 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(38687), // Rule ID 1587 //
     /*  38647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38669 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3779:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  38672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38685 */     GIR_RootConstrainSelectedInstOperands,
     /*  38686 */     // GIR_Coverage, 1587,
     /*  38686 */     GIR_EraseRootFromParent_Done,
     /*  38687 */   // Label 866: @38687
     /*  38687 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(38732), // Rule ID 1588 //
     /*  38692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38714 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3779:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  38717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38730 */     GIR_RootConstrainSelectedInstOperands,
     /*  38731 */     // GIR_Coverage, 1588,
     /*  38731 */     GIR_EraseRootFromParent_Done,
     /*  38732 */   // Label 867: @38732
     /*  38732 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38777), // Rule ID 1589 //
     /*  38737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38759 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3781:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  38762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38775 */     GIR_RootConstrainSelectedInstOperands,
     /*  38776 */     // GIR_Coverage, 1589,
     /*  38776 */     GIR_EraseRootFromParent_Done,
     /*  38777 */   // Label 868: @38777
     /*  38777 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38822), // Rule ID 1590 //
     /*  38782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38804 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3781:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  38807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38820 */     GIR_RootConstrainSelectedInstOperands,
     /*  38821 */     // GIR_Coverage, 1590,
     /*  38821 */     GIR_EraseRootFromParent_Done,
     /*  38822 */   // Label 869: @38822
     /*  38822 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38867), // Rule ID 1591 //
     /*  38827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38849 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3781:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  38852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38865 */     GIR_RootConstrainSelectedInstOperands,
     /*  38866 */     // GIR_Coverage, 1591,
     /*  38866 */     GIR_EraseRootFromParent_Done,
     /*  38867 */   // Label 870: @38867
     /*  38867 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38912), // Rule ID 1592 //
     /*  38872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38894 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3780:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  38897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38910 */     GIR_RootConstrainSelectedInstOperands,
     /*  38911 */     // GIR_Coverage, 1592,
     /*  38911 */     GIR_EraseRootFromParent_Done,
     /*  38912 */   // Label 871: @38912
     /*  38912 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38957), // Rule ID 1593 //
     /*  38917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38939 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3780:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  38942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38955 */     GIR_RootConstrainSelectedInstOperands,
     /*  38956 */     // GIR_Coverage, 1593,
     /*  38956 */     GIR_EraseRootFromParent_Done,
     /*  38957 */   // Label 872: @38957
     /*  38957 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(39002), // Rule ID 1594 //
     /*  38962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38984 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3780:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  38987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39000 */     GIR_RootConstrainSelectedInstOperands,
     /*  39001 */     // GIR_Coverage, 1594,
     /*  39001 */     GIR_EraseRootFromParent_Done,
     /*  39002 */   // Label 873: @39002
     /*  39002 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(39038), // Rule ID 1617 //
     /*  39007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39029 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3724:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39036 */     GIR_RootConstrainSelectedInstOperands,
     /*  39037 */     // GIR_Coverage, 1617,
     /*  39037 */     GIR_EraseRootFromParent_Done,
     /*  39038 */   // Label 874: @39038
     /*  39038 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(39074), // Rule ID 1618 //
     /*  39043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39065 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3724:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39072 */     GIR_RootConstrainSelectedInstOperands,
     /*  39073 */     // GIR_Coverage, 1618,
     /*  39073 */     GIR_EraseRootFromParent_Done,
     /*  39074 */   // Label 875: @39074
     /*  39074 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(39110), // Rule ID 1619 //
     /*  39079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39101 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3725:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39108 */     GIR_RootConstrainSelectedInstOperands,
     /*  39109 */     // GIR_Coverage, 1619,
     /*  39109 */     GIR_EraseRootFromParent_Done,
     /*  39110 */   // Label 876: @39110
     /*  39110 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(39146), // Rule ID 1620 //
     /*  39115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39137 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3725:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39144 */     GIR_RootConstrainSelectedInstOperands,
     /*  39145 */     // GIR_Coverage, 1620,
     /*  39145 */     GIR_EraseRootFromParent_Done,
     /*  39146 */   // Label 877: @39146
     /*  39146 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(39182), // Rule ID 1621 //
     /*  39151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39173 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3724:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39180 */     GIR_RootConstrainSelectedInstOperands,
     /*  39181 */     // GIR_Coverage, 1621,
     /*  39181 */     GIR_EraseRootFromParent_Done,
     /*  39182 */   // Label 878: @39182
     /*  39182 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(39218), // Rule ID 1622 //
     /*  39187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39209 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3724:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39216 */     GIR_RootConstrainSelectedInstOperands,
     /*  39217 */     // GIR_Coverage, 1622,
     /*  39217 */     GIR_EraseRootFromParent_Done,
     /*  39218 */   // Label 879: @39218
     /*  39218 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(39254), // Rule ID 1623 //
     /*  39223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39245 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3725:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39252 */     GIR_RootConstrainSelectedInstOperands,
     /*  39253 */     // GIR_Coverage, 1623,
     /*  39253 */     GIR_EraseRootFromParent_Done,
     /*  39254 */   // Label 880: @39254
     /*  39254 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(39290), // Rule ID 1624 //
     /*  39259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39281 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3725:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39288 */     GIR_RootConstrainSelectedInstOperands,
     /*  39289 */     // GIR_Coverage, 1624,
     /*  39289 */     GIR_EraseRootFromParent_Done,
     /*  39290 */   // Label 881: @39290
     /*  39290 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(39326), // Rule ID 1625 //
     /*  39295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39317 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3736:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39324 */     GIR_RootConstrainSelectedInstOperands,
     /*  39325 */     // GIR_Coverage, 1625,
     /*  39325 */     GIR_EraseRootFromParent_Done,
     /*  39326 */   // Label 882: @39326
     /*  39326 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(39362), // Rule ID 1626 //
     /*  39331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39353 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3736:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39360 */     GIR_RootConstrainSelectedInstOperands,
     /*  39361 */     // GIR_Coverage, 1626,
     /*  39361 */     GIR_EraseRootFromParent_Done,
     /*  39362 */   // Label 883: @39362
     /*  39362 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(39398), // Rule ID 1627 //
     /*  39367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39389 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3737:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39396 */     GIR_RootConstrainSelectedInstOperands,
     /*  39397 */     // GIR_Coverage, 1627,
     /*  39397 */     GIR_EraseRootFromParent_Done,
     /*  39398 */   // Label 884: @39398
     /*  39398 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(39434), // Rule ID 1628 //
     /*  39403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39425 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3737:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39432 */     GIR_RootConstrainSelectedInstOperands,
     /*  39433 */     // GIR_Coverage, 1628,
     /*  39433 */     GIR_EraseRootFromParent_Done,
     /*  39434 */   // Label 885: @39434
     /*  39434 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(39470), // Rule ID 1629 //
     /*  39439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39461 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3736:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39468 */     GIR_RootConstrainSelectedInstOperands,
     /*  39469 */     // GIR_Coverage, 1629,
     /*  39469 */     GIR_EraseRootFromParent_Done,
     /*  39470 */   // Label 886: @39470
     /*  39470 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(39506), // Rule ID 1630 //
     /*  39475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39497 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3736:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39504 */     GIR_RootConstrainSelectedInstOperands,
     /*  39505 */     // GIR_Coverage, 1630,
     /*  39505 */     GIR_EraseRootFromParent_Done,
     /*  39506 */   // Label 887: @39506
     /*  39506 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(39542), // Rule ID 1631 //
     /*  39511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39533 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3737:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  39536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39540 */     GIR_RootConstrainSelectedInstOperands,
     /*  39541 */     // GIR_Coverage, 1631,
     /*  39541 */     GIR_EraseRootFromParent_Done,
     /*  39542 */   // Label 888: @39542
     /*  39542 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(39578), // Rule ID 1632 //
     /*  39547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39569 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3737:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  39572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39576 */     GIR_RootConstrainSelectedInstOperands,
     /*  39577 */     // GIR_Coverage, 1632,
     /*  39577 */     GIR_EraseRootFromParent_Done,
     /*  39578 */   // Label 889: @39578
     /*  39578 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39614), // Rule ID 1633 //
     /*  39583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39605 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3738:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  39608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39612 */     GIR_RootConstrainSelectedInstOperands,
     /*  39613 */     // GIR_Coverage, 1633,
     /*  39613 */     GIR_EraseRootFromParent_Done,
     /*  39614 */   // Label 890: @39614
     /*  39614 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39650), // Rule ID 1634 //
     /*  39619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39641 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  39644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39648 */     GIR_RootConstrainSelectedInstOperands,
     /*  39649 */     // GIR_Coverage, 1634,
     /*  39649 */     GIR_EraseRootFromParent_Done,
     /*  39650 */   // Label 891: @39650
     /*  39650 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39686), // Rule ID 1635 //
     /*  39655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39677 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3739:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  39680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39684 */     GIR_RootConstrainSelectedInstOperands,
     /*  39685 */     // GIR_Coverage, 1635,
     /*  39685 */     GIR_EraseRootFromParent_Done,
     /*  39686 */   // Label 892: @39686
     /*  39686 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39722), // Rule ID 1636 //
     /*  39691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39713 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  39716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39720 */     GIR_RootConstrainSelectedInstOperands,
     /*  39721 */     // GIR_Coverage, 1636,
     /*  39721 */     GIR_EraseRootFromParent_Done,
     /*  39722 */   // Label 893: @39722
     /*  39722 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39758), // Rule ID 1637 //
     /*  39727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39749 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3738:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  39752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39756 */     GIR_RootConstrainSelectedInstOperands,
     /*  39757 */     // GIR_Coverage, 1637,
     /*  39757 */     GIR_EraseRootFromParent_Done,
     /*  39758 */   // Label 894: @39758
     /*  39758 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39794), // Rule ID 1638 //
     /*  39763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39785 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3738:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  39788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39792 */     GIR_RootConstrainSelectedInstOperands,
     /*  39793 */     // GIR_Coverage, 1638,
     /*  39793 */     GIR_EraseRootFromParent_Done,
     /*  39794 */   // Label 895: @39794
     /*  39794 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39830), // Rule ID 1639 //
     /*  39799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39821 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3739:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  39824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39828 */     GIR_RootConstrainSelectedInstOperands,
     /*  39829 */     // GIR_Coverage, 1639,
     /*  39829 */     GIR_EraseRootFromParent_Done,
     /*  39830 */   // Label 896: @39830
     /*  39830 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39866), // Rule ID 1640 //
     /*  39835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39857 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3739:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  39860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39864 */     GIR_RootConstrainSelectedInstOperands,
     /*  39865 */     // GIR_Coverage, 1640,
     /*  39865 */     GIR_EraseRootFromParent_Done,
     /*  39866 */   // Label 897: @39866
     /*  39866 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39902), // Rule ID 1641 //
     /*  39871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  39879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39893 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3734:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  39896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39900 */     GIR_RootConstrainSelectedInstOperands,
     /*  39901 */     // GIR_Coverage, 1641,
     /*  39901 */     GIR_EraseRootFromParent_Done,
     /*  39902 */   // Label 898: @39902
     /*  39902 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39938), // Rule ID 1642 //
     /*  39907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  39915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39929 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3734:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  39932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39936 */     GIR_RootConstrainSelectedInstOperands,
     /*  39937 */     // GIR_Coverage, 1642,
     /*  39937 */     GIR_EraseRootFromParent_Done,
     /*  39938 */   // Label 899: @39938
     /*  39938 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39974), // Rule ID 1643 //
     /*  39943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  39951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39965 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3735:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  39968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39972 */     GIR_RootConstrainSelectedInstOperands,
     /*  39973 */     // GIR_Coverage, 1643,
     /*  39973 */     GIR_EraseRootFromParent_Done,
     /*  39974 */   // Label 900: @39974
     /*  39974 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(40010), // Rule ID 1644 //
     /*  39979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  39987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40001 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3735:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40008 */     GIR_RootConstrainSelectedInstOperands,
     /*  40009 */     // GIR_Coverage, 1644,
     /*  40009 */     GIR_EraseRootFromParent_Done,
     /*  40010 */   // Label 901: @40010
     /*  40010 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(40046), // Rule ID 1645 //
     /*  40015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40037 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3734:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40044 */     GIR_RootConstrainSelectedInstOperands,
     /*  40045 */     // GIR_Coverage, 1645,
     /*  40045 */     GIR_EraseRootFromParent_Done,
     /*  40046 */   // Label 902: @40046
     /*  40046 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(40082), // Rule ID 1646 //
     /*  40051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40073 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3734:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40080 */     GIR_RootConstrainSelectedInstOperands,
     /*  40081 */     // GIR_Coverage, 1646,
     /*  40081 */     GIR_EraseRootFromParent_Done,
     /*  40082 */   // Label 903: @40082
     /*  40082 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(40118), // Rule ID 1647 //
     /*  40087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40109 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3735:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40116 */     GIR_RootConstrainSelectedInstOperands,
     /*  40117 */     // GIR_Coverage, 1647,
     /*  40117 */     GIR_EraseRootFromParent_Done,
     /*  40118 */   // Label 904: @40118
     /*  40118 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(40154), // Rule ID 1648 //
     /*  40123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40145 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3735:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40152 */     GIR_RootConstrainSelectedInstOperands,
     /*  40153 */     // GIR_Coverage, 1648,
     /*  40153 */     GIR_EraseRootFromParent_Done,
     /*  40154 */   // Label 905: @40154
     /*  40154 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(40199), // Rule ID 1665 //
     /*  40159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40181 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3730:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40197 */     GIR_RootConstrainSelectedInstOperands,
     /*  40198 */     // GIR_Coverage, 1665,
     /*  40198 */     GIR_EraseRootFromParent_Done,
     /*  40199 */   // Label 906: @40199
     /*  40199 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(40244), // Rule ID 1666 //
     /*  40204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40226 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3733:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40242 */     GIR_RootConstrainSelectedInstOperands,
     /*  40243 */     // GIR_Coverage, 1666,
     /*  40243 */     GIR_EraseRootFromParent_Done,
     /*  40244 */   // Label 907: @40244
     /*  40244 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(40280), // Rule ID 1688 //
     /*  40249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40271 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40278 */     GIR_RootConstrainSelectedInstOperands,
     /*  40279 */     // GIR_Coverage, 1688,
     /*  40279 */     GIR_EraseRootFromParent_Done,
     /*  40280 */   // Label 908: @40280
     /*  40280 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(40316), // Rule ID 1689 //
     /*  40285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40307 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3804:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40314 */     GIR_RootConstrainSelectedInstOperands,
     /*  40315 */     // GIR_Coverage, 1689,
     /*  40315 */     GIR_EraseRootFromParent_Done,
     /*  40316 */   // Label 909: @40316
     /*  40316 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(40352), // Rule ID 1690 //
     /*  40321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40343 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40350 */     GIR_RootConstrainSelectedInstOperands,
     /*  40351 */     // GIR_Coverage, 1690,
     /*  40351 */     GIR_EraseRootFromParent_Done,
     /*  40352 */   // Label 910: @40352
     /*  40352 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(40388), // Rule ID 1691 //
     /*  40357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40379 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3804:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40386 */     GIR_RootConstrainSelectedInstOperands,
     /*  40387 */     // GIR_Coverage, 1691,
     /*  40387 */     GIR_EraseRootFromParent_Done,
     /*  40388 */   // Label 911: @40388
     /*  40388 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(40424), // Rule ID 1692 //
     /*  40393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40415 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3806:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40422 */     GIR_RootConstrainSelectedInstOperands,
     /*  40423 */     // GIR_Coverage, 1692,
     /*  40423 */     GIR_EraseRootFromParent_Done,
     /*  40424 */   // Label 912: @40424
     /*  40424 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(40460), // Rule ID 1693 //
     /*  40429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40451 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3806:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40458 */     GIR_RootConstrainSelectedInstOperands,
     /*  40459 */     // GIR_Coverage, 1693,
     /*  40459 */     GIR_EraseRootFromParent_Done,
     /*  40460 */   // Label 913: @40460
     /*  40460 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(40496), // Rule ID 1694 //
     /*  40465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40487 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3806:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40494 */     GIR_RootConstrainSelectedInstOperands,
     /*  40495 */     // GIR_Coverage, 1694,
     /*  40495 */     GIR_EraseRootFromParent_Done,
     /*  40496 */   // Label 914: @40496
     /*  40496 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40532), // Rule ID 1695 //
     /*  40501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40523 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3806:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  40526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40530 */     GIR_RootConstrainSelectedInstOperands,
     /*  40531 */     // GIR_Coverage, 1695,
     /*  40531 */     GIR_EraseRootFromParent_Done,
     /*  40532 */   // Label 915: @40532
     /*  40532 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40568), // Rule ID 1696 //
     /*  40537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40559 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3802:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  40562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40566 */     GIR_RootConstrainSelectedInstOperands,
     /*  40567 */     // GIR_Coverage, 1696,
     /*  40567 */     GIR_EraseRootFromParent_Done,
     /*  40568 */   // Label 916: @40568
     /*  40568 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40604), // Rule ID 1697 //
     /*  40573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40595 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3802:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  40598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40602 */     GIR_RootConstrainSelectedInstOperands,
     /*  40603 */     // GIR_Coverage, 1697,
     /*  40603 */     GIR_EraseRootFromParent_Done,
     /*  40604 */   // Label 917: @40604
     /*  40604 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40640), // Rule ID 1698 //
     /*  40609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40631 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3802:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  40634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40638 */     GIR_RootConstrainSelectedInstOperands,
     /*  40639 */     // GIR_Coverage, 1698,
     /*  40639 */     GIR_EraseRootFromParent_Done,
     /*  40640 */   // Label 918: @40640
     /*  40640 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40676), // Rule ID 1699 //
     /*  40645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40667 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3802:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  40670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40674 */     GIR_RootConstrainSelectedInstOperands,
     /*  40675 */     // GIR_Coverage, 1699,
     /*  40675 */     GIR_EraseRootFromParent_Done,
     /*  40676 */   // Label 919: @40676
     /*  40676 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40712), // Rule ID 1700 //
     /*  40681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40703 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3807:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  40706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40710 */     GIR_RootConstrainSelectedInstOperands,
     /*  40711 */     // GIR_Coverage, 1700,
     /*  40711 */     GIR_EraseRootFromParent_Done,
     /*  40712 */   // Label 920: @40712
     /*  40712 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40748), // Rule ID 1701 //
     /*  40717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40739 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3807:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  40742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40746 */     GIR_RootConstrainSelectedInstOperands,
     /*  40747 */     // GIR_Coverage, 1701,
     /*  40747 */     GIR_EraseRootFromParent_Done,
     /*  40748 */   // Label 921: @40748
     /*  40748 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40784), // Rule ID 1702 //
     /*  40753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40775 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3807:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  40778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40782 */     GIR_RootConstrainSelectedInstOperands,
     /*  40783 */     // GIR_Coverage, 1702,
     /*  40783 */     GIR_EraseRootFromParent_Done,
     /*  40784 */   // Label 922: @40784
     /*  40784 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40820), // Rule ID 1703 //
     /*  40789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40811 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3807:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  40814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40818 */     GIR_RootConstrainSelectedInstOperands,
     /*  40819 */     // GIR_Coverage, 1703,
     /*  40819 */     GIR_EraseRootFromParent_Done,
     /*  40820 */   // Label 923: @40820
     /*  40820 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40856), // Rule ID 1704 //
     /*  40825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40847 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /*  40850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40854 */     GIR_RootConstrainSelectedInstOperands,
     /*  40855 */     // GIR_Coverage, 1704,
     /*  40855 */     GIR_EraseRootFromParent_Done,
     /*  40856 */   // Label 924: @40856
     /*  40856 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40892), // Rule ID 1705 //
     /*  40861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40883 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3803:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /*  40886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40890 */     GIR_RootConstrainSelectedInstOperands,
     /*  40891 */     // GIR_Coverage, 1705,
     /*  40891 */     GIR_EraseRootFromParent_Done,
     /*  40892 */   // Label 925: @40892
     /*  40892 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40928), // Rule ID 1706 //
     /*  40897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40919 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /*  40922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40926 */     GIR_RootConstrainSelectedInstOperands,
     /*  40927 */     // GIR_Coverage, 1706,
     /*  40927 */     GIR_EraseRootFromParent_Done,
     /*  40928 */   // Label 926: @40928
     /*  40928 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40964), // Rule ID 1707 //
     /*  40933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40955 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3803:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /*  40958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40962 */     GIR_RootConstrainSelectedInstOperands,
     /*  40963 */     // GIR_Coverage, 1707,
     /*  40963 */     GIR_EraseRootFromParent_Done,
     /*  40964 */   // Label 927: @40964
     /*  40964 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(41000), // Rule ID 1708 //
     /*  40969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  40977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40991 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /*  40994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40998 */     GIR_RootConstrainSelectedInstOperands,
     /*  40999 */     // GIR_Coverage, 1708,
     /*  40999 */     GIR_EraseRootFromParent_Done,
     /*  41000 */   // Label 928: @41000
     /*  41000 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(41036), // Rule ID 1709 //
     /*  41005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41027 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3805:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /*  41030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41034 */     GIR_RootConstrainSelectedInstOperands,
     /*  41035 */     // GIR_Coverage, 1709,
     /*  41035 */     GIR_EraseRootFromParent_Done,
     /*  41036 */   // Label 929: @41036
     /*  41036 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(41072), // Rule ID 1710 //
     /*  41041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41063 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /*  41066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41070 */     GIR_RootConstrainSelectedInstOperands,
     /*  41071 */     // GIR_Coverage, 1710,
     /*  41071 */     GIR_EraseRootFromParent_Done,
     /*  41072 */   // Label 930: @41072
     /*  41072 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(41108), // Rule ID 1711 //
     /*  41077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41099 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3805:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /*  41102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41106 */     GIR_RootConstrainSelectedInstOperands,
     /*  41107 */     // GIR_Coverage, 1711,
     /*  41107 */     GIR_EraseRootFromParent_Done,
     /*  41108 */   // Label 931: @41108
     /*  41108 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(41144), // Rule ID 1714 //
     /*  41113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41135 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3693:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41142 */     GIR_RootConstrainSelectedInstOperands,
     /*  41143 */     // GIR_Coverage, 1714,
     /*  41143 */     GIR_EraseRootFromParent_Done,
     /*  41144 */   // Label 932: @41144
     /*  41144 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(41180), // Rule ID 1715 //
     /*  41149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41171 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3694:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41178 */     GIR_RootConstrainSelectedInstOperands,
     /*  41179 */     // GIR_Coverage, 1715,
     /*  41179 */     GIR_EraseRootFromParent_Done,
     /*  41180 */   // Label 933: @41180
     /*  41180 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(41228), // Rule ID 1848 //
     /*  41185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41207 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41226 */     GIR_RootConstrainSelectedInstOperands,
     /*  41227 */     // GIR_Coverage, 1848,
     /*  41227 */     GIR_EraseRootFromParent_Done,
     /*  41228 */   // Label 934: @41228
     /*  41228 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(41276), // Rule ID 2096 //
     /*  41233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41255 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41274 */     GIR_RootConstrainSelectedInstOperands,
     /*  41275 */     // GIR_Coverage, 2096,
     /*  41275 */     GIR_EraseRootFromParent_Done,
     /*  41276 */   // Label 935: @41276
     /*  41276 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(41342), // Rule ID 3645 //
     /*  41281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41303 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3575:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41320 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41340 */     GIR_RootConstrainSelectedInstOperands,
     /*  41341 */     // GIR_Coverage, 3645,
     /*  41341 */     GIR_EraseRootFromParent_Done,
     /*  41342 */   // Label 936: @41342
     /*  41342 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(41408), // Rule ID 3647 //
     /*  41347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41369 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3575:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41386 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41406 */     GIR_RootConstrainSelectedInstOperands,
     /*  41407 */     // GIR_Coverage, 3647,
     /*  41407 */     GIR_EraseRootFromParent_Done,
     /*  41408 */   // Label 937: @41408
     /*  41408 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(41474), // Rule ID 3649 //
     /*  41413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41435 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3575:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41452 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41472 */     GIR_RootConstrainSelectedInstOperands,
     /*  41473 */     // GIR_Coverage, 3649,
     /*  41473 */     GIR_EraseRootFromParent_Done,
     /*  41474 */   // Label 938: @41474
     /*  41474 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(41540), // Rule ID 3961 //
     /*  41479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  41482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrintn),
     /*  41487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41501 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3657:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  41501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  41516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41518 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41538 */     GIR_RootConstrainSelectedInstOperands,
     /*  41539 */     // GIR_Coverage, 3961,
     /*  41539 */     GIR_EraseRootFromParent_Done,
     /*  41540 */   // Label 939: @41540
     /*  41540 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(41606), // Rule ID 3973 //
     /*  41545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  41548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrintn),
     /*  41553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41567 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3657:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  41567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  41582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41584 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41604 */     GIR_RootConstrainSelectedInstOperands,
     /*  41605 */     // GIR_Coverage, 3973,
     /*  41605 */     GIR_EraseRootFromParent_Done,
     /*  41606 */   // Label 940: @41606
     /*  41606 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(41657), // Rule ID 4861 //
     /*  41611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41633 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3583:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41655 */     GIR_RootConstrainSelectedInstOperands,
     /*  41656 */     // GIR_Coverage, 4861,
     /*  41656 */     GIR_EraseRootFromParent_Done,
     /*  41657 */   // Label 941: @41657
     /*  41657 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(41708), // Rule ID 4863 //
     /*  41662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41684 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3580:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41706 */     GIR_RootConstrainSelectedInstOperands,
     /*  41707 */     // GIR_Coverage, 4863,
     /*  41707 */     GIR_EraseRootFromParent_Done,
     /*  41708 */   // Label 942: @41708
     /*  41708 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41759), // Rule ID 4865 //
     /*  41713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41735 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3581:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41757 */     GIR_RootConstrainSelectedInstOperands,
     /*  41758 */     // GIR_Coverage, 4865,
     /*  41758 */     GIR_EraseRootFromParent_Done,
     /*  41759 */   // Label 943: @41759
     /*  41759 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41810), // Rule ID 4867 //
     /*  41764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41786 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3582:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41808 */     GIR_RootConstrainSelectedInstOperands,
     /*  41809 */     // GIR_Coverage, 4867,
     /*  41809 */     GIR_EraseRootFromParent_Done,
     /*  41810 */   // Label 944: @41810
     /*  41810 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41856), // Rule ID 600 //
     /*  41815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41830 */     // MIs[0] Rn
     /*  41830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41838 */     // (intrinsic_wo_chain:{ *:[i32] } 3465:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41854 */     GIR_RootConstrainSelectedInstOperands,
     /*  41855 */     // GIR_Coverage, 600,
     /*  41855 */     GIR_EraseRootFromParent_Done,
     /*  41856 */   // Label 945: @41856
     /*  41856 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41902), // Rule ID 601 //
     /*  41861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41876 */     // MIs[0] Rn
     /*  41876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41884 */     // (intrinsic_wo_chain:{ *:[i32] } 3468:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41900 */     GIR_RootConstrainSelectedInstOperands,
     /*  41901 */     // GIR_Coverage, 601,
     /*  41901 */     GIR_EraseRootFromParent_Done,
     /*  41902 */   // Label 946: @41902
     /*  41902 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41948), // Rule ID 602 //
     /*  41907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41922 */     // MIs[0] Rn
     /*  41922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41930 */     // (intrinsic_wo_chain:{ *:[i32] } 3466:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41946 */     GIR_RootConstrainSelectedInstOperands,
     /*  41947 */     // GIR_Coverage, 602,
     /*  41947 */     GIR_EraseRootFromParent_Done,
     /*  41948 */   // Label 947: @41948
     /*  41948 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(41994), // Rule ID 603 //
     /*  41953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41968 */     // MIs[0] Rn
     /*  41968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41976 */     // (intrinsic_wo_chain:{ *:[i32] } 3467:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41992 */     GIR_RootConstrainSelectedInstOperands,
     /*  41993 */     // GIR_Coverage, 603,
     /*  41993 */     GIR_EraseRootFromParent_Done,
     /*  41994 */   // Label 948: @41994
     /*  41994 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(42129), // Rule ID 2690 //
     /*  41999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  42007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  42017 */     // (intrinsic_wo_chain:{ *:[i32] } 3701:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  42017 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  42020 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42024 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42029 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  42033 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42038 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  42041 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  42045 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42050 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  42053 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  42056 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  42059 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  42064 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42069 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  42072 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  42076 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42081 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  42086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42098 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  42105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  42128 */     // GIR_Coverage, 2690,
     /*  42128 */     GIR_EraseRootFromParent_Done,
     /*  42129 */   // Label 949: @42129
     /*  42129 */   GIM_Reject,
     /*  42130 */ // Label 813: @42130
     /*  42130 */ GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(62684),
     /*  42135 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  42138 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(42195), // Rule ID 2114 //
     /*  42143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  42151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42172 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  42172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  42175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42193 */     GIR_RootConstrainSelectedInstOperands,
     /*  42194 */     // GIR_Coverage, 2114,
     /*  42194 */     GIR_EraseRootFromParent_Done,
     /*  42195 */   // Label 951: @42195
     /*  42195 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(42294), // Rule ID 1885 //
     /*  42200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  42203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42250 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42254 */     // MIs[2] Operand 1
     /*  42254 */     // No operand predicates
     /*  42254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42262 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42266 */     // MIs[3] Operand 1
     /*  42266 */     // No operand predicates
     /*  42266 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42268 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42292 */     GIR_RootConstrainSelectedInstOperands,
     /*  42293 */     // GIR_Coverage, 1885,
     /*  42293 */     GIR_EraseRootFromParent_Done,
     /*  42294 */   // Label 952: @42294
     /*  42294 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(42393), // Rule ID 2151 //
     /*  42299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42349 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42353 */     // MIs[2] Operand 1
     /*  42353 */     // No operand predicates
     /*  42353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42361 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42365 */     // MIs[3] Operand 1
     /*  42365 */     // No operand predicates
     /*  42365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42367 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42391 */     GIR_RootConstrainSelectedInstOperands,
     /*  42392 */     // GIR_Coverage, 2151,
     /*  42392 */     GIR_EraseRootFromParent_Done,
     /*  42393 */   // Label 953: @42393
     /*  42393 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(42477), // Rule ID 5427 //
     /*  42398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42427 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42430 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42444 */     // MIs[1] Rn
     /*  42444 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42455 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42475 */     GIR_RootConstrainSelectedInstOperands,
     /*  42476 */     // GIR_Coverage, 5427,
     /*  42476 */     GIR_EraseRootFromParent_Done,
     /*  42477 */   // Label 954: @42477
     /*  42477 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(42561), // Rule ID 5684 //
     /*  42482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42511 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42514 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42528 */     // MIs[1] Rn
     /*  42528 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42539 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42559 */     GIR_RootConstrainSelectedInstOperands,
     /*  42560 */     // GIR_Coverage, 5684,
     /*  42560 */     GIR_EraseRootFromParent_Done,
     /*  42561 */   // Label 955: @42561
     /*  42561 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(42645), // Rule ID 109 //
     /*  42566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42599 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42602 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42616 */     // MIs[1] Rn
     /*  42616 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42623 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42643 */     GIR_RootConstrainSelectedInstOperands,
     /*  42644 */     // GIR_Coverage, 109,
     /*  42644 */     GIR_EraseRootFromParent_Done,
     /*  42645 */   // Label 956: @42645
     /*  42645 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(42729), // Rule ID 110 //
     /*  42650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42683 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42686 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42700 */     // MIs[1] Rn
     /*  42700 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42707 */     // (intrinsic_wo_chain:{ *:[i32] } 3840:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42727 */     GIR_RootConstrainSelectedInstOperands,
     /*  42728 */     // GIR_Coverage, 110,
     /*  42728 */     GIR_EraseRootFromParent_Done,
     /*  42729 */   // Label 957: @42729
     /*  42729 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(42813), // Rule ID 2129 //
     /*  42734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42767 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42770 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42784 */     // MIs[1] Rn
     /*  42784 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42791 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42811 */     GIR_RootConstrainSelectedInstOperands,
     /*  42812 */     // GIR_Coverage, 2129,
     /*  42812 */     GIR_EraseRootFromParent_Done,
     /*  42813 */   // Label 958: @42813
     /*  42813 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(42897), // Rule ID 2130 //
     /*  42818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42851 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42854 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42868 */     // MIs[1] Rn
     /*  42868 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42875 */     // (intrinsic_wo_chain:{ *:[i32] } 3840:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42895 */     GIR_RootConstrainSelectedInstOperands,
     /*  42896 */     // GIR_Coverage, 2130,
     /*  42896 */     GIR_EraseRootFromParent_Done,
     /*  42897 */   // Label 959: @42897
     /*  42897 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(42970), // Rule ID 4055 //
     /*  42902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42931 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3591:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42948 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42968 */     GIR_RootConstrainSelectedInstOperands,
     /*  42969 */     // GIR_Coverage, 4055,
     /*  42969 */     GIR_EraseRootFromParent_Done,
     /*  42970 */   // Label 960: @42970
     /*  42970 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(43043), // Rule ID 4057 //
     /*  42975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43004 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3595:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  43019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43021 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43041 */     GIR_RootConstrainSelectedInstOperands,
     /*  43042 */     // GIR_Coverage, 4057,
     /*  43042 */     GIR_EraseRootFromParent_Done,
     /*  43043 */   // Label 961: @43043
     /*  43043 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(43116), // Rule ID 4059 //
     /*  43048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43077 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3597:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  43092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43094 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43114 */     GIR_RootConstrainSelectedInstOperands,
     /*  43115 */     // GIR_Coverage, 4059,
     /*  43115 */     GIR_EraseRootFromParent_Done,
     /*  43116 */   // Label 962: @43116
     /*  43116 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(43189), // Rule ID 4061 //
     /*  43121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43150 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3593:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  43165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43167 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43172 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43187 */     GIR_RootConstrainSelectedInstOperands,
     /*  43188 */     // GIR_Coverage, 4061,
     /*  43188 */     GIR_EraseRootFromParent_Done,
     /*  43189 */   // Label 963: @43189
     /*  43189 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(43262), // Rule ID 4063 //
     /*  43194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43215 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43223 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3591:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43240 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43260 */     GIR_RootConstrainSelectedInstOperands,
     /*  43261 */     // GIR_Coverage, 4063,
     /*  43261 */     GIR_EraseRootFromParent_Done,
     /*  43262 */   // Label 964: @43262
     /*  43262 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(43335), // Rule ID 4065 //
     /*  43267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43296 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3595:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43313 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43318 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43333 */     GIR_RootConstrainSelectedInstOperands,
     /*  43334 */     // GIR_Coverage, 4065,
     /*  43334 */     GIR_EraseRootFromParent_Done,
     /*  43335 */   // Label 965: @43335
     /*  43335 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(43408), // Rule ID 4067 //
     /*  43340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43369 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3597:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43386 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43406 */     GIR_RootConstrainSelectedInstOperands,
     /*  43407 */     // GIR_Coverage, 4067,
     /*  43407 */     GIR_EraseRootFromParent_Done,
     /*  43408 */   // Label 966: @43408
     /*  43408 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(43481), // Rule ID 4069 //
     /*  43413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43442 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3593:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43459 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43479 */     GIR_RootConstrainSelectedInstOperands,
     /*  43480 */     // GIR_Coverage, 4069,
     /*  43480 */     GIR_EraseRootFromParent_Done,
     /*  43481 */   // Label 967: @43481
     /*  43481 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(43554), // Rule ID 4071 //
     /*  43486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43515 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3591:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43532 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43552 */     GIR_RootConstrainSelectedInstOperands,
     /*  43553 */     // GIR_Coverage, 4071,
     /*  43553 */     GIR_EraseRootFromParent_Done,
     /*  43554 */   // Label 968: @43554
     /*  43554 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(43627), // Rule ID 4073 //
     /*  43559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3595:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43605 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43625 */     GIR_RootConstrainSelectedInstOperands,
     /*  43626 */     // GIR_Coverage, 4073,
     /*  43626 */     GIR_EraseRootFromParent_Done,
     /*  43627 */   // Label 969: @43627
     /*  43627 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(43700), // Rule ID 4075 //
     /*  43632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43661 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3597:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43678 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43698 */     GIR_RootConstrainSelectedInstOperands,
     /*  43699 */     // GIR_Coverage, 4075,
     /*  43699 */     GIR_EraseRootFromParent_Done,
     /*  43700 */   // Label 970: @43700
     /*  43700 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(43773), // Rule ID 4077 //
     /*  43705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43734 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3593:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43751 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43771 */     GIR_RootConstrainSelectedInstOperands,
     /*  43772 */     // GIR_Coverage, 4077,
     /*  43772 */     GIR_EraseRootFromParent_Done,
     /*  43773 */   // Label 971: @43773
     /*  43773 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(43846), // Rule ID 4079 //
     /*  43778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43799 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43807 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3591:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43824 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43844 */     GIR_RootConstrainSelectedInstOperands,
     /*  43845 */     // GIR_Coverage, 4079,
     /*  43845 */     GIR_EraseRootFromParent_Done,
     /*  43846 */   // Label 972: @43846
     /*  43846 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(43919), // Rule ID 4081 //
     /*  43851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43872 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43880 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3595:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43897 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43917 */     GIR_RootConstrainSelectedInstOperands,
     /*  43918 */     // GIR_Coverage, 4081,
     /*  43918 */     GIR_EraseRootFromParent_Done,
     /*  43919 */   // Label 973: @43919
     /*  43919 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(43992), // Rule ID 4083 //
     /*  43924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43945 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43953 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3597:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43970 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43990 */     GIR_RootConstrainSelectedInstOperands,
     /*  43991 */     // GIR_Coverage, 4083,
     /*  43991 */     GIR_EraseRootFromParent_Done,
     /*  43992 */   // Label 974: @43992
     /*  43992 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(44065), // Rule ID 4085 //
     /*  43997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  44005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44026 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3593:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  44041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44043 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44063 */     GIR_RootConstrainSelectedInstOperands,
     /*  44064 */     // GIR_Coverage, 4085,
     /*  44064 */     GIR_EraseRootFromParent_Done,
     /*  44065 */   // Label 975: @44065
     /*  44065 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(44138), // Rule ID 4529 //
     /*  44070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  44099 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3589:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  44114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44127 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44136 */     GIR_RootConstrainSelectedInstOperands,
     /*  44137 */     // GIR_Coverage, 4529,
     /*  44137 */     GIR_EraseRootFromParent_Done,
     /*  44138 */   // Label 976: @44138
     /*  44138 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(44211), // Rule ID 4535 //
     /*  44143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  44172 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3589:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  44187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44209 */     GIR_RootConstrainSelectedInstOperands,
     /*  44210 */     // GIR_Coverage, 4535,
     /*  44210 */     GIR_EraseRootFromParent_Done,
     /*  44211 */   // Label 977: @44211
     /*  44211 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(44279), // Rule ID 1878 //
     /*  44216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44253 */     // MIs[1] Operand 1
     /*  44253 */     // No operand predicates
     /*  44253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44255 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44263 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44277 */     GIR_RootConstrainSelectedInstOperands,
     /*  44278 */     // GIR_Coverage, 1878,
     /*  44278 */     GIR_EraseRootFromParent_Done,
     /*  44279 */   // Label 978: @44279
     /*  44279 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(44344), // Rule ID 1882 //
     /*  44284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44321 */     // MIs[1] Operand 1
     /*  44321 */     // No operand predicates
     /*  44321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44323 */     // (intrinsic_wo_chain:{ *:[i32] } 3913:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44331 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44342 */     GIR_RootConstrainSelectedInstOperands,
     /*  44343 */     // GIR_Coverage, 1882,
     /*  44343 */     GIR_EraseRootFromParent_Done,
     /*  44344 */   // Label 979: @44344
     /*  44344 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(44412), // Rule ID 2146 //
     /*  44349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44382 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44386 */     // MIs[1] Operand 1
     /*  44386 */     // No operand predicates
     /*  44386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44388 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44396 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44410 */     GIR_RootConstrainSelectedInstOperands,
     /*  44411 */     // GIR_Coverage, 2146,
     /*  44411 */     GIR_EraseRootFromParent_Done,
     /*  44412 */   // Label 980: @44412
     /*  44412 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(44477), // Rule ID 2148 //
     /*  44417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44454 */     // MIs[1] Operand 1
     /*  44454 */     // No operand predicates
     /*  44454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44456 */     // (intrinsic_wo_chain:{ *:[i32] } 3913:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44464 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44475 */     GIR_RootConstrainSelectedInstOperands,
     /*  44476 */     // GIR_Coverage, 2148,
     /*  44476 */     GIR_EraseRootFromParent_Done,
     /*  44477 */   // Label 981: @44477
     /*  44477 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(44560), // Rule ID 3925 //
     /*  44482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44516 */     // MIs[1] Operand 1
     /*  44516 */     // No operand predicates
     /*  44516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44518 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3650:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44535 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44558 */     GIR_RootConstrainSelectedInstOperands,
     /*  44559 */     // GIR_Coverage, 3925,
     /*  44559 */     GIR_EraseRootFromParent_Done,
     /*  44560 */   // Label 982: @44560
     /*  44560 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(44643), // Rule ID 3927 //
     /*  44565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44599 */     // MIs[1] Operand 1
     /*  44599 */     // No operand predicates
     /*  44599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44601 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3650:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44618 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44641 */     GIR_RootConstrainSelectedInstOperands,
     /*  44642 */     // GIR_Coverage, 3927,
     /*  44642 */     GIR_EraseRootFromParent_Done,
     /*  44643 */   // Label 983: @44643
     /*  44643 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(44726), // Rule ID 3929 //
     /*  44648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44682 */     // MIs[1] Operand 1
     /*  44682 */     // No operand predicates
     /*  44682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44684 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3650:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44701 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44724 */     GIR_RootConstrainSelectedInstOperands,
     /*  44725 */     // GIR_Coverage, 3929,
     /*  44725 */     GIR_EraseRootFromParent_Done,
     /*  44726 */   // Label 984: @44726
     /*  44726 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(44787), // Rule ID 1649 //
     /*  44731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44764 */     // MIs[1] Operand 1
     /*  44764 */     // No operand predicates
     /*  44764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44766 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3728:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44785 */     GIR_RootConstrainSelectedInstOperands,
     /*  44786 */     // GIR_Coverage, 1649,
     /*  44786 */     GIR_EraseRootFromParent_Done,
     /*  44787 */   // Label 985: @44787
     /*  44787 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(44848), // Rule ID 1650 //
     /*  44792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44825 */     // MIs[1] Operand 1
     /*  44825 */     // No operand predicates
     /*  44825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44827 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3729:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44840 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44846 */     GIR_RootConstrainSelectedInstOperands,
     /*  44847 */     // GIR_Coverage, 1650,
     /*  44847 */     GIR_EraseRootFromParent_Done,
     /*  44848 */   // Label 986: @44848
     /*  44848 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(44909), // Rule ID 1651 //
     /*  44853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44886 */     // MIs[1] Operand 1
     /*  44886 */     // No operand predicates
     /*  44886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44888 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3731:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44907 */     GIR_RootConstrainSelectedInstOperands,
     /*  44908 */     // GIR_Coverage, 1651,
     /*  44908 */     GIR_EraseRootFromParent_Done,
     /*  44909 */   // Label 987: @44909
     /*  44909 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44970), // Rule ID 1652 //
     /*  44914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44947 */     // MIs[1] Operand 1
     /*  44947 */     // No operand predicates
     /*  44947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44949 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3732:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44968 */     GIR_RootConstrainSelectedInstOperands,
     /*  44969 */     // GIR_Coverage, 1652,
     /*  44969 */     GIR_EraseRootFromParent_Done,
     /*  44970 */   // Label 988: @44970
     /*  44970 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(45031), // Rule ID 1653 //
     /*  44975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45008 */     // MIs[1] Operand 1
     /*  45008 */     // No operand predicates
     /*  45008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45010 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3728:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  45013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45029 */     GIR_RootConstrainSelectedInstOperands,
     /*  45030 */     // GIR_Coverage, 1653,
     /*  45030 */     GIR_EraseRootFromParent_Done,
     /*  45031 */   // Label 989: @45031
     /*  45031 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(45092), // Rule ID 1654 //
     /*  45036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45069 */     // MIs[1] Operand 1
     /*  45069 */     // No operand predicates
     /*  45069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45071 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3729:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  45074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45084 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45090 */     GIR_RootConstrainSelectedInstOperands,
     /*  45091 */     // GIR_Coverage, 1654,
     /*  45091 */     GIR_EraseRootFromParent_Done,
     /*  45092 */   // Label 990: @45092
     /*  45092 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(45153), // Rule ID 1655 //
     /*  45097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45130 */     // MIs[1] Operand 1
     /*  45130 */     // No operand predicates
     /*  45130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45132 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3731:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  45135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45151 */     GIR_RootConstrainSelectedInstOperands,
     /*  45152 */     // GIR_Coverage, 1655,
     /*  45152 */     GIR_EraseRootFromParent_Done,
     /*  45153 */   // Label 991: @45153
     /*  45153 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(45214), // Rule ID 1656 //
     /*  45158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45191 */     // MIs[1] Operand 1
     /*  45191 */     // No operand predicates
     /*  45191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45193 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3732:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  45196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45212 */     GIR_RootConstrainSelectedInstOperands,
     /*  45213 */     // GIR_Coverage, 1656,
     /*  45213 */     GIR_EraseRootFromParent_Done,
     /*  45214 */   // Label 992: @45214
     /*  45214 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(45275), // Rule ID 1657 //
     /*  45219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45252 */     // MIs[1] Operand 1
     /*  45252 */     // No operand predicates
     /*  45252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45254 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3728:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45273 */     GIR_RootConstrainSelectedInstOperands,
     /*  45274 */     // GIR_Coverage, 1657,
     /*  45274 */     GIR_EraseRootFromParent_Done,
     /*  45275 */   // Label 993: @45275
     /*  45275 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(45336), // Rule ID 1658 //
     /*  45280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45313 */     // MIs[1] Operand 1
     /*  45313 */     // No operand predicates
     /*  45313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45315 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3729:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45334 */     GIR_RootConstrainSelectedInstOperands,
     /*  45335 */     // GIR_Coverage, 1658,
     /*  45335 */     GIR_EraseRootFromParent_Done,
     /*  45336 */   // Label 994: @45336
     /*  45336 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(45397), // Rule ID 1659 //
     /*  45341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45374 */     // MIs[1] Operand 1
     /*  45374 */     // No operand predicates
     /*  45374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45376 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3731:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45395 */     GIR_RootConstrainSelectedInstOperands,
     /*  45396 */     // GIR_Coverage, 1659,
     /*  45396 */     GIR_EraseRootFromParent_Done,
     /*  45397 */   // Label 995: @45397
     /*  45397 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(45458), // Rule ID 1660 //
     /*  45402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45435 */     // MIs[1] Operand 1
     /*  45435 */     // No operand predicates
     /*  45435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45437 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3732:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45456 */     GIR_RootConstrainSelectedInstOperands,
     /*  45457 */     // GIR_Coverage, 1660,
     /*  45457 */     GIR_EraseRootFromParent_Done,
     /*  45458 */   // Label 996: @45458
     /*  45458 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(45519), // Rule ID 1661 //
     /*  45463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45496 */     // MIs[1] Operand 1
     /*  45496 */     // No operand predicates
     /*  45496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45498 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3728:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45517 */     GIR_RootConstrainSelectedInstOperands,
     /*  45518 */     // GIR_Coverage, 1661,
     /*  45518 */     GIR_EraseRootFromParent_Done,
     /*  45519 */   // Label 997: @45519
     /*  45519 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(45580), // Rule ID 1662 //
     /*  45524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45557 */     // MIs[1] Operand 1
     /*  45557 */     // No operand predicates
     /*  45557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45559 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3729:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45578 */     GIR_RootConstrainSelectedInstOperands,
     /*  45579 */     // GIR_Coverage, 1662,
     /*  45579 */     GIR_EraseRootFromParent_Done,
     /*  45580 */   // Label 998: @45580
     /*  45580 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(45641), // Rule ID 1663 //
     /*  45585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45618 */     // MIs[1] Operand 1
     /*  45618 */     // No operand predicates
     /*  45618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45620 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3731:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45639 */     GIR_RootConstrainSelectedInstOperands,
     /*  45640 */     // GIR_Coverage, 1663,
     /*  45640 */     GIR_EraseRootFromParent_Done,
     /*  45641 */   // Label 999: @45641
     /*  45641 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(45702), // Rule ID 1664 //
     /*  45646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45679 */     // MIs[1] Operand 1
     /*  45679 */     // No operand predicates
     /*  45679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45681 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3732:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45688 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45700 */     GIR_RootConstrainSelectedInstOperands,
     /*  45701 */     // GIR_Coverage, 1664,
     /*  45701 */     GIR_EraseRootFromParent_Done,
     /*  45702 */   // Label 1000: @45702
     /*  45702 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(45763), // Rule ID 1722 //
     /*  45707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45740 */     // MIs[1] Operand 1
     /*  45740 */     // No operand predicates
     /*  45740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45742 */     // (intrinsic_wo_chain:{ *:[i32] } 3555:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45747 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45761 */     GIR_RootConstrainSelectedInstOperands,
     /*  45762 */     // GIR_Coverage, 1722,
     /*  45762 */     GIR_EraseRootFromParent_Done,
     /*  45763 */   // Label 1001: @45763
     /*  45763 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45824), // Rule ID 1723 //
     /*  45768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45801 */     // MIs[1] Operand 1
     /*  45801 */     // No operand predicates
     /*  45801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45803 */     // (intrinsic_wo_chain:{ *:[i32] } 3557:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45808 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45822 */     GIR_RootConstrainSelectedInstOperands,
     /*  45823 */     // GIR_Coverage, 1723,
     /*  45823 */     GIR_EraseRootFromParent_Done,
     /*  45824 */   // Label 1002: @45824
     /*  45824 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45885), // Rule ID 1724 //
     /*  45829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45862 */     // MIs[1] Operand 1
     /*  45862 */     // No operand predicates
     /*  45862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45864 */     // (intrinsic_wo_chain:{ *:[i32] } 3562:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45869 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45883 */     GIR_RootConstrainSelectedInstOperands,
     /*  45884 */     // GIR_Coverage, 1724,
     /*  45884 */     GIR_EraseRootFromParent_Done,
     /*  45885 */   // Label 1003: @45885
     /*  45885 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45946), // Rule ID 1725 //
     /*  45890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45923 */     // MIs[1] Operand 1
     /*  45923 */     // No operand predicates
     /*  45923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45925 */     // (intrinsic_wo_chain:{ *:[i32] } 3564:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45930 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45938 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45944 */     GIR_RootConstrainSelectedInstOperands,
     /*  45945 */     // GIR_Coverage, 1725,
     /*  45945 */     GIR_EraseRootFromParent_Done,
     /*  45946 */   // Label 1004: @45946
     /*  45946 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(46000), // Rule ID 105 //
     /*  45951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45980 */     // (intrinsic_wo_chain:{ *:[i32] } 3837:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45998 */     GIR_RootConstrainSelectedInstOperands,
     /*  45999 */     // GIR_Coverage, 105,
     /*  45999 */     GIR_EraseRootFromParent_Done,
     /*  46000 */   // Label 1005: @46000
     /*  46000 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(46054), // Rule ID 106 //
     /*  46005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  46013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46034 */     // (intrinsic_wo_chain:{ *:[i32] } 3836:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  46037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46052 */     GIR_RootConstrainSelectedInstOperands,
     /*  46053 */     // GIR_Coverage, 106,
     /*  46053 */     GIR_EraseRootFromParent_Done,
     /*  46054 */   // Label 1006: @46054
     /*  46054 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(46108), // Rule ID 107 //
     /*  46059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  46067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46088 */     // (intrinsic_wo_chain:{ *:[i32] } 3841:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  46091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46106 */     GIR_RootConstrainSelectedInstOperands,
     /*  46107 */     // GIR_Coverage, 107,
     /*  46107 */     GIR_EraseRootFromParent_Done,
     /*  46108 */   // Label 1007: @46108
     /*  46108 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(46162), // Rule ID 108 //
     /*  46113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  46121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46142 */     // (intrinsic_wo_chain:{ *:[i32] } 3842:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  46145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46160 */     GIR_RootConstrainSelectedInstOperands,
     /*  46161 */     // GIR_Coverage, 108,
     /*  46161 */     GIR_EraseRootFromParent_Done,
     /*  46162 */   // Label 1008: @46162
     /*  46162 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(46216), // Rule ID 111 //
     /*  46167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  46175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46196 */     // (intrinsic_wo_chain:{ *:[i32] } 3840:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  46199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46214 */     GIR_RootConstrainSelectedInstOperands,
     /*  46215 */     // GIR_Coverage, 111,
     /*  46215 */     GIR_EraseRootFromParent_Done,
     /*  46216 */   // Label 1009: @46216
     /*  46216 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(46270), // Rule ID 112 //
     /*  46221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46250 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46268 */     GIR_RootConstrainSelectedInstOperands,
     /*  46269 */     // GIR_Coverage, 112,
     /*  46269 */     GIR_EraseRootFromParent_Done,
     /*  46270 */   // Label 1010: @46270
     /*  46270 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(46324), // Rule ID 113 //
     /*  46275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46304 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46322 */     GIR_RootConstrainSelectedInstOperands,
     /*  46323 */     // GIR_Coverage, 113,
     /*  46323 */     GIR_EraseRootFromParent_Done,
     /*  46324 */   // Label 1011: @46324
     /*  46324 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(46378), // Rule ID 114 //
     /*  46329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46358 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46376 */     GIR_RootConstrainSelectedInstOperands,
     /*  46377 */     // GIR_Coverage, 114,
     /*  46377 */     GIR_EraseRootFromParent_Done,
     /*  46378 */   // Label 1012: @46378
     /*  46378 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(46432), // Rule ID 115 //
     /*  46383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46412 */     // (intrinsic_wo_chain:{ *:[i32] } 3908:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46430 */     GIR_RootConstrainSelectedInstOperands,
     /*  46431 */     // GIR_Coverage, 115,
     /*  46431 */     GIR_EraseRootFromParent_Done,
     /*  46432 */   // Label 1013: @46432
     /*  46432 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(46486), // Rule ID 116 //
     /*  46437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46466 */     // (intrinsic_wo_chain:{ *:[i32] } 3909:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46484 */     GIR_RootConstrainSelectedInstOperands,
     /*  46485 */     // GIR_Coverage, 116,
     /*  46485 */     GIR_EraseRootFromParent_Done,
     /*  46486 */   // Label 1014: @46486
     /*  46486 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(46540), // Rule ID 117 //
     /*  46491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46520 */     // (intrinsic_wo_chain:{ *:[i32] } 3838:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46538 */     GIR_RootConstrainSelectedInstOperands,
     /*  46539 */     // GIR_Coverage, 117,
     /*  46539 */     GIR_EraseRootFromParent_Done,
     /*  46540 */   // Label 1015: @46540
     /*  46540 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(46594), // Rule ID 118 //
     /*  46545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46574 */     // (intrinsic_wo_chain:{ *:[i32] } 3839:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46592 */     GIR_RootConstrainSelectedInstOperands,
     /*  46593 */     // GIR_Coverage, 118,
     /*  46593 */     GIR_EraseRootFromParent_Done,
     /*  46594 */   // Label 1016: @46594
     /*  46594 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(46648), // Rule ID 119 //
     /*  46599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46628 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46646 */     GIR_RootConstrainSelectedInstOperands,
     /*  46647 */     // GIR_Coverage, 119,
     /*  46647 */     GIR_EraseRootFromParent_Done,
     /*  46648 */   // Label 1017: @46648
     /*  46648 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(46702), // Rule ID 120 //
     /*  46653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46682 */     // (intrinsic_wo_chain:{ *:[i32] } 3907:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46700 */     GIR_RootConstrainSelectedInstOperands,
     /*  46701 */     // GIR_Coverage, 120,
     /*  46701 */     GIR_EraseRootFromParent_Done,
     /*  46702 */   // Label 1018: @46702
     /*  46702 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46756), // Rule ID 133 //
     /*  46707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46736 */     // (intrinsic_wo_chain:{ *:[i32] } 3850:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46754 */     GIR_RootConstrainSelectedInstOperands,
     /*  46755 */     // GIR_Coverage, 133,
     /*  46755 */     GIR_EraseRootFromParent_Done,
     /*  46756 */   // Label 1019: @46756
     /*  46756 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46810), // Rule ID 134 //
     /*  46761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46790 */     // (intrinsic_wo_chain:{ *:[i32] } 3848:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46808 */     GIR_RootConstrainSelectedInstOperands,
     /*  46809 */     // GIR_Coverage, 134,
     /*  46809 */     GIR_EraseRootFromParent_Done,
     /*  46810 */   // Label 1020: @46810
     /*  46810 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46864), // Rule ID 135 //
     /*  46815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46844 */     // (intrinsic_wo_chain:{ *:[i32] } 3849:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46862 */     GIR_RootConstrainSelectedInstOperands,
     /*  46863 */     // GIR_Coverage, 135,
     /*  46863 */     GIR_EraseRootFromParent_Done,
     /*  46864 */   // Label 1021: @46864
     /*  46864 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46918), // Rule ID 136 //
     /*  46869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46898 */     // (intrinsic_wo_chain:{ *:[i32] } 3851:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46916 */     GIR_RootConstrainSelectedInstOperands,
     /*  46917 */     // GIR_Coverage, 136,
     /*  46917 */     GIR_EraseRootFromParent_Done,
     /*  46918 */   // Label 1022: @46918
     /*  46918 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46972), // Rule ID 137 //
     /*  46923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46952 */     // (intrinsic_wo_chain:{ *:[i32] } 3852:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46970 */     GIR_RootConstrainSelectedInstOperands,
     /*  46971 */     // GIR_Coverage, 137,
     /*  46971 */     GIR_EraseRootFromParent_Done,
     /*  46972 */   // Label 1023: @46972
     /*  46972 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(47026), // Rule ID 138 //
     /*  46977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47006 */     // (intrinsic_wo_chain:{ *:[i32] } 3853:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  47009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47024 */     GIR_RootConstrainSelectedInstOperands,
     /*  47025 */     // GIR_Coverage, 138,
     /*  47025 */     GIR_EraseRootFromParent_Done,
     /*  47026 */   // Label 1024: @47026
     /*  47026 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(47080), // Rule ID 139 //
     /*  47031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  47039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47060 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  47063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47078 */     GIR_RootConstrainSelectedInstOperands,
     /*  47079 */     // GIR_Coverage, 139,
     /*  47079 */     GIR_EraseRootFromParent_Done,
     /*  47080 */   // Label 1025: @47080
     /*  47080 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(47134), // Rule ID 140 //
     /*  47085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  47093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47114 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  47117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47132 */     GIR_RootConstrainSelectedInstOperands,
     /*  47133 */     // GIR_Coverage, 140,
     /*  47133 */     GIR_EraseRootFromParent_Done,
     /*  47134 */   // Label 1026: @47134
     /*  47134 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(47188), // Rule ID 141 //
     /*  47139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  47147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47168 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  47171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47186 */     GIR_RootConstrainSelectedInstOperands,
     /*  47187 */     // GIR_Coverage, 141,
     /*  47187 */     GIR_EraseRootFromParent_Done,
     /*  47188 */   // Label 1027: @47188
     /*  47188 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(47242), // Rule ID 142 //
     /*  47193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  47201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47222 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47240 */     GIR_RootConstrainSelectedInstOperands,
     /*  47241 */     // GIR_Coverage, 142,
     /*  47241 */     GIR_EraseRootFromParent_Done,
     /*  47242 */   // Label 1028: @47242
     /*  47242 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(47296), // Rule ID 143 //
     /*  47247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47276 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47294 */     GIR_RootConstrainSelectedInstOperands,
     /*  47295 */     // GIR_Coverage, 143,
     /*  47295 */     GIR_EraseRootFromParent_Done,
     /*  47296 */   // Label 1029: @47296
     /*  47296 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(47350), // Rule ID 144 //
     /*  47301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47330 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47348 */     GIR_RootConstrainSelectedInstOperands,
     /*  47349 */     // GIR_Coverage, 144,
     /*  47349 */     GIR_EraseRootFromParent_Done,
     /*  47350 */   // Label 1030: @47350
     /*  47350 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(47404), // Rule ID 145 //
     /*  47355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47384 */     // (intrinsic_wo_chain:{ *:[i32] } 3910:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47402 */     GIR_RootConstrainSelectedInstOperands,
     /*  47403 */     // GIR_Coverage, 145,
     /*  47403 */     GIR_EraseRootFromParent_Done,
     /*  47404 */   // Label 1031: @47404
     /*  47404 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(47449), // Rule ID 204 //
     /*  47409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47438 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47447 */     GIR_RootConstrainSelectedInstOperands,
     /*  47448 */     // GIR_Coverage, 204,
     /*  47448 */     GIR_EraseRootFromParent_Done,
     /*  47449 */   // Label 1032: @47449
     /*  47449 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(47494), // Rule ID 205 //
     /*  47454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47483 */     // (intrinsic_wo_chain:{ *:[i32] } 3470:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47492 */     GIR_RootConstrainSelectedInstOperands,
     /*  47493 */     // GIR_Coverage, 205,
     /*  47493 */     GIR_EraseRootFromParent_Done,
     /*  47494 */   // Label 1033: @47494
     /*  47494 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(47539), // Rule ID 206 //
     /*  47499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47528 */     // (intrinsic_wo_chain:{ *:[i32] } 3473:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47537 */     GIR_RootConstrainSelectedInstOperands,
     /*  47538 */     // GIR_Coverage, 206,
     /*  47538 */     GIR_EraseRootFromParent_Done,
     /*  47539 */   // Label 1034: @47539
     /*  47539 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(47584), // Rule ID 207 //
     /*  47544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47573 */     // (intrinsic_wo_chain:{ *:[i32] } 3471:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47582 */     GIR_RootConstrainSelectedInstOperands,
     /*  47583 */     // GIR_Coverage, 207,
     /*  47583 */     GIR_EraseRootFromParent_Done,
     /*  47584 */   // Label 1035: @47584
     /*  47584 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(47629), // Rule ID 208 //
     /*  47589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47618 */     // (intrinsic_wo_chain:{ *:[i32] } 3474:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47627 */     GIR_RootConstrainSelectedInstOperands,
     /*  47628 */     // GIR_Coverage, 208,
     /*  47628 */     GIR_EraseRootFromParent_Done,
     /*  47629 */   // Label 1036: @47629
     /*  47629 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(47674), // Rule ID 209 //
     /*  47634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47663 */     // (intrinsic_wo_chain:{ *:[i32] } 3472:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47672 */     GIR_RootConstrainSelectedInstOperands,
     /*  47673 */     // GIR_Coverage, 209,
     /*  47673 */     GIR_EraseRootFromParent_Done,
     /*  47674 */   // Label 1037: @47674
     /*  47674 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47728), // Rule ID 432 //
     /*  47679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47708 */     // (intrinsic_wo_chain:{ *:[i32] } 3836:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47726 */     GIR_RootConstrainSelectedInstOperands,
     /*  47727 */     // GIR_Coverage, 432,
     /*  47727 */     GIR_EraseRootFromParent_Done,
     /*  47728 */   // Label 1038: @47728
     /*  47728 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47782), // Rule ID 433 //
     /*  47733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47762 */     // (intrinsic_wo_chain:{ *:[i32] } 3837:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47780 */     GIR_RootConstrainSelectedInstOperands,
     /*  47781 */     // GIR_Coverage, 433,
     /*  47781 */     GIR_EraseRootFromParent_Done,
     /*  47782 */   // Label 1039: @47782
     /*  47782 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47836), // Rule ID 434 //
     /*  47787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47816 */     // (intrinsic_wo_chain:{ *:[i32] } 3838:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47834 */     GIR_RootConstrainSelectedInstOperands,
     /*  47835 */     // GIR_Coverage, 434,
     /*  47835 */     GIR_EraseRootFromParent_Done,
     /*  47836 */   // Label 1040: @47836
     /*  47836 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47890), // Rule ID 435 //
     /*  47841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47870 */     // (intrinsic_wo_chain:{ *:[i32] } 3909:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47888 */     GIR_RootConstrainSelectedInstOperands,
     /*  47889 */     // GIR_Coverage, 435,
     /*  47889 */     GIR_EraseRootFromParent_Done,
     /*  47890 */   // Label 1041: @47890
     /*  47890 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47944), // Rule ID 436 //
     /*  47895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47924 */     // (intrinsic_wo_chain:{ *:[i32] } 3839:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47942 */     GIR_RootConstrainSelectedInstOperands,
     /*  47943 */     // GIR_Coverage, 436,
     /*  47943 */     GIR_EraseRootFromParent_Done,
     /*  47944 */   // Label 1042: @47944
     /*  47944 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(47998), // Rule ID 437 //
     /*  47949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47978 */     // (intrinsic_wo_chain:{ *:[i32] } 3841:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47996 */     GIR_RootConstrainSelectedInstOperands,
     /*  47997 */     // GIR_Coverage, 437,
     /*  47997 */     GIR_EraseRootFromParent_Done,
     /*  47998 */   // Label 1043: @47998
     /*  47998 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(48052), // Rule ID 438 //
     /*  48003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  48011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48032 */     // (intrinsic_wo_chain:{ *:[i32] } 3842:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  48035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48050 */     GIR_RootConstrainSelectedInstOperands,
     /*  48051 */     // GIR_Coverage, 438,
     /*  48051 */     GIR_EraseRootFromParent_Done,
     /*  48052 */   // Label 1044: @48052
     /*  48052 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(48106), // Rule ID 439 //
     /*  48057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  48065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48086 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  48089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48104 */     GIR_RootConstrainSelectedInstOperands,
     /*  48105 */     // GIR_Coverage, 439,
     /*  48105 */     GIR_EraseRootFromParent_Done,
     /*  48106 */   // Label 1045: @48106
     /*  48106 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(48160), // Rule ID 440 //
     /*  48111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  48119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48140 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  48143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48158 */     GIR_RootConstrainSelectedInstOperands,
     /*  48159 */     // GIR_Coverage, 440,
     /*  48159 */     GIR_EraseRootFromParent_Done,
     /*  48160 */   // Label 1046: @48160
     /*  48160 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(48214), // Rule ID 441 //
     /*  48165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  48173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48194 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  48197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48212 */     GIR_RootConstrainSelectedInstOperands,
     /*  48213 */     // GIR_Coverage, 441,
     /*  48213 */     GIR_EraseRootFromParent_Done,
     /*  48214 */   // Label 1047: @48214
     /*  48214 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(48268), // Rule ID 442 //
     /*  48219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48248 */     // (intrinsic_wo_chain:{ *:[i32] } 3907:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48260 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48266 */     GIR_RootConstrainSelectedInstOperands,
     /*  48267 */     // GIR_Coverage, 442,
     /*  48267 */     GIR_EraseRootFromParent_Done,
     /*  48268 */   // Label 1048: @48268
     /*  48268 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(48322), // Rule ID 443 //
     /*  48273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48302 */     // (intrinsic_wo_chain:{ *:[i32] } 3908:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48314 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48320 */     GIR_RootConstrainSelectedInstOperands,
     /*  48321 */     // GIR_Coverage, 443,
     /*  48321 */     GIR_EraseRootFromParent_Done,
     /*  48322 */   // Label 1049: @48322
     /*  48322 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(48376), // Rule ID 456 //
     /*  48327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48356 */     // (intrinsic_wo_chain:{ *:[i32] } 3850:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48374 */     GIR_RootConstrainSelectedInstOperands,
     /*  48375 */     // GIR_Coverage, 456,
     /*  48375 */     GIR_EraseRootFromParent_Done,
     /*  48376 */   // Label 1050: @48376
     /*  48376 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(48430), // Rule ID 457 //
     /*  48381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48410 */     // (intrinsic_wo_chain:{ *:[i32] } 3848:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48428 */     GIR_RootConstrainSelectedInstOperands,
     /*  48429 */     // GIR_Coverage, 457,
     /*  48429 */     GIR_EraseRootFromParent_Done,
     /*  48430 */   // Label 1051: @48430
     /*  48430 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(48484), // Rule ID 458 //
     /*  48435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48464 */     // (intrinsic_wo_chain:{ *:[i32] } 3849:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48476 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48482 */     GIR_RootConstrainSelectedInstOperands,
     /*  48483 */     // GIR_Coverage, 458,
     /*  48483 */     GIR_EraseRootFromParent_Done,
     /*  48484 */   // Label 1052: @48484
     /*  48484 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(48538), // Rule ID 459 //
     /*  48489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48518 */     // (intrinsic_wo_chain:{ *:[i32] } 3851:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48536 */     GIR_RootConstrainSelectedInstOperands,
     /*  48537 */     // GIR_Coverage, 459,
     /*  48537 */     GIR_EraseRootFromParent_Done,
     /*  48538 */   // Label 1053: @48538
     /*  48538 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(48592), // Rule ID 460 //
     /*  48543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48572 */     // (intrinsic_wo_chain:{ *:[i32] } 3852:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48584 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48590 */     GIR_RootConstrainSelectedInstOperands,
     /*  48591 */     // GIR_Coverage, 460,
     /*  48591 */     GIR_EraseRootFromParent_Done,
     /*  48592 */   // Label 1054: @48592
     /*  48592 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(48646), // Rule ID 461 //
     /*  48597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48626 */     // (intrinsic_wo_chain:{ *:[i32] } 3853:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48644 */     GIR_RootConstrainSelectedInstOperands,
     /*  48645 */     // GIR_Coverage, 461,
     /*  48645 */     GIR_EraseRootFromParent_Done,
     /*  48646 */   // Label 1055: @48646
     /*  48646 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(48700), // Rule ID 462 //
     /*  48651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48680 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48698 */     GIR_RootConstrainSelectedInstOperands,
     /*  48699 */     // GIR_Coverage, 462,
     /*  48699 */     GIR_EraseRootFromParent_Done,
     /*  48700 */   // Label 1056: @48700
     /*  48700 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48754), // Rule ID 463 //
     /*  48705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48734 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48752 */     GIR_RootConstrainSelectedInstOperands,
     /*  48753 */     // GIR_Coverage, 463,
     /*  48753 */     GIR_EraseRootFromParent_Done,
     /*  48754 */   // Label 1057: @48754
     /*  48754 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48808), // Rule ID 464 //
     /*  48759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48788 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48806 */     GIR_RootConstrainSelectedInstOperands,
     /*  48807 */     // GIR_Coverage, 464,
     /*  48807 */     GIR_EraseRootFromParent_Done,
     /*  48808 */   // Label 1058: @48808
     /*  48808 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48862), // Rule ID 465 //
     /*  48813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48842 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48860 */     GIR_RootConstrainSelectedInstOperands,
     /*  48861 */     // GIR_Coverage, 465,
     /*  48861 */     GIR_EraseRootFromParent_Done,
     /*  48862 */   // Label 1059: @48862
     /*  48862 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48916), // Rule ID 466 //
     /*  48867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48896 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48908 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48914 */     GIR_RootConstrainSelectedInstOperands,
     /*  48915 */     // GIR_Coverage, 466,
     /*  48915 */     GIR_EraseRootFromParent_Done,
     /*  48916 */   // Label 1060: @48916
     /*  48916 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48970), // Rule ID 467 //
     /*  48921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48950 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48968 */     GIR_RootConstrainSelectedInstOperands,
     /*  48969 */     // GIR_Coverage, 467,
     /*  48969 */     GIR_EraseRootFromParent_Done,
     /*  48970 */   // Label 1061: @48970
     /*  48970 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(49024), // Rule ID 468 //
     /*  48975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49004 */     // (intrinsic_wo_chain:{ *:[i32] } 3910:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  49007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49022 */     GIR_RootConstrainSelectedInstOperands,
     /*  49023 */     // GIR_Coverage, 468,
     /*  49023 */     GIR_EraseRootFromParent_Done,
     /*  49024 */   // Label 1062: @49024
     /*  49024 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(49078), // Rule ID 524 //
     /*  49029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  49037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49058 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  49061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49076 */     GIR_RootConstrainSelectedInstOperands,
     /*  49077 */     // GIR_Coverage, 524,
     /*  49077 */     GIR_EraseRootFromParent_Done,
     /*  49078 */   // Label 1063: @49078
     /*  49078 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(49132), // Rule ID 525 //
     /*  49083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  49091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49112 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  49115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49130 */     GIR_RootConstrainSelectedInstOperands,
     /*  49131 */     // GIR_Coverage, 525,
     /*  49131 */     GIR_EraseRootFromParent_Done,
     /*  49132 */   // Label 1064: @49132
     /*  49132 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(49186), // Rule ID 526 //
     /*  49137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  49145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49166 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  49169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49184 */     GIR_RootConstrainSelectedInstOperands,
     /*  49185 */     // GIR_Coverage, 526,
     /*  49185 */     GIR_EraseRootFromParent_Done,
     /*  49186 */   // Label 1065: @49186
     /*  49186 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(49240), // Rule ID 527 //
     /*  49191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  49199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49220 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49238 */     GIR_RootConstrainSelectedInstOperands,
     /*  49239 */     // GIR_Coverage, 527,
     /*  49239 */     GIR_EraseRootFromParent_Done,
     /*  49240 */   // Label 1066: @49240
     /*  49240 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(49285), // Rule ID 541 //
     /*  49245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49274 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49283 */     GIR_RootConstrainSelectedInstOperands,
     /*  49284 */     // GIR_Coverage, 541,
     /*  49284 */     GIR_EraseRootFromParent_Done,
     /*  49285 */   // Label 1067: @49285
     /*  49285 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(49330), // Rule ID 542 //
     /*  49290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49319 */     // (intrinsic_wo_chain:{ *:[i32] } 3470:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49328 */     GIR_RootConstrainSelectedInstOperands,
     /*  49329 */     // GIR_Coverage, 542,
     /*  49329 */     GIR_EraseRootFromParent_Done,
     /*  49330 */   // Label 1068: @49330
     /*  49330 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(49375), // Rule ID 543 //
     /*  49335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49364 */     // (intrinsic_wo_chain:{ *:[i32] } 3473:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49373 */     GIR_RootConstrainSelectedInstOperands,
     /*  49374 */     // GIR_Coverage, 543,
     /*  49374 */     GIR_EraseRootFromParent_Done,
     /*  49375 */   // Label 1069: @49375
     /*  49375 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(49420), // Rule ID 544 //
     /*  49380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49409 */     // (intrinsic_wo_chain:{ *:[i32] } 3471:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49418 */     GIR_RootConstrainSelectedInstOperands,
     /*  49419 */     // GIR_Coverage, 544,
     /*  49419 */     GIR_EraseRootFromParent_Done,
     /*  49420 */   // Label 1070: @49420
     /*  49420 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(49465), // Rule ID 545 //
     /*  49425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49454 */     // (intrinsic_wo_chain:{ *:[i32] } 3474:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49463 */     GIR_RootConstrainSelectedInstOperands,
     /*  49464 */     // GIR_Coverage, 545,
     /*  49464 */     GIR_EraseRootFromParent_Done,
     /*  49465 */   // Label 1071: @49465
     /*  49465 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(49510), // Rule ID 546 //
     /*  49470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49499 */     // (intrinsic_wo_chain:{ *:[i32] } 3472:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49508 */     GIR_RootConstrainSelectedInstOperands,
     /*  49509 */     // GIR_Coverage, 546,
     /*  49509 */     GIR_EraseRootFromParent_Done,
     /*  49510 */   // Label 1072: @49510
     /*  49510 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(49564), // Rule ID 789 //
     /*  49515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49544 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3740:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49562 */     GIR_RootConstrainSelectedInstOperands,
     /*  49563 */     // GIR_Coverage, 789,
     /*  49563 */     GIR_EraseRootFromParent_Done,
     /*  49564 */   // Label 1073: @49564
     /*  49564 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(49618), // Rule ID 790 //
     /*  49569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49598 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3740:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49616 */     GIR_RootConstrainSelectedInstOperands,
     /*  49617 */     // GIR_Coverage, 790,
     /*  49617 */     GIR_EraseRootFromParent_Done,
     /*  49618 */   // Label 1074: @49618
     /*  49618 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(49672), // Rule ID 791 //
     /*  49623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3740:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49670 */     GIR_RootConstrainSelectedInstOperands,
     /*  49671 */     // GIR_Coverage, 791,
     /*  49671 */     GIR_EraseRootFromParent_Done,
     /*  49672 */   // Label 1075: @49672
     /*  49672 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49726), // Rule ID 792 //
     /*  49677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49706 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49724 */     GIR_RootConstrainSelectedInstOperands,
     /*  49725 */     // GIR_Coverage, 792,
     /*  49725 */     GIR_EraseRootFromParent_Done,
     /*  49726 */   // Label 1076: @49726
     /*  49726 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49780), // Rule ID 793 //
     /*  49731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49760 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3740:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49778 */     GIR_RootConstrainSelectedInstOperands,
     /*  49779 */     // GIR_Coverage, 793,
     /*  49779 */     GIR_EraseRootFromParent_Done,
     /*  49780 */   // Label 1077: @49780
     /*  49780 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49834), // Rule ID 794 //
     /*  49785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49814 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3740:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49826 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49832 */     GIR_RootConstrainSelectedInstOperands,
     /*  49833 */     // GIR_Coverage, 794,
     /*  49833 */     GIR_EraseRootFromParent_Done,
     /*  49834 */   // Label 1078: @49834
     /*  49834 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49888), // Rule ID 795 //
     /*  49839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49868 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3741:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49886 */     GIR_RootConstrainSelectedInstOperands,
     /*  49887 */     // GIR_Coverage, 795,
     /*  49887 */     GIR_EraseRootFromParent_Done,
     /*  49888 */   // Label 1079: @49888
     /*  49888 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49942), // Rule ID 796 //
     /*  49893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49922 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3741:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49940 */     GIR_RootConstrainSelectedInstOperands,
     /*  49941 */     // GIR_Coverage, 796,
     /*  49941 */     GIR_EraseRootFromParent_Done,
     /*  49942 */   // Label 1080: @49942
     /*  49942 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(49996), // Rule ID 797 //
     /*  49947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49976 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3741:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49994 */     GIR_RootConstrainSelectedInstOperands,
     /*  49995 */     // GIR_Coverage, 797,
     /*  49995 */     GIR_EraseRootFromParent_Done,
     /*  49996 */   // Label 1081: @49996
     /*  49996 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(50050), // Rule ID 798 //
     /*  50001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50030 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  50033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50042 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50048 */     GIR_RootConstrainSelectedInstOperands,
     /*  50049 */     // GIR_Coverage, 798,
     /*  50049 */     GIR_EraseRootFromParent_Done,
     /*  50050 */   // Label 1082: @50050
     /*  50050 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(50104), // Rule ID 799 //
     /*  50055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50084 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3741:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  50087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50096 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50102 */     GIR_RootConstrainSelectedInstOperands,
     /*  50103 */     // GIR_Coverage, 799,
     /*  50103 */     GIR_EraseRootFromParent_Done,
     /*  50104 */   // Label 1083: @50104
     /*  50104 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(50158), // Rule ID 800 //
     /*  50109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50138 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3741:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  50141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50156 */     GIR_RootConstrainSelectedInstOperands,
     /*  50157 */     // GIR_Coverage, 800,
     /*  50157 */     GIR_EraseRootFromParent_Done,
     /*  50158 */   // Label 1084: @50158
     /*  50158 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(50212), // Rule ID 801 //
     /*  50163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50192 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3800:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  50195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50204 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50210 */     GIR_RootConstrainSelectedInstOperands,
     /*  50211 */     // GIR_Coverage, 801,
     /*  50211 */     GIR_EraseRootFromParent_Done,
     /*  50212 */   // Label 1085: @50212
     /*  50212 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(50266), // Rule ID 802 //
     /*  50217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50246 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3800:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50264 */     GIR_RootConstrainSelectedInstOperands,
     /*  50265 */     // GIR_Coverage, 802,
     /*  50265 */     GIR_EraseRootFromParent_Done,
     /*  50266 */   // Label 1086: @50266
     /*  50266 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(50320), // Rule ID 803 //
     /*  50271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50300 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3800:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50318 */     GIR_RootConstrainSelectedInstOperands,
     /*  50319 */     // GIR_Coverage, 803,
     /*  50319 */     GIR_EraseRootFromParent_Done,
     /*  50320 */   // Label 1087: @50320
     /*  50320 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(50374), // Rule ID 804 //
     /*  50325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50354 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3800:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50372 */     GIR_RootConstrainSelectedInstOperands,
     /*  50373 */     // GIR_Coverage, 804,
     /*  50373 */     GIR_EraseRootFromParent_Done,
     /*  50374 */   // Label 1088: @50374
     /*  50374 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(50428), // Rule ID 805 //
     /*  50379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50408 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3800:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50426 */     GIR_RootConstrainSelectedInstOperands,
     /*  50427 */     // GIR_Coverage, 805,
     /*  50427 */     GIR_EraseRootFromParent_Done,
     /*  50428 */   // Label 1089: @50428
     /*  50428 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(50482), // Rule ID 806 //
     /*  50433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50462 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3800:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50480 */     GIR_RootConstrainSelectedInstOperands,
     /*  50481 */     // GIR_Coverage, 806,
     /*  50481 */     GIR_EraseRootFromParent_Done,
     /*  50482 */   // Label 1090: @50482
     /*  50482 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(50536), // Rule ID 807 //
     /*  50487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50516 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3801:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50534 */     GIR_RootConstrainSelectedInstOperands,
     /*  50535 */     // GIR_Coverage, 807,
     /*  50535 */     GIR_EraseRootFromParent_Done,
     /*  50536 */   // Label 1091: @50536
     /*  50536 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(50590), // Rule ID 808 //
     /*  50541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50570 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3801:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50588 */     GIR_RootConstrainSelectedInstOperands,
     /*  50589 */     // GIR_Coverage, 808,
     /*  50589 */     GIR_EraseRootFromParent_Done,
     /*  50590 */   // Label 1092: @50590
     /*  50590 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(50644), // Rule ID 809 //
     /*  50595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50624 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3801:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50642 */     GIR_RootConstrainSelectedInstOperands,
     /*  50643 */     // GIR_Coverage, 809,
     /*  50643 */     GIR_EraseRootFromParent_Done,
     /*  50644 */   // Label 1093: @50644
     /*  50644 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(50698), // Rule ID 810 //
     /*  50649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50678 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3801:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50696 */     GIR_RootConstrainSelectedInstOperands,
     /*  50697 */     // GIR_Coverage, 810,
     /*  50697 */     GIR_EraseRootFromParent_Done,
     /*  50698 */   // Label 1094: @50698
     /*  50698 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(50752), // Rule ID 811 //
     /*  50703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50732 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3801:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50750 */     GIR_RootConstrainSelectedInstOperands,
     /*  50751 */     // GIR_Coverage, 811,
     /*  50751 */     GIR_EraseRootFromParent_Done,
     /*  50752 */   // Label 1095: @50752
     /*  50752 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50806), // Rule ID 812 //
     /*  50757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50786 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3801:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50804 */     GIR_RootConstrainSelectedInstOperands,
     /*  50805 */     // GIR_Coverage, 812,
     /*  50805 */     GIR_EraseRootFromParent_Done,
     /*  50806 */   // Label 1096: @50806
     /*  50806 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50860), // Rule ID 829 //
     /*  50811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50840 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3797:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50858 */     GIR_RootConstrainSelectedInstOperands,
     /*  50859 */     // GIR_Coverage, 829,
     /*  50859 */     GIR_EraseRootFromParent_Done,
     /*  50860 */   // Label 1097: @50860
     /*  50860 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50914), // Rule ID 830 //
     /*  50865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50894 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3797:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50912 */     GIR_RootConstrainSelectedInstOperands,
     /*  50913 */     // GIR_Coverage, 830,
     /*  50913 */     GIR_EraseRootFromParent_Done,
     /*  50914 */   // Label 1098: @50914
     /*  50914 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50968), // Rule ID 831 //
     /*  50919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50948 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3797:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50966 */     GIR_RootConstrainSelectedInstOperands,
     /*  50967 */     // GIR_Coverage, 831,
     /*  50967 */     GIR_EraseRootFromParent_Done,
     /*  50968 */   // Label 1099: @50968
     /*  50968 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(51022), // Rule ID 838 //
     /*  50973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51002 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3766:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  51005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51020 */     GIR_RootConstrainSelectedInstOperands,
     /*  51021 */     // GIR_Coverage, 838,
     /*  51021 */     GIR_EraseRootFromParent_Done,
     /*  51022 */   // Label 1100: @51022
     /*  51022 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(51076), // Rule ID 839 //
     /*  51027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  51035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51056 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3766:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  51059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51068 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51074 */     GIR_RootConstrainSelectedInstOperands,
     /*  51075 */     // GIR_Coverage, 839,
     /*  51075 */     GIR_EraseRootFromParent_Done,
     /*  51076 */   // Label 1101: @51076
     /*  51076 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(51130), // Rule ID 852 //
     /*  51081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51110 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3777:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  51113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51128 */     GIR_RootConstrainSelectedInstOperands,
     /*  51129 */     // GIR_Coverage, 852,
     /*  51129 */     GIR_EraseRootFromParent_Done,
     /*  51130 */   // Label 1102: @51130
     /*  51130 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(51184), // Rule ID 853 //
     /*  51135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51164 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3777:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  51167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51182 */     GIR_RootConstrainSelectedInstOperands,
     /*  51183 */     // GIR_Coverage, 853,
     /*  51183 */     GIR_EraseRootFromParent_Done,
     /*  51184 */   // Label 1103: @51184
     /*  51184 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(51238), // Rule ID 854 //
     /*  51189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51218 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3777:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51225 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51236 */     GIR_RootConstrainSelectedInstOperands,
     /*  51237 */     // GIR_Coverage, 854,
     /*  51237 */     GIR_EraseRootFromParent_Done,
     /*  51238 */   // Label 1104: @51238
     /*  51238 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(51292), // Rule ID 855 //
     /*  51243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51272 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3777:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51290 */     GIR_RootConstrainSelectedInstOperands,
     /*  51291 */     // GIR_Coverage, 855,
     /*  51291 */     GIR_EraseRootFromParent_Done,
     /*  51292 */   // Label 1105: @51292
     /*  51292 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(51346), // Rule ID 860 //
     /*  51297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51326 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3785:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51344 */     GIR_RootConstrainSelectedInstOperands,
     /*  51345 */     // GIR_Coverage, 860,
     /*  51345 */     GIR_EraseRootFromParent_Done,
     /*  51346 */   // Label 1106: @51346
     /*  51346 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(51400), // Rule ID 861 //
     /*  51351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51380 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3785:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51398 */     GIR_RootConstrainSelectedInstOperands,
     /*  51399 */     // GIR_Coverage, 861,
     /*  51399 */     GIR_EraseRootFromParent_Done,
     /*  51400 */   // Label 1107: @51400
     /*  51400 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(51454), // Rule ID 862 //
     /*  51405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51434 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3785:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51452 */     GIR_RootConstrainSelectedInstOperands,
     /*  51453 */     // GIR_Coverage, 862,
     /*  51453 */     GIR_EraseRootFromParent_Done,
     /*  51454 */   // Label 1108: @51454
     /*  51454 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(51508), // Rule ID 863 //
     /*  51459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51488 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3785:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51506 */     GIR_RootConstrainSelectedInstOperands,
     /*  51507 */     // GIR_Coverage, 863,
     /*  51507 */     GIR_EraseRootFromParent_Done,
     /*  51508 */   // Label 1109: @51508
     /*  51508 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(51562), // Rule ID 874 //
     /*  51513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51542 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3763:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51560 */     GIR_RootConstrainSelectedInstOperands,
     /*  51561 */     // GIR_Coverage, 874,
     /*  51561 */     GIR_EraseRootFromParent_Done,
     /*  51562 */   // Label 1110: @51562
     /*  51562 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(51607), // Rule ID 875 //
     /*  51567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51596 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3763:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51605 */     GIR_RootConstrainSelectedInstOperands,
     /*  51606 */     // GIR_Coverage, 875,
     /*  51606 */     GIR_EraseRootFromParent_Done,
     /*  51607 */   // Label 1111: @51607
     /*  51607 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(51661), // Rule ID 880 //
     /*  51612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51641 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51659 */     GIR_RootConstrainSelectedInstOperands,
     /*  51660 */     // GIR_Coverage, 880,
     /*  51660 */     GIR_EraseRootFromParent_Done,
     /*  51661 */   // Label 1112: @51661
     /*  51661 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(51715), // Rule ID 881 //
     /*  51666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51695 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51713 */     GIR_RootConstrainSelectedInstOperands,
     /*  51714 */     // GIR_Coverage, 881,
     /*  51714 */     GIR_EraseRootFromParent_Done,
     /*  51715 */   // Label 1113: @51715
     /*  51715 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51769), // Rule ID 993 //
     /*  51720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51749 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3742:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51767 */     GIR_RootConstrainSelectedInstOperands,
     /*  51768 */     // GIR_Coverage, 993,
     /*  51768 */     GIR_EraseRootFromParent_Done,
     /*  51769 */   // Label 1114: @51769
     /*  51769 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51823), // Rule ID 994 //
     /*  51774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51803 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3742:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51821 */     GIR_RootConstrainSelectedInstOperands,
     /*  51822 */     // GIR_Coverage, 994,
     /*  51822 */     GIR_EraseRootFromParent_Done,
     /*  51823 */   // Label 1115: @51823
     /*  51823 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51877), // Rule ID 995 //
     /*  51828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51857 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3742:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51875 */     GIR_RootConstrainSelectedInstOperands,
     /*  51876 */     // GIR_Coverage, 995,
     /*  51876 */     GIR_EraseRootFromParent_Done,
     /*  51877 */   // Label 1116: @51877
     /*  51877 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51931), // Rule ID 996 //
     /*  51882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51911 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51929 */     GIR_RootConstrainSelectedInstOperands,
     /*  51930 */     // GIR_Coverage, 996,
     /*  51930 */     GIR_EraseRootFromParent_Done,
     /*  51931 */   // Label 1117: @51931
     /*  51931 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51985), // Rule ID 997 //
     /*  51936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51965 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3742:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51983 */     GIR_RootConstrainSelectedInstOperands,
     /*  51984 */     // GIR_Coverage, 997,
     /*  51984 */     GIR_EraseRootFromParent_Done,
     /*  51985 */   // Label 1118: @51985
     /*  51985 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(52039), // Rule ID 998 //
     /*  51990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52019 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3742:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  52022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52037 */     GIR_RootConstrainSelectedInstOperands,
     /*  52038 */     // GIR_Coverage, 998,
     /*  52038 */     GIR_EraseRootFromParent_Done,
     /*  52039 */   // Label 1119: @52039
     /*  52039 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(52093), // Rule ID 999 //
     /*  52044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52073 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3743:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  52076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52091 */     GIR_RootConstrainSelectedInstOperands,
     /*  52092 */     // GIR_Coverage, 999,
     /*  52092 */     GIR_EraseRootFromParent_Done,
     /*  52093 */   // Label 1120: @52093
     /*  52093 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(52147), // Rule ID 1000 //
     /*  52098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52127 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3743:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  52130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52145 */     GIR_RootConstrainSelectedInstOperands,
     /*  52146 */     // GIR_Coverage, 1000,
     /*  52146 */     GIR_EraseRootFromParent_Done,
     /*  52147 */   // Label 1121: @52147
     /*  52147 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(52201), // Rule ID 1001 //
     /*  52152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52181 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3743:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  52184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52199 */     GIR_RootConstrainSelectedInstOperands,
     /*  52200 */     // GIR_Coverage, 1001,
     /*  52200 */     GIR_EraseRootFromParent_Done,
     /*  52201 */   // Label 1122: @52201
     /*  52201 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(52255), // Rule ID 1002 //
     /*  52206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52235 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52253 */     GIR_RootConstrainSelectedInstOperands,
     /*  52254 */     // GIR_Coverage, 1002,
     /*  52254 */     GIR_EraseRootFromParent_Done,
     /*  52255 */   // Label 1123: @52255
     /*  52255 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(52309), // Rule ID 1003 //
     /*  52260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52289 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3743:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52301 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52307 */     GIR_RootConstrainSelectedInstOperands,
     /*  52308 */     // GIR_Coverage, 1003,
     /*  52308 */     GIR_EraseRootFromParent_Done,
     /*  52309 */   // Label 1124: @52309
     /*  52309 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(52363), // Rule ID 1004 //
     /*  52314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52343 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3743:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52361 */     GIR_RootConstrainSelectedInstOperands,
     /*  52362 */     // GIR_Coverage, 1004,
     /*  52362 */     GIR_EraseRootFromParent_Done,
     /*  52363 */   // Label 1125: @52363
     /*  52363 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(52417), // Rule ID 1021 //
     /*  52368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52397 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3813:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52415 */     GIR_RootConstrainSelectedInstOperands,
     /*  52416 */     // GIR_Coverage, 1021,
     /*  52416 */     GIR_EraseRootFromParent_Done,
     /*  52417 */   // Label 1126: @52417
     /*  52417 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(52471), // Rule ID 1022 //
     /*  52422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52451 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3813:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52469 */     GIR_RootConstrainSelectedInstOperands,
     /*  52470 */     // GIR_Coverage, 1022,
     /*  52470 */     GIR_EraseRootFromParent_Done,
     /*  52471 */   // Label 1127: @52471
     /*  52471 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(52525), // Rule ID 1023 //
     /*  52476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52505 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3813:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52523 */     GIR_RootConstrainSelectedInstOperands,
     /*  52524 */     // GIR_Coverage, 1023,
     /*  52524 */     GIR_EraseRootFromParent_Done,
     /*  52525 */   // Label 1128: @52525
     /*  52525 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(52579), // Rule ID 1116 //
     /*  52530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52559 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3718:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52577 */     GIR_RootConstrainSelectedInstOperands,
     /*  52578 */     // GIR_Coverage, 1116,
     /*  52578 */     GIR_EraseRootFromParent_Done,
     /*  52579 */   // Label 1129: @52579
     /*  52579 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(52633), // Rule ID 1117 //
     /*  52584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52613 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3718:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52631 */     GIR_RootConstrainSelectedInstOperands,
     /*  52632 */     // GIR_Coverage, 1117,
     /*  52632 */     GIR_EraseRootFromParent_Done,
     /*  52633 */   // Label 1130: @52633
     /*  52633 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(52687), // Rule ID 1118 //
     /*  52638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52667 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3718:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52685 */     GIR_RootConstrainSelectedInstOperands,
     /*  52686 */     // GIR_Coverage, 1118,
     /*  52686 */     GIR_EraseRootFromParent_Done,
     /*  52687 */   // Label 1131: @52687
     /*  52687 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(52741), // Rule ID 1119 //
     /*  52692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52721 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3718:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52739 */     GIR_RootConstrainSelectedInstOperands,
     /*  52740 */     // GIR_Coverage, 1119,
     /*  52740 */     GIR_EraseRootFromParent_Done,
     /*  52741 */   // Label 1132: @52741
     /*  52741 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52795), // Rule ID 1120 //
     /*  52746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52775 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3719:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52793 */     GIR_RootConstrainSelectedInstOperands,
     /*  52794 */     // GIR_Coverage, 1120,
     /*  52794 */     GIR_EraseRootFromParent_Done,
     /*  52795 */   // Label 1133: @52795
     /*  52795 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52849), // Rule ID 1121 //
     /*  52800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52829 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3719:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52847 */     GIR_RootConstrainSelectedInstOperands,
     /*  52848 */     // GIR_Coverage, 1121,
     /*  52848 */     GIR_EraseRootFromParent_Done,
     /*  52849 */   // Label 1134: @52849
     /*  52849 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52903), // Rule ID 1122 //
     /*  52854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52883 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3719:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52901 */     GIR_RootConstrainSelectedInstOperands,
     /*  52902 */     // GIR_Coverage, 1122,
     /*  52902 */     GIR_EraseRootFromParent_Done,
     /*  52903 */   // Label 1135: @52903
     /*  52903 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52957), // Rule ID 1123 //
     /*  52908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52937 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3719:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52955 */     GIR_RootConstrainSelectedInstOperands,
     /*  52956 */     // GIR_Coverage, 1123,
     /*  52956 */     GIR_EraseRootFromParent_Done,
     /*  52957 */   // Label 1136: @52957
     /*  52957 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(53011), // Rule ID 1166 //
     /*  52962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52991 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3715:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  52994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53009 */     GIR_RootConstrainSelectedInstOperands,
     /*  53010 */     // GIR_Coverage, 1166,
     /*  53010 */     GIR_EraseRootFromParent_Done,
     /*  53011 */   // Label 1137: @53011
     /*  53011 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(53065), // Rule ID 1167 //
     /*  53016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53045 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3715:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  53045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  53048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53063 */     GIR_RootConstrainSelectedInstOperands,
     /*  53064 */     // GIR_Coverage, 1167,
     /*  53064 */     GIR_EraseRootFromParent_Done,
     /*  53065 */   // Label 1138: @53065
     /*  53065 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(53119), // Rule ID 1168 //
     /*  53070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53099 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3715:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  53102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53117 */     GIR_RootConstrainSelectedInstOperands,
     /*  53118 */     // GIR_Coverage, 1168,
     /*  53118 */     GIR_EraseRootFromParent_Done,
     /*  53119 */   // Label 1139: @53119
     /*  53119 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(53173), // Rule ID 1169 //
     /*  53124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53153 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3715:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  53156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53171 */     GIR_RootConstrainSelectedInstOperands,
     /*  53172 */     // GIR_Coverage, 1169,
     /*  53172 */     GIR_EraseRootFromParent_Done,
     /*  53173 */   // Label 1140: @53173
     /*  53173 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(53227), // Rule ID 1234 //
     /*  53178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53207 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3769:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  53210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53219 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53225 */     GIR_RootConstrainSelectedInstOperands,
     /*  53226 */     // GIR_Coverage, 1234,
     /*  53226 */     GIR_EraseRootFromParent_Done,
     /*  53227 */   // Label 1141: @53227
     /*  53227 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(53281), // Rule ID 1235 //
     /*  53232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53261 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53279 */     GIR_RootConstrainSelectedInstOperands,
     /*  53280 */     // GIR_Coverage, 1235,
     /*  53280 */     GIR_EraseRootFromParent_Done,
     /*  53281 */   // Label 1142: @53281
     /*  53281 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(53335), // Rule ID 1236 //
     /*  53286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53315 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53333 */     GIR_RootConstrainSelectedInstOperands,
     /*  53334 */     // GIR_Coverage, 1236,
     /*  53334 */     GIR_EraseRootFromParent_Done,
     /*  53335 */   // Label 1143: @53335
     /*  53335 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(53389), // Rule ID 1237 //
     /*  53340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53369 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53387 */     GIR_RootConstrainSelectedInstOperands,
     /*  53388 */     // GIR_Coverage, 1237,
     /*  53388 */     GIR_EraseRootFromParent_Done,
     /*  53389 */   // Label 1144: @53389
     /*  53389 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(53443), // Rule ID 1238 //
     /*  53394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53423 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53441 */     GIR_RootConstrainSelectedInstOperands,
     /*  53442 */     // GIR_Coverage, 1238,
     /*  53442 */     GIR_EraseRootFromParent_Done,
     /*  53443 */   // Label 1145: @53443
     /*  53443 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(53497), // Rule ID 1251 //
     /*  53448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53477 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3767:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53482 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53495 */     GIR_RootConstrainSelectedInstOperands,
     /*  53496 */     // GIR_Coverage, 1251,
     /*  53496 */     GIR_EraseRootFromParent_Done,
     /*  53497 */   // Label 1146: @53497
     /*  53497 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(53551), // Rule ID 1252 //
     /*  53502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53531 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3767:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53536 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53549 */     GIR_RootConstrainSelectedInstOperands,
     /*  53550 */     // GIR_Coverage, 1252,
     /*  53550 */     GIR_EraseRootFromParent_Done,
     /*  53551 */   // Label 1147: @53551
     /*  53551 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(53605), // Rule ID 1253 //
     /*  53556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53585 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3767:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53590 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53603 */     GIR_RootConstrainSelectedInstOperands,
     /*  53604 */     // GIR_Coverage, 1253,
     /*  53604 */     GIR_EraseRootFromParent_Done,
     /*  53605 */   // Label 1148: @53605
     /*  53605 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(53659), // Rule ID 1254 //
     /*  53610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53639 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3767:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53644 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53657 */     GIR_RootConstrainSelectedInstOperands,
     /*  53658 */     // GIR_Coverage, 1254,
     /*  53658 */     GIR_EraseRootFromParent_Done,
     /*  53659 */   // Label 1149: @53659
     /*  53659 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(53713), // Rule ID 1255 //
     /*  53664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53693 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3767:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53698 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53711 */     GIR_RootConstrainSelectedInstOperands,
     /*  53712 */     // GIR_Coverage, 1255,
     /*  53712 */     GIR_EraseRootFromParent_Done,
     /*  53713 */   // Label 1150: @53713
     /*  53713 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53767), // Rule ID 1256 //
     /*  53718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53747 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3767:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53752 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53765 */     GIR_RootConstrainSelectedInstOperands,
     /*  53766 */     // GIR_Coverage, 1256,
     /*  53766 */     GIR_EraseRootFromParent_Done,
     /*  53767 */   // Label 1151: @53767
     /*  53767 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53821), // Rule ID 1257 //
     /*  53772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53801 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3768:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53806 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53819 */     GIR_RootConstrainSelectedInstOperands,
     /*  53820 */     // GIR_Coverage, 1257,
     /*  53820 */     GIR_EraseRootFromParent_Done,
     /*  53821 */   // Label 1152: @53821
     /*  53821 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53875), // Rule ID 1258 //
     /*  53826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53855 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3768:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53860 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53873 */     GIR_RootConstrainSelectedInstOperands,
     /*  53874 */     // GIR_Coverage, 1258,
     /*  53874 */     GIR_EraseRootFromParent_Done,
     /*  53875 */   // Label 1153: @53875
     /*  53875 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53929), // Rule ID 1259 //
     /*  53880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53909 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3768:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53914 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53927 */     GIR_RootConstrainSelectedInstOperands,
     /*  53928 */     // GIR_Coverage, 1259,
     /*  53928 */     GIR_EraseRootFromParent_Done,
     /*  53929 */   // Label 1154: @53929
     /*  53929 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53983), // Rule ID 1260 //
     /*  53934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53963 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3768:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53968 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53981 */     GIR_RootConstrainSelectedInstOperands,
     /*  53982 */     // GIR_Coverage, 1260,
     /*  53982 */     GIR_EraseRootFromParent_Done,
     /*  53983 */   // Label 1155: @53983
     /*  53983 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(54037), // Rule ID 1261 //
     /*  53988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54017 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3768:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  54017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  54020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54022 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54029 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54035 */     GIR_RootConstrainSelectedInstOperands,
     /*  54036 */     // GIR_Coverage, 1261,
     /*  54036 */     GIR_EraseRootFromParent_Done,
     /*  54037 */   // Label 1156: @54037
     /*  54037 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(54091), // Rule ID 1262 //
     /*  54042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  54053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54071 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3768:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  54071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  54074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54076 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54089 */     GIR_RootConstrainSelectedInstOperands,
     /*  54090 */     // GIR_Coverage, 1262,
     /*  54090 */     GIR_EraseRootFromParent_Done,
     /*  54091 */   // Label 1157: @54091
     /*  54091 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(54145), // Rule ID 1263 //
     /*  54096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54125 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3772:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  54128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54143 */     GIR_RootConstrainSelectedInstOperands,
     /*  54144 */     // GIR_Coverage, 1263,
     /*  54144 */     GIR_EraseRootFromParent_Done,
     /*  54145 */   // Label 1158: @54145
     /*  54145 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(54199), // Rule ID 1264 //
     /*  54150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54179 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  54182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54197 */     GIR_RootConstrainSelectedInstOperands,
     /*  54198 */     // GIR_Coverage, 1264,
     /*  54198 */     GIR_EraseRootFromParent_Done,
     /*  54199 */   // Label 1159: @54199
     /*  54199 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(54253), // Rule ID 1265 //
     /*  54204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54233 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54251 */     GIR_RootConstrainSelectedInstOperands,
     /*  54252 */     // GIR_Coverage, 1265,
     /*  54252 */     GIR_EraseRootFromParent_Done,
     /*  54253 */   // Label 1160: @54253
     /*  54253 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(54307), // Rule ID 1266 //
     /*  54258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54287 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3773:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54305 */     GIR_RootConstrainSelectedInstOperands,
     /*  54306 */     // GIR_Coverage, 1266,
     /*  54306 */     GIR_EraseRootFromParent_Done,
     /*  54307 */   // Label 1161: @54307
     /*  54307 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(54361), // Rule ID 1267 //
     /*  54312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54341 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3773:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54359 */     GIR_RootConstrainSelectedInstOperands,
     /*  54360 */     // GIR_Coverage, 1267,
     /*  54360 */     GIR_EraseRootFromParent_Done,
     /*  54361 */   // Label 1162: @54361
     /*  54361 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(54415), // Rule ID 1268 //
     /*  54366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54395 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3773:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54413 */     GIR_RootConstrainSelectedInstOperands,
     /*  54414 */     // GIR_Coverage, 1268,
     /*  54414 */     GIR_EraseRootFromParent_Done,
     /*  54415 */   // Label 1163: @54415
     /*  54415 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(54469), // Rule ID 1269 //
     /*  54420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54449 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54467 */     GIR_RootConstrainSelectedInstOperands,
     /*  54468 */     // GIR_Coverage, 1269,
     /*  54468 */     GIR_EraseRootFromParent_Done,
     /*  54469 */   // Label 1164: @54469
     /*  54469 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(54523), // Rule ID 1270 //
     /*  54474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54503 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54521 */     GIR_RootConstrainSelectedInstOperands,
     /*  54522 */     // GIR_Coverage, 1270,
     /*  54522 */     GIR_EraseRootFromParent_Done,
     /*  54523 */   // Label 1165: @54523
     /*  54523 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(54577), // Rule ID 1271 //
     /*  54528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54557 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3774:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54569 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54575 */     GIR_RootConstrainSelectedInstOperands,
     /*  54576 */     // GIR_Coverage, 1271,
     /*  54576 */     GIR_EraseRootFromParent_Done,
     /*  54577 */   // Label 1166: @54577
     /*  54577 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(54631), // Rule ID 1272 //
     /*  54582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54611 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3774:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54629 */     GIR_RootConstrainSelectedInstOperands,
     /*  54630 */     // GIR_Coverage, 1272,
     /*  54630 */     GIR_EraseRootFromParent_Done,
     /*  54631 */   // Label 1167: @54631
     /*  54631 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(54685), // Rule ID 1273 //
     /*  54636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54665 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3774:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54683 */     GIR_RootConstrainSelectedInstOperands,
     /*  54684 */     // GIR_Coverage, 1273,
     /*  54684 */     GIR_EraseRootFromParent_Done,
     /*  54685 */   // Label 1168: @54685
     /*  54685 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(54739), // Rule ID 1274 //
     /*  54690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54719 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3775:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54737 */     GIR_RootConstrainSelectedInstOperands,
     /*  54738 */     // GIR_Coverage, 1274,
     /*  54738 */     GIR_EraseRootFromParent_Done,
     /*  54739 */   // Label 1169: @54739
     /*  54739 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54793), // Rule ID 1275 //
     /*  54744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54773 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3775:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54791 */     GIR_RootConstrainSelectedInstOperands,
     /*  54792 */     // GIR_Coverage, 1275,
     /*  54792 */     GIR_EraseRootFromParent_Done,
     /*  54793 */   // Label 1170: @54793
     /*  54793 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54847), // Rule ID 1276 //
     /*  54798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54827 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3775:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54845 */     GIR_RootConstrainSelectedInstOperands,
     /*  54846 */     // GIR_Coverage, 1276,
     /*  54846 */     GIR_EraseRootFromParent_Done,
     /*  54847 */   // Label 1171: @54847
     /*  54847 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54901), // Rule ID 1277 //
     /*  54852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54881 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3774:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54899 */     GIR_RootConstrainSelectedInstOperands,
     /*  54900 */     // GIR_Coverage, 1277,
     /*  54900 */     GIR_EraseRootFromParent_Done,
     /*  54901 */   // Label 1172: @54901
     /*  54901 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54955), // Rule ID 1278 //
     /*  54906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54935 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3774:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54953 */     GIR_RootConstrainSelectedInstOperands,
     /*  54954 */     // GIR_Coverage, 1278,
     /*  54954 */     GIR_EraseRootFromParent_Done,
     /*  54955 */   // Label 1173: @54955
     /*  54955 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(55009), // Rule ID 1285 //
     /*  54960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54989 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3799:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  54992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55007 */     GIR_RootConstrainSelectedInstOperands,
     /*  55008 */     // GIR_Coverage, 1285,
     /*  55008 */     GIR_EraseRootFromParent_Done,
     /*  55009 */   // Label 1174: @55009
     /*  55009 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(55063), // Rule ID 1286 //
     /*  55014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55043 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3799:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  55046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55061 */     GIR_RootConstrainSelectedInstOperands,
     /*  55062 */     // GIR_Coverage, 1286,
     /*  55062 */     GIR_EraseRootFromParent_Done,
     /*  55063 */   // Label 1175: @55063
     /*  55063 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(55117), // Rule ID 1287 //
     /*  55068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55097 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3799:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  55100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55115 */     GIR_RootConstrainSelectedInstOperands,
     /*  55116 */     // GIR_Coverage, 1287,
     /*  55116 */     GIR_EraseRootFromParent_Done,
     /*  55117 */   // Label 1176: @55117
     /*  55117 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(55171), // Rule ID 1288 //
     /*  55122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55151 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3799:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  55154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55169 */     GIR_RootConstrainSelectedInstOperands,
     /*  55170 */     // GIR_Coverage, 1288,
     /*  55170 */     GIR_EraseRootFromParent_Done,
     /*  55171 */   // Label 1177: @55171
     /*  55171 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(55225), // Rule ID 1295 //
     /*  55176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55205 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3812:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  55208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55223 */     GIR_RootConstrainSelectedInstOperands,
     /*  55224 */     // GIR_Coverage, 1295,
     /*  55224 */     GIR_EraseRootFromParent_Done,
     /*  55225 */   // Label 1178: @55225
     /*  55225 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(55279), // Rule ID 1296 //
     /*  55230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55259 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3812:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55277 */     GIR_RootConstrainSelectedInstOperands,
     /*  55278 */     // GIR_Coverage, 1296,
     /*  55278 */     GIR_EraseRootFromParent_Done,
     /*  55279 */   // Label 1179: @55279
     /*  55279 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(55333), // Rule ID 1297 //
     /*  55284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55313 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3812:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55331 */     GIR_RootConstrainSelectedInstOperands,
     /*  55332 */     // GIR_Coverage, 1297,
     /*  55332 */     GIR_EraseRootFromParent_Done,
     /*  55333 */   // Label 1180: @55333
     /*  55333 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(55387), // Rule ID 1298 //
     /*  55338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55367 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3812:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55385 */     GIR_RootConstrainSelectedInstOperands,
     /*  55386 */     // GIR_Coverage, 1298,
     /*  55386 */     GIR_EraseRootFromParent_Done,
     /*  55387 */   // Label 1181: @55387
     /*  55387 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(55441), // Rule ID 1299 //
     /*  55392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55421 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3815:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55439 */     GIR_RootConstrainSelectedInstOperands,
     /*  55440 */     // GIR_Coverage, 1299,
     /*  55440 */     GIR_EraseRootFromParent_Done,
     /*  55441 */   // Label 1182: @55441
     /*  55441 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(55495), // Rule ID 1300 //
     /*  55446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55475 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3815:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55493 */     GIR_RootConstrainSelectedInstOperands,
     /*  55494 */     // GIR_Coverage, 1300,
     /*  55494 */     GIR_EraseRootFromParent_Done,
     /*  55495 */   // Label 1183: @55495
     /*  55495 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(55549), // Rule ID 1301 //
     /*  55500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55529 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3815:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55547 */     GIR_RootConstrainSelectedInstOperands,
     /*  55548 */     // GIR_Coverage, 1301,
     /*  55548 */     GIR_EraseRootFromParent_Done,
     /*  55549 */   // Label 1184: @55549
     /*  55549 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(55603), // Rule ID 1302 //
     /*  55554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55583 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3815:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55601 */     GIR_RootConstrainSelectedInstOperands,
     /*  55602 */     // GIR_Coverage, 1302,
     /*  55602 */     GIR_EraseRootFromParent_Done,
     /*  55603 */   // Label 1185: @55603
     /*  55603 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(55657), // Rule ID 1303 //
     /*  55608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55637 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3815:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55655 */     GIR_RootConstrainSelectedInstOperands,
     /*  55656 */     // GIR_Coverage, 1303,
     /*  55656 */     GIR_EraseRootFromParent_Done,
     /*  55657 */   // Label 1186: @55657
     /*  55657 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(55711), // Rule ID 1304 //
     /*  55662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55691 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3815:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55709 */     GIR_RootConstrainSelectedInstOperands,
     /*  55710 */     // GIR_Coverage, 1304,
     /*  55710 */     GIR_EraseRootFromParent_Done,
     /*  55711 */   // Label 1187: @55711
     /*  55711 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55765), // Rule ID 1305 //
     /*  55716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55745 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3815:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55763 */     GIR_RootConstrainSelectedInstOperands,
     /*  55764 */     // GIR_Coverage, 1305,
     /*  55764 */     GIR_EraseRootFromParent_Done,
     /*  55765 */   // Label 1188: @55765
     /*  55765 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55819), // Rule ID 1306 //
     /*  55770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55799 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3815:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55817 */     GIR_RootConstrainSelectedInstOperands,
     /*  55818 */     // GIR_Coverage, 1306,
     /*  55818 */     GIR_EraseRootFromParent_Done,
     /*  55819 */   // Label 1189: @55819
     /*  55819 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55873), // Rule ID 1307 //
     /*  55824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55853 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3816:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55871 */     GIR_RootConstrainSelectedInstOperands,
     /*  55872 */     // GIR_Coverage, 1307,
     /*  55872 */     GIR_EraseRootFromParent_Done,
     /*  55873 */   // Label 1190: @55873
     /*  55873 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55927), // Rule ID 1308 //
     /*  55878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55907 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3816:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55925 */     GIR_RootConstrainSelectedInstOperands,
     /*  55926 */     // GIR_Coverage, 1308,
     /*  55926 */     GIR_EraseRootFromParent_Done,
     /*  55927 */   // Label 1191: @55927
     /*  55927 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55981), // Rule ID 1309 //
     /*  55932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55961 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3816:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55979 */     GIR_RootConstrainSelectedInstOperands,
     /*  55980 */     // GIR_Coverage, 1309,
     /*  55980 */     GIR_EraseRootFromParent_Done,
     /*  55981 */   // Label 1192: @55981
     /*  55981 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(56035), // Rule ID 1310 //
     /*  55986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56015 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3816:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  56018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56033 */     GIR_RootConstrainSelectedInstOperands,
     /*  56034 */     // GIR_Coverage, 1310,
     /*  56034 */     GIR_EraseRootFromParent_Done,
     /*  56035 */   // Label 1193: @56035
     /*  56035 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(56089), // Rule ID 1311 //
     /*  56040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56069 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3816:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  56072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56087 */     GIR_RootConstrainSelectedInstOperands,
     /*  56088 */     // GIR_Coverage, 1311,
     /*  56088 */     GIR_EraseRootFromParent_Done,
     /*  56089 */   // Label 1194: @56089
     /*  56089 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(56143), // Rule ID 1312 //
     /*  56094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56123 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3816:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  56126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56141 */     GIR_RootConstrainSelectedInstOperands,
     /*  56142 */     // GIR_Coverage, 1312,
     /*  56142 */     GIR_EraseRootFromParent_Done,
     /*  56143 */   // Label 1195: @56143
     /*  56143 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(56197), // Rule ID 1313 //
     /*  56148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56177 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3816:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  56180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56195 */     GIR_RootConstrainSelectedInstOperands,
     /*  56196 */     // GIR_Coverage, 1313,
     /*  56196 */     GIR_EraseRootFromParent_Done,
     /*  56197 */   // Label 1196: @56197
     /*  56197 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(56251), // Rule ID 1314 //
     /*  56202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56231 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3816:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56249 */     GIR_RootConstrainSelectedInstOperands,
     /*  56250 */     // GIR_Coverage, 1314,
     /*  56250 */     GIR_EraseRootFromParent_Done,
     /*  56251 */   // Label 1197: @56251
     /*  56251 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(56305), // Rule ID 1348 //
     /*  56256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56285 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56303 */     GIR_RootConstrainSelectedInstOperands,
     /*  56304 */     // GIR_Coverage, 1348,
     /*  56304 */     GIR_EraseRootFromParent_Done,
     /*  56305 */   // Label 1198: @56305
     /*  56305 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(56359), // Rule ID 1349 //
     /*  56310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56339 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56357 */     GIR_RootConstrainSelectedInstOperands,
     /*  56358 */     // GIR_Coverage, 1349,
     /*  56358 */     GIR_EraseRootFromParent_Done,
     /*  56359 */   // Label 1199: @56359
     /*  56359 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(56413), // Rule ID 1350 //
     /*  56364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56393 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3809:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56411 */     GIR_RootConstrainSelectedInstOperands,
     /*  56412 */     // GIR_Coverage, 1350,
     /*  56412 */     GIR_EraseRootFromParent_Done,
     /*  56413 */   // Label 1200: @56413
     /*  56413 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(56467), // Rule ID 1351 //
     /*  56418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56447 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56465 */     GIR_RootConstrainSelectedInstOperands,
     /*  56466 */     // GIR_Coverage, 1351,
     /*  56466 */     GIR_EraseRootFromParent_Done,
     /*  56467 */   // Label 1201: @56467
     /*  56467 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(56521), // Rule ID 1352 //
     /*  56472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56501 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3809:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56519 */     GIR_RootConstrainSelectedInstOperands,
     /*  56520 */     // GIR_Coverage, 1352,
     /*  56520 */     GIR_EraseRootFromParent_Done,
     /*  56521 */   // Label 1202: @56521
     /*  56521 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(56575), // Rule ID 1353 //
     /*  56526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56555 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3809:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56573 */     GIR_RootConstrainSelectedInstOperands,
     /*  56574 */     // GIR_Coverage, 1353,
     /*  56574 */     GIR_EraseRootFromParent_Done,
     /*  56575 */   // Label 1203: @56575
     /*  56575 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(56629), // Rule ID 1354 //
     /*  56580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56609 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56627 */     GIR_RootConstrainSelectedInstOperands,
     /*  56628 */     // GIR_Coverage, 1354,
     /*  56628 */     GIR_EraseRootFromParent_Done,
     /*  56629 */   // Label 1204: @56629
     /*  56629 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(56683), // Rule ID 1355 //
     /*  56634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56663 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56675 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56681 */     GIR_RootConstrainSelectedInstOperands,
     /*  56682 */     // GIR_Coverage, 1355,
     /*  56682 */     GIR_EraseRootFromParent_Done,
     /*  56683 */   // Label 1205: @56683
     /*  56683 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(56737), // Rule ID 1356 //
     /*  56688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56717 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56735 */     GIR_RootConstrainSelectedInstOperands,
     /*  56736 */     // GIR_Coverage, 1356,
     /*  56736 */     GIR_EraseRootFromParent_Done,
     /*  56737 */   // Label 1206: @56737
     /*  56737 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56791), // Rule ID 1357 //
     /*  56742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56771 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56789 */     GIR_RootConstrainSelectedInstOperands,
     /*  56790 */     // GIR_Coverage, 1357,
     /*  56790 */     GIR_EraseRootFromParent_Done,
     /*  56791 */   // Label 1207: @56791
     /*  56791 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56845), // Rule ID 1358 //
     /*  56796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56825 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3810:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56843 */     GIR_RootConstrainSelectedInstOperands,
     /*  56844 */     // GIR_Coverage, 1358,
     /*  56844 */     GIR_EraseRootFromParent_Done,
     /*  56845 */   // Label 1208: @56845
     /*  56845 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56899), // Rule ID 1359 //
     /*  56850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56879 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3810:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56897 */     GIR_RootConstrainSelectedInstOperands,
     /*  56898 */     // GIR_Coverage, 1359,
     /*  56898 */     GIR_EraseRootFromParent_Done,
     /*  56899 */   // Label 1209: @56899
     /*  56899 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56953), // Rule ID 1360 //
     /*  56904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56933 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3810:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56951 */     GIR_RootConstrainSelectedInstOperands,
     /*  56952 */     // GIR_Coverage, 1360,
     /*  56952 */     GIR_EraseRootFromParent_Done,
     /*  56953 */   // Label 1210: @56953
     /*  56953 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(57007), // Rule ID 1361 //
     /*  56958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56987 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3810:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57005 */     GIR_RootConstrainSelectedInstOperands,
     /*  57006 */     // GIR_Coverage, 1361,
     /*  57006 */     GIR_EraseRootFromParent_Done,
     /*  57007 */   // Label 1211: @57007
     /*  57007 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(57061), // Rule ID 1362 //
     /*  57012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57041 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3810:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  57044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57059 */     GIR_RootConstrainSelectedInstOperands,
     /*  57060 */     // GIR_Coverage, 1362,
     /*  57060 */     GIR_EraseRootFromParent_Done,
     /*  57061 */   // Label 1212: @57061
     /*  57061 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(57115), // Rule ID 1363 //
     /*  57066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57095 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3810:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  57098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57113 */     GIR_RootConstrainSelectedInstOperands,
     /*  57114 */     // GIR_Coverage, 1363,
     /*  57114 */     GIR_EraseRootFromParent_Done,
     /*  57115 */   // Label 1213: @57115
     /*  57115 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(57169), // Rule ID 1383 //
     /*  57120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57149 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3794:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  57152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57167 */     GIR_RootConstrainSelectedInstOperands,
     /*  57168 */     // GIR_Coverage, 1383,
     /*  57168 */     GIR_EraseRootFromParent_Done,
     /*  57169 */   // Label 1214: @57169
     /*  57169 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(57223), // Rule ID 1384 //
     /*  57174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57203 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3794:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  57206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57221 */     GIR_RootConstrainSelectedInstOperands,
     /*  57222 */     // GIR_Coverage, 1384,
     /*  57222 */     GIR_EraseRootFromParent_Done,
     /*  57223 */   // Label 1215: @57223
     /*  57223 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(57277), // Rule ID 1385 //
     /*  57228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57257 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3794:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57275 */     GIR_RootConstrainSelectedInstOperands,
     /*  57276 */     // GIR_Coverage, 1385,
     /*  57276 */     GIR_EraseRootFromParent_Done,
     /*  57277 */   // Label 1216: @57277
     /*  57277 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(57331), // Rule ID 1386 //
     /*  57282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57311 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3794:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57329 */     GIR_RootConstrainSelectedInstOperands,
     /*  57330 */     // GIR_Coverage, 1386,
     /*  57330 */     GIR_EraseRootFromParent_Done,
     /*  57331 */   // Label 1217: @57331
     /*  57331 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(57385), // Rule ID 1387 //
     /*  57336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57365 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3794:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57383 */     GIR_RootConstrainSelectedInstOperands,
     /*  57384 */     // GIR_Coverage, 1387,
     /*  57384 */     GIR_EraseRootFromParent_Done,
     /*  57385 */   // Label 1218: @57385
     /*  57385 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(57439), // Rule ID 1388 //
     /*  57390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57419 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3794:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57437 */     GIR_RootConstrainSelectedInstOperands,
     /*  57438 */     // GIR_Coverage, 1388,
     /*  57438 */     GIR_EraseRootFromParent_Done,
     /*  57439 */   // Label 1219: @57439
     /*  57439 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(57493), // Rule ID 1389 //
     /*  57444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57473 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3794:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57491 */     GIR_RootConstrainSelectedInstOperands,
     /*  57492 */     // GIR_Coverage, 1389,
     /*  57492 */     GIR_EraseRootFromParent_Done,
     /*  57493 */   // Label 1220: @57493
     /*  57493 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(57547), // Rule ID 1390 //
     /*  57498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57527 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3794:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57545 */     GIR_RootConstrainSelectedInstOperands,
     /*  57546 */     // GIR_Coverage, 1390,
     /*  57546 */     GIR_EraseRootFromParent_Done,
     /*  57547 */   // Label 1221: @57547
     /*  57547 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(57601), // Rule ID 1391 //
     /*  57552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57581 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3796:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57599 */     GIR_RootConstrainSelectedInstOperands,
     /*  57600 */     // GIR_Coverage, 1391,
     /*  57600 */     GIR_EraseRootFromParent_Done,
     /*  57601 */   // Label 1222: @57601
     /*  57601 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(57655), // Rule ID 1392 //
     /*  57606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57635 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3796:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57653 */     GIR_RootConstrainSelectedInstOperands,
     /*  57654 */     // GIR_Coverage, 1392,
     /*  57654 */     GIR_EraseRootFromParent_Done,
     /*  57655 */   // Label 1223: @57655
     /*  57655 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(57709), // Rule ID 1393 //
     /*  57660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57689 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3796:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57707 */     GIR_RootConstrainSelectedInstOperands,
     /*  57708 */     // GIR_Coverage, 1393,
     /*  57708 */     GIR_EraseRootFromParent_Done,
     /*  57709 */   // Label 1224: @57709
     /*  57709 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57763), // Rule ID 1394 //
     /*  57714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57743 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3796:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57761 */     GIR_RootConstrainSelectedInstOperands,
     /*  57762 */     // GIR_Coverage, 1394,
     /*  57762 */     GIR_EraseRootFromParent_Done,
     /*  57763 */   // Label 1225: @57763
     /*  57763 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57817), // Rule ID 1395 //
     /*  57768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57797 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3796:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57815 */     GIR_RootConstrainSelectedInstOperands,
     /*  57816 */     // GIR_Coverage, 1395,
     /*  57816 */     GIR_EraseRootFromParent_Done,
     /*  57817 */   // Label 1226: @57817
     /*  57817 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57871), // Rule ID 1396 //
     /*  57822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57851 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3796:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57869 */     GIR_RootConstrainSelectedInstOperands,
     /*  57870 */     // GIR_Coverage, 1396,
     /*  57870 */     GIR_EraseRootFromParent_Done,
     /*  57871 */   // Label 1227: @57871
     /*  57871 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57925), // Rule ID 1397 //
     /*  57876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57905 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3796:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57923 */     GIR_RootConstrainSelectedInstOperands,
     /*  57924 */     // GIR_Coverage, 1397,
     /*  57924 */     GIR_EraseRootFromParent_Done,
     /*  57925 */   // Label 1228: @57925
     /*  57925 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57979), // Rule ID 1398 //
     /*  57930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57959 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3796:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57971 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57977 */     GIR_RootConstrainSelectedInstOperands,
     /*  57978 */     // GIR_Coverage, 1398,
     /*  57978 */     GIR_EraseRootFromParent_Done,
     /*  57979 */   // Label 1229: @57979
     /*  57979 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(58033), // Rule ID 1432 //
     /*  57984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  57992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58013 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3789:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  58016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58025 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58031 */     GIR_RootConstrainSelectedInstOperands,
     /*  58032 */     // GIR_Coverage, 1432,
     /*  58032 */     GIR_EraseRootFromParent_Done,
     /*  58033 */   // Label 1230: @58033
     /*  58033 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(58087), // Rule ID 1433 //
     /*  58038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58067 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3789:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  58070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58085 */     GIR_RootConstrainSelectedInstOperands,
     /*  58086 */     // GIR_Coverage, 1433,
     /*  58086 */     GIR_EraseRootFromParent_Done,
     /*  58087 */   // Label 1231: @58087
     /*  58087 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(58141), // Rule ID 1434 //
     /*  58092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58121 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3789:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58139 */     GIR_RootConstrainSelectedInstOperands,
     /*  58140 */     // GIR_Coverage, 1434,
     /*  58140 */     GIR_EraseRootFromParent_Done,
     /*  58141 */   // Label 1232: @58141
     /*  58141 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(58195), // Rule ID 1435 //
     /*  58146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58175 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3789:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  58178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58193 */     GIR_RootConstrainSelectedInstOperands,
     /*  58194 */     // GIR_Coverage, 1435,
     /*  58194 */     GIR_EraseRootFromParent_Done,
     /*  58195 */   // Label 1233: @58195
     /*  58195 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(58249), // Rule ID 1436 //
     /*  58200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58229 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3789:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58247 */     GIR_RootConstrainSelectedInstOperands,
     /*  58248 */     // GIR_Coverage, 1436,
     /*  58248 */     GIR_EraseRootFromParent_Done,
     /*  58249 */   // Label 1234: @58249
     /*  58249 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(58303), // Rule ID 1437 //
     /*  58254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58283 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3789:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58301 */     GIR_RootConstrainSelectedInstOperands,
     /*  58302 */     // GIR_Coverage, 1437,
     /*  58302 */     GIR_EraseRootFromParent_Done,
     /*  58303 */   // Label 1235: @58303
     /*  58303 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(58357), // Rule ID 1438 //
     /*  58308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58337 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3789:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58355 */     GIR_RootConstrainSelectedInstOperands,
     /*  58356 */     // GIR_Coverage, 1438,
     /*  58356 */     GIR_EraseRootFromParent_Done,
     /*  58357 */   // Label 1236: @58357
     /*  58357 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(58411), // Rule ID 1439 //
     /*  58362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58391 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3789:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58409 */     GIR_RootConstrainSelectedInstOperands,
     /*  58410 */     // GIR_Coverage, 1439,
     /*  58410 */     GIR_EraseRootFromParent_Done,
     /*  58411 */   // Label 1237: @58411
     /*  58411 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(58465), // Rule ID 1440 //
     /*  58416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58445 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3790:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58463 */     GIR_RootConstrainSelectedInstOperands,
     /*  58464 */     // GIR_Coverage, 1440,
     /*  58464 */     GIR_EraseRootFromParent_Done,
     /*  58465 */   // Label 1238: @58465
     /*  58465 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(58519), // Rule ID 1441 //
     /*  58470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58499 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3790:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58517 */     GIR_RootConstrainSelectedInstOperands,
     /*  58518 */     // GIR_Coverage, 1441,
     /*  58518 */     GIR_EraseRootFromParent_Done,
     /*  58519 */   // Label 1239: @58519
     /*  58519 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(58573), // Rule ID 1442 //
     /*  58524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58553 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3790:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58571 */     GIR_RootConstrainSelectedInstOperands,
     /*  58572 */     // GIR_Coverage, 1442,
     /*  58572 */     GIR_EraseRootFromParent_Done,
     /*  58573 */   // Label 1240: @58573
     /*  58573 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(58627), // Rule ID 1443 //
     /*  58578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58607 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3790:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58625 */     GIR_RootConstrainSelectedInstOperands,
     /*  58626 */     // GIR_Coverage, 1443,
     /*  58626 */     GIR_EraseRootFromParent_Done,
     /*  58627 */   // Label 1241: @58627
     /*  58627 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(58681), // Rule ID 1444 //
     /*  58632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58661 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3790:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58679 */     GIR_RootConstrainSelectedInstOperands,
     /*  58680 */     // GIR_Coverage, 1444,
     /*  58680 */     GIR_EraseRootFromParent_Done,
     /*  58681 */   // Label 1242: @58681
     /*  58681 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(58735), // Rule ID 1445 //
     /*  58686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58715 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3790:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58733 */     GIR_RootConstrainSelectedInstOperands,
     /*  58734 */     // GIR_Coverage, 1445,
     /*  58734 */     GIR_EraseRootFromParent_Done,
     /*  58735 */   // Label 1243: @58735
     /*  58735 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58789), // Rule ID 1446 //
     /*  58740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58769 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3790:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58787 */     GIR_RootConstrainSelectedInstOperands,
     /*  58788 */     // GIR_Coverage, 1446,
     /*  58788 */     GIR_EraseRootFromParent_Done,
     /*  58789 */   // Label 1244: @58789
     /*  58789 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58843), // Rule ID 1447 //
     /*  58794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58823 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3790:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58841 */     GIR_RootConstrainSelectedInstOperands,
     /*  58842 */     // GIR_Coverage, 1447,
     /*  58842 */     GIR_EraseRootFromParent_Done,
     /*  58843 */   // Label 1245: @58843
     /*  58843 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58888), // Rule ID 1712 //
     /*  58848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58877 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58882 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58886 */     GIR_RootConstrainSelectedInstOperands,
     /*  58887 */     // GIR_Coverage, 1712,
     /*  58887 */     GIR_EraseRootFromParent_Done,
     /*  58888 */   // Label 1246: @58888
     /*  58888 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58933), // Rule ID 1713 //
     /*  58893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58922 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3692:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58927 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58931 */     GIR_RootConstrainSelectedInstOperands,
     /*  58932 */     // GIR_Coverage, 1713,
     /*  58932 */     GIR_EraseRootFromParent_Done,
     /*  58933 */   // Label 1247: @58933
     /*  58933 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58978), // Rule ID 1716 //
     /*  58938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58967 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58972 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58976 */     GIR_RootConstrainSelectedInstOperands,
     /*  58977 */     // GIR_Coverage, 1716,
     /*  58977 */     GIR_EraseRootFromParent_Done,
     /*  58978 */   // Label 1248: @58978
     /*  58978 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(59023), // Rule ID 1717 //
     /*  58983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  59000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59012 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3708:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  59012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  59015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59017 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59021 */     GIR_RootConstrainSelectedInstOperands,
     /*  59022 */     // GIR_Coverage, 1717,
     /*  59022 */     GIR_EraseRootFromParent_Done,
     /*  59023 */   // Label 1249: @59023
     /*  59023 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(59077), // Rule ID 1726 //
     /*  59028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  59036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59057 */     // (intrinsic_wo_chain:{ *:[i32] } 3553:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  59060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59062 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59075 */     GIR_RootConstrainSelectedInstOperands,
     /*  59076 */     // GIR_Coverage, 1726,
     /*  59076 */     GIR_EraseRootFromParent_Done,
     /*  59077 */   // Label 1250: @59077
     /*  59077 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(59131), // Rule ID 1727 //
     /*  59082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  59090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59111 */     // (intrinsic_wo_chain:{ *:[i32] } 3560:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  59114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59116 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59129 */     GIR_RootConstrainSelectedInstOperands,
     /*  59130 */     // GIR_Coverage, 1727,
     /*  59130 */     GIR_EraseRootFromParent_Done,
     /*  59131 */   // Label 1251: @59131
     /*  59131 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(59188), // Rule ID 1850 //
     /*  59136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59165 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  59168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59170 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59172 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59186 */     GIR_RootConstrainSelectedInstOperands,
     /*  59187 */     // GIR_Coverage, 1850,
     /*  59187 */     GIR_EraseRootFromParent_Done,
     /*  59188 */   // Label 1252: @59188
     /*  59188 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(59245), // Rule ID 1857 //
     /*  59193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  59201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59222 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59227 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59229 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59243 */     GIR_RootConstrainSelectedInstOperands,
     /*  59244 */     // GIR_Coverage, 1857,
     /*  59244 */     GIR_EraseRootFromParent_Done,
     /*  59245 */   // Label 1253: @59245
     /*  59245 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(59299), // Rule ID 1904 //
     /*  59250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59279 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59297 */     GIR_RootConstrainSelectedInstOperands,
     /*  59298 */     // GIR_Coverage, 1904,
     /*  59298 */     GIR_EraseRootFromParent_Done,
     /*  59299 */   // Label 1254: @59299
     /*  59299 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(59353), // Rule ID 1905 //
     /*  59304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59333 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59351 */     GIR_RootConstrainSelectedInstOperands,
     /*  59352 */     // GIR_Coverage, 1905,
     /*  59352 */     GIR_EraseRootFromParent_Done,
     /*  59353 */   // Label 1255: @59353
     /*  59353 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(59407), // Rule ID 1906 //
     /*  59358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59387 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59405 */     GIR_RootConstrainSelectedInstOperands,
     /*  59406 */     // GIR_Coverage, 1906,
     /*  59406 */     GIR_EraseRootFromParent_Done,
     /*  59407 */   // Label 1256: @59407
     /*  59407 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(59461), // Rule ID 1907 //
     /*  59412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59441 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59459 */     GIR_RootConstrainSelectedInstOperands,
     /*  59460 */     // GIR_Coverage, 1907,
     /*  59460 */     GIR_EraseRootFromParent_Done,
     /*  59461 */   // Label 1257: @59461
     /*  59461 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(59515), // Rule ID 1981 //
     /*  59466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59495 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59500 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59502 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59513 */     GIR_RootConstrainSelectedInstOperands,
     /*  59514 */     // GIR_Coverage, 1981,
     /*  59514 */     GIR_EraseRootFromParent_Done,
     /*  59515 */   // Label 1258: @59515
     /*  59515 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(59569), // Rule ID 1982 //
     /*  59520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59549 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59554 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59556 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59567 */     GIR_RootConstrainSelectedInstOperands,
     /*  59568 */     // GIR_Coverage, 1982,
     /*  59568 */     GIR_EraseRootFromParent_Done,
     /*  59569 */   // Label 1259: @59569
     /*  59569 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(59623), // Rule ID 1983 //
     /*  59574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59603 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59608 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59610 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59621 */     GIR_RootConstrainSelectedInstOperands,
     /*  59622 */     // GIR_Coverage, 1983,
     /*  59622 */     GIR_EraseRootFromParent_Done,
     /*  59623 */   // Label 1260: @59623
     /*  59623 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(59677), // Rule ID 1984 //
     /*  59628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59657 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59662 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59664 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59669 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59675 */     GIR_RootConstrainSelectedInstOperands,
     /*  59676 */     // GIR_Coverage, 1984,
     /*  59676 */     GIR_EraseRootFromParent_Done,
     /*  59677 */   // Label 1261: @59677
     /*  59677 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(59731), // Rule ID 1985 //
     /*  59682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59711 */     // (intrinsic_wo_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59716 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59718 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59729 */     GIR_RootConstrainSelectedInstOperands,
     /*  59730 */     // GIR_Coverage, 1985,
     /*  59730 */     GIR_EraseRootFromParent_Done,
     /*  59731 */   // Label 1262: @59731
     /*  59731 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59785), // Rule ID 1986 //
     /*  59736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59765 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59770 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59772 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59783 */     GIR_RootConstrainSelectedInstOperands,
     /*  59784 */     // GIR_Coverage, 1986,
     /*  59784 */     GIR_EraseRootFromParent_Done,
     /*  59785 */   // Label 1263: @59785
     /*  59785 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59842), // Rule ID 2097 //
     /*  59790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59819 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59840 */     GIR_RootConstrainSelectedInstOperands,
     /*  59841 */     // GIR_Coverage, 2097,
     /*  59841 */     GIR_EraseRootFromParent_Done,
     /*  59842 */   // Label 1264: @59842
     /*  59842 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59896), // Rule ID 2127 //
     /*  59847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59876 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59894 */     GIR_RootConstrainSelectedInstOperands,
     /*  59895 */     // GIR_Coverage, 2127,
     /*  59895 */     GIR_EraseRootFromParent_Done,
     /*  59896 */   // Label 1265: @59896
     /*  59896 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59950), // Rule ID 2128 //
     /*  59901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59930 */     // (intrinsic_wo_chain:{ *:[i32] } 3840:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59948 */     GIR_RootConstrainSelectedInstOperands,
     /*  59949 */     // GIR_Coverage, 2128,
     /*  59949 */     GIR_EraseRootFromParent_Done,
     /*  59950 */   // Label 1266: @59950
     /*  59950 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(60004), // Rule ID 2168 //
     /*  59955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59984 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60002 */     GIR_RootConstrainSelectedInstOperands,
     /*  60003 */     // GIR_Coverage, 2168,
     /*  60003 */     GIR_EraseRootFromParent_Done,
     /*  60004 */   // Label 1267: @60004
     /*  60004 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(60058), // Rule ID 2169 //
     /*  60009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  60017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60038 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  60041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60056 */     GIR_RootConstrainSelectedInstOperands,
     /*  60057 */     // GIR_Coverage, 2169,
     /*  60057 */     GIR_EraseRootFromParent_Done,
     /*  60058 */   // Label 1268: @60058
     /*  60058 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(60112), // Rule ID 2170 //
     /*  60063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  60071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60092 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  60095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60110 */     GIR_RootConstrainSelectedInstOperands,
     /*  60111 */     // GIR_Coverage, 2170,
     /*  60111 */     GIR_EraseRootFromParent_Done,
     /*  60112 */   // Label 1269: @60112
     /*  60112 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(60166), // Rule ID 2171 //
     /*  60117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  60125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60146 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  60149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60164 */     GIR_RootConstrainSelectedInstOperands,
     /*  60165 */     // GIR_Coverage, 2171,
     /*  60165 */     GIR_EraseRootFromParent_Done,
     /*  60166 */   // Label 1270: @60166
     /*  60166 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(60220), // Rule ID 2172 //
     /*  60171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  60179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60200 */     // (intrinsic_wo_chain:{ *:[i32] } 3874:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  60203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60218 */     GIR_RootConstrainSelectedInstOperands,
     /*  60219 */     // GIR_Coverage, 2172,
     /*  60219 */     GIR_EraseRootFromParent_Done,
     /*  60220 */   // Label 1271: @60220
     /*  60220 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(60274), // Rule ID 2173 //
     /*  60225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60254 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60272 */     GIR_RootConstrainSelectedInstOperands,
     /*  60273 */     // GIR_Coverage, 2173,
     /*  60273 */     GIR_EraseRootFromParent_Done,
     /*  60274 */   // Label 1272: @60274
     /*  60274 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(60322), // Rule ID 2510 //
     /*  60279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60308 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3722:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60320 */     GIR_RootConstrainSelectedInstOperands,
     /*  60321 */     // GIR_Coverage, 2510,
     /*  60321 */     GIR_EraseRootFromParent_Done,
     /*  60322 */   // Label 1273: @60322
     /*  60322 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(60370), // Rule ID 2511 //
     /*  60327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60356 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3721:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60368 */     GIR_RootConstrainSelectedInstOperands,
     /*  60369 */     // GIR_Coverage, 2511,
     /*  60369 */     GIR_EraseRootFromParent_Done,
     /*  60370 */   // Label 1274: @60370
     /*  60370 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(60418), // Rule ID 2512 //
     /*  60375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60404 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3722:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60416 */     GIR_RootConstrainSelectedInstOperands,
     /*  60417 */     // GIR_Coverage, 2512,
     /*  60417 */     GIR_EraseRootFromParent_Done,
     /*  60418 */   // Label 1275: @60418
     /*  60418 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(60466), // Rule ID 2513 //
     /*  60423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60452 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3721:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60464 */     GIR_RootConstrainSelectedInstOperands,
     /*  60465 */     // GIR_Coverage, 2513,
     /*  60465 */     GIR_EraseRootFromParent_Done,
     /*  60466 */   // Label 1276: @60466
     /*  60466 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(60514), // Rule ID 2514 //
     /*  60471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60500 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3722:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60512 */     GIR_RootConstrainSelectedInstOperands,
     /*  60513 */     // GIR_Coverage, 2514,
     /*  60513 */     GIR_EraseRootFromParent_Done,
     /*  60514 */   // Label 1277: @60514
     /*  60514 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(60562), // Rule ID 2515 //
     /*  60519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60548 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3721:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60560 */     GIR_RootConstrainSelectedInstOperands,
     /*  60561 */     // GIR_Coverage, 2515,
     /*  60561 */     GIR_EraseRootFromParent_Done,
     /*  60562 */   // Label 1278: @60562
     /*  60562 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(60610), // Rule ID 2516 //
     /*  60567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60596 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3722:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60608 */     GIR_RootConstrainSelectedInstOperands,
     /*  60609 */     // GIR_Coverage, 2516,
     /*  60609 */     GIR_EraseRootFromParent_Done,
     /*  60610 */   // Label 1279: @60610
     /*  60610 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(60658), // Rule ID 2517 //
     /*  60615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60644 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3721:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60656 */     GIR_RootConstrainSelectedInstOperands,
     /*  60657 */     // GIR_Coverage, 2517,
     /*  60657 */     GIR_EraseRootFromParent_Done,
     /*  60658 */   // Label 1280: @60658
     /*  60658 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60763), // Rule ID 3102 //
     /*  60663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60692 */     // (intrinsic_wo_chain:{ *:[f32] } 3529:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60692 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60695 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60699 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60704 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60708 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60725 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60732 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60735 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60741 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60762 */     // GIR_Coverage, 3102,
     /*  60762 */     GIR_EraseRootFromParent_Done,
     /*  60763 */   // Label 1281: @60763
     /*  60763 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60868), // Rule ID 3104 //
     /*  60768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60797 */     // (intrinsic_wo_chain:{ *:[f16] } 3529:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60797 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60800 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60804 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60809 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60837 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60840 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60846 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60867 */     // GIR_Coverage, 3104,
     /*  60867 */     GIR_EraseRootFromParent_Done,
     /*  60868 */   // Label 1282: @60868
     /*  60868 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60973), // Rule ID 3106 //
     /*  60873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60902 */     // (intrinsic_wo_chain:{ *:[f32] } 3520:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60914 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60918 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60935 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60938 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60942 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60945 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60951 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60972 */     // GIR_Coverage, 3106,
     /*  60972 */     GIR_EraseRootFromParent_Done,
     /*  60973 */   // Label 1283: @60973
     /*  60973 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(61078), // Rule ID 3108 //
     /*  60978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61007 */     // (intrinsic_wo_chain:{ *:[f16] } 3520:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61007 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61010 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61014 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61019 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61023 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  61035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61040 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61047 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61050 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61056 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61077 */     // GIR_Coverage, 3108,
     /*  61077 */     GIR_EraseRootFromParent_Done,
     /*  61078 */   // Label 1284: @61078
     /*  61078 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(61183), // Rule ID 3110 //
     /*  61083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61112 */     // (intrinsic_wo_chain:{ *:[f32] } 3527:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61112 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61115 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61119 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61124 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61128 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  61140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61148 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61152 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61155 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61161 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61182 */     // GIR_Coverage, 3110,
     /*  61182 */     GIR_EraseRootFromParent_Done,
     /*  61183 */   // Label 1285: @61183
     /*  61183 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(61288), // Rule ID 3112 //
     /*  61188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61217 */     // (intrinsic_wo_chain:{ *:[f16] } 3527:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61217 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61220 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61224 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61229 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61250 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61260 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61266 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61287 */     // GIR_Coverage, 3112,
     /*  61287 */     GIR_EraseRootFromParent_Done,
     /*  61288 */   // Label 1286: @61288
     /*  61288 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(61393), // Rule ID 3114 //
     /*  61293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61322 */     // (intrinsic_wo_chain:{ *:[f32] } 3518:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61322 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61325 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61329 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61334 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61338 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61355 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61358 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61362 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61365 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61371 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61387 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61392 */     // GIR_Coverage, 3114,
     /*  61392 */     GIR_EraseRootFromParent_Done,
     /*  61393 */   // Label 1287: @61393
     /*  61393 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(61498), // Rule ID 3116 //
     /*  61398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61427 */     // (intrinsic_wo_chain:{ *:[f16] } 3518:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61427 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61430 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61434 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61439 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61443 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61460 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61463 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61467 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61470 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61476 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61497 */     // GIR_Coverage, 3116,
     /*  61497 */     GIR_EraseRootFromParent_Done,
     /*  61498 */   // Label 1288: @61498
     /*  61498 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(61558), // Rule ID 3166 //
     /*  61503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61532 */     // (intrinsic_wo_chain:{ *:[i32] } 3525:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61537 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61539 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61556 */     GIR_RootConstrainSelectedInstOperands,
     /*  61557 */     // GIR_Coverage, 3166,
     /*  61557 */     GIR_EraseRootFromParent_Done,
     /*  61558 */   // Label 1289: @61558
     /*  61558 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(61618), // Rule ID 3168 //
     /*  61563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61592 */     // (intrinsic_wo_chain:{ *:[i32] } 3525:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61597 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61599 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61616 */     GIR_RootConstrainSelectedInstOperands,
     /*  61617 */     // GIR_Coverage, 3168,
     /*  61617 */     GIR_EraseRootFromParent_Done,
     /*  61618 */   // Label 1290: @61618
     /*  61618 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(61678), // Rule ID 3170 //
     /*  61623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61652 */     // (intrinsic_wo_chain:{ *:[i32] } 3525:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61657 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61659 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61676 */     GIR_RootConstrainSelectedInstOperands,
     /*  61677 */     // GIR_Coverage, 3170,
     /*  61677 */     GIR_EraseRootFromParent_Done,
     /*  61678 */   // Label 1291: @61678
     /*  61678 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(61738), // Rule ID 3172 //
     /*  61683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61712 */     // (intrinsic_wo_chain:{ *:[i32] } 3516:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61717 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61719 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61736 */     GIR_RootConstrainSelectedInstOperands,
     /*  61737 */     // GIR_Coverage, 3172,
     /*  61737 */     GIR_EraseRootFromParent_Done,
     /*  61738 */   // Label 1292: @61738
     /*  61738 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(61798), // Rule ID 3174 //
     /*  61743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61772 */     // (intrinsic_wo_chain:{ *:[i32] } 3516:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61777 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61779 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61796 */     GIR_RootConstrainSelectedInstOperands,
     /*  61797 */     // GIR_Coverage, 3174,
     /*  61797 */     GIR_EraseRootFromParent_Done,
     /*  61798 */   // Label 1293: @61798
     /*  61798 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(61858), // Rule ID 3176 //
     /*  61803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61832 */     // (intrinsic_wo_chain:{ *:[i32] } 3516:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61837 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61839 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61856 */     GIR_RootConstrainSelectedInstOperands,
     /*  61857 */     // GIR_Coverage, 3176,
     /*  61857 */     GIR_EraseRootFromParent_Done,
     /*  61858 */   // Label 1294: @61858
     /*  61858 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61933), // Rule ID 3467 //
     /*  61863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61892 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3638:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61931 */     GIR_RootConstrainSelectedInstOperands,
     /*  61932 */     // GIR_Coverage, 3467,
     /*  61932 */     GIR_EraseRootFromParent_Done,
     /*  61933 */   // Label 1295: @61933
     /*  61933 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(62008), // Rule ID 3474 //
     /*  61938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61967 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3638:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62006 */     GIR_RootConstrainSelectedInstOperands,
     /*  62007 */     // GIR_Coverage, 3474,
     /*  62007 */     GIR_EraseRootFromParent_Done,
     /*  62008 */   // Label 1296: @62008
     /*  62008 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(62083), // Rule ID 3478 //
     /*  62013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62042 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3638:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  62057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62081 */     GIR_RootConstrainSelectedInstOperands,
     /*  62082 */     // GIR_Coverage, 3478,
     /*  62082 */     GIR_EraseRootFromParent_Done,
     /*  62083 */   // Label 1297: @62083
     /*  62083 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(62158), // Rule ID 3480 //
     /*  62088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  62105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62117 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3647:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  62132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62156 */     GIR_RootConstrainSelectedInstOperands,
     /*  62157 */     // GIR_Coverage, 3480,
     /*  62157 */     GIR_EraseRootFromParent_Done,
     /*  62158 */   // Label 1298: @62158
     /*  62158 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(62233), // Rule ID 3482 //
     /*  62163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62192 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  62207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62231 */     GIR_RootConstrainSelectedInstOperands,
     /*  62232 */     // GIR_Coverage, 3482,
     /*  62232 */     GIR_EraseRootFromParent_Done,
     /*  62233 */   // Label 1299: @62233
     /*  62233 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(62308), // Rule ID 3484 //
     /*  62238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62267 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62306 */     GIR_RootConstrainSelectedInstOperands,
     /*  62307 */     // GIR_Coverage, 3484,
     /*  62307 */     GIR_EraseRootFromParent_Done,
     /*  62308 */   // Label 1300: @62308
     /*  62308 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(62383), // Rule ID 4752 //
     /*  62313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62342 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3571:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62381 */     GIR_RootConstrainSelectedInstOperands,
     /*  62382 */     // GIR_Coverage, 4752,
     /*  62382 */     GIR_EraseRootFromParent_Done,
     /*  62383 */   // Label 1301: @62383
     /*  62383 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(62458), // Rule ID 4757 //
     /*  62388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62417 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3571:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62456 */     GIR_RootConstrainSelectedInstOperands,
     /*  62457 */     // GIR_Coverage, 4757,
     /*  62457 */     GIR_EraseRootFromParent_Done,
     /*  62458 */   // Label 1302: @62458
     /*  62458 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(62533), // Rule ID 4759 //
     /*  62463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3571:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62531 */     GIR_RootConstrainSelectedInstOperands,
     /*  62532 */     // GIR_Coverage, 4759,
     /*  62532 */     GIR_EraseRootFromParent_Done,
     /*  62533 */   // Label 1303: @62533
     /*  62533 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(62608), // Rule ID 4761 //
     /*  62538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62567 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3571:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62606 */     GIR_RootConstrainSelectedInstOperands,
     /*  62607 */     // GIR_Coverage, 4761,
     /*  62607 */     GIR_EraseRootFromParent_Done,
     /*  62608 */   // Label 1304: @62608
     /*  62608 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(62683), // Rule ID 4763 //
     /*  62613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62642 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3571:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62681 */     GIR_RootConstrainSelectedInstOperands,
     /*  62682 */     // GIR_Coverage, 4763,
     /*  62682 */     GIR_EraseRootFromParent_Done,
     /*  62683 */   // Label 1305: @62683
     /*  62683 */   GIM_Reject,
     /*  62684 */ // Label 950: @62684
     /*  62684 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(73607),
     /*  62689 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62692 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(62782), // Rule ID 3913 //
     /*  62697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62734 */     // MIs[1] Operand 1
     /*  62734 */     // No operand predicates
     /*  62734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62740 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3648:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62757 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62780 */     GIR_RootConstrainSelectedInstOperands,
     /*  62781 */     // GIR_Coverage, 3913,
     /*  62781 */     GIR_EraseRootFromParent_Done,
     /*  62782 */   // Label 1307: @62782
     /*  62782 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(62872), // Rule ID 3915 //
     /*  62787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62824 */     // MIs[1] Operand 1
     /*  62824 */     // No operand predicates
     /*  62824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62830 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3648:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62847 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62870 */     GIR_RootConstrainSelectedInstOperands,
     /*  62871 */     // GIR_Coverage, 3915,
     /*  62871 */     GIR_EraseRootFromParent_Done,
     /*  62872 */   // Label 1308: @62872
     /*  62872 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62962), // Rule ID 3917 //
     /*  62877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62914 */     // MIs[1] Operand 1
     /*  62914 */     // No operand predicates
     /*  62914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62920 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3648:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62960 */     GIR_RootConstrainSelectedInstOperands,
     /*  62961 */     // GIR_Coverage, 3917,
     /*  62961 */     GIR_EraseRootFromParent_Done,
     /*  62962 */   // Label 1309: @62962
     /*  62962 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(63052), // Rule ID 3919 //
     /*  62967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  63004 */     // MIs[1] Operand 1
     /*  63004 */     // No operand predicates
     /*  63004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63010 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3648:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  63010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  63025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63027 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63050 */     GIR_RootConstrainSelectedInstOperands,
     /*  63051 */     // GIR_Coverage, 3919,
     /*  63051 */     GIR_EraseRootFromParent_Done,
     /*  63052 */   // Label 1310: @63052
     /*  63052 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(63142), // Rule ID 3921 //
     /*  63057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63094 */     // MIs[1] Operand 1
     /*  63094 */     // No operand predicates
     /*  63094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63100 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3648:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  63115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63140 */     GIR_RootConstrainSelectedInstOperands,
     /*  63141 */     // GIR_Coverage, 3921,
     /*  63141 */     GIR_EraseRootFromParent_Done,
     /*  63142 */   // Label 1311: @63142
     /*  63142 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(63232), // Rule ID 3923 //
     /*  63147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63184 */     // MIs[1] Operand 1
     /*  63184 */     // No operand predicates
     /*  63184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63190 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3648:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  63205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63207 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63230 */     GIR_RootConstrainSelectedInstOperands,
     /*  63231 */     // GIR_Coverage, 3923,
     /*  63231 */     GIR_EraseRootFromParent_Done,
     /*  63232 */   // Label 1312: @63232
     /*  63232 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(63322), // Rule ID 3931 //
     /*  63237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63274 */     // MIs[1] Operand 1
     /*  63274 */     // No operand predicates
     /*  63274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63280 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3665:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63297 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63320 */     GIR_RootConstrainSelectedInstOperands,
     /*  63321 */     // GIR_Coverage, 3931,
     /*  63321 */     GIR_EraseRootFromParent_Done,
     /*  63322 */   // Label 1313: @63322
     /*  63322 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(63412), // Rule ID 3933 //
     /*  63327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63364 */     // MIs[1] Operand 1
     /*  63364 */     // No operand predicates
     /*  63364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63370 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3665:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63387 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63410 */     GIR_RootConstrainSelectedInstOperands,
     /*  63411 */     // GIR_Coverage, 3933,
     /*  63411 */     GIR_EraseRootFromParent_Done,
     /*  63412 */   // Label 1314: @63412
     /*  63412 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(63502), // Rule ID 3935 //
     /*  63417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63454 */     // MIs[1] Operand 1
     /*  63454 */     // No operand predicates
     /*  63454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63460 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3665:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63477 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63500 */     GIR_RootConstrainSelectedInstOperands,
     /*  63501 */     // GIR_Coverage, 3935,
     /*  63501 */     GIR_EraseRootFromParent_Done,
     /*  63502 */   // Label 1315: @63502
     /*  63502 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(63592), // Rule ID 3937 //
     /*  63507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63544 */     // MIs[1] Operand 1
     /*  63544 */     // No operand predicates
     /*  63544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63550 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3665:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63567 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63590 */     GIR_RootConstrainSelectedInstOperands,
     /*  63591 */     // GIR_Coverage, 3937,
     /*  63591 */     GIR_EraseRootFromParent_Done,
     /*  63592 */   // Label 1316: @63592
     /*  63592 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(63682), // Rule ID 3939 //
     /*  63597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63634 */     // MIs[1] Operand 1
     /*  63634 */     // No operand predicates
     /*  63634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63640 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3665:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63657 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63680 */     GIR_RootConstrainSelectedInstOperands,
     /*  63681 */     // GIR_Coverage, 3939,
     /*  63681 */     GIR_EraseRootFromParent_Done,
     /*  63682 */   // Label 1317: @63682
     /*  63682 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(63772), // Rule ID 3941 //
     /*  63687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63724 */     // MIs[1] Operand 1
     /*  63724 */     // No operand predicates
     /*  63724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63730 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3665:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63747 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63770 */     GIR_RootConstrainSelectedInstOperands,
     /*  63771 */     // GIR_Coverage, 3941,
     /*  63771 */     GIR_EraseRootFromParent_Done,
     /*  63772 */   // Label 1318: @63772
     /*  63772 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(63861), // Rule ID 4039 //
     /*  63777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63817 */     // MIs[1] Operand 1
     /*  63817 */     // No operand predicates
     /*  63817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63819 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3584:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63859 */     GIR_RootConstrainSelectedInstOperands,
     /*  63860 */     // GIR_Coverage, 4039,
     /*  63860 */     GIR_EraseRootFromParent_Done,
     /*  63861 */   // Label 1319: @63861
     /*  63861 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(63950), // Rule ID 4041 //
     /*  63866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63906 */     // MIs[1] Operand 1
     /*  63906 */     // No operand predicates
     /*  63906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63908 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3584:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63948 */     GIR_RootConstrainSelectedInstOperands,
     /*  63949 */     // GIR_Coverage, 4041,
     /*  63949 */     GIR_EraseRootFromParent_Done,
     /*  63950 */   // Label 1320: @63950
     /*  63950 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(64039), // Rule ID 4043 //
     /*  63955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63995 */     // MIs[1] Operand 1
     /*  63995 */     // No operand predicates
     /*  63995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63997 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3584:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  64012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64037 */     GIR_RootConstrainSelectedInstOperands,
     /*  64038 */     // GIR_Coverage, 4043,
     /*  64038 */     GIR_EraseRootFromParent_Done,
     /*  64039 */   // Label 1321: @64039
     /*  64039 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(64128), // Rule ID 4045 //
     /*  64044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64084 */     // MIs[1] Operand 1
     /*  64084 */     // No operand predicates
     /*  64084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64086 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3584:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  64101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64126 */     GIR_RootConstrainSelectedInstOperands,
     /*  64127 */     // GIR_Coverage, 4045,
     /*  64127 */     GIR_EraseRootFromParent_Done,
     /*  64128 */   // Label 1322: @64128
     /*  64128 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(64217), // Rule ID 4047 //
     /*  64133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64173 */     // MIs[1] Operand 1
     /*  64173 */     // No operand predicates
     /*  64173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64175 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3584:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  64190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64215 */     GIR_RootConstrainSelectedInstOperands,
     /*  64216 */     // GIR_Coverage, 4047,
     /*  64216 */     GIR_EraseRootFromParent_Done,
     /*  64217 */   // Label 1323: @64217
     /*  64217 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(64306), // Rule ID 4049 //
     /*  64222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64262 */     // MIs[1] Operand 1
     /*  64262 */     // No operand predicates
     /*  64262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64264 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3584:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64295 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64304 */     GIR_RootConstrainSelectedInstOperands,
     /*  64305 */     // GIR_Coverage, 4049,
     /*  64305 */     GIR_EraseRootFromParent_Done,
     /*  64306 */   // Label 1324: @64306
     /*  64306 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(64395), // Rule ID 4051 //
     /*  64311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64351 */     // MIs[1] Operand 1
     /*  64351 */     // No operand predicates
     /*  64351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64353 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3584:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64372 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64393 */     GIR_RootConstrainSelectedInstOperands,
     /*  64394 */     // GIR_Coverage, 4051,
     /*  64394 */     GIR_EraseRootFromParent_Done,
     /*  64395 */   // Label 1325: @64395
     /*  64395 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(64484), // Rule ID 4053 //
     /*  64400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64440 */     // MIs[1] Operand 1
     /*  64440 */     // No operand predicates
     /*  64440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64442 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3584:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64482 */     GIR_RootConstrainSelectedInstOperands,
     /*  64483 */     // GIR_Coverage, 4053,
     /*  64483 */     GIR_EraseRootFromParent_Done,
     /*  64484 */   // Label 1326: @64484
     /*  64484 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(64551), // Rule ID 3118 //
     /*  64489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64525 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64530 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64532 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64549 */     GIR_RootConstrainSelectedInstOperands,
     /*  64550 */     // GIR_Coverage, 3118,
     /*  64550 */     GIR_EraseRootFromParent_Done,
     /*  64551 */   // Label 1327: @64551
     /*  64551 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(64618), // Rule ID 3120 //
     /*  64556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64592 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64597 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64599 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64616 */     GIR_RootConstrainSelectedInstOperands,
     /*  64617 */     // GIR_Coverage, 3120,
     /*  64617 */     GIR_EraseRootFromParent_Done,
     /*  64618 */   // Label 1328: @64618
     /*  64618 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(64685), // Rule ID 3122 //
     /*  64623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64659 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64664 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64666 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64683 */     GIR_RootConstrainSelectedInstOperands,
     /*  64684 */     // GIR_Coverage, 3122,
     /*  64684 */     GIR_EraseRootFromParent_Done,
     /*  64685 */   // Label 1329: @64685
     /*  64685 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(64752), // Rule ID 3124 //
     /*  64690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64726 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64731 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64733 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64750 */     GIR_RootConstrainSelectedInstOperands,
     /*  64751 */     // GIR_Coverage, 3124,
     /*  64751 */     GIR_EraseRootFromParent_Done,
     /*  64752 */   // Label 1330: @64752
     /*  64752 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(64819), // Rule ID 3126 //
     /*  64757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64793 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64798 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64800 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64817 */     GIR_RootConstrainSelectedInstOperands,
     /*  64818 */     // GIR_Coverage, 3126,
     /*  64818 */     GIR_EraseRootFromParent_Done,
     /*  64819 */   // Label 1331: @64819
     /*  64819 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(64886), // Rule ID 3128 //
     /*  64824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64856 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64860 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64865 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64867 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64884 */     GIR_RootConstrainSelectedInstOperands,
     /*  64885 */     // GIR_Coverage, 3128,
     /*  64885 */     GIR_EraseRootFromParent_Done,
     /*  64886 */   // Label 1332: @64886
     /*  64886 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64953), // Rule ID 3130 //
     /*  64891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64927 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64932 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64934 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64951 */     GIR_RootConstrainSelectedInstOperands,
     /*  64952 */     // GIR_Coverage, 3130,
     /*  64952 */     GIR_EraseRootFromParent_Done,
     /*  64953 */   // Label 1333: @64953
     /*  64953 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(65020), // Rule ID 3132 //
     /*  64958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64990 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64994 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  64997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64999 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65001 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65018 */     GIR_RootConstrainSelectedInstOperands,
     /*  65019 */     // GIR_Coverage, 3132,
     /*  65019 */     GIR_EraseRootFromParent_Done,
     /*  65020 */   // Label 1334: @65020
     /*  65020 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(65087), // Rule ID 3134 //
     /*  65025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65061 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  65064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65066 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65068 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65085 */     GIR_RootConstrainSelectedInstOperands,
     /*  65086 */     // GIR_Coverage, 3134,
     /*  65086 */     GIR_EraseRootFromParent_Done,
     /*  65087 */   // Label 1335: @65087
     /*  65087 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(65154), // Rule ID 3136 //
     /*  65092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65124 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65128 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  65131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65133 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65135 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65140 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65152 */     GIR_RootConstrainSelectedInstOperands,
     /*  65153 */     // GIR_Coverage, 3136,
     /*  65153 */     GIR_EraseRootFromParent_Done,
     /*  65154 */   // Label 1336: @65154
     /*  65154 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(65221), // Rule ID 3138 //
     /*  65159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65195 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  65198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65200 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65202 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65213 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65219 */     GIR_RootConstrainSelectedInstOperands,
     /*  65220 */     // GIR_Coverage, 3138,
     /*  65220 */     GIR_EraseRootFromParent_Done,
     /*  65221 */   // Label 1337: @65221
     /*  65221 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(65288), // Rule ID 3140 //
     /*  65226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65262 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65267 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65269 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65286 */     GIR_RootConstrainSelectedInstOperands,
     /*  65287 */     // GIR_Coverage, 3140,
     /*  65287 */     GIR_EraseRootFromParent_Done,
     /*  65288 */   // Label 1338: @65288
     /*  65288 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(65370), // Rule ID 3545 //
     /*  65293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65329 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3568:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65368 */     GIR_RootConstrainSelectedInstOperands,
     /*  65369 */     // GIR_Coverage, 3545,
     /*  65369 */     GIR_EraseRootFromParent_Done,
     /*  65370 */   // Label 1339: @65370
     /*  65370 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(65452), // Rule ID 3552 //
     /*  65375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65411 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3568:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65450 */     GIR_RootConstrainSelectedInstOperands,
     /*  65451 */     // GIR_Coverage, 3552,
     /*  65451 */     GIR_EraseRootFromParent_Done,
     /*  65452 */   // Label 1340: @65452
     /*  65452 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(65534), // Rule ID 3556 //
     /*  65457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65493 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3568:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65532 */     GIR_RootConstrainSelectedInstOperands,
     /*  65533 */     // GIR_Coverage, 3556,
     /*  65533 */     GIR_EraseRootFromParent_Done,
     /*  65534 */   // Label 1341: @65534
     /*  65534 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(65616), // Rule ID 3560 //
     /*  65539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65575 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3568:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65614 */     GIR_RootConstrainSelectedInstOperands,
     /*  65615 */     // GIR_Coverage, 3560,
     /*  65615 */     GIR_EraseRootFromParent_Done,
     /*  65616 */   // Label 1342: @65616
     /*  65616 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(65698), // Rule ID 3564 //
     /*  65621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65657 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3568:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65696 */     GIR_RootConstrainSelectedInstOperands,
     /*  65697 */     // GIR_Coverage, 3564,
     /*  65697 */     GIR_EraseRootFromParent_Done,
     /*  65698 */   // Label 1343: @65698
     /*  65698 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(65780), // Rule ID 3568 //
     /*  65703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65739 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3568:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65778 */     GIR_RootConstrainSelectedInstOperands,
     /*  65779 */     // GIR_Coverage, 3568,
     /*  65779 */     GIR_EraseRootFromParent_Done,
     /*  65780 */   // Label 1344: @65780
     /*  65780 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(65862), // Rule ID 3569 //
     /*  65785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65821 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3654:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65860 */     GIR_RootConstrainSelectedInstOperands,
     /*  65861 */     // GIR_Coverage, 3569,
     /*  65861 */     GIR_EraseRootFromParent_Done,
     /*  65862 */   // Label 1345: @65862
     /*  65862 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(65944), // Rule ID 3576 //
     /*  65867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65903 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3654:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65942 */     GIR_RootConstrainSelectedInstOperands,
     /*  65943 */     // GIR_Coverage, 3576,
     /*  65943 */     GIR_EraseRootFromParent_Done,
     /*  65944 */   // Label 1346: @65944
     /*  65944 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(66026), // Rule ID 3580 //
     /*  65949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65985 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3654:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  66000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66024 */     GIR_RootConstrainSelectedInstOperands,
     /*  66025 */     // GIR_Coverage, 3580,
     /*  66025 */     GIR_EraseRootFromParent_Done,
     /*  66026 */   // Label 1347: @66026
     /*  66026 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(66108), // Rule ID 3584 //
     /*  66031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66067 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3654:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  66082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66106 */     GIR_RootConstrainSelectedInstOperands,
     /*  66107 */     // GIR_Coverage, 3584,
     /*  66107 */     GIR_EraseRootFromParent_Done,
     /*  66108 */   // Label 1348: @66108
     /*  66108 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(66190), // Rule ID 3588 //
     /*  66113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66149 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3654:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  66164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66188 */     GIR_RootConstrainSelectedInstOperands,
     /*  66189 */     // GIR_Coverage, 3588,
     /*  66189 */     GIR_EraseRootFromParent_Done,
     /*  66190 */   // Label 1349: @66190
     /*  66190 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(66272), // Rule ID 3592 //
     /*  66195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66231 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3654:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66270 */     GIR_RootConstrainSelectedInstOperands,
     /*  66271 */     // GIR_Coverage, 3592,
     /*  66271 */     GIR_EraseRootFromParent_Done,
     /*  66272 */   // Label 1350: @66272
     /*  66272 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(66354), // Rule ID 3593 //
     /*  66277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66313 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3603:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66352 */     GIR_RootConstrainSelectedInstOperands,
     /*  66353 */     // GIR_Coverage, 3593,
     /*  66353 */     GIR_EraseRootFromParent_Done,
     /*  66354 */   // Label 1351: @66354
     /*  66354 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(66436), // Rule ID 3600 //
     /*  66359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66395 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66434 */     GIR_RootConstrainSelectedInstOperands,
     /*  66435 */     // GIR_Coverage, 3600,
     /*  66435 */     GIR_EraseRootFromParent_Done,
     /*  66436 */   // Label 1352: @66436
     /*  66436 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(66518), // Rule ID 3604 //
     /*  66441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66477 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66501 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66516 */     GIR_RootConstrainSelectedInstOperands,
     /*  66517 */     // GIR_Coverage, 3604,
     /*  66517 */     GIR_EraseRootFromParent_Done,
     /*  66518 */   // Label 1353: @66518
     /*  66518 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(66600), // Rule ID 3608 //
     /*  66523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66555 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66559 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3603:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66598 */     GIR_RootConstrainSelectedInstOperands,
     /*  66599 */     // GIR_Coverage, 3608,
     /*  66599 */     GIR_EraseRootFromParent_Done,
     /*  66600 */   // Label 1354: @66600
     /*  66600 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(66682), // Rule ID 3612 //
     /*  66605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66641 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66680 */     GIR_RootConstrainSelectedInstOperands,
     /*  66681 */     // GIR_Coverage, 3612,
     /*  66681 */     GIR_EraseRootFromParent_Done,
     /*  66682 */   // Label 1355: @66682
     /*  66682 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(66764), // Rule ID 3616 //
     /*  66687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66723 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66762 */     GIR_RootConstrainSelectedInstOperands,
     /*  66763 */     // GIR_Coverage, 3616,
     /*  66763 */     GIR_EraseRootFromParent_Done,
     /*  66764 */   // Label 1356: @66764
     /*  66764 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(66846), // Rule ID 3617 //
     /*  66769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66805 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3604:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66844 */     GIR_RootConstrainSelectedInstOperands,
     /*  66845 */     // GIR_Coverage, 3617,
     /*  66845 */     GIR_EraseRootFromParent_Done,
     /*  66846 */   // Label 1357: @66846
     /*  66846 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(66928), // Rule ID 3620 //
     /*  66851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66883 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66887 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3604:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66926 */     GIR_RootConstrainSelectedInstOperands,
     /*  66927 */     // GIR_Coverage, 3620,
     /*  66927 */     GIR_EraseRootFromParent_Done,
     /*  66928 */   // Label 1358: @66928
     /*  66928 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(67010), // Rule ID 3623 //
     /*  66933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66969 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3604:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67008 */     GIR_RootConstrainSelectedInstOperands,
     /*  67009 */     // GIR_Coverage, 3623,
     /*  67009 */     GIR_EraseRootFromParent_Done,
     /*  67010 */   // Label 1359: @67010
     /*  67010 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(67092), // Rule ID 3626 //
     /*  67015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67051 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3604:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  67066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67090 */     GIR_RootConstrainSelectedInstOperands,
     /*  67091 */     // GIR_Coverage, 3626,
     /*  67091 */     GIR_EraseRootFromParent_Done,
     /*  67092 */   // Label 1360: @67092
     /*  67092 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(67174), // Rule ID 3629 //
     /*  67097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67133 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3604:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  67148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67172 */     GIR_RootConstrainSelectedInstOperands,
     /*  67173 */     // GIR_Coverage, 3629,
     /*  67173 */     GIR_EraseRootFromParent_Done,
     /*  67174 */   // Label 1361: @67174
     /*  67174 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(67256), // Rule ID 3632 //
     /*  67179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67215 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3604:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67254 */     GIR_RootConstrainSelectedInstOperands,
     /*  67255 */     // GIR_Coverage, 3632,
     /*  67255 */     GIR_EraseRootFromParent_Done,
     /*  67256 */   // Label 1362: @67256
     /*  67256 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(67338), // Rule ID 4033 //
     /*  67261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67297 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3568:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67336 */     GIR_RootConstrainSelectedInstOperands,
     /*  67337 */     // GIR_Coverage, 4033,
     /*  67337 */     GIR_EraseRootFromParent_Done,
     /*  67338 */   // Label 1363: @67338
     /*  67338 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(67420), // Rule ID 4035 //
     /*  67343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67379 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3568:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67418 */     GIR_RootConstrainSelectedInstOperands,
     /*  67419 */     // GIR_Coverage, 4035,
     /*  67419 */     GIR_EraseRootFromParent_Done,
     /*  67420 */   // Label 1364: @67420
     /*  67420 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(67502), // Rule ID 4408 //
     /*  67425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67461 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67500 */     GIR_RootConstrainSelectedInstOperands,
     /*  67501 */     // GIR_Coverage, 4408,
     /*  67501 */     GIR_EraseRootFromParent_Done,
     /*  67502 */   // Label 1365: @67502
     /*  67502 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(67584), // Rule ID 4410 //
     /*  67507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67543 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67582 */     GIR_RootConstrainSelectedInstOperands,
     /*  67583 */     // GIR_Coverage, 4410,
     /*  67583 */     GIR_EraseRootFromParent_Done,
     /*  67584 */   // Label 1366: @67584
     /*  67584 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(67666), // Rule ID 4412 //
     /*  67589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67625 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67664 */     GIR_RootConstrainSelectedInstOperands,
     /*  67665 */     // GIR_Coverage, 4412,
     /*  67665 */     GIR_EraseRootFromParent_Done,
     /*  67666 */   // Label 1367: @67666
     /*  67666 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(67748), // Rule ID 4414 //
     /*  67671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67707 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67746 */     GIR_RootConstrainSelectedInstOperands,
     /*  67747 */     // GIR_Coverage, 4414,
     /*  67747 */     GIR_EraseRootFromParent_Done,
     /*  67748 */   // Label 1368: @67748
     /*  67748 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(67830), // Rule ID 4441 //
     /*  67753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67789 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3629:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67828 */     GIR_RootConstrainSelectedInstOperands,
     /*  67829 */     // GIR_Coverage, 4441,
     /*  67829 */     GIR_EraseRootFromParent_Done,
     /*  67830 */   // Label 1369: @67830
     /*  67830 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(67912), // Rule ID 4448 //
     /*  67835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67871 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67890 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67910 */     GIR_RootConstrainSelectedInstOperands,
     /*  67911 */     // GIR_Coverage, 4448,
     /*  67911 */     GIR_EraseRootFromParent_Done,
     /*  67912 */   // Label 1370: @67912
     /*  67912 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(67994), // Rule ID 4452 //
     /*  67917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67949 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67953 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67992 */     GIR_RootConstrainSelectedInstOperands,
     /*  67993 */     // GIR_Coverage, 4452,
     /*  67993 */     GIR_EraseRootFromParent_Done,
     /*  67994 */   // Label 1371: @67994
     /*  67994 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(68076), // Rule ID 4456 //
     /*  67999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68031 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68035 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3629:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  68050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68074 */     GIR_RootConstrainSelectedInstOperands,
     /*  68075 */     // GIR_Coverage, 4456,
     /*  68075 */     GIR_EraseRootFromParent_Done,
     /*  68076 */   // Label 1372: @68076
     /*  68076 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(68158), // Rule ID 4460 //
     /*  68081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68117 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  68132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68156 */     GIR_RootConstrainSelectedInstOperands,
     /*  68157 */     // GIR_Coverage, 4460,
     /*  68157 */     GIR_EraseRootFromParent_Done,
     /*  68158 */   // Label 1373: @68158
     /*  68158 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(68240), // Rule ID 4464 //
     /*  68163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68199 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68238 */     GIR_RootConstrainSelectedInstOperands,
     /*  68239 */     // GIR_Coverage, 4464,
     /*  68239 */     GIR_EraseRootFromParent_Done,
     /*  68240 */   // Label 1374: @68240
     /*  68240 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(68322), // Rule ID 4465 //
     /*  68245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68281 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68320 */     GIR_RootConstrainSelectedInstOperands,
     /*  68321 */     // GIR_Coverage, 4465,
     /*  68321 */     GIR_EraseRootFromParent_Done,
     /*  68322 */   // Label 1375: @68322
     /*  68322 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(68404), // Rule ID 4467 //
     /*  68327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68363 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68402 */     GIR_RootConstrainSelectedInstOperands,
     /*  68403 */     // GIR_Coverage, 4467,
     /*  68403 */     GIR_EraseRootFromParent_Done,
     /*  68404 */   // Label 1376: @68404
     /*  68404 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(68486), // Rule ID 4469 //
     /*  68409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68445 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68445 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68448 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68452 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68484 */     GIR_RootConstrainSelectedInstOperands,
     /*  68485 */     // GIR_Coverage, 4469,
     /*  68485 */     GIR_EraseRootFromParent_Done,
     /*  68486 */   // Label 1377: @68486
     /*  68486 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(68568), // Rule ID 4471 //
     /*  68491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68527 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68566 */     GIR_RootConstrainSelectedInstOperands,
     /*  68567 */     // GIR_Coverage, 4471,
     /*  68567 */     GIR_EraseRootFromParent_Done,
     /*  68568 */   // Label 1378: @68568
     /*  68568 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(68650), // Rule ID 4473 //
     /*  68573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68609 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68648 */     GIR_RootConstrainSelectedInstOperands,
     /*  68649 */     // GIR_Coverage, 4473,
     /*  68649 */     GIR_EraseRootFromParent_Done,
     /*  68650 */   // Label 1379: @68650
     /*  68650 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(68732), // Rule ID 4475 //
     /*  68655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68691 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68730 */     GIR_RootConstrainSelectedInstOperands,
     /*  68731 */     // GIR_Coverage, 4475,
     /*  68731 */     GIR_EraseRootFromParent_Done,
     /*  68732 */   // Label 1380: @68732
     /*  68732 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(68799), // Rule ID 4526 //
     /*  68737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68773 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3587:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68797 */     GIR_RootConstrainSelectedInstOperands,
     /*  68798 */     // GIR_Coverage, 4526,
     /*  68798 */     GIR_EraseRootFromParent_Done,
     /*  68799 */   // Label 1381: @68799
     /*  68799 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(68866), // Rule ID 4532 //
     /*  68804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68840 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3587:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68864 */     GIR_RootConstrainSelectedInstOperands,
     /*  68865 */     // GIR_Coverage, 4532,
     /*  68865 */     GIR_EraseRootFromParent_Done,
     /*  68866 */   // Label 1382: @68866
     /*  68866 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(68948), // Rule ID 4550 //
     /*  68871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68907 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68946 */     GIR_RootConstrainSelectedInstOperands,
     /*  68947 */     // GIR_Coverage, 4550,
     /*  68947 */     GIR_EraseRootFromParent_Done,
     /*  68948 */   // Label 1383: @68948
     /*  68948 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(69030), // Rule ID 4552 //
     /*  68953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68989 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  69004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69028 */     GIR_RootConstrainSelectedInstOperands,
     /*  69029 */     // GIR_Coverage, 4552,
     /*  69029 */     GIR_EraseRootFromParent_Done,
     /*  69030 */   // Label 1384: @69030
     /*  69030 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(69112), // Rule ID 4554 //
     /*  69035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69071 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3639:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  69086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69095 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69110 */     GIR_RootConstrainSelectedInstOperands,
     /*  69111 */     // GIR_Coverage, 4554,
     /*  69111 */     GIR_EraseRootFromParent_Done,
     /*  69112 */   // Label 1385: @69112
     /*  69112 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(69194), // Rule ID 4556 //
     /*  69117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69153 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3639:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  69168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69192 */     GIR_RootConstrainSelectedInstOperands,
     /*  69193 */     // GIR_Coverage, 4556,
     /*  69193 */     GIR_EraseRootFromParent_Done,
     /*  69194 */   // Label 1386: @69194
     /*  69194 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(69271), // Rule ID 3901 //
     /*  69199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69240 */     // MIs[1] Operand 1
     /*  69240 */     // No operand predicates
     /*  69240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69247 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69269 */     GIR_RootConstrainSelectedInstOperands,
     /*  69270 */     // GIR_Coverage, 3901,
     /*  69270 */     GIR_EraseRootFromParent_Done,
     /*  69271 */   // Label 1387: @69271
     /*  69271 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(69348), // Rule ID 3903 //
     /*  69276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69317 */     // MIs[1] Operand 1
     /*  69317 */     // No operand predicates
     /*  69317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69319 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69324 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69340 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69346 */     GIR_RootConstrainSelectedInstOperands,
     /*  69347 */     // GIR_Coverage, 3903,
     /*  69347 */     GIR_EraseRootFromParent_Done,
     /*  69348 */   // Label 1388: @69348
     /*  69348 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(69425), // Rule ID 3905 //
     /*  69353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69394 */     // MIs[1] Operand 1
     /*  69394 */     // No operand predicates
     /*  69394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69396 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69401 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69423 */     GIR_RootConstrainSelectedInstOperands,
     /*  69424 */     // GIR_Coverage, 3905,
     /*  69424 */     GIR_EraseRootFromParent_Done,
     /*  69425 */   // Label 1389: @69425
     /*  69425 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(69502), // Rule ID 3907 //
     /*  69430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69471 */     // MIs[1] Operand 1
     /*  69471 */     // No operand predicates
     /*  69471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69473 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3681:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69478 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69500 */     GIR_RootConstrainSelectedInstOperands,
     /*  69501 */     // GIR_Coverage, 3907,
     /*  69501 */     GIR_EraseRootFromParent_Done,
     /*  69502 */   // Label 1390: @69502
     /*  69502 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(69579), // Rule ID 3909 //
     /*  69507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69544 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69548 */     // MIs[1] Operand 1
     /*  69548 */     // No operand predicates
     /*  69548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69550 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3681:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69555 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69577 */     GIR_RootConstrainSelectedInstOperands,
     /*  69578 */     // GIR_Coverage, 3909,
     /*  69578 */     GIR_EraseRootFromParent_Done,
     /*  69579 */   // Label 1391: @69579
     /*  69579 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(69656), // Rule ID 3911 //
     /*  69584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69625 */     // MIs[1] Operand 1
     /*  69625 */     // No operand predicates
     /*  69625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69627 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69632 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69654 */     GIR_RootConstrainSelectedInstOperands,
     /*  69655 */     // GIR_Coverage, 3911,
     /*  69655 */     GIR_EraseRootFromParent_Done,
     /*  69656 */   // Label 1392: @69656
     /*  69656 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(69747), // Rule ID 4380 //
     /*  69661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69693 */     // MIs[1] Operand 1
     /*  69693 */     // No operand predicates
     /*  69693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69703 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3578:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69745 */     GIR_RootConstrainSelectedInstOperands,
     /*  69746 */     // GIR_Coverage, 4380,
     /*  69746 */     GIR_EraseRootFromParent_Done,
     /*  69747 */   // Label 1393: @69747
     /*  69747 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(69838), // Rule ID 4382 //
     /*  69752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69784 */     // MIs[1] Operand 1
     /*  69784 */     // No operand predicates
     /*  69784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69794 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3578:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69836 */     GIR_RootConstrainSelectedInstOperands,
     /*  69837 */     // GIR_Coverage, 4382,
     /*  69837 */     GIR_EraseRootFromParent_Done,
     /*  69838 */   // Label 1394: @69838
     /*  69838 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(69901), // Rule ID 146 //
     /*  69843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69879 */     // (intrinsic_wo_chain:{ *:[i32] } 3911:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69899 */     GIR_RootConstrainSelectedInstOperands,
     /*  69900 */     // GIR_Coverage, 146,
     /*  69900 */     GIR_EraseRootFromParent_Done,
     /*  69901 */   // Label 1395: @69901
     /*  69901 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(69964), // Rule ID 469 //
     /*  69906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69942 */     // (intrinsic_wo_chain:{ *:[i32] } 3911:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69962 */     GIR_RootConstrainSelectedInstOperands,
     /*  69963 */     // GIR_Coverage, 469,
     /*  69963 */     GIR_EraseRootFromParent_Done,
     /*  69964 */   // Label 1396: @69964
     /*  69964 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(70027), // Rule ID 528 //
     /*  69969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70005 */     // (intrinsic_wo_chain:{ *:[i32] } 3856:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  70008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70025 */     GIR_RootConstrainSelectedInstOperands,
     /*  70026 */     // GIR_Coverage, 528,
     /*  70026 */     GIR_EraseRootFromParent_Done,
     /*  70027 */   // Label 1397: @70027
     /*  70027 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(70090), // Rule ID 529 //
     /*  70032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70068 */     // (intrinsic_wo_chain:{ *:[i32] } 3857:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  70071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70088 */     GIR_RootConstrainSelectedInstOperands,
     /*  70089 */     // GIR_Coverage, 529,
     /*  70089 */     GIR_EraseRootFromParent_Done,
     /*  70090 */   // Label 1398: @70090
     /*  70090 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(70153), // Rule ID 530 //
     /*  70095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70131 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  70134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70151 */     GIR_RootConstrainSelectedInstOperands,
     /*  70152 */     // GIR_Coverage, 530,
     /*  70152 */     GIR_EraseRootFromParent_Done,
     /*  70153 */   // Label 1399: @70153
     /*  70153 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(70216), // Rule ID 531 //
     /*  70158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70194 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  70197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70214 */     GIR_RootConstrainSelectedInstOperands,
     /*  70215 */     // GIR_Coverage, 531,
     /*  70215 */     GIR_EraseRootFromParent_Done,
     /*  70216 */   // Label 1400: @70216
     /*  70216 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(70270), // Rule ID 948 //
     /*  70221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70257 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3711:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70268 */     GIR_RootConstrainSelectedInstOperands,
     /*  70269 */     // GIR_Coverage, 948,
     /*  70269 */     GIR_EraseRootFromParent_Done,
     /*  70270 */   // Label 1401: @70270
     /*  70270 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(70324), // Rule ID 949 //
     /*  70275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70311 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3699:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70322 */     GIR_RootConstrainSelectedInstOperands,
     /*  70323 */     // GIR_Coverage, 949,
     /*  70323 */     GIR_EraseRootFromParent_Done,
     /*  70324 */   // Label 1402: @70324
     /*  70324 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(70378), // Rule ID 950 //
     /*  70329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70365 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3711:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70376 */     GIR_RootConstrainSelectedInstOperands,
     /*  70377 */     // GIR_Coverage, 950,
     /*  70377 */     GIR_EraseRootFromParent_Done,
     /*  70378 */   // Label 1403: @70378
     /*  70378 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(70432), // Rule ID 951 //
     /*  70383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70419 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3699:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70430 */     GIR_RootConstrainSelectedInstOperands,
     /*  70431 */     // GIR_Coverage, 951,
     /*  70431 */     GIR_EraseRootFromParent_Done,
     /*  70432 */   // Label 1404: @70432
     /*  70432 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(70486), // Rule ID 952 //
     /*  70437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70473 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70484 */     GIR_RootConstrainSelectedInstOperands,
     /*  70485 */     // GIR_Coverage, 952,
     /*  70485 */     GIR_EraseRootFromParent_Done,
     /*  70486 */   // Label 1405: @70486
     /*  70486 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(70540), // Rule ID 953 //
     /*  70491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70527 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3712:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70538 */     GIR_RootConstrainSelectedInstOperands,
     /*  70539 */     // GIR_Coverage, 953,
     /*  70539 */     GIR_EraseRootFromParent_Done,
     /*  70540 */   // Label 1406: @70540
     /*  70540 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(70594), // Rule ID 954 //
     /*  70545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70581 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3714:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70592 */     GIR_RootConstrainSelectedInstOperands,
     /*  70593 */     // GIR_Coverage, 954,
     /*  70593 */     GIR_EraseRootFromParent_Done,
     /*  70594 */   // Label 1407: @70594
     /*  70594 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(70648), // Rule ID 955 //
     /*  70599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70635 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3713:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70646 */     GIR_RootConstrainSelectedInstOperands,
     /*  70647 */     // GIR_Coverage, 955,
     /*  70647 */     GIR_EraseRootFromParent_Done,
     /*  70648 */   // Label 1408: @70648
     /*  70648 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(70702), // Rule ID 956 //
     /*  70653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70689 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3713:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70700 */     GIR_RootConstrainSelectedInstOperands,
     /*  70701 */     // GIR_Coverage, 956,
     /*  70701 */     GIR_EraseRootFromParent_Done,
     /*  70702 */   // Label 1409: @70702
     /*  70702 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70765), // Rule ID 1687 //
     /*  70707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70743 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3831:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70748 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70763 */     GIR_RootConstrainSelectedInstOperands,
     /*  70764 */     // GIR_Coverage, 1687,
     /*  70764 */     GIR_EraseRootFromParent_Done,
     /*  70765 */   // Label 1410: @70765
     /*  70765 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70819), // Rule ID 1718 //
     /*  70770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70806 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70811 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70817 */     GIR_RootConstrainSelectedInstOperands,
     /*  70818 */     // GIR_Coverage, 1718,
     /*  70818 */     GIR_EraseRootFromParent_Done,
     /*  70819 */   // Label 1411: @70819
     /*  70819 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70873), // Rule ID 1719 //
     /*  70824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70860 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70865 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70871 */     GIR_RootConstrainSelectedInstOperands,
     /*  70872 */     // GIR_Coverage, 1719,
     /*  70872 */     GIR_EraseRootFromParent_Done,
     /*  70873 */   // Label 1412: @70873
     /*  70873 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70927), // Rule ID 1720 //
     /*  70878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70914 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70919 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70925 */     GIR_RootConstrainSelectedInstOperands,
     /*  70926 */     // GIR_Coverage, 1720,
     /*  70926 */     GIR_EraseRootFromParent_Done,
     /*  70927 */   // Label 1413: @70927
     /*  70927 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70981), // Rule ID 1721 //
     /*  70932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70968 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3709:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70973 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70979 */     GIR_RootConstrainSelectedInstOperands,
     /*  70980 */     // GIR_Coverage, 1721,
     /*  70980 */     GIR_EraseRootFromParent_Done,
     /*  70981 */   // Label 1414: @70981
     /*  70981 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(71044), // Rule ID 1896 //
     /*  70986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  70994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71022 */     // (intrinsic_wo_chain:{ *:[i32] } 3856:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  71025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71031 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71042 */     GIR_RootConstrainSelectedInstOperands,
     /*  71043 */     // GIR_Coverage, 1896,
     /*  71043 */     GIR_EraseRootFromParent_Done,
     /*  71044 */   // Label 1415: @71044
     /*  71044 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(71107), // Rule ID 1897 //
     /*  71049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  71057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71085 */     // (intrinsic_wo_chain:{ *:[i32] } 3857:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  71088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71105 */     GIR_RootConstrainSelectedInstOperands,
     /*  71106 */     // GIR_Coverage, 1897,
     /*  71106 */     GIR_EraseRootFromParent_Done,
     /*  71107 */   // Label 1416: @71107
     /*  71107 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(71170), // Rule ID 1898 //
     /*  71112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  71120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71148 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  71151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71157 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71168 */     GIR_RootConstrainSelectedInstOperands,
     /*  71169 */     // GIR_Coverage, 1898,
     /*  71169 */     GIR_EraseRootFromParent_Done,
     /*  71170 */   // Label 1417: @71170
     /*  71170 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(71233), // Rule ID 1899 //
     /*  71175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  71183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71211 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71231 */     GIR_RootConstrainSelectedInstOperands,
     /*  71232 */     // GIR_Coverage, 1899,
     /*  71232 */     GIR_EraseRootFromParent_Done,
     /*  71233 */   // Label 1418: @71233
     /*  71233 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(71296), // Rule ID 1987 //
     /*  71238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71274 */     // (intrinsic_wo_chain:{ *:[i32] } 3854:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71279 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71281 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71283 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71294 */     GIR_RootConstrainSelectedInstOperands,
     /*  71295 */     // GIR_Coverage, 1987,
     /*  71295 */     GIR_EraseRootFromParent_Done,
     /*  71296 */   // Label 1419: @71296
     /*  71296 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(71359), // Rule ID 1988 //
     /*  71301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71337 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71342 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71344 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71346 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71357 */     GIR_RootConstrainSelectedInstOperands,
     /*  71358 */     // GIR_Coverage, 1988,
     /*  71358 */     GIR_EraseRootFromParent_Done,
     /*  71359 */   // Label 1420: @71359
     /*  71359 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(71422), // Rule ID 1989 //
     /*  71364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71400 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71405 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71407 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71409 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71420 */     GIR_RootConstrainSelectedInstOperands,
     /*  71421 */     // GIR_Coverage, 1989,
     /*  71421 */     GIR_EraseRootFromParent_Done,
     /*  71422 */   // Label 1421: @71422
     /*  71422 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(71485), // Rule ID 1990 //
     /*  71427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71463 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71468 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71470 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71472 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71483 */     GIR_RootConstrainSelectedInstOperands,
     /*  71484 */     // GIR_Coverage, 1990,
     /*  71484 */     GIR_EraseRootFromParent_Done,
     /*  71485 */   // Label 1422: @71485
     /*  71485 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(71548), // Rule ID 1991 //
     /*  71490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71526 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71531 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71533 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71535 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71546 */     GIR_RootConstrainSelectedInstOperands,
     /*  71547 */     // GIR_Coverage, 1991,
     /*  71547 */     GIR_EraseRootFromParent_Done,
     /*  71548 */   // Label 1423: @71548
     /*  71548 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(71611), // Rule ID 1992 //
     /*  71553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71589 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71594 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71596 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71598 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71609 */     GIR_RootConstrainSelectedInstOperands,
     /*  71610 */     // GIR_Coverage, 1992,
     /*  71610 */     GIR_EraseRootFromParent_Done,
     /*  71611 */   // Label 1424: @71611
     /*  71611 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(71674), // Rule ID 2178 //
     /*  71616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71652 */     // (intrinsic_wo_chain:{ *:[i32] } 3854:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71657 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71659 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71661 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71672 */     GIR_RootConstrainSelectedInstOperands,
     /*  71673 */     // GIR_Coverage, 2178,
     /*  71673 */     GIR_EraseRootFromParent_Done,
     /*  71674 */   // Label 1425: @71674
     /*  71674 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(71737), // Rule ID 2179 //
     /*  71679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71715 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71720 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71722 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71724 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71735 */     GIR_RootConstrainSelectedInstOperands,
     /*  71736 */     // GIR_Coverage, 2179,
     /*  71736 */     GIR_EraseRootFromParent_Done,
     /*  71737 */   // Label 1426: @71737
     /*  71737 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(71800), // Rule ID 2180 //
     /*  71742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71778 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71783 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71785 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71787 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71798 */     GIR_RootConstrainSelectedInstOperands,
     /*  71799 */     // GIR_Coverage, 2180,
     /*  71799 */     GIR_EraseRootFromParent_Done,
     /*  71800 */   // Label 1427: @71800
     /*  71800 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71863), // Rule ID 2181 //
     /*  71805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71841 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71846 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71848 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71850 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71861 */     GIR_RootConstrainSelectedInstOperands,
     /*  71862 */     // GIR_Coverage, 2181,
     /*  71862 */     GIR_EraseRootFromParent_Done,
     /*  71863 */   // Label 1428: @71863
     /*  71863 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71926), // Rule ID 2182 //
     /*  71868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71904 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71909 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71911 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71913 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71924 */     GIR_RootConstrainSelectedInstOperands,
     /*  71925 */     // GIR_Coverage, 2182,
     /*  71925 */     GIR_EraseRootFromParent_Done,
     /*  71926 */   // Label 1429: @71926
     /*  71926 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71989), // Rule ID 2183 //
     /*  71931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71967 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71972 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71974 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71976 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71987 */     GIR_RootConstrainSelectedInstOperands,
     /*  71988 */     // GIR_Coverage, 2183,
     /*  71988 */     GIR_EraseRootFromParent_Done,
     /*  71989 */   // Label 1430: @71989
     /*  71989 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(72052), // Rule ID 2469 //
     /*  71994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  71997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72030 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3783:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  72033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72035 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72050 */     GIR_RootConstrainSelectedInstOperands,
     /*  72051 */     // GIR_Coverage, 2469,
     /*  72051 */     GIR_EraseRootFromParent_Done,
     /*  72052 */   // Label 1431: @72052
     /*  72052 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(72115), // Rule ID 2470 //
     /*  72057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72093 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3783:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  72096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72098 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72113 */     GIR_RootConstrainSelectedInstOperands,
     /*  72114 */     // GIR_Coverage, 2470,
     /*  72114 */     GIR_EraseRootFromParent_Done,
     /*  72115 */   // Label 1432: @72115
     /*  72115 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(72178), // Rule ID 2471 //
     /*  72120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72156 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3783:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  72159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72161 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72176 */     GIR_RootConstrainSelectedInstOperands,
     /*  72177 */     // GIR_Coverage, 2471,
     /*  72177 */     GIR_EraseRootFromParent_Done,
     /*  72178 */   // Label 1433: @72178
     /*  72178 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(72241), // Rule ID 2472 //
     /*  72183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72219 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3783:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72224 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72239 */     GIR_RootConstrainSelectedInstOperands,
     /*  72240 */     // GIR_Coverage, 2472,
     /*  72240 */     GIR_EraseRootFromParent_Done,
     /*  72241 */   // Label 1434: @72241
     /*  72241 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(72304), // Rule ID 2477 //
     /*  72246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72282 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3784:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72287 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72302 */     GIR_RootConstrainSelectedInstOperands,
     /*  72303 */     // GIR_Coverage, 2477,
     /*  72303 */     GIR_EraseRootFromParent_Done,
     /*  72304 */   // Label 1435: @72304
     /*  72304 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(72367), // Rule ID 2478 //
     /*  72309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72345 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3784:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72350 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72365 */     GIR_RootConstrainSelectedInstOperands,
     /*  72366 */     // GIR_Coverage, 2478,
     /*  72366 */     GIR_EraseRootFromParent_Done,
     /*  72367 */   // Label 1436: @72367
     /*  72367 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(72430), // Rule ID 2479 //
     /*  72372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72408 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3784:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72413 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72428 */     GIR_RootConstrainSelectedInstOperands,
     /*  72429 */     // GIR_Coverage, 2479,
     /*  72429 */     GIR_EraseRootFromParent_Done,
     /*  72430 */   // Label 1437: @72430
     /*  72430 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(72493), // Rule ID 2480 //
     /*  72435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3784:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72476 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72480 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72491 */     GIR_RootConstrainSelectedInstOperands,
     /*  72492 */     // GIR_Coverage, 2480,
     /*  72492 */     GIR_EraseRootFromParent_Done,
     /*  72493 */   // Label 1438: @72493
     /*  72493 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(72562), // Rule ID 4837 //
     /*  72498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72534 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3634:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72539 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72541 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72543 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72560 */     GIR_RootConstrainSelectedInstOperands,
     /*  72561 */     // GIR_Coverage, 4837,
     /*  72561 */     GIR_EraseRootFromParent_Done,
     /*  72562 */   // Label 1439: @72562
     /*  72562 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(72631), // Rule ID 4839 //
     /*  72567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72603 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3634:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72608 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72610 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72612 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72629 */     GIR_RootConstrainSelectedInstOperands,
     /*  72630 */     // GIR_Coverage, 4839,
     /*  72630 */     GIR_EraseRootFromParent_Done,
     /*  72631 */   // Label 1440: @72631
     /*  72631 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(72700), // Rule ID 4841 //
     /*  72636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72672 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3634:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72677 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72679 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72681 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72698 */     GIR_RootConstrainSelectedInstOperands,
     /*  72699 */     // GIR_Coverage, 4841,
     /*  72699 */     GIR_EraseRootFromParent_Done,
     /*  72700 */   // Label 1441: @72700
     /*  72700 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(72769), // Rule ID 4843 //
     /*  72705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72741 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3643:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72746 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72748 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72750 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72767 */     GIR_RootConstrainSelectedInstOperands,
     /*  72768 */     // GIR_Coverage, 4843,
     /*  72768 */     GIR_EraseRootFromParent_Done,
     /*  72769 */   // Label 1442: @72769
     /*  72769 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(72838), // Rule ID 4845 //
     /*  72774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72810 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3643:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72815 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72817 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72819 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72836 */     GIR_RootConstrainSelectedInstOperands,
     /*  72837 */     // GIR_Coverage, 4845,
     /*  72837 */     GIR_EraseRootFromParent_Done,
     /*  72838 */   // Label 1443: @72838
     /*  72838 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72907), // Rule ID 4847 //
     /*  72843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72879 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3643:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72884 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72886 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72888 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72905 */     GIR_RootConstrainSelectedInstOperands,
     /*  72906 */     // GIR_Coverage, 4847,
     /*  72906 */     GIR_EraseRootFromParent_Done,
     /*  72907 */   // Label 1444: @72907
     /*  72907 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72976), // Rule ID 4849 //
     /*  72912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72948 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3636:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72953 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72955 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72957 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72974 */     GIR_RootConstrainSelectedInstOperands,
     /*  72975 */     // GIR_Coverage, 4849,
     /*  72975 */     GIR_EraseRootFromParent_Done,
     /*  72976 */   // Label 1445: @72976
     /*  72976 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(73045), // Rule ID 4851 //
     /*  72981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73017 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  73020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73022 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73024 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73026 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73043 */     GIR_RootConstrainSelectedInstOperands,
     /*  73044 */     // GIR_Coverage, 4851,
     /*  73044 */     GIR_EraseRootFromParent_Done,
     /*  73045 */   // Label 1446: @73045
     /*  73045 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(73114), // Rule ID 4853 //
     /*  73050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  73089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73091 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73093 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73095 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73112 */     GIR_RootConstrainSelectedInstOperands,
     /*  73113 */     // GIR_Coverage, 4853,
     /*  73113 */     GIR_EraseRootFromParent_Done,
     /*  73114 */   // Label 1447: @73114
     /*  73114 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(73183), // Rule ID 4855 //
     /*  73119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73155 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3645:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  73158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73160 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73162 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73164 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73181 */     GIR_RootConstrainSelectedInstOperands,
     /*  73182 */     // GIR_Coverage, 4855,
     /*  73182 */     GIR_EraseRootFromParent_Done,
     /*  73183 */   // Label 1448: @73183
     /*  73183 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(73252), // Rule ID 4857 //
     /*  73188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73224 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73229 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73231 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73233 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73250 */     GIR_RootConstrainSelectedInstOperands,
     /*  73251 */     // GIR_Coverage, 4857,
     /*  73251 */     GIR_EraseRootFromParent_Done,
     /*  73252 */   // Label 1449: @73252
     /*  73252 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(73321), // Rule ID 4859 //
     /*  73257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73293 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73298 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73300 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73302 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73319 */     GIR_RootConstrainSelectedInstOperands,
     /*  73320 */     // GIR_Coverage, 4859,
     /*  73320 */     GIR_EraseRootFromParent_Done,
     /*  73321 */   // Label 1450: @73321
     /*  73321 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(73416), // Rule ID 2691 //
     /*  73326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73350 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73350 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73353 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73357 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73383 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73386 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73389 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73407 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73412 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73414 */     GIR_RootConstrainSelectedInstOperands,
     /*  73415 */     // GIR_Coverage, 2691,
     /*  73415 */     GIR_EraseRootFromParent_Done,
     /*  73416 */   // Label 1451: @73416
     /*  73416 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(73511), // Rule ID 2692 //
     /*  73421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73445 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73445 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73448 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73452 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73457 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73461 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73481 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73502 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73507 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73509 */     GIR_RootConstrainSelectedInstOperands,
     /*  73510 */     // GIR_Coverage, 2692,
     /*  73510 */     GIR_EraseRootFromParent_Done,
     /*  73511 */   // Label 1452: @73511
     /*  73511 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(73606), // Rule ID 2693 //
     /*  73516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73540 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3703:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73540 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73543 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73547 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73552 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73556 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73573 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73576 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73582 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73587 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73597 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73602 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73604 */     GIR_RootConstrainSelectedInstOperands,
     /*  73605 */     // GIR_Coverage, 2693,
     /*  73605 */     GIR_EraseRootFromParent_Done,
     /*  73606 */   // Label 1453: @73606
     /*  73606 */   GIM_Reject,
     /*  73607 */ // Label 1306: @73607
     /*  73607 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(76993),
     /*  73612 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73615 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(73699), // Rule ID 3724 //
     /*  73620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73660 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73677 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73697 */     GIR_RootConstrainSelectedInstOperands,
     /*  73698 */     // GIR_Coverage, 3724,
     /*  73698 */     GIR_EraseRootFromParent_Done,
     /*  73699 */   // Label 1455: @73699
     /*  73699 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(73783), // Rule ID 3728 //
     /*  73704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73744 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73761 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73766 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73781 */     GIR_RootConstrainSelectedInstOperands,
     /*  73782 */     // GIR_Coverage, 3728,
     /*  73782 */     GIR_EraseRootFromParent_Done,
     /*  73783 */   // Label 1456: @73783
     /*  73783 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(73867), // Rule ID 3732 //
     /*  73788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73828 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73845 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73865 */     GIR_RootConstrainSelectedInstOperands,
     /*  73866 */     // GIR_Coverage, 3732,
     /*  73866 */     GIR_EraseRootFromParent_Done,
     /*  73867 */   // Label 1457: @73867
     /*  73867 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(73951), // Rule ID 3736 //
     /*  73872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73900 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73929 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73949 */     GIR_RootConstrainSelectedInstOperands,
     /*  73950 */     // GIR_Coverage, 3736,
     /*  73950 */     GIR_EraseRootFromParent_Done,
     /*  73951 */   // Label 1458: @73951
     /*  73951 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(74035), // Rule ID 3740 //
     /*  73956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73988 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  73992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73996 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  74011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74013 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74033 */     GIR_RootConstrainSelectedInstOperands,
     /*  74034 */     // GIR_Coverage, 3740,
     /*  74034 */     GIR_EraseRootFromParent_Done,
     /*  74035 */   // Label 1459: @74035
     /*  74035 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(74119), // Rule ID 3744 //
     /*  74040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74080 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  74095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74097 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74117 */     GIR_RootConstrainSelectedInstOperands,
     /*  74118 */     // GIR_Coverage, 3744,
     /*  74118 */     GIR_EraseRootFromParent_Done,
     /*  74119 */   // Label 1460: @74119
     /*  74119 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(74203), // Rule ID 3748 //
     /*  74124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74152 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74156 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74164 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  74179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74181 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74201 */     GIR_RootConstrainSelectedInstOperands,
     /*  74202 */     // GIR_Coverage, 3748,
     /*  74202 */     GIR_EraseRootFromParent_Done,
     /*  74203 */   // Label 1461: @74203
     /*  74203 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(74287), // Rule ID 3752 //
     /*  74208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74248 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74265 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74285 */     GIR_RootConstrainSelectedInstOperands,
     /*  74286 */     // GIR_Coverage, 3752,
     /*  74286 */     GIR_EraseRootFromParent_Done,
     /*  74287 */   // Label 1462: @74287
     /*  74287 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(74376), // Rule ID 4384 //
     /*  74292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74335 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74374 */     GIR_RootConstrainSelectedInstOperands,
     /*  74375 */     // GIR_Coverage, 4384,
     /*  74375 */     GIR_EraseRootFromParent_Done,
     /*  74376 */   // Label 1463: @74376
     /*  74376 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(74465), // Rule ID 4386 //
     /*  74381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74424 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74463 */     GIR_RootConstrainSelectedInstOperands,
     /*  74464 */     // GIR_Coverage, 4386,
     /*  74464 */     GIR_EraseRootFromParent_Done,
     /*  74465 */   // Label 1464: @74465
     /*  74465 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(74554), // Rule ID 4388 //
     /*  74470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74513 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74552 */     GIR_RootConstrainSelectedInstOperands,
     /*  74553 */     // GIR_Coverage, 4388,
     /*  74553 */     GIR_EraseRootFromParent_Done,
     /*  74554 */   // Label 1465: @74554
     /*  74554 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(74643), // Rule ID 4390 //
     /*  74559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74602 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74641 */     GIR_RootConstrainSelectedInstOperands,
     /*  74642 */     // GIR_Coverage, 4390,
     /*  74642 */     GIR_EraseRootFromParent_Done,
     /*  74643 */   // Label 1466: @74643
     /*  74643 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(74732), // Rule ID 4392 //
     /*  74648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74687 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74691 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74730 */     GIR_RootConstrainSelectedInstOperands,
     /*  74731 */     // GIR_Coverage, 4392,
     /*  74731 */     GIR_EraseRootFromParent_Done,
     /*  74732 */   // Label 1467: @74732
     /*  74732 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(74821), // Rule ID 4394 //
     /*  74737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74780 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74819 */     GIR_RootConstrainSelectedInstOperands,
     /*  74820 */     // GIR_Coverage, 4394,
     /*  74820 */     GIR_EraseRootFromParent_Done,
     /*  74821 */   // Label 1468: @74821
     /*  74821 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(74910), // Rule ID 4396 //
     /*  74826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74869 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74908 */     GIR_RootConstrainSelectedInstOperands,
     /*  74909 */     // GIR_Coverage, 4396,
     /*  74909 */     GIR_EraseRootFromParent_Done,
     /*  74910 */   // Label 1469: @74910
     /*  74910 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(74999), // Rule ID 4398 //
     /*  74915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74958 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74997 */     GIR_RootConstrainSelectedInstOperands,
     /*  74998 */     // GIR_Coverage, 4398,
     /*  74998 */     GIR_EraseRootFromParent_Done,
     /*  74999 */   // Label 1470: @74999
     /*  74999 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(75088), // Rule ID 4400 //
     /*  75004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75047 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  75062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75086 */     GIR_RootConstrainSelectedInstOperands,
     /*  75087 */     // GIR_Coverage, 4400,
     /*  75087 */     GIR_EraseRootFromParent_Done,
     /*  75088 */   // Label 1471: @75088
     /*  75088 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(75177), // Rule ID 4402 //
     /*  75093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75136 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  75151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75175 */     GIR_RootConstrainSelectedInstOperands,
     /*  75176 */     // GIR_Coverage, 4402,
     /*  75176 */     GIR_EraseRootFromParent_Done,
     /*  75177 */   // Label 1472: @75177
     /*  75177 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(75266), // Rule ID 4404 //
     /*  75182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75225 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75264 */     GIR_RootConstrainSelectedInstOperands,
     /*  75265 */     // GIR_Coverage, 4404,
     /*  75265 */     GIR_EraseRootFromParent_Done,
     /*  75266 */   // Label 1473: @75266
     /*  75266 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(75355), // Rule ID 4406 //
     /*  75271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75314 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75353 */     GIR_RootConstrainSelectedInstOperands,
     /*  75354 */     // GIR_Coverage, 4406,
     /*  75354 */     GIR_EraseRootFromParent_Done,
     /*  75355 */   // Label 1474: @75355
     /*  75355 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(75453), // Rule ID 4029 //
     /*  75360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75399 */     // MIs[1] Operand 1
     /*  75399 */     // No operand predicates
     /*  75399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75409 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75428 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75451 */     GIR_RootConstrainSelectedInstOperands,
     /*  75452 */     // GIR_Coverage, 4029,
     /*  75452 */     GIR_EraseRootFromParent_Done,
     /*  75453 */   // Label 1475: @75453
     /*  75453 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(75551), // Rule ID 4031 //
     /*  75458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75497 */     // MIs[1] Operand 1
     /*  75497 */     // No operand predicates
     /*  75497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75507 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75526 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75534 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75549 */     GIR_RootConstrainSelectedInstOperands,
     /*  75550 */     // GIR_Coverage, 4031,
     /*  75550 */     GIR_EraseRootFromParent_Done,
     /*  75551 */   // Label 1476: @75551
     /*  75551 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(75649), // Rule ID 4538 //
     /*  75556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75583 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75595 */     // MIs[1] Operand 1
     /*  75595 */     // No operand predicates
     /*  75595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75605 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75624 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75632 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75647 */     GIR_RootConstrainSelectedInstOperands,
     /*  75648 */     // GIR_Coverage, 4538,
     /*  75648 */     GIR_EraseRootFromParent_Done,
     /*  75649 */   // Label 1477: @75649
     /*  75649 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(75747), // Rule ID 4540 //
     /*  75654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75693 */     // MIs[1] Operand 1
     /*  75693 */     // No operand predicates
     /*  75693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75703 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75722 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75745 */     GIR_RootConstrainSelectedInstOperands,
     /*  75746 */     // GIR_Coverage, 4540,
     /*  75746 */     GIR_EraseRootFromParent_Done,
     /*  75747 */   // Label 1478: @75747
     /*  75747 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(75845), // Rule ID 4542 //
     /*  75752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75791 */     // MIs[1] Operand 1
     /*  75791 */     // No operand predicates
     /*  75791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75801 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75820 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75843 */     GIR_RootConstrainSelectedInstOperands,
     /*  75844 */     // GIR_Coverage, 4542,
     /*  75844 */     GIR_EraseRootFromParent_Done,
     /*  75845 */   // Label 1479: @75845
     /*  75845 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(75943), // Rule ID 4544 //
     /*  75850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75889 */     // MIs[1] Operand 1
     /*  75889 */     // No operand predicates
     /*  75889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75899 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3573:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75918 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75941 */     GIR_RootConstrainSelectedInstOperands,
     /*  75942 */     // GIR_Coverage, 4544,
     /*  75942 */     GIR_EraseRootFromParent_Done,
     /*  75943 */   // Label 1480: @75943
     /*  75943 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(76041), // Rule ID 4546 //
     /*  75948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75987 */     // MIs[1] Operand 1
     /*  75987 */     // No operand predicates
     /*  75987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75997 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3573:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  76012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76016 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76039 */     GIR_RootConstrainSelectedInstOperands,
     /*  76040 */     // GIR_Coverage, 4546,
     /*  76040 */     GIR_EraseRootFromParent_Done,
     /*  76041 */   // Label 1481: @76041
     /*  76041 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(76139), // Rule ID 4548 //
     /*  76046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76073 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76085 */     // MIs[1] Operand 1
     /*  76085 */     // No operand predicates
     /*  76085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76095 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3573:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  76110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76112 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76114 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76116 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76134 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76137 */     GIR_RootConstrainSelectedInstOperands,
     /*  76138 */     // GIR_Coverage, 4548,
     /*  76138 */     GIR_EraseRootFromParent_Done,
     /*  76139 */   // Label 1482: @76139
     /*  76139 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(76215), // Rule ID 3034 //
     /*  76144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76187 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  76190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76196 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76213 */     GIR_RootConstrainSelectedInstOperands,
     /*  76214 */     // GIR_Coverage, 3034,
     /*  76214 */     GIR_EraseRootFromParent_Done,
     /*  76215 */   // Label 1483: @76215
     /*  76215 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(76291), // Rule ID 3036 //
     /*  76220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76247 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76263 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76272 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76289 */     GIR_RootConstrainSelectedInstOperands,
     /*  76290 */     // GIR_Coverage, 3036,
     /*  76290 */     GIR_EraseRootFromParent_Done,
     /*  76291 */   // Label 1484: @76291
     /*  76291 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(76367), // Rule ID 3038 //
     /*  76296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76339 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76346 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76348 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76365 */     GIR_RootConstrainSelectedInstOperands,
     /*  76366 */     // GIR_Coverage, 3038,
     /*  76366 */     GIR_EraseRootFromParent_Done,
     /*  76367 */   // Label 1485: @76367
     /*  76367 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(76443), // Rule ID 3040 //
     /*  76372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76415 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76424 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76441 */     GIR_RootConstrainSelectedInstOperands,
     /*  76442 */     // GIR_Coverage, 3040,
     /*  76442 */     GIR_EraseRootFromParent_Done,
     /*  76443 */   // Label 1486: @76443
     /*  76443 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(76519), // Rule ID 3042 //
     /*  76448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76491 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76500 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76517 */     GIR_RootConstrainSelectedInstOperands,
     /*  76518 */     // GIR_Coverage, 3042,
     /*  76518 */     GIR_EraseRootFromParent_Done,
     /*  76519 */   // Label 1487: @76519
     /*  76519 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(76595), // Rule ID 3044 //
     /*  76524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76567 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76574 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76576 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76593 */     GIR_RootConstrainSelectedInstOperands,
     /*  76594 */     // GIR_Coverage, 3044,
     /*  76594 */     GIR_EraseRootFromParent_Done,
     /*  76595 */   // Label 1488: @76595
     /*  76595 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(76680), // Rule ID 3993 //
     /*  76600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76635 */     // MIs[1] Operand 1
     /*  76635 */     // No operand predicates
     /*  76635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76649 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3576:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76658 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76678 */     GIR_RootConstrainSelectedInstOperands,
     /*  76679 */     // GIR_Coverage, 3993,
     /*  76679 */     GIR_EraseRootFromParent_Done,
     /*  76680 */   // Label 1489: @76680
     /*  76680 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(76765), // Rule ID 3996 //
     /*  76685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76720 */     // MIs[1] Operand 1
     /*  76720 */     // No operand predicates
     /*  76720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76734 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3576:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76743 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76763 */     GIR_RootConstrainSelectedInstOperands,
     /*  76764 */     // GIR_Coverage, 3996,
     /*  76764 */     GIR_EraseRootFromParent_Done,
     /*  76765 */   // Label 1490: @76765
     /*  76765 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(76861), // Rule ID 2685 //
     /*  76770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76797 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3832:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76813 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76820 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76843 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76848 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76859 */     GIR_RootConstrainSelectedInstOperands,
     /*  76860 */     // GIR_Coverage, 2685,
     /*  76860 */     GIR_EraseRootFromParent_Done,
     /*  76861 */   // Label 1491: @76861
     /*  76861 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(76992), // Rule ID 2686 //
     /*  76866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76893 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3829:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76893 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76896 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76900 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76919 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76923 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76926 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76930 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76933 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76937 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76940 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76943 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76979 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76990 */     GIR_RootConstrainSelectedInstOperands,
     /*  76991 */     // GIR_Coverage, 2686,
     /*  76991 */     GIR_EraseRootFromParent_Done,
     /*  76992 */   // Label 1492: @76992
     /*  76992 */   GIM_Reject,
     /*  76993 */ // Label 1454: @76993
     /*  76993 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(82299),
     /*  76998 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  77001 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(77094), // Rule ID 3835 //
     /*  77006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77053 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  77068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77070 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77072 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77092 */     GIR_RootConstrainSelectedInstOperands,
     /*  77093 */     // GIR_Coverage, 3835,
     /*  77093 */     GIR_EraseRootFromParent_Done,
     /*  77094 */   // Label 1494: @77094
     /*  77094 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(77187), // Rule ID 3837 //
     /*  77099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77146 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  77161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77163 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77165 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77185 */     GIR_RootConstrainSelectedInstOperands,
     /*  77186 */     // GIR_Coverage, 3837,
     /*  77186 */     GIR_EraseRootFromParent_Done,
     /*  77187 */   // Label 1495: @77187
     /*  77187 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(77280), // Rule ID 3839 //
     /*  77192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77239 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77256 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77258 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77278 */     GIR_RootConstrainSelectedInstOperands,
     /*  77279 */     // GIR_Coverage, 3839,
     /*  77279 */     GIR_EraseRootFromParent_Done,
     /*  77280 */   // Label 1496: @77280
     /*  77280 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(77373), // Rule ID 3841 //
     /*  77285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77324 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77332 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77349 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77351 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77371 */     GIR_RootConstrainSelectedInstOperands,
     /*  77372 */     // GIR_Coverage, 3841,
     /*  77372 */     GIR_EraseRootFromParent_Done,
     /*  77373 */   // Label 1497: @77373
     /*  77373 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(77466), // Rule ID 3843 //
     /*  77378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77425 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77442 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77444 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77464 */     GIR_RootConstrainSelectedInstOperands,
     /*  77465 */     // GIR_Coverage, 3843,
     /*  77465 */     GIR_EraseRootFromParent_Done,
     /*  77466 */   // Label 1498: @77466
     /*  77466 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(77559), // Rule ID 3845 //
     /*  77471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77510 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77518 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77535 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77537 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77557 */     GIR_RootConstrainSelectedInstOperands,
     /*  77558 */     // GIR_Coverage, 3845,
     /*  77558 */     GIR_EraseRootFromParent_Done,
     /*  77559 */   // Label 1499: @77559
     /*  77559 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(77652), // Rule ID 3847 //
     /*  77564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77611 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77628 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77630 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77650 */     GIR_RootConstrainSelectedInstOperands,
     /*  77651 */     // GIR_Coverage, 3847,
     /*  77651 */     GIR_EraseRootFromParent_Done,
     /*  77652 */   // Label 1500: @77652
     /*  77652 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(77745), // Rule ID 3849 //
     /*  77657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77704 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77721 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77723 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77743 */     GIR_RootConstrainSelectedInstOperands,
     /*  77744 */     // GIR_Coverage, 3849,
     /*  77744 */     GIR_EraseRootFromParent_Done,
     /*  77745 */   // Label 1501: @77745
     /*  77745 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(77838), // Rule ID 3851 //
     /*  77750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77797 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77814 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77816 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77836 */     GIR_RootConstrainSelectedInstOperands,
     /*  77837 */     // GIR_Coverage, 3851,
     /*  77837 */     GIR_EraseRootFromParent_Done,
     /*  77838 */   // Label 1502: @77838
     /*  77838 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(77931), // Rule ID 3853 //
     /*  77843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77890 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77907 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77909 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77929 */     GIR_RootConstrainSelectedInstOperands,
     /*  77930 */     // GIR_Coverage, 3853,
     /*  77930 */     GIR_EraseRootFromParent_Done,
     /*  77931 */   // Label 1503: @77931
     /*  77931 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(78024), // Rule ID 3855 //
     /*  77936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77983 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  77998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78000 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78002 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78022 */     GIR_RootConstrainSelectedInstOperands,
     /*  78023 */     // GIR_Coverage, 3855,
     /*  78023 */     GIR_EraseRootFromParent_Done,
     /*  78024 */   // Label 1504: @78024
     /*  78024 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(78117), // Rule ID 3857 //
     /*  78029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78064 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78076 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  78091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78093 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78095 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78115 */     GIR_RootConstrainSelectedInstOperands,
     /*  78116 */     // GIR_Coverage, 3857,
     /*  78116 */     GIR_EraseRootFromParent_Done,
     /*  78117 */   // Label 1505: @78117
     /*  78117 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(78210), // Rule ID 3859 //
     /*  78122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78169 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  78184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78186 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78188 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78208 */     GIR_RootConstrainSelectedInstOperands,
     /*  78209 */     // GIR_Coverage, 3859,
     /*  78209 */     GIR_EraseRootFromParent_Done,
     /*  78210 */   // Label 1506: @78210
     /*  78210 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(78303), // Rule ID 3861 //
     /*  78215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78262 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78279 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78281 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78286 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78301 */     GIR_RootConstrainSelectedInstOperands,
     /*  78302 */     // GIR_Coverage, 3861,
     /*  78302 */     GIR_EraseRootFromParent_Done,
     /*  78303 */   // Label 1507: @78303
     /*  78303 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(78396), // Rule ID 3863 //
     /*  78308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78355 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78372 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78374 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78379 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78394 */     GIR_RootConstrainSelectedInstOperands,
     /*  78395 */     // GIR_Coverage, 3863,
     /*  78395 */     GIR_EraseRootFromParent_Done,
     /*  78396 */   // Label 1508: @78396
     /*  78396 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(78489), // Rule ID 3865 //
     /*  78401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78440 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78448 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78465 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78467 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78487 */     GIR_RootConstrainSelectedInstOperands,
     /*  78488 */     // GIR_Coverage, 3865,
     /*  78488 */     GIR_EraseRootFromParent_Done,
     /*  78489 */   // Label 1509: @78489
     /*  78489 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(78582), // Rule ID 3867 //
     /*  78494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78541 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78541 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78544 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78548 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78558 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78560 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78580 */     GIR_RootConstrainSelectedInstOperands,
     /*  78581 */     // GIR_Coverage, 3867,
     /*  78581 */     GIR_EraseRootFromParent_Done,
     /*  78582 */   // Label 1510: @78582
     /*  78582 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(78675), // Rule ID 3869 //
     /*  78587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78626 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78634 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78651 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78653 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78673 */     GIR_RootConstrainSelectedInstOperands,
     /*  78674 */     // GIR_Coverage, 3869,
     /*  78674 */     GIR_EraseRootFromParent_Done,
     /*  78675 */   // Label 1511: @78675
     /*  78675 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(78768), // Rule ID 3871 //
     /*  78680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78715 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78727 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78744 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78746 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78766 */     GIR_RootConstrainSelectedInstOperands,
     /*  78767 */     // GIR_Coverage, 3871,
     /*  78767 */     GIR_EraseRootFromParent_Done,
     /*  78768 */   // Label 1512: @78768
     /*  78768 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(78861), // Rule ID 3873 //
     /*  78773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78820 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78837 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78839 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78859 */     GIR_RootConstrainSelectedInstOperands,
     /*  78860 */     // GIR_Coverage, 3873,
     /*  78860 */     GIR_EraseRootFromParent_Done,
     /*  78861 */   // Label 1513: @78861
     /*  78861 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(78954), // Rule ID 3875 //
     /*  78866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78913 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78930 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78932 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78952 */     GIR_RootConstrainSelectedInstOperands,
     /*  78953 */     // GIR_Coverage, 3875,
     /*  78953 */     GIR_EraseRootFromParent_Done,
     /*  78954 */   // Label 1514: @78954
     /*  78954 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(79047), // Rule ID 3877 //
     /*  78959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78994 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79006 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  79006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  79021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79023 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79025 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79045 */     GIR_RootConstrainSelectedInstOperands,
     /*  79046 */     // GIR_Coverage, 3877,
     /*  79046 */     GIR_EraseRootFromParent_Done,
     /*  79047 */   // Label 1515: @79047
     /*  79047 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(79140), // Rule ID 3879 //
     /*  79052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79087 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79091 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79099 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  79099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  79114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79116 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79118 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79138 */     GIR_RootConstrainSelectedInstOperands,
     /*  79139 */     // GIR_Coverage, 3879,
     /*  79139 */     GIR_EraseRootFromParent_Done,
     /*  79140 */   // Label 1516: @79140
     /*  79140 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(79233), // Rule ID 3881 //
     /*  79145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79184 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  79207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79209 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79211 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79231 */     GIR_RootConstrainSelectedInstOperands,
     /*  79232 */     // GIR_Coverage, 3881,
     /*  79232 */     GIR_EraseRootFromParent_Done,
     /*  79233 */   // Label 1517: @79233
     /*  79233 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(79311), // Rule ID 4486 //
     /*  79238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79285 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79309 */     GIR_RootConstrainSelectedInstOperands,
     /*  79310 */     // GIR_Coverage, 4486,
     /*  79310 */     GIR_EraseRootFromParent_Done,
     /*  79311 */   // Label 1518: @79311
     /*  79311 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(79389), // Rule ID 4488 //
     /*  79316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79363 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79387 */     GIR_RootConstrainSelectedInstOperands,
     /*  79388 */     // GIR_Coverage, 4488,
     /*  79388 */     GIR_EraseRootFromParent_Done,
     /*  79389 */   // Label 1519: @79389
     /*  79389 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(79467), // Rule ID 4490 //
     /*  79394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79441 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79453 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79459 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79465 */     GIR_RootConstrainSelectedInstOperands,
     /*  79466 */     // GIR_Coverage, 4490,
     /*  79466 */     GIR_EraseRootFromParent_Done,
     /*  79467 */   // Label 1520: @79467
     /*  79467 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(79545), // Rule ID 4492 //
     /*  79472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79519 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79543 */     GIR_RootConstrainSelectedInstOperands,
     /*  79544 */     // GIR_Coverage, 4492,
     /*  79544 */     GIR_EraseRootFromParent_Done,
     /*  79545 */   // Label 1521: @79545
     /*  79545 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(79623), // Rule ID 4494 //
     /*  79550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79597 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79621 */     GIR_RootConstrainSelectedInstOperands,
     /*  79622 */     // GIR_Coverage, 4494,
     /*  79622 */     GIR_EraseRootFromParent_Done,
     /*  79623 */   // Label 1522: @79623
     /*  79623 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(79701), // Rule ID 4496 //
     /*  79628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79675 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79699 */     GIR_RootConstrainSelectedInstOperands,
     /*  79700 */     // GIR_Coverage, 4496,
     /*  79700 */     GIR_EraseRootFromParent_Done,
     /*  79701 */   // Label 1523: @79701
     /*  79701 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(79779), // Rule ID 4498 //
     /*  79706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79753 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79777 */     GIR_RootConstrainSelectedInstOperands,
     /*  79778 */     // GIR_Coverage, 4498,
     /*  79778 */     GIR_EraseRootFromParent_Done,
     /*  79779 */   // Label 1524: @79779
     /*  79779 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(79857), // Rule ID 4500 //
     /*  79784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79831 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79855 */     GIR_RootConstrainSelectedInstOperands,
     /*  79856 */     // GIR_Coverage, 4500,
     /*  79856 */     GIR_EraseRootFromParent_Done,
     /*  79857 */   // Label 1525: @79857
     /*  79857 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(79935), // Rule ID 4502 //
     /*  79862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79909 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79933 */     GIR_RootConstrainSelectedInstOperands,
     /*  79934 */     // GIR_Coverage, 4502,
     /*  79934 */     GIR_EraseRootFromParent_Done,
     /*  79935 */   // Label 1526: @79935
     /*  79935 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(80013), // Rule ID 4504 //
     /*  79940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79987 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80011 */     GIR_RootConstrainSelectedInstOperands,
     /*  80012 */     // GIR_Coverage, 4504,
     /*  80012 */     GIR_EraseRootFromParent_Done,
     /*  80013 */   // Label 1527: @80013
     /*  80013 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(80091), // Rule ID 4506 //
     /*  80018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80065 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  80068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80089 */     GIR_RootConstrainSelectedInstOperands,
     /*  80090 */     // GIR_Coverage, 4506,
     /*  80090 */     GIR_EraseRootFromParent_Done,
     /*  80091 */   // Label 1528: @80091
     /*  80091 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(80169), // Rule ID 4508 //
     /*  80096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80135 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80143 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  80146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80167 */     GIR_RootConstrainSelectedInstOperands,
     /*  80168 */     // GIR_Coverage, 4508,
     /*  80168 */     GIR_EraseRootFromParent_Done,
     /*  80169 */   // Label 1529: @80169
     /*  80169 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(80247), // Rule ID 4698 //
     /*  80174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80221 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80226 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80228 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80239 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80245 */     GIR_RootConstrainSelectedInstOperands,
     /*  80246 */     // GIR_Coverage, 4698,
     /*  80246 */     GIR_EraseRootFromParent_Done,
     /*  80247 */   // Label 1530: @80247
     /*  80247 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(80325), // Rule ID 4700 //
     /*  80252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80287 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80299 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80304 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80306 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80323 */     GIR_RootConstrainSelectedInstOperands,
     /*  80324 */     // GIR_Coverage, 4700,
     /*  80324 */     GIR_EraseRootFromParent_Done,
     /*  80325 */   // Label 1531: @80325
     /*  80325 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(80403), // Rule ID 4702 //
     /*  80330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80377 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80382 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80384 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80401 */     GIR_RootConstrainSelectedInstOperands,
     /*  80402 */     // GIR_Coverage, 4702,
     /*  80402 */     GIR_EraseRootFromParent_Done,
     /*  80403 */   // Label 1532: @80403
     /*  80403 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(80481), // Rule ID 4704 //
     /*  80408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80447 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80455 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80460 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80462 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80473 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80479 */     GIR_RootConstrainSelectedInstOperands,
     /*  80480 */     // GIR_Coverage, 4704,
     /*  80480 */     GIR_EraseRootFromParent_Done,
     /*  80481 */   // Label 1533: @80481
     /*  80481 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(80559), // Rule ID 4706 //
     /*  80486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80533 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80538 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80540 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80557 */     GIR_RootConstrainSelectedInstOperands,
     /*  80558 */     // GIR_Coverage, 4706,
     /*  80558 */     GIR_EraseRootFromParent_Done,
     /*  80559 */   // Label 1534: @80559
     /*  80559 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(80637), // Rule ID 4708 //
     /*  80564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80599 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80611 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80616 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80618 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80635 */     GIR_RootConstrainSelectedInstOperands,
     /*  80636 */     // GIR_Coverage, 4708,
     /*  80636 */     GIR_EraseRootFromParent_Done,
     /*  80637 */   // Label 1535: @80637
     /*  80637 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(80715), // Rule ID 4710 //
     /*  80642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80689 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80694 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80696 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80713 */     GIR_RootConstrainSelectedInstOperands,
     /*  80714 */     // GIR_Coverage, 4710,
     /*  80714 */     GIR_EraseRootFromParent_Done,
     /*  80715 */   // Label 1536: @80715
     /*  80715 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(80793), // Rule ID 4712 //
     /*  80720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80767 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80772 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80774 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80791 */     GIR_RootConstrainSelectedInstOperands,
     /*  80792 */     // GIR_Coverage, 4712,
     /*  80792 */     GIR_EraseRootFromParent_Done,
     /*  80793 */   // Label 1537: @80793
     /*  80793 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(80871), // Rule ID 4714 //
     /*  80798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80845 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80850 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80852 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80869 */     GIR_RootConstrainSelectedInstOperands,
     /*  80870 */     // GIR_Coverage, 4714,
     /*  80870 */     GIR_EraseRootFromParent_Done,
     /*  80871 */   // Label 1538: @80871
     /*  80871 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(80949), // Rule ID 4716 //
     /*  80876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80923 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80928 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80930 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80947 */     GIR_RootConstrainSelectedInstOperands,
     /*  80948 */     // GIR_Coverage, 4716,
     /*  80948 */     GIR_EraseRootFromParent_Done,
     /*  80949 */   // Label 1539: @80949
     /*  80949 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(81027), // Rule ID 4718 //
     /*  80954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81001 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  81004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81006 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81008 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81025 */     GIR_RootConstrainSelectedInstOperands,
     /*  81026 */     // GIR_Coverage, 4718,
     /*  81026 */     GIR_EraseRootFromParent_Done,
     /*  81027 */   // Label 1540: @81027
     /*  81027 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(81105), // Rule ID 4720 //
     /*  81032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81079 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  81082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81084 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81086 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81097 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81103 */     GIR_RootConstrainSelectedInstOperands,
     /*  81104 */     // GIR_Coverage, 4720,
     /*  81104 */     GIR_EraseRootFromParent_Done,
     /*  81105 */   // Label 1541: @81105
     /*  81105 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(81183), // Rule ID 4722 //
     /*  81110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81157 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  81160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81162 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81164 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81181 */     GIR_RootConstrainSelectedInstOperands,
     /*  81182 */     // GIR_Coverage, 4722,
     /*  81182 */     GIR_EraseRootFromParent_Done,
     /*  81183 */   // Label 1542: @81183
     /*  81183 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(81261), // Rule ID 4724 //
     /*  81188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81227 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81235 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81240 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81242 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81259 */     GIR_RootConstrainSelectedInstOperands,
     /*  81260 */     // GIR_Coverage, 4724,
     /*  81260 */     GIR_EraseRootFromParent_Done,
     /*  81261 */   // Label 1543: @81261
     /*  81261 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(81339), // Rule ID 4726 //
     /*  81266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81313 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81318 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81320 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81337 */     GIR_RootConstrainSelectedInstOperands,
     /*  81338 */     // GIR_Coverage, 4726,
     /*  81338 */     GIR_EraseRootFromParent_Done,
     /*  81339 */   // Label 1544: @81339
     /*  81339 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(81417), // Rule ID 4728 //
     /*  81344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81391 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81396 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81398 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81415 */     GIR_RootConstrainSelectedInstOperands,
     /*  81416 */     // GIR_Coverage, 4728,
     /*  81416 */     GIR_EraseRootFromParent_Done,
     /*  81417 */   // Label 1545: @81417
     /*  81417 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(81495), // Rule ID 4730 //
     /*  81422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81469 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81474 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81476 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81493 */     GIR_RootConstrainSelectedInstOperands,
     /*  81494 */     // GIR_Coverage, 4730,
     /*  81494 */     GIR_EraseRootFromParent_Done,
     /*  81495 */   // Label 1546: @81495
     /*  81495 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(81573), // Rule ID 4732 //
     /*  81500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81535 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81539 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81547 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81552 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81554 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81571 */     GIR_RootConstrainSelectedInstOperands,
     /*  81572 */     // GIR_Coverage, 4732,
     /*  81572 */     GIR_EraseRootFromParent_Done,
     /*  81573 */   // Label 1547: @81573
     /*  81573 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(81651), // Rule ID 4734 //
     /*  81578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81625 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81630 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81632 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81649 */     GIR_RootConstrainSelectedInstOperands,
     /*  81650 */     // GIR_Coverage, 4734,
     /*  81650 */     GIR_EraseRootFromParent_Done,
     /*  81651 */   // Label 1548: @81651
     /*  81651 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(81729), // Rule ID 4736 //
     /*  81656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81703 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81708 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81710 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81727 */     GIR_RootConstrainSelectedInstOperands,
     /*  81728 */     // GIR_Coverage, 4736,
     /*  81728 */     GIR_EraseRootFromParent_Done,
     /*  81729 */   // Label 1549: @81729
     /*  81729 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(81807), // Rule ID 4738 //
     /*  81734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81781 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81786 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81788 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81805 */     GIR_RootConstrainSelectedInstOperands,
     /*  81806 */     // GIR_Coverage, 4738,
     /*  81806 */     GIR_EraseRootFromParent_Done,
     /*  81807 */   // Label 1550: @81807
     /*  81807 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(81885), // Rule ID 4740 //
     /*  81812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81859 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81864 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81866 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81883 */     GIR_RootConstrainSelectedInstOperands,
     /*  81884 */     // GIR_Coverage, 4740,
     /*  81884 */     GIR_EraseRootFromParent_Done,
     /*  81885 */   // Label 1551: @81885
     /*  81885 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(81963), // Rule ID 4742 //
     /*  81890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81937 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81942 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81944 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81961 */     GIR_RootConstrainSelectedInstOperands,
     /*  81962 */     // GIR_Coverage, 4742,
     /*  81962 */     GIR_EraseRootFromParent_Done,
     /*  81963 */   // Label 1552: @81963
     /*  81963 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(82041), // Rule ID 4744 //
     /*  81968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  82003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  82011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  82015 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  82015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  82018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82020 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82022 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82039 */     GIR_RootConstrainSelectedInstOperands,
     /*  82040 */     // GIR_Coverage, 4744,
     /*  82040 */     GIR_EraseRootFromParent_Done,
     /*  82041 */   // Label 1553: @82041
     /*  82041 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(82177), // Rule ID 2687 //
     /*  82046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  82054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82076 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3833:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82076 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  82079 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82083 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  82106 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82109 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  82113 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  82120 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82123 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82126 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82139 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82144 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  82157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82159 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  82161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82164 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82175 */     GIR_RootConstrainSelectedInstOperands,
     /*  82176 */     // GIR_Coverage, 2687,
     /*  82176 */     GIR_EraseRootFromParent_Done,
     /*  82177 */   // Label 1554: @82177
     /*  82177 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(82298), // Rule ID 2688 //
     /*  82182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  82190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82212 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3830:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82224 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82228 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82235 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82242 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82249 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82285 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82296 */     GIR_RootConstrainSelectedInstOperands,
     /*  82297 */     // GIR_Coverage, 2688,
     /*  82297 */     GIR_EraseRootFromParent_Done,
     /*  82298 */   // Label 1555: @82298
     /*  82298 */   GIM_Reject,
     /*  82299 */ // Label 1493: @82299
     /*  82299 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(87192),
     /*  82304 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82307 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(82395), // Rule ID 3178 //
     /*  82312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82361 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82365 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82369 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82374 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82376 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82393 */     GIR_RootConstrainSelectedInstOperands,
     /*  82394 */     // GIR_Coverage, 3178,
     /*  82394 */     GIR_EraseRootFromParent_Done,
     /*  82395 */   // Label 1557: @82395
     /*  82395 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(82483), // Rule ID 3182 //
     /*  82400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82449 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82453 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82457 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82462 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82464 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82481 */     GIR_RootConstrainSelectedInstOperands,
     /*  82482 */     // GIR_Coverage, 3182,
     /*  82482 */     GIR_EraseRootFromParent_Done,
     /*  82483 */   // Label 1558: @82483
     /*  82483 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(82571), // Rule ID 3186 //
     /*  82488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82537 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82541 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82545 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82550 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82552 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82569 */     GIR_RootConstrainSelectedInstOperands,
     /*  82570 */     // GIR_Coverage, 3186,
     /*  82570 */     GIR_EraseRootFromParent_Done,
     /*  82571 */   // Label 1559: @82571
     /*  82571 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(82659), // Rule ID 3190 //
     /*  82576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82625 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82629 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82633 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82638 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82640 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82657 */     GIR_RootConstrainSelectedInstOperands,
     /*  82658 */     // GIR_Coverage, 3190,
     /*  82658 */     GIR_EraseRootFromParent_Done,
     /*  82659 */   // Label 1560: @82659
     /*  82659 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(82747), // Rule ID 3194 //
     /*  82664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82713 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82717 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82721 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82726 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82728 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82745 */     GIR_RootConstrainSelectedInstOperands,
     /*  82746 */     // GIR_Coverage, 3194,
     /*  82746 */     GIR_EraseRootFromParent_Done,
     /*  82747 */   // Label 1561: @82747
     /*  82747 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(82835), // Rule ID 3198 //
     /*  82752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82801 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82805 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82809 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82814 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82816 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82833 */     GIR_RootConstrainSelectedInstOperands,
     /*  82834 */     // GIR_Coverage, 3198,
     /*  82834 */     GIR_EraseRootFromParent_Done,
     /*  82835 */   // Label 1562: @82835
     /*  82835 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(82923), // Rule ID 3202 //
     /*  82840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82889 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82893 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82897 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82902 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82904 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82921 */     GIR_RootConstrainSelectedInstOperands,
     /*  82922 */     // GIR_Coverage, 3202,
     /*  82922 */     GIR_EraseRootFromParent_Done,
     /*  82923 */   // Label 1563: @82923
     /*  82923 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(83011), // Rule ID 3206 //
     /*  82928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82961 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82977 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82981 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82985 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82990 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82992 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83009 */     GIR_RootConstrainSelectedInstOperands,
     /*  83010 */     // GIR_Coverage, 3206,
     /*  83010 */     GIR_EraseRootFromParent_Done,
     /*  83011 */   // Label 1564: @83011
     /*  83011 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(83099), // Rule ID 3210 //
     /*  83016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83065 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83069 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83073 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  83076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83078 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83080 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83097 */     GIR_RootConstrainSelectedInstOperands,
     /*  83098 */     // GIR_Coverage, 3210,
     /*  83098 */     GIR_EraseRootFromParent_Done,
     /*  83099 */   // Label 1565: @83099
     /*  83099 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(83187), // Rule ID 3214 //
     /*  83104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83153 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83157 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83161 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  83164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83166 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83168 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83185 */     GIR_RootConstrainSelectedInstOperands,
     /*  83186 */     // GIR_Coverage, 3214,
     /*  83186 */     GIR_EraseRootFromParent_Done,
     /*  83187 */   // Label 1566: @83187
     /*  83187 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(83275), // Rule ID 3218 //
     /*  83192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83241 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83245 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83249 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83254 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83256 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83273 */     GIR_RootConstrainSelectedInstOperands,
     /*  83274 */     // GIR_Coverage, 3218,
     /*  83274 */     GIR_EraseRootFromParent_Done,
     /*  83275 */   // Label 1567: @83275
     /*  83275 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(83363), // Rule ID 3222 //
     /*  83280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83329 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83333 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83337 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83342 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83344 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83349 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83361 */     GIR_RootConstrainSelectedInstOperands,
     /*  83362 */     // GIR_Coverage, 3222,
     /*  83362 */     GIR_EraseRootFromParent_Done,
     /*  83363 */   // Label 1568: @83363
     /*  83363 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(83451), // Rule ID 3226 //
     /*  83368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83417 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83421 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83425 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83430 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83432 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83449 */     GIR_RootConstrainSelectedInstOperands,
     /*  83450 */     // GIR_Coverage, 3226,
     /*  83450 */     GIR_EraseRootFromParent_Done,
     /*  83451 */   // Label 1569: @83451
     /*  83451 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(83539), // Rule ID 3230 //
     /*  83456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83505 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83509 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83513 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83518 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83520 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83537 */     GIR_RootConstrainSelectedInstOperands,
     /*  83538 */     // GIR_Coverage, 3230,
     /*  83538 */     GIR_EraseRootFromParent_Done,
     /*  83539 */   // Label 1570: @83539
     /*  83539 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(83627), // Rule ID 3234 //
     /*  83544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83593 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83597 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83601 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83606 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83608 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83625 */     GIR_RootConstrainSelectedInstOperands,
     /*  83626 */     // GIR_Coverage, 3234,
     /*  83626 */     GIR_EraseRootFromParent_Done,
     /*  83627 */   // Label 1571: @83627
     /*  83627 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(83717), // Rule ID 3180 //
     /*  83632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83681 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83685 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83689 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83694 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83696 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83698 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83715 */     GIR_RootConstrainSelectedInstOperands,
     /*  83716 */     // GIR_Coverage, 3180,
     /*  83716 */     GIR_EraseRootFromParent_Done,
     /*  83717 */   // Label 1572: @83717
     /*  83717 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(83807), // Rule ID 3184 //
     /*  83722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83755 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83771 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83775 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83779 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83784 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83786 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83788 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83805 */     GIR_RootConstrainSelectedInstOperands,
     /*  83806 */     // GIR_Coverage, 3184,
     /*  83806 */     GIR_EraseRootFromParent_Done,
     /*  83807 */   // Label 1573: @83807
     /*  83807 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(83897), // Rule ID 3188 //
     /*  83812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83861 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83865 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83869 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83874 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83876 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83878 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83895 */     GIR_RootConstrainSelectedInstOperands,
     /*  83896 */     // GIR_Coverage, 3188,
     /*  83896 */     GIR_EraseRootFromParent_Done,
     /*  83897 */   // Label 1574: @83897
     /*  83897 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(83987), // Rule ID 3192 //
     /*  83902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83935 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83939 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83951 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83955 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83959 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83964 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83966 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83968 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83985 */     GIR_RootConstrainSelectedInstOperands,
     /*  83986 */     // GIR_Coverage, 3192,
     /*  83986 */     GIR_EraseRootFromParent_Done,
     /*  83987 */   // Label 1575: @83987
     /*  83987 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(84077), // Rule ID 3196 //
     /*  83992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84041 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84045 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84049 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  84052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84054 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84056 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84058 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84069 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84075 */     GIR_RootConstrainSelectedInstOperands,
     /*  84076 */     // GIR_Coverage, 3196,
     /*  84076 */     GIR_EraseRootFromParent_Done,
     /*  84077 */   // Label 1576: @84077
     /*  84077 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(84167), // Rule ID 3200 //
     /*  84082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84131 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84135 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84139 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  84142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84144 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84146 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84148 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84165 */     GIR_RootConstrainSelectedInstOperands,
     /*  84166 */     // GIR_Coverage, 3200,
     /*  84166 */     GIR_EraseRootFromParent_Done,
     /*  84167 */   // Label 1577: @84167
     /*  84167 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(84257), // Rule ID 3204 //
     /*  84172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84209 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84221 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84225 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84229 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84234 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84236 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84238 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84255 */     GIR_RootConstrainSelectedInstOperands,
     /*  84256 */     // GIR_Coverage, 3204,
     /*  84256 */     GIR_EraseRootFromParent_Done,
     /*  84257 */   // Label 1578: @84257
     /*  84257 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(84347), // Rule ID 3208 //
     /*  84262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84311 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84315 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84319 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84324 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84326 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84328 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84345 */     GIR_RootConstrainSelectedInstOperands,
     /*  84346 */     // GIR_Coverage, 3208,
     /*  84346 */     GIR_EraseRootFromParent_Done,
     /*  84347 */   // Label 1579: @84347
     /*  84347 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(84437), // Rule ID 3212 //
     /*  84352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84401 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84405 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84409 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84414 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84416 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84418 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84423 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84429 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84435 */     GIR_RootConstrainSelectedInstOperands,
     /*  84436 */     // GIR_Coverage, 3212,
     /*  84436 */     GIR_EraseRootFromParent_Done,
     /*  84437 */   // Label 1580: @84437
     /*  84437 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(84527), // Rule ID 3216 //
     /*  84442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84491 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84495 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84499 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84504 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84506 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84508 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84525 */     GIR_RootConstrainSelectedInstOperands,
     /*  84526 */     // GIR_Coverage, 3216,
     /*  84526 */     GIR_EraseRootFromParent_Done,
     /*  84527 */   // Label 1581: @84527
     /*  84527 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(84617), // Rule ID 3220 //
     /*  84532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84581 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84585 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84589 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84594 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84596 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84598 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84615 */     GIR_RootConstrainSelectedInstOperands,
     /*  84616 */     // GIR_Coverage, 3220,
     /*  84616 */     GIR_EraseRootFromParent_Done,
     /*  84617 */   // Label 1582: @84617
     /*  84617 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(84707), // Rule ID 3224 //
     /*  84622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84655 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84659 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84671 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84675 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84679 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84684 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84686 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84688 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84705 */     GIR_RootConstrainSelectedInstOperands,
     /*  84706 */     // GIR_Coverage, 3224,
     /*  84706 */     GIR_EraseRootFromParent_Done,
     /*  84707 */   // Label 1583: @84707
     /*  84707 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(84797), // Rule ID 3228 //
     /*  84712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84761 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84765 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84769 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84774 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84776 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84778 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84783 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84795 */     GIR_RootConstrainSelectedInstOperands,
     /*  84796 */     // GIR_Coverage, 3228,
     /*  84796 */     GIR_EraseRootFromParent_Done,
     /*  84797 */   // Label 1584: @84797
     /*  84797 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(84887), // Rule ID 3232 //
     /*  84802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84839 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84851 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84855 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84859 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84864 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84866 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84868 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84885 */     GIR_RootConstrainSelectedInstOperands,
     /*  84886 */     // GIR_Coverage, 3232,
     /*  84886 */     GIR_EraseRootFromParent_Done,
     /*  84887 */   // Label 1585: @84887
     /*  84887 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(84977), // Rule ID 3236 //
     /*  84892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84941 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84945 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84949 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84954 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84956 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84958 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84975 */     GIR_RootConstrainSelectedInstOperands,
     /*  84976 */     // GIR_Coverage, 3236,
     /*  84976 */     GIR_EraseRootFromParent_Done,
     /*  84977 */   // Label 1586: @84977
     /*  84977 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(85064), // Rule ID 4332 //
     /*  84982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  84993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  84996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  84999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85036 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  85039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85041 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85043 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85045 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85062 */     GIR_RootConstrainSelectedInstOperands,
     /*  85063 */     // GIR_Coverage, 4332,
     /*  85063 */     GIR_EraseRootFromParent_Done,
     /*  85064 */   // Label 1587: @85064
     /*  85064 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(85151), // Rule ID 4334 //
     /*  85069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85115 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85123 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  85126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85128 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85130 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85132 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85149 */     GIR_RootConstrainSelectedInstOperands,
     /*  85150 */     // GIR_Coverage, 4334,
     /*  85150 */     GIR_EraseRootFromParent_Done,
     /*  85151 */   // Label 1588: @85151
     /*  85151 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(85238), // Rule ID 4336 //
     /*  85156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85198 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85210 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85215 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85217 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85219 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85236 */     GIR_RootConstrainSelectedInstOperands,
     /*  85237 */     // GIR_Coverage, 4336,
     /*  85237 */     GIR_EraseRootFromParent_Done,
     /*  85238 */   // Label 1589: @85238
     /*  85238 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(85325), // Rule ID 4338 //
     /*  85243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85297 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85302 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85304 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85306 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85323 */     GIR_RootConstrainSelectedInstOperands,
     /*  85324 */     // GIR_Coverage, 4338,
     /*  85324 */     GIR_EraseRootFromParent_Done,
     /*  85325 */   // Label 1590: @85325
     /*  85325 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(85412), // Rule ID 4340 //
     /*  85330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85384 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85389 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85391 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85393 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85410 */     GIR_RootConstrainSelectedInstOperands,
     /*  85411 */     // GIR_Coverage, 4340,
     /*  85411 */     GIR_EraseRootFromParent_Done,
     /*  85412 */   // Label 1591: @85412
     /*  85412 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(85499), // Rule ID 4342 //
     /*  85417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85471 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85476 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85478 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85480 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85497 */     GIR_RootConstrainSelectedInstOperands,
     /*  85498 */     // GIR_Coverage, 4342,
     /*  85498 */     GIR_EraseRootFromParent_Done,
     /*  85499 */   // Label 1592: @85499
     /*  85499 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(85586), // Rule ID 4344 //
     /*  85504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85550 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85558 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85563 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85565 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85567 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85584 */     GIR_RootConstrainSelectedInstOperands,
     /*  85585 */     // GIR_Coverage, 4344,
     /*  85585 */     GIR_EraseRootFromParent_Done,
     /*  85586 */   // Label 1593: @85586
     /*  85586 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(85673), // Rule ID 4346 //
     /*  85591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85645 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85650 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85652 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85654 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85665 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85671 */     GIR_RootConstrainSelectedInstOperands,
     /*  85672 */     // GIR_Coverage, 4346,
     /*  85672 */     GIR_EraseRootFromParent_Done,
     /*  85673 */   // Label 1594: @85673
     /*  85673 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(85760), // Rule ID 4348 //
     /*  85678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85720 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85724 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85732 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85737 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85739 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85741 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85758 */     GIR_RootConstrainSelectedInstOperands,
     /*  85759 */     // GIR_Coverage, 4348,
     /*  85759 */     GIR_EraseRootFromParent_Done,
     /*  85760 */   // Label 1595: @85760
     /*  85760 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(85847), // Rule ID 4350 //
     /*  85765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85819 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85824 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85826 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85828 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85845 */     GIR_RootConstrainSelectedInstOperands,
     /*  85846 */     // GIR_Coverage, 4350,
     /*  85846 */     GIR_EraseRootFromParent_Done,
     /*  85847 */   // Label 1596: @85847
     /*  85847 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85934), // Rule ID 4352 //
     /*  85852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85906 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85911 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85913 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85915 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85932 */     GIR_RootConstrainSelectedInstOperands,
     /*  85933 */     // GIR_Coverage, 4352,
     /*  85933 */     GIR_EraseRootFromParent_Done,
     /*  85934 */   // Label 1597: @85934
     /*  85934 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(86021), // Rule ID 4354 //
     /*  85939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85993 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  85996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85998 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86000 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86002 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86019 */     GIR_RootConstrainSelectedInstOperands,
     /*  86020 */     // GIR_Coverage, 4354,
     /*  86020 */     GIR_EraseRootFromParent_Done,
     /*  86021 */   // Label 1598: @86021
     /*  86021 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(86108), // Rule ID 4356 //
     /*  86026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86080 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  86083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86085 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86087 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86089 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86106 */     GIR_RootConstrainSelectedInstOperands,
     /*  86107 */     // GIR_Coverage, 4356,
     /*  86107 */     GIR_EraseRootFromParent_Done,
     /*  86108 */   // Label 1599: @86108
     /*  86108 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(86195), // Rule ID 4358 //
     /*  86113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86155 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86159 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86167 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  86170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86172 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86174 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86176 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86193 */     GIR_RootConstrainSelectedInstOperands,
     /*  86194 */     // GIR_Coverage, 4358,
     /*  86194 */     GIR_EraseRootFromParent_Done,
     /*  86195 */   // Label 1600: @86195
     /*  86195 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(86282), // Rule ID 4360 //
     /*  86200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86242 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86254 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86259 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86261 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86263 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86280 */     GIR_RootConstrainSelectedInstOperands,
     /*  86281 */     // GIR_Coverage, 4360,
     /*  86281 */     GIR_EraseRootFromParent_Done,
     /*  86282 */   // Label 1601: @86282
     /*  86282 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(86369), // Rule ID 4362 //
     /*  86287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86341 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86346 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86348 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86350 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86355 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86367 */     GIR_RootConstrainSelectedInstOperands,
     /*  86368 */     // GIR_Coverage, 4362,
     /*  86368 */     GIR_EraseRootFromParent_Done,
     /*  86369 */   // Label 1602: @86369
     /*  86369 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(86456), // Rule ID 4364 //
     /*  86374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86420 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86428 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86433 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86435 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86437 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86454 */     GIR_RootConstrainSelectedInstOperands,
     /*  86455 */     // GIR_Coverage, 4364,
     /*  86455 */     GIR_EraseRootFromParent_Done,
     /*  86456 */   // Label 1603: @86456
     /*  86456 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(86543), // Rule ID 4366 //
     /*  86461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86503 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86515 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86520 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86522 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86524 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86535 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86541 */     GIR_RootConstrainSelectedInstOperands,
     /*  86542 */     // GIR_Coverage, 4366,
     /*  86542 */     GIR_EraseRootFromParent_Done,
     /*  86543 */   // Label 1604: @86543
     /*  86543 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(86630), // Rule ID 4368 //
     /*  86548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86602 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86607 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86609 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86611 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86622 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86628 */     GIR_RootConstrainSelectedInstOperands,
     /*  86629 */     // GIR_Coverage, 4368,
     /*  86629 */     GIR_EraseRootFromParent_Done,
     /*  86630 */   // Label 1605: @86630
     /*  86630 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(86717), // Rule ID 4370 //
     /*  86635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86689 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86694 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86696 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86698 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86715 */     GIR_RootConstrainSelectedInstOperands,
     /*  86716 */     // GIR_Coverage, 4370,
     /*  86716 */     GIR_EraseRootFromParent_Done,
     /*  86717 */   // Label 1606: @86717
     /*  86717 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(86804), // Rule ID 4372 //
     /*  86722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86764 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86776 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86781 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86783 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86785 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86790 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86802 */     GIR_RootConstrainSelectedInstOperands,
     /*  86803 */     // GIR_Coverage, 4372,
     /*  86803 */     GIR_EraseRootFromParent_Done,
     /*  86804 */   // Label 1607: @86804
     /*  86804 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(86891), // Rule ID 4374 //
     /*  86809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86863 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86868 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86870 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86872 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86889 */     GIR_RootConstrainSelectedInstOperands,
     /*  86890 */     // GIR_Coverage, 4374,
     /*  86890 */     GIR_EraseRootFromParent_Done,
     /*  86891 */   // Label 1608: @86891
     /*  86891 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86978), // Rule ID 4376 //
     /*  86896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86938 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86950 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86955 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86957 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86959 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86976 */     GIR_RootConstrainSelectedInstOperands,
     /*  86977 */     // GIR_Coverage, 4376,
     /*  86977 */     GIR_EraseRootFromParent_Done,
     /*  86978 */   // Label 1609: @86978
     /*  86978 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(87065), // Rule ID 4378 //
     /*  86983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  87000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87025 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  87029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87037 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  87037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  87040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87042 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87044 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87046 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87063 */     GIR_RootConstrainSelectedInstOperands,
     /*  87064 */     // GIR_Coverage, 4378,
     /*  87064 */     GIR_EraseRootFromParent_Done,
     /*  87065 */   // Label 1610: @87065
     /*  87065 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(87191), // Rule ID 2689 //
     /*  87070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  87078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  87081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  87084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  87087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  87090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  87093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  87096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  87099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  87103 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3834:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  87103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  87106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  87110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87115 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  87119 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  87122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  87126 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  87129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  87133 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  87136 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  87140 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  87143 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  87148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87158 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  87171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87173 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  87175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87178 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  87180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  87183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87189 */     GIR_RootConstrainSelectedInstOperands,
     /*  87190 */     // GIR_Coverage, 2689,
     /*  87190 */     GIR_EraseRootFromParent_Done,
     /*  87191 */   // Label 1611: @87191
     /*  87191 */   GIM_Reject,
     /*  87192 */ // Label 1556: @87192
     /*  87192 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(91486),
     /*  87197 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  87200 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  87205 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(87312), // Rule ID 3755 //
     /*  87210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87231 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87234 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87261 */     // MIs[1] Operand 1
     /*  87261 */     // No operand predicates
     /*  87261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87283 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87288 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87310 */     GIR_RootConstrainSelectedInstOperands,
     /*  87311 */     // GIR_Coverage, 3755,
     /*  87311 */     GIR_EraseRootFromParent_Done,
     /*  87312 */   // Label 1613: @87312
     /*  87312 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(87419), // Rule ID 3757 //
     /*  87317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87338 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87341 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87368 */     // MIs[1] Operand 1
     /*  87368 */     // No operand predicates
     /*  87368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87390 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87395 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87417 */     GIR_RootConstrainSelectedInstOperands,
     /*  87418 */     // GIR_Coverage, 3757,
     /*  87418 */     GIR_EraseRootFromParent_Done,
     /*  87419 */   // Label 1614: @87419
     /*  87419 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(87526), // Rule ID 3759 //
     /*  87424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87445 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87448 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87475 */     // MIs[1] Operand 1
     /*  87475 */     // No operand predicates
     /*  87475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87497 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87502 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87518 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87524 */     GIR_RootConstrainSelectedInstOperands,
     /*  87525 */     // GIR_Coverage, 3759,
     /*  87525 */     GIR_EraseRootFromParent_Done,
     /*  87526 */   // Label 1615: @87526
     /*  87526 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(87633), // Rule ID 3761 //
     /*  87531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87552 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87555 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87582 */     // MIs[1] Operand 1
     /*  87582 */     // No operand predicates
     /*  87582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87604 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87609 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87631 */     GIR_RootConstrainSelectedInstOperands,
     /*  87632 */     // GIR_Coverage, 3761,
     /*  87632 */     GIR_EraseRootFromParent_Done,
     /*  87633 */   // Label 1616: @87633
     /*  87633 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(87740), // Rule ID 3763 //
     /*  87638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87659 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87662 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87689 */     // MIs[1] Operand 1
     /*  87689 */     // No operand predicates
     /*  87689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87711 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87716 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87738 */     GIR_RootConstrainSelectedInstOperands,
     /*  87739 */     // GIR_Coverage, 3763,
     /*  87739 */     GIR_EraseRootFromParent_Done,
     /*  87740 */   // Label 1617: @87740
     /*  87740 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(87847), // Rule ID 3765 //
     /*  87745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87766 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87769 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87796 */     // MIs[1] Operand 1
     /*  87796 */     // No operand predicates
     /*  87796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87818 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87823 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87845 */     GIR_RootConstrainSelectedInstOperands,
     /*  87846 */     // GIR_Coverage, 3765,
     /*  87846 */     GIR_EraseRootFromParent_Done,
     /*  87847 */   // Label 1618: @87847
     /*  87847 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(87954), // Rule ID 3767 //
     /*  87852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87873 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87876 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87903 */     // MIs[1] Operand 1
     /*  87903 */     // No operand predicates
     /*  87903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87925 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87930 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87952 */     GIR_RootConstrainSelectedInstOperands,
     /*  87953 */     // GIR_Coverage, 3767,
     /*  87953 */     GIR_EraseRootFromParent_Done,
     /*  87954 */   // Label 1619: @87954
     /*  87954 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(88061), // Rule ID 3769 //
     /*  87959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87980 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87983 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88006 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88010 */     // MIs[1] Operand 1
     /*  88010 */     // No operand predicates
     /*  88010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88032 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  88035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88037 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88059 */     GIR_RootConstrainSelectedInstOperands,
     /*  88060 */     // GIR_Coverage, 3769,
     /*  88060 */     GIR_EraseRootFromParent_Done,
     /*  88061 */   // Label 1620: @88061
     /*  88061 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(88168), // Rule ID 3771 //
     /*  88066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88087 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88090 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88117 */     // MIs[1] Operand 1
     /*  88117 */     // No operand predicates
     /*  88117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88139 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88144 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88148 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88166 */     GIR_RootConstrainSelectedInstOperands,
     /*  88167 */     // GIR_Coverage, 3771,
     /*  88167 */     GIR_EraseRootFromParent_Done,
     /*  88168 */   // Label 1621: @88168
     /*  88168 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(88275), // Rule ID 3773 //
     /*  88173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88194 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88197 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88224 */     // MIs[1] Operand 1
     /*  88224 */     // No operand predicates
     /*  88224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88246 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88251 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88273 */     GIR_RootConstrainSelectedInstOperands,
     /*  88274 */     // GIR_Coverage, 3773,
     /*  88274 */     GIR_EraseRootFromParent_Done,
     /*  88275 */   // Label 1622: @88275
     /*  88275 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(88382), // Rule ID 3775 //
     /*  88280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88301 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88304 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88331 */     // MIs[1] Operand 1
     /*  88331 */     // No operand predicates
     /*  88331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88353 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88358 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88380 */     GIR_RootConstrainSelectedInstOperands,
     /*  88381 */     // GIR_Coverage, 3775,
     /*  88381 */     GIR_EraseRootFromParent_Done,
     /*  88382 */   // Label 1623: @88382
     /*  88382 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(88489), // Rule ID 3777 //
     /*  88387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88408 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88411 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88438 */     // MIs[1] Operand 1
     /*  88438 */     // No operand predicates
     /*  88438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88460 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88465 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88487 */     GIR_RootConstrainSelectedInstOperands,
     /*  88488 */     // GIR_Coverage, 3777,
     /*  88488 */     GIR_EraseRootFromParent_Done,
     /*  88489 */   // Label 1624: @88489
     /*  88489 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(88596), // Rule ID 3779 //
     /*  88494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88515 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88518 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88545 */     // MIs[1] Operand 1
     /*  88545 */     // No operand predicates
     /*  88545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88567 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88572 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88588 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88594 */     GIR_RootConstrainSelectedInstOperands,
     /*  88595 */     // GIR_Coverage, 3779,
     /*  88595 */     GIR_EraseRootFromParent_Done,
     /*  88596 */   // Label 1625: @88596
     /*  88596 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(88703), // Rule ID 3781 //
     /*  88601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88622 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88625 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88652 */     // MIs[1] Operand 1
     /*  88652 */     // No operand predicates
     /*  88652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88674 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88679 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88701 */     GIR_RootConstrainSelectedInstOperands,
     /*  88702 */     // GIR_Coverage, 3781,
     /*  88702 */     GIR_EraseRootFromParent_Done,
     /*  88703 */   // Label 1626: @88703
     /*  88703 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(88810), // Rule ID 3783 //
     /*  88708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88729 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88732 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88759 */     // MIs[1] Operand 1
     /*  88759 */     // No operand predicates
     /*  88759 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88781 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88786 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88790 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88808 */     GIR_RootConstrainSelectedInstOperands,
     /*  88809 */     // GIR_Coverage, 3783,
     /*  88809 */     GIR_EraseRootFromParent_Done,
     /*  88810 */   // Label 1627: @88810
     /*  88810 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(88917), // Rule ID 3785 //
     /*  88815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88836 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88839 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88866 */     // MIs[1] Operand 1
     /*  88866 */     // No operand predicates
     /*  88866 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88888 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88893 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88915 */     GIR_RootConstrainSelectedInstOperands,
     /*  88916 */     // GIR_Coverage, 3785,
     /*  88916 */     GIR_EraseRootFromParent_Done,
     /*  88917 */   // Label 1628: @88917
     /*  88917 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(89024), // Rule ID 3787 //
     /*  88922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88943 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88946 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88973 */     // MIs[1] Operand 1
     /*  88973 */     // No operand predicates
     /*  88973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88995 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  88998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89000 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89010 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89016 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89022 */     GIR_RootConstrainSelectedInstOperands,
     /*  89023 */     // GIR_Coverage, 3787,
     /*  89023 */     GIR_EraseRootFromParent_Done,
     /*  89024 */   // Label 1629: @89024
     /*  89024 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(89131), // Rule ID 3789 //
     /*  89029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89050 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89053 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89080 */     // MIs[1] Operand 1
     /*  89080 */     // No operand predicates
     /*  89080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89102 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  89105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89107 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89129 */     GIR_RootConstrainSelectedInstOperands,
     /*  89130 */     // GIR_Coverage, 3789,
     /*  89130 */     GIR_EraseRootFromParent_Done,
     /*  89131 */   // Label 1630: @89131
     /*  89131 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(89238), // Rule ID 3791 //
     /*  89136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89157 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89160 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89187 */     // MIs[1] Operand 1
     /*  89187 */     // No operand predicates
     /*  89187 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89191 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89209 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  89212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89214 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89236 */     GIR_RootConstrainSelectedInstOperands,
     /*  89237 */     // GIR_Coverage, 3791,
     /*  89237 */     GIR_EraseRootFromParent_Done,
     /*  89238 */   // Label 1631: @89238
     /*  89238 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(89345), // Rule ID 3793 //
     /*  89243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89264 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89267 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89294 */     // MIs[1] Operand 1
     /*  89294 */     // No operand predicates
     /*  89294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89316 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89321 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89343 */     GIR_RootConstrainSelectedInstOperands,
     /*  89344 */     // GIR_Coverage, 3793,
     /*  89344 */     GIR_EraseRootFromParent_Done,
     /*  89345 */   // Label 1632: @89345
     /*  89345 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(89452), // Rule ID 3795 //
     /*  89350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89371 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89374 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89401 */     // MIs[1] Operand 1
     /*  89401 */     // No operand predicates
     /*  89401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89423 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89428 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89450 */     GIR_RootConstrainSelectedInstOperands,
     /*  89451 */     // GIR_Coverage, 3795,
     /*  89451 */     GIR_EraseRootFromParent_Done,
     /*  89452 */   // Label 1633: @89452
     /*  89452 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(89559), // Rule ID 3797 //
     /*  89457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89478 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89481 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89508 */     // MIs[1] Operand 1
     /*  89508 */     // No operand predicates
     /*  89508 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89512 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89530 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89535 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89557 */     GIR_RootConstrainSelectedInstOperands,
     /*  89558 */     // GIR_Coverage, 3797,
     /*  89558 */     GIR_EraseRootFromParent_Done,
     /*  89559 */   // Label 1634: @89559
     /*  89559 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(89666), // Rule ID 3799 //
     /*  89564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89585 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89588 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89615 */     // MIs[1] Operand 1
     /*  89615 */     // No operand predicates
     /*  89615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89619 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89637 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89642 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89664 */     GIR_RootConstrainSelectedInstOperands,
     /*  89665 */     // GIR_Coverage, 3799,
     /*  89665 */     GIR_EraseRootFromParent_Done,
     /*  89666 */   // Label 1635: @89666
     /*  89666 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(89773), // Rule ID 3801 //
     /*  89671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89692 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89695 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89722 */     // MIs[1] Operand 1
     /*  89722 */     // No operand predicates
     /*  89722 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89726 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89744 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89749 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89771 */     GIR_RootConstrainSelectedInstOperands,
     /*  89772 */     // GIR_Coverage, 3801,
     /*  89772 */     GIR_EraseRootFromParent_Done,
     /*  89773 */   // Label 1636: @89773
     /*  89773 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(89880), // Rule ID 3803 //
     /*  89778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89799 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89802 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89829 */     // MIs[1] Operand 1
     /*  89829 */     // No operand predicates
     /*  89829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89851 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89856 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89878 */     GIR_RootConstrainSelectedInstOperands,
     /*  89879 */     // GIR_Coverage, 3803,
     /*  89879 */     GIR_EraseRootFromParent_Done,
     /*  89880 */   // Label 1637: @89880
     /*  89880 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(89987), // Rule ID 3805 //
     /*  89885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89906 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89909 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89936 */     // MIs[1] Operand 1
     /*  89936 */     // No operand predicates
     /*  89936 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89940 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89958 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89963 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89985 */     GIR_RootConstrainSelectedInstOperands,
     /*  89986 */     // GIR_Coverage, 3805,
     /*  89986 */     GIR_EraseRootFromParent_Done,
     /*  89987 */   // Label 1638: @89987
     /*  89987 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(90094), // Rule ID 3807 //
     /*  89992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90013 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90016 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90043 */     // MIs[1] Operand 1
     /*  90043 */     // No operand predicates
     /*  90043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90065 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  90068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90070 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90086 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90092 */     GIR_RootConstrainSelectedInstOperands,
     /*  90093 */     // GIR_Coverage, 3807,
     /*  90093 */     GIR_EraseRootFromParent_Done,
     /*  90094 */   // Label 1639: @90094
     /*  90094 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(90201), // Rule ID 3809 //
     /*  90099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90120 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90123 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90150 */     // MIs[1] Operand 1
     /*  90150 */     // No operand predicates
     /*  90150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90172 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  90175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90177 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90199 */     GIR_RootConstrainSelectedInstOperands,
     /*  90200 */     // GIR_Coverage, 3809,
     /*  90200 */     GIR_EraseRootFromParent_Done,
     /*  90201 */   // Label 1640: @90201
     /*  90201 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(90308), // Rule ID 3811 //
     /*  90206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90227 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90230 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90257 */     // MIs[1] Operand 1
     /*  90257 */     // No operand predicates
     /*  90257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90279 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90284 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90306 */     GIR_RootConstrainSelectedInstOperands,
     /*  90307 */     // GIR_Coverage, 3811,
     /*  90307 */     GIR_EraseRootFromParent_Done,
     /*  90308 */   // Label 1641: @90308
     /*  90308 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(90415), // Rule ID 3813 //
     /*  90313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90334 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90337 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90364 */     // MIs[1] Operand 1
     /*  90364 */     // No operand predicates
     /*  90364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90368 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90386 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90391 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90413 */     GIR_RootConstrainSelectedInstOperands,
     /*  90414 */     // GIR_Coverage, 3813,
     /*  90414 */     GIR_EraseRootFromParent_Done,
     /*  90415 */   // Label 1642: @90415
     /*  90415 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(90522), // Rule ID 3815 //
     /*  90420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90441 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90444 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90471 */     // MIs[1] Operand 1
     /*  90471 */     // No operand predicates
     /*  90471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90493 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90498 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90520 */     GIR_RootConstrainSelectedInstOperands,
     /*  90521 */     // GIR_Coverage, 3815,
     /*  90521 */     GIR_EraseRootFromParent_Done,
     /*  90522 */   // Label 1643: @90522
     /*  90522 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(90629), // Rule ID 3817 //
     /*  90527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90548 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90551 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90578 */     // MIs[1] Operand 1
     /*  90578 */     // No operand predicates
     /*  90578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90582 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90600 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90605 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90627 */     GIR_RootConstrainSelectedInstOperands,
     /*  90628 */     // GIR_Coverage, 3817,
     /*  90628 */     GIR_EraseRootFromParent_Done,
     /*  90629 */   // Label 1644: @90629
     /*  90629 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(90736), // Rule ID 3819 //
     /*  90634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90655 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90658 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90685 */     // MIs[1] Operand 1
     /*  90685 */     // No operand predicates
     /*  90685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90707 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90712 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90734 */     GIR_RootConstrainSelectedInstOperands,
     /*  90735 */     // GIR_Coverage, 3819,
     /*  90735 */     GIR_EraseRootFromParent_Done,
     /*  90736 */   // Label 1645: @90736
     /*  90736 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(90843), // Rule ID 3821 //
     /*  90741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90762 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90765 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90792 */     // MIs[1] Operand 1
     /*  90792 */     // No operand predicates
     /*  90792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90814 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90819 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90841 */     GIR_RootConstrainSelectedInstOperands,
     /*  90842 */     // GIR_Coverage, 3821,
     /*  90842 */     GIR_EraseRootFromParent_Done,
     /*  90843 */   // Label 1646: @90843
     /*  90843 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(90950), // Rule ID 3823 //
     /*  90848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90869 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90872 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90899 */     // MIs[1] Operand 1
     /*  90899 */     // No operand predicates
     /*  90899 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90903 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90921 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90926 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90936 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90948 */     GIR_RootConstrainSelectedInstOperands,
     /*  90949 */     // GIR_Coverage, 3823,
     /*  90949 */     GIR_EraseRootFromParent_Done,
     /*  90950 */   // Label 1647: @90950
     /*  90950 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(91057), // Rule ID 3825 //
     /*  90955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90976 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90979 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91006 */     // MIs[1] Operand 1
     /*  91006 */     // No operand predicates
     /*  91006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  91014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91028 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  91031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91033 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91055 */     GIR_RootConstrainSelectedInstOperands,
     /*  91056 */     // GIR_Coverage, 3825,
     /*  91056 */     GIR_EraseRootFromParent_Done,
     /*  91057 */   // Label 1648: @91057
     /*  91057 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(91164), // Rule ID 3827 //
     /*  91062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91083 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91086 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91113 */     // MIs[1] Operand 1
     /*  91113 */     // No operand predicates
     /*  91113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91135 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  91138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91140 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91156 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91162 */     GIR_RootConstrainSelectedInstOperands,
     /*  91163 */     // GIR_Coverage, 3827,
     /*  91163 */     GIR_EraseRootFromParent_Done,
     /*  91164 */   // Label 1649: @91164
     /*  91164 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(91271), // Rule ID 3829 //
     /*  91169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91190 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91193 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91220 */     // MIs[1] Operand 1
     /*  91220 */     // No operand predicates
     /*  91220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91224 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91247 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91269 */     GIR_RootConstrainSelectedInstOperands,
     /*  91270 */     // GIR_Coverage, 3829,
     /*  91270 */     GIR_EraseRootFromParent_Done,
     /*  91271 */   // Label 1650: @91271
     /*  91271 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(91378), // Rule ID 3831 //
     /*  91276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91297 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91300 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91327 */     // MIs[1] Operand 1
     /*  91327 */     // No operand predicates
     /*  91327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91349 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91354 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91376 */     GIR_RootConstrainSelectedInstOperands,
     /*  91377 */     // GIR_Coverage, 3831,
     /*  91377 */     GIR_EraseRootFromParent_Done,
     /*  91378 */   // Label 1651: @91378
     /*  91378 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(91485), // Rule ID 3833 //
     /*  91383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91404 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91407 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91434 */     // MIs[1] Operand 1
     /*  91434 */     // No operand predicates
     /*  91434 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91456 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91461 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91483 */     GIR_RootConstrainSelectedInstOperands,
     /*  91484 */     // GIR_Coverage, 3833,
     /*  91484 */     GIR_EraseRootFromParent_Done,
     /*  91485 */   // Label 1652: @91485
     /*  91485 */   GIM_Reject,
     /*  91486 */ // Label 1612: @91486
     /*  91486 */ GIM_Reject,
     /*  91487 */ // Label 15: @91487
     /*  91487 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(91544),
     /*  91492 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91495 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91500 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(91517), // Rule ID 245 //
     /*  91505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91508 */     // (intrinsic_void 3462:{ *:[iPTR] })  =>  (CLREX)
     /*  91508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91515 */     GIR_RootConstrainSelectedInstOperands,
     /*  91516 */     // GIR_Coverage, 245,
     /*  91516 */     GIR_EraseRootFromParent_Done,
     /*  91517 */   // Label 1654: @91517
     /*  91517 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91543), // Rule ID 574 //
     /*  91522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91525 */     // (intrinsic_void 3462:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91541 */     GIR_RootConstrainSelectedInstOperands,
     /*  91542 */     // GIR_Coverage, 574,
     /*  91542 */     GIR_EraseRootFromParent_Done,
     /*  91543 */   // Label 1655: @91543
     /*  91543 */   GIM_Reject,
     /*  91544 */ // Label 1653: @91544
     /*  91544 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(92346),
     /*  91549 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91552 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91588), // Rule ID 344 //
     /*  91557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91565 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91568 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91579 */     // (intrinsic_void 3903:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91586 */     GIR_RootConstrainSelectedInstOperands,
     /*  91587 */     // GIR_Coverage, 344,
     /*  91587 */     GIR_EraseRootFromParent_Done,
     /*  91588 */   // Label 1657: @91588
     /*  91588 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91640), // Rule ID 2 //
     /*  91593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91601 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91616 */     // MIs[1] Operand 1
     /*  91616 */     // No operand predicates
     /*  91616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91618 */     // (intrinsic_void 3480:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91633 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91638 */     GIR_RootConstrainSelectedInstOperands,
     /*  91639 */     // GIR_Coverage, 2,
     /*  91639 */     GIR_EraseRootFromParent_Done,
     /*  91640 */   // Label 1658: @91640
     /*  91640 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91692), // Rule ID 10 //
     /*  91645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91653 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91664 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91668 */     // MIs[1] Operand 1
     /*  91668 */     // No operand predicates
     /*  91668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91670 */     // (intrinsic_void 3475:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91690 */     GIR_RootConstrainSelectedInstOperands,
     /*  91691 */     // GIR_Coverage, 10,
     /*  91691 */     GIR_EraseRootFromParent_Done,
     /*  91692 */   // Label 1659: @91692
     /*  91692 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91735), // Rule ID 11 //
     /*  91697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91705 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91720 */     // MIs[1] Operand 1
     /*  91720 */     // No operand predicates
     /*  91720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91722 */     // (intrinsic_void 3903:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91733 */     GIR_RootConstrainSelectedInstOperands,
     /*  91734 */     // GIR_Coverage, 11,
     /*  91734 */     GIR_EraseRootFromParent_Done,
     /*  91735 */   // Label 1660: @91735
     /*  91735 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91778), // Rule ID 228 //
     /*  91740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91748 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91763 */     // MIs[1] Operand 1
     /*  91763 */     // No operand predicates
     /*  91763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91765 */     // (intrinsic_void 3476:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91776 */     GIR_RootConstrainSelectedInstOperands,
     /*  91777 */     // GIR_Coverage, 228,
     /*  91777 */     GIR_EraseRootFromParent_Done,
     /*  91778 */   // Label 1661: @91778
     /*  91778 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91821), // Rule ID 229 //
     /*  91783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91791 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91806 */     // MIs[1] Operand 1
     /*  91806 */     // No operand predicates
     /*  91806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91808 */     // (intrinsic_void 3477:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91819 */     GIR_RootConstrainSelectedInstOperands,
     /*  91820 */     // GIR_Coverage, 229,
     /*  91820 */     GIR_EraseRootFromParent_Done,
     /*  91821 */   // Label 1662: @91821
     /*  91821 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91864), // Rule ID 230 //
     /*  91826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91834 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91849 */     // MIs[1] Operand 1
     /*  91849 */     // No operand predicates
     /*  91849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91851 */     // (intrinsic_void 3481:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91862 */     GIR_RootConstrainSelectedInstOperands,
     /*  91863 */     // GIR_Coverage, 230,
     /*  91863 */     GIR_EraseRootFromParent_Done,
     /*  91864 */   // Label 1663: @91864
     /*  91864 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91916), // Rule ID 276 //
     /*  91869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91877 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91892 */     // MIs[1] Operand 1
     /*  91892 */     // No operand predicates
     /*  91892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91894 */     // (intrinsic_void 3480:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91914 */     GIR_RootConstrainSelectedInstOperands,
     /*  91915 */     // GIR_Coverage, 276,
     /*  91915 */     GIR_EraseRootFromParent_Done,
     /*  91916 */   // Label 1664: @91916
     /*  91916 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91959), // Rule ID 343 //
     /*  91921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91929 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91944 */     // MIs[1] Operand 1
     /*  91944 */     // No operand predicates
     /*  91944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91946 */     // (intrinsic_void 3903:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91952 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91957 */     GIR_RootConstrainSelectedInstOperands,
     /*  91958 */     // GIR_Coverage, 343,
     /*  91958 */     GIR_EraseRootFromParent_Done,
     /*  91959 */   // Label 1665: @91959
     /*  91959 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(92002), // Rule ID 494 //
     /*  91964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91972 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91987 */     // MIs[1] Operand 1
     /*  91987 */     // No operand predicates
     /*  91987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91989 */     // (intrinsic_void 3903:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  91992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92000 */     GIR_RootConstrainSelectedInstOperands,
     /*  92001 */     // GIR_Coverage, 494,
     /*  92001 */     GIR_EraseRootFromParent_Done,
     /*  92002 */   // Label 1666: @92002
     /*  92002 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(92054), // Rule ID 559 //
     /*  92007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  92015 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92030 */     // MIs[1] Operand 1
     /*  92030 */     // No operand predicates
     /*  92030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92032 */     // (intrinsic_void 3476:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  92032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  92035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92052 */     GIR_RootConstrainSelectedInstOperands,
     /*  92053 */     // GIR_Coverage, 559,
     /*  92053 */     GIR_EraseRootFromParent_Done,
     /*  92054 */   // Label 1667: @92054
     /*  92054 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(92106), // Rule ID 560 //
     /*  92059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  92067 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92082 */     // MIs[1] Operand 1
     /*  92082 */     // No operand predicates
     /*  92082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92084 */     // (intrinsic_void 3477:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  92084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  92087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92104 */     GIR_RootConstrainSelectedInstOperands,
     /*  92105 */     // GIR_Coverage, 560,
     /*  92105 */     GIR_EraseRootFromParent_Done,
     /*  92106 */   // Label 1668: @92106
     /*  92106 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(92158), // Rule ID 561 //
     /*  92111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  92119 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92134 */     // MIs[1] Operand 1
     /*  92134 */     // No operand predicates
     /*  92134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92136 */     // (intrinsic_void 3481:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  92136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  92139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92156 */     GIR_RootConstrainSelectedInstOperands,
     /*  92157 */     // GIR_Coverage, 561,
     /*  92157 */     GIR_EraseRootFromParent_Done,
     /*  92158 */   // Label 1669: @92158
     /*  92158 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(92210), // Rule ID 579 //
     /*  92163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  92171 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  92186 */     // MIs[1] Operand 1
     /*  92186 */     // No operand predicates
     /*  92186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92188 */     // (intrinsic_void 3480:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  92188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  92191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92203 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92208 */     GIR_RootConstrainSelectedInstOperands,
     /*  92209 */     // GIR_Coverage, 579,
     /*  92209 */     GIR_EraseRootFromParent_Done,
     /*  92210 */   // Label 1670: @92210
     /*  92210 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(92262), // Rule ID 580 //
     /*  92215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92223 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92238 */     // MIs[1] Operand 1
     /*  92238 */     // No operand predicates
     /*  92238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92240 */     // (intrinsic_void 3475:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92260 */     GIR_RootConstrainSelectedInstOperands,
     /*  92261 */     // GIR_Coverage, 580,
     /*  92261 */     GIR_EraseRootFromParent_Done,
     /*  92262 */   // Label 1671: @92262
     /*  92262 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(92302), // Rule ID 722 //
     /*  92267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92282 */     // (intrinsic_w_chain:{ *:[i32] } 3478:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92290 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92300 */     GIR_RootConstrainSelectedInstOperands,
     /*  92301 */     // GIR_Coverage, 722,
     /*  92301 */     GIR_EraseRootFromParent_Done,
     /*  92302 */   // Label 1672: @92302
     /*  92302 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(92345), // Rule ID 723 //
     /*  92307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92315 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92322 */     // (intrinsic_void 3847:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  92322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92336 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92343 */     GIR_RootConstrainSelectedInstOperands,
     /*  92344 */     // GIR_Coverage, 723,
     /*  92344 */     GIR_EraseRootFromParent_Done,
     /*  92345 */   // Label 1673: @92345
     /*  92345 */   GIM_Reject,
     /*  92346 */ // Label 1656: @92346
     /*  92346 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92389), // Rule ID 604 //
     /*  92351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92354 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92357 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92362 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92376 */   // (intrinsic_w_chain:{ *:[i32] } 344:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92381 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92387 */   GIR_RootConstrainSelectedInstOperands,
     /*  92388 */   // GIR_Coverage, 604,
     /*  92388 */   GIR_EraseRootFromParent_Done,
     /*  92389 */ // Label 1674: @92389
     /*  92389 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(94380),
     /*  92394 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92397 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92451), // Rule ID 5048 //
     /*  92402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92432 */     // MIs[1] Operand 1
     /*  92432 */     // No operand predicates
     /*  92432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92434 */     // (intrinsic_w_chain:{ *:[v4i32] } 3611:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92439 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92449 */     GIR_RootConstrainSelectedInstOperands,
     /*  92450 */     // GIR_Coverage, 5048,
     /*  92450 */     GIR_EraseRootFromParent_Done,
     /*  92451 */   // Label 1676: @92451
     /*  92451 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92505), // Rule ID 5054 //
     /*  92456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92486 */     // MIs[1] Operand 1
     /*  92486 */     // No operand predicates
     /*  92486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92488 */     // (intrinsic_w_chain:{ *:[v4f32] } 3611:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92493 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92503 */     GIR_RootConstrainSelectedInstOperands,
     /*  92504 */     // GIR_Coverage, 5054,
     /*  92504 */     GIR_EraseRootFromParent_Done,
     /*  92505 */   // Label 1677: @92505
     /*  92505 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92559), // Rule ID 5056 //
     /*  92510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92540 */     // MIs[1] Operand 1
     /*  92540 */     // No operand predicates
     /*  92540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92542 */     // (intrinsic_w_chain:{ *:[v2i64] } 3611:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92547 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92557 */     GIR_RootConstrainSelectedInstOperands,
     /*  92558 */     // GIR_Coverage, 5056,
     /*  92558 */     GIR_EraseRootFromParent_Done,
     /*  92559 */   // Label 1678: @92559
     /*  92559 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92613), // Rule ID 5058 //
     /*  92564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92594 */     // MIs[1] Operand 1
     /*  92594 */     // No operand predicates
     /*  92594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92596 */     // (intrinsic_w_chain:{ *:[v2f64] } 3611:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92601 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92611 */     GIR_RootConstrainSelectedInstOperands,
     /*  92612 */     // GIR_Coverage, 5058,
     /*  92612 */     GIR_EraseRootFromParent_Done,
     /*  92613 */   // Label 1679: @92613
     /*  92613 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92655), // Rule ID 1738 //
     /*  92618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92633 */     // MIs[0] size
     /*  92633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92640 */     // (intrinsic_w_chain:{ *:[i32] } 3878:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92645 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92653 */     GIR_RootConstrainSelectedInstOperands,
     /*  92654 */     // GIR_Coverage, 1738,
     /*  92654 */     GIR_EraseRootFromParent_Done,
     /*  92655 */   // Label 1680: @92655
     /*  92655 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92709), // Rule ID 5050 //
     /*  92660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92665 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92686 */     // MIs[1] Operand 1
     /*  92686 */     // No operand predicates
     /*  92686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92692 */     // (intrinsic_void 3685:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92695 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92697 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92707 */     GIR_RootConstrainSelectedInstOperands,
     /*  92708 */     // GIR_Coverage, 5050,
     /*  92708 */     GIR_EraseRootFromParent_Done,
     /*  92709 */   // Label 1681: @92709
     /*  92709 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92763), // Rule ID 5060 //
     /*  92714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92719 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92740 */     // MIs[1] Operand 1
     /*  92740 */     // No operand predicates
     /*  92740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92746 */     // (intrinsic_void 3685:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92749 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92751 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92761 */     GIR_RootConstrainSelectedInstOperands,
     /*  92762 */     // GIR_Coverage, 5060,
     /*  92762 */     GIR_EraseRootFromParent_Done,
     /*  92763 */   // Label 1682: @92763
     /*  92763 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92817), // Rule ID 5064 //
     /*  92768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92773 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92794 */     // MIs[1] Operand 1
     /*  92794 */     // No operand predicates
     /*  92794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92800 */     // (intrinsic_void 3685:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92803 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92805 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92815 */     GIR_RootConstrainSelectedInstOperands,
     /*  92816 */     // GIR_Coverage, 5064,
     /*  92816 */     GIR_EraseRootFromParent_Done,
     /*  92817 */   // Label 1683: @92817
     /*  92817 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92871), // Rule ID 5068 //
     /*  92822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92827 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92848 */     // MIs[1] Operand 1
     /*  92848 */     // No operand predicates
     /*  92848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92854 */     // (intrinsic_void 3685:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92857 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92859 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92869 */     GIR_RootConstrainSelectedInstOperands,
     /*  92870 */     // GIR_Coverage, 5068,
     /*  92870 */     GIR_EraseRootFromParent_Done,
     /*  92871 */   // Label 1684: @92871
     /*  92871 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92929), // Rule ID 3 //
     /*  92876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92905 */     // (intrinsic_w_chain:{ *:[i32] } 3846:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92927 */     GIR_RootConstrainSelectedInstOperands,
     /*  92928 */     // GIR_Coverage, 3,
     /*  92928 */     GIR_EraseRootFromParent_Done,
     /*  92929 */   // Label 1685: @92929
     /*  92929 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92987), // Rule ID 121 //
     /*  92934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92963 */     // (intrinsic_w_chain:{ *:[i32] } 3845:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92985 */     GIR_RootConstrainSelectedInstOperands,
     /*  92986 */     // GIR_Coverage, 121,
     /*  92986 */     GIR_EraseRootFromParent_Done,
     /*  92987 */   // Label 1686: @92987
     /*  92987 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(93045), // Rule ID 122 //
     /*  92992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93021 */     // (intrinsic_w_chain:{ *:[i32] } 3843:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  93024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93043 */     GIR_RootConstrainSelectedInstOperands,
     /*  93044 */     // GIR_Coverage, 122,
     /*  93044 */     GIR_EraseRootFromParent_Done,
     /*  93045 */   // Label 1687: @93045
     /*  93045 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(93103), // Rule ID 123 //
     /*  93050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93079 */     // (intrinsic_w_chain:{ *:[i32] } 3844:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  93082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93101 */     GIR_RootConstrainSelectedInstOperands,
     /*  93102 */     // GIR_Coverage, 123,
     /*  93102 */     GIR_EraseRootFromParent_Done,
     /*  93103 */   // Label 1688: @93103
     /*  93103 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(93161), // Rule ID 124 //
     /*  93108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93137 */     // (intrinsic_w_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  93140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93159 */     GIR_RootConstrainSelectedInstOperands,
     /*  93160 */     // GIR_Coverage, 124,
     /*  93160 */     GIR_EraseRootFromParent_Done,
     /*  93161 */   // Label 1689: @93161
     /*  93161 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(93219), // Rule ID 125 //
     /*  93166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93195 */     // (intrinsic_w_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  93198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93217 */     GIR_RootConstrainSelectedInstOperands,
     /*  93218 */     // GIR_Coverage, 125,
     /*  93218 */     GIR_EraseRootFromParent_Done,
     /*  93219 */   // Label 1690: @93219
     /*  93219 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(93277), // Rule ID 126 //
     /*  93224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93253 */     // (intrinsic_w_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93271 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93275 */     GIR_RootConstrainSelectedInstOperands,
     /*  93276 */     // GIR_Coverage, 126,
     /*  93276 */     GIR_EraseRootFromParent_Done,
     /*  93277 */   // Label 1691: @93277
     /*  93277 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(93335), // Rule ID 127 //
     /*  93282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93311 */     // (intrinsic_w_chain:{ *:[i32] } 3896:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93333 */     GIR_RootConstrainSelectedInstOperands,
     /*  93334 */     // GIR_Coverage, 127,
     /*  93334 */     GIR_EraseRootFromParent_Done,
     /*  93335 */   // Label 1692: @93335
     /*  93335 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(93393), // Rule ID 128 //
     /*  93340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93369 */     // (intrinsic_w_chain:{ *:[i32] } 3894:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93391 */     GIR_RootConstrainSelectedInstOperands,
     /*  93392 */     // GIR_Coverage, 128,
     /*  93392 */     GIR_EraseRootFromParent_Done,
     /*  93393 */   // Label 1693: @93393
     /*  93393 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(93451), // Rule ID 129 //
     /*  93398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93427 */     // (intrinsic_w_chain:{ *:[i32] } 3895:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93449 */     GIR_RootConstrainSelectedInstOperands,
     /*  93450 */     // GIR_Coverage, 129,
     /*  93450 */     GIR_EraseRootFromParent_Done,
     /*  93451 */   // Label 1694: @93451
     /*  93451 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(93509), // Rule ID 130 //
     /*  93456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93485 */     // (intrinsic_w_chain:{ *:[i32] } 3914:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93503 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93507 */     GIR_RootConstrainSelectedInstOperands,
     /*  93508 */     // GIR_Coverage, 130,
     /*  93508 */     GIR_EraseRootFromParent_Done,
     /*  93509 */   // Label 1695: @93509
     /*  93509 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(93567), // Rule ID 131 //
     /*  93514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93543 */     // (intrinsic_w_chain:{ *:[i32] } 3915:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93565 */     GIR_RootConstrainSelectedInstOperands,
     /*  93566 */     // GIR_Coverage, 131,
     /*  93566 */     GIR_EraseRootFromParent_Done,
     /*  93567 */   // Label 1696: @93567
     /*  93567 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(93625), // Rule ID 132 //
     /*  93572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93601 */     // (intrinsic_w_chain:{ *:[i32] } 3916:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93623 */     GIR_RootConstrainSelectedInstOperands,
     /*  93624 */     // GIR_Coverage, 132,
     /*  93624 */     GIR_EraseRootFromParent_Done,
     /*  93625 */   // Label 1697: @93625
     /*  93625 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(93683), // Rule ID 431 //
     /*  93630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93659 */     // (intrinsic_w_chain:{ *:[i32] } 3846:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93681 */     GIR_RootConstrainSelectedInstOperands,
     /*  93682 */     // GIR_Coverage, 431,
     /*  93682 */     GIR_EraseRootFromParent_Done,
     /*  93683 */   // Label 1698: @93683
     /*  93683 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(93741), // Rule ID 444 //
     /*  93688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93717 */     // (intrinsic_w_chain:{ *:[i32] } 3845:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93739 */     GIR_RootConstrainSelectedInstOperands,
     /*  93740 */     // GIR_Coverage, 444,
     /*  93740 */     GIR_EraseRootFromParent_Done,
     /*  93741 */   // Label 1699: @93741
     /*  93741 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93799), // Rule ID 445 //
     /*  93746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93775 */     // (intrinsic_w_chain:{ *:[i32] } 3843:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93793 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93797 */     GIR_RootConstrainSelectedInstOperands,
     /*  93798 */     // GIR_Coverage, 445,
     /*  93798 */     GIR_EraseRootFromParent_Done,
     /*  93799 */   // Label 1700: @93799
     /*  93799 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93857), // Rule ID 446 //
     /*  93804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93833 */     // (intrinsic_w_chain:{ *:[i32] } 3844:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93851 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93855 */     GIR_RootConstrainSelectedInstOperands,
     /*  93856 */     // GIR_Coverage, 446,
     /*  93856 */     GIR_EraseRootFromParent_Done,
     /*  93857 */   // Label 1701: @93857
     /*  93857 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93915), // Rule ID 447 //
     /*  93862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93891 */     // (intrinsic_w_chain:{ *:[i32] } 3881:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93913 */     GIR_RootConstrainSelectedInstOperands,
     /*  93914 */     // GIR_Coverage, 447,
     /*  93914 */     GIR_EraseRootFromParent_Done,
     /*  93915 */   // Label 1702: @93915
     /*  93915 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93973), // Rule ID 448 //
     /*  93920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93949 */     // (intrinsic_w_chain:{ *:[i32] } 3882:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93971 */     GIR_RootConstrainSelectedInstOperands,
     /*  93972 */     // GIR_Coverage, 448,
     /*  93972 */     GIR_EraseRootFromParent_Done,
     /*  93973 */   // Label 1703: @93973
     /*  93973 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(94031), // Rule ID 449 //
     /*  93978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94007 */     // (intrinsic_w_chain:{ *:[i32] } 3883:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  94010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94019 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94029 */     GIR_RootConstrainSelectedInstOperands,
     /*  94030 */     // GIR_Coverage, 449,
     /*  94030 */     GIR_EraseRootFromParent_Done,
     /*  94031 */   // Label 1704: @94031
     /*  94031 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(94089), // Rule ID 450 //
     /*  94036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  94044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94065 */     // (intrinsic_w_chain:{ *:[i32] } 3896:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  94068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94087 */     GIR_RootConstrainSelectedInstOperands,
     /*  94088 */     // GIR_Coverage, 450,
     /*  94088 */     GIR_EraseRootFromParent_Done,
     /*  94089 */   // Label 1705: @94089
     /*  94089 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(94147), // Rule ID 451 //
     /*  94094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  94102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94123 */     // (intrinsic_w_chain:{ *:[i32] } 3894:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  94126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94145 */     GIR_RootConstrainSelectedInstOperands,
     /*  94146 */     // GIR_Coverage, 451,
     /*  94146 */     GIR_EraseRootFromParent_Done,
     /*  94147 */   // Label 1706: @94147
     /*  94147 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(94205), // Rule ID 452 //
     /*  94152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  94160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94181 */     // (intrinsic_w_chain:{ *:[i32] } 3895:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  94184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94203 */     GIR_RootConstrainSelectedInstOperands,
     /*  94204 */     // GIR_Coverage, 452,
     /*  94204 */     GIR_EraseRootFromParent_Done,
     /*  94205 */   // Label 1707: @94205
     /*  94205 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(94263), // Rule ID 453 //
     /*  94210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94239 */     // (intrinsic_w_chain:{ *:[i32] } 3914:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94261 */     GIR_RootConstrainSelectedInstOperands,
     /*  94262 */     // GIR_Coverage, 453,
     /*  94262 */     GIR_EraseRootFromParent_Done,
     /*  94263 */   // Label 1708: @94263
     /*  94263 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(94321), // Rule ID 454 //
     /*  94268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94297 */     // (intrinsic_w_chain:{ *:[i32] } 3915:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94319 */     GIR_RootConstrainSelectedInstOperands,
     /*  94320 */     // GIR_Coverage, 454,
     /*  94320 */     GIR_EraseRootFromParent_Done,
     /*  94321 */   // Label 1709: @94321
     /*  94321 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(94379), // Rule ID 455 //
     /*  94326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94355 */     // (intrinsic_w_chain:{ *:[i32] } 3916:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94377 */     GIR_RootConstrainSelectedInstOperands,
     /*  94378 */     // GIR_Coverage, 455,
     /*  94378 */     GIR_EraseRootFromParent_Done,
     /*  94379 */   // Label 1710: @94379
     /*  94379 */   GIM_Reject,
     /*  94380 */ // Label 1675: @94380
     /*  94380 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(94626),
     /*  94385 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94388 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94393 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(94451), // Rule ID 5052 //
     /*  94398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94426 */     // MIs[1] Operand 1
     /*  94426 */     // No operand predicates
     /*  94426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94432 */     // (intrinsic_w_chain:{ *:[v4i32] } 3687:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94437 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94439 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94449 */     GIR_RootConstrainSelectedInstOperands,
     /*  94450 */     // GIR_Coverage, 5052,
     /*  94450 */     GIR_EraseRootFromParent_Done,
     /*  94451 */   // Label 1712: @94451
     /*  94451 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(94509), // Rule ID 5062 //
     /*  94456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94484 */     // MIs[1] Operand 1
     /*  94484 */     // No operand predicates
     /*  94484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94490 */     // (intrinsic_w_chain:{ *:[v4i32] } 3687:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94495 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94497 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94507 */     GIR_RootConstrainSelectedInstOperands,
     /*  94508 */     // GIR_Coverage, 5062,
     /*  94508 */     GIR_EraseRootFromParent_Done,
     /*  94509 */   // Label 1713: @94509
     /*  94509 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(94567), // Rule ID 5066 //
     /*  94514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94542 */     // MIs[1] Operand 1
     /*  94542 */     // No operand predicates
     /*  94542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94548 */     // (intrinsic_w_chain:{ *:[v2i64] } 3687:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94553 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94555 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94565 */     GIR_RootConstrainSelectedInstOperands,
     /*  94566 */     // GIR_Coverage, 5066,
     /*  94566 */     GIR_EraseRootFromParent_Done,
     /*  94567 */   // Label 1714: @94567
     /*  94567 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(94625), // Rule ID 5070 //
     /*  94572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94600 */     // MIs[1] Operand 1
     /*  94600 */     // No operand predicates
     /*  94600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94606 */     // (intrinsic_w_chain:{ *:[v2i64] } 3687:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94611 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94613 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94623 */     GIR_RootConstrainSelectedInstOperands,
     /*  94624 */     // GIR_Coverage, 5070,
     /*  94624 */     GIR_EraseRootFromParent_Done,
     /*  94625 */   // Label 1715: @94625
     /*  94625 */   GIM_Reject,
     /*  94626 */ // Label 1711: @94626
     /*  94626 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(95797),
     /*  94631 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94634 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(94695), // Rule ID 4940 //
     /*  94639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94656 */     // MIs[0] base
     /*  94656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94680 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94683 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94685 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94687 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94693 */     GIR_RootConstrainSelectedInstOperands,
     /*  94694 */     // GIR_Coverage, 4940,
     /*  94694 */     GIR_EraseRootFromParent_Done,
     /*  94695 */   // Label 1717: @94695
     /*  94695 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94756), // Rule ID 4941 //
     /*  94700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94717 */     // MIs[0] base
     /*  94717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94741 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94744 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94746 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94748 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94750 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94754 */     GIR_RootConstrainSelectedInstOperands,
     /*  94755 */     // GIR_Coverage, 4941,
     /*  94755 */     GIR_EraseRootFromParent_Done,
     /*  94756 */   // Label 1718: @94756
     /*  94756 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94817), // Rule ID 4944 //
     /*  94761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94778 */     // MIs[0] base
     /*  94778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94794 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94802 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94805 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94807 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94809 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94815 */     GIR_RootConstrainSelectedInstOperands,
     /*  94816 */     // GIR_Coverage, 4944,
     /*  94816 */     GIR_EraseRootFromParent_Done,
     /*  94817 */   // Label 1719: @94817
     /*  94817 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94878), // Rule ID 5024 //
     /*  94822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94839 */     // MIs[0] base
     /*  94839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94863 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94866 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94868 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94870 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94876 */     GIR_RootConstrainSelectedInstOperands,
     /*  94877 */     // GIR_Coverage, 5024,
     /*  94877 */     GIR_EraseRootFromParent_Done,
     /*  94878 */   // Label 1720: @94878
     /*  94878 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94939), // Rule ID 5026 //
     /*  94883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94900 */     // MIs[0] base
     /*  94900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94920 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94924 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94927 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94929 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94931 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94933 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94937 */     GIR_RootConstrainSelectedInstOperands,
     /*  94938 */     // GIR_Coverage, 5026,
     /*  94938 */     GIR_EraseRootFromParent_Done,
     /*  94939 */   // Label 1721: @94939
     /*  94939 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(95000), // Rule ID 5028 //
     /*  94944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94961 */     // MIs[0] base
     /*  94961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94985 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94988 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94990 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94992 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94998 */     GIR_RootConstrainSelectedInstOperands,
     /*  94999 */     // GIR_Coverage, 5028,
     /*  94999 */     GIR_EraseRootFromParent_Done,
     /*  95000 */   // Label 1722: @95000
     /*  95000 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(95061), // Rule ID 5029 //
     /*  95005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  95013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95022 */     // MIs[0] base
     /*  95022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95042 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95046 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  95049 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95051 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95053 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95059 */     GIR_RootConstrainSelectedInstOperands,
     /*  95060 */     // GIR_Coverage, 5029,
     /*  95060 */     GIR_EraseRootFromParent_Done,
     /*  95061 */   // Label 1723: @95061
     /*  95061 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(95122), // Rule ID 5032 //
     /*  95066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95083 */     // MIs[0] base
     /*  95083 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95107 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  95110 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95112 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95114 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95120 */     GIR_RootConstrainSelectedInstOperands,
     /*  95121 */     // GIR_Coverage, 5032,
     /*  95121 */     GIR_EraseRootFromParent_Done,
     /*  95122 */   // Label 1724: @95122
     /*  95122 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(95183), // Rule ID 5033 //
     /*  95127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95144 */     // MIs[0] base
     /*  95144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95168 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  95171 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95173 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95175 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95177 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95181 */     GIR_RootConstrainSelectedInstOperands,
     /*  95182 */     // GIR_Coverage, 5033,
     /*  95182 */     GIR_EraseRootFromParent_Done,
     /*  95183 */   // Label 1725: @95183
     /*  95183 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(95244), // Rule ID 5036 //
     /*  95188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95205 */     // MIs[0] base
     /*  95205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95229 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95232 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95234 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95236 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95242 */     GIR_RootConstrainSelectedInstOperands,
     /*  95243 */     // GIR_Coverage, 5036,
     /*  95243 */     GIR_EraseRootFromParent_Done,
     /*  95244 */   // Label 1726: @95244
     /*  95244 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(95305), // Rule ID 5037 //
     /*  95249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95266 */     // MIs[0] base
     /*  95266 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95290 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95293 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95295 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95297 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95303 */     GIR_RootConstrainSelectedInstOperands,
     /*  95304 */     // GIR_Coverage, 5037,
     /*  95304 */     GIR_EraseRootFromParent_Done,
     /*  95305 */   // Label 1727: @95305
     /*  95305 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(95366), // Rule ID 5040 //
     /*  95310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95327 */     // MIs[0] base
     /*  95327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95351 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95354 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95356 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95358 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95364 */     GIR_RootConstrainSelectedInstOperands,
     /*  95365 */     // GIR_Coverage, 5040,
     /*  95365 */     GIR_EraseRootFromParent_Done,
     /*  95366 */   // Label 1728: @95366
     /*  95366 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(95427), // Rule ID 5041 //
     /*  95371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95388 */     // MIs[0] base
     /*  95388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95408 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95412 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95415 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95417 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95419 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95421 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95425 */     GIR_RootConstrainSelectedInstOperands,
     /*  95426 */     // GIR_Coverage, 5041,
     /*  95426 */     GIR_EraseRootFromParent_Done,
     /*  95427 */   // Label 1729: @95427
     /*  95427 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(95488), // Rule ID 5044 //
     /*  95432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95449 */     // MIs[0] base
     /*  95449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95473 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95476 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95478 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95480 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95486 */     GIR_RootConstrainSelectedInstOperands,
     /*  95487 */     // GIR_Coverage, 5044,
     /*  95487 */     GIR_EraseRootFromParent_Done,
     /*  95488 */   // Label 1730: @95488
     /*  95488 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(95549), // Rule ID 5045 //
     /*  95493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95510 */     // MIs[0] base
     /*  95510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95526 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95530 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95534 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95537 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95539 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95541 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95547 */     GIR_RootConstrainSelectedInstOperands,
     /*  95548 */     // GIR_Coverage, 5045,
     /*  95548 */     GIR_EraseRootFromParent_Done,
     /*  95549 */   // Label 1731: @95549
     /*  95549 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(95613), // Rule ID 258 //
     /*  95554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95568 */     // MIs[0] cop
     /*  95568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95571 */     // MIs[0] opc1
     /*  95571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95582 */     // MIs[0] CRm
     /*  95582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95585 */     // (intrinsic_void 3492:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95588 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95590 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95596 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95607 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95611 */     GIR_RootConstrainSelectedInstOperands,
     /*  95612 */     // GIR_Coverage, 258,
     /*  95612 */     GIR_EraseRootFromParent_Done,
     /*  95613 */   // Label 1732: @95613
     /*  95613 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95668), // Rule ID 259 //
     /*  95618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95632 */     // MIs[0] cop
     /*  95632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95635 */     // MIs[0] opc1
     /*  95635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95646 */     // MIs[0] CRm
     /*  95646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95649 */     // (intrinsic_void 3493:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95652 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95654 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95660 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95666 */     GIR_RootConstrainSelectedInstOperands,
     /*  95667 */     // GIR_Coverage, 259,
     /*  95667 */     GIR_EraseRootFromParent_Done,
     /*  95668 */   // Label 1733: @95668
     /*  95668 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95732), // Rule ID 596 //
     /*  95673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95687 */     // MIs[0] cop
     /*  95687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95690 */     // MIs[0] opc1
     /*  95690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95701 */     // MIs[0] CRm
     /*  95701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95704 */     // (intrinsic_void 3492:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95707 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95709 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95715 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95730 */     GIR_RootConstrainSelectedInstOperands,
     /*  95731 */     // GIR_Coverage, 596,
     /*  95731 */     GIR_EraseRootFromParent_Done,
     /*  95732 */   // Label 1734: @95732
     /*  95732 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95796), // Rule ID 597 //
     /*  95737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95751 */     // MIs[0] cop
     /*  95751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95754 */     // MIs[0] opc1
     /*  95754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95765 */     // MIs[0] CRm
     /*  95765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95768 */     // (intrinsic_void 3493:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95771 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95773 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95779 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95794 */     GIR_RootConstrainSelectedInstOperands,
     /*  95795 */     // GIR_Coverage, 597,
     /*  95795 */     GIR_EraseRootFromParent_Done,
     /*  95796 */   // Label 1735: @95796
     /*  95796 */   GIM_Reject,
     /*  95797 */ // Label 1716: @95797
     /*  95797 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(99148),
     /*  95802 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95805 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95866), // Rule ID 246 //
     /*  95810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95818 */     // MIs[0] cop
     /*  95818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95821 */     // MIs[0] opc1
     /*  95821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95824 */     // MIs[0] CRd
     /*  95824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95827 */     // MIs[0] CRn
     /*  95827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95830 */     // MIs[0] CRm
     /*  95830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95833 */     // MIs[0] opc2
     /*  95833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95836 */     // (intrinsic_void 3460:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95839 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95841 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95843 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95845 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95847 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95849 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95864 */     GIR_RootConstrainSelectedInstOperands,
     /*  95865 */     // GIR_Coverage, 246,
     /*  95865 */     GIR_EraseRootFromParent_Done,
     /*  95866 */   // Label 1737: @95866
     /*  95866 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95918), // Rule ID 247 //
     /*  95871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95879 */     // MIs[0] cop
     /*  95879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95882 */     // MIs[0] opc1
     /*  95882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95885 */     // MIs[0] CRd
     /*  95885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95888 */     // MIs[0] CRn
     /*  95888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95891 */     // MIs[0] CRm
     /*  95891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95894 */     // MIs[0] opc2
     /*  95894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95897 */     // (intrinsic_void 3461:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95900 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95902 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95904 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95906 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95908 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95910 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95916 */     GIR_RootConstrainSelectedInstOperands,
     /*  95917 */     // GIR_Coverage, 247,
     /*  95917 */     GIR_EraseRootFromParent_Done,
     /*  95918 */   // Label 1738: @95918
     /*  95918 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95979), // Rule ID 598 //
     /*  95923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95931 */     // MIs[0] cop
     /*  95931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95934 */     // MIs[0] opc1
     /*  95934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95937 */     // MIs[0] CRd
     /*  95937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95940 */     // MIs[0] CRn
     /*  95940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95943 */     // MIs[0] CRm
     /*  95943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95946 */     // MIs[0] opc2
     /*  95946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95949 */     // (intrinsic_void 3460:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95952 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95954 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95956 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95958 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95960 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95962 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95977 */     GIR_RootConstrainSelectedInstOperands,
     /*  95978 */     // GIR_Coverage, 598,
     /*  95978 */     GIR_EraseRootFromParent_Done,
     /*  95979 */   // Label 1739: @95979
     /*  95979 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(96040), // Rule ID 599 //
     /*  95984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95992 */     // MIs[0] cop
     /*  95992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95995 */     // MIs[0] opc1
     /*  95995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95998 */     // MIs[0] CRd
     /*  95998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  96001 */     // MIs[0] CRn
     /*  96001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96004 */     // MIs[0] CRm
     /*  96004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96007 */     // MIs[0] opc2
     /*  96007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96010 */     // (intrinsic_void 3461:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  96013 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96015 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96017 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96019 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96021 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96023 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  96028 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  96034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96038 */     GIR_RootConstrainSelectedInstOperands,
     /*  96039 */     // GIR_Coverage, 599,
     /*  96039 */     GIR_EraseRootFromParent_Done,
     /*  96040 */   // Label 1740: @96040
     /*  96040 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(96108), // Rule ID 4934 //
     /*  96045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96069 */     // MIs[0] base
     /*  96069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96085 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96093 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96098 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96100 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96106 */     GIR_RootConstrainSelectedInstOperands,
     /*  96107 */     // GIR_Coverage, 4934,
     /*  96107 */     GIR_EraseRootFromParent_Done,
     /*  96108 */   // Label 1741: @96108
     /*  96108 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(96176), // Rule ID 4935 //
     /*  96113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96137 */     // MIs[0] base
     /*  96137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96161 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96166 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96168 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96174 */     GIR_RootConstrainSelectedInstOperands,
     /*  96175 */     // GIR_Coverage, 4935,
     /*  96175 */     GIR_EraseRootFromParent_Done,
     /*  96176 */   // Label 1742: @96176
     /*  96176 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(96244), // Rule ID 4938 //
     /*  96181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96205 */     // MIs[0] base
     /*  96205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96229 */     // (intrinsic_w_chain:{ *:[v16i8] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96234 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96236 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96242 */     GIR_RootConstrainSelectedInstOperands,
     /*  96243 */     // GIR_Coverage, 4938,
     /*  96243 */     GIR_EraseRootFromParent_Done,
     /*  96244 */   // Label 1743: @96244
     /*  96244 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(96312), // Rule ID 4946 //
     /*  96249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96273 */     // MIs[0] base
     /*  96273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96297 */     // (intrinsic_w_chain:{ *:[v16i8] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96302 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96304 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96310 */     GIR_RootConstrainSelectedInstOperands,
     /*  96311 */     // GIR_Coverage, 4946,
     /*  96311 */     GIR_EraseRootFromParent_Done,
     /*  96312 */   // Label 1744: @96312
     /*  96312 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(96380), // Rule ID 4948 //
     /*  96317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96341 */     // MIs[0] base
     /*  96341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96365 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96370 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96372 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96374 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96378 */     GIR_RootConstrainSelectedInstOperands,
     /*  96379 */     // GIR_Coverage, 4948,
     /*  96379 */     GIR_EraseRootFromParent_Done,
     /*  96380 */   // Label 1745: @96380
     /*  96380 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(96448), // Rule ID 4950 //
     /*  96385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96409 */     // MIs[0] base
     /*  96409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96433 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96438 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96440 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96446 */     GIR_RootConstrainSelectedInstOperands,
     /*  96447 */     // GIR_Coverage, 4950,
     /*  96447 */     GIR_EraseRootFromParent_Done,
     /*  96448 */   // Label 1746: @96448
     /*  96448 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(96516), // Rule ID 4952 //
     /*  96453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96477 */     // MIs[0] base
     /*  96477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96489 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96501 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96506 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96508 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96514 */     GIR_RootConstrainSelectedInstOperands,
     /*  96515 */     // GIR_Coverage, 4952,
     /*  96515 */     GIR_EraseRootFromParent_Done,
     /*  96516 */   // Label 1747: @96516
     /*  96516 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(96584), // Rule ID 4954 //
     /*  96521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96545 */     // MIs[0] base
     /*  96545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96569 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96574 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96576 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96578 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96582 */     GIR_RootConstrainSelectedInstOperands,
     /*  96583 */     // GIR_Coverage, 4954,
     /*  96583 */     GIR_EraseRootFromParent_Done,
     /*  96584 */   // Label 1748: @96584
     /*  96584 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(96652), // Rule ID 4956 //
     /*  96589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96613 */     // MIs[0] base
     /*  96613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96637 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96642 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96644 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96650 */     GIR_RootConstrainSelectedInstOperands,
     /*  96651 */     // GIR_Coverage, 4956,
     /*  96651 */     GIR_EraseRootFromParent_Done,
     /*  96652 */   // Label 1749: @96652
     /*  96652 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96720), // Rule ID 4957 //
     /*  96657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96681 */     // MIs[0] base
     /*  96681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96705 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96710 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96712 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96718 */     GIR_RootConstrainSelectedInstOperands,
     /*  96719 */     // GIR_Coverage, 4957,
     /*  96719 */     GIR_EraseRootFromParent_Done,
     /*  96720 */   // Label 1750: @96720
     /*  96720 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96788), // Rule ID 4960 //
     /*  96725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96749 */     // MIs[0] base
     /*  96749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96773 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96778 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96780 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96782 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96786 */     GIR_RootConstrainSelectedInstOperands,
     /*  96787 */     // GIR_Coverage, 4960,
     /*  96787 */     GIR_EraseRootFromParent_Done,
     /*  96788 */   // Label 1751: @96788
     /*  96788 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96856), // Rule ID 4961 //
     /*  96793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96817 */     // MIs[0] base
     /*  96817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96833 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96841 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96846 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96848 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96850 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96854 */     GIR_RootConstrainSelectedInstOperands,
     /*  96855 */     // GIR_Coverage, 4961,
     /*  96855 */     GIR_EraseRootFromParent_Done,
     /*  96856 */   // Label 1752: @96856
     /*  96856 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96924), // Rule ID 4964 //
     /*  96861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96885 */     // MIs[0] base
     /*  96885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96901 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96909 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96914 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96916 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96922 */     GIR_RootConstrainSelectedInstOperands,
     /*  96923 */     // GIR_Coverage, 4964,
     /*  96923 */     GIR_EraseRootFromParent_Done,
     /*  96924 */   // Label 1753: @96924
     /*  96924 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(96992), // Rule ID 4965 //
     /*  96929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96953 */     // MIs[0] base
     /*  96953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96965 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96977 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96982 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96984 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96986 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96990 */     GIR_RootConstrainSelectedInstOperands,
     /*  96991 */     // GIR_Coverage, 4965,
     /*  96991 */     GIR_EraseRootFromParent_Done,
     /*  96992 */   // Label 1754: @96992
     /*  96992 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(97060), // Rule ID 4968 //
     /*  96997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97021 */     // MIs[0] base
     /*  97021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97045 */     // (intrinsic_w_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97050 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97052 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97058 */     GIR_RootConstrainSelectedInstOperands,
     /*  97059 */     // GIR_Coverage, 4968,
     /*  97059 */     GIR_EraseRootFromParent_Done,
     /*  97060 */   // Label 1755: @97060
     /*  97060 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(97128), // Rule ID 4969 //
     /*  97065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97089 */     // MIs[0] base
     /*  97089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97105 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97113 */     // (intrinsic_w_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97118 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97120 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97126 */     GIR_RootConstrainSelectedInstOperands,
     /*  97127 */     // GIR_Coverage, 4969,
     /*  97127 */     GIR_EraseRootFromParent_Done,
     /*  97128 */   // Label 1756: @97128
     /*  97128 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(97196), // Rule ID 4972 //
     /*  97133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97157 */     // MIs[0] base
     /*  97157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97181 */     // (intrinsic_w_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97186 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97188 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97194 */     GIR_RootConstrainSelectedInstOperands,
     /*  97195 */     // GIR_Coverage, 4972,
     /*  97195 */     GIR_EraseRootFromParent_Done,
     /*  97196 */   // Label 1757: @97196
     /*  97196 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(97264), // Rule ID 4973 //
     /*  97201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97225 */     // MIs[0] base
     /*  97225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97249 */     // (intrinsic_w_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97254 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97256 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97262 */     GIR_RootConstrainSelectedInstOperands,
     /*  97263 */     // GIR_Coverage, 4973,
     /*  97263 */     GIR_EraseRootFromParent_Done,
     /*  97264 */   // Label 1758: @97264
     /*  97264 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(97332), // Rule ID 4976 //
     /*  97269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97293 */     // MIs[0] base
     /*  97293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97317 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97322 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97324 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97330 */     GIR_RootConstrainSelectedInstOperands,
     /*  97331 */     // GIR_Coverage, 4976,
     /*  97331 */     GIR_EraseRootFromParent_Done,
     /*  97332 */   // Label 1759: @97332
     /*  97332 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(97400), // Rule ID 4977 //
     /*  97337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97361 */     // MIs[0] base
     /*  97361 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97385 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97390 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97392 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97398 */     GIR_RootConstrainSelectedInstOperands,
     /*  97399 */     // GIR_Coverage, 4977,
     /*  97399 */     GIR_EraseRootFromParent_Done,
     /*  97400 */   // Label 1760: @97400
     /*  97400 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97468), // Rule ID 4980 //
     /*  97405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97429 */     // MIs[0] base
     /*  97429 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97453 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97458 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97460 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97466 */     GIR_RootConstrainSelectedInstOperands,
     /*  97467 */     // GIR_Coverage, 4980,
     /*  97467 */     GIR_EraseRootFromParent_Done,
     /*  97468 */   // Label 1761: @97468
     /*  97468 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97536), // Rule ID 4981 //
     /*  97473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97497 */     // MIs[0] base
     /*  97497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97521 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97526 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97528 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97534 */     GIR_RootConstrainSelectedInstOperands,
     /*  97535 */     // GIR_Coverage, 4981,
     /*  97535 */     GIR_EraseRootFromParent_Done,
     /*  97536 */   // Label 1762: @97536
     /*  97536 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97604), // Rule ID 4984 //
     /*  97541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97565 */     // MIs[0] base
     /*  97565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97589 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97594 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97596 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97602 */     GIR_RootConstrainSelectedInstOperands,
     /*  97603 */     // GIR_Coverage, 4984,
     /*  97603 */     GIR_EraseRootFromParent_Done,
     /*  97604 */   // Label 1763: @97604
     /*  97604 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97672), // Rule ID 4985 //
     /*  97609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97633 */     // MIs[0] base
     /*  97633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97657 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97662 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97664 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97670 */     GIR_RootConstrainSelectedInstOperands,
     /*  97671 */     // GIR_Coverage, 4985,
     /*  97671 */     GIR_EraseRootFromParent_Done,
     /*  97672 */   // Label 1764: @97672
     /*  97672 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97740), // Rule ID 4988 //
     /*  97677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97701 */     // MIs[0] base
     /*  97701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97725 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97730 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97732 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97738 */     GIR_RootConstrainSelectedInstOperands,
     /*  97739 */     // GIR_Coverage, 4988,
     /*  97739 */     GIR_EraseRootFromParent_Done,
     /*  97740 */   // Label 1765: @97740
     /*  97740 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97808), // Rule ID 4989 //
     /*  97745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97769 */     // MIs[0] base
     /*  97769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97793 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97798 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97800 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97806 */     GIR_RootConstrainSelectedInstOperands,
     /*  97807 */     // GIR_Coverage, 4989,
     /*  97807 */     GIR_EraseRootFromParent_Done,
     /*  97808 */   // Label 1766: @97808
     /*  97808 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97876), // Rule ID 4992 //
     /*  97813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97837 */     // MIs[0] base
     /*  97837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97861 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97866 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97868 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97874 */     GIR_RootConstrainSelectedInstOperands,
     /*  97875 */     // GIR_Coverage, 4992,
     /*  97875 */     GIR_EraseRootFromParent_Done,
     /*  97876 */   // Label 1767: @97876
     /*  97876 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97944), // Rule ID 4993 //
     /*  97881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97905 */     // MIs[0] base
     /*  97905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97921 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97929 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97934 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97936 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97942 */     GIR_RootConstrainSelectedInstOperands,
     /*  97943 */     // GIR_Coverage, 4993,
     /*  97943 */     GIR_EraseRootFromParent_Done,
     /*  97944 */   // Label 1768: @97944
     /*  97944 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(98012), // Rule ID 4996 //
     /*  97949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97973 */     // MIs[0] base
     /*  97973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97997 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98002 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98004 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98010 */     GIR_RootConstrainSelectedInstOperands,
     /*  98011 */     // GIR_Coverage, 4996,
     /*  98011 */     GIR_EraseRootFromParent_Done,
     /*  98012 */   // Label 1769: @98012
     /*  98012 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(98080), // Rule ID 4997 //
     /*  98017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98041 */     // MIs[0] base
     /*  98041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98065 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98070 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98072 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98078 */     GIR_RootConstrainSelectedInstOperands,
     /*  98079 */     // GIR_Coverage, 4997,
     /*  98079 */     GIR_EraseRootFromParent_Done,
     /*  98080 */   // Label 1770: @98080
     /*  98080 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(98148), // Rule ID 5000 //
     /*  98085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98109 */     // MIs[0] base
     /*  98109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98133 */     // (intrinsic_w_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98138 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98140 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98146 */     GIR_RootConstrainSelectedInstOperands,
     /*  98147 */     // GIR_Coverage, 5000,
     /*  98147 */     GIR_EraseRootFromParent_Done,
     /*  98148 */   // Label 1771: @98148
     /*  98148 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(98216), // Rule ID 5001 //
     /*  98153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98177 */     // MIs[0] base
     /*  98177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98193 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98201 */     // (intrinsic_w_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98206 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98208 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98214 */     GIR_RootConstrainSelectedInstOperands,
     /*  98215 */     // GIR_Coverage, 5001,
     /*  98215 */     GIR_EraseRootFromParent_Done,
     /*  98216 */   // Label 1772: @98216
     /*  98216 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(98284), // Rule ID 5004 //
     /*  98221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98245 */     // MIs[0] base
     /*  98245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98269 */     // (intrinsic_w_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98274 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98276 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98282 */     GIR_RootConstrainSelectedInstOperands,
     /*  98283 */     // GIR_Coverage, 5004,
     /*  98283 */     GIR_EraseRootFromParent_Done,
     /*  98284 */   // Label 1773: @98284
     /*  98284 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(98352), // Rule ID 5005 //
     /*  98289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98313 */     // MIs[0] base
     /*  98313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98337 */     // (intrinsic_w_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98342 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98344 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98350 */     GIR_RootConstrainSelectedInstOperands,
     /*  98351 */     // GIR_Coverage, 5005,
     /*  98351 */     GIR_EraseRootFromParent_Done,
     /*  98352 */   // Label 1774: @98352
     /*  98352 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(98420), // Rule ID 5008 //
     /*  98357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98381 */     // MIs[0] base
     /*  98381 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98405 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98410 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98412 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98418 */     GIR_RootConstrainSelectedInstOperands,
     /*  98419 */     // GIR_Coverage, 5008,
     /*  98419 */     GIR_EraseRootFromParent_Done,
     /*  98420 */   // Label 1775: @98420
     /*  98420 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(98488), // Rule ID 5009 //
     /*  98425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98449 */     // MIs[0] base
     /*  98449 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98461 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98473 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98478 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98480 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98486 */     GIR_RootConstrainSelectedInstOperands,
     /*  98487 */     // GIR_Coverage, 5009,
     /*  98487 */     GIR_EraseRootFromParent_Done,
     /*  98488 */   // Label 1776: @98488
     /*  98488 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98556), // Rule ID 5012 //
     /*  98493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98517 */     // MIs[0] base
     /*  98517 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98541 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98546 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98548 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98554 */     GIR_RootConstrainSelectedInstOperands,
     /*  98555 */     // GIR_Coverage, 5012,
     /*  98555 */     GIR_EraseRootFromParent_Done,
     /*  98556 */   // Label 1777: @98556
     /*  98556 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98624), // Rule ID 5013 //
     /*  98561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98585 */     // MIs[0] base
     /*  98585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98609 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98614 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98616 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98618 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98622 */     GIR_RootConstrainSelectedInstOperands,
     /*  98623 */     // GIR_Coverage, 5013,
     /*  98623 */     GIR_EraseRootFromParent_Done,
     /*  98624 */   // Label 1778: @98624
     /*  98624 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98692), // Rule ID 5016 //
     /*  98629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98653 */     // MIs[0] base
     /*  98653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98665 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98677 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98682 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98684 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98690 */     GIR_RootConstrainSelectedInstOperands,
     /*  98691 */     // GIR_Coverage, 5016,
     /*  98691 */     GIR_EraseRootFromParent_Done,
     /*  98692 */   // Label 1779: @98692
     /*  98692 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98760), // Rule ID 5017 //
     /*  98697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98721 */     // MIs[0] base
     /*  98721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98733 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98745 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98750 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98752 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98754 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98758 */     GIR_RootConstrainSelectedInstOperands,
     /*  98759 */     // GIR_Coverage, 5017,
     /*  98759 */     GIR_EraseRootFromParent_Done,
     /*  98760 */   // Label 1780: @98760
     /*  98760 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98828), // Rule ID 5020 //
     /*  98765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98789 */     // MIs[0] base
     /*  98789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98813 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98818 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98820 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98826 */     GIR_RootConstrainSelectedInstOperands,
     /*  98827 */     // GIR_Coverage, 5020,
     /*  98827 */     GIR_EraseRootFromParent_Done,
     /*  98828 */   // Label 1781: @98828
     /*  98828 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98896), // Rule ID 5021 //
     /*  98833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98857 */     // MIs[0] base
     /*  98857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98881 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98886 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98888 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98894 */     GIR_RootConstrainSelectedInstOperands,
     /*  98895 */     // GIR_Coverage, 5021,
     /*  98895 */     GIR_EraseRootFromParent_Done,
     /*  98896 */   // Label 1782: @98896
     /*  98896 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98961), // Rule ID 256 //
     /*  98901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98912 */     // MIs[0] cop
     /*  98912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98915 */     // MIs[0] opc1
     /*  98915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98922 */     // MIs[0] CRn
     /*  98922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98925 */     // MIs[0] CRm
     /*  98925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98928 */     // MIs[0] opc2
     /*  98928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98931 */     // (intrinsic_void 3490:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98934 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98936 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98940 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98942 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98944 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98955 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98959 */     GIR_RootConstrainSelectedInstOperands,
     /*  98960 */     // GIR_Coverage, 256,
     /*  98960 */     GIR_EraseRootFromParent_Done,
     /*  98961 */   // Label 1783: @98961
     /*  98961 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(99017), // Rule ID 257 //
     /*  98966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98977 */     // MIs[0] cop
     /*  98977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98980 */     // MIs[0] opc1
     /*  98980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98987 */     // MIs[0] CRn
     /*  98987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98990 */     // MIs[0] CRm
     /*  98990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98993 */     // MIs[0] opc2
     /*  98993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98996 */     // (intrinsic_void 3491:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  98999 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99001 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99005 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99007 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99009 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99015 */     GIR_RootConstrainSelectedInstOperands,
     /*  99016 */     // GIR_Coverage, 257,
     /*  99016 */     GIR_EraseRootFromParent_Done,
     /*  99017 */   // Label 1784: @99017
     /*  99017 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(99082), // Rule ID 594 //
     /*  99022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  99030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99033 */     // MIs[0] cop
     /*  99033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99036 */     // MIs[0] opc1
     /*  99036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99043 */     // MIs[0] CRn
     /*  99043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99046 */     // MIs[0] CRm
     /*  99046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99049 */     // MIs[0] opc2
     /*  99049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99052 */     // (intrinsic_void 3490:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  99055 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99057 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99061 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99063 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99065 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99080 */     GIR_RootConstrainSelectedInstOperands,
     /*  99081 */     // GIR_Coverage, 594,
     /*  99081 */     GIR_EraseRootFromParent_Done,
     /*  99082 */   // Label 1785: @99082
     /*  99082 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(99147), // Rule ID 595 //
     /*  99087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  99090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99098 */     // MIs[0] cop
     /*  99098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99101 */     // MIs[0] opc1
     /*  99101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99108 */     // MIs[0] CRn
     /*  99108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99111 */     // MIs[0] CRm
     /*  99111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99114 */     // MIs[0] opc2
     /*  99114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99117 */     // (intrinsic_void 3491:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  99120 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99122 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99126 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99128 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99130 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99145 */     GIR_RootConstrainSelectedInstOperands,
     /*  99146 */     // GIR_Coverage, 595,
     /*  99146 */     GIR_EraseRootFromParent_Done,
     /*  99147 */   // Label 1786: @99147
     /*  99147 */   GIM_Reject,
     /*  99148 */ // Label 1736: @99148
     /*  99148 */ GIM_Reject,
     /*  99149 */ // Label 16: @99149
     /*  99149 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1790*/ GIMT_Encode4(99306),
     /*  99160 */ /*GILLT_v2s64*//*Label 1787*/ GIMT_Encode4(99192), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99172 */ /*GILLT_v4s32*//*Label 1788*/ GIMT_Encode4(99230), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99188 */ /*GILLT_v8s16*//*Label 1789*/ GIMT_Encode4(99268),
     /*  99192 */ // Label 1787: @99192
     /*  99192 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(99229), // Rule ID 2665 //
     /*  99197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99211 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99216 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99227 */   GIR_RootConstrainSelectedInstOperands,
     /*  99228 */   // GIR_Coverage, 2665,
     /*  99228 */   GIR_EraseRootFromParent_Done,
     /*  99229 */ // Label 1791: @99229
     /*  99229 */ GIM_Reject,
     /*  99230 */ // Label 1788: @99230
     /*  99230 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(99267), // Rule ID 2664 //
     /*  99235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99249 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99254 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99259 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99265 */   GIR_RootConstrainSelectedInstOperands,
     /*  99266 */   // GIR_Coverage, 2664,
     /*  99266 */   GIR_EraseRootFromParent_Done,
     /*  99267 */ // Label 1792: @99267
     /*  99267 */ GIM_Reject,
     /*  99268 */ // Label 1789: @99268
     /*  99268 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(99305), // Rule ID 2663 //
     /*  99273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99287 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99292 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99297 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99303 */   GIR_RootConstrainSelectedInstOperands,
     /*  99304 */   // GIR_Coverage, 2663,
     /*  99304 */   GIR_EraseRootFromParent_Done,
     /*  99305 */ // Label 1793: @99305
     /*  99305 */ GIM_Reject,
     /*  99306 */ // Label 1790: @99306
     /*  99306 */ GIM_Reject,
     /*  99307 */ // Label 17: @99307
     /*  99307 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1797*/ GIMT_Encode4(99464),
     /*  99318 */ /*GILLT_v2s32*//*Label 1794*/ GIMT_Encode4(99350), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99330 */ /*GILLT_v4s16*//*Label 1795*/ GIMT_Encode4(99388), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99346 */ /*GILLT_v8s8*//*Label 1796*/ GIMT_Encode4(99426),
     /*  99350 */ // Label 1794: @99350
     /*  99350 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(99387), // Rule ID 1585 //
     /*  99355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99369 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99374 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99376 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99379 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99385 */   GIR_RootConstrainSelectedInstOperands,
     /*  99386 */   // GIR_Coverage, 1585,
     /*  99386 */   GIR_EraseRootFromParent_Done,
     /*  99387 */ // Label 1798: @99387
     /*  99387 */ GIM_Reject,
     /*  99388 */ // Label 1795: @99388
     /*  99388 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(99425), // Rule ID 1584 //
     /*  99393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99407 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99412 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99417 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99423 */   GIR_RootConstrainSelectedInstOperands,
     /*  99424 */   // GIR_Coverage, 1584,
     /*  99424 */   GIR_EraseRootFromParent_Done,
     /*  99425 */ // Label 1799: @99425
     /*  99425 */ GIM_Reject,
     /*  99426 */ // Label 1796: @99426
     /*  99426 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(99463), // Rule ID 1583 //
     /*  99431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99445 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99448 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99450 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99455 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99461 */   GIR_RootConstrainSelectedInstOperands,
     /*  99462 */   // GIR_Coverage, 1583,
     /*  99462 */   GIR_EraseRootFromParent_Done,
     /*  99463 */ // Label 1800: @99463
     /*  99463 */ GIM_Reject,
     /*  99464 */ // Label 1797: @99464
     /*  99464 */ GIM_Reject,
     /*  99465 */ // Label 18: @99465
     /*  99465 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(99785),
     /*  99470 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99473 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(99514), // Rule ID 404 //
     /*  99478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99481 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99489 */     // MIs[0] Operand 1
     /*  99489 */     // No operand predicates
     /*  99489 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99512 */     GIR_RootConstrainSelectedInstOperands,
     /*  99513 */     // GIR_Coverage, 404,
     /*  99513 */     GIR_EraseRootFromParent_Done,
     /*  99514 */   // Label 1802: @99514
     /*  99514 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(99555), // Rule ID 57 //
     /*  99519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99522 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99530 */     // MIs[0] Operand 1
     /*  99530 */     // No operand predicates
     /*  99530 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99553 */     GIR_RootConstrainSelectedInstOperands,
     /*  99554 */     // GIR_Coverage, 57,
     /*  99554 */     GIR_EraseRootFromParent_Done,
     /*  99555 */   // Label 1803: @99555
     /*  99555 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(99590), // Rule ID 58 //
     /*  99560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99563 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99571 */     // MIs[0] Operand 1
     /*  99571 */     // No operand predicates
     /*  99571 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99582 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99588 */     GIR_RootConstrainSelectedInstOperands,
     /*  99589 */     // GIR_Coverage, 58,
     /*  99589 */     GIR_EraseRootFromParent_Done,
     /*  99590 */   // Label 1804: @99590
     /*  99590 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(99633), // Rule ID 168 //
     /*  99595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99598 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99606 */     // MIs[0] Operand 1
     /*  99606 */     // No operand predicates
     /*  99606 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99611 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99619 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99631 */     GIR_RootConstrainSelectedInstOperands,
     /*  99632 */     // GIR_Coverage, 168,
     /*  99632 */     GIR_EraseRootFromParent_Done,
     /*  99633 */   // Label 1805: @99633
     /*  99633 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(99659), // Rule ID 268 //
     /*  99638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99641 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99649 */     // MIs[0] Operand 1
     /*  99649 */     // No operand predicates
     /*  99649 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99657 */     GIR_RootConstrainSelectedInstOperands,
     /*  99658 */     // GIR_Coverage, 268,
     /*  99658 */     GIR_EraseRootFromParent_Done,
     /*  99659 */   // Label 1806: @99659
     /*  99659 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(99700), // Rule ID 322 //
     /*  99664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99667 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99675 */     // MIs[0] Operand 1
     /*  99675 */     // No operand predicates
     /*  99675 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99698 */     GIR_RootConstrainSelectedInstOperands,
     /*  99699 */     // GIR_Coverage, 322,
     /*  99699 */     GIR_EraseRootFromParent_Done,
     /*  99700 */   // Label 1807: @99700
     /*  99700 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99735), // Rule ID 405 //
     /*  99705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99708 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99716 */     // MIs[0] Operand 1
     /*  99716 */     // No operand predicates
     /*  99716 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99727 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99733 */     GIR_RootConstrainSelectedInstOperands,
     /*  99734 */     // GIR_Coverage, 405,
     /*  99734 */     GIR_EraseRootFromParent_Done,
     /*  99735 */   // Label 1808: @99735
     /*  99735 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99784),
     /*  99740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99744 */     GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99765), // Rule ID 353 //
     /*  99749 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99752 */       // MIs[0] Operand 1
     /*  99752 */       // No operand predicates
     /*  99752 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99752 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99755 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99757 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99760 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99763 */       GIR_RootConstrainSelectedInstOperands,
     /*  99764 */       // GIR_Coverage, 353,
     /*  99764 */       GIR_EraseRootFromParent_Done,
     /*  99765 */     // Label 1810: @99765
     /*  99765 */     GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99783), // Rule ID 582 //
     /*  99770 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99773 */       // MIs[0] Operand 1
     /*  99773 */       // No operand predicates
     /*  99773 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99773 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99776 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99778 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99781 */       GIR_RootConstrainSelectedInstOperands,
     /*  99782 */       // GIR_Coverage, 582,
     /*  99782 */       GIR_EraseRootFromParent_Done,
     /*  99783 */     // Label 1811: @99783
     /*  99783 */     GIM_Reject,
     /*  99784 */   // Label 1809: @99784
     /*  99784 */   GIM_Reject,
     /*  99785 */ // Label 1801: @99785
     /*  99785 */ GIM_Reject,
     /*  99786 */ // Label 19: @99786
     /*  99786 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1814*/ GIMT_Encode4(99881),
     /*  99797 */ /*GILLT_s32*//*Label 1812*/ GIMT_Encode4(99805),
     /*  99801 */ /*GILLT_s64*//*Label 1813*/ GIMT_Encode4(99843),
     /*  99805 */ // Label 1812: @99805
     /*  99805 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99842), // Rule ID 725 //
     /*  99810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99817 */   // MIs[0] Operand 1
     /*  99817 */   // No operand predicates
     /*  99817 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99821 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99826 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99834 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99840 */   GIR_RootConstrainSelectedInstOperands,
     /*  99841 */   // GIR_Coverage, 725,
     /*  99841 */   GIR_EraseRootFromParent_Done,
     /*  99842 */ // Label 1815: @99842
     /*  99842 */ GIM_Reject,
     /*  99843 */ // Label 1813: @99843
     /*  99843 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99880), // Rule ID 724 //
     /*  99848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99855 */   // MIs[0] Operand 1
     /*  99855 */   // No operand predicates
     /*  99855 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99859 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99864 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99872 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99878 */   GIR_RootConstrainSelectedInstOperands,
     /*  99879 */   // GIR_Coverage, 724,
     /*  99879 */   GIR_EraseRootFromParent_Done,
     /*  99880 */ // Label 1816: @99880
     /*  99880 */ GIM_Reject,
     /*  99881 */ // Label 1814: @99881
     /*  99881 */ GIM_Reject,
     /*  99882 */ // Label 20: @99882
     /*  99882 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1820*/ GIMT_Encode4(100039),
     /*  99893 */ /*GILLT_v2s64*//*Label 1817*/ GIMT_Encode4(99925), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99905 */ /*GILLT_v4s32*//*Label 1818*/ GIMT_Encode4(99963), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99921 */ /*GILLT_v8s16*//*Label 1819*/ GIMT_Encode4(100001),
     /*  99925 */ // Label 1817: @99925
     /*  99925 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99962), // Rule ID 1597 //
     /*  99930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99944 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99949 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99954 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99960 */   GIR_RootConstrainSelectedInstOperands,
     /*  99961 */   // GIR_Coverage, 1597,
     /*  99961 */   GIR_EraseRootFromParent_Done,
     /*  99962 */ // Label 1821: @99962
     /*  99962 */ GIM_Reject,
     /*  99963 */ // Label 1818: @99963
     /*  99963 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(100000), // Rule ID 1596 //
     /*  99968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99982 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99987 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99998 */   GIR_RootConstrainSelectedInstOperands,
     /*  99999 */   // GIR_Coverage, 1596,
     /*  99999 */   GIR_EraseRootFromParent_Done,
     /* 100000 */ // Label 1822: @100000
     /* 100000 */ GIM_Reject,
     /* 100001 */ // Label 1819: @100001
     /* 100001 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(100038), // Rule ID 1595 //
     /* 100006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100020 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /* 100023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100025 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100036 */   GIR_RootConstrainSelectedInstOperands,
     /* 100037 */   // GIR_Coverage, 1595,
     /* 100037 */   GIR_EraseRootFromParent_Done,
     /* 100038 */ // Label 1823: @100038
     /* 100038 */ GIM_Reject,
     /* 100039 */ // Label 1820: @100039
     /* 100039 */ GIM_Reject,
     /* 100040 */ // Label 21: @100040
     /* 100040 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1827*/ GIMT_Encode4(100644),
     /* 100051 */ /*GILLT_s32*//*Label 1824*/ GIMT_Encode4(100099), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100079 */ /*GILLT_v4s32*//*Label 1825*/ GIMT_Encode4(100391), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100095 */ /*GILLT_v8s16*//*Label 1826*/ GIMT_Encode4(100574),
     /* 100099 */ // Label 1824: @100099
     /* 100099 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(100390),
     /* 100104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100107 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(100152), // Rule ID 340 //
     /* 100112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100123 */     // MIs[0] Operand 2
     /* 100123 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100134 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /* 100137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100150 */     GIR_RootConstrainSelectedInstOperands,
     /* 100151 */     // GIR_Coverage, 340,
     /* 100151 */     GIR_EraseRootFromParent_Done,
     /* 100152 */   // Label 1829: @100152
     /* 100152 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(100197), // Rule ID 341 //
     /* 100157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100168 */     // MIs[0] Operand 2
     /* 100168 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100179 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /* 100182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100195 */     GIR_RootConstrainSelectedInstOperands,
     /* 100196 */     // GIR_Coverage, 341,
     /* 100196 */     GIR_EraseRootFromParent_Done,
     /* 100197 */   // Label 1830: @100197
     /* 100197 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(100245), // Rule ID 1999 //
     /* 100202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100213 */     // MIs[0] Operand 2
     /* 100213 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100224 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100243 */     GIR_RootConstrainSelectedInstOperands,
     /* 100244 */     // GIR_Coverage, 1999,
     /* 100244 */     GIR_EraseRootFromParent_Done,
     /* 100245 */   // Label 1831: @100245
     /* 100245 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(100293), // Rule ID 2000 //
     /* 100250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100261 */     // MIs[0] Operand 2
     /* 100261 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100272 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100277 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100291 */     GIR_RootConstrainSelectedInstOperands,
     /* 100292 */     // GIR_Coverage, 2000,
     /* 100292 */     GIR_EraseRootFromParent_Done,
     /* 100293 */   // Label 1832: @100293
     /* 100293 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(100341), // Rule ID 2238 //
     /* 100298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100309 */     // MIs[0] Operand 2
     /* 100309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100320 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100339 */     GIR_RootConstrainSelectedInstOperands,
     /* 100340 */     // GIR_Coverage, 2238,
     /* 100340 */     GIR_EraseRootFromParent_Done,
     /* 100341 */   // Label 1833: @100341
     /* 100341 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(100389), // Rule ID 2239 //
     /* 100346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100357 */     // MIs[0] Operand 2
     /* 100357 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100368 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100387 */     GIR_RootConstrainSelectedInstOperands,
     /* 100388 */     // GIR_Coverage, 2239,
     /* 100388 */     GIR_EraseRootFromParent_Done,
     /* 100389 */   // Label 1834: @100389
     /* 100389 */   GIM_Reject,
     /* 100390 */ // Label 1828: @100390
     /* 100390 */ GIM_Reject,
     /* 100391 */ // Label 1825: @100391
     /* 100391 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(100573),
     /* 100396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100407 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(100465), // Rule ID 3710 //
     /* 100412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100415 */     // MIs[0] Operand 2
     /* 100415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100426 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100443 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100463 */     GIR_RootConstrainSelectedInstOperands,
     /* 100464 */     // GIR_Coverage, 3710,
     /* 100464 */     GIR_EraseRootFromParent_Done,
     /* 100465 */   // Label 1836: @100465
     /* 100465 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(100572), // Rule ID 3712 //
     /* 100470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100473 */     // MIs[0] Operand 2
     /* 100473 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100484 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100520 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100524 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100527 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100533 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100539 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100570 */     GIR_RootConstrainSelectedInstOperands,
     /* 100571 */     // GIR_Coverage, 3712,
     /* 100571 */     GIR_EraseRootFromParent_Done,
     /* 100572 */   // Label 1837: @100572
     /* 100572 */   GIM_Reject,
     /* 100573 */ // Label 1835: @100573
     /* 100573 */ GIM_Reject,
     /* 100574 */ // Label 1826: @100574
     /* 100574 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100643), // Rule ID 3711 //
     /* 100579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100593 */   // MIs[0] Operand 2
     /* 100593 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100604 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100604 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100607 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100611 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100626 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100632 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100641 */   GIR_RootConstrainSelectedInstOperands,
     /* 100642 */   // GIR_Coverage, 3711,
     /* 100642 */   GIR_EraseRootFromParent_Done,
     /* 100643 */ // Label 1838: @100643
     /* 100643 */ GIM_Reject,
     /* 100644 */ // Label 1827: @100644
     /* 100644 */ GIM_Reject,
     /* 100645 */ // Label 22: @100645
     /* 100645 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1842*/ GIMT_Encode4(100802),
     /* 100656 */ /*GILLT_v2s64*//*Label 1839*/ GIMT_Encode4(100688), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100668 */ /*GILLT_v4s32*//*Label 1840*/ GIMT_Encode4(100726), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100684 */ /*GILLT_v8s16*//*Label 1841*/ GIMT_Encode4(100764),
     /* 100688 */ // Label 1839: @100688
     /* 100688 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100725), // Rule ID 1600 //
     /* 100693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100707 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100712 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100717 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100723 */   GIR_RootConstrainSelectedInstOperands,
     /* 100724 */   // GIR_Coverage, 1600,
     /* 100724 */   GIR_EraseRootFromParent_Done,
     /* 100725 */ // Label 1843: @100725
     /* 100725 */ GIM_Reject,
     /* 100726 */ // Label 1840: @100726
     /* 100726 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100763), // Rule ID 1599 //
     /* 100731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100745 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100750 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100755 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100761 */   GIR_RootConstrainSelectedInstOperands,
     /* 100762 */   // GIR_Coverage, 1599,
     /* 100762 */   GIR_EraseRootFromParent_Done,
     /* 100763 */ // Label 1844: @100763
     /* 100763 */ GIM_Reject,
     /* 100764 */ // Label 1841: @100764
     /* 100764 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100801), // Rule ID 1598 //
     /* 100769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100783 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100788 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100793 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100799 */   GIR_RootConstrainSelectedInstOperands,
     /* 100800 */   // GIR_Coverage, 1598,
     /* 100800 */   GIR_EraseRootFromParent_Done,
     /* 100801 */ // Label 1845: @100801
     /* 100801 */ GIM_Reject,
     /* 100802 */ // Label 1842: @100802
     /* 100802 */ GIM_Reject,
     /* 100803 */ // Label 23: @100803
     /* 100803 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(101018),
     /* 100808 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100817 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(100874), // Rule ID 470 //
     /* 100822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100845 */     // MIs[1] Operand 1
     /* 100845 */     // No operand predicates
     /* 100845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100847 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100872 */     GIR_RootConstrainSelectedInstOperands,
     /* 100873 */     // GIR_Coverage, 470,
     /* 100873 */     GIR_EraseRootFromParent_Done,
     /* 100874 */   // Label 1847: @100874
     /* 100874 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(100971),
     /* 100879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100887 */     GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(100932), // Rule ID 318 //
     /* 100892 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100895 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100899 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100903 */       // MIs[1] Operand 1
     /* 100903 */       // No operand predicates
     /* 100903 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100905 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100905 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100908 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100910 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100916 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100918 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100921 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100924 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100930 */       GIR_RootConstrainSelectedInstOperands,
     /* 100931 */       // GIR_Coverage, 318,
     /* 100931 */       GIR_EraseRootFromParent_Done,
     /* 100932 */     // Label 1849: @100932
     /* 100932 */     GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(100970), // Rule ID 319 //
     /* 100937 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100940 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100944 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100944 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100947 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100949 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100955 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100957 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100959 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100962 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100968 */       GIR_RootConstrainSelectedInstOperands,
     /* 100969 */       // GIR_Coverage, 319,
     /* 100969 */       GIR_EraseRootFromParent_Done,
     /* 100970 */     // Label 1850: @100970
     /* 100970 */     GIM_Reject,
     /* 100971 */   // Label 1848: @100971
     /* 100971 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(101017), // Rule ID 471 //
     /* 100976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100991 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 100994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101003 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101015 */     GIR_RootConstrainSelectedInstOperands,
     /* 101016 */     // GIR_Coverage, 471,
     /* 101016 */     GIR_EraseRootFromParent_Done,
     /* 101017 */   // Label 1851: @101017
     /* 101017 */   GIM_Reject,
     /* 101018 */ // Label 1846: @101018
     /* 101018 */ GIM_Reject,
     /* 101019 */ // Label 24: @101019
     /* 101019 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(101126),
     /* 101024 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101033 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(101079), // Rule ID 321 //
     /* 101038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101053 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 101056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101077 */     GIR_RootConstrainSelectedInstOperands,
     /* 101078 */     // GIR_Coverage, 321,
     /* 101078 */     GIR_EraseRootFromParent_Done,
     /* 101079 */   // Label 1853: @101079
     /* 101079 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(101125), // Rule ID 473 //
     /* 101084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101099 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 101102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101111 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101123 */     GIR_RootConstrainSelectedInstOperands,
     /* 101124 */     // GIR_Coverage, 473,
     /* 101124 */     GIR_EraseRootFromParent_Done,
     /* 101125 */   // Label 1854: @101125
     /* 101125 */   GIM_Reject,
     /* 101126 */ // Label 1852: @101126
     /* 101126 */ GIM_Reject,
     /* 101127 */ // Label 25: @101127
     /* 101127 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(101399),
     /* 101132 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101141 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(101196), // Rule ID 201 //
     /* 101146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101176 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 101179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101194 */     GIR_RootConstrainSelectedInstOperands,
     /* 101195 */     // GIR_Coverage, 201,
     /* 101195 */     GIR_EraseRootFromParent_Done,
     /* 101196 */   // Label 1856: @101196
     /* 101196 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(101251), // Rule ID 328 //
     /* 101201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101231 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101243 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101249 */     GIR_RootConstrainSelectedInstOperands,
     /* 101250 */     // GIR_Coverage, 328,
     /* 101250 */     GIR_EraseRootFromParent_Done,
     /* 101251 */   // Label 1857: @101251
     /* 101251 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(101306), // Rule ID 538 //
     /* 101256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101286 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101304 */     GIR_RootConstrainSelectedInstOperands,
     /* 101305 */     // GIR_Coverage, 538,
     /* 101305 */     GIR_EraseRootFromParent_Done,
     /* 101306 */   // Label 1858: @101306
     /* 101306 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(101352), // Rule ID 312 //
     /* 101311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101326 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101350 */     GIR_RootConstrainSelectedInstOperands,
     /* 101351 */     // GIR_Coverage, 312,
     /* 101351 */     GIR_EraseRootFromParent_Done,
     /* 101352 */   // Label 1859: @101352
     /* 101352 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(101398), // Rule ID 475 //
     /* 101357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101372 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101396 */     GIR_RootConstrainSelectedInstOperands,
     /* 101397 */     // GIR_Coverage, 475,
     /* 101397 */     GIR_EraseRootFromParent_Done,
     /* 101398 */   // Label 1860: @101398
     /* 101398 */   GIM_Reject,
     /* 101399 */ // Label 1855: @101399
     /* 101399 */ GIM_Reject,
     /* 101400 */ // Label 26: @101400
     /* 101400 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(101731),
     /* 101405 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101414 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(101469), // Rule ID 200 //
     /* 101419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101449 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101467 */     GIR_RootConstrainSelectedInstOperands,
     /* 101468 */     // GIR_Coverage, 200,
     /* 101468 */     GIR_EraseRootFromParent_Done,
     /* 101469 */   // Label 1862: @101469
     /* 101469 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(101524), // Rule ID 327 //
     /* 101474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101498 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101504 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101522 */     GIR_RootConstrainSelectedInstOperands,
     /* 101523 */     // GIR_Coverage, 327,
     /* 101523 */     GIR_EraseRootFromParent_Done,
     /* 101524 */   // Label 1863: @101524
     /* 101524 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(101638),
     /* 101529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101533 */     GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101584), // Rule ID 537 //
     /* 101538 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101541 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101545 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101549 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101553 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101558 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101562 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101564 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101564 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101567 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101569 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101573 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101576 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101582 */       GIR_RootConstrainSelectedInstOperands,
     /* 101583 */       // GIR_Coverage, 537,
     /* 101583 */       GIR_EraseRootFromParent_Done,
     /* 101584 */     // Label 1865: @101584
     /* 101584 */     GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(101637), // Rule ID 476 //
     /* 101589 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101592 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101596 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101600 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101604 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101608 */       // MIs[1] Operand 1
     /* 101608 */       // No operand predicates
     /* 101608 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101610 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101610 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101613 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101615 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101617 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101620 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101623 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101629 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101635 */       GIR_RootConstrainSelectedInstOperands,
     /* 101636 */       // GIR_Coverage, 476,
     /* 101636 */       GIR_EraseRootFromParent_Done,
     /* 101637 */     // Label 1866: @101637
     /* 101637 */     GIM_Reject,
     /* 101638 */   // Label 1864: @101638
     /* 101638 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101684), // Rule ID 329 //
     /* 101643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101658 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101682 */     GIR_RootConstrainSelectedInstOperands,
     /* 101683 */     // GIR_Coverage, 329,
     /* 101683 */     GIR_EraseRootFromParent_Done,
     /* 101684 */   // Label 1867: @101684
     /* 101684 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101730), // Rule ID 477 //
     /* 101689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101704 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101728 */     GIR_RootConstrainSelectedInstOperands,
     /* 101729 */     // GIR_Coverage, 477,
     /* 101729 */     GIR_EraseRootFromParent_Done,
     /* 101730 */   // Label 1868: @101730
     /* 101730 */   GIM_Reject,
     /* 101731 */ // Label 1861: @101731
     /* 101731 */ GIM_Reject,
     /* 101732 */ // Label 27: @101732
     /* 101732 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1872*/ GIMT_Encode4(101979),
     /* 101743 */ /*GILLT_v4s32*//*Label 1869*/ GIMT_Encode4(101775), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101759 */ /*GILLT_v8s16*//*Label 1870*/ GIMT_Encode4(101843), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101771 */ /*GILLT_v16s8*//*Label 1871*/ GIMT_Encode4(101911),
     /* 101775 */ // Label 1869: @101775
     /* 101775 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101842), // Rule ID 4461 //
     /* 101780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101786 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101801 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101801 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101804 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101808 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101818 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101820 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101831 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101840 */   GIR_RootConstrainSelectedInstOperands,
     /* 101841 */   // GIR_Coverage, 4461,
     /* 101841 */   GIR_EraseRootFromParent_Done,
     /* 101842 */ // Label 1873: @101842
     /* 101842 */ GIM_Reject,
     /* 101843 */ // Label 1870: @101843
     /* 101843 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101910), // Rule ID 4457 //
     /* 101848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101869 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101886 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101888 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101893 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101899 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101908 */   GIR_RootConstrainSelectedInstOperands,
     /* 101909 */   // GIR_Coverage, 4457,
     /* 101909 */   GIR_EraseRootFromParent_Done,
     /* 101910 */ // Label 1874: @101910
     /* 101910 */ GIM_Reject,
     /* 101911 */ // Label 1871: @101911
     /* 101911 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101978), // Rule ID 4453 //
     /* 101916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101937 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101954 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101956 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101961 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101967 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101976 */   GIR_RootConstrainSelectedInstOperands,
     /* 101977 */   // GIR_Coverage, 4453,
     /* 101977 */   GIR_EraseRootFromParent_Done,
     /* 101978 */ // Label 1875: @101978
     /* 101978 */ GIM_Reject,
     /* 101979 */ // Label 1872: @101979
     /* 101979 */ GIM_Reject,
     /* 101980 */ // Label 28: @101980
     /* 101980 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1880*/ GIMT_Encode4(102348),
     /* 101991 */ /*GILLT_s32*//*Label 1876*/ GIMT_Encode4(102051), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102019 */ /*GILLT_v4s32*//*Label 1877*/ GIMT_Encode4(102144), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102035 */ /*GILLT_v8s16*//*Label 1878*/ GIMT_Encode4(102212), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102047 */ /*GILLT_v16s8*//*Label 1879*/ GIMT_Encode4(102280),
     /* 102051 */ // Label 1876: @102051
     /* 102051 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(102143),
     /* 102056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102062 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(102102), // Rule ID 178 //
     /* 102067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 102070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102082 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 102082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 102085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102100 */     GIR_RootConstrainSelectedInstOperands,
     /* 102101 */     // GIR_Coverage, 178,
     /* 102101 */     GIR_EraseRootFromParent_Done,
     /* 102102 */   // Label 1882: @102102
     /* 102102 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(102142), // Rule ID 507 //
     /* 102107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102122 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 102122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 102125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102140 */     GIR_RootConstrainSelectedInstOperands,
     /* 102141 */     // GIR_Coverage, 507,
     /* 102141 */     GIR_EraseRootFromParent_Done,
     /* 102142 */   // Label 1883: @102142
     /* 102142 */   GIM_Reject,
     /* 102143 */ // Label 1881: @102143
     /* 102143 */ GIM_Reject,
     /* 102144 */ // Label 1877: @102144
     /* 102144 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(102211), // Rule ID 4449 //
     /* 102149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102170 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 102185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102187 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102189 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102194 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102209 */   GIR_RootConstrainSelectedInstOperands,
     /* 102210 */   // GIR_Coverage, 4449,
     /* 102210 */   GIR_EraseRootFromParent_Done,
     /* 102211 */ // Label 1884: @102211
     /* 102211 */ GIM_Reject,
     /* 102212 */ // Label 1878: @102212
     /* 102212 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(102279), // Rule ID 4445 //
     /* 102217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102238 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102255 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102257 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102262 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102268 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102274 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102277 */   GIR_RootConstrainSelectedInstOperands,
     /* 102278 */   // GIR_Coverage, 4445,
     /* 102278 */   GIR_EraseRootFromParent_Done,
     /* 102279 */ // Label 1885: @102279
     /* 102279 */ GIM_Reject,
     /* 102280 */ // Label 1879: @102280
     /* 102280 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(102347), // Rule ID 4442 //
     /* 102285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102306 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102323 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102325 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102330 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102336 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102342 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102345 */   GIR_RootConstrainSelectedInstOperands,
     /* 102346 */   // GIR_Coverage, 4442,
     /* 102346 */   GIR_EraseRootFromParent_Done,
     /* 102347 */ // Label 1886: @102347
     /* 102347 */ GIM_Reject,
     /* 102348 */ // Label 1880: @102348
     /* 102348 */ GIM_Reject,
     /* 102349 */ // Label 29: @102349
     /* 102349 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1895*/ GIMT_Encode4(102993),
     /* 102360 */ /*GILLT_s64*//*Label 1887*/ GIMT_Encode4(102416), GIMT_Encode4(0),
     /* 102368 */ /*GILLT_v2s32*//*Label 1888*/ GIMT_Encode4(102463),
     /* 102372 */ /*GILLT_v2s64*//*Label 1889*/ GIMT_Encode4(102510), GIMT_Encode4(0),
     /* 102380 */ /*GILLT_v4s16*//*Label 1890*/ GIMT_Encode4(102557),
     /* 102384 */ /*GILLT_v4s32*//*Label 1891*/ GIMT_Encode4(102604), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102396 */ /*GILLT_v8s8*//*Label 1892*/ GIMT_Encode4(102718),
     /* 102400 */ /*GILLT_v8s16*//*Label 1893*/ GIMT_Encode4(102765), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102412 */ /*GILLT_v16s8*//*Label 1894*/ GIMT_Encode4(102879),
     /* 102416 */ // Label 1887: @102416
     /* 102416 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102462), // Rule ID 827 //
     /* 102421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102442 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102447 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102449 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102454 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102460 */   GIR_RootConstrainSelectedInstOperands,
     /* 102461 */   // GIR_Coverage, 827,
     /* 102461 */   GIR_EraseRootFromParent_Done,
     /* 102462 */ // Label 1896: @102462
     /* 102462 */ GIM_Reject,
     /* 102463 */ // Label 1888: @102463
     /* 102463 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(102509), // Rule ID 822 //
     /* 102468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102489 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102494 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102496 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102501 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102507 */   GIR_RootConstrainSelectedInstOperands,
     /* 102508 */   // GIR_Coverage, 822,
     /* 102508 */   GIR_EraseRootFromParent_Done,
     /* 102509 */ // Label 1897: @102509
     /* 102509 */ GIM_Reject,
     /* 102510 */ // Label 1889: @102510
     /* 102510 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(102556), // Rule ID 828 //
     /* 102515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102536 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102541 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102543 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102554 */   GIR_RootConstrainSelectedInstOperands,
     /* 102555 */   // GIR_Coverage, 828,
     /* 102555 */   GIR_EraseRootFromParent_Done,
     /* 102556 */ // Label 1898: @102556
     /* 102556 */ GIM_Reject,
     /* 102557 */ // Label 1890: @102557
     /* 102557 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(102603), // Rule ID 821 //
     /* 102562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102583 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102588 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102590 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102595 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102601 */   GIR_RootConstrainSelectedInstOperands,
     /* 102602 */   // GIR_Coverage, 821,
     /* 102602 */   GIR_EraseRootFromParent_Done,
     /* 102603 */ // Label 1899: @102603
     /* 102603 */ GIM_Reject,
     /* 102604 */ // Label 1891: @102604
     /* 102604 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(102717),
     /* 102609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102615 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(102655), // Rule ID 824 //
     /* 102620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102635 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102653 */     GIR_RootConstrainSelectedInstOperands,
     /* 102654 */     // GIR_Coverage, 824,
     /* 102654 */     GIR_EraseRootFromParent_Done,
     /* 102655 */   // Label 1901: @102655
     /* 102655 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102716), // Rule ID 3524 //
     /* 102660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102675 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102705 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102714 */     GIR_RootConstrainSelectedInstOperands,
     /* 102715 */     // GIR_Coverage, 3524,
     /* 102715 */     GIR_EraseRootFromParent_Done,
     /* 102716 */   // Label 1902: @102716
     /* 102716 */   GIM_Reject,
     /* 102717 */ // Label 1900: @102717
     /* 102717 */ GIM_Reject,
     /* 102718 */ // Label 1892: @102718
     /* 102718 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102764), // Rule ID 825 //
     /* 102723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102744 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102749 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102751 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102756 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102762 */   GIR_RootConstrainSelectedInstOperands,
     /* 102763 */   // GIR_Coverage, 825,
     /* 102763 */   GIR_EraseRootFromParent_Done,
     /* 102764 */ // Label 1903: @102764
     /* 102764 */ GIM_Reject,
     /* 102765 */ // Label 1893: @102765
     /* 102765 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102878),
     /* 102770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102776 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102816), // Rule ID 823 //
     /* 102781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102796 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102801 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102814 */     GIR_RootConstrainSelectedInstOperands,
     /* 102815 */     // GIR_Coverage, 823,
     /* 102815 */     GIR_EraseRootFromParent_Done,
     /* 102816 */   // Label 1905: @102816
     /* 102816 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102877), // Rule ID 3521 //
     /* 102821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102836 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102875 */     GIR_RootConstrainSelectedInstOperands,
     /* 102876 */     // GIR_Coverage, 3521,
     /* 102876 */     GIR_EraseRootFromParent_Done,
     /* 102877 */   // Label 1906: @102877
     /* 102877 */   GIM_Reject,
     /* 102878 */ // Label 1904: @102878
     /* 102878 */ GIM_Reject,
     /* 102879 */ // Label 1894: @102879
     /* 102879 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102992),
     /* 102884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102887 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102890 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102930), // Rule ID 826 //
     /* 102895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102910 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102928 */     GIR_RootConstrainSelectedInstOperands,
     /* 102929 */     // GIR_Coverage, 826,
     /* 102929 */     GIR_EraseRootFromParent_Done,
     /* 102930 */   // Label 1908: @102930
     /* 102930 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102991), // Rule ID 3518 //
     /* 102935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102950 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102980 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102989 */     GIR_RootConstrainSelectedInstOperands,
     /* 102990 */     // GIR_Coverage, 3518,
     /* 102990 */     GIR_EraseRootFromParent_Done,
     /* 102991 */   // Label 1909: @102991
     /* 102991 */   GIM_Reject,
     /* 102992 */ // Label 1907: @102992
     /* 102992 */ GIM_Reject,
     /* 102993 */ // Label 1895: @102993
     /* 102993 */ GIM_Reject,
     /* 102994 */ // Label 30: @102994
     /* 102994 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1919*/ GIMT_Encode4(104293),
     /* 103005 */ /*GILLT_s32*//*Label 1910*/ GIMT_Encode4(103065),
     /* 103009 */ /*GILLT_s64*//*Label 1911*/ GIMT_Encode4(103406), GIMT_Encode4(0),
     /* 103017 */ /*GILLT_v2s32*//*Label 1912*/ GIMT_Encode4(103453),
     /* 103021 */ /*GILLT_v2s64*//*Label 1913*/ GIMT_Encode4(103500), GIMT_Encode4(0),
     /* 103029 */ /*GILLT_v4s16*//*Label 1914*/ GIMT_Encode4(103701),
     /* 103033 */ /*GILLT_v4s32*//*Label 1915*/ GIMT_Encode4(103748), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103045 */ /*GILLT_v8s8*//*Label 1916*/ GIMT_Encode4(104018),
     /* 103049 */ /*GILLT_v8s16*//*Label 1917*/ GIMT_Encode4(104065), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103061 */ /*GILLT_v16s8*//*Label 1918*/ GIMT_Encode4(104179),
     /* 103065 */ // Label 1910: @103065
     /* 103065 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103405),
     /* 103070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 103073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 103076 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103138), // Rule ID 5651 //
     /* 103081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103105 */     // MIs[1] Rn
     /* 103105 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103116 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103136 */     GIR_RootConstrainSelectedInstOperands,
     /* 103137 */     // GIR_Coverage, 5651,
     /* 103137 */     GIR_EraseRootFromParent_Done,
     /* 103138 */   // Label 1921: @103138
     /* 103138 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103200), // Rule ID 5685 //
     /* 103143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103167 */     // MIs[1] Rn
     /* 103167 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103178 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103198 */     GIR_RootConstrainSelectedInstOperands,
     /* 103199 */     // GIR_Coverage, 5685,
     /* 103199 */     GIR_EraseRootFromParent_Done,
     /* 103200 */   // Label 1922: @103200
     /* 103200 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103262), // Rule ID 1867 //
     /* 103205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103233 */     // MIs[1] Rn
     /* 103233 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103240 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103260 */     GIR_RootConstrainSelectedInstOperands,
     /* 103261 */     // GIR_Coverage, 1867,
     /* 103261 */     GIR_EraseRootFromParent_Done,
     /* 103262 */   // Label 1923: @103262
     /* 103262 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(103324), // Rule ID 2133 //
     /* 103267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103295 */     // MIs[1] Rn
     /* 103295 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103302 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103316 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103322 */     GIR_RootConstrainSelectedInstOperands,
     /* 103323 */     // GIR_Coverage, 2133,
     /* 103323 */     GIR_EraseRootFromParent_Done,
     /* 103324 */   // Label 1924: @103324
     /* 103324 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(103364), // Rule ID 1865 //
     /* 103329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103344 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103349 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103351 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103362 */     GIR_RootConstrainSelectedInstOperands,
     /* 103363 */     // GIR_Coverage, 1865,
     /* 103363 */     GIR_EraseRootFromParent_Done,
     /* 103364 */   // Label 1925: @103364
     /* 103364 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103404), // Rule ID 2131 //
     /* 103369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103384 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103396 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103402 */     GIR_RootConstrainSelectedInstOperands,
     /* 103403 */     // GIR_Coverage, 2131,
     /* 103403 */     GIR_EraseRootFromParent_Done,
     /* 103404 */   // Label 1926: @103404
     /* 103404 */   GIM_Reject,
     /* 103405 */ // Label 1920: @103405
     /* 103405 */ GIM_Reject,
     /* 103406 */ // Label 1911: @103406
     /* 103406 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(103452), // Rule ID 819 //
     /* 103411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103432 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103437 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103439 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103444 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103450 */   GIR_RootConstrainSelectedInstOperands,
     /* 103451 */   // GIR_Coverage, 819,
     /* 103451 */   GIR_EraseRootFromParent_Done,
     /* 103452 */ // Label 1927: @103452
     /* 103452 */ GIM_Reject,
     /* 103453 */ // Label 1912: @103453
     /* 103453 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103499), // Rule ID 814 //
     /* 103458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103479 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103484 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103486 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103491 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103497 */   GIR_RootConstrainSelectedInstOperands,
     /* 103498 */   // GIR_Coverage, 814,
     /* 103498 */   GIR_EraseRootFromParent_Done,
     /* 103499 */ // Label 1928: @103499
     /* 103499 */ GIM_Reject,
     /* 103500 */ // Label 1913: @103500
     /* 103500 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103700),
     /* 103505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103515 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103589), // Rule ID 5742 //
     /* 103520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103531 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103534 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103543 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103563 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103568 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103587 */     GIR_RootConstrainSelectedInstOperands,
     /* 103588 */     // GIR_Coverage, 5742,
     /* 103588 */     GIR_EraseRootFromParent_Done,
     /* 103589 */   // Label 1930: @103589
     /* 103589 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103663), // Rule ID 2486 //
     /* 103594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103609 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103612 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103621 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103637 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103642 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103661 */     GIR_RootConstrainSelectedInstOperands,
     /* 103662 */     // GIR_Coverage, 2486,
     /* 103662 */     GIR_EraseRootFromParent_Done,
     /* 103663 */   // Label 1931: @103663
     /* 103663 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103699), // Rule ID 820 //
     /* 103668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103679 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103697 */     GIR_RootConstrainSelectedInstOperands,
     /* 103698 */     // GIR_Coverage, 820,
     /* 103698 */     GIR_EraseRootFromParent_Done,
     /* 103699 */   // Label 1932: @103699
     /* 103699 */   GIM_Reject,
     /* 103700 */ // Label 1929: @103700
     /* 103700 */ GIM_Reject,
     /* 103701 */ // Label 1914: @103701
     /* 103701 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103747), // Rule ID 813 //
     /* 103706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103727 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103732 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103734 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103739 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103745 */   GIR_RootConstrainSelectedInstOperands,
     /* 103746 */   // GIR_Coverage, 813,
     /* 103746 */   GIR_EraseRootFromParent_Done,
     /* 103747 */ // Label 1933: @103747
     /* 103747 */ GIM_Reject,
     /* 103748 */ // Label 1915: @103748
     /* 103748 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104017),
     /* 103753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103759 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103837), // Rule ID 5741 //
     /* 103764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103779 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103782 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103791 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103811 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103816 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103835 */     GIR_RootConstrainSelectedInstOperands,
     /* 103836 */     // GIR_Coverage, 5741,
     /* 103836 */     GIR_EraseRootFromParent_Done,
     /* 103837 */   // Label 1935: @103837
     /* 103837 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103915), // Rule ID 2485 //
     /* 103842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103861 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103864 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103873 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103889 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103894 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103913 */     GIR_RootConstrainSelectedInstOperands,
     /* 103914 */     // GIR_Coverage, 2485,
     /* 103914 */     GIR_EraseRootFromParent_Done,
     /* 103915 */   // Label 1936: @103915
     /* 103915 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103955), // Rule ID 816 //
     /* 103920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103935 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103953 */     GIR_RootConstrainSelectedInstOperands,
     /* 103954 */     // GIR_Coverage, 816,
     /* 103954 */     GIR_EraseRootFromParent_Done,
     /* 103955 */   // Label 1937: @103955
     /* 103955 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104016), // Rule ID 3515 //
     /* 103960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103975 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 103992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 103994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 103996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104014 */     GIR_RootConstrainSelectedInstOperands,
     /* 104015 */     // GIR_Coverage, 3515,
     /* 104015 */     GIR_EraseRootFromParent_Done,
     /* 104016 */   // Label 1938: @104016
     /* 104016 */   GIM_Reject,
     /* 104017 */ // Label 1934: @104017
     /* 104017 */ GIM_Reject,
     /* 104018 */ // Label 1916: @104018
     /* 104018 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(104064), // Rule ID 817 //
     /* 104023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104044 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 104047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104049 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104051 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104056 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104062 */   GIR_RootConstrainSelectedInstOperands,
     /* 104063 */   // GIR_Coverage, 817,
     /* 104063 */   GIR_EraseRootFromParent_Done,
     /* 104064 */ // Label 1939: @104064
     /* 104064 */ GIM_Reject,
     /* 104065 */ // Label 1917: @104065
     /* 104065 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(104178),
     /* 104070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104076 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(104116), // Rule ID 815 //
     /* 104081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104096 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 104099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104114 */     GIR_RootConstrainSelectedInstOperands,
     /* 104115 */     // GIR_Coverage, 815,
     /* 104115 */     GIR_EraseRootFromParent_Done,
     /* 104116 */   // Label 1941: @104116
     /* 104116 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(104177), // Rule ID 3512 //
     /* 104121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104136 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 104151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104175 */     GIR_RootConstrainSelectedInstOperands,
     /* 104176 */     // GIR_Coverage, 3512,
     /* 104176 */     GIR_EraseRootFromParent_Done,
     /* 104177 */   // Label 1942: @104177
     /* 104177 */   GIM_Reject,
     /* 104178 */ // Label 1940: @104178
     /* 104178 */ GIM_Reject,
     /* 104179 */ // Label 1918: @104179
     /* 104179 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(104292),
     /* 104184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104190 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104230), // Rule ID 818 //
     /* 104195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104210 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104222 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104228 */     GIR_RootConstrainSelectedInstOperands,
     /* 104229 */     // GIR_Coverage, 818,
     /* 104229 */     GIR_EraseRootFromParent_Done,
     /* 104230 */   // Label 1944: @104230
     /* 104230 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104291), // Rule ID 3509 //
     /* 104235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104242 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104250 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104267 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104289 */     GIR_RootConstrainSelectedInstOperands,
     /* 104290 */     // GIR_Coverage, 3509,
     /* 104290 */     GIR_EraseRootFromParent_Done,
     /* 104291 */   // Label 1945: @104291
     /* 104291 */   GIM_Reject,
     /* 104292 */ // Label 1943: @104292
     /* 104292 */ GIM_Reject,
     /* 104293 */ // Label 1919: @104293
     /* 104293 */ GIM_Reject,
     /* 104294 */ // Label 31: @104294
     /* 104294 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1954*/ GIMT_Encode4(104938),
     /* 104305 */ /*GILLT_s64*//*Label 1946*/ GIMT_Encode4(104361), GIMT_Encode4(0),
     /* 104313 */ /*GILLT_v2s32*//*Label 1947*/ GIMT_Encode4(104408),
     /* 104317 */ /*GILLT_v2s64*//*Label 1948*/ GIMT_Encode4(104455), GIMT_Encode4(0),
     /* 104325 */ /*GILLT_v4s16*//*Label 1949*/ GIMT_Encode4(104502),
     /* 104329 */ /*GILLT_v4s32*//*Label 1950*/ GIMT_Encode4(104549), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104341 */ /*GILLT_v8s8*//*Label 1951*/ GIMT_Encode4(104663),
     /* 104345 */ /*GILLT_v8s16*//*Label 1952*/ GIMT_Encode4(104710), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104357 */ /*GILLT_v16s8*//*Label 1953*/ GIMT_Encode4(104824),
     /* 104361 */ // Label 1946: @104361
     /* 104361 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104407), // Rule ID 1019 //
     /* 104366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104387 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104392 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104394 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104399 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104405 */   GIR_RootConstrainSelectedInstOperands,
     /* 104406 */   // GIR_Coverage, 1019,
     /* 104406 */   GIR_EraseRootFromParent_Done,
     /* 104407 */ // Label 1955: @104407
     /* 104407 */ GIM_Reject,
     /* 104408 */ // Label 1947: @104408
     /* 104408 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(104454), // Rule ID 1014 //
     /* 104413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104434 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104439 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104441 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104446 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104452 */   GIR_RootConstrainSelectedInstOperands,
     /* 104453 */   // GIR_Coverage, 1014,
     /* 104453 */   GIR_EraseRootFromParent_Done,
     /* 104454 */ // Label 1956: @104454
     /* 104454 */ GIM_Reject,
     /* 104455 */ // Label 1948: @104455
     /* 104455 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(104501), // Rule ID 1020 //
     /* 104460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104481 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104486 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104488 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104493 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104499 */   GIR_RootConstrainSelectedInstOperands,
     /* 104500 */   // GIR_Coverage, 1020,
     /* 104500 */   GIR_EraseRootFromParent_Done,
     /* 104501 */ // Label 1957: @104501
     /* 104501 */ GIM_Reject,
     /* 104502 */ // Label 1949: @104502
     /* 104502 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(104548), // Rule ID 1013 //
     /* 104507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104528 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104533 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104535 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104546 */   GIR_RootConstrainSelectedInstOperands,
     /* 104547 */   // GIR_Coverage, 1013,
     /* 104547 */   GIR_EraseRootFromParent_Done,
     /* 104548 */ // Label 1958: @104548
     /* 104548 */ GIM_Reject,
     /* 104549 */ // Label 1950: @104549
     /* 104549 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(104662),
     /* 104554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104560 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(104600), // Rule ID 1016 //
     /* 104565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104580 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104598 */     GIR_RootConstrainSelectedInstOperands,
     /* 104599 */     // GIR_Coverage, 1016,
     /* 104599 */     GIR_EraseRootFromParent_Done,
     /* 104600 */   // Label 1960: @104600
     /* 104600 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(104661), // Rule ID 3542 //
     /* 104605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104620 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104659 */     GIR_RootConstrainSelectedInstOperands,
     /* 104660 */     // GIR_Coverage, 3542,
     /* 104660 */     GIR_EraseRootFromParent_Done,
     /* 104661 */   // Label 1961: @104661
     /* 104661 */   GIM_Reject,
     /* 104662 */ // Label 1959: @104662
     /* 104662 */ GIM_Reject,
     /* 104663 */ // Label 1951: @104663
     /* 104663 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(104709), // Rule ID 1017 //
     /* 104668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104685 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104689 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104694 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104696 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104701 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104707 */   GIR_RootConstrainSelectedInstOperands,
     /* 104708 */   // GIR_Coverage, 1017,
     /* 104708 */   GIR_EraseRootFromParent_Done,
     /* 104709 */ // Label 1962: @104709
     /* 104709 */ GIM_Reject,
     /* 104710 */ // Label 1952: @104710
     /* 104710 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(104823),
     /* 104715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104721 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104761), // Rule ID 1015 //
     /* 104726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104741 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104759 */     GIR_RootConstrainSelectedInstOperands,
     /* 104760 */     // GIR_Coverage, 1015,
     /* 104760 */     GIR_EraseRootFromParent_Done,
     /* 104761 */   // Label 1964: @104761
     /* 104761 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104822), // Rule ID 3539 //
     /* 104766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104781 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104820 */     GIR_RootConstrainSelectedInstOperands,
     /* 104821 */     // GIR_Coverage, 3539,
     /* 104821 */     GIR_EraseRootFromParent_Done,
     /* 104822 */   // Label 1965: @104822
     /* 104822 */   GIM_Reject,
     /* 104823 */ // Label 1963: @104823
     /* 104823 */ GIM_Reject,
     /* 104824 */ // Label 1953: @104824
     /* 104824 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104937),
     /* 104829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104835 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104875), // Rule ID 1018 //
     /* 104840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104855 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104873 */     GIR_RootConstrainSelectedInstOperands,
     /* 104874 */     // GIR_Coverage, 1018,
     /* 104874 */     GIR_EraseRootFromParent_Done,
     /* 104875 */   // Label 1967: @104875
     /* 104875 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104936), // Rule ID 3536 //
     /* 104880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104895 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104934 */     GIR_RootConstrainSelectedInstOperands,
     /* 104935 */     // GIR_Coverage, 3536,
     /* 104935 */     GIR_EraseRootFromParent_Done,
     /* 104936 */   // Label 1968: @104936
     /* 104936 */   GIM_Reject,
     /* 104937 */ // Label 1966: @104937
     /* 104937 */ GIM_Reject,
     /* 104938 */ // Label 1954: @104938
     /* 104938 */ GIM_Reject,
     /* 104939 */ // Label 32: @104939
     /* 104939 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1978*/ GIMT_Encode4(105958),
     /* 104950 */ /*GILLT_s32*//*Label 1969*/ GIMT_Encode4(105010),
     /* 104954 */ /*GILLT_s64*//*Label 1970*/ GIMT_Encode4(105227), GIMT_Encode4(0),
     /* 104962 */ /*GILLT_v2s32*//*Label 1971*/ GIMT_Encode4(105274),
     /* 104966 */ /*GILLT_v2s64*//*Label 1972*/ GIMT_Encode4(105321), GIMT_Encode4(0),
     /* 104974 */ /*GILLT_v4s16*//*Label 1973*/ GIMT_Encode4(105444),
     /* 104978 */ /*GILLT_v4s32*//*Label 1974*/ GIMT_Encode4(105491), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104990 */ /*GILLT_v8s8*//*Label 1975*/ GIMT_Encode4(105683),
     /* 104994 */ /*GILLT_v8s16*//*Label 1976*/ GIMT_Encode4(105730), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105006 */ /*GILLT_v16s8*//*Label 1977*/ GIMT_Encode4(105844),
     /* 105010 */ // Label 1969: @105010
     /* 105010 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(105226),
     /* 105015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105021 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(105083), // Rule ID 1868 //
     /* 105026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105054 */     // MIs[1] Rn
     /* 105054 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105061 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 105064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105066 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105075 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105081 */     GIR_RootConstrainSelectedInstOperands,
     /* 105082 */     // GIR_Coverage, 1868,
     /* 105082 */     GIR_EraseRootFromParent_Done,
     /* 105083 */   // Label 1980: @105083
     /* 105083 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(105145), // Rule ID 2134 //
     /* 105088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105116 */     // MIs[1] Rn
     /* 105116 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105123 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 105126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105143 */     GIR_RootConstrainSelectedInstOperands,
     /* 105144 */     // GIR_Coverage, 2134,
     /* 105144 */     GIR_EraseRootFromParent_Done,
     /* 105145 */   // Label 1981: @105145
     /* 105145 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(105185), // Rule ID 1866 //
     /* 105150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105165 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 105165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 105168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105170 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 105172 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 105174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105183 */     GIR_RootConstrainSelectedInstOperands,
     /* 105184 */     // GIR_Coverage, 1866,
     /* 105184 */     GIR_EraseRootFromParent_Done,
     /* 105185 */   // Label 1982: @105185
     /* 105185 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(105225), // Rule ID 2132 //
     /* 105190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105205 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 105208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105223 */     GIR_RootConstrainSelectedInstOperands,
     /* 105224 */     // GIR_Coverage, 2132,
     /* 105224 */     GIR_EraseRootFromParent_Done,
     /* 105225 */   // Label 1983: @105225
     /* 105225 */   GIM_Reject,
     /* 105226 */ // Label 1979: @105226
     /* 105226 */ GIM_Reject,
     /* 105227 */ // Label 1970: @105227
     /* 105227 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(105273), // Rule ID 1011 //
     /* 105232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105238 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105249 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105253 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105258 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105260 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105265 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105271 */   GIR_RootConstrainSelectedInstOperands,
     /* 105272 */   // GIR_Coverage, 1011,
     /* 105272 */   GIR_EraseRootFromParent_Done,
     /* 105273 */ // Label 1984: @105273
     /* 105273 */ GIM_Reject,
     /* 105274 */ // Label 1971: @105274
     /* 105274 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(105320), // Rule ID 1006 //
     /* 105279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105300 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105305 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105307 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105312 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105318 */   GIR_RootConstrainSelectedInstOperands,
     /* 105319 */   // GIR_Coverage, 1006,
     /* 105319 */   GIR_EraseRootFromParent_Done,
     /* 105320 */ // Label 1985: @105320
     /* 105320 */ GIM_Reject,
     /* 105321 */ // Label 1972: @105321
     /* 105321 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(105443),
     /* 105326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105340 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(105410), // Rule ID 2493 //
     /* 105345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105356 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105359 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105368 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105384 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105389 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105408 */     GIR_RootConstrainSelectedInstOperands,
     /* 105409 */     // GIR_Coverage, 2493,
     /* 105409 */     GIR_EraseRootFromParent_Done,
     /* 105410 */   // Label 1987: @105410
     /* 105410 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(105442), // Rule ID 1012 //
     /* 105415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105422 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105427 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105434 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105440 */     GIR_RootConstrainSelectedInstOperands,
     /* 105441 */     // GIR_Coverage, 1012,
     /* 105441 */     GIR_EraseRootFromParent_Done,
     /* 105442 */   // Label 1988: @105442
     /* 105442 */   GIM_Reject,
     /* 105443 */ // Label 1986: @105443
     /* 105443 */ GIM_Reject,
     /* 105444 */ // Label 1973: @105444
     /* 105444 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105490), // Rule ID 1005 //
     /* 105449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105470 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105475 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105477 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105488 */   GIR_RootConstrainSelectedInstOperands,
     /* 105489 */   // GIR_Coverage, 1005,
     /* 105489 */   GIR_EraseRootFromParent_Done,
     /* 105490 */ // Label 1989: @105490
     /* 105490 */ GIM_Reject,
     /* 105491 */ // Label 1974: @105491
     /* 105491 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105682),
     /* 105496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105502 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105580), // Rule ID 2492 //
     /* 105507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105526 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105529 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105538 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105554 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105559 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105578 */     GIR_RootConstrainSelectedInstOperands,
     /* 105579 */     // GIR_Coverage, 2492,
     /* 105579 */     GIR_EraseRootFromParent_Done,
     /* 105580 */   // Label 1991: @105580
     /* 105580 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105620), // Rule ID 1008 //
     /* 105585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105600 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105618 */     GIR_RootConstrainSelectedInstOperands,
     /* 105619 */     // GIR_Coverage, 1008,
     /* 105619 */     GIR_EraseRootFromParent_Done,
     /* 105620 */   // Label 1992: @105620
     /* 105620 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105681), // Rule ID 3533 //
     /* 105625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105640 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105679 */     GIR_RootConstrainSelectedInstOperands,
     /* 105680 */     // GIR_Coverage, 3533,
     /* 105680 */     GIR_EraseRootFromParent_Done,
     /* 105681 */   // Label 1993: @105681
     /* 105681 */   GIM_Reject,
     /* 105682 */ // Label 1990: @105682
     /* 105682 */ GIM_Reject,
     /* 105683 */ // Label 1975: @105683
     /* 105683 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105729), // Rule ID 1009 //
     /* 105688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105709 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105714 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105716 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105721 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105727 */   GIR_RootConstrainSelectedInstOperands,
     /* 105728 */   // GIR_Coverage, 1009,
     /* 105728 */   GIR_EraseRootFromParent_Done,
     /* 105729 */ // Label 1994: @105729
     /* 105729 */ GIM_Reject,
     /* 105730 */ // Label 1976: @105730
     /* 105730 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105843),
     /* 105735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105741 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105781), // Rule ID 1007 //
     /* 105746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105761 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105779 */     GIR_RootConstrainSelectedInstOperands,
     /* 105780 */     // GIR_Coverage, 1007,
     /* 105780 */     GIR_EraseRootFromParent_Done,
     /* 105781 */   // Label 1996: @105781
     /* 105781 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105842), // Rule ID 3530 //
     /* 105786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105801 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105825 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105840 */     GIR_RootConstrainSelectedInstOperands,
     /* 105841 */     // GIR_Coverage, 3530,
     /* 105841 */     GIR_EraseRootFromParent_Done,
     /* 105842 */   // Label 1997: @105842
     /* 105842 */   GIM_Reject,
     /* 105843 */ // Label 1995: @105843
     /* 105843 */ GIM_Reject,
     /* 105844 */ // Label 1977: @105844
     /* 105844 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105957),
     /* 105849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105855 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105895), // Rule ID 1010 //
     /* 105860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105875 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105893 */     GIR_RootConstrainSelectedInstOperands,
     /* 105894 */     // GIR_Coverage, 1010,
     /* 105894 */     GIR_EraseRootFromParent_Done,
     /* 105895 */   // Label 1999: @105895
     /* 105895 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105956), // Rule ID 3527 //
     /* 105900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105915 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105954 */     GIR_RootConstrainSelectedInstOperands,
     /* 105955 */     // GIR_Coverage, 3527,
     /* 105955 */     GIR_EraseRootFromParent_Done,
     /* 105956 */   // Label 2000: @105956
     /* 105956 */   GIM_Reject,
     /* 105957 */ // Label 1998: @105957
     /* 105957 */ GIM_Reject,
     /* 105958 */ // Label 1978: @105958
     /* 105958 */ GIM_Reject,
     /* 105959 */ // Label 33: @105959
     /* 105959 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2008*/ GIMT_Encode4(108311),
     /* 105970 */ /*GILLT_s16*//*Label 2001*/ GIMT_Encode4(106022),
     /* 105974 */ /*GILLT_s32*//*Label 2002*/ GIMT_Encode4(106069),
     /* 105978 */ /*GILLT_s64*//*Label 2003*/ GIMT_Encode4(107664), GIMT_Encode4(0),
     /* 105986 */ /*GILLT_v2s32*//*Label 2004*/ GIMT_Encode4(107711), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105998 */ /*GILLT_v4s16*//*Label 2005*/ GIMT_Encode4(107758),
     /* 106002 */ /*GILLT_v4s32*//*Label 2006*/ GIMT_Encode4(107943), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106018 */ /*GILLT_v8s16*//*Label 2007*/ GIMT_Encode4(108057),
     /* 106022 */ // Label 2001: @106022
     /* 106022 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(106068), // Rule ID 614 //
     /* 106027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 106030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 106033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 106036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106048 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 106048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 106051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106053 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106055 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106060 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106066 */   GIR_RootConstrainSelectedInstOperands,
     /* 106067 */   // GIR_Coverage, 614,
     /* 106067 */   GIR_EraseRootFromParent_Done,
     /* 106068 */ // Label 2009: @106068
     /* 106068 */ GIM_Reject,
     /* 106069 */ // Label 2002: @106069
     /* 106069 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(107663),
     /* 106074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106084 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(106412), // Rule ID 5918 //
     /* 106089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106124 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106124 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106127 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106131 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106138 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106141 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106145 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106150 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106153 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106158 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106161 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106165 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106170 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106173 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106177 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106180 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106185 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106190 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106195 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106198 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106202 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106209 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106212 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106216 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106221 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106224 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106229 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106232 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106236 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106241 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106244 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106248 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106251 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106256 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106261 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106266 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106269 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106273 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106280 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106283 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106287 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106292 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106295 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106300 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106303 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106307 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106312 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106315 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106319 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106322 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106327 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106332 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106349 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106352 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106355 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106358 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106361 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106381 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106384 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106394 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106411 */     // GIR_Coverage, 5918,
     /* 106411 */     GIR_EraseRootFromParent_Done,
     /* 106412 */   // Label 2011: @106412
     /* 106412 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(106740), // Rule ID 5919 //
     /* 106417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106452 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106452 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106455 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106459 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106466 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106469 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106473 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106478 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106481 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106486 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106489 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106493 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106498 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106501 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106505 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106508 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106513 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106518 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106523 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106526 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106530 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106537 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106540 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106544 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106549 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106552 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106557 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106560 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106564 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106569 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106572 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106576 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106579 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106584 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106589 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106594 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106597 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106601 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106608 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106611 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106615 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106620 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106623 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106628 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106631 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106635 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106640 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106643 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106647 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106650 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106655 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106660 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106677 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106680 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106683 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106686 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106689 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106709 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106722 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106739 */     // GIR_Coverage, 5919,
     /* 106739 */     GIR_EraseRootFromParent_Done,
     /* 106740 */   // Label 2012: @106740
     /* 106740 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107068), // Rule ID 2697 //
     /* 106745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106780 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106780 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106783 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106787 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106794 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106797 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106801 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106806 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106809 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106814 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106817 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106821 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106826 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106829 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106833 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106836 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106841 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106846 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106851 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106854 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106858 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106865 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106868 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106872 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106877 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106880 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106885 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106888 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106892 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106897 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106900 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106904 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106907 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106912 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106917 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106922 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106925 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106929 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106936 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106939 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106943 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106948 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106951 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106956 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106959 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106963 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106968 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106971 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106975 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106978 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106983 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106988 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106993 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106996 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 107000 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107005 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107008 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107011 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107014 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107017 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107050 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107057 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107067 */     // GIR_Coverage, 2697,
     /* 107067 */     GIR_EraseRootFromParent_Done,
     /* 107068 */   // Label 2013: @107068
     /* 107068 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107396), // Rule ID 2699 //
     /* 107073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 107076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107108 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107108 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107111 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107115 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 107122 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 107125 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107129 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107134 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 107137 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107142 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 107145 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107149 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107154 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 107157 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 107161 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 107164 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107169 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107174 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107179 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107182 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107186 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107193 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107196 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107200 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107205 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107208 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107213 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107216 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107220 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107225 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107228 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107232 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107235 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107240 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107245 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107250 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107253 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107257 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107264 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107267 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107271 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107276 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107279 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107284 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107287 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107291 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107296 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107299 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107303 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107306 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107311 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107316 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107321 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107324 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107328 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107333 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107336 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107339 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107342 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107345 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107378 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107395 */     // GIR_Coverage, 2699,
     /* 107395 */     GIR_EraseRootFromParent_Done,
     /* 107396 */   // Label 2014: @107396
     /* 107396 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107432), // Rule ID 613 //
     /* 107401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107412 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107430 */     GIR_RootConstrainSelectedInstOperands,
     /* 107431 */     // GIR_Coverage, 613,
     /* 107431 */     GIR_EraseRootFromParent_Done,
     /* 107432 */   // Label 2015: @107432
     /* 107432 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107662), // Rule ID 2694 //
     /* 107437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107448 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107448 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107451 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107455 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107462 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107465 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107469 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107474 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107477 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107482 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107485 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107489 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107494 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107497 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107501 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107504 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107509 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107514 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107519 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107522 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107526 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107533 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107536 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107540 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107545 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107548 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107553 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107556 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107560 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107565 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107568 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107572 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107575 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107580 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107585 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107602 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107605 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107608 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107611 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107631 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107644 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107661 */     // GIR_Coverage, 2694,
     /* 107661 */     GIR_EraseRootFromParent_Done,
     /* 107662 */   // Label 2016: @107662
     /* 107662 */   GIM_Reject,
     /* 107663 */ // Label 2010: @107663
     /* 107663 */ GIM_Reject,
     /* 107664 */ // Label 2003: @107664
     /* 107664 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107710), // Rule ID 612 //
     /* 107669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107690 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107695 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107697 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107702 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107708 */   GIR_RootConstrainSelectedInstOperands,
     /* 107709 */   // GIR_Coverage, 612,
     /* 107709 */   GIR_EraseRootFromParent_Done,
     /* 107710 */ // Label 2017: @107710
     /* 107710 */ GIM_Reject,
     /* 107711 */ // Label 2004: @107711
     /* 107711 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107757), // Rule ID 761 //
     /* 107716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107737 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107742 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107744 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107749 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107755 */   GIR_RootConstrainSelectedInstOperands,
     /* 107756 */   // GIR_Coverage, 761,
     /* 107756 */   GIR_EraseRootFromParent_Done,
     /* 107757 */ // Label 2018: @107757
     /* 107757 */ GIM_Reject,
     /* 107758 */ // Label 2005: @107758
     /* 107758 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(107942),
     /* 107763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107773 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107839), // Rule ID 5581 //
     /* 107778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107813 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107818 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107837 */     GIR_RootConstrainSelectedInstOperands,
     /* 107838 */     // GIR_Coverage, 5581,
     /* 107838 */     GIR_EraseRootFromParent_Done,
     /* 107839 */   // Label 2020: @107839
     /* 107839 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107905), // Rule ID 942 //
     /* 107844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107879 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107884 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107903 */     GIR_RootConstrainSelectedInstOperands,
     /* 107904 */     // GIR_Coverage, 942,
     /* 107904 */     GIR_EraseRootFromParent_Done,
     /* 107905 */   // Label 2021: @107905
     /* 107905 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107941), // Rule ID 763 //
     /* 107910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107921 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107939 */     GIR_RootConstrainSelectedInstOperands,
     /* 107940 */     // GIR_Coverage, 763,
     /* 107940 */     GIR_EraseRootFromParent_Done,
     /* 107941 */   // Label 2022: @107941
     /* 107941 */   GIM_Reject,
     /* 107942 */ // Label 2019: @107942
     /* 107942 */ GIM_Reject,
     /* 107943 */ // Label 2006: @107943
     /* 107943 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(108056),
     /* 107948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107954 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107994), // Rule ID 762 //
     /* 107959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107974 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107992 */     GIR_RootConstrainSelectedInstOperands,
     /* 107993 */     // GIR_Coverage, 762,
     /* 107993 */     GIR_EraseRootFromParent_Done,
     /* 107994 */   // Label 2024: @107994
     /* 107994 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(108055), // Rule ID 4013 //
     /* 107999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108014 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 108014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 108029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108053 */     GIR_RootConstrainSelectedInstOperands,
     /* 108054 */     // GIR_Coverage, 4013,
     /* 108054 */     GIR_EraseRootFromParent_Done,
     /* 108055 */   // Label 2025: @108055
     /* 108055 */   GIM_Reject,
     /* 108056 */ // Label 2023: @108056
     /* 108056 */ GIM_Reject,
     /* 108057 */ // Label 2007: @108057
     /* 108057 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(108310),
     /* 108062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108068 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(108138), // Rule ID 5582 //
     /* 108073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108112 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108117 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108136 */     GIR_RootConstrainSelectedInstOperands,
     /* 108137 */     // GIR_Coverage, 5582,
     /* 108137 */     GIR_EraseRootFromParent_Done,
     /* 108138 */   // Label 2027: @108138
     /* 108138 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(108208), // Rule ID 943 //
     /* 108143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108182 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108187 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108206 */     GIR_RootConstrainSelectedInstOperands,
     /* 108207 */     // GIR_Coverage, 943,
     /* 108207 */     GIR_EraseRootFromParent_Done,
     /* 108208 */   // Label 2028: @108208
     /* 108208 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(108248), // Rule ID 764 //
     /* 108213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108228 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108246 */     GIR_RootConstrainSelectedInstOperands,
     /* 108247 */     // GIR_Coverage, 764,
     /* 108247 */     GIR_EraseRootFromParent_Done,
     /* 108248 */   // Label 2029: @108248
     /* 108248 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(108309), // Rule ID 4017 //
     /* 108253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108268 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108307 */     GIR_RootConstrainSelectedInstOperands,
     /* 108308 */     // GIR_Coverage, 4017,
     /* 108308 */     GIR_EraseRootFromParent_Done,
     /* 108309 */   // Label 2030: @108309
     /* 108309 */   GIM_Reject,
     /* 108310 */ // Label 2026: @108310
     /* 108310 */ GIM_Reject,
     /* 108311 */ // Label 2008: @108311
     /* 108311 */ GIM_Reject,
     /* 108312 */ // Label 34: @108312
     /* 108312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2038*/ GIMT_Encode4(109988),
     /* 108323 */ /*GILLT_s16*//*Label 2031*/ GIMT_Encode4(108375),
     /* 108327 */ /*GILLT_s32*//*Label 2032*/ GIMT_Encode4(108422),
     /* 108331 */ /*GILLT_s64*//*Label 2033*/ GIMT_Encode4(109349), GIMT_Encode4(0),
     /* 108339 */ /*GILLT_v2s32*//*Label 2034*/ GIMT_Encode4(109396), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108351 */ /*GILLT_v4s16*//*Label 2035*/ GIMT_Encode4(109443),
     /* 108355 */ /*GILLT_v4s32*//*Label 2036*/ GIMT_Encode4(109620), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108371 */ /*GILLT_v8s16*//*Label 2037*/ GIMT_Encode4(109734),
     /* 108375 */ // Label 2031: @108375
     /* 108375 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108421), // Rule ID 617 //
     /* 108380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108401 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108406 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108408 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108413 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108419 */   GIR_RootConstrainSelectedInstOperands,
     /* 108420 */   // GIR_Coverage, 617,
     /* 108420 */   GIR_EraseRootFromParent_Done,
     /* 108421 */ // Label 2039: @108421
     /* 108421 */ GIM_Reject,
     /* 108422 */ // Label 2032: @108422
     /* 108422 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(109348),
     /* 108427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108441 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108765), // Rule ID 2698 //
     /* 108446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108477 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108477 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108480 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108484 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108491 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108494 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108498 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108503 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108506 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108511 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108514 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108518 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108523 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108526 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108530 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108533 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108538 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108543 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108548 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108551 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108555 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108562 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108565 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108569 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108574 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108577 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108582 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108585 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108589 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108594 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108597 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108601 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108604 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108609 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108614 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108619 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108622 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108626 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108633 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108636 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108640 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108645 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108648 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108653 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108656 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108660 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108665 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108668 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108672 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108675 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108680 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108685 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108705 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108708 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108711 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108714 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108747 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108764 */     // GIR_Coverage, 2698,
     /* 108764 */     GIR_EraseRootFromParent_Done,
     /* 108765 */   // Label 2041: @108765
     /* 108765 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(109089), // Rule ID 2700 //
     /* 108770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108801 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108801 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108804 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108808 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108815 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108818 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108822 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108827 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108830 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108835 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108838 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108842 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108847 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108850 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108854 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108857 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108862 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108867 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108872 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108875 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108879 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108886 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108889 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108893 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108898 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108901 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108906 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108909 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108913 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108918 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108921 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108925 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108928 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108933 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108938 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108943 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108946 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108950 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108957 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108960 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108964 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108969 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108972 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108977 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108980 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108984 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108989 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108992 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108996 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108999 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109004 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109009 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109014 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109017 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 109021 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109026 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109029 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109032 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 109035 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109038 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109058 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109071 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109088 */     // GIR_Coverage, 2700,
     /* 109088 */     GIR_EraseRootFromParent_Done,
     /* 109089 */   // Label 2042: @109089
     /* 109089 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(109121), // Rule ID 616 //
     /* 109094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109101 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 109104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109119 */     GIR_RootConstrainSelectedInstOperands,
     /* 109120 */     // GIR_Coverage, 616,
     /* 109120 */     GIR_EraseRootFromParent_Done,
     /* 109121 */   // Label 2043: @109121
     /* 109121 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(109347), // Rule ID 2695 //
     /* 109126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109133 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109133 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109136 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109140 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109147 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109150 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109154 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109159 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109162 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109167 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109170 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109174 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109179 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109182 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109186 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109189 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109194 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109199 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109204 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109207 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109211 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109218 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109221 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109225 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109230 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109233 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109238 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109241 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109245 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109250 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109253 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109257 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109260 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109265 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109270 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109287 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109290 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109293 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109296 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109316 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109329 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109346 */     // GIR_Coverage, 2695,
     /* 109346 */     GIR_EraseRootFromParent_Done,
     /* 109347 */   // Label 2044: @109347
     /* 109347 */   GIM_Reject,
     /* 109348 */ // Label 2040: @109348
     /* 109348 */ GIM_Reject,
     /* 109349 */ // Label 2033: @109349
     /* 109349 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(109395), // Rule ID 615 //
     /* 109354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109375 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109380 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109382 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109393 */   GIR_RootConstrainSelectedInstOperands,
     /* 109394 */   // GIR_Coverage, 615,
     /* 109394 */   GIR_EraseRootFromParent_Done,
     /* 109395 */ // Label 2045: @109395
     /* 109395 */ GIM_Reject,
     /* 109396 */ // Label 2034: @109396
     /* 109396 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(109442), // Rule ID 965 //
     /* 109401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109422 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109427 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109429 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109434 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109440 */   GIR_RootConstrainSelectedInstOperands,
     /* 109441 */   // GIR_Coverage, 965,
     /* 109441 */   GIR_EraseRootFromParent_Done,
     /* 109442 */ // Label 2046: @109442
     /* 109442 */ GIM_Reject,
     /* 109443 */ // Label 2035: @109443
     /* 109443 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(109619),
     /* 109448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109462 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(109524), // Rule ID 920 //
     /* 109467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109498 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109503 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109522 */     GIR_RootConstrainSelectedInstOperands,
     /* 109523 */     // GIR_Coverage, 920,
     /* 109523 */     GIR_EraseRootFromParent_Done,
     /* 109524 */   // Label 2048: @109524
     /* 109524 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(109586), // Rule ID 946 //
     /* 109529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109560 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109565 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109584 */     GIR_RootConstrainSelectedInstOperands,
     /* 109585 */     // GIR_Coverage, 946,
     /* 109585 */     GIR_EraseRootFromParent_Done,
     /* 109586 */   // Label 2049: @109586
     /* 109586 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109618), // Rule ID 967 //
     /* 109591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109598 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109610 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109616 */     GIR_RootConstrainSelectedInstOperands,
     /* 109617 */     // GIR_Coverage, 967,
     /* 109617 */     GIR_EraseRootFromParent_Done,
     /* 109618 */   // Label 2050: @109618
     /* 109618 */   GIM_Reject,
     /* 109619 */ // Label 2047: @109619
     /* 109619 */ GIM_Reject,
     /* 109620 */ // Label 2036: @109620
     /* 109620 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109733),
     /* 109625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109631 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109671), // Rule ID 966 //
     /* 109636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109651 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109669 */     GIR_RootConstrainSelectedInstOperands,
     /* 109670 */     // GIR_Coverage, 966,
     /* 109670 */     GIR_EraseRootFromParent_Done,
     /* 109671 */   // Label 2052: @109671
     /* 109671 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109732), // Rule ID 4021 //
     /* 109676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109691 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109730 */     GIR_RootConstrainSelectedInstOperands,
     /* 109731 */     // GIR_Coverage, 4021,
     /* 109731 */     GIR_EraseRootFromParent_Done,
     /* 109732 */   // Label 2053: @109732
     /* 109732 */   GIM_Reject,
     /* 109733 */ // Label 2051: @109733
     /* 109733 */ GIM_Reject,
     /* 109734 */ // Label 2037: @109734
     /* 109734 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109987),
     /* 109739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109745 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109815), // Rule ID 921 //
     /* 109750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109789 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109794 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109813 */     GIR_RootConstrainSelectedInstOperands,
     /* 109814 */     // GIR_Coverage, 921,
     /* 109814 */     GIR_EraseRootFromParent_Done,
     /* 109815 */   // Label 2055: @109815
     /* 109815 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109885), // Rule ID 947 //
     /* 109820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109859 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109864 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109883 */     GIR_RootConstrainSelectedInstOperands,
     /* 109884 */     // GIR_Coverage, 947,
     /* 109884 */     GIR_EraseRootFromParent_Done,
     /* 109885 */   // Label 2056: @109885
     /* 109885 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109925), // Rule ID 968 //
     /* 109890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109905 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109923 */     GIR_RootConstrainSelectedInstOperands,
     /* 109924 */     // GIR_Coverage, 968,
     /* 109924 */     GIR_EraseRootFromParent_Done,
     /* 109925 */   // Label 2057: @109925
     /* 109925 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109986), // Rule ID 4025 //
     /* 109930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109937 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109945 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109984 */     GIR_RootConstrainSelectedInstOperands,
     /* 109985 */     // GIR_Coverage, 4025,
     /* 109985 */     GIR_EraseRootFromParent_Done,
     /* 109986 */   // Label 2058: @109986
     /* 109986 */   GIM_Reject,
     /* 109987 */ // Label 2054: @109987
     /* 109987 */ GIM_Reject,
     /* 109988 */ // Label 2038: @109988
     /* 109988 */ GIM_Reject,
     /* 109989 */ // Label 35: @109989
     /* 109989 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2066*/ GIMT_Encode4(110969),
     /* 110000 */ /*GILLT_s16*//*Label 2059*/ GIMT_Encode4(110052),
     /* 110004 */ /*GILLT_s32*//*Label 2060*/ GIMT_Encode4(110099),
     /* 110008 */ /*GILLT_s64*//*Label 2061*/ GIMT_Encode4(110488), GIMT_Encode4(0),
     /* 110016 */ /*GILLT_v2s32*//*Label 2062*/ GIMT_Encode4(110647), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110028 */ /*GILLT_v4s16*//*Label 2063*/ GIMT_Encode4(110694),
     /* 110032 */ /*GILLT_v4s32*//*Label 2064*/ GIMT_Encode4(110741), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110048 */ /*GILLT_v8s16*//*Label 2065*/ GIMT_Encode4(110855),
     /* 110052 */ // Label 2059: @110052
     /* 110052 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(110098), // Rule ID 623 //
     /* 110057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110078 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 110081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110085 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110096 */   GIR_RootConstrainSelectedInstOperands,
     /* 110097 */   // GIR_Coverage, 623,
     /* 110097 */   GIR_EraseRootFromParent_Done,
     /* 110098 */ // Label 2067: @110098
     /* 110098 */ GIM_Reject,
     /* 110099 */ // Label 2060: @110099
     /* 110099 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(110487),
     /* 110104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110114 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(110167), // Rule ID 2299 //
     /* 110119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110145 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110154 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110165 */     GIR_RootConstrainSelectedInstOperands,
     /* 110166 */     // GIR_Coverage, 2299,
     /* 110166 */     GIR_EraseRootFromParent_Done,
     /* 110167 */   // Label 2069: @110167
     /* 110167 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(110220), // Rule ID 5708 //
     /* 110172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110198 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110207 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110218 */     GIR_RootConstrainSelectedInstOperands,
     /* 110219 */     // GIR_Coverage, 5708,
     /* 110219 */     GIR_EraseRootFromParent_Done,
     /* 110220 */   // Label 2070: @110220
     /* 110220 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(110256), // Rule ID 622 //
     /* 110225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110236 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110254 */     GIR_RootConstrainSelectedInstOperands,
     /* 110255 */     // GIR_Coverage, 622,
     /* 110255 */     GIR_EraseRootFromParent_Done,
     /* 110256 */   // Label 2071: @110256
     /* 110256 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(110486), // Rule ID 2696 //
     /* 110261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110272 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110272 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110275 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110279 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110286 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110289 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110293 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110298 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110301 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110306 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110309 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110313 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110318 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110321 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110325 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110328 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110333 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110338 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110343 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110346 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110350 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110357 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110360 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110364 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110369 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110372 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110377 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110380 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110384 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110389 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110392 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110396 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110399 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110404 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110409 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110429 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110432 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110435 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110455 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110468 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110480 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110485 */     // GIR_Coverage, 2696,
     /* 110485 */     GIR_EraseRootFromParent_Done,
     /* 110486 */   // Label 2072: @110486
     /* 110486 */   GIM_Reject,
     /* 110487 */ // Label 2068: @110487
     /* 110487 */ GIM_Reject,
     /* 110488 */ // Label 2061: @110488
     /* 110488 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(110646),
     /* 110493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110503 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(110556), // Rule ID 2298 //
     /* 110508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110534 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110543 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110554 */     GIR_RootConstrainSelectedInstOperands,
     /* 110555 */     // GIR_Coverage, 2298,
     /* 110555 */     GIR_EraseRootFromParent_Done,
     /* 110556 */   // Label 2074: @110556
     /* 110556 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110609), // Rule ID 5707 //
     /* 110561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110587 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110596 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110607 */     GIR_RootConstrainSelectedInstOperands,
     /* 110608 */     // GIR_Coverage, 5707,
     /* 110608 */     GIR_EraseRootFromParent_Done,
     /* 110609 */   // Label 2075: @110609
     /* 110609 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110645), // Rule ID 621 //
     /* 110614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110625 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110643 */     GIR_RootConstrainSelectedInstOperands,
     /* 110644 */     // GIR_Coverage, 621,
     /* 110644 */     GIR_EraseRootFromParent_Done,
     /* 110645 */   // Label 2076: @110645
     /* 110645 */   GIM_Reject,
     /* 110646 */ // Label 2073: @110646
     /* 110646 */ GIM_Reject,
     /* 110647 */ // Label 2062: @110647
     /* 110647 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110693), // Rule ID 840 //
     /* 110652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110673 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110678 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110680 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110685 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110691 */   GIR_RootConstrainSelectedInstOperands,
     /* 110692 */   // GIR_Coverage, 840,
     /* 110692 */   GIR_EraseRootFromParent_Done,
     /* 110693 */ // Label 2077: @110693
     /* 110693 */ GIM_Reject,
     /* 110694 */ // Label 2063: @110694
     /* 110694 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110740), // Rule ID 842 //
     /* 110699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110720 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110723 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110725 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110727 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110732 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110738 */   GIR_RootConstrainSelectedInstOperands,
     /* 110739 */   // GIR_Coverage, 842,
     /* 110739 */   GIR_EraseRootFromParent_Done,
     /* 110740 */ // Label 2078: @110740
     /* 110740 */ GIM_Reject,
     /* 110741 */ // Label 2064: @110741
     /* 110741 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110854),
     /* 110746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110752 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110792), // Rule ID 841 //
     /* 110757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110772 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110784 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110790 */     GIR_RootConstrainSelectedInstOperands,
     /* 110791 */     // GIR_Coverage, 841,
     /* 110791 */     GIR_EraseRootFromParent_Done,
     /* 110792 */   // Label 2080: @110792
     /* 110792 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110853), // Rule ID 3985 //
     /* 110797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110812 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110829 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110851 */     GIR_RootConstrainSelectedInstOperands,
     /* 110852 */     // GIR_Coverage, 3985,
     /* 110852 */     GIR_EraseRootFromParent_Done,
     /* 110853 */   // Label 2081: @110853
     /* 110853 */   GIM_Reject,
     /* 110854 */ // Label 2079: @110854
     /* 110854 */ GIM_Reject,
     /* 110855 */ // Label 2065: @110855
     /* 110855 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110968),
     /* 110860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110866 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110906), // Rule ID 843 //
     /* 110871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110886 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110898 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110904 */     GIR_RootConstrainSelectedInstOperands,
     /* 110905 */     // GIR_Coverage, 843,
     /* 110905 */     GIR_EraseRootFromParent_Done,
     /* 110906 */   // Label 2083: @110906
     /* 110906 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110967), // Rule ID 3989 //
     /* 110911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110926 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110965 */     GIR_RootConstrainSelectedInstOperands,
     /* 110966 */     // GIR_Coverage, 3989,
     /* 110966 */     GIR_EraseRootFromParent_Done,
     /* 110967 */   // Label 2084: @110967
     /* 110967 */   GIM_Reject,
     /* 110968 */ // Label 2082: @110968
     /* 110968 */ GIM_Reject,
     /* 110969 */ // Label 2066: @110969
     /* 110969 */ GIM_Reject,
     /* 110970 */ // Label 36: @110970
     /* 110970 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2092*/ GIMT_Encode4(113060),
     /* 110981 */ /*GILLT_s16*//*Label 2085*/ GIMT_Encode4(111033),
     /* 110985 */ /*GILLT_s32*//*Label 2086*/ GIMT_Encode4(111420),
     /* 110989 */ /*GILLT_s64*//*Label 2087*/ GIMT_Encode4(111807), GIMT_Encode4(0),
     /* 110997 */ /*GILLT_v2s32*//*Label 2088*/ GIMT_Encode4(112194), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111009 */ /*GILLT_v4s16*//*Label 2089*/ GIMT_Encode4(112374),
     /* 111013 */ /*GILLT_v4s32*//*Label 2090*/ GIMT_Encode4(112430), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111029 */ /*GILLT_v8s16*//*Label 2091*/ GIMT_Encode4(112808),
     /* 111033 */ // Label 2085: @111033
     /* 111033 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(111419),
     /* 111038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 111044 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 111047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111051 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(111125), // Rule ID 2403 //
     /* 111056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111092 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111099 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111123 */     GIR_RootConstrainSelectedInstOperands,
     /* 111124 */     // GIR_Coverage, 2403,
     /* 111124 */     GIR_EraseRootFromParent_Done,
     /* 111125 */   // Label 2094: @111125
     /* 111125 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111199), // Rule ID 5716 //
     /* 111130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111173 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111197 */     GIR_RootConstrainSelectedInstOperands,
     /* 111198 */     // GIR_Coverage, 5716,
     /* 111198 */     GIR_EraseRootFromParent_Done,
     /* 111199 */   // Label 2095: @111199
     /* 111199 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111258), // Rule ID 2395 //
     /* 111204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111234 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111256 */     GIR_RootConstrainSelectedInstOperands,
     /* 111257 */     // GIR_Coverage, 2395,
     /* 111257 */     GIR_EraseRootFromParent_Done,
     /* 111258 */   // Label 2096: @111258
     /* 111258 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111317), // Rule ID 5713 //
     /* 111263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111293 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111315 */     GIR_RootConstrainSelectedInstOperands,
     /* 111316 */     // GIR_Coverage, 5713,
     /* 111316 */     GIR_EraseRootFromParent_Done,
     /* 111317 */   // Label 2097: @111317
     /* 111317 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111376), // Rule ID 2408 //
     /* 111322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111352 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111374 */     GIR_RootConstrainSelectedInstOperands,
     /* 111375 */     // GIR_Coverage, 2408,
     /* 111375 */     GIR_EraseRootFromParent_Done,
     /* 111376 */   // Label 2098: @111376
     /* 111376 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111418), // Rule ID 2389 //
     /* 111381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111396 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111416 */     GIR_RootConstrainSelectedInstOperands,
     /* 111417 */     // GIR_Coverage, 2389,
     /* 111417 */     GIR_EraseRootFromParent_Done,
     /* 111418 */   // Label 2099: @111418
     /* 111418 */   GIM_Reject,
     /* 111419 */ // Label 2093: @111419
     /* 111419 */ GIM_Reject,
     /* 111420 */ // Label 2086: @111420
     /* 111420 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(111806),
     /* 111425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111431 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111438 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111512), // Rule ID 2402 //
     /* 111443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111486 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111510 */     GIR_RootConstrainSelectedInstOperands,
     /* 111511 */     // GIR_Coverage, 2402,
     /* 111511 */     GIR_EraseRootFromParent_Done,
     /* 111512 */   // Label 2101: @111512
     /* 111512 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(111586), // Rule ID 5715 //
     /* 111517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111560 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111584 */     GIR_RootConstrainSelectedInstOperands,
     /* 111585 */     // GIR_Coverage, 5715,
     /* 111585 */     GIR_EraseRootFromParent_Done,
     /* 111586 */   // Label 2102: @111586
     /* 111586 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111645), // Rule ID 2394 //
     /* 111591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111621 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111643 */     GIR_RootConstrainSelectedInstOperands,
     /* 111644 */     // GIR_Coverage, 2394,
     /* 111644 */     GIR_EraseRootFromParent_Done,
     /* 111645 */   // Label 2103: @111645
     /* 111645 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111704), // Rule ID 5712 //
     /* 111650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111680 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111702 */     GIR_RootConstrainSelectedInstOperands,
     /* 111703 */     // GIR_Coverage, 5712,
     /* 111703 */     GIR_EraseRootFromParent_Done,
     /* 111704 */   // Label 2104: @111704
     /* 111704 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111763), // Rule ID 2407 //
     /* 111709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111739 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111748 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111761 */     GIR_RootConstrainSelectedInstOperands,
     /* 111762 */     // GIR_Coverage, 2407,
     /* 111762 */     GIR_EraseRootFromParent_Done,
     /* 111763 */   // Label 2105: @111763
     /* 111763 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111805), // Rule ID 2388 //
     /* 111768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111783 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111803 */     GIR_RootConstrainSelectedInstOperands,
     /* 111804 */     // GIR_Coverage, 2388,
     /* 111804 */     GIR_EraseRootFromParent_Done,
     /* 111805 */   // Label 2106: @111805
     /* 111805 */   GIM_Reject,
     /* 111806 */ // Label 2100: @111806
     /* 111806 */ GIM_Reject,
     /* 111807 */ // Label 2087: @111807
     /* 111807 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(112193),
     /* 111812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111825 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111899), // Rule ID 2401 //
     /* 111830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111873 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111897 */     GIR_RootConstrainSelectedInstOperands,
     /* 111898 */     // GIR_Coverage, 2401,
     /* 111898 */     GIR_EraseRootFromParent_Done,
     /* 111899 */   // Label 2108: @111899
     /* 111899 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111973), // Rule ID 5714 //
     /* 111904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111947 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111965 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111971 */     GIR_RootConstrainSelectedInstOperands,
     /* 111972 */     // GIR_Coverage, 5714,
     /* 111972 */     GIR_EraseRootFromParent_Done,
     /* 111973 */   // Label 2109: @111973
     /* 111973 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(112032), // Rule ID 2393 //
     /* 111978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112008 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112030 */     GIR_RootConstrainSelectedInstOperands,
     /* 112031 */     // GIR_Coverage, 2393,
     /* 112031 */     GIR_EraseRootFromParent_Done,
     /* 112032 */   // Label 2110: @112032
     /* 112032 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(112091), // Rule ID 5711 //
     /* 112037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112067 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112089 */     GIR_RootConstrainSelectedInstOperands,
     /* 112090 */     // GIR_Coverage, 5711,
     /* 112090 */     GIR_EraseRootFromParent_Done,
     /* 112091 */   // Label 2111: @112091
     /* 112091 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(112150), // Rule ID 2406 //
     /* 112096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 112111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112126 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 112129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 112135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112148 */     GIR_RootConstrainSelectedInstOperands,
     /* 112149 */     // GIR_Coverage, 2406,
     /* 112149 */     GIR_EraseRootFromParent_Done,
     /* 112150 */   // Label 2112: @112150
     /* 112150 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(112192), // Rule ID 2387 //
     /* 112155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112170 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 112173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112190 */     GIR_RootConstrainSelectedInstOperands,
     /* 112191 */     // GIR_Coverage, 2387,
     /* 112191 */     GIR_EraseRootFromParent_Done,
     /* 112192 */   // Label 2113: @112192
     /* 112192 */   GIM_Reject,
     /* 112193 */ // Label 2107: @112193
     /* 112193 */ GIM_Reject,
     /* 112194 */ // Label 2088: @112194
     /* 112194 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(112373),
     /* 112199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 112205 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 112208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112212 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(112271), // Rule ID 2500 //
     /* 112217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112247 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112252 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112269 */     GIR_RootConstrainSelectedInstOperands,
     /* 112270 */     // GIR_Coverage, 2500,
     /* 112270 */     GIR_EraseRootFromParent_Done,
     /* 112271 */   // Label 2115: @112271
     /* 112271 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(112330), // Rule ID 5754 //
     /* 112276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112306 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112311 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112328 */     GIR_RootConstrainSelectedInstOperands,
     /* 112329 */     // GIR_Coverage, 5754,
     /* 112329 */     GIR_EraseRootFromParent_Done,
     /* 112330 */   // Label 2116: @112330
     /* 112330 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(112372), // Rule ID 2498 //
     /* 112335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112350 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112355 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112370 */     GIR_RootConstrainSelectedInstOperands,
     /* 112371 */     // GIR_Coverage, 2498,
     /* 112371 */     GIR_EraseRootFromParent_Done,
     /* 112372 */   // Label 2117: @112372
     /* 112372 */   GIM_Reject,
     /* 112373 */ // Label 2114: @112373
     /* 112373 */ GIM_Reject,
     /* 112374 */ // Label 2089: @112374
     /* 112374 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(112429), // Rule ID 2496 //
     /* 112379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112388 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112403 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112407 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112412 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112414 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112416 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112421 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112427 */   GIR_RootConstrainSelectedInstOperands,
     /* 112428 */   // GIR_Coverage, 2496,
     /* 112428 */   GIR_EraseRootFromParent_Done,
     /* 112429 */ // Label 2118: @112429
     /* 112429 */ GIM_Reject,
     /* 112430 */ // Label 2090: @112430
     /* 112430 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(112807),
     /* 112435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112444 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(112507), // Rule ID 2501 //
     /* 112449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112483 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112488 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112505 */     GIR_RootConstrainSelectedInstOperands,
     /* 112506 */     // GIR_Coverage, 2501,
     /* 112506 */     GIR_EraseRootFromParent_Done,
     /* 112507 */   // Label 2120: @112507
     /* 112507 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(112576), // Rule ID 3999 //
     /* 112512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112546 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112551 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112557 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112568 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112574 */     GIR_RootConstrainSelectedInstOperands,
     /* 112575 */     // GIR_Coverage, 3999,
     /* 112575 */     GIR_EraseRootFromParent_Done,
     /* 112576 */   // Label 2121: @112576
     /* 112576 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(112639), // Rule ID 5755 //
     /* 112581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112615 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112620 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112637 */     GIR_RootConstrainSelectedInstOperands,
     /* 112638 */     // GIR_Coverage, 5755,
     /* 112638 */     GIR_EraseRootFromParent_Done,
     /* 112639 */   // Label 2122: @112639
     /* 112639 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112708), // Rule ID 6035 //
     /* 112644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112678 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112683 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112689 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112706 */     GIR_RootConstrainSelectedInstOperands,
     /* 112707 */     // GIR_Coverage, 6035,
     /* 112707 */     GIR_EraseRootFromParent_Done,
     /* 112708 */   // Label 2123: @112708
     /* 112708 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112754), // Rule ID 2499 //
     /* 112713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112732 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112737 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112752 */     GIR_RootConstrainSelectedInstOperands,
     /* 112753 */     // GIR_Coverage, 2499,
     /* 112753 */     GIR_EraseRootFromParent_Done,
     /* 112754 */   // Label 2124: @112754
     /* 112754 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112806), // Rule ID 4003 //
     /* 112759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112778 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112783 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112785 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112787 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112804 */     GIR_RootConstrainSelectedInstOperands,
     /* 112805 */     // GIR_Coverage, 4003,
     /* 112805 */     GIR_EraseRootFromParent_Done,
     /* 112806 */   // Label 2125: @112806
     /* 112806 */   GIM_Reject,
     /* 112807 */ // Label 2119: @112807
     /* 112807 */ GIM_Reject,
     /* 112808 */ // Label 2091: @112808
     /* 112808 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(113059),
     /* 112813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112822 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112891), // Rule ID 4009 //
     /* 112827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112861 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112866 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112872 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112889 */     GIR_RootConstrainSelectedInstOperands,
     /* 112890 */     // GIR_Coverage, 4009,
     /* 112890 */     GIR_EraseRootFromParent_Done,
     /* 112891 */   // Label 2127: @112891
     /* 112891 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112960), // Rule ID 6037 //
     /* 112896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112930 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112935 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112941 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112952 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112958 */     GIR_RootConstrainSelectedInstOperands,
     /* 112959 */     // GIR_Coverage, 6037,
     /* 112959 */     GIR_EraseRootFromParent_Done,
     /* 112960 */   // Label 2128: @112960
     /* 112960 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(113006), // Rule ID 2497 //
     /* 112965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112984 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112989 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113004 */     GIR_RootConstrainSelectedInstOperands,
     /* 113005 */     // GIR_Coverage, 2497,
     /* 113005 */     GIR_EraseRootFromParent_Done,
     /* 113006 */   // Label 2129: @113006
     /* 113006 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(113058), // Rule ID 4006 //
     /* 113011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 113014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113030 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 113033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113035 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113037 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 113039 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 113041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113056 */     GIR_RootConstrainSelectedInstOperands,
     /* 113057 */     // GIR_Coverage, 4006,
     /* 113057 */     GIR_EraseRootFromParent_Done,
     /* 113058 */   // Label 2130: @113058
     /* 113058 */   GIM_Reject,
     /* 113059 */ // Label 2126: @113059
     /* 113059 */ GIM_Reject,
     /* 113060 */ // Label 2092: @113060
     /* 113060 */ GIM_Reject,
     /* 113061 */ // Label 37: @113061
     /* 113061 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2134*/ GIMT_Encode4(113225),
     /* 113072 */ /*GILLT_s16*//*Label 2131*/ GIMT_Encode4(113084),
     /* 113076 */ /*GILLT_s32*//*Label 2132*/ GIMT_Encode4(113131),
     /* 113080 */ /*GILLT_s64*//*Label 2133*/ GIMT_Encode4(113178),
     /* 113084 */ // Label 2131: @113084
     /* 113084 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(113130), // Rule ID 620 //
     /* 113089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 113098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113110 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 113113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113115 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113117 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113122 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113128 */   GIR_RootConstrainSelectedInstOperands,
     /* 113129 */   // GIR_Coverage, 620,
     /* 113129 */   GIR_EraseRootFromParent_Done,
     /* 113130 */ // Label 2135: @113130
     /* 113130 */ GIM_Reject,
     /* 113131 */ // Label 2132: @113131
     /* 113131 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113177), // Rule ID 619 //
     /* 113136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 113145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113157 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 113160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113162 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113164 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113169 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113175 */   GIR_RootConstrainSelectedInstOperands,
     /* 113176 */   // GIR_Coverage, 619,
     /* 113176 */   GIR_EraseRootFromParent_Done,
     /* 113177 */ // Label 2136: @113177
     /* 113177 */ GIM_Reject,
     /* 113178 */ // Label 2133: @113178
     /* 113178 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113224), // Rule ID 618 //
     /* 113183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 113192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113204 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 113207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113209 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 113211 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113216 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113222 */   GIR_RootConstrainSelectedInstOperands,
     /* 113223 */   // GIR_Coverage, 618,
     /* 113223 */   GIR_EraseRootFromParent_Done,
     /* 113224 */ // Label 2137: @113224
     /* 113224 */ GIM_Reject,
     /* 113225 */ // Label 2134: @113225
     /* 113225 */ GIM_Reject,
     /* 113226 */ // Label 38: @113226
     /* 113226 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2145*/ GIMT_Encode4(114756),
     /* 113237 */ /*GILLT_s16*//*Label 2138*/ GIMT_Encode4(113289),
     /* 113241 */ /*GILLT_s32*//*Label 2139*/ GIMT_Encode4(113636),
     /* 113245 */ /*GILLT_s64*//*Label 2140*/ GIMT_Encode4(114135), GIMT_Encode4(0),
     /* 113253 */ /*GILLT_v2s32*//*Label 2141*/ GIMT_Encode4(114482), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113265 */ /*GILLT_v4s16*//*Label 2142*/ GIMT_Encode4(114520),
     /* 113269 */ /*GILLT_v4s32*//*Label 2143*/ GIMT_Encode4(114558), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113285 */ /*GILLT_v8s16*//*Label 2144*/ GIMT_Encode4(114657),
     /* 113289 */ // Label 2138: @113289
     /* 113289 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113635),
     /* 113294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113301 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113386), // Rule ID 2411 //
     /* 113306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113325 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113351 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113358 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113384 */     GIR_RootConstrainSelectedInstOperands,
     /* 113385 */     // GIR_Coverage, 2411,
     /* 113385 */     GIR_EraseRootFromParent_Done,
     /* 113386 */   // Label 2147: @113386
     /* 113386 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113471), // Rule ID 5719 //
     /* 113391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113410 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113443 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113469 */     GIR_RootConstrainSelectedInstOperands,
     /* 113470 */     // GIR_Coverage, 5719,
     /* 113470 */     GIR_EraseRootFromParent_Done,
     /* 113471 */   // Label 2148: @113471
     /* 113471 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113544), // Rule ID 2400 //
     /* 113476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113516 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113542 */     GIR_RootConstrainSelectedInstOperands,
     /* 113543 */     // GIR_Coverage, 2400,
     /* 113543 */     GIR_EraseRootFromParent_Done,
     /* 113544 */   // Label 2149: @113544
     /* 113544 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113604), // Rule ID 626 //
     /* 113549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113580 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113602 */     GIR_RootConstrainSelectedInstOperands,
     /* 113603 */     // GIR_Coverage, 626,
     /* 113603 */     GIR_EraseRootFromParent_Done,
     /* 113604 */   // Label 2150: @113604
     /* 113604 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113634), // Rule ID 664 //
     /* 113609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113616 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113626 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113632 */     GIR_RootConstrainSelectedInstOperands,
     /* 113633 */     // GIR_Coverage, 664,
     /* 113633 */     GIR_EraseRootFromParent_Done,
     /* 113634 */   // Label 2151: @113634
     /* 113634 */   GIM_Reject,
     /* 113635 */ // Label 2146: @113635
     /* 113635 */ GIM_Reject,
     /* 113636 */ // Label 2139: @113636
     /* 113636 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(114134),
     /* 113641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113648 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113733), // Rule ID 2410 //
     /* 113653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113672 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113688 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113705 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113725 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113731 */     GIR_RootConstrainSelectedInstOperands,
     /* 113732 */     // GIR_Coverage, 2410,
     /* 113732 */     GIR_EraseRootFromParent_Done,
     /* 113733 */   // Label 2153: @113733
     /* 113733 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113818), // Rule ID 5718 //
     /* 113738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113757 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113790 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113816 */     GIR_RootConstrainSelectedInstOperands,
     /* 113817 */     // GIR_Coverage, 5718,
     /* 113817 */     GIR_EraseRootFromParent_Done,
     /* 113818 */   // Label 2154: @113818
     /* 113818 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113891), // Rule ID 2399 //
     /* 113823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113842 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113863 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113889 */     GIR_RootConstrainSelectedInstOperands,
     /* 113890 */     // GIR_Coverage, 2399,
     /* 113890 */     GIR_EraseRootFromParent_Done,
     /* 113891 */   // Label 2155: @113891
     /* 113891 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113951), // Rule ID 625 //
     /* 113896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113927 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113949 */     GIR_RootConstrainSelectedInstOperands,
     /* 113950 */     // GIR_Coverage, 625,
     /* 113950 */     GIR_EraseRootFromParent_Done,
     /* 113951 */   // Label 2156: @113951
     /* 113951 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113981), // Rule ID 663 //
     /* 113956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113963 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113979 */     GIR_RootConstrainSelectedInstOperands,
     /* 113980 */     // GIR_Coverage, 663,
     /* 113980 */     GIR_EraseRootFromParent_Done,
     /* 113981 */   // Label 2157: @113981
     /* 113981 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(114133), // Rule ID 2702 //
     /* 113986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113993 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 113993 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 113996 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114000 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 114007 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 114010 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114014 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114019 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 114022 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114027 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 114030 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 114034 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114039 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 114042 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 114046 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 114049 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114054 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114059 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114064 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114067 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114071 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114076 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 114079 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 114082 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 114093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114102 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114115 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 114122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114132 */     // GIR_Coverage, 2702,
     /* 114132 */     GIR_EraseRootFromParent_Done,
     /* 114133 */   // Label 2158: @114133
     /* 114133 */   GIM_Reject,
     /* 114134 */ // Label 2152: @114134
     /* 114134 */ GIM_Reject,
     /* 114135 */ // Label 2140: @114135
     /* 114135 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(114481),
     /* 114140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114147 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(114232), // Rule ID 2409 //
     /* 114152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114171 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114204 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114230 */     GIR_RootConstrainSelectedInstOperands,
     /* 114231 */     // GIR_Coverage, 2409,
     /* 114231 */     GIR_EraseRootFromParent_Done,
     /* 114232 */   // Label 2160: @114232
     /* 114232 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(114317), // Rule ID 5717 //
     /* 114237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114256 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114289 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114315 */     GIR_RootConstrainSelectedInstOperands,
     /* 114316 */     // GIR_Coverage, 5717,
     /* 114316 */     GIR_EraseRootFromParent_Done,
     /* 114317 */   // Label 2161: @114317
     /* 114317 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114390), // Rule ID 2398 //
     /* 114322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114341 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114362 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114388 */     GIR_RootConstrainSelectedInstOperands,
     /* 114389 */     // GIR_Coverage, 2398,
     /* 114389 */     GIR_EraseRootFromParent_Done,
     /* 114390 */   // Label 2162: @114390
     /* 114390 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(114450), // Rule ID 624 //
     /* 114395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114426 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114448 */     GIR_RootConstrainSelectedInstOperands,
     /* 114449 */     // GIR_Coverage, 624,
     /* 114449 */     GIR_EraseRootFromParent_Done,
     /* 114450 */   // Label 2163: @114450
     /* 114450 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(114480), // Rule ID 662 //
     /* 114455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114462 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114478 */     GIR_RootConstrainSelectedInstOperands,
     /* 114479 */     // GIR_Coverage, 662,
     /* 114479 */     GIR_EraseRootFromParent_Done,
     /* 114480 */   // Label 2164: @114480
     /* 114480 */   GIM_Reject,
     /* 114481 */ // Label 2159: @114481
     /* 114481 */ GIM_Reject,
     /* 114482 */ // Label 2141: @114482
     /* 114482 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114519), // Rule ID 1527 //
     /* 114487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114501 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114506 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114508 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114511 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114517 */   GIR_RootConstrainSelectedInstOperands,
     /* 114518 */   // GIR_Coverage, 1527,
     /* 114518 */   GIR_EraseRootFromParent_Done,
     /* 114519 */ // Label 2165: @114519
     /* 114519 */ GIM_Reject,
     /* 114520 */ // Label 2142: @114520
     /* 114520 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114557), // Rule ID 1529 //
     /* 114525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114539 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114544 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114549 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114555 */   GIR_RootConstrainSelectedInstOperands,
     /* 114556 */   // GIR_Coverage, 1529,
     /* 114556 */   GIR_EraseRootFromParent_Done,
     /* 114557 */ // Label 2166: @114557
     /* 114557 */ GIM_Reject,
     /* 114558 */ // Label 2143: @114558
     /* 114558 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114656),
     /* 114563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114566 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114600), // Rule ID 1528 //
     /* 114571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114582 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114587 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114598 */     GIR_RootConstrainSelectedInstOperands,
     /* 114599 */     // GIR_Coverage, 1528,
     /* 114599 */     GIR_EraseRootFromParent_Done,
     /* 114600 */   // Label 2168: @114600
     /* 114600 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114655), // Rule ID 4113 //
     /* 114605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114616 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114633 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114638 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114653 */     GIR_RootConstrainSelectedInstOperands,
     /* 114654 */     // GIR_Coverage, 4113,
     /* 114654 */     GIR_EraseRootFromParent_Done,
     /* 114655 */   // Label 2169: @114655
     /* 114655 */   GIM_Reject,
     /* 114656 */ // Label 2167: @114656
     /* 114656 */ GIM_Reject,
     /* 114657 */ // Label 2144: @114657
     /* 114657 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114755),
     /* 114662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114665 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114699), // Rule ID 1530 //
     /* 114670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114681 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114697 */     GIR_RootConstrainSelectedInstOperands,
     /* 114698 */     // GIR_Coverage, 1530,
     /* 114698 */     GIR_EraseRootFromParent_Done,
     /* 114699 */   // Label 2171: @114699
     /* 114699 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114754), // Rule ID 4111 //
     /* 114704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114715 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114732 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114752 */     GIR_RootConstrainSelectedInstOperands,
     /* 114753 */     // GIR_Coverage, 4111,
     /* 114753 */     GIR_EraseRootFromParent_Done,
     /* 114754 */   // Label 2172: @114754
     /* 114754 */   GIM_Reject,
     /* 114755 */ // Label 2170: @114755
     /* 114755 */ GIM_Reject,
     /* 114756 */ // Label 2145: @114756
     /* 114756 */ GIM_Reject,
     /* 114757 */ // Label 39: @114757
     /* 114757 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2176*/ GIMT_Encode4(114992),
     /* 114768 */ /*GILLT_s32*//*Label 2173*/ GIMT_Encode4(114800),
     /* 114772 */ /*GILLT_s64*//*Label 2174*/ GIMT_Encode4(114860), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114796 */ /*GILLT_v4s32*//*Label 2175*/ GIMT_Encode4(114957),
     /* 114800 */ // Label 2173: @114800
     /* 114800 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114859), // Rule ID 2300 //
     /* 114805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114819 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114819 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114822 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114826 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114831 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114857 */   GIR_RootConstrainSelectedInstOperands,
     /* 114858 */   // GIR_Coverage, 2300,
     /* 114858 */   GIR_EraseRootFromParent_Done,
     /* 114859 */ // Label 2177: @114859
     /* 114859 */ GIM_Reject,
     /* 114860 */ // Label 2174: @114860
     /* 114860 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114897), // Rule ID 660 //
     /* 114865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114879 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114884 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114889 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114895 */   GIR_RootConstrainSelectedInstOperands,
     /* 114896 */   // GIR_Coverage, 660,
     /* 114896 */   GIR_EraseRootFromParent_Done,
     /* 114897 */ // Label 2178: @114897
     /* 114897 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114956), // Rule ID 2310 //
     /* 114902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114916 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114928 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114932 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114937 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114940 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114942 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114948 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114954 */   GIR_RootConstrainSelectedInstOperands,
     /* 114955 */   // GIR_Coverage, 2310,
     /* 114955 */   GIR_EraseRootFromParent_Done,
     /* 114956 */ // Label 2179: @114956
     /* 114956 */ GIM_Reject,
     /* 114957 */ // Label 2175: @114957
     /* 114957 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114991), // Rule ID 2667 //
     /* 114962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114973 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114973 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114976 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114978 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114983 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114989 */   GIR_RootConstrainSelectedInstOperands,
     /* 114990 */   // GIR_Coverage, 2667,
     /* 114990 */   GIR_EraseRootFromParent_Done,
     /* 114991 */ // Label 2180: @114991
     /* 114991 */ GIM_Reject,
     /* 114992 */ // Label 2176: @114992
     /* 114992 */ GIM_Reject,
     /* 114993 */ // Label 40: @114993
     /* 114993 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2184*/ GIMT_Encode4(115264),
     /* 115004 */ /*GILLT_s16*//*Label 2181*/ GIMT_Encode4(115036),
     /* 115008 */ /*GILLT_s32*//*Label 2182*/ GIMT_Encode4(115191), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115032 */ /*GILLT_v4s16*//*Label 2183*/ GIMT_Encode4(115229),
     /* 115036 */ // Label 2181: @115036
     /* 115036 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(115113), // Rule ID 2302 //
     /* 115041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 115044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115055 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 115055 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115058 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115062 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115067 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115069 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115072 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 115076 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115081 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115084 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115088 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115091 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115104 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115112 */   // GIR_Coverage, 2302,
     /* 115112 */   GIR_EraseRootFromParent_Done,
     /* 115113 */ // Label 2185: @115113
     /* 115113 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115190), // Rule ID 2312 //
     /* 115118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115132 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 115132 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115135 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115139 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 115153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115158 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115161 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 115165 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115168 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115174 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115181 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115184 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115189 */   // GIR_Coverage, 2312,
     /* 115189 */   GIR_EraseRootFromParent_Done,
     /* 115190 */ // Label 2186: @115190
     /* 115190 */ GIM_Reject,
     /* 115191 */ // Label 2182: @115191
     /* 115191 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115228), // Rule ID 661 //
     /* 115196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115210 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 115210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115215 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115220 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115226 */   GIR_RootConstrainSelectedInstOperands,
     /* 115227 */   // GIR_Coverage, 661,
     /* 115227 */   GIR_EraseRootFromParent_Done,
     /* 115228 */ // Label 2187: @115228
     /* 115228 */ GIM_Reject,
     /* 115229 */ // Label 2183: @115229
     /* 115229 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115263), // Rule ID 2666 //
     /* 115234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115245 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115250 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115255 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115261 */   GIR_RootConstrainSelectedInstOperands,
     /* 115262 */   // GIR_Coverage, 2666,
     /* 115262 */   GIR_EraseRootFromParent_Done,
     /* 115263 */ // Label 2188: @115263
     /* 115263 */ GIM_Reject,
     /* 115264 */ // Label 2184: @115264
     /* 115264 */ GIM_Reject,
     /* 115265 */ // Label 41: @115265
     /* 115265 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2196*/ GIMT_Encode4(116598),
     /* 115276 */ /*GILLT_s32*//*Label 2189*/ GIMT_Encode4(115324), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115288 */ /*GILLT_v2s32*//*Label 2190*/ GIMT_Encode4(116218), GIMT_Encode4(0),
     /* 115296 */ /*GILLT_v4s1*//*Label 2191*/ GIMT_Encode4(116256),
     /* 115300 */ /*GILLT_v4s16*//*Label 2192*/ GIMT_Encode4(116309),
     /* 115304 */ /*GILLT_v4s32*//*Label 2193*/ GIMT_Encode4(116347), GIMT_Encode4(0),
     /* 115312 */ /*GILLT_v8s1*//*Label 2194*/ GIMT_Encode4(116446), GIMT_Encode4(0),
     /* 115320 */ /*GILLT_v8s16*//*Label 2195*/ GIMT_Encode4(116499),
     /* 115324 */ // Label 2189: @115324
     /* 115324 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(115390), // Rule ID 2320 //
     /* 115329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115347 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115351 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115356 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115358 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115370 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115374 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115389 */   // GIR_Coverage, 2320,
     /* 115389 */   GIR_EraseRootFromParent_Done,
     /* 115390 */ // Label 2197: @115390
     /* 115390 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(115456), // Rule ID 2322 //
     /* 115395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115405 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115409 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115413 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115417 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115424 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115424 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115427 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115431 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115436 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115450 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115455 */   // GIR_Coverage, 2322,
     /* 115455 */   GIR_EraseRootFromParent_Done,
     /* 115456 */ // Label 2198: @115456
     /* 115456 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(115522), // Rule ID 2324 //
     /* 115461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115479 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115483 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115490 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115502 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115521 */   // GIR_Coverage, 2324,
     /* 115521 */   GIR_EraseRootFromParent_Done,
     /* 115522 */ // Label 2199: @115522
     /* 115522 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(115588), // Rule ID 2326 //
     /* 115527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115537 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115541 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115545 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115549 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115556 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115568 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115579 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115587 */   // GIR_Coverage, 2326,
     /* 115587 */   GIR_EraseRootFromParent_Done,
     /* 115588 */ // Label 2200: @115588
     /* 115588 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(115654), // Rule ID 2328 //
     /* 115593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115603 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115607 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115611 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115615 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115622 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115622 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115625 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115629 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115634 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115653 */   // GIR_Coverage, 2328,
     /* 115653 */   GIR_EraseRootFromParent_Done,
     /* 115654 */ // Label 2201: @115654
     /* 115654 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(115720), // Rule ID 2330 //
     /* 115659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115669 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115673 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115677 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115681 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115686 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115688 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115700 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115709 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115711 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115719 */   // GIR_Coverage, 2330,
     /* 115719 */   GIR_EraseRootFromParent_Done,
     /* 115720 */ // Label 2202: @115720
     /* 115720 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(115786), // Rule ID 2314 //
     /* 115725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115735 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115739 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115743 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115747 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115754 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115766 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115785 */   // GIR_Coverage, 2314,
     /* 115785 */   GIR_EraseRootFromParent_Done,
     /* 115786 */ // Label 2203: @115786
     /* 115786 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(115852), // Rule ID 2316 //
     /* 115791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115801 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115805 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115809 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115813 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115820 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115820 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115823 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115827 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115832 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115851 */   // GIR_Coverage, 2316,
     /* 115851 */   GIR_EraseRootFromParent_Done,
     /* 115852 */ // Label 2204: @115852
     /* 115852 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(115918), // Rule ID 2318 //
     /* 115857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115867 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115871 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115875 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115879 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115884 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115886 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115898 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115917 */   // GIR_Coverage, 2318,
     /* 115917 */   GIR_EraseRootFromParent_Done,
     /* 115918 */ // Label 2205: @115918
     /* 115918 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115978), // Rule ID 2349 //
     /* 115923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115933 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115937 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115937 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115940 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115944 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115949 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115953 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115956 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115972 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115977 */   // GIR_Coverage, 2349,
     /* 115977 */   GIR_EraseRootFromParent_Done,
     /* 115978 */ // Label 2206: @115978
     /* 115978 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(116038), // Rule ID 2353 //
     /* 115983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115993 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115997 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 116004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116009 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116013 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116016 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116037 */   // GIR_Coverage, 2353,
     /* 116037 */   GIR_EraseRootFromParent_Done,
     /* 116038 */ // Label 2207: @116038
     /* 116038 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(116098), // Rule ID 2357 //
     /* 116043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116057 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116057 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116060 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 116064 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116069 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116073 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116076 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116092 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116097 */   // GIR_Coverage, 2357,
     /* 116097 */   GIR_EraseRootFromParent_Done,
     /* 116098 */ // Label 2208: @116098
     /* 116098 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(116217), // Rule ID 2707 //
     /* 116103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116117 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116117 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116120 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116124 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116131 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116134 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116138 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116143 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116146 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116150 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 116153 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116158 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116163 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 116171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116180 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116183 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116186 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116192 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116199 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 116206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116211 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116216 */   // GIR_Coverage, 2707,
     /* 116216 */   GIR_EraseRootFromParent_Done,
     /* 116217 */ // Label 2209: @116217
     /* 116217 */ GIM_Reject,
     /* 116218 */ // Label 2190: @116218
     /* 116218 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(116255), // Rule ID 1601 //
     /* 116223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116237 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116242 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116247 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116253 */   GIR_RootConstrainSelectedInstOperands,
     /* 116254 */   // GIR_Coverage, 1601,
     /* 116254 */   GIR_EraseRootFromParent_Done,
     /* 116255 */ // Label 2210: @116255
     /* 116255 */ GIM_Reject,
     /* 116256 */ // Label 2191: @116256
     /* 116256 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(116308), // Rule ID 5102 //
     /* 116261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116275 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116280 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116282 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116288 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116291 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116294 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116300 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116306 */   GIR_RootConstrainSelectedInstOperands,
     /* 116307 */   // GIR_Coverage, 5102,
     /* 116307 */   GIR_EraseRootFromParent_Done,
     /* 116308 */ // Label 2211: @116308
     /* 116308 */ GIM_Reject,
     /* 116309 */ // Label 2192: @116309
     /* 116309 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(116346), // Rule ID 1609 //
     /* 116314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116328 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116333 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116338 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116344 */   GIR_RootConstrainSelectedInstOperands,
     /* 116345 */   // GIR_Coverage, 1609,
     /* 116345 */   GIR_EraseRootFromParent_Done,
     /* 116346 */ // Label 2212: @116346
     /* 116346 */ GIM_Reject,
     /* 116347 */ // Label 2193: @116347
     /* 116347 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(116445),
     /* 116352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116355 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(116389), // Rule ID 1605 //
     /* 116360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116371 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116387 */     GIR_RootConstrainSelectedInstOperands,
     /* 116388 */     // GIR_Coverage, 1605,
     /* 116388 */     GIR_EraseRootFromParent_Done,
     /* 116389 */   // Label 2214: @116389
     /* 116389 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(116444), // Rule ID 4091 //
     /* 116394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116405 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116422 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116442 */     GIR_RootConstrainSelectedInstOperands,
     /* 116443 */     // GIR_Coverage, 4091,
     /* 116443 */     GIR_EraseRootFromParent_Done,
     /* 116444 */   // Label 2215: @116444
     /* 116444 */   GIM_Reject,
     /* 116445 */ // Label 2213: @116445
     /* 116445 */ GIM_Reject,
     /* 116446 */ // Label 2194: @116446
     /* 116446 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(116498), // Rule ID 5103 //
     /* 116451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116465 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116470 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116484 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116496 */   GIR_RootConstrainSelectedInstOperands,
     /* 116497 */   // GIR_Coverage, 5103,
     /* 116497 */   GIR_EraseRootFromParent_Done,
     /* 116498 */ // Label 2216: @116498
     /* 116498 */ GIM_Reject,
     /* 116499 */ // Label 2195: @116499
     /* 116499 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116597),
     /* 116504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116507 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116541), // Rule ID 1613 //
     /* 116512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116523 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116539 */     GIR_RootConstrainSelectedInstOperands,
     /* 116540 */     // GIR_Coverage, 1613,
     /* 116540 */     GIR_EraseRootFromParent_Done,
     /* 116541 */   // Label 2218: @116541
     /* 116541 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116596), // Rule ID 4087 //
     /* 116546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116557 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116574 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116594 */     GIR_RootConstrainSelectedInstOperands,
     /* 116595 */     // GIR_Coverage, 4087,
     /* 116595 */     GIR_EraseRootFromParent_Done,
     /* 116596 */   // Label 2219: @116596
     /* 116596 */   GIM_Reject,
     /* 116597 */ // Label 2217: @116597
     /* 116597 */ GIM_Reject,
     /* 116598 */ // Label 2196: @116598
     /* 116598 */ GIM_Reject,
     /* 116599 */ // Label 42: @116599
     /* 116599 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2227*/ GIMT_Encode4(117932),
     /* 116610 */ /*GILLT_s32*//*Label 2220*/ GIMT_Encode4(116658), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116622 */ /*GILLT_v2s32*//*Label 2221*/ GIMT_Encode4(117552), GIMT_Encode4(0),
     /* 116630 */ /*GILLT_v4s1*//*Label 2222*/ GIMT_Encode4(117590),
     /* 116634 */ /*GILLT_v4s16*//*Label 2223*/ GIMT_Encode4(117643),
     /* 116638 */ /*GILLT_v4s32*//*Label 2224*/ GIMT_Encode4(117681), GIMT_Encode4(0),
     /* 116646 */ /*GILLT_v8s1*//*Label 2225*/ GIMT_Encode4(117780), GIMT_Encode4(0),
     /* 116654 */ /*GILLT_v8s16*//*Label 2226*/ GIMT_Encode4(117833),
     /* 116658 */ // Label 2220: @116658
     /* 116658 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(116724), // Rule ID 2321 //
     /* 116663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116681 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116685 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116690 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116692 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116704 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116723 */   // GIR_Coverage, 2321,
     /* 116723 */   GIR_EraseRootFromParent_Done,
     /* 116724 */ // Label 2228: @116724
     /* 116724 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(116790), // Rule ID 2323 //
     /* 116729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116739 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116743 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116747 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116751 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116756 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116758 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116758 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116761 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116765 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116770 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116784 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116789 */   // GIR_Coverage, 2323,
     /* 116789 */   GIR_EraseRootFromParent_Done,
     /* 116790 */ // Label 2229: @116790
     /* 116790 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(116856), // Rule ID 2325 //
     /* 116795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116813 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116817 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116822 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116824 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116836 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116850 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116855 */   // GIR_Coverage, 2325,
     /* 116855 */   GIR_EraseRootFromParent_Done,
     /* 116856 */ // Label 2230: @116856
     /* 116856 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(116922), // Rule ID 2327 //
     /* 116861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116871 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116875 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116879 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116883 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116890 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116902 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116916 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116921 */   // GIR_Coverage, 2327,
     /* 116921 */   GIR_EraseRootFromParent_Done,
     /* 116922 */ // Label 2231: @116922
     /* 116922 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(116988), // Rule ID 2329 //
     /* 116927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116949 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116956 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116968 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116972 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116987 */   // GIR_Coverage, 2329,
     /* 116987 */   GIR_EraseRootFromParent_Done,
     /* 116988 */ // Label 2232: @116988
     /* 116988 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(117054), // Rule ID 2331 //
     /* 116993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117011 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117015 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117022 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 117029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117034 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117048 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117053 */   // GIR_Coverage, 2331,
     /* 117053 */   GIR_EraseRootFromParent_Done,
     /* 117054 */ // Label 2233: @117054
     /* 117054 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(117120), // Rule ID 2315 //
     /* 117059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117069 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117073 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117077 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 117081 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117086 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117088 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 117095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117100 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117111 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117114 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117119 */   // GIR_Coverage, 2315,
     /* 117119 */   GIR_EraseRootFromParent_Done,
     /* 117120 */ // Label 2234: @117120
     /* 117120 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(117186), // Rule ID 2317 //
     /* 117125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117143 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117147 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117152 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117154 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 117161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117166 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117180 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117185 */   // GIR_Coverage, 2317,
     /* 117185 */   GIR_EraseRootFromParent_Done,
     /* 117186 */ // Label 2235: @117186
     /* 117186 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(117252), // Rule ID 2319 //
     /* 117191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117201 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117209 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117213 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117220 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117232 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117246 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117251 */   // GIR_Coverage, 2319,
     /* 117251 */   GIR_EraseRootFromParent_Done,
     /* 117252 */ // Label 2236: @117252
     /* 117252 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(117312), // Rule ID 2359 //
     /* 117257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117271 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117283 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117287 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117290 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117306 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117311 */   // GIR_Coverage, 2359,
     /* 117311 */   GIR_EraseRootFromParent_Done,
     /* 117312 */ // Label 2237: @117312
     /* 117312 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(117372), // Rule ID 2363 //
     /* 117317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117331 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117343 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117347 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117350 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117363 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117366 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117371 */   // GIR_Coverage, 2363,
     /* 117371 */   GIR_EraseRootFromParent_Done,
     /* 117372 */ // Label 2238: @117372
     /* 117372 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(117432), // Rule ID 2367 //
     /* 117377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117391 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117407 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117410 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117431 */   // GIR_Coverage, 2367,
     /* 117431 */   GIR_EraseRootFromParent_Done,
     /* 117432 */ // Label 2239: @117432
     /* 117432 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(117551), // Rule ID 2708 //
     /* 117437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117451 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117451 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117454 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117458 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117465 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117468 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117472 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117477 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117480 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117484 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117487 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117492 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117497 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117502 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117505 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117509 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117514 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117517 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117520 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117533 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117540 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117550 */   // GIR_Coverage, 2708,
     /* 117550 */   GIR_EraseRootFromParent_Done,
     /* 117551 */ // Label 2240: @117551
     /* 117551 */ GIM_Reject,
     /* 117552 */ // Label 2221: @117552
     /* 117552 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(117589), // Rule ID 1602 //
     /* 117557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117571 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117576 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117581 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117587 */   GIR_RootConstrainSelectedInstOperands,
     /* 117588 */   // GIR_Coverage, 1602,
     /* 117588 */   GIR_EraseRootFromParent_Done,
     /* 117589 */ // Label 2241: @117589
     /* 117589 */ GIM_Reject,
     /* 117590 */ // Label 2222: @117590
     /* 117590 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(117642), // Rule ID 5100 //
     /* 117595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117609 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117614 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117616 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117628 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117634 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117640 */   GIR_RootConstrainSelectedInstOperands,
     /* 117641 */   // GIR_Coverage, 5100,
     /* 117641 */   GIR_EraseRootFromParent_Done,
     /* 117642 */ // Label 2242: @117642
     /* 117642 */ GIM_Reject,
     /* 117643 */ // Label 2223: @117643
     /* 117643 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117680), // Rule ID 1610 //
     /* 117648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117662 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117678 */   GIR_RootConstrainSelectedInstOperands,
     /* 117679 */   // GIR_Coverage, 1610,
     /* 117679 */   GIR_EraseRootFromParent_Done,
     /* 117680 */ // Label 2243: @117680
     /* 117680 */ GIM_Reject,
     /* 117681 */ // Label 2224: @117681
     /* 117681 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(117779),
     /* 117686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117689 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(117723), // Rule ID 1606 //
     /* 117694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117705 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117721 */     GIR_RootConstrainSelectedInstOperands,
     /* 117722 */     // GIR_Coverage, 1606,
     /* 117722 */     GIR_EraseRootFromParent_Done,
     /* 117723 */   // Label 2245: @117723
     /* 117723 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117778), // Rule ID 4093 //
     /* 117728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117739 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117756 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117776 */     GIR_RootConstrainSelectedInstOperands,
     /* 117777 */     // GIR_Coverage, 4093,
     /* 117777 */     GIR_EraseRootFromParent_Done,
     /* 117778 */   // Label 2246: @117778
     /* 117778 */   GIM_Reject,
     /* 117779 */ // Label 2244: @117779
     /* 117779 */ GIM_Reject,
     /* 117780 */ // Label 2225: @117780
     /* 117780 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117832), // Rule ID 5101 //
     /* 117785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117799 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117804 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117806 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117818 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117830 */   GIR_RootConstrainSelectedInstOperands,
     /* 117831 */   // GIR_Coverage, 5101,
     /* 117831 */   GIR_EraseRootFromParent_Done,
     /* 117832 */ // Label 2247: @117832
     /* 117832 */ GIM_Reject,
     /* 117833 */ // Label 2226: @117833
     /* 117833 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117931),
     /* 117838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117841 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117875), // Rule ID 1614 //
     /* 117846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117857 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117873 */     GIR_RootConstrainSelectedInstOperands,
     /* 117874 */     // GIR_Coverage, 1614,
     /* 117874 */     GIR_EraseRootFromParent_Done,
     /* 117875 */   // Label 2249: @117875
     /* 117875 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117930), // Rule ID 4089 //
     /* 117880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117891 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117908 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117928 */     GIR_RootConstrainSelectedInstOperands,
     /* 117929 */     // GIR_Coverage, 4089,
     /* 117929 */     GIR_EraseRootFromParent_Done,
     /* 117930 */   // Label 2250: @117930
     /* 117930 */   GIM_Reject,
     /* 117931 */ // Label 2248: @117931
     /* 117931 */ GIM_Reject,
     /* 117932 */ // Label 2227: @117932
     /* 117932 */ GIM_Reject,
     /* 117933 */ // Label 43: @117933
     /* 117933 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2258*/ GIMT_Encode4(118584),
     /* 117944 */ /*GILLT_s16*//*Label 2251*/ GIMT_Encode4(117996),
     /* 117948 */ /*GILLT_s32*//*Label 2252*/ GIMT_Encode4(118056),
     /* 117952 */ /*GILLT_s64*//*Label 2253*/ GIMT_Encode4(118250), GIMT_Encode4(0),
     /* 117960 */ /*GILLT_v2s32*//*Label 2254*/ GIMT_Encode4(118310), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117972 */ /*GILLT_v4s16*//*Label 2255*/ GIMT_Encode4(118348),
     /* 117976 */ /*GILLT_v4s32*//*Label 2256*/ GIMT_Encode4(118386), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117992 */ /*GILLT_v8s16*//*Label 2257*/ GIMT_Encode4(118485),
     /* 117996 */ // Label 2251: @117996
     /* 117996 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(118055), // Rule ID 2343 //
     /* 118001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118015 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118027 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 118039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118047 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118053 */   GIR_RootConstrainSelectedInstOperands,
     /* 118054 */   // GIR_Coverage, 2343,
     /* 118054 */   GIR_EraseRootFromParent_Done,
     /* 118055 */ // Label 2259: @118055
     /* 118055 */ GIM_Reject,
     /* 118056 */ // Label 2252: @118056
     /* 118056 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(118249),
     /* 118061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118072 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(118120), // Rule ID 2341 //
     /* 118077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118080 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 118104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118118 */     GIR_RootConstrainSelectedInstOperands,
     /* 118119 */     // GIR_Coverage, 2341,
     /* 118119 */     GIR_EraseRootFromParent_Done,
     /* 118120 */   // Label 2261: @118120
     /* 118120 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(118248), // Rule ID 2709 //
     /* 118125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118128 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118128 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118131 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118135 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118140 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118144 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118149 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118152 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118156 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118175 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118178 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118181 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118184 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118194 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118211 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118214 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118217 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118230 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118247 */     // GIR_Coverage, 2709,
     /* 118247 */     GIR_EraseRootFromParent_Done,
     /* 118248 */   // Label 2262: @118248
     /* 118248 */   GIM_Reject,
     /* 118249 */ // Label 2260: @118249
     /* 118249 */ GIM_Reject,
     /* 118250 */ // Label 2253: @118250
     /* 118250 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(118309), // Rule ID 2339 //
     /* 118255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118269 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118281 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118285 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118301 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118307 */   GIR_RootConstrainSelectedInstOperands,
     /* 118308 */   // GIR_Coverage, 2339,
     /* 118308 */   GIR_EraseRootFromParent_Done,
     /* 118309 */ // Label 2263: @118309
     /* 118309 */ GIM_Reject,
     /* 118310 */ // Label 2254: @118310
     /* 118310 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(118347), // Rule ID 1603 //
     /* 118315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118329 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118334 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118339 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118345 */   GIR_RootConstrainSelectedInstOperands,
     /* 118346 */   // GIR_Coverage, 1603,
     /* 118346 */   GIR_EraseRootFromParent_Done,
     /* 118347 */ // Label 2264: @118347
     /* 118347 */ GIM_Reject,
     /* 118348 */ // Label 2255: @118348
     /* 118348 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(118385), // Rule ID 1611 //
     /* 118353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118367 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118372 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118377 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118383 */   GIR_RootConstrainSelectedInstOperands,
     /* 118384 */   // GIR_Coverage, 1611,
     /* 118384 */   GIR_EraseRootFromParent_Done,
     /* 118385 */ // Label 2265: @118385
     /* 118385 */ GIM_Reject,
     /* 118386 */ // Label 2256: @118386
     /* 118386 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(118484),
     /* 118391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118394 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(118428), // Rule ID 1607 //
     /* 118399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118410 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118426 */     GIR_RootConstrainSelectedInstOperands,
     /* 118427 */     // GIR_Coverage, 1607,
     /* 118427 */     GIR_EraseRootFromParent_Done,
     /* 118428 */   // Label 2267: @118428
     /* 118428 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(118483), // Rule ID 4099 //
     /* 118433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118444 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118481 */     GIR_RootConstrainSelectedInstOperands,
     /* 118482 */     // GIR_Coverage, 4099,
     /* 118482 */     GIR_EraseRootFromParent_Done,
     /* 118483 */   // Label 2268: @118483
     /* 118483 */   GIM_Reject,
     /* 118484 */ // Label 2266: @118484
     /* 118484 */ GIM_Reject,
     /* 118485 */ // Label 2257: @118485
     /* 118485 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(118583),
     /* 118490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118493 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118527), // Rule ID 1615 //
     /* 118498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118509 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118525 */     GIR_RootConstrainSelectedInstOperands,
     /* 118526 */     // GIR_Coverage, 1615,
     /* 118526 */     GIR_EraseRootFromParent_Done,
     /* 118527 */   // Label 2270: @118527
     /* 118527 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(118582), // Rule ID 4095 //
     /* 118532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118543 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118580 */     GIR_RootConstrainSelectedInstOperands,
     /* 118581 */     // GIR_Coverage, 4095,
     /* 118581 */     GIR_EraseRootFromParent_Done,
     /* 118582 */   // Label 2271: @118582
     /* 118582 */   GIM_Reject,
     /* 118583 */ // Label 2269: @118583
     /* 118583 */ GIM_Reject,
     /* 118584 */ // Label 2258: @118584
     /* 118584 */ GIM_Reject,
     /* 118585 */ // Label 44: @118585
     /* 118585 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2279*/ GIMT_Encode4(119236),
     /* 118596 */ /*GILLT_s16*//*Label 2272*/ GIMT_Encode4(118648),
     /* 118600 */ /*GILLT_s32*//*Label 2273*/ GIMT_Encode4(118708),
     /* 118604 */ /*GILLT_s64*//*Label 2274*/ GIMT_Encode4(118902), GIMT_Encode4(0),
     /* 118612 */ /*GILLT_v2s32*//*Label 2275*/ GIMT_Encode4(118962), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118624 */ /*GILLT_v4s16*//*Label 2276*/ GIMT_Encode4(119000),
     /* 118628 */ /*GILLT_v4s32*//*Label 2277*/ GIMT_Encode4(119038), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118644 */ /*GILLT_v8s16*//*Label 2278*/ GIMT_Encode4(119137),
     /* 118648 */ // Label 2272: @118648
     /* 118648 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(118707), // Rule ID 2348 //
     /* 118653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118667 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118667 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118670 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118674 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118679 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118699 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118705 */   GIR_RootConstrainSelectedInstOperands,
     /* 118706 */   // GIR_Coverage, 2348,
     /* 118706 */   GIR_EraseRootFromParent_Done,
     /* 118707 */ // Label 2280: @118707
     /* 118707 */ GIM_Reject,
     /* 118708 */ // Label 2273: @118708
     /* 118708 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(118901),
     /* 118713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118724 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(118772), // Rule ID 2346 //
     /* 118729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118732 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118744 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118770 */     GIR_RootConstrainSelectedInstOperands,
     /* 118771 */     // GIR_Coverage, 2346,
     /* 118771 */     GIR_EraseRootFromParent_Done,
     /* 118772 */   // Label 2282: @118772
     /* 118772 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(118900), // Rule ID 2710 //
     /* 118777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118780 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118780 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118783 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118787 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118792 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118796 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118801 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118804 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118808 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118815 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118818 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118822 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118827 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118830 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118833 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118846 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118863 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118866 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118869 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118882 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118894 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118899 */     // GIR_Coverage, 2710,
     /* 118899 */     GIR_EraseRootFromParent_Done,
     /* 118900 */   // Label 2283: @118900
     /* 118900 */   GIM_Reject,
     /* 118901 */ // Label 2281: @118901
     /* 118901 */ GIM_Reject,
     /* 118902 */ // Label 2274: @118902
     /* 118902 */ GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(118961), // Rule ID 2344 //
     /* 118907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118921 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118921 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118924 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118928 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118933 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118937 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118947 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118953 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118959 */   GIR_RootConstrainSelectedInstOperands,
     /* 118960 */   // GIR_Coverage, 2344,
     /* 118960 */   GIR_EraseRootFromParent_Done,
     /* 118961 */ // Label 2284: @118961
     /* 118961 */ GIM_Reject,
     /* 118962 */ // Label 2275: @118962
     /* 118962 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(118999), // Rule ID 1604 //
     /* 118967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118981 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118986 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118991 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118997 */   GIR_RootConstrainSelectedInstOperands,
     /* 118998 */   // GIR_Coverage, 1604,
     /* 118998 */   GIR_EraseRootFromParent_Done,
     /* 118999 */ // Label 2285: @118999
     /* 118999 */ GIM_Reject,
     /* 119000 */ // Label 2276: @119000
     /* 119000 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(119037), // Rule ID 1612 //
     /* 119005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119019 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 119019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 119022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119024 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119035 */   GIR_RootConstrainSelectedInstOperands,
     /* 119036 */   // GIR_Coverage, 1612,
     /* 119036 */   GIR_EraseRootFromParent_Done,
     /* 119037 */ // Label 2286: @119037
     /* 119037 */ GIM_Reject,
     /* 119038 */ // Label 2277: @119038
     /* 119038 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(119136),
     /* 119043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119046 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(119080), // Rule ID 1608 //
     /* 119051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119062 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 119062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 119065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119072 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119078 */     GIR_RootConstrainSelectedInstOperands,
     /* 119079 */     // GIR_Coverage, 1608,
     /* 119079 */     GIR_EraseRootFromParent_Done,
     /* 119080 */   // Label 2288: @119080
     /* 119080 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(119135), // Rule ID 4101 //
     /* 119085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119096 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 119096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 119111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119113 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119118 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119133 */     GIR_RootConstrainSelectedInstOperands,
     /* 119134 */     // GIR_Coverage, 4101,
     /* 119134 */     GIR_EraseRootFromParent_Done,
     /* 119135 */   // Label 2289: @119135
     /* 119135 */   GIM_Reject,
     /* 119136 */ // Label 2287: @119136
     /* 119136 */ GIM_Reject,
     /* 119137 */ // Label 2278: @119137
     /* 119137 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(119235),
     /* 119142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119145 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(119179), // Rule ID 1616 //
     /* 119150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119161 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 119161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 119164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119177 */     GIR_RootConstrainSelectedInstOperands,
     /* 119178 */     // GIR_Coverage, 1616,
     /* 119178 */     GIR_EraseRootFromParent_Done,
     /* 119179 */   // Label 2291: @119179
     /* 119179 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(119234), // Rule ID 4097 //
     /* 119184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119195 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 119195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 119210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119212 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119217 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119232 */     GIR_RootConstrainSelectedInstOperands,
     /* 119233 */     // GIR_Coverage, 4097,
     /* 119233 */     GIR_EraseRootFromParent_Done,
     /* 119234 */   // Label 2292: @119234
     /* 119234 */   GIM_Reject,
     /* 119235 */ // Label 2290: @119235
     /* 119235 */ GIM_Reject,
     /* 119236 */ // Label 2279: @119236
     /* 119236 */ GIM_Reject,
     /* 119237 */ // Label 45: @119237
     /* 119237 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2300*/ GIMT_Encode4(120012),
     /* 119248 */ /*GILLT_s16*//*Label 2293*/ GIMT_Encode4(119300),
     /* 119252 */ /*GILLT_s32*//*Label 2294*/ GIMT_Encode4(119338),
     /* 119256 */ /*GILLT_s64*//*Label 2295*/ GIMT_Encode4(119530), GIMT_Encode4(0),
     /* 119264 */ /*GILLT_v2s32*//*Label 2296*/ GIMT_Encode4(119568), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119276 */ /*GILLT_v4s16*//*Label 2297*/ GIMT_Encode4(119606),
     /* 119280 */ /*GILLT_v4s32*//*Label 2298*/ GIMT_Encode4(119644), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119296 */ /*GILLT_v8s16*//*Label 2299*/ GIMT_Encode4(119828),
     /* 119300 */ // Label 2293: @119300
     /* 119300 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(119337), // Rule ID 653 //
     /* 119305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119319 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119324 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119335 */   GIR_RootConstrainSelectedInstOperands,
     /* 119336 */   // GIR_Coverage, 653,
     /* 119336 */   GIR_EraseRootFromParent_Done,
     /* 119337 */ // Label 2301: @119337
     /* 119337 */ GIM_Reject,
     /* 119338 */ // Label 2294: @119338
     /* 119338 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(119529),
     /* 119343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119354 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(119380), // Rule ID 652 //
     /* 119359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119362 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119378 */     GIR_RootConstrainSelectedInstOperands,
     /* 119379 */     // GIR_Coverage, 652,
     /* 119379 */     GIR_EraseRootFromParent_Done,
     /* 119380 */   // Label 2303: @119380
     /* 119380 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(119528), // Rule ID 2701 //
     /* 119385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119388 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119388 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119391 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119395 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119402 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119405 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119409 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119414 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119417 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119422 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119425 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119429 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119434 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119437 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119441 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119444 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119449 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119454 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119459 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119462 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119466 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119471 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119474 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119477 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119497 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119510 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119527 */     // GIR_Coverage, 2701,
     /* 119527 */     GIR_EraseRootFromParent_Done,
     /* 119528 */   // Label 2304: @119528
     /* 119528 */   GIM_Reject,
     /* 119529 */ // Label 2302: @119529
     /* 119529 */ GIM_Reject,
     /* 119530 */ // Label 2295: @119530
     /* 119530 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(119567), // Rule ID 651 //
     /* 119535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119549 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119554 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119559 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119565 */   GIR_RootConstrainSelectedInstOperands,
     /* 119566 */   // GIR_Coverage, 651,
     /* 119566 */   GIR_EraseRootFromParent_Done,
     /* 119567 */ // Label 2305: @119567
     /* 119567 */ GIM_Reject,
     /* 119568 */ // Label 2296: @119568
     /* 119568 */ GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(119605), // Rule ID 1511 //
     /* 119573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119587 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119592 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119597 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119603 */   GIR_RootConstrainSelectedInstOperands,
     /* 119604 */   // GIR_Coverage, 1511,
     /* 119604 */   GIR_EraseRootFromParent_Done,
     /* 119605 */ // Label 2306: @119605
     /* 119605 */ GIM_Reject,
     /* 119606 */ // Label 2297: @119606
     /* 119606 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(119643), // Rule ID 1513 //
     /* 119611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119625 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119630 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119635 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119641 */   GIR_RootConstrainSelectedInstOperands,
     /* 119642 */   // GIR_Coverage, 1513,
     /* 119642 */   GIR_EraseRootFromParent_Done,
     /* 119643 */ // Label 2307: @119643
     /* 119643 */ GIM_Reject,
     /* 119644 */ // Label 2298: @119644
     /* 119644 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(119827),
     /* 119649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119652 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(119737), // Rule ID 4038 //
     /* 119657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119692 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119735 */     GIR_RootConstrainSelectedInstOperands,
     /* 119736 */     // GIR_Coverage, 4038,
     /* 119736 */     GIR_EraseRootFromParent_Done,
     /* 119737 */   // Label 2309: @119737
     /* 119737 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(119771), // Rule ID 1512 //
     /* 119742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119753 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119769 */     GIR_RootConstrainSelectedInstOperands,
     /* 119770 */     // GIR_Coverage, 1512,
     /* 119770 */     GIR_EraseRootFromParent_Done,
     /* 119771 */   // Label 2310: @119771
     /* 119771 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119826), // Rule ID 4109 //
     /* 119776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119787 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119804 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119809 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119824 */     GIR_RootConstrainSelectedInstOperands,
     /* 119825 */     // GIR_Coverage, 4109,
     /* 119825 */     GIR_EraseRootFromParent_Done,
     /* 119826 */   // Label 2311: @119826
     /* 119826 */   GIM_Reject,
     /* 119827 */ // Label 2308: @119827
     /* 119827 */ GIM_Reject,
     /* 119828 */ // Label 2299: @119828
     /* 119828 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(120011),
     /* 119833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119836 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119921), // Rule ID 4037 //
     /* 119841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119876 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119904 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119919 */     GIR_RootConstrainSelectedInstOperands,
     /* 119920 */     // GIR_Coverage, 4037,
     /* 119920 */     GIR_EraseRootFromParent_Done,
     /* 119921 */   // Label 2313: @119921
     /* 119921 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119955), // Rule ID 1514 //
     /* 119926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119937 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119942 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119953 */     GIR_RootConstrainSelectedInstOperands,
     /* 119954 */     // GIR_Coverage, 1514,
     /* 119954 */     GIR_EraseRootFromParent_Done,
     /* 119955 */   // Label 2314: @119955
     /* 119955 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(120010), // Rule ID 4107 //
     /* 119960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119971 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119988 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120008 */     GIR_RootConstrainSelectedInstOperands,
     /* 120009 */     // GIR_Coverage, 4107,
     /* 120009 */     GIR_EraseRootFromParent_Done,
     /* 120010 */   // Label 2315: @120010
     /* 120010 */   GIM_Reject,
     /* 120011 */ // Label 2312: @120011
     /* 120011 */ GIM_Reject,
     /* 120012 */ // Label 2300: @120012
     /* 120012 */ GIM_Reject,
     /* 120013 */ // Label 46: @120013
     /* 120013 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2323*/ GIMT_Encode4(120604),
     /* 120024 */ /*GILLT_s16*//*Label 2316*/ GIMT_Encode4(120076),
     /* 120028 */ /*GILLT_s32*//*Label 2317*/ GIMT_Encode4(120110),
     /* 120032 */ /*GILLT_s64*//*Label 2318*/ GIMT_Encode4(120144), GIMT_Encode4(0),
     /* 120040 */ /*GILLT_v2s32*//*Label 2319*/ GIMT_Encode4(120178), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120052 */ /*GILLT_v4s16*//*Label 2320*/ GIMT_Encode4(120212),
     /* 120056 */ /*GILLT_v4s32*//*Label 2321*/ GIMT_Encode4(120246), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120072 */ /*GILLT_v8s16*//*Label 2322*/ GIMT_Encode4(120425),
     /* 120076 */ // Label 2316: @120076
     /* 120076 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(120109), // Rule ID 642 //
     /* 120081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120102 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 120107 */   GIR_RootConstrainSelectedInstOperands,
     /* 120108 */   // GIR_Coverage, 642,
     /* 120108 */   GIR_Done,
     /* 120109 */ // Label 2324: @120109
     /* 120109 */ GIM_Reject,
     /* 120110 */ // Label 2317: @120110
     /* 120110 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(120143), // Rule ID 643 //
     /* 120115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120136 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 120141 */   GIR_RootConstrainSelectedInstOperands,
     /* 120142 */   // GIR_Coverage, 643,
     /* 120142 */   GIR_Done,
     /* 120143 */ // Label 2325: @120143
     /* 120143 */ GIM_Reject,
     /* 120144 */ // Label 2318: @120144
     /* 120144 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(120177), // Rule ID 644 //
     /* 120149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120170 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 120175 */   GIR_RootConstrainSelectedInstOperands,
     /* 120176 */   // GIR_Coverage, 644,
     /* 120176 */   GIR_Done,
     /* 120177 */ // Label 2326: @120177
     /* 120177 */ GIM_Reject,
     /* 120178 */ // Label 2319: @120178
     /* 120178 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(120211), // Rule ID 1230 //
     /* 120183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120204 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120204 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 120209 */   GIR_RootConstrainSelectedInstOperands,
     /* 120210 */   // GIR_Coverage, 1230,
     /* 120210 */   GIR_Done,
     /* 120211 */ // Label 2327: @120211
     /* 120211 */ GIM_Reject,
     /* 120212 */ // Label 2320: @120212
     /* 120212 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(120245), // Rule ID 1232 //
     /* 120217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120238 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120243 */   GIR_RootConstrainSelectedInstOperands,
     /* 120244 */   // GIR_Coverage, 1232,
     /* 120244 */   GIR_Done,
     /* 120245 */ // Label 2328: @120245
     /* 120245 */ GIM_Reject,
     /* 120246 */ // Label 2321: @120246
     /* 120246 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(120424),
     /* 120251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120257 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(120335), // Rule ID 4119 //
     /* 120262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120305 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120333 */     GIR_RootConstrainSelectedInstOperands,
     /* 120334 */     // GIR_Coverage, 4119,
     /* 120334 */     GIR_EraseRootFromParent_Done,
     /* 120335 */   // Label 2330: @120335
     /* 120335 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(120362), // Rule ID 1231 //
     /* 120340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120355 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120360 */     GIR_RootConstrainSelectedInstOperands,
     /* 120361 */     // GIR_Coverage, 1231,
     /* 120361 */     GIR_Done,
     /* 120362 */   // Label 2331: @120362
     /* 120362 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(120423), // Rule ID 3285 //
     /* 120367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120382 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120421 */     GIR_RootConstrainSelectedInstOperands,
     /* 120422 */     // GIR_Coverage, 3285,
     /* 120422 */     GIR_EraseRootFromParent_Done,
     /* 120423 */   // Label 2332: @120423
     /* 120423 */   GIM_Reject,
     /* 120424 */ // Label 2329: @120424
     /* 120424 */ GIM_Reject,
     /* 120425 */ // Label 2322: @120425
     /* 120425 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(120603),
     /* 120430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120436 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(120514), // Rule ID 4121 //
     /* 120441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120484 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120506 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120512 */     GIR_RootConstrainSelectedInstOperands,
     /* 120513 */     // GIR_Coverage, 4121,
     /* 120513 */     GIR_EraseRootFromParent_Done,
     /* 120514 */   // Label 2334: @120514
     /* 120514 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(120541), // Rule ID 1233 //
     /* 120519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120534 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120539 */     GIR_RootConstrainSelectedInstOperands,
     /* 120540 */     // GIR_Coverage, 1233,
     /* 120540 */     GIR_Done,
     /* 120541 */   // Label 2335: @120541
     /* 120541 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(120602), // Rule ID 3288 //
     /* 120546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120561 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120585 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120600 */     GIR_RootConstrainSelectedInstOperands,
     /* 120601 */     // GIR_Coverage, 3288,
     /* 120601 */     GIR_EraseRootFromParent_Done,
     /* 120602 */   // Label 2336: @120602
     /* 120602 */   GIM_Reject,
     /* 120603 */ // Label 2333: @120603
     /* 120603 */ GIM_Reject,
     /* 120604 */ // Label 2323: @120604
     /* 120604 */ GIM_Reject,
     /* 120605 */ // Label 47: @120605
     /* 120605 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2344*/ GIMT_Encode4(121196),
     /* 120616 */ /*GILLT_s16*//*Label 2337*/ GIMT_Encode4(120668),
     /* 120620 */ /*GILLT_s32*//*Label 2338*/ GIMT_Encode4(120702),
     /* 120624 */ /*GILLT_s64*//*Label 2339*/ GIMT_Encode4(120736), GIMT_Encode4(0),
     /* 120632 */ /*GILLT_v2s32*//*Label 2340*/ GIMT_Encode4(120770), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120644 */ /*GILLT_v4s16*//*Label 2341*/ GIMT_Encode4(120804),
     /* 120648 */ /*GILLT_v4s32*//*Label 2342*/ GIMT_Encode4(120838), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120664 */ /*GILLT_v8s16*//*Label 2343*/ GIMT_Encode4(121017),
     /* 120668 */ // Label 2337: @120668
     /* 120668 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(120701), // Rule ID 639 //
     /* 120673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120690 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120694 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120699 */   GIR_RootConstrainSelectedInstOperands,
     /* 120700 */   // GIR_Coverage, 639,
     /* 120700 */   GIR_Done,
     /* 120701 */ // Label 2345: @120701
     /* 120701 */ GIM_Reject,
     /* 120702 */ // Label 2338: @120702
     /* 120702 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(120735), // Rule ID 640 //
     /* 120707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120728 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120733 */   GIR_RootConstrainSelectedInstOperands,
     /* 120734 */   // GIR_Coverage, 640,
     /* 120734 */   GIR_Done,
     /* 120735 */ // Label 2346: @120735
     /* 120735 */ GIM_Reject,
     /* 120736 */ // Label 2339: @120736
     /* 120736 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(120769), // Rule ID 641 //
     /* 120741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120762 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120767 */   GIR_RootConstrainSelectedInstOperands,
     /* 120768 */   // GIR_Coverage, 641,
     /* 120768 */   GIR_Done,
     /* 120769 */ // Label 2347: @120769
     /* 120769 */ GIM_Reject,
     /* 120770 */ // Label 2340: @120770
     /* 120770 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(120803), // Rule ID 1210 //
     /* 120775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120796 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120801 */   GIR_RootConstrainSelectedInstOperands,
     /* 120802 */   // GIR_Coverage, 1210,
     /* 120802 */   GIR_Done,
     /* 120803 */ // Label 2348: @120803
     /* 120803 */ GIM_Reject,
     /* 120804 */ // Label 2341: @120804
     /* 120804 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(120837), // Rule ID 1212 //
     /* 120809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120830 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120835 */   GIR_RootConstrainSelectedInstOperands,
     /* 120836 */   // GIR_Coverage, 1212,
     /* 120836 */   GIR_Done,
     /* 120837 */ // Label 2349: @120837
     /* 120837 */ GIM_Reject,
     /* 120838 */ // Label 2342: @120838
     /* 120838 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(121016),
     /* 120843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120849 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(120927), // Rule ID 4115 //
     /* 120854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120897 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120913 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120925 */     GIR_RootConstrainSelectedInstOperands,
     /* 120926 */     // GIR_Coverage, 4115,
     /* 120926 */     GIR_EraseRootFromParent_Done,
     /* 120927 */   // Label 2351: @120927
     /* 120927 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(120954), // Rule ID 1211 //
     /* 120932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120947 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120947 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120952 */     GIR_RootConstrainSelectedInstOperands,
     /* 120953 */     // GIR_Coverage, 1211,
     /* 120953 */     GIR_Done,
     /* 120954 */   // Label 2352: @120954
     /* 120954 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(121015), // Rule ID 3027 //
     /* 120959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120974 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121013 */     GIR_RootConstrainSelectedInstOperands,
     /* 121014 */     // GIR_Coverage, 3027,
     /* 121014 */     GIR_EraseRootFromParent_Done,
     /* 121015 */   // Label 2353: @121015
     /* 121015 */   GIM_Reject,
     /* 121016 */ // Label 2350: @121016
     /* 121016 */ GIM_Reject,
     /* 121017 */ // Label 2343: @121017
     /* 121017 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(121195),
     /* 121022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121028 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(121106), // Rule ID 4117 //
     /* 121033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 121036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121076 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 121076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 121079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121098 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121104 */     GIR_RootConstrainSelectedInstOperands,
     /* 121105 */     // GIR_Coverage, 4117,
     /* 121105 */     GIR_EraseRootFromParent_Done,
     /* 121106 */   // Label 2355: @121106
     /* 121106 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(121133), // Rule ID 1213 //
     /* 121111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 121114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121126 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 121131 */     GIR_RootConstrainSelectedInstOperands,
     /* 121132 */     // GIR_Coverage, 1213,
     /* 121132 */     GIR_Done,
     /* 121133 */   // Label 2356: @121133
     /* 121133 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(121194), // Rule ID 3282 //
     /* 121138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121153 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 121153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 121168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121192 */     GIR_RootConstrainSelectedInstOperands,
     /* 121193 */     // GIR_Coverage, 3282,
     /* 121193 */     GIR_EraseRootFromParent_Done,
     /* 121194 */   // Label 2357: @121194
     /* 121194 */   GIM_Reject,
     /* 121195 */ // Label 2354: @121195
     /* 121195 */ GIM_Reject,
     /* 121196 */ // Label 2344: @121196
     /* 121196 */ GIM_Reject,
     /* 121197 */ // Label 48: @121197
     /* 121197 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2364*/ GIMT_Encode4(121930),
     /* 121208 */ /*GILLT_s16*//*Label 2358*/ GIMT_Encode4(121260),
     /* 121212 */ /*GILLT_s32*//*Label 2359*/ GIMT_Encode4(121501), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121224 */ /*GILLT_v2s32*//*Label 2360*/ GIMT_Encode4(121742), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121236 */ /*GILLT_v4s16*//*Label 2361*/ GIMT_Encode4(121789),
     /* 121240 */ /*GILLT_v4s32*//*Label 2362*/ GIMT_Encode4(121836), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121256 */ /*GILLT_v8s16*//*Label 2363*/ GIMT_Encode4(121883),
     /* 121260 */ // Label 2358: @121260
     /* 121260 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(121500), // Rule ID 2704 //
     /* 121265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121286 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121286 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121289 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121293 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121298 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121300 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121303 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121307 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121312 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121315 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121320 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121323 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121327 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121332 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121335 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121339 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121342 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121347 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121352 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121357 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121360 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121364 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121369 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121371 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121374 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121378 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121383 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121386 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121391 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121394 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121398 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121403 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121406 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121410 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121413 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121418 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121423 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121428 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121431 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121435 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121440 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121443 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121446 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121449 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121455 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121469 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121482 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121489 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121494 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121499 */   // GIR_Coverage, 2704,
     /* 121499 */   GIR_EraseRootFromParent_Done,
     /* 121500 */ // Label 2365: @121500
     /* 121500 */ GIM_Reject,
     /* 121501 */ // Label 2359: @121501
     /* 121501 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(121741), // Rule ID 2706 //
     /* 121506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121523 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121527 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121527 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121530 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121534 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121541 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121544 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121548 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121553 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121556 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121561 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121564 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121568 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121573 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121576 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121580 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121583 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121588 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121593 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121598 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121601 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121605 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121612 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121615 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121619 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121624 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121627 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121632 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121635 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121639 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121644 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121647 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121651 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121654 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121659 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121664 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121669 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121672 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121676 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121681 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121684 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121687 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121690 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121710 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121713 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121723 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121735 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121740 */   // GIR_Coverage, 2706,
     /* 121740 */   GIR_EraseRootFromParent_Done,
     /* 121741 */ // Label 2366: @121741
     /* 121741 */ GIM_Reject,
     /* 121742 */ // Label 2360: @121742
     /* 121742 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(121788), // Rule ID 1226 //
     /* 121747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121768 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121771 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121773 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121775 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121780 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121786 */   GIR_RootConstrainSelectedInstOperands,
     /* 121787 */   // GIR_Coverage, 1226,
     /* 121787 */   GIR_EraseRootFromParent_Done,
     /* 121788 */ // Label 2367: @121788
     /* 121788 */ GIM_Reject,
     /* 121789 */ // Label 2361: @121789
     /* 121789 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(121835), // Rule ID 1228 //
     /* 121794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121815 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121820 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121822 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121827 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121833 */   GIR_RootConstrainSelectedInstOperands,
     /* 121834 */   // GIR_Coverage, 1228,
     /* 121834 */   GIR_EraseRootFromParent_Done,
     /* 121835 */ // Label 2368: @121835
     /* 121835 */ GIM_Reject,
     /* 121836 */ // Label 2362: @121836
     /* 121836 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(121882), // Rule ID 1227 //
     /* 121841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121862 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121867 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121869 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121874 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121880 */   GIR_RootConstrainSelectedInstOperands,
     /* 121881 */   // GIR_Coverage, 1227,
     /* 121881 */   GIR_EraseRootFromParent_Done,
     /* 121882 */ // Label 2369: @121882
     /* 121882 */ GIM_Reject,
     /* 121883 */ // Label 2363: @121883
     /* 121883 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(121929), // Rule ID 1229 //
     /* 121888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121909 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121914 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121916 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121921 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121927 */   GIR_RootConstrainSelectedInstOperands,
     /* 121928 */   // GIR_Coverage, 1229,
     /* 121928 */   GIR_EraseRootFromParent_Done,
     /* 121929 */ // Label 2370: @121929
     /* 121929 */ GIM_Reject,
     /* 121930 */ // Label 2364: @121930
     /* 121930 */ GIM_Reject,
     /* 121931 */ // Label 49: @121931
     /* 121931 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2377*/ GIMT_Encode4(122664),
     /* 121942 */ /*GILLT_s16*//*Label 2371*/ GIMT_Encode4(121994),
     /* 121946 */ /*GILLT_s32*//*Label 2372*/ GIMT_Encode4(122235), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121958 */ /*GILLT_v2s32*//*Label 2373*/ GIMT_Encode4(122476), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121970 */ /*GILLT_v4s16*//*Label 2374*/ GIMT_Encode4(122523),
     /* 121974 */ /*GILLT_v4s32*//*Label 2375*/ GIMT_Encode4(122570), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121990 */ /*GILLT_v8s16*//*Label 2376*/ GIMT_Encode4(122617),
     /* 121994 */ // Label 2371: @121994
     /* 121994 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(122234), // Rule ID 2703 //
     /* 121999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 122002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 122005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 122008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122020 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122020 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 122023 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122027 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122034 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 122037 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122041 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122046 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122049 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122054 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 122057 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122061 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122066 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122069 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122073 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122076 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122081 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122086 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122091 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 122094 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122098 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122103 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122105 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 122108 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122112 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122117 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122120 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122125 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 122128 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122132 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122137 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122140 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122144 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122147 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122152 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122157 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122162 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122165 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122169 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122174 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122177 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122180 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122183 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 122194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122203 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122206 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122216 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122223 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122233 */   // GIR_Coverage, 2703,
     /* 122233 */   GIR_EraseRootFromParent_Done,
     /* 122234 */ // Label 2378: @122234
     /* 122234 */ GIM_Reject,
     /* 122235 */ // Label 2372: @122235
     /* 122235 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(122475), // Rule ID 2705 //
     /* 122240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122261 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122261 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122264 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122268 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122275 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122278 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122282 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122287 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122290 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122295 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122298 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122302 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122307 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122310 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122314 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122317 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122322 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122327 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122332 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122335 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122339 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122346 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122349 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122353 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122358 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122361 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122366 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122369 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122373 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122378 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122381 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122385 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122388 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122393 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122398 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122403 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122406 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122410 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122415 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122418 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122421 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122424 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122444 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122447 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122457 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122464 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122474 */   // GIR_Coverage, 2705,
     /* 122474 */   GIR_EraseRootFromParent_Done,
     /* 122475 */ // Label 2379: @122475
     /* 122475 */ GIM_Reject,
     /* 122476 */ // Label 2373: @122476
     /* 122476 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(122522), // Rule ID 1206 //
     /* 122481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122502 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122507 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122509 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122514 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122520 */   GIR_RootConstrainSelectedInstOperands,
     /* 122521 */   // GIR_Coverage, 1206,
     /* 122521 */   GIR_EraseRootFromParent_Done,
     /* 122522 */ // Label 2380: @122522
     /* 122522 */ GIM_Reject,
     /* 122523 */ // Label 2374: @122523
     /* 122523 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(122569), // Rule ID 1208 //
     /* 122528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122545 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122549 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122554 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122556 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122567 */   GIR_RootConstrainSelectedInstOperands,
     /* 122568 */   // GIR_Coverage, 1208,
     /* 122568 */   GIR_EraseRootFromParent_Done,
     /* 122569 */ // Label 2381: @122569
     /* 122569 */ GIM_Reject,
     /* 122570 */ // Label 2375: @122570
     /* 122570 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(122616), // Rule ID 1207 //
     /* 122575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122596 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122601 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122603 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122608 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122614 */   GIR_RootConstrainSelectedInstOperands,
     /* 122615 */   // GIR_Coverage, 1207,
     /* 122615 */   GIR_EraseRootFromParent_Done,
     /* 122616 */ // Label 2382: @122616
     /* 122616 */ GIM_Reject,
     /* 122617 */ // Label 2376: @122617
     /* 122617 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(122663), // Rule ID 1209 //
     /* 122622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122643 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122648 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122650 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122655 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122661 */   GIR_RootConstrainSelectedInstOperands,
     /* 122662 */   // GIR_Coverage, 1209,
     /* 122662 */   GIR_EraseRootFromParent_Done,
     /* 122663 */ // Label 2383: @122663
     /* 122663 */ GIM_Reject,
     /* 122664 */ // Label 2377: @122664
     /* 122664 */ GIM_Reject,
     /* 122665 */ // Label 50: @122665
     /* 122665 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(122697), // Rule ID 2416 //
     /* 122670 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122677 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122685 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122691 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122695 */   GIR_RootConstrainSelectedInstOperands,
     /* 122696 */   // GIR_Coverage, 2416,
     /* 122696 */   GIR_EraseRootFromParent_Done,
     /* 122697 */ // Label 2384: @122697
     /* 122697 */ GIM_Reject,
     /* 122698 */ // Label 51: @122698
     /* 122698 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(122733), // Rule ID 2417 //
     /* 122703 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122710 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122713 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122718 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122724 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122727 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122731 */   GIR_RootConstrainSelectedInstOperands,
     /* 122732 */   // GIR_Coverage, 2417,
     /* 122732 */   GIR_EraseRootFromParent_Done,
     /* 122733 */ // Label 2385: @122733
     /* 122733 */ GIM_Reject,
     /* 122734 */ // Label 52: @122734
     /* 122734 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(122798), // Rule ID 2418 //
     /* 122739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122742 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122742 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122745 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122749 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122754 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122757 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122760 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122766 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122783 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122789 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122796 */   GIR_RootConstrainSelectedInstOperands,
     /* 122797 */   // GIR_Coverage, 2418,
     /* 122797 */   GIR_EraseRootFromParent_Done,
     /* 122798 */ // Label 2386: @122798
     /* 122798 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(122862), // Rule ID 2419 //
     /* 122803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122806 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122818 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122824 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122827 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122830 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122847 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122853 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122860 */   GIR_RootConstrainSelectedInstOperands,
     /* 122861 */   // GIR_Coverage, 2419,
     /* 122861 */   GIR_EraseRootFromParent_Done,
     /* 122862 */ // Label 2387: @122862
     /* 122862 */ GIM_Reject,
     /* 122863 */ // Label 53: @122863
     /* 122863 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122895), // Rule ID 2420 //
     /* 122868 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122875 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122883 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122889 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122893 */   GIR_RootConstrainSelectedInstOperands,
     /* 122894 */   // GIR_Coverage, 2420,
     /* 122894 */   GIR_EraseRootFromParent_Done,
     /* 122895 */ // Label 2388: @122895
     /* 122895 */ GIM_Reject,
     /* 122896 */ // Label 54: @122896
     /* 122896 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2395*/ GIMT_Encode4(123438),
     /* 122907 */ /*GILLT_v2s32*//*Label 2389*/ GIMT_Encode4(122955), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122919 */ /*GILLT_v4s16*//*Label 2390*/ GIMT_Encode4(123002),
     /* 122923 */ /*GILLT_v4s32*//*Label 2391*/ GIMT_Encode4(123049), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122935 */ /*GILLT_v8s8*//*Label 2392*/ GIMT_Encode4(123163),
     /* 122939 */ /*GILLT_v8s16*//*Label 2393*/ GIMT_Encode4(123210), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122951 */ /*GILLT_v16s8*//*Label 2394*/ GIMT_Encode4(123324),
     /* 122955 */ // Label 2389: @122955
     /* 122955 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(123001), // Rule ID 1215 //
     /* 122960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122981 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122986 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122988 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122999 */   GIR_RootConstrainSelectedInstOperands,
     /* 123000 */   // GIR_Coverage, 1215,
     /* 123000 */   GIR_EraseRootFromParent_Done,
     /* 123001 */ // Label 2396: @123001
     /* 123001 */ GIM_Reject,
     /* 123002 */ // Label 2390: @123002
     /* 123002 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(123048), // Rule ID 1214 //
     /* 123007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123028 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 123031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123033 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123035 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123040 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123046 */   GIR_RootConstrainSelectedInstOperands,
     /* 123047 */   // GIR_Coverage, 1214,
     /* 123047 */   GIR_EraseRootFromParent_Done,
     /* 123048 */ // Label 2397: @123048
     /* 123048 */ GIM_Reject,
     /* 123049 */ // Label 2391: @123049
     /* 123049 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(123162),
     /* 123054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123060 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(123100), // Rule ID 1217 //
     /* 123065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123080 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 123083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123098 */     GIR_RootConstrainSelectedInstOperands,
     /* 123099 */     // GIR_Coverage, 1217,
     /* 123099 */     GIR_EraseRootFromParent_Done,
     /* 123100 */   // Label 2399: @123100
     /* 123100 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(123161), // Rule ID 3297 //
     /* 123105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123120 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 123135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123144 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123159 */     GIR_RootConstrainSelectedInstOperands,
     /* 123160 */     // GIR_Coverage, 3297,
     /* 123160 */     GIR_EraseRootFromParent_Done,
     /* 123161 */   // Label 2400: @123161
     /* 123161 */   GIM_Reject,
     /* 123162 */ // Label 2398: @123162
     /* 123162 */ GIM_Reject,
     /* 123163 */ // Label 2392: @123163
     /* 123163 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(123209), // Rule ID 1218 //
     /* 123168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123189 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 123192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123194 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123196 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123201 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123207 */   GIR_RootConstrainSelectedInstOperands,
     /* 123208 */   // GIR_Coverage, 1218,
     /* 123208 */   GIR_EraseRootFromParent_Done,
     /* 123209 */ // Label 2401: @123209
     /* 123209 */ GIM_Reject,
     /* 123210 */ // Label 2393: @123210
     /* 123210 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(123323),
     /* 123215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123221 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(123261), // Rule ID 1216 //
     /* 123226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123241 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123259 */     GIR_RootConstrainSelectedInstOperands,
     /* 123260 */     // GIR_Coverage, 1216,
     /* 123260 */     GIR_EraseRootFromParent_Done,
     /* 123261 */   // Label 2403: @123261
     /* 123261 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(123322), // Rule ID 3294 //
     /* 123266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123281 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123320 */     GIR_RootConstrainSelectedInstOperands,
     /* 123321 */     // GIR_Coverage, 3294,
     /* 123321 */     GIR_EraseRootFromParent_Done,
     /* 123322 */   // Label 2404: @123322
     /* 123322 */   GIM_Reject,
     /* 123323 */ // Label 2402: @123323
     /* 123323 */ GIM_Reject,
     /* 123324 */ // Label 2394: @123324
     /* 123324 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(123437),
     /* 123329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123335 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(123375), // Rule ID 1219 //
     /* 123340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123355 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123373 */     GIR_RootConstrainSelectedInstOperands,
     /* 123374 */     // GIR_Coverage, 1219,
     /* 123374 */     GIR_EraseRootFromParent_Done,
     /* 123375 */   // Label 2406: @123375
     /* 123375 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(123436), // Rule ID 3291 //
     /* 123380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123395 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123412 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123434 */     GIR_RootConstrainSelectedInstOperands,
     /* 123435 */     // GIR_Coverage, 3291,
     /* 123435 */     GIR_EraseRootFromParent_Done,
     /* 123436 */   // Label 2407: @123436
     /* 123436 */   GIM_Reject,
     /* 123437 */ // Label 2405: @123437
     /* 123437 */ GIM_Reject,
     /* 123438 */ // Label 2395: @123438
     /* 123438 */ GIM_Reject,
     /* 123439 */ // Label 55: @123439
     /* 123439 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2414*/ GIMT_Encode4(123981),
     /* 123450 */ /*GILLT_v2s32*//*Label 2408*/ GIMT_Encode4(123498), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123462 */ /*GILLT_v4s16*//*Label 2409*/ GIMT_Encode4(123545),
     /* 123466 */ /*GILLT_v4s32*//*Label 2410*/ GIMT_Encode4(123592), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123478 */ /*GILLT_v8s8*//*Label 2411*/ GIMT_Encode4(123706),
     /* 123482 */ /*GILLT_v8s16*//*Label 2412*/ GIMT_Encode4(123753), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123494 */ /*GILLT_v16s8*//*Label 2413*/ GIMT_Encode4(123867),
     /* 123498 */ // Label 2408: @123498
     /* 123498 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(123544), // Rule ID 1195 //
     /* 123503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123524 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123529 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123531 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123536 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123542 */   GIR_RootConstrainSelectedInstOperands,
     /* 123543 */   // GIR_Coverage, 1195,
     /* 123543 */   GIR_EraseRootFromParent_Done,
     /* 123544 */ // Label 2415: @123544
     /* 123544 */ GIM_Reject,
     /* 123545 */ // Label 2409: @123545
     /* 123545 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(123591), // Rule ID 1194 //
     /* 123550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123571 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123576 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123578 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123583 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123589 */   GIR_RootConstrainSelectedInstOperands,
     /* 123590 */   // GIR_Coverage, 1194,
     /* 123590 */   GIR_EraseRootFromParent_Done,
     /* 123591 */ // Label 2416: @123591
     /* 123591 */ GIM_Reject,
     /* 123592 */ // Label 2410: @123592
     /* 123592 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(123705),
     /* 123597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123603 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(123643), // Rule ID 1197 //
     /* 123608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123623 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123641 */     GIR_RootConstrainSelectedInstOperands,
     /* 123642 */     // GIR_Coverage, 1197,
     /* 123642 */     GIR_EraseRootFromParent_Done,
     /* 123643 */   // Label 2418: @123643
     /* 123643 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(123704), // Rule ID 3315 //
     /* 123648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123663 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123680 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123702 */     GIR_RootConstrainSelectedInstOperands,
     /* 123703 */     // GIR_Coverage, 3315,
     /* 123703 */     GIR_EraseRootFromParent_Done,
     /* 123704 */   // Label 2419: @123704
     /* 123704 */   GIM_Reject,
     /* 123705 */ // Label 2417: @123705
     /* 123705 */ GIM_Reject,
     /* 123706 */ // Label 2411: @123706
     /* 123706 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(123752), // Rule ID 1198 //
     /* 123711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123732 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123737 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123739 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123744 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123750 */   GIR_RootConstrainSelectedInstOperands,
     /* 123751 */   // GIR_Coverage, 1198,
     /* 123751 */   GIR_EraseRootFromParent_Done,
     /* 123752 */ // Label 2420: @123752
     /* 123752 */ GIM_Reject,
     /* 123753 */ // Label 2412: @123753
     /* 123753 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(123866),
     /* 123758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123764 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(123804), // Rule ID 1196 //
     /* 123769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123784 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123796 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123802 */     GIR_RootConstrainSelectedInstOperands,
     /* 123803 */     // GIR_Coverage, 1196,
     /* 123803 */     GIR_EraseRootFromParent_Done,
     /* 123804 */   // Label 2422: @123804
     /* 123804 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(123865), // Rule ID 3312 //
     /* 123809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123824 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123854 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123863 */     GIR_RootConstrainSelectedInstOperands,
     /* 123864 */     // GIR_Coverage, 3312,
     /* 123864 */     GIR_EraseRootFromParent_Done,
     /* 123865 */   // Label 2423: @123865
     /* 123865 */   GIM_Reject,
     /* 123866 */ // Label 2421: @123866
     /* 123866 */ GIM_Reject,
     /* 123867 */ // Label 2413: @123867
     /* 123867 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(123980),
     /* 123872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123878 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123918), // Rule ID 1199 //
     /* 123883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123898 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123916 */     GIR_RootConstrainSelectedInstOperands,
     /* 123917 */     // GIR_Coverage, 1199,
     /* 123917 */     GIR_EraseRootFromParent_Done,
     /* 123918 */   // Label 2425: @123918
     /* 123918 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123979), // Rule ID 3309 //
     /* 123923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123938 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123977 */     GIR_RootConstrainSelectedInstOperands,
     /* 123978 */     // GIR_Coverage, 3309,
     /* 123978 */     GIR_EraseRootFromParent_Done,
     /* 123979 */   // Label 2426: @123979
     /* 123979 */   GIM_Reject,
     /* 123980 */ // Label 2424: @123980
     /* 123980 */ GIM_Reject,
     /* 123981 */ // Label 2414: @123981
     /* 123981 */ GIM_Reject,
     /* 123982 */ // Label 56: @123982
     /* 123982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2433*/ GIMT_Encode4(124902),
     /* 123993 */ /*GILLT_v2s32*//*Label 2427*/ GIMT_Encode4(124041), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124005 */ /*GILLT_v4s16*//*Label 2428*/ GIMT_Encode4(124088),
     /* 124009 */ /*GILLT_v4s32*//*Label 2429*/ GIMT_Encode4(124135), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124021 */ /*GILLT_v8s8*//*Label 2430*/ GIMT_Encode4(124375),
     /* 124025 */ /*GILLT_v8s16*//*Label 2431*/ GIMT_Encode4(124422), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124037 */ /*GILLT_v16s8*//*Label 2432*/ GIMT_Encode4(124662),
     /* 124041 */ // Label 2427: @124041
     /* 124041 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(124087), // Rule ID 1221 //
     /* 124046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124067 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 124070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124072 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124074 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124079 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124085 */   GIR_RootConstrainSelectedInstOperands,
     /* 124086 */   // GIR_Coverage, 1221,
     /* 124086 */   GIR_EraseRootFromParent_Done,
     /* 124087 */ // Label 2434: @124087
     /* 124087 */ GIM_Reject,
     /* 124088 */ // Label 2428: @124088
     /* 124088 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(124134), // Rule ID 1220 //
     /* 124093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124114 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 124117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124119 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124121 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124126 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124132 */   GIR_RootConstrainSelectedInstOperands,
     /* 124133 */   // GIR_Coverage, 1220,
     /* 124133 */   GIR_EraseRootFromParent_Done,
     /* 124134 */ // Label 2435: @124134
     /* 124134 */ GIM_Reject,
     /* 124135 */ // Label 2429: @124135
     /* 124135 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(124374),
     /* 124140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124146 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(124209), // Rule ID 6024 //
     /* 124151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124181 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124207 */     GIR_RootConstrainSelectedInstOperands,
     /* 124208 */     // GIR_Coverage, 6024,
     /* 124208 */     GIR_EraseRootFromParent_Done,
     /* 124209 */   // Label 2437: @124209
     /* 124209 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(124272), // Rule ID 3694 //
     /* 124214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124244 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124264 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124270 */     GIR_RootConstrainSelectedInstOperands,
     /* 124271 */     // GIR_Coverage, 3694,
     /* 124271 */     GIR_EraseRootFromParent_Done,
     /* 124272 */   // Label 2438: @124272
     /* 124272 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(124312), // Rule ID 1223 //
     /* 124277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124292 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124310 */     GIR_RootConstrainSelectedInstOperands,
     /* 124311 */     // GIR_Coverage, 1223,
     /* 124311 */     GIR_EraseRootFromParent_Done,
     /* 124312 */   // Label 2439: @124312
     /* 124312 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(124373), // Rule ID 3306 //
     /* 124317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124332 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124356 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124362 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124371 */     GIR_RootConstrainSelectedInstOperands,
     /* 124372 */     // GIR_Coverage, 3306,
     /* 124372 */     GIR_EraseRootFromParent_Done,
     /* 124373 */   // Label 2440: @124373
     /* 124373 */   GIM_Reject,
     /* 124374 */ // Label 2436: @124374
     /* 124374 */ GIM_Reject,
     /* 124375 */ // Label 2430: @124375
     /* 124375 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(124421), // Rule ID 1224 //
     /* 124380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124401 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124406 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124408 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124413 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124419 */   GIR_RootConstrainSelectedInstOperands,
     /* 124420 */   // GIR_Coverage, 1224,
     /* 124420 */   GIR_EraseRootFromParent_Done,
     /* 124421 */ // Label 2441: @124421
     /* 124421 */ GIM_Reject,
     /* 124422 */ // Label 2431: @124422
     /* 124422 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(124661),
     /* 124427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124433 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(124496), // Rule ID 6023 //
     /* 124438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124468 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124494 */     GIR_RootConstrainSelectedInstOperands,
     /* 124495 */     // GIR_Coverage, 6023,
     /* 124495 */     GIR_EraseRootFromParent_Done,
     /* 124496 */   // Label 2443: @124496
     /* 124496 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(124559), // Rule ID 3692 //
     /* 124501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124531 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124557 */     GIR_RootConstrainSelectedInstOperands,
     /* 124558 */     // GIR_Coverage, 3692,
     /* 124558 */     GIR_EraseRootFromParent_Done,
     /* 124559 */   // Label 2444: @124559
     /* 124559 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(124599), // Rule ID 1222 //
     /* 124564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124579 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124597 */     GIR_RootConstrainSelectedInstOperands,
     /* 124598 */     // GIR_Coverage, 1222,
     /* 124598 */     GIR_EraseRootFromParent_Done,
     /* 124599 */   // Label 2445: @124599
     /* 124599 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124660), // Rule ID 3303 //
     /* 124604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124619 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124658 */     GIR_RootConstrainSelectedInstOperands,
     /* 124659 */     // GIR_Coverage, 3303,
     /* 124659 */     GIR_EraseRootFromParent_Done,
     /* 124660 */   // Label 2446: @124660
     /* 124660 */   GIM_Reject,
     /* 124661 */ // Label 2442: @124661
     /* 124661 */ GIM_Reject,
     /* 124662 */ // Label 2432: @124662
     /* 124662 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(124901),
     /* 124667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124673 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124736), // Rule ID 6022 //
     /* 124678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124708 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124734 */     GIR_RootConstrainSelectedInstOperands,
     /* 124735 */     // GIR_Coverage, 6022,
     /* 124735 */     GIR_EraseRootFromParent_Done,
     /* 124736 */   // Label 2448: @124736
     /* 124736 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124799), // Rule ID 3690 //
     /* 124741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124771 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124797 */     GIR_RootConstrainSelectedInstOperands,
     /* 124798 */     // GIR_Coverage, 3690,
     /* 124798 */     GIR_EraseRootFromParent_Done,
     /* 124799 */   // Label 2449: @124799
     /* 124799 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124839), // Rule ID 1225 //
     /* 124804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124819 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124837 */     GIR_RootConstrainSelectedInstOperands,
     /* 124838 */     // GIR_Coverage, 1225,
     /* 124838 */     GIR_EraseRootFromParent_Done,
     /* 124839 */   // Label 2450: @124839
     /* 124839 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124900), // Rule ID 3300 //
     /* 124844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124859 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124883 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124898 */     GIR_RootConstrainSelectedInstOperands,
     /* 124899 */     // GIR_Coverage, 3300,
     /* 124899 */     GIR_EraseRootFromParent_Done,
     /* 124900 */   // Label 2451: @124900
     /* 124900 */   GIM_Reject,
     /* 124901 */ // Label 2447: @124901
     /* 124901 */ GIM_Reject,
     /* 124902 */ // Label 2433: @124902
     /* 124902 */ GIM_Reject,
     /* 124903 */ // Label 57: @124903
     /* 124903 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2458*/ GIMT_Encode4(125823),
     /* 124914 */ /*GILLT_v2s32*//*Label 2452*/ GIMT_Encode4(124962), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124926 */ /*GILLT_v4s16*//*Label 2453*/ GIMT_Encode4(125009),
     /* 124930 */ /*GILLT_v4s32*//*Label 2454*/ GIMT_Encode4(125056), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124942 */ /*GILLT_v8s8*//*Label 2455*/ GIMT_Encode4(125296),
     /* 124946 */ /*GILLT_v8s16*//*Label 2456*/ GIMT_Encode4(125343), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124958 */ /*GILLT_v16s8*//*Label 2457*/ GIMT_Encode4(125583),
     /* 124962 */ // Label 2452: @124962
     /* 124962 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(125008), // Rule ID 1201 //
     /* 124967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124988 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124993 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124995 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125000 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125006 */   GIR_RootConstrainSelectedInstOperands,
     /* 125007 */   // GIR_Coverage, 1201,
     /* 125007 */   GIR_EraseRootFromParent_Done,
     /* 125008 */ // Label 2459: @125008
     /* 125008 */ GIM_Reject,
     /* 125009 */ // Label 2453: @125009
     /* 125009 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(125055), // Rule ID 1200 //
     /* 125014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 125023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125035 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 125035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 125038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125040 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125042 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125047 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125053 */   GIR_RootConstrainSelectedInstOperands,
     /* 125054 */   // GIR_Coverage, 1200,
     /* 125054 */   GIR_EraseRootFromParent_Done,
     /* 125055 */ // Label 2460: @125055
     /* 125055 */ GIM_Reject,
     /* 125056 */ // Label 2454: @125056
     /* 125056 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(125295),
     /* 125061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 125067 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(125130), // Rule ID 6027 //
     /* 125072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125102 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125122 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125128 */     GIR_RootConstrainSelectedInstOperands,
     /* 125129 */     // GIR_Coverage, 6027,
     /* 125129 */     GIR_EraseRootFromParent_Done,
     /* 125130 */   // Label 2462: @125130
     /* 125130 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(125193), // Rule ID 3700 //
     /* 125135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125165 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125191 */     GIR_RootConstrainSelectedInstOperands,
     /* 125192 */     // GIR_Coverage, 3700,
     /* 125192 */     GIR_EraseRootFromParent_Done,
     /* 125193 */   // Label 2463: @125193
     /* 125193 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(125233), // Rule ID 1203 //
     /* 125198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125213 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125231 */     GIR_RootConstrainSelectedInstOperands,
     /* 125232 */     // GIR_Coverage, 1203,
     /* 125232 */     GIR_EraseRootFromParent_Done,
     /* 125233 */   // Label 2464: @125233
     /* 125233 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(125294), // Rule ID 3324 //
     /* 125238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125253 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125292 */     GIR_RootConstrainSelectedInstOperands,
     /* 125293 */     // GIR_Coverage, 3324,
     /* 125293 */     GIR_EraseRootFromParent_Done,
     /* 125294 */   // Label 2465: @125294
     /* 125294 */   GIM_Reject,
     /* 125295 */ // Label 2461: @125295
     /* 125295 */ GIM_Reject,
     /* 125296 */ // Label 2455: @125296
     /* 125296 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(125342), // Rule ID 1204 //
     /* 125301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125307 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125322 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125327 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125329 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125334 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125340 */   GIR_RootConstrainSelectedInstOperands,
     /* 125341 */   // GIR_Coverage, 1204,
     /* 125341 */   GIR_EraseRootFromParent_Done,
     /* 125342 */ // Label 2466: @125342
     /* 125342 */ GIM_Reject,
     /* 125343 */ // Label 2456: @125343
     /* 125343 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(125582),
     /* 125348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125354 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(125417), // Rule ID 6026 //
     /* 125359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125389 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125415 */     GIR_RootConstrainSelectedInstOperands,
     /* 125416 */     // GIR_Coverage, 6026,
     /* 125416 */     GIR_EraseRootFromParent_Done,
     /* 125417 */   // Label 2468: @125417
     /* 125417 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(125480), // Rule ID 3698 //
     /* 125422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125452 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125478 */     GIR_RootConstrainSelectedInstOperands,
     /* 125479 */     // GIR_Coverage, 3698,
     /* 125479 */     GIR_EraseRootFromParent_Done,
     /* 125480 */   // Label 2469: @125480
     /* 125480 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(125520), // Rule ID 1202 //
     /* 125485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125500 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125518 */     GIR_RootConstrainSelectedInstOperands,
     /* 125519 */     // GIR_Coverage, 1202,
     /* 125519 */     GIR_EraseRootFromParent_Done,
     /* 125520 */   // Label 2470: @125520
     /* 125520 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125581), // Rule ID 3321 //
     /* 125525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125532 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125540 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125579 */     GIR_RootConstrainSelectedInstOperands,
     /* 125580 */     // GIR_Coverage, 3321,
     /* 125580 */     GIR_EraseRootFromParent_Done,
     /* 125581 */   // Label 2471: @125581
     /* 125581 */   GIM_Reject,
     /* 125582 */ // Label 2467: @125582
     /* 125582 */ GIM_Reject,
     /* 125583 */ // Label 2457: @125583
     /* 125583 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(125822),
     /* 125588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125594 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(125657), // Rule ID 6025 //
     /* 125599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125629 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125655 */     GIR_RootConstrainSelectedInstOperands,
     /* 125656 */     // GIR_Coverage, 6025,
     /* 125656 */     GIR_EraseRootFromParent_Done,
     /* 125657 */   // Label 2473: @125657
     /* 125657 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125720), // Rule ID 3696 //
     /* 125662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125692 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125706 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125712 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125718 */     GIR_RootConstrainSelectedInstOperands,
     /* 125719 */     // GIR_Coverage, 3696,
     /* 125719 */     GIR_EraseRootFromParent_Done,
     /* 125720 */   // Label 2474: @125720
     /* 125720 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125760), // Rule ID 1205 //
     /* 125725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125740 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125745 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125758 */     GIR_RootConstrainSelectedInstOperands,
     /* 125759 */     // GIR_Coverage, 1205,
     /* 125759 */     GIR_EraseRootFromParent_Done,
     /* 125760 */   // Label 2475: @125760
     /* 125760 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125821), // Rule ID 3318 //
     /* 125765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125780 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125819 */     GIR_RootConstrainSelectedInstOperands,
     /* 125820 */     // GIR_Coverage, 3318,
     /* 125820 */     GIR_EraseRootFromParent_Done,
     /* 125821 */   // Label 2476: @125821
     /* 125821 */   GIM_Reject,
     /* 125822 */ // Label 2472: @125822
     /* 125822 */ GIM_Reject,
     /* 125823 */ // Label 2458: @125823
     /* 125823 */ GIM_Reject,
     /* 125824 */ // Label 58: @125824
     /* 125824 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2483*/ GIMT_Encode4(126294),
     /* 125835 */ /*GILLT_v2s32*//*Label 2477*/ GIMT_Encode4(125883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125847 */ /*GILLT_v4s16*//*Label 2478*/ GIMT_Encode4(125921),
     /* 125851 */ /*GILLT_v4s32*//*Label 2479*/ GIMT_Encode4(125959), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125863 */ /*GILLT_v8s8*//*Label 2480*/ GIMT_Encode4(126058),
     /* 125867 */ /*GILLT_v8s16*//*Label 2481*/ GIMT_Encode4(126096), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125879 */ /*GILLT_v16s8*//*Label 2482*/ GIMT_Encode4(126195),
     /* 125883 */ // Label 2477: @125883
     /* 125883 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(125920), // Rule ID 1507 //
     /* 125888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125902 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125907 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125912 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125918 */   GIR_RootConstrainSelectedInstOperands,
     /* 125919 */   // GIR_Coverage, 1507,
     /* 125919 */   GIR_EraseRootFromParent_Done,
     /* 125920 */ // Label 2484: @125920
     /* 125920 */ GIM_Reject,
     /* 125921 */ // Label 2478: @125921
     /* 125921 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(125958), // Rule ID 1506 //
     /* 125926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125940 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125956 */   GIR_RootConstrainSelectedInstOperands,
     /* 125957 */   // GIR_Coverage, 1506,
     /* 125957 */   GIR_EraseRootFromParent_Done,
     /* 125958 */ // Label 2485: @125958
     /* 125958 */ GIM_Reject,
     /* 125959 */ // Label 2479: @125959
     /* 125959 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(126057),
     /* 125964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125967 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(126001), // Rule ID 1510 //
     /* 125972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125983 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125993 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125999 */     GIR_RootConstrainSelectedInstOperands,
     /* 126000 */     // GIR_Coverage, 1510,
     /* 126000 */     GIR_EraseRootFromParent_Done,
     /* 126001 */   // Label 2487: @126001
     /* 126001 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(126056), // Rule ID 3669 //
     /* 126006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126017 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 126017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 126032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126034 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126054 */     GIR_RootConstrainSelectedInstOperands,
     /* 126055 */     // GIR_Coverage, 3669,
     /* 126055 */     GIR_EraseRootFromParent_Done,
     /* 126056 */   // Label 2488: @126056
     /* 126056 */   GIM_Reject,
     /* 126057 */ // Label 2486: @126057
     /* 126057 */ GIM_Reject,
     /* 126058 */ // Label 2480: @126058
     /* 126058 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(126095), // Rule ID 1505 //
     /* 126063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126077 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 126080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126082 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126087 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126093 */   GIR_RootConstrainSelectedInstOperands,
     /* 126094 */   // GIR_Coverage, 1505,
     /* 126094 */   GIR_EraseRootFromParent_Done,
     /* 126095 */ // Label 2489: @126095
     /* 126095 */ GIM_Reject,
     /* 126096 */ // Label 2481: @126096
     /* 126096 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(126194),
     /* 126101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126104 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(126138), // Rule ID 1509 //
     /* 126109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126120 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 126123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126136 */     GIR_RootConstrainSelectedInstOperands,
     /* 126137 */     // GIR_Coverage, 1509,
     /* 126137 */     GIR_EraseRootFromParent_Done,
     /* 126138 */   // Label 2491: @126138
     /* 126138 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(126193), // Rule ID 3663 //
     /* 126143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126154 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 126154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 126169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126171 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126176 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126191 */     GIR_RootConstrainSelectedInstOperands,
     /* 126192 */     // GIR_Coverage, 3663,
     /* 126192 */     GIR_EraseRootFromParent_Done,
     /* 126193 */   // Label 2492: @126193
     /* 126193 */   GIM_Reject,
     /* 126194 */ // Label 2490: @126194
     /* 126194 */ GIM_Reject,
     /* 126195 */ // Label 2482: @126195
     /* 126195 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(126293),
     /* 126200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126203 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(126237), // Rule ID 1508 //
     /* 126208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126219 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126235 */     GIR_RootConstrainSelectedInstOperands,
     /* 126236 */     // GIR_Coverage, 1508,
     /* 126236 */     GIR_EraseRootFromParent_Done,
     /* 126237 */   // Label 2494: @126237
     /* 126237 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(126292), // Rule ID 3657 //
     /* 126242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126253 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126270 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126290 */     GIR_RootConstrainSelectedInstOperands,
     /* 126291 */     // GIR_Coverage, 3657,
     /* 126291 */     GIR_EraseRootFromParent_Done,
     /* 126292 */   // Label 2495: @126292
     /* 126292 */   GIM_Reject,
     /* 126293 */ // Label 2493: @126293
     /* 126293 */ GIM_Reject,
     /* 126294 */ // Label 2483: @126294
     /* 126294 */ GIM_Reject,
     /* 126295 */ // Label 59: @126295
     /* 126295 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(126367),
     /* 126300 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126303 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(126318), // Rule ID 32 //
     /* 126308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126311 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126316 */     GIR_RootConstrainSelectedInstOperands,
     /* 126317 */     // GIR_Coverage, 32,
     /* 126317 */     GIR_Done,
     /* 126318 */   // Label 2497: @126318
     /* 126318 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(126342), // Rule ID 283 //
     /* 126323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126326 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126329 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126340 */     GIR_RootConstrainSelectedInstOperands,
     /* 126341 */     // GIR_Coverage, 283,
     /* 126341 */     GIR_EraseRootFromParent_Done,
     /* 126342 */   // Label 2498: @126342
     /* 126342 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(126366), // Rule ID 577 //
     /* 126347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126350 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126353 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126364 */     GIR_RootConstrainSelectedInstOperands,
     /* 126365 */     // GIR_Coverage, 577,
     /* 126365 */     GIR_EraseRootFromParent_Done,
     /* 126366 */   // Label 2499: @126366
     /* 126366 */   GIM_Reject,
     /* 126367 */ // Label 2496: @126367
     /* 126367 */ GIM_Reject,
     /* 126368 */ // Label 60: @126368
     /* 126368 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2504*/ GIMT_Encode4(126667),
     /* 126379 */ /*GILLT_v4s16*//*Label 2500*/ GIMT_Encode4(126415), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126395 */ /*GILLT_v8s8*//*Label 2501*/ GIMT_Encode4(126478),
     /* 126399 */ /*GILLT_v8s16*//*Label 2502*/ GIMT_Encode4(126541), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126411 */ /*GILLT_v16s8*//*Label 2503*/ GIMT_Encode4(126604),
     /* 126415 */ // Label 2500: @126415
     /* 126415 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126477), // Rule ID 1569 //
     /* 126420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126429 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126444 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126452 */   // MIs[1] Operand 1
     /* 126452 */   // No operand predicates
     /* 126452 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126454 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126459 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126461 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126463 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126469 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126475 */   GIR_RootConstrainSelectedInstOperands,
     /* 126476 */   // GIR_Coverage, 1569,
     /* 126476 */   GIR_EraseRootFromParent_Done,
     /* 126477 */ // Label 2505: @126477
     /* 126477 */ GIM_Reject,
     /* 126478 */ // Label 2501: @126478
     /* 126478 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(126540), // Rule ID 1568 //
     /* 126483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126492 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126507 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126511 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126515 */   // MIs[1] Operand 1
     /* 126515 */   // No operand predicates
     /* 126515 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126517 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126522 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126524 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126526 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126532 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126538 */   GIR_RootConstrainSelectedInstOperands,
     /* 126539 */   // GIR_Coverage, 1568,
     /* 126539 */   GIR_EraseRootFromParent_Done,
     /* 126540 */ // Label 2506: @126540
     /* 126540 */ GIM_Reject,
     /* 126541 */ // Label 2502: @126541
     /* 126541 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(126603), // Rule ID 3433 //
     /* 126546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126570 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126574 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126578 */   // MIs[1] Operand 1
     /* 126578 */   // No operand predicates
     /* 126578 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126580 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126585 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126587 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126589 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126595 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126601 */   GIR_RootConstrainSelectedInstOperands,
     /* 126602 */   // GIR_Coverage, 3433,
     /* 126602 */   GIR_EraseRootFromParent_Done,
     /* 126603 */ // Label 2507: @126603
     /* 126603 */ GIM_Reject,
     /* 126604 */ // Label 2503: @126604
     /* 126604 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(126666), // Rule ID 3432 //
     /* 126609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126641 */   // MIs[1] Operand 1
     /* 126641 */   // No operand predicates
     /* 126641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126643 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126650 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126652 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126658 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126664 */   GIR_RootConstrainSelectedInstOperands,
     /* 126665 */   // GIR_Coverage, 3432,
     /* 126665 */   GIR_EraseRootFromParent_Done,
     /* 126666 */ // Label 2508: @126666
     /* 126666 */ GIM_Reject,
     /* 126667 */ // Label 2504: @126667
     /* 126667 */ GIM_Reject,
     /* 126668 */ // Label 61: @126668
     /* 126668 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(126724), // Rule ID 1567 //
     /* 126673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126676 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126701 */   // MIs[1] Operand 1
     /* 126701 */   // No operand predicates
     /* 126701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126703 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126708 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126710 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126716 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126722 */   GIR_RootConstrainSelectedInstOperands,
     /* 126723 */   // GIR_Coverage, 1567,
     /* 126723 */   GIR_EraseRootFromParent_Done,
     /* 126724 */ // Label 2509: @126724
     /* 126724 */ GIM_Reject,
     /* 126725 */ // Label 62: @126725
     /* 126725 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2517*/ GIMT_Encode4(127285),
     /* 126736 */ /*GILLT_s32*//*Label 2510*/ GIMT_Encode4(126796), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126748 */ /*GILLT_v2s32*//*Label 2511*/ GIMT_Encode4(126874), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126760 */ /*GILLT_v4s16*//*Label 2512*/ GIMT_Encode4(126912),
     /* 126764 */ /*GILLT_v4s32*//*Label 2513*/ GIMT_Encode4(126950), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126776 */ /*GILLT_v8s8*//*Label 2514*/ GIMT_Encode4(127049),
     /* 126780 */ /*GILLT_v8s16*//*Label 2515*/ GIMT_Encode4(127087), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126792 */ /*GILLT_v16s8*//*Label 2516*/ GIMT_Encode4(127186),
     /* 126796 */ // Label 2510: @126796
     /* 126796 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(126873),
     /* 126801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126804 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(126838), // Rule ID 197 //
     /* 126809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126820 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126830 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126836 */     GIR_RootConstrainSelectedInstOperands,
     /* 126837 */     // GIR_Coverage, 197,
     /* 126837 */     GIR_EraseRootFromParent_Done,
     /* 126838 */   // Label 2519: @126838
     /* 126838 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(126872), // Rule ID 534 //
     /* 126843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126854 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126870 */     GIR_RootConstrainSelectedInstOperands,
     /* 126871 */     // GIR_Coverage, 534,
     /* 126871 */     GIR_EraseRootFromParent_Done,
     /* 126872 */   // Label 2520: @126872
     /* 126872 */   GIM_Reject,
     /* 126873 */ // Label 2518: @126873
     /* 126873 */ GIM_Reject,
     /* 126874 */ // Label 2511: @126874
     /* 126874 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(126911), // Rule ID 1545 //
     /* 126879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126893 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126898 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126903 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126909 */   GIR_RootConstrainSelectedInstOperands,
     /* 126910 */   // GIR_Coverage, 1545,
     /* 126910 */   GIR_EraseRootFromParent_Done,
     /* 126911 */ // Label 2521: @126911
     /* 126911 */ GIM_Reject,
     /* 126912 */ // Label 2512: @126912
     /* 126912 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(126949), // Rule ID 1544 //
     /* 126917 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126931 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126936 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126941 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126947 */   GIR_RootConstrainSelectedInstOperands,
     /* 126948 */   // GIR_Coverage, 1544,
     /* 126948 */   GIR_EraseRootFromParent_Done,
     /* 126949 */ // Label 2522: @126949
     /* 126949 */ GIM_Reject,
     /* 126950 */ // Label 2513: @126950
     /* 126950 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(127048),
     /* 126955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126958 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(126992), // Rule ID 1548 //
     /* 126963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126974 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126984 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126990 */     GIR_RootConstrainSelectedInstOperands,
     /* 126991 */     // GIR_Coverage, 1548,
     /* 126991 */     GIR_EraseRootFromParent_Done,
     /* 126992 */   // Label 2524: @126992
     /* 126992 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(127047), // Rule ID 3655 //
     /* 126997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127008 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 127008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 127023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127025 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127045 */     GIR_RootConstrainSelectedInstOperands,
     /* 127046 */     // GIR_Coverage, 3655,
     /* 127046 */     GIR_EraseRootFromParent_Done,
     /* 127047 */   // Label 2525: @127047
     /* 127047 */   GIM_Reject,
     /* 127048 */ // Label 2523: @127048
     /* 127048 */ GIM_Reject,
     /* 127049 */ // Label 2514: @127049
     /* 127049 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(127086), // Rule ID 1543 //
     /* 127054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127068 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 127071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127078 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127084 */   GIR_RootConstrainSelectedInstOperands,
     /* 127085 */   // GIR_Coverage, 1543,
     /* 127085 */   GIR_EraseRootFromParent_Done,
     /* 127086 */ // Label 2526: @127086
     /* 127086 */ GIM_Reject,
     /* 127087 */ // Label 2515: @127087
     /* 127087 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(127185),
     /* 127092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127095 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(127129), // Rule ID 1547 //
     /* 127100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127111 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 127111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 127114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127127 */     GIR_RootConstrainSelectedInstOperands,
     /* 127128 */     // GIR_Coverage, 1547,
     /* 127128 */     GIR_EraseRootFromParent_Done,
     /* 127129 */   // Label 2528: @127129
     /* 127129 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(127184), // Rule ID 3653 //
     /* 127134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127145 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 127145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 127160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127162 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127182 */     GIR_RootConstrainSelectedInstOperands,
     /* 127183 */     // GIR_Coverage, 3653,
     /* 127183 */     GIR_EraseRootFromParent_Done,
     /* 127184 */   // Label 2529: @127184
     /* 127184 */   GIM_Reject,
     /* 127185 */ // Label 2527: @127185
     /* 127185 */ GIM_Reject,
     /* 127186 */ // Label 2516: @127186
     /* 127186 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(127284),
     /* 127191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127194 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(127228), // Rule ID 1546 //
     /* 127199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127210 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127226 */     GIR_RootConstrainSelectedInstOperands,
     /* 127227 */     // GIR_Coverage, 1546,
     /* 127227 */     GIR_EraseRootFromParent_Done,
     /* 127228 */   // Label 2531: @127228
     /* 127228 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(127283), // Rule ID 3651 //
     /* 127233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127244 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127261 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127281 */     GIR_RootConstrainSelectedInstOperands,
     /* 127282 */     // GIR_Coverage, 3651,
     /* 127282 */     GIR_EraseRootFromParent_Done,
     /* 127283 */   // Label 2532: @127283
     /* 127283 */   GIM_Reject,
     /* 127284 */ // Label 2530: @127284
     /* 127284 */ GIM_Reject,
     /* 127285 */ // Label 2517: @127285
     /* 127285 */ GIM_Reject,
     /* 127286 */ // Label 63: @127286
     /* 127286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2535*/ GIMT_Encode4(127393),
     /* 127297 */ /*GILLT_v8s8*//*Label 2533*/ GIMT_Encode4(127317), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127313 */ /*GILLT_v16s8*//*Label 2534*/ GIMT_Encode4(127355),
     /* 127317 */ // Label 2533: @127317
     /* 127317 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(127354), // Rule ID 1549 //
     /* 127322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127336 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127341 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127346 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127352 */   GIR_RootConstrainSelectedInstOperands,
     /* 127353 */   // GIR_Coverage, 1549,
     /* 127353 */   GIR_EraseRootFromParent_Done,
     /* 127354 */ // Label 2536: @127354
     /* 127354 */ GIM_Reject,
     /* 127355 */ // Label 2534: @127355
     /* 127355 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(127392), // Rule ID 1550 //
     /* 127360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127374 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127379 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127384 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127390 */   GIR_RootConstrainSelectedInstOperands,
     /* 127391 */   // GIR_Coverage, 1550,
     /* 127391 */   GIR_EraseRootFromParent_Done,
     /* 127392 */ // Label 2537: @127392
     /* 127392 */ GIM_Reject,
     /* 127393 */ // Label 2535: @127393
     /* 127393 */ GIM_Reject,
     /* 127394 */ // Label 64: @127394
     /* 127394 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2541*/ GIMT_Encode4(127683),
     /* 127405 */ /*GILLT_s32*//*Label 2538*/ GIMT_Encode4(127453), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127433 */ /*GILLT_v4s32*//*Label 2539*/ GIMT_Encode4(127565), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127449 */ /*GILLT_v8s16*//*Label 2540*/ GIMT_Encode4(127624),
     /* 127453 */ // Label 2538: @127453
     /* 127453 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(127564),
     /* 127458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127461 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(127495), // Rule ID 199 //
     /* 127466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127477 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127493 */     GIR_RootConstrainSelectedInstOperands,
     /* 127494 */     // GIR_Coverage, 199,
     /* 127494 */     GIR_EraseRootFromParent_Done,
     /* 127495 */   // Label 2543: @127495
     /* 127495 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(127529), // Rule ID 326 //
     /* 127500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127511 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127527 */     GIR_RootConstrainSelectedInstOperands,
     /* 127528 */     // GIR_Coverage, 326,
     /* 127528 */     GIR_EraseRootFromParent_Done,
     /* 127529 */   // Label 2544: @127529
     /* 127529 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(127563), // Rule ID 536 //
     /* 127534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127541 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127545 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127561 */     GIR_RootConstrainSelectedInstOperands,
     /* 127562 */     // GIR_Coverage, 536,
     /* 127562 */     GIR_EraseRootFromParent_Done,
     /* 127563 */   // Label 2545: @127563
     /* 127563 */   GIM_Reject,
     /* 127564 */ // Label 2542: @127564
     /* 127564 */ GIM_Reject,
     /* 127565 */ // Label 2539: @127565
     /* 127565 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(127623), // Rule ID 3328 //
     /* 127570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127584 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127621 */   GIR_RootConstrainSelectedInstOperands,
     /* 127622 */   // GIR_Coverage, 3328,
     /* 127622 */   GIR_EraseRootFromParent_Done,
     /* 127623 */ // Label 2546: @127623
     /* 127623 */ GIM_Reject,
     /* 127624 */ // Label 2540: @127624
     /* 127624 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(127682), // Rule ID 3327 //
     /* 127629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127643 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127643 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127646 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127650 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127660 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127665 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127671 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127677 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127680 */   GIR_RootConstrainSelectedInstOperands,
     /* 127681 */   // GIR_Coverage, 3327,
     /* 127681 */   GIR_EraseRootFromParent_Done,
     /* 127682 */ // Label 2547: @127682
     /* 127682 */ GIM_Reject,
     /* 127683 */ // Label 2541: @127683
     /* 127683 */ GIM_Reject,
     /* 127684 */ // Label 65: @127684
     /* 127684 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2552*/ GIMT_Encode4(128115),
     /* 127695 */ /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(127755), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127723 */ /*GILLT_v4s32*//*Label 2549*/ GIMT_Encode4(127833), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127739 */ /*GILLT_v8s16*//*Label 2550*/ GIMT_Encode4(127927), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127751 */ /*GILLT_v16s8*//*Label 2551*/ GIMT_Encode4(128021),
     /* 127755 */ // Label 2548: @127755
     /* 127755 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127832),
     /* 127760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127763 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127797), // Rule ID 198 //
     /* 127768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127779 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127795 */     GIR_RootConstrainSelectedInstOperands,
     /* 127796 */     // GIR_Coverage, 198,
     /* 127796 */     GIR_EraseRootFromParent_Done,
     /* 127797 */   // Label 2554: @127797
     /* 127797 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(127831), // Rule ID 535 //
     /* 127802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127813 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127829 */     GIR_RootConstrainSelectedInstOperands,
     /* 127830 */     // GIR_Coverage, 535,
     /* 127830 */     GIR_EraseRootFromParent_Done,
     /* 127831 */   // Label 2555: @127831
     /* 127831 */   GIM_Reject,
     /* 127832 */ // Label 2553: @127832
     /* 127832 */ GIM_Reject,
     /* 127833 */ // Label 2549: @127833
     /* 127833 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(127926), // Rule ID 4755 //
     /* 127838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127852 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127852 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127855 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127859 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127876 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127879 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127882 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127888 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127901 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127903 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127909 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127924 */   GIR_RootConstrainSelectedInstOperands,
     /* 127925 */   // GIR_Coverage, 4755,
     /* 127925 */   GIR_EraseRootFromParent_Done,
     /* 127926 */ // Label 2556: @127926
     /* 127926 */ GIM_Reject,
     /* 127927 */ // Label 2550: @127927
     /* 127927 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(128020), // Rule ID 4756 //
     /* 127932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127946 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127946 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127949 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127953 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127970 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127973 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127976 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127982 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 127993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127995 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128003 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128009 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128018 */   GIR_RootConstrainSelectedInstOperands,
     /* 128019 */   // GIR_Coverage, 4756,
     /* 128019 */   GIR_EraseRootFromParent_Done,
     /* 128020 */ // Label 2557: @128020
     /* 128020 */ GIM_Reject,
     /* 128021 */ // Label 2551: @128021
     /* 128021 */ GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(128114), // Rule ID 4754 //
     /* 128026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 128029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 128032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128040 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 128040 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128043 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128047 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128064 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 128067 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128070 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128076 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 128087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128089 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128097 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128112 */   GIR_RootConstrainSelectedInstOperands,
     /* 128113 */   // GIR_Coverage, 4754,
     /* 128113 */   GIR_EraseRootFromParent_Done,
     /* 128114 */ // Label 2558: @128114
     /* 128114 */ GIM_Reject,
     /* 128115 */ // Label 2552: @128115
     /* 128115 */ GIM_Reject,
     /* 128116 */ // Label 66: @128116
     /* 128116 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2564*/ GIMT_Encode4(128378),
     /* 128127 */ /*GILLT_s16*//*Label 2559*/ GIMT_Encode4(128179),
     /* 128131 */ /*GILLT_s32*//*Label 2560*/ GIMT_Encode4(128206),
     /* 128135 */ /*GILLT_s64*//*Label 2561*/ GIMT_Encode4(128233), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128159 */ /*GILLT_v4s32*//*Label 2562*/ GIMT_Encode4(128260), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128175 */ /*GILLT_v8s16*//*Label 2563*/ GIMT_Encode4(128319),
     /* 128179 */ // Label 2559: @128179
     /* 128179 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(128205), // Rule ID 680 //
     /* 128184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128198 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 128203 */   GIR_RootConstrainSelectedInstOperands,
     /* 128204 */   // GIR_Coverage, 680,
     /* 128204 */   GIR_Done,
     /* 128205 */ // Label 2565: @128205
     /* 128205 */ GIM_Reject,
     /* 128206 */ // Label 2560: @128206
     /* 128206 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(128232), // Rule ID 681 //
     /* 128211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128225 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128230 */   GIR_RootConstrainSelectedInstOperands,
     /* 128231 */   // GIR_Coverage, 681,
     /* 128231 */   GIR_Done,
     /* 128232 */ // Label 2566: @128232
     /* 128232 */ GIM_Reject,
     /* 128233 */ // Label 2561: @128233
     /* 128233 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(128259), // Rule ID 682 //
     /* 128238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128252 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128257 */   GIR_RootConstrainSelectedInstOperands,
     /* 128258 */   // GIR_Coverage, 682,
     /* 128258 */   GIR_Done,
     /* 128259 */ // Label 2567: @128259
     /* 128259 */ GIM_Reject,
     /* 128260 */ // Label 2562: @128260
     /* 128260 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(128318), // Rule ID 3983 //
     /* 128265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128279 */   // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128296 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128301 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128307 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128316 */   GIR_RootConstrainSelectedInstOperands,
     /* 128317 */   // GIR_Coverage, 3983,
     /* 128317 */   GIR_EraseRootFromParent_Done,
     /* 128318 */ // Label 2568: @128318
     /* 128318 */ GIM_Reject,
     /* 128319 */ // Label 2563: @128319
     /* 128319 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(128377), // Rule ID 3971 //
     /* 128324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128338 */   // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128338 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128341 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128345 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128355 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128360 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128366 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128375 */   GIR_RootConstrainSelectedInstOperands,
     /* 128376 */   // GIR_Coverage, 3971,
     /* 128376 */   GIR_EraseRootFromParent_Done,
     /* 128377 */ // Label 2569: @128377
     /* 128377 */ GIM_Reject,
     /* 128378 */ // Label 2564: @128378
     /* 128378 */ GIM_Reject,
     /* 128379 */ // Label 67: @128379
     /* 128379 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2573*/ GIMT_Encode4(128516),
     /* 128390 */ /*GILLT_s16*//*Label 2570*/ GIMT_Encode4(128402),
     /* 128394 */ /*GILLT_s32*//*Label 2571*/ GIMT_Encode4(128440),
     /* 128398 */ /*GILLT_s64*//*Label 2572*/ GIMT_Encode4(128478),
     /* 128402 */ // Label 2570: @128402
     /* 128402 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(128439), // Rule ID 688 //
     /* 128407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128421 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128426 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128431 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128437 */   GIR_RootConstrainSelectedInstOperands,
     /* 128438 */   // GIR_Coverage, 688,
     /* 128438 */   GIR_EraseRootFromParent_Done,
     /* 128439 */ // Label 2574: @128439
     /* 128439 */ GIM_Reject,
     /* 128440 */ // Label 2571: @128440
     /* 128440 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(128477), // Rule ID 687 //
     /* 128445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128459 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128459 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128462 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128464 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128469 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128475 */   GIR_RootConstrainSelectedInstOperands,
     /* 128476 */   // GIR_Coverage, 687,
     /* 128476 */   GIR_EraseRootFromParent_Done,
     /* 128477 */ // Label 2575: @128477
     /* 128477 */ GIM_Reject,
     /* 128478 */ // Label 2572: @128478
     /* 128478 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(128515), // Rule ID 686 //
     /* 128483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128497 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128502 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128507 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128513 */   GIR_RootConstrainSelectedInstOperands,
     /* 128514 */   // GIR_Coverage, 686,
     /* 128514 */   GIR_EraseRootFromParent_Done,
     /* 128515 */ // Label 2576: @128515
     /* 128515 */ GIM_Reject,
     /* 128516 */ // Label 2573: @128516
     /* 128516 */ GIM_Reject,
     /* 128517 */ // Label 68: @128517
     /* 128517 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2582*/ GIMT_Encode4(128779),
     /* 128528 */ /*GILLT_s16*//*Label 2577*/ GIMT_Encode4(128580),
     /* 128532 */ /*GILLT_s32*//*Label 2578*/ GIMT_Encode4(128607),
     /* 128536 */ /*GILLT_s64*//*Label 2579*/ GIMT_Encode4(128634), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128560 */ /*GILLT_v4s32*//*Label 2580*/ GIMT_Encode4(128661), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128576 */ /*GILLT_v8s16*//*Label 2581*/ GIMT_Encode4(128720),
     /* 128580 */ // Label 2577: @128580
     /* 128580 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(128606), // Rule ID 683 //
     /* 128585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128599 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128604 */   GIR_RootConstrainSelectedInstOperands,
     /* 128605 */   // GIR_Coverage, 683,
     /* 128605 */   GIR_Done,
     /* 128606 */ // Label 2583: @128606
     /* 128606 */ GIM_Reject,
     /* 128607 */ // Label 2578: @128607
     /* 128607 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(128633), // Rule ID 684 //
     /* 128612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128626 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128631 */   GIR_RootConstrainSelectedInstOperands,
     /* 128632 */   // GIR_Coverage, 684,
     /* 128632 */   GIR_Done,
     /* 128633 */ // Label 2584: @128633
     /* 128633 */ GIM_Reject,
     /* 128634 */ // Label 2579: @128634
     /* 128634 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(128660), // Rule ID 685 //
     /* 128639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128653 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128658 */   GIR_RootConstrainSelectedInstOperands,
     /* 128659 */   // GIR_Coverage, 685,
     /* 128659 */   GIR_Done,
     /* 128660 */ // Label 2585: @128660
     /* 128660 */ GIM_Reject,
     /* 128661 */ // Label 2580: @128661
     /* 128661 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(128719), // Rule ID 3981 //
     /* 128666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128680 */   // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128697 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128702 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128714 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128717 */   GIR_RootConstrainSelectedInstOperands,
     /* 128718 */   // GIR_Coverage, 3981,
     /* 128718 */   GIR_EraseRootFromParent_Done,
     /* 128719 */ // Label 2586: @128719
     /* 128719 */ GIM_Reject,
     /* 128720 */ // Label 2581: @128720
     /* 128720 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(128778), // Rule ID 3969 //
     /* 128725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128739 */   // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128756 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128761 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128767 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128773 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128776 */   GIR_RootConstrainSelectedInstOperands,
     /* 128777 */   // GIR_Coverage, 3969,
     /* 128777 */   GIR_EraseRootFromParent_Done,
     /* 128778 */ // Label 2587: @128778
     /* 128778 */ GIM_Reject,
     /* 128779 */ // Label 2582: @128779
     /* 128779 */ GIM_Reject,
     /* 128780 */ // Label 69: @128780
     /* 128780 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2593*/ GIMT_Encode4(129075),
     /* 128791 */ /*GILLT_s16*//*Label 2588*/ GIMT_Encode4(128843),
     /* 128795 */ /*GILLT_s32*//*Label 2589*/ GIMT_Encode4(128881),
     /* 128799 */ /*GILLT_s64*//*Label 2590*/ GIMT_Encode4(128919), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128823 */ /*GILLT_v4s32*//*Label 2591*/ GIMT_Encode4(128957), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128839 */ /*GILLT_v8s16*//*Label 2592*/ GIMT_Encode4(129016),
     /* 128843 */ // Label 2588: @128843
     /* 128843 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(128880), // Rule ID 671 //
     /* 128848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128862 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128867 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128872 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128878 */   GIR_RootConstrainSelectedInstOperands,
     /* 128879 */   // GIR_Coverage, 671,
     /* 128879 */   GIR_EraseRootFromParent_Done,
     /* 128880 */ // Label 2594: @128880
     /* 128880 */ GIM_Reject,
     /* 128881 */ // Label 2589: @128881
     /* 128881 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(128918), // Rule ID 672 //
     /* 128886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128900 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 128903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128905 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128910 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128916 */   GIR_RootConstrainSelectedInstOperands,
     /* 128917 */   // GIR_Coverage, 672,
     /* 128917 */   GIR_EraseRootFromParent_Done,
     /* 128918 */ // Label 2595: @128918
     /* 128918 */ GIM_Reject,
     /* 128919 */ // Label 2590: @128919
     /* 128919 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(128956), // Rule ID 673 //
     /* 128924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128938 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 128941 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128943 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128948 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128954 */   GIR_RootConstrainSelectedInstOperands,
     /* 128955 */   // GIR_Coverage, 673,
     /* 128955 */   GIR_EraseRootFromParent_Done,
     /* 128956 */ // Label 2596: @128956
     /* 128956 */ GIM_Reject,
     /* 128957 */ // Label 2591: @128957
     /* 128957 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(129015), // Rule ID 3975 //
     /* 128962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128976 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 128991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128993 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129013 */   GIR_RootConstrainSelectedInstOperands,
     /* 129014 */   // GIR_Coverage, 3975,
     /* 129014 */   GIR_EraseRootFromParent_Done,
     /* 129015 */ // Label 2597: @129015
     /* 129015 */ GIM_Reject,
     /* 129016 */ // Label 2592: @129016
     /* 129016 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(129074), // Rule ID 3963 //
     /* 129021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129035 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129035 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129038 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129042 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129052 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129057 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129063 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129072 */   GIR_RootConstrainSelectedInstOperands,
     /* 129073 */   // GIR_Coverage, 3963,
     /* 129073 */   GIR_EraseRootFromParent_Done,
     /* 129074 */ // Label 2598: @129074
     /* 129074 */ GIM_Reject,
     /* 129075 */ // Label 2593: @129075
     /* 129075 */ GIM_Reject,
     /* 129076 */ // Label 70: @129076
     /* 129076 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2602*/ GIMT_Encode4(129213),
     /* 129087 */ /*GILLT_s16*//*Label 2599*/ GIMT_Encode4(129099),
     /* 129091 */ /*GILLT_s32*//*Label 2600*/ GIMT_Encode4(129137),
     /* 129095 */ /*GILLT_s64*//*Label 2601*/ GIMT_Encode4(129175),
     /* 129099 */ // Label 2599: @129099
     /* 129099 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(129136), // Rule ID 668 //
     /* 129104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129118 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129123 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129128 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129134 */   GIR_RootConstrainSelectedInstOperands,
     /* 129135 */   // GIR_Coverage, 668,
     /* 129135 */   GIR_EraseRootFromParent_Done,
     /* 129136 */ // Label 2603: @129136
     /* 129136 */ GIM_Reject,
     /* 129137 */ // Label 2600: @129137
     /* 129137 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(129174), // Rule ID 669 //
     /* 129142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129156 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129161 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129166 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129172 */   GIR_RootConstrainSelectedInstOperands,
     /* 129173 */   // GIR_Coverage, 669,
     /* 129173 */   GIR_EraseRootFromParent_Done,
     /* 129174 */ // Label 2604: @129174
     /* 129174 */ GIM_Reject,
     /* 129175 */ // Label 2601: @129175
     /* 129175 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(129212), // Rule ID 670 //
     /* 129180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129194 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129199 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129204 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129210 */   GIR_RootConstrainSelectedInstOperands,
     /* 129211 */   // GIR_Coverage, 670,
     /* 129211 */   GIR_EraseRootFromParent_Done,
     /* 129212 */ // Label 2605: @129212
     /* 129212 */ GIM_Reject,
     /* 129213 */ // Label 2602: @129213
     /* 129213 */ GIM_Reject,
     /* 129214 */ // Label 71: @129214
     /* 129214 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(129229), // Rule ID 12 //
     /* 129219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129222 */   // (trap)  =>  (TRAPNaCl)
     /* 129222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129227 */   GIR_RootConstrainSelectedInstOperands,
     /* 129228 */   // GIR_Coverage, 12,
     /* 129228 */   GIR_Done,
     /* 129229 */ // Label 2606: @129229
     /* 129229 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(129244), // Rule ID 13 //
     /* 129234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129237 */   // (trap)  =>  (TRAP)
     /* 129237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129242 */   GIR_RootConstrainSelectedInstOperands,
     /* 129243 */   // GIR_Coverage, 13,
     /* 129243 */   GIR_Done,
     /* 129244 */ // Label 2607: @129244
     /* 129244 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(129259), // Rule ID 285 //
     /* 129249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129252 */   // (trap)  =>  (tTRAP)
     /* 129252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129257 */   GIR_RootConstrainSelectedInstOperands,
     /* 129258 */   // GIR_Coverage, 285,
     /* 129258 */   GIR_Done,
     /* 129259 */ // Label 2608: @129259
     /* 129259 */ GIM_Reject,
     /* 129260 */ // Label 72: @129260
     /* 129260 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(129276), // Rule ID 1835 //
     /* 129265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129268 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129274 */   GIR_RootConstrainSelectedInstOperands,
     /* 129275 */   // GIR_Coverage, 1835,
     /* 129275 */   GIR_EraseRootFromParent_Done,
     /* 129276 */ // Label 2609: @129276
     /* 129276 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(129303), // Rule ID 1836 //
     /* 129281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129284 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129287 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129301 */   GIR_RootConstrainSelectedInstOperands,
     /* 129302 */   // GIR_Coverage, 1836,
     /* 129302 */   GIR_EraseRootFromParent_Done,
     /* 129303 */ // Label 2610: @129303
     /* 129303 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(129319), // Rule ID 2021 //
     /* 129308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129311 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129317 */   GIR_RootConstrainSelectedInstOperands,
     /* 129318 */   // GIR_Coverage, 2021,
     /* 129318 */   GIR_EraseRootFromParent_Done,
     /* 129319 */ // Label 2611: @129319
     /* 129319 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(129346), // Rule ID 2022 //
     /* 129324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129327 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129330 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129340 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129344 */   GIR_RootConstrainSelectedInstOperands,
     /* 129345 */   // GIR_Coverage, 2022,
     /* 129345 */   GIR_EraseRootFromParent_Done,
     /* 129346 */ // Label 2612: @129346
     /* 129346 */ GIM_Reject,
     /* 129347 */ // Label 73: @129347
     /* 129347 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(129767),
     /* 129352 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129355 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2617*/ GIMT_Encode4(129653),
     /* 129366 */   /*GILLT_v4s32*//*Label 2614*/ GIMT_Encode4(129398), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129382 */   /*GILLT_v8s16*//*Label 2615*/ GIMT_Encode4(129469), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129394 */   /*GILLT_v16s8*//*Label 2616*/ GIMT_Encode4(129540),
     /* 129398 */   // Label 2614: @129398
     /* 129398 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(129468), // Rule ID 3238 //
     /* 129403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129438 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129460 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129466 */     GIR_RootConstrainSelectedInstOperands,
     /* 129467 */     // GIR_Coverage, 3238,
     /* 129467 */     GIR_EraseRootFromParent_Done,
     /* 129468 */   // Label 2618: @129468
     /* 129468 */   GIM_Reject,
     /* 129469 */   // Label 2615: @129469
     /* 129469 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(129539), // Rule ID 3239 //
     /* 129474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129509 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129537 */     GIR_RootConstrainSelectedInstOperands,
     /* 129538 */     // GIR_Coverage, 3239,
     /* 129538 */     GIR_EraseRootFromParent_Done,
     /* 129539 */   // Label 2619: @129539
     /* 129539 */   GIM_Reject,
     /* 129540 */   // Label 2616: @129540
     /* 129540 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(129652),
     /* 129545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129549 */     GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(129615), // Rule ID 3242 //
     /* 129554 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129557 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129561 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129565 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129569 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129573 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129578 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129583 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129585 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129585 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129588 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129590 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129594 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129598 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129601 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129607 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129613 */       GIR_RootConstrainSelectedInstOperands,
     /* 129614 */       // GIR_Coverage, 3242,
     /* 129614 */       GIR_EraseRootFromParent_Done,
     /* 129615 */     // Label 2621: @129615
     /* 129615 */     GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(129651), // Rule ID 3046 //
     /* 129620 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129623 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129627 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129627 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129630 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129632 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129634 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129637 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129643 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129649 */       GIR_RootConstrainSelectedInstOperands,
     /* 129650 */       // GIR_Coverage, 3046,
     /* 129650 */       GIR_EraseRootFromParent_Done,
     /* 129651 */     // Label 2622: @129651
     /* 129651 */     GIM_Reject,
     /* 129652 */   // Label 2620: @129652
     /* 129652 */   GIM_Reject,
     /* 129653 */   // Label 2617: @129653
     /* 129653 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2625*/ GIMT_Encode4(129766),
     /* 129664 */   /*GILLT_v4s32*//*Label 2623*/ GIMT_Encode4(129684), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129680 */   /*GILLT_v8s16*//*Label 2624*/ GIMT_Encode4(129725),
     /* 129684 */   // Label 2623: @129684
     /* 129684 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(129724), // Rule ID 3084 //
     /* 129689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129700 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129705 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129722 */     GIR_RootConstrainSelectedInstOperands,
     /* 129723 */     // GIR_Coverage, 3084,
     /* 129723 */     GIR_EraseRootFromParent_Done,
     /* 129724 */   // Label 2626: @129724
     /* 129724 */   GIM_Reject,
     /* 129725 */   // Label 2624: @129725
     /* 129725 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(129765), // Rule ID 3074 //
     /* 129730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129741 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129746 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129757 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129763 */     GIR_RootConstrainSelectedInstOperands,
     /* 129764 */     // GIR_Coverage, 3074,
     /* 129764 */     GIR_EraseRootFromParent_Done,
     /* 129765 */   // Label 2627: @129765
     /* 129765 */   GIM_Reject,
     /* 129766 */   // Label 2625: @129766
     /* 129766 */   GIM_Reject,
     /* 129767 */ // Label 2613: @129767
     /* 129767 */ GIM_Reject,
     /* 129768 */ // Label 74: @129768
     /* 129768 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(130047),
     /* 129773 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129776 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2632*/ GIMT_Encode4(130046),
     /* 129787 */   /*GILLT_v4s32*//*Label 2629*/ GIMT_Encode4(129819), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129803 */   /*GILLT_v8s16*//*Label 2630*/ GIMT_Encode4(129902), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129815 */   /*GILLT_v16s8*//*Label 2631*/ GIMT_Encode4(129970),
     /* 129819 */   // Label 2629: @129819
     /* 129819 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(129901), // Rule ID 3144 //
     /* 129824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129835 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129847 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129857 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129860 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129866 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129882 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129899 */     GIR_RootConstrainSelectedInstOperands,
     /* 129900 */     // GIR_Coverage, 3144,
     /* 129900 */     GIR_EraseRootFromParent_Done,
     /* 129901 */   // Label 2633: @129901
     /* 129901 */   GIM_Reject,
     /* 129902 */   // Label 2630: @129902
     /* 129902 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(129969), // Rule ID 3143 //
     /* 129907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129918 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 129918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 129925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129930 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 129940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 129945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129950 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129967 */     GIR_RootConstrainSelectedInstOperands,
     /* 129968 */     // GIR_Coverage, 3143,
     /* 129968 */     GIR_EraseRootFromParent_Done,
     /* 129969 */   // Label 2634: @129969
     /* 129969 */   GIM_Reject,
     /* 129970 */   // Label 2631: @129970
     /* 129970 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(130045), // Rule ID 3142 //
     /* 129975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129986 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 129986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 129993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129998 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130001 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130004 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130010 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130026 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130043 */     GIR_RootConstrainSelectedInstOperands,
     /* 130044 */     // GIR_Coverage, 3142,
     /* 130044 */     GIR_EraseRootFromParent_Done,
     /* 130045 */   // Label 2635: @130045
     /* 130045 */   GIM_Reject,
     /* 130046 */   // Label 2632: @130046
     /* 130046 */   GIM_Reject,
     /* 130047 */ // Label 2628: @130047
     /* 130047 */ GIM_Reject,
     /* 130048 */ // Label 75: @130048
     /* 130048 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(130336),
     /* 130053 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130056 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2640*/ GIMT_Encode4(130335),
     /* 130067 */   /*GILLT_v4s32*//*Label 2637*/ GIMT_Encode4(130099), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130083 */   /*GILLT_v8s16*//*Label 2638*/ GIMT_Encode4(130182), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130095 */   /*GILLT_v16s8*//*Label 2639*/ GIMT_Encode4(130259),
     /* 130099 */   // Label 2637: @130099
     /* 130099 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(130181), // Rule ID 3150 //
     /* 130104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130115 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130127 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130137 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130140 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130146 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130162 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130179 */     GIR_RootConstrainSelectedInstOperands,
     /* 130180 */     // GIR_Coverage, 3150,
     /* 130180 */     GIR_EraseRootFromParent_Done,
     /* 130181 */   // Label 2641: @130181
     /* 130181 */   GIM_Reject,
     /* 130182 */   // Label 2638: @130182
     /* 130182 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(130258), // Rule ID 3149 //
     /* 130187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130198 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130210 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130220 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130223 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130239 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130250 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130256 */     GIR_RootConstrainSelectedInstOperands,
     /* 130257 */     // GIR_Coverage, 3149,
     /* 130257 */     GIR_EraseRootFromParent_Done,
     /* 130258 */   // Label 2642: @130258
     /* 130258 */   GIM_Reject,
     /* 130259 */   // Label 2639: @130259
     /* 130259 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(130334), // Rule ID 3148 //
     /* 130264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130275 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130287 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130293 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130299 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130315 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130332 */     GIR_RootConstrainSelectedInstOperands,
     /* 130333 */     // GIR_Coverage, 3148,
     /* 130333 */     GIR_EraseRootFromParent_Done,
     /* 130334 */   // Label 2643: @130334
     /* 130334 */   GIM_Reject,
     /* 130335 */   // Label 2640: @130335
     /* 130335 */   GIM_Reject,
     /* 130336 */ // Label 2636: @130336
     /* 130336 */ GIM_Reject,
     /* 130337 */ // Label 76: @130337
     /* 130337 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(130617),
     /* 130342 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130345 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2648*/ GIMT_Encode4(130616),
     /* 130356 */   /*GILLT_v4s32*//*Label 2645*/ GIMT_Encode4(130388), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130372 */   /*GILLT_v8s16*//*Label 2646*/ GIMT_Encode4(130464), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130384 */   /*GILLT_v16s8*//*Label 2647*/ GIMT_Encode4(130540),
     /* 130388 */   // Label 2645: @130388
     /* 130388 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(130463), // Rule ID 3147 //
     /* 130393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130404 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130416 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130419 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130422 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130428 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130444 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130461 */     GIR_RootConstrainSelectedInstOperands,
     /* 130462 */     // GIR_Coverage, 3147,
     /* 130462 */     GIR_EraseRootFromParent_Done,
     /* 130463 */   // Label 2649: @130463
     /* 130463 */   GIM_Reject,
     /* 130464 */   // Label 2646: @130464
     /* 130464 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(130539), // Rule ID 3146 //
     /* 130469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130480 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130492 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130495 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130498 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130504 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130520 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130537 */     GIR_RootConstrainSelectedInstOperands,
     /* 130538 */     // GIR_Coverage, 3146,
     /* 130538 */     GIR_EraseRootFromParent_Done,
     /* 130539 */   // Label 2650: @130539
     /* 130539 */   GIM_Reject,
     /* 130540 */   // Label 2647: @130540
     /* 130540 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(130615), // Rule ID 3145 //
     /* 130545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130556 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130571 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130574 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130580 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130596 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130613 */     GIR_RootConstrainSelectedInstOperands,
     /* 130614 */     // GIR_Coverage, 3145,
     /* 130614 */     GIR_EraseRootFromParent_Done,
     /* 130615 */   // Label 2651: @130615
     /* 130615 */   GIM_Reject,
     /* 130616 */   // Label 2648: @130616
     /* 130616 */   GIM_Reject,
     /* 130617 */ // Label 2644: @130617
     /* 130617 */ GIM_Reject,
     /* 130618 */ // Label 77: @130618
     /* 130618 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(130913),
     /* 130623 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130626 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2656*/ GIMT_Encode4(130912),
     /* 130637 */   /*GILLT_v4s32*//*Label 2653*/ GIMT_Encode4(130669), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130653 */   /*GILLT_v8s16*//*Label 2654*/ GIMT_Encode4(130752), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130665 */   /*GILLT_v16s8*//*Label 2655*/ GIMT_Encode4(130829),
     /* 130669 */   // Label 2653: @130669
     /* 130669 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(130751), // Rule ID 3153 //
     /* 130674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130685 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130697 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130710 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130716 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130732 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130743 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130749 */     GIR_RootConstrainSelectedInstOperands,
     /* 130750 */     // GIR_Coverage, 3153,
     /* 130750 */     GIR_EraseRootFromParent_Done,
     /* 130751 */   // Label 2657: @130751
     /* 130751 */   GIM_Reject,
     /* 130752 */   // Label 2654: @130752
     /* 130752 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(130828), // Rule ID 3152 //
     /* 130757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130768 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130780 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130790 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130793 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130809 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130814 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130826 */     GIR_RootConstrainSelectedInstOperands,
     /* 130827 */     // GIR_Coverage, 3152,
     /* 130827 */     GIR_EraseRootFromParent_Done,
     /* 130828 */   // Label 2658: @130828
     /* 130828 */   GIM_Reject,
     /* 130829 */   // Label 2655: @130829
     /* 130829 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(130911), // Rule ID 3151 //
     /* 130834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130845 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130857 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130867 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130870 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130876 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130909 */     GIR_RootConstrainSelectedInstOperands,
     /* 130910 */     // GIR_Coverage, 3151,
     /* 130910 */     GIR_EraseRootFromParent_Done,
     /* 130911 */   // Label 2659: @130911
     /* 130911 */   GIM_Reject,
     /* 130912 */   // Label 2656: @130912
     /* 130912 */   GIM_Reject,
     /* 130913 */ // Label 2652: @130913
     /* 130913 */ GIM_Reject,
     /* 130914 */ // Label 78: @130914
     /* 130914 */ GIM_Reject,
     /* 130915 */ }; // Size: 130915 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
