/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the Mips target                            *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 44;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(MipsInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(MipsInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static MipsInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static MipsInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s16,
  GILLT_v2s64,
  GILLT_v4s8,
  GILLT_v4s32,
  GILLT_v8s16,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 9;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 16),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 8),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasMips2Bit = 7,
  Feature_HasMips3Bit = 17,
  Feature_HasMips4_32Bit = 27,
  Feature_NotMips4_32Bit = 28,
  Feature_HasMips4_32r2Bit = 18,
  Feature_HasMips32Bit = 3,
  Feature_HasMips32r2Bit = 6,
  Feature_HasMips32r6Bit = 29,
  Feature_NotMips32r6Bit = 4,
  Feature_IsGP64bitBit = 22,
  Feature_IsPTR64bitBit = 24,
  Feature_HasMips64Bit = 25,
  Feature_HasMips64r2Bit = 23,
  Feature_HasMips64r6Bit = 30,
  Feature_NotMips64r6Bit = 5,
  Feature_InMips16ModeBit = 31,
  Feature_NotInMips16ModeBit = 0,
  Feature_HasCnMipsBit = 26,
  Feature_NotCnMipsBit = 8,
  Feature_IsSym32Bit = 38,
  Feature_IsSym64Bit = 39,
  Feature_IsN64Bit = 40,
  Feature_RelocNotPICBit = 9,
  Feature_RelocPICBit = 37,
  Feature_NoNaNsFPMathBit = 21,
  Feature_UseAbsBit = 14,
  Feature_HasStdEncBit = 1,
  Feature_NotDSPBit = 11,
  Feature_InMicroMipsBit = 35,
  Feature_NotInMicroMipsBit = 2,
  Feature_IsLEBit = 42,
  Feature_IsBEBit = 43,
  Feature_IsNotNaClBit = 19,
  Feature_HasEVABit = 36,
  Feature_HasMSABit = 34,
  Feature_HasMadd4Bit = 20,
  Feature_UseIndirectJumpsHazardBit = 12,
  Feature_NoIndirectJumpGuardsBit = 10,
  Feature_AllowFPOpFusionBit = 41,
  Feature_IsFP64bitBit = 16,
  Feature_NotFP64bitBit = 15,
  Feature_IsNotSoftFloatBit = 13,
  Feature_HasDSPBit = 32,
  Feature_HasDSPR2Bit = 33,
};

PredicateBitset MipsInstructionSelector::
computeAvailableModuleFeatures(const MipsSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasMips2())
    Features.set(Feature_HasMips2Bit);
  if (Subtarget->hasMips3())
    Features.set(Feature_HasMips3Bit);
  if (Subtarget->hasMips4_32())
    Features.set(Feature_HasMips4_32Bit);
  if (!Subtarget->hasMips4_32())
    Features.set(Feature_NotMips4_32Bit);
  if (Subtarget->hasMips4_32r2())
    Features.set(Feature_HasMips4_32r2Bit);
  if (Subtarget->hasMips32())
    Features.set(Feature_HasMips32Bit);
  if (Subtarget->hasMips32r2())
    Features.set(Feature_HasMips32r2Bit);
  if (Subtarget->hasMips32r6())
    Features.set(Feature_HasMips32r6Bit);
  if (!Subtarget->hasMips32r6())
    Features.set(Feature_NotMips32r6Bit);
  if (Subtarget->isGP64bit())
    Features.set(Feature_IsGP64bitBit);
  if (Subtarget->isABI_N64())
    Features.set(Feature_IsPTR64bitBit);
  if (Subtarget->hasMips64())
    Features.set(Feature_HasMips64Bit);
  if (Subtarget->hasMips64r2())
    Features.set(Feature_HasMips64r2Bit);
  if (Subtarget->hasMips64r6())
    Features.set(Feature_HasMips64r6Bit);
  if (!Subtarget->hasMips64r6())
    Features.set(Feature_NotMips64r6Bit);
  if (Subtarget->inMips16Mode())
    Features.set(Feature_InMips16ModeBit);
  if (!Subtarget->inMips16Mode())
    Features.set(Feature_NotInMips16ModeBit);
  if (Subtarget->hasCnMips())
    Features.set(Feature_HasCnMipsBit);
  if (!Subtarget->hasCnMips())
    Features.set(Feature_NotCnMipsBit);
  if (Subtarget->hasSym32())
    Features.set(Feature_IsSym32Bit);
  if (!Subtarget->hasSym32())
    Features.set(Feature_IsSym64Bit);
  if (Subtarget->isABI_N64())
    Features.set(Feature_IsN64Bit);
  if (!TM.isPositionIndependent())
    Features.set(Feature_RelocNotPICBit);
  if (TM.isPositionIndependent())
    Features.set(Feature_RelocPICBit);
  if (TM.Options.NoNaNsFPMath)
    Features.set(Feature_NoNaNsFPMathBit);
  if (Subtarget->inAbs2008Mode() ||TM.Options.NoNaNsFPMath)
    Features.set(Feature_UseAbsBit);
  if (Subtarget->hasStandardEncoding())
    Features.set(Feature_HasStdEncBit);
  if (!Subtarget->hasDSP())
    Features.set(Feature_NotDSPBit);
  if (Subtarget->inMicroMipsMode())
    Features.set(Feature_InMicroMipsBit);
  if (!Subtarget->inMicroMipsMode())
    Features.set(Feature_NotInMicroMipsBit);
  if (Subtarget->isLittle())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittle())
    Features.set(Feature_IsBEBit);
  if (!Subtarget->isTargetNaCl())
    Features.set(Feature_IsNotNaClBit);
  if (Subtarget->hasEVA())
    Features.set(Feature_HasEVABit);
  if (Subtarget->hasMSA())
    Features.set(Feature_HasMSABit);
  if (!Subtarget->disableMadd4())
    Features.set(Feature_HasMadd4Bit);
  if (Subtarget->useIndirectJumpsHazard())
    Features.set(Feature_UseIndirectJumpsHazardBit);
  if (!Subtarget->useIndirectJumpsHazard())
    Features.set(Feature_NoIndirectJumpGuardsBit);
  if (TM.Options.AllowFPOpFusion == FPOpFusion::Fast)
    Features.set(Feature_AllowFPOpFusionBit);
  if (Subtarget->isFP64bit())
    Features.set(Feature_IsFP64bitBit);
  if (!Subtarget->isFP64bit())
    Features.set(Feature_NotFP64bitBit);
  if (!Subtarget->useSoftFloat())
    Features.set(Feature_IsNotSoftFloatBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDSPR2())
    Features.set(Feature_HasDSPR2Bit);
  return Features;
}

void MipsInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const MipsSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset MipsInstructionSelector::
computeAvailableFunctionFeatures(const MipsSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasCnMips,
  GIFBS_HasDSP,
  GIFBS_HasDSPR2,
  GIFBS_HasMSA,
  GIFBS_InMicroMips,
  GIFBS_InMips16Mode,
  GIFBS_IsFP64bit,
  GIFBS_NotFP64bit,
  GIFBS_NotInMips16Mode,
  GIFBS_HasDSP_InMicroMips,
  GIFBS_HasDSP_NotInMicroMips,
  GIFBS_HasDSPR2_InMicroMips,
  GIFBS_HasMSA_HasStdEnc,
  GIFBS_HasMSA_IsBE,
  GIFBS_HasMSA_IsLE,
  GIFBS_HasMips32r6_HasStdEnc,
  GIFBS_HasMips32r6_InMicroMips,
  GIFBS_HasMips64r2_HasStdEnc,
  GIFBS_HasMips64r6_HasStdEnc,
  GIFBS_HasStdEnc_IsNotSoftFloat,
  GIFBS_HasStdEnc_NotInMicroMips,
  GIFBS_HasStdEnc_NotMips4_32,
  GIFBS_InMicroMips_IsFP64bit,
  GIFBS_InMicroMips_IsNotSoftFloat,
  GIFBS_InMicroMips_NotFP64bit,
  GIFBS_InMicroMips_NotMips32r6,
  GIFBS_IsGP64bit_NotInMips16Mode,
  GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc,
  GIFBS_HasMSA_HasMips64_HasStdEnc,
  GIFBS_HasMips3_HasStdEnc_IsGP64bit,
  GIFBS_HasMips3_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r2_HasStdEnc_IsGP64bit,
  GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat,
  GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips,
  GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_NotMips4_32,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_NotFP64bit_NotMips4_32,
  GIFBS_HasStdEnc_NotInMicroMips_RelocNotPIC,
  GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat,
  GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit,
  GIFBS_InMicroMips_IsNotSoftFloat_UseAbs,
  GIFBS_InMicroMips_NotFP64bit_NotMips32r6,
  GIFBS_InMicroMips_NotMips32r6_RelocNotPIC,
  GIFBS_InMicroMips_NotMips32r6_RelocPIC,
  GIFBS_IsFP64bit_IsNotSoftFloat_NotInMips16Mode,
  GIFBS_IsNotSoftFloat_NotFP64bit_NotInMips16Mode,
  GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6,
  GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips,
  GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips32_HasStdEnc_NotMips32r6_NotMips64r6,
  GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6,
  GIFBS_HasMips64r2_HasStdEnc_IsGP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips_UseAbs,
  GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6,
  GIFBS_HasMips2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips,
  GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips,
  GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6,
  GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_UseAbs,
  GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_UseAbs,
  GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
  GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasCnMipsBit, },
  {Feature_HasDSPBit, },
  {Feature_HasDSPR2Bit, },
  {Feature_HasMSABit, },
  {Feature_InMicroMipsBit, },
  {Feature_InMips16ModeBit, },
  {Feature_IsFP64bitBit, },
  {Feature_NotFP64bitBit, },
  {Feature_NotInMips16ModeBit, },
  {Feature_HasDSPBit, Feature_InMicroMipsBit, },
  {Feature_HasDSPBit, Feature_NotInMicroMipsBit, },
  {Feature_HasDSPR2Bit, Feature_InMicroMipsBit, },
  {Feature_HasMSABit, Feature_HasStdEncBit, },
  {Feature_HasMSABit, Feature_IsBEBit, },
  {Feature_HasMSABit, Feature_IsLEBit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, },
  {Feature_HasMips32r6Bit, Feature_InMicroMipsBit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, },
  {Feature_HasMips64r6Bit, Feature_HasStdEncBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, },
  {Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotMips4_32Bit, },
  {Feature_InMicroMipsBit, Feature_IsFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, },
  {Feature_InMicroMipsBit, Feature_NotFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, },
  {Feature_IsGP64bitBit, Feature_NotInMips16ModeBit, },
  {Feature_AllowFPOpFusionBit, Feature_HasMSABit, Feature_HasStdEncBit, },
  {Feature_HasMSABit, Feature_HasMips64Bit, Feature_HasStdEncBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r2Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, },
  {Feature_HasMips32r2Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32r6Bit, Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips64r6Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotMips4_32Bit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotMips4_32Bit, },
  {Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_RelocNotPICBit, },
  {Feature_InMicroMipsBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, },
  {Feature_InMicroMipsBit, Feature_IsNotSoftFloatBit, Feature_UseAbsBit, },
  {Feature_InMicroMipsBit, Feature_NotFP64bitBit, Feature_NotMips32r6Bit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, Feature_RelocNotPICBit, },
  {Feature_InMicroMipsBit, Feature_NotMips32r6Bit, Feature_RelocPICBit, },
  {Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMips16ModeBit, },
  {Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMips16ModeBit, },
  {Feature_HasMadd4Bit, Feature_InMicroMipsBit, Feature_NoNaNsFPMathBit, Feature_NotMips32r6Bit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips3Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32Bit, Feature_HasStdEncBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips32r6Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips64r2Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasMadd4Bit, Feature_InMicroMipsBit, Feature_NoNaNsFPMathBit, Feature_NotFP64bitBit, Feature_NotMips32r6Bit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, },
  {Feature_HasMips32Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips64Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips64r6Bit, },
  {Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_UseAbsBit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_IsGP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMips4_32Bit, Feature_HasStdEncBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_NoNaNsFPMathBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_IsNotSoftFloatBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsFP64bitBit, Feature_NoNaNsFPMathBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_IsNotSoftFloatBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
  {Feature_HasMadd4Bit, Feature_HasMips4_32r2Bit, Feature_HasStdEncBit, Feature_NoNaNsFPMathBit, Feature_NotFP64bitBit, Feature_NotInMicroMipsBit, Feature_NotMips32r6Bit, Feature_NotMips64r6Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

MipsInstructionSelector::ComplexMatcherMemFn
MipsInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool MipsInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_immLi16 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_immSExt6,
  GICXXPred_I64_Predicate_immSExt10,
  GICXXPred_I64_Predicate_immSExtAddiur2,
  GICXXPred_I64_Predicate_immSExtAddius5,
  GICXXPred_I64_Predicate_immZExt1,
  GICXXPred_I64_Predicate_immZExt1Ptr,
  GICXXPred_I64_Predicate_immZExt2,
  GICXXPred_I64_Predicate_immZExt2Lsa,
  GICXXPred_I64_Predicate_immZExt2Ptr,
  GICXXPred_I64_Predicate_immZExt2Shift,
  GICXXPred_I64_Predicate_immZExt3,
  GICXXPred_I64_Predicate_immZExt3Ptr,
  GICXXPred_I64_Predicate_immZExt4,
  GICXXPred_I64_Predicate_immZExt4Ptr,
  GICXXPred_I64_Predicate_immZExt5,
  GICXXPred_I64_Predicate_immZExt5_64,
  GICXXPred_I64_Predicate_immZExt6,
  GICXXPred_I64_Predicate_immZExt8,
  GICXXPred_I64_Predicate_immZExt10,
  GICXXPred_I64_Predicate_immZExtAndi16,
  GICXXPred_I64_Predicate_immi32Cst7,
  GICXXPred_I64_Predicate_immi32Cst15,
  GICXXPred_I64_Predicate_immi32Cst31,
  GICXXPred_I64_Predicate_timmSExt6,
  GICXXPred_I64_Predicate_timmZExt1,
  GICXXPred_I64_Predicate_timmZExt1Ptr,
  GICXXPred_I64_Predicate_timmZExt2,
  GICXXPred_I64_Predicate_timmZExt2Ptr,
  GICXXPred_I64_Predicate_timmZExt3,
  GICXXPred_I64_Predicate_timmZExt3Ptr,
  GICXXPred_I64_Predicate_timmZExt4,
  GICXXPred_I64_Predicate_timmZExt4Ptr,
  GICXXPred_I64_Predicate_timmZExt5,
  GICXXPred_I64_Predicate_timmZExt6,
  GICXXPred_I64_Predicate_timmZExt8,
  GICXXPred_I64_Predicate_timmZExt10,
};
bool MipsInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_immLi16: {
    return Imm >= -1 && Imm <= 126;
  }
  case GICXXPred_I64_Predicate_immSExt6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_immSExt10: {
    return isInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immSExtAddiur2: {
    return Imm == 1 || Imm == -1 ||
                                               ((Imm % 4 == 0) &&
                                                Imm < 28 && Imm > 0);
  }
  case GICXXPred_I64_Predicate_immSExtAddius5: {
    return Imm >= -8 && Imm <= 7;
  }
  case GICXXPred_I64_Predicate_immZExt1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt1Ptr: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2Lsa: {
    return isUInt<2>(Imm - 1);
  }
  case GICXXPred_I64_Predicate_immZExt2Ptr: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt2Shift: {
    return Imm >= 1 && Imm <= 8;
  }
  case GICXXPred_I64_Predicate_immZExt3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt3Ptr: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt4Ptr: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt5: {
    return Imm == (Imm & 0x1f);
  }
  case GICXXPred_I64_Predicate_immZExt5_64: {
     return Imm == (Imm & 0x1f); 
  }
  case GICXXPred_I64_Predicate_immZExt6: {
    return Imm == (Imm & 0x3f);
  }
  case GICXXPred_I64_Predicate_immZExt8: {
    return isUInt<8>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExt10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immZExtAndi16: {
    return (Imm == 128 || (Imm >= 1 && Imm <= 4) || Imm == 7 || Imm == 8 ||
                Imm == 15 || Imm == 16 || Imm == 31 || Imm == 32 || Imm == 63 ||
                Imm == 64 || Imm == 255 || Imm == 32768 || Imm == 65535 );
  }
  case GICXXPred_I64_Predicate_immi32Cst7: {
    return isUInt<32>(Imm) && Imm == 7;
  }
  case GICXXPred_I64_Predicate_immi32Cst15: {
    return isUInt<32>(Imm) && Imm == 15;
  }
  case GICXXPred_I64_Predicate_immi32Cst31: {
    return isUInt<32>(Imm) && Imm == 31;
  }
  case GICXXPred_I64_Predicate_timmSExt6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt1Ptr: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt2Ptr: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt3Ptr: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt4Ptr: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt5: {
    return Imm == (Imm & 0x1f);
  }
  case GICXXPred_I64_Predicate_timmZExt6: {
    return Imm == (Imm & 0x3f);
  }
  case GICXXPred_I64_Predicate_timmZExt8: {
    return isUInt<8>(Imm);
  }
  case GICXXPred_I64_Predicate_timmZExt10: {
    return isUInt<10>(Imm);
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool MipsInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_imm32SExt16 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_imm32ZExt16,
};
bool MipsInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_imm32SExt16: {
     return isInt<16>(Imm.getSExtValue()); 
  }
  case GICXXPred_APInt_Predicate_imm32ZExt16: {
    
      return (uint32_t)Imm.getZExtValue() == (unsigned short)Imm.getZExtValue();
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool MipsInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("MipsInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
MipsInstructionSelector::CustomRendererFn
MipsInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool MipsInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool MipsInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("MipsInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *MipsInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*     0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(287), /*)*//*default:*//*Label 77*/ GIMT_Encode4(69625),
     /*    10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(946),
     /*    14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(2244),
     /*    18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(2935),
     /*    22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(3416),
     /*    26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(3685),
     /*    30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(3954),
     /*    34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(4223), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(4492),
     /*    50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(5048),
     /*    54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(5452), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 10*/ GIMT_Encode4(6344),
     /*   106 */ /*TargetOpcode::G_BUILD_VECTOR*//*Label 11*/ GIMT_Encode4(6417), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   126 */ /*TargetOpcode::G_BITCAST*//*Label 12*/ GIMT_Encode4(6758), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   170 */ /*TargetOpcode::G_LOAD*//*Label 13*/ GIMT_Encode4(11069),
     /*   174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 14*/ GIMT_Encode4(11134),
     /*   178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 15*/ GIMT_Encode4(11202), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 16*/ GIMT_Encode4(11270),
     /*   210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 17*/ GIMT_Encode4(11462),
     /*   214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 18*/ GIMT_Encode4(11632),
     /*   218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 19*/ GIMT_Encode4(11802),
     /*   222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 20*/ GIMT_Encode4(11972),
     /*   226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 21*/ GIMT_Encode4(12142),
     /*   230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 22*/ GIMT_Encode4(12312),
     /*   234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 23*/ GIMT_Encode4(12482),
     /*   238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 24*/ GIMT_Encode4(12652),
     /*   242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 25*/ GIMT_Encode4(12822),
     /*   246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 26*/ GIMT_Encode4(12992),
     /*   250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 27*/ GIMT_Encode4(13162), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   302 */ /*TargetOpcode::G_BRCOND*//*Label 28*/ GIMT_Encode4(13332), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   314 */ /*TargetOpcode::G_INTRINSIC*//*Label 29*/ GIMT_Encode4(18053),
     /*   318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 30*/ GIMT_Encode4(32318), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   330 */ /*TargetOpcode::G_ANYEXT*//*Label 31*/ GIMT_Encode4(37412),
     /*   334 */ /*TargetOpcode::G_TRUNC*//*Label 32*/ GIMT_Encode4(37478),
     /*   338 */ /*TargetOpcode::G_CONSTANT*//*Label 33*/ GIMT_Encode4(37542), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   354 */ /*TargetOpcode::G_SEXT*//*Label 34*/ GIMT_Encode4(37603),
     /*   358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 35*/ GIMT_Encode4(39067),
     /*   362 */ /*TargetOpcode::G_ZEXT*//*Label 36*/ GIMT_Encode4(39415),
     /*   366 */ /*TargetOpcode::G_SHL*//*Label 37*/ GIMT_Encode4(39616),
     /*   370 */ /*TargetOpcode::G_LSHR*//*Label 38*/ GIMT_Encode4(41413),
     /*   374 */ /*TargetOpcode::G_ASHR*//*Label 39*/ GIMT_Encode4(43210), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   386 */ /*TargetOpcode::G_ROTR*//*Label 40*/ GIMT_Encode4(44965), GIMT_Encode4(0),
     /*   394 */ /*TargetOpcode::G_ICMP*//*Label 41*/ GIMT_Encode4(45253),
     /*   398 */ /*TargetOpcode::G_FCMP*//*Label 42*/ GIMT_Encode4(47784), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   410 */ /*TargetOpcode::G_SELECT*//*Label 43*/ GIMT_Encode4(49490), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   454 */ /*TargetOpcode::G_UMULH*//*Label 44*/ GIMT_Encode4(61528),
     /*   458 */ /*TargetOpcode::G_SMULH*//*Label 45*/ GIMT_Encode4(61637), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   518 */ /*TargetOpcode::G_FADD*//*Label 46*/ GIMT_Encode4(61746),
     /*   522 */ /*TargetOpcode::G_FSUB*//*Label 47*/ GIMT_Encode4(62659),
     /*   526 */ /*TargetOpcode::G_FMUL*//*Label 48*/ GIMT_Encode4(63271),
     /*   530 */ /*TargetOpcode::G_FMA*//*Label 49*/ GIMT_Encode4(63758), GIMT_Encode4(0),
     /*   538 */ /*TargetOpcode::G_FDIV*//*Label 50*/ GIMT_Encode4(63864), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   558 */ /*TargetOpcode::G_FEXP2*//*Label 51*/ GIMT_Encode4(64163), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   570 */ /*TargetOpcode::G_FLOG2*//*Label 52*/ GIMT_Encode4(64241), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   586 */ /*TargetOpcode::G_FNEG*//*Label 53*/ GIMT_Encode4(64319),
     /*   590 */ /*TargetOpcode::G_FPEXT*//*Label 54*/ GIMT_Encode4(65688),
     /*   594 */ /*TargetOpcode::G_FPTRUNC*//*Label 55*/ GIMT_Encode4(65866),
     /*   598 */ /*TargetOpcode::G_FPTOSI*//*Label 56*/ GIMT_Encode4(66029),
     /*   602 */ /*TargetOpcode::G_FPTOUI*//*Label 57*/ GIMT_Encode4(66107),
     /*   606 */ /*TargetOpcode::G_SITOFP*//*Label 58*/ GIMT_Encode4(66185),
     /*   610 */ /*TargetOpcode::G_UITOFP*//*Label 59*/ GIMT_Encode4(66438), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   622 */ /*TargetOpcode::G_FABS*//*Label 60*/ GIMT_Encode4(66516), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 61*/ GIMT_Encode4(66756), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 62*/ GIMT_Encode4(66830),
     /*   650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 63*/ GIMT_Encode4(66902), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   694 */ /*TargetOpcode::G_SMIN*//*Label 64*/ GIMT_Encode4(66974),
     /*   698 */ /*TargetOpcode::G_SMAX*//*Label 65*/ GIMT_Encode4(67142),
     /*   702 */ /*TargetOpcode::G_UMIN*//*Label 66*/ GIMT_Encode4(67310),
     /*   706 */ /*TargetOpcode::G_UMAX*//*Label 67*/ GIMT_Encode4(67478), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   722 */ /*TargetOpcode::G_BR*//*Label 68*/ GIMT_Encode4(67646), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   742 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 69*/ GIMT_Encode4(67770),
     /*   746 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 70*/ GIMT_Encode4(68334), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   774 */ /*TargetOpcode::G_CTLZ*//*Label 71*/ GIMT_Encode4(68386), GIMT_Encode4(0),
     /*   782 */ /*TargetOpcode::G_CTPOP*//*Label 72*/ GIMT_Encode4(68891),
     /*   786 */ /*TargetOpcode::G_BSWAP*//*Label 73*/ GIMT_Encode4(69097), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   842 */ /*TargetOpcode::G_FSQRT*//*Label 74*/ GIMT_Encode4(69261), GIMT_Encode4(0),
     /*   850 */ /*TargetOpcode::G_FRINT*//*Label 75*/ GIMT_Encode4(69501), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   942 */ /*TargetOpcode::G_TRAP*//*Label 76*/ GIMT_Encode4(69579),
     /*   946 */ // Label 0: @946
     /*   946 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 86*/ GIMT_Encode4(2243),
     /*   957 */ /*GILLT_s32*//*Label 78*/ GIMT_Encode4(989),
     /*   961 */ /*GILLT_s64*//*Label 79*/ GIMT_Encode4(1397),
     /*   965 */ /*GILLT_v2s16*//*Label 80*/ GIMT_Encode4(1563),
     /*   969 */ /*GILLT_v2s64*//*Label 81*/ GIMT_Encode4(1595),
     /*   973 */ /*GILLT_v4s8*//*Label 82*/ GIMT_Encode4(1749),
     /*   977 */ /*GILLT_v4s32*//*Label 83*/ GIMT_Encode4(1781),
     /*   981 */ /*GILLT_v8s16*//*Label 84*/ GIMT_Encode4(1935),
     /*   985 */ /*GILLT_v16s8*//*Label 85*/ GIMT_Encode4(2089),
     /*   989 */ // Label 78: @989
     /*   989 */ GIM_Try, /*On fail goto*//*Label 87*/ GIMT_Encode4(1396),
     /*   994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  1000 */   GIM_Try, /*On fail goto*//*Label 88*/ GIMT_Encode4(1067), // Rule ID 2396 //
     /*  1005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  1024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1041 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1045 */     // MIs[2] Operand 1
     /*  1045 */     // No operand predicates
     /*  1045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1051 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa), GPR32Opnd:{ *:[i32] }:$rt)  =>  (LSA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LSA),
     /*  1054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /*  1062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1065 */     GIR_RootConstrainSelectedInstOperands,
     /*  1066 */     // GIR_Coverage, 2396,
     /*  1066 */     GIR_EraseRootFromParent_Done,
     /*  1067 */   // Label 88: @1067
     /*  1067 */   GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1134), // Rule ID 834 //
     /*  1072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  1095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1116 */     // MIs[2] Operand 1
     /*  1116 */     // No operand predicates
     /*  1116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1118 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa))  =>  (LSA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LSA),
     /*  1121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /*  1129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1132 */     GIR_RootConstrainSelectedInstOperands,
     /*  1133 */     // GIR_Coverage, 834,
     /*  1133 */     GIR_EraseRootFromParent_Done,
     /*  1134 */   // Label 89: @1134
     /*  1134 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1176), // Rule ID 40 //
     /*  1139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  1142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1158 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32SExt16),
     /*  1162 */     // MIs[1] Operand 1
     /*  1162 */     // No operand predicates
     /*  1162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1164 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32SExt16>>:$imm16)  =>  (ADDiu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  1164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDiu),
     /*  1167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  1169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  1171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  1174 */     GIR_RootConstrainSelectedInstOperands,
     /*  1175 */     // GIR_Coverage, 40,
     /*  1175 */     GIR_EraseRootFromParent_Done,
     /*  1176 */   // Label 90: @1176
     /*  1176 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1218), // Rule ID 2165 //
     /*  1181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  1184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1200 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExtAddiur2),
     /*  1204 */     // MIs[1] Operand 1
     /*  1204 */     // No operand predicates
     /*  1204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1206 */     // (add:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddiur2>>:$imm)  =>  (ADDIUR2_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddiur2>>:$imm)
     /*  1206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDIUR2_MM),
     /*  1209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1211 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  1216 */     GIR_RootConstrainSelectedInstOperands,
     /*  1217 */     // GIR_Coverage, 2165,
     /*  1217 */     GIR_EraseRootFromParent_Done,
     /*  1218 */   // Label 91: @1218
     /*  1218 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1260), // Rule ID 2166 //
     /*  1223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  1226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExtAddius5),
     /*  1246 */     // MIs[1] Operand 1
     /*  1246 */     // No operand predicates
     /*  1246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddius5>>:$imm)  =>  (ADDIUS5_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immSExtAddius5>>:$imm)
     /*  1248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDIUS5_MM),
     /*  1251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  1253 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  1255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  1258 */     GIR_RootConstrainSelectedInstOperands,
     /*  1259 */     // GIR_Coverage, 2166,
     /*  1259 */     GIR_EraseRootFromParent_Done,
     /*  1260 */   // Label 92: @1260
     /*  1260 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1287), // Rule ID 1208 //
     /*  1265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  1268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1280 */     // (add:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (ADDU16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  1280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU16_MMR6),
     /*  1285 */     GIR_RootConstrainSelectedInstOperands,
     /*  1286 */     // GIR_Coverage, 1208,
     /*  1286 */     GIR_Done,
     /*  1287 */   // Label 93: @1287
     /*  1287 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1314), // Rule ID 46 //
     /*  1292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  1295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1307 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  1307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDu),
     /*  1312 */     GIR_RootConstrainSelectedInstOperands,
     /*  1313 */     // GIR_Coverage, 46,
     /*  1313 */     GIR_Done,
     /*  1314 */   // Label 94: @1314
     /*  1314 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1341), // Rule ID 1060 //
     /*  1319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  1322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  1334 */     // (add:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (ADDU16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  1334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU16_MM),
     /*  1339 */     GIR_RootConstrainSelectedInstOperands,
     /*  1340 */     // GIR_Coverage, 1060,
     /*  1340 */     GIR_Done,
     /*  1341 */   // Label 95: @1341
     /*  1341 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1368), // Rule ID 1072 //
     /*  1346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  1349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  1361 */     // (add:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  1361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDu_MM),
     /*  1366 */     GIR_RootConstrainSelectedInstOperands,
     /*  1367 */     // GIR_Coverage, 1072,
     /*  1367 */     GIR_Done,
     /*  1368 */   // Label 96: @1368
     /*  1368 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1395), // Rule ID 1823 //
     /*  1373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  1376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  1388 */     // (add:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (AdduRxRyRz16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  1388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AdduRxRyRz16),
     /*  1393 */     GIR_RootConstrainSelectedInstOperands,
     /*  1394 */     // GIR_Coverage, 1823,
     /*  1394 */     GIR_Done,
     /*  1395 */   // Label 97: @1395
     /*  1395 */   GIM_Reject,
     /*  1396 */ // Label 87: @1396
     /*  1396 */ GIM_Reject,
     /*  1397 */ // Label 79: @1397
     /*  1397 */ GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1562),
     /*  1402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  1405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  1408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1412 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1475), // Rule ID 2397 //
     /*  1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  1420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  1432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1449 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1453 */     // MIs[2] Operand 1
     /*  1453 */     // No operand predicates
     /*  1453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1459 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa), GPR64Opnd:{ *:[i64] }:$rt)  =>  (DLSA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DLSA),
     /*  1462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /*  1470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1473 */     GIR_RootConstrainSelectedInstOperands,
     /*  1474 */     // GIR_Coverage, 2397,
     /*  1474 */     GIR_EraseRootFromParent_Done,
     /*  1475 */   // Label 99: @1475
     /*  1475 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(1538), // Rule ID 835 //
     /*  1480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  1483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  1495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  1499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  1503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  1512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  1516 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Lsa),
     /*  1520 */     // MIs[2] Operand 1
     /*  1520 */     // No operand predicates
     /*  1520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  1522 */     // (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2Lsa>>:$sa))  =>  (DLSA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$sa)
     /*  1522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DLSA),
     /*  1525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  1527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  1531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /*  1533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sa
     /*  1536 */     GIR_RootConstrainSelectedInstOperands,
     /*  1537 */     // GIR_Coverage, 835,
     /*  1537 */     GIR_EraseRootFromParent_Done,
     /*  1538 */   // Label 100: @1538
     /*  1538 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(1561), // Rule ID 202 //
     /*  1543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /*  1546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  1554 */     // (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DADDu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  1554 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DADDu),
     /*  1559 */     GIR_RootConstrainSelectedInstOperands,
     /*  1560 */     // GIR_Coverage, 202,
     /*  1560 */     GIR_Done,
     /*  1561 */   // Label 101: @1561
     /*  1561 */   GIM_Reject,
     /*  1562 */ // Label 98: @1562
     /*  1562 */ GIM_Reject,
     /*  1563 */ // Label 80: @1563
     /*  1563 */ GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(1594), // Rule ID 1922 //
     /*  1568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  1571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  1574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  1577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  1581 */   // (add:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (ADDQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  1581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDQ_PH),
     /*  1586 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  1592 */   GIR_RootConstrainSelectedInstOperands,
     /*  1593 */   // GIR_Coverage, 1922,
     /*  1593 */   GIR_Done,
     /*  1594 */ // Label 102: @1594
     /*  1594 */ GIM_Reject,
     /*  1595 */ // Label 81: @1595
     /*  1595 */ GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(1748),
     /*  1600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1610 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(1667), // Rule ID 2401 //
     /*  1615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1650 */     // (add:{ *:[v2i64] } (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt), MSA128DOpnd:{ *:[v2i64] }:$wd_in)  =>  (MADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_D),
     /*  1653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1655 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1665 */     GIR_RootConstrainSelectedInstOperands,
     /*  1666 */     // GIR_Coverage, 2401,
     /*  1666 */     GIR_EraseRootFromParent_Done,
     /*  1667 */   // Label 104: @1667
     /*  1667 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(1724), // Rule ID 843 //
     /*  1672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  1691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  1695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1707 */     // (add:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt))  =>  (MADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_D),
     /*  1710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1712 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  1714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1722 */     GIR_RootConstrainSelectedInstOperands,
     /*  1723 */     // GIR_Coverage, 843,
     /*  1723 */     GIR_EraseRootFromParent_Done,
     /*  1724 */   // Label 105: @1724
     /*  1724 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(1747), // Rule ID 510 //
     /*  1729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  1740 */     // (add:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  1740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_D),
     /*  1745 */     GIR_RootConstrainSelectedInstOperands,
     /*  1746 */     // GIR_Coverage, 510,
     /*  1746 */     GIR_Done,
     /*  1747 */   // Label 106: @1747
     /*  1747 */   GIM_Reject,
     /*  1748 */ // Label 103: @1748
     /*  1748 */ GIM_Reject,
     /*  1749 */ // Label 82: @1749
     /*  1749 */ GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(1780), // Rule ID 1928 //
     /*  1754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  1757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  1760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /*  1763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  1767 */   // (add:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (ADDU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /*  1767 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDU_QB),
     /*  1772 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  1778 */   GIR_RootConstrainSelectedInstOperands,
     /*  1779 */   // GIR_Coverage, 1928,
     /*  1779 */   GIR_Done,
     /*  1780 */ // Label 107: @1780
     /*  1780 */ GIM_Reject,
     /*  1781 */ // Label 83: @1781
     /*  1781 */ GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(1934),
     /*  1786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1796 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(1853), // Rule ID 2400 //
     /*  1801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1836 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt), MSA128WOpnd:{ *:[v4i32] }:$wd_in)  =>  (MADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_W),
     /*  1839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1841 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1851 */     GIR_RootConstrainSelectedInstOperands,
     /*  1852 */     // GIR_Coverage, 2400,
     /*  1852 */     GIR_EraseRootFromParent_Done,
     /*  1853 */   // Label 109: @1853
     /*  1853 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(1910), // Rule ID 842 //
     /*  1858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  1869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  1877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  1881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1893 */     // (add:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt))  =>  (MADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_W),
     /*  1896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1898 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  1900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  1904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  1908 */     GIR_RootConstrainSelectedInstOperands,
     /*  1909 */     // GIR_Coverage, 842,
     /*  1909 */     GIR_EraseRootFromParent_Done,
     /*  1910 */   // Label 110: @1910
     /*  1910 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(1933), // Rule ID 509 //
     /*  1915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  1926 */     // (add:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  1926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_W),
     /*  1931 */     GIR_RootConstrainSelectedInstOperands,
     /*  1932 */     // GIR_Coverage, 509,
     /*  1932 */     GIR_Done,
     /*  1933 */   // Label 111: @1933
     /*  1933 */   GIM_Reject,
     /*  1934 */ // Label 108: @1934
     /*  1934 */ GIM_Reject,
     /*  1935 */ // Label 84: @1935
     /*  1935 */ GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(2088),
     /*  1940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  1943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  1946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1950 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(2007), // Rule ID 2399 //
     /*  1955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  1958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  1962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  1966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  1970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  1974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  1988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  1990 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt), MSA128HOpnd:{ *:[v8i16] }:$wd_in)  =>  (MADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  1990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_H),
     /*  1993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  1995 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  1997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2005 */     GIR_RootConstrainSelectedInstOperands,
     /*  2006 */     // GIR_Coverage, 2399,
     /*  2006 */     GIR_EraseRootFromParent_Done,
     /*  2007 */   // Label 113: @2007
     /*  2007 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(2064), // Rule ID 841 //
     /*  2012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2047 */     // (add:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt))  =>  (MADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_H),
     /*  2050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2052 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2062 */     GIR_RootConstrainSelectedInstOperands,
     /*  2063 */     // GIR_Coverage, 841,
     /*  2063 */     GIR_EraseRootFromParent_Done,
     /*  2064 */   // Label 114: @2064
     /*  2064 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(2087), // Rule ID 508 //
     /*  2069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2080 */     // (add:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_H),
     /*  2085 */     GIR_RootConstrainSelectedInstOperands,
     /*  2086 */     // GIR_Coverage, 508,
     /*  2086 */     GIR_Done,
     /*  2087 */   // Label 115: @2087
     /*  2087 */   GIM_Reject,
     /*  2088 */ // Label 112: @2088
     /*  2088 */ GIM_Reject,
     /*  2089 */ // Label 85: @2089
     /*  2089 */ GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(2242),
     /*  2094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2104 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2161), // Rule ID 2398 //
     /*  2109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2144 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt), MSA128BOpnd:{ *:[v16i8] }:$wd_in)  =>  (MADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_B),
     /*  2147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2149 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /*  2151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2159 */     GIR_RootConstrainSelectedInstOperands,
     /*  2160 */     // GIR_Coverage, 2398,
     /*  2160 */     GIR_EraseRootFromParent_Done,
     /*  2161 */   // Label 117: @2161
     /*  2161 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2218), // Rule ID 840 //
     /*  2166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2201 */     // (add:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt))  =>  (MADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDV_B),
     /*  2204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2206 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2216 */     GIR_RootConstrainSelectedInstOperands,
     /*  2217 */     // GIR_Coverage, 840,
     /*  2217 */     GIR_EraseRootFromParent_Done,
     /*  2218 */   // Label 118: @2218
     /*  2218 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2241), // Rule ID 507 //
     /*  2223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2234 */     // (add:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2234 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ADDV_B),
     /*  2239 */     GIR_RootConstrainSelectedInstOperands,
     /*  2240 */     // GIR_Coverage, 507,
     /*  2240 */     GIR_Done,
     /*  2241 */   // Label 119: @2241
     /*  2241 */   GIM_Reject,
     /*  2242 */ // Label 116: @2242
     /*  2242 */ GIM_Reject,
     /*  2243 */ // Label 86: @2243
     /*  2243 */ GIM_Reject,
     /*  2244 */ // Label 1: @2244
     /*  2244 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 128*/ GIMT_Encode4(2934),
     /*  2255 */ /*GILLT_s32*//*Label 120*/ GIMT_Encode4(2287),
     /*  2259 */ /*GILLT_s64*//*Label 121*/ GIMT_Encode4(2464),
     /*  2263 */ /*GILLT_v2s16*//*Label 122*/ GIMT_Encode4(2498),
     /*  2267 */ /*GILLT_v2s64*//*Label 123*/ GIMT_Encode4(2530),
     /*  2271 */ /*GILLT_v4s8*//*Label 124*/ GIMT_Encode4(2623),
     /*  2275 */ /*GILLT_v4s32*//*Label 125*/ GIMT_Encode4(2655),
     /*  2279 */ /*GILLT_v8s16*//*Label 126*/ GIMT_Encode4(2748),
     /*  2283 */ /*GILLT_v16s8*//*Label 127*/ GIMT_Encode4(2841),
     /*  2287 */ // Label 120: @2287
     /*  2287 */ GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(2463),
     /*  2292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  2295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  2298 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(2327), // Rule ID 1822 //
     /*  2303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  2306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  2314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2318 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, CPU16Regs:{ *:[i32] }:$r)  =>  (NegRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r)
     /*  2318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NegRxRy16),
     /*  2321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /*  2323 */     GIR_RootToRootCopy, /*OpIdx*/2, // r
     /*  2325 */     GIR_RootConstrainSelectedInstOperands,
     /*  2326 */     // GIR_Coverage, 1822,
     /*  2326 */     GIR_EraseRootFromParent_Done,
     /*  2327 */   // Label 130: @2327
     /*  2327 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(2354), // Rule ID 1210 //
     /*  2332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  2335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2347 */     // (sub:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (SUBU16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  2347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU16_MMR6),
     /*  2352 */     GIR_RootConstrainSelectedInstOperands,
     /*  2353 */     // GIR_Coverage, 1210,
     /*  2353 */     GIR_Done,
     /*  2354 */   // Label 131: @2354
     /*  2354 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(2381), // Rule ID 47 //
     /*  2359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  2362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2374 */     // (sub:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  2374 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBu),
     /*  2379 */     GIR_RootConstrainSelectedInstOperands,
     /*  2380 */     // GIR_Coverage, 47,
     /*  2380 */     GIR_Done,
     /*  2381 */   // Label 132: @2381
     /*  2381 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(2408), // Rule ID 1064 //
     /*  2386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  2389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  2401 */     // (sub:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (SUBU16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  2401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU16_MM),
     /*  2406 */     GIR_RootConstrainSelectedInstOperands,
     /*  2407 */     // GIR_Coverage, 1064,
     /*  2407 */     GIR_Done,
     /*  2408 */   // Label 133: @2408
     /*  2408 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(2435), // Rule ID 1073 //
     /*  2413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  2416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  2428 */     // (sub:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  2428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBu_MM),
     /*  2433 */     GIR_RootConstrainSelectedInstOperands,
     /*  2434 */     // GIR_Coverage, 1073,
     /*  2434 */     GIR_Done,
     /*  2435 */   // Label 134: @2435
     /*  2435 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(2462), // Rule ID 1827 //
     /*  2440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  2443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  2455 */     // (sub:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (SubuRxRyRz16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  2455 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SubuRxRyRz16),
     /*  2460 */     GIR_RootConstrainSelectedInstOperands,
     /*  2461 */     // GIR_Coverage, 1827,
     /*  2461 */     GIR_Done,
     /*  2462 */   // Label 135: @2462
     /*  2462 */   GIM_Reject,
     /*  2463 */ // Label 129: @2463
     /*  2463 */ GIM_Reject,
     /*  2464 */ // Label 121: @2464
     /*  2464 */ GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(2497), // Rule ID 203 //
     /*  2469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /*  2472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  2475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  2478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  2490 */   // (sub:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DSUBu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  2490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSUBu),
     /*  2495 */   GIR_RootConstrainSelectedInstOperands,
     /*  2496 */   // GIR_Coverage, 203,
     /*  2496 */   GIR_Done,
     /*  2497 */ // Label 136: @2497
     /*  2497 */ GIM_Reject,
     /*  2498 */ // Label 122: @2498
     /*  2498 */ GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(2529), // Rule ID 1924 //
     /*  2503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  2506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  2509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  2512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  2516 */   // (sub:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (SUBQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  2516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBQ_PH),
     /*  2521 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  2527 */   GIR_RootConstrainSelectedInstOperands,
     /*  2528 */   // GIR_Coverage, 1924,
     /*  2528 */   GIR_Done,
     /*  2529 */ // Label 137: @2529
     /*  2529 */ GIM_Reject,
     /*  2530 */ // Label 123: @2530
     /*  2530 */ GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(2622),
     /*  2535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2549 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(2602), // Rule ID 899 //
     /*  2554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  2569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  2573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2585 */     // (sub:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt))  =>  (MSUBV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  2585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_D),
     /*  2588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2590 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2600 */     GIR_RootConstrainSelectedInstOperands,
     /*  2601 */     // GIR_Coverage, 899,
     /*  2601 */     GIR_EraseRootFromParent_Done,
     /*  2602 */   // Label 139: @2602
     /*  2602 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(2621), // Rule ID 1028 //
     /*  2607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  2614 */     // (sub:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  2614 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_D),
     /*  2619 */     GIR_RootConstrainSelectedInstOperands,
     /*  2620 */     // GIR_Coverage, 1028,
     /*  2620 */     GIR_Done,
     /*  2621 */   // Label 140: @2621
     /*  2621 */   GIM_Reject,
     /*  2622 */ // Label 138: @2622
     /*  2622 */ GIM_Reject,
     /*  2623 */ // Label 124: @2623
     /*  2623 */ GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(2654), // Rule ID 1930 //
     /*  2628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  2631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  2634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /*  2637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  2641 */   // (sub:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (SUBU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /*  2641 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBU_QB),
     /*  2646 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag20), GIMT_Encode2(RegState::Dead),
     /*  2652 */   GIR_RootConstrainSelectedInstOperands,
     /*  2653 */   // GIR_Coverage, 1930,
     /*  2653 */   GIR_Done,
     /*  2654 */ // Label 141: @2654
     /*  2654 */ GIM_Reject,
     /*  2655 */ // Label 125: @2655
     /*  2655 */ GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(2747),
     /*  2660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2674 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(2727), // Rule ID 898 //
     /*  2679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  2694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  2698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2710 */     // (sub:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt))  =>  (MSUBV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  2710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_W),
     /*  2713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2715 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2725 */     GIR_RootConstrainSelectedInstOperands,
     /*  2726 */     // GIR_Coverage, 898,
     /*  2726 */     GIR_EraseRootFromParent_Done,
     /*  2727 */   // Label 143: @2727
     /*  2727 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(2746), // Rule ID 1027 //
     /*  2732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  2739 */     // (sub:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  2739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_W),
     /*  2744 */     GIR_RootConstrainSelectedInstOperands,
     /*  2745 */     // GIR_Coverage, 1027,
     /*  2745 */     GIR_Done,
     /*  2746 */   // Label 144: @2746
     /*  2746 */   GIM_Reject,
     /*  2747 */ // Label 142: @2747
     /*  2747 */ GIM_Reject,
     /*  2748 */ // Label 126: @2748
     /*  2748 */ GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(2840),
     /*  2753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2767 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(2820), // Rule ID 897 //
     /*  2772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  2787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  2791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2803 */     // (sub:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt))  =>  (MSUBV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_H),
     /*  2806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2808 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2818 */     GIR_RootConstrainSelectedInstOperands,
     /*  2819 */     // GIR_Coverage, 897,
     /*  2819 */     GIR_EraseRootFromParent_Done,
     /*  2820 */   // Label 146: @2820
     /*  2820 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(2839), // Rule ID 1026 //
     /*  2825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  2832 */     // (sub:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  2832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_H),
     /*  2837 */     GIR_RootConstrainSelectedInstOperands,
     /*  2838 */     // GIR_Coverage, 1026,
     /*  2838 */     GIR_Done,
     /*  2839 */   // Label 147: @2839
     /*  2839 */   GIM_Reject,
     /*  2840 */ // Label 145: @2840
     /*  2840 */ GIM_Reject,
     /*  2841 */ // Label 127: @2841
     /*  2841 */ GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(2933),
     /*  2846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2860 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(2913), // Rule ID 896 //
     /*  2865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  2872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  2876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  2880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  2884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  2896 */     // (sub:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt))  =>  (MSUBV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBV_B),
     /*  2899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  2901 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /*  2903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /*  2907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /*  2911 */     GIR_RootConstrainSelectedInstOperands,
     /*  2912 */     // GIR_Coverage, 896,
     /*  2912 */     GIR_EraseRootFromParent_Done,
     /*  2913 */   // Label 149: @2913
     /*  2913 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(2932), // Rule ID 1025 //
     /*  2918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  2921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  2925 */     // (sub:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  2925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SUBV_B),
     /*  2930 */     GIR_RootConstrainSelectedInstOperands,
     /*  2931 */     // GIR_Coverage, 1025,
     /*  2931 */     GIR_Done,
     /*  2932 */   // Label 150: @2932
     /*  2932 */   GIM_Reject,
     /*  2933 */ // Label 148: @2933
     /*  2933 */ GIM_Reject,
     /*  2934 */ // Label 128: @2934
     /*  2934 */ GIM_Reject,
     /*  2935 */ // Label 2: @2935
     /*  2935 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 158*/ GIMT_Encode4(3415),
     /*  2946 */ /*GILLT_s32*//*Label 151*/ GIMT_Encode4(2978),
     /*  2950 */ /*GILLT_s64*//*Label 152*/ GIMT_Encode4(3162),
     /*  2954 */ /*GILLT_v2s16*//*Label 153*/ GIMT_Encode4(3247),
     /*  2958 */ /*GILLT_v2s64*//*Label 154*/ GIMT_Encode4(3279), GIMT_Encode4(0),
     /*  2966 */ /*GILLT_v4s32*//*Label 155*/ GIMT_Encode4(3313),
     /*  2970 */ /*GILLT_v8s16*//*Label 156*/ GIMT_Encode4(3347),
     /*  2974 */ /*GILLT_v16s8*//*Label 157*/ GIMT_Encode4(3381),
     /*  2978 */ // Label 151: @2978
     /*  2978 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(3161),
     /*  2983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  2986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  2989 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(3028), // Rule ID 48 //
     /*  2994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /*  2997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3009 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL:{ *:[i32] }:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL),
     /*  3014 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3020 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3026 */     GIR_RootConstrainSelectedInstOperands,
     /*  3027 */     // GIR_Coverage, 48,
     /*  3027 */     GIR_Done,
     /*  3028 */   // Label 160: @3028
     /*  3028 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(3055), // Rule ID 332 //
     /*  3033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3048 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_R6),
     /*  3053 */     GIR_RootConstrainSelectedInstOperands,
     /*  3054 */     // GIR_Coverage, 332,
     /*  3054 */     GIR_Done,
     /*  3055 */   // Label 161: @3055
     /*  3055 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(3094), // Rule ID 1074 //
     /*  3060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  3063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3075 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_MM:{ *:[i32] }:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_MM),
     /*  3080 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3086 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3092 */     GIR_RootConstrainSelectedInstOperands,
     /*  3093 */     // GIR_Coverage, 1074,
     /*  3093 */     GIR_Done,
     /*  3094 */   // Label 162: @3094
     /*  3094 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(3121), // Rule ID 1179 //
     /*  3099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3114 */     // (mul:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUL_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_MMR6),
     /*  3119 */     GIR_RootConstrainSelectedInstOperands,
     /*  3120 */     // GIR_Coverage, 1179,
     /*  3120 */     GIR_Done,
     /*  3121 */   // Label 163: @3121
     /*  3121 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(3160), // Rule ID 1825 //
     /*  3126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  3129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  3141 */     // (mul:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (MultRxRyRz16:{ *:[i32] }:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  3141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MultRxRyRz16),
     /*  3146 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3152 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3158 */     GIR_RootConstrainSelectedInstOperands,
     /*  3159 */     // GIR_Coverage, 1825,
     /*  3159 */     GIR_Done,
     /*  3160 */   // Label 164: @3160
     /*  3160 */   GIM_Reject,
     /*  3161 */ // Label 159: @3161
     /*  3161 */ GIM_Reject,
     /*  3162 */ // Label 152: @3162
     /*  3162 */ GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(3246),
     /*  3167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3185 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(3230), // Rule ID 274 //
     /*  3190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /*  3193 */     // (mul:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUL:{ *:[i64] }:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUL),
     /*  3198 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::HI0), GIMT_Encode2(RegState::Dead),
     /*  3204 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::LO0), GIMT_Encode2(RegState::Dead),
     /*  3210 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P0), GIMT_Encode2(RegState::Dead),
     /*  3216 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P1), GIMT_Encode2(RegState::Dead),
     /*  3222 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::P2), GIMT_Encode2(RegState::Dead),
     /*  3228 */     GIR_RootConstrainSelectedInstOperands,
     /*  3229 */     // GIR_Coverage, 274,
     /*  3229 */     GIR_Done,
     /*  3230 */   // Label 166: @3230
     /*  3230 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(3245), // Rule ID 347 //
     /*  3235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3238 */     // (mul:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUL_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUL_R6),
     /*  3243 */     GIR_RootConstrainSelectedInstOperands,
     /*  3244 */     // GIR_Coverage, 347,
     /*  3244 */     GIR_Done,
     /*  3245 */   // Label 167: @3245
     /*  3245 */   GIM_Reject,
     /*  3246 */ // Label 165: @3246
     /*  3246 */ GIM_Reject,
     /*  3247 */ // Label 153: @3247
     /*  3247 */ GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(3278), // Rule ID 1926 //
     /*  3252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /*  3255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  3258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /*  3261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  3265 */   // (mul:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (MUL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /*  3265 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUL_PH),
     /*  3270 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::DSPOutFlag21), GIMT_Encode2(RegState::Dead),
     /*  3276 */   GIR_RootConstrainSelectedInstOperands,
     /*  3277 */   // GIR_Coverage, 1926,
     /*  3277 */   GIR_Done,
     /*  3278 */ // Label 168: @3278
     /*  3278 */ GIM_Reject,
     /*  3279 */ // Label 154: @3279
     /*  3279 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(3312), // Rule ID 907 //
     /*  3284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3305 */   // (mul:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MULV_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_D),
     /*  3310 */   GIR_RootConstrainSelectedInstOperands,
     /*  3311 */   // GIR_Coverage, 907,
     /*  3311 */   GIR_Done,
     /*  3312 */ // Label 169: @3312
     /*  3312 */ GIM_Reject,
     /*  3313 */ // Label 155: @3313
     /*  3313 */ GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3346), // Rule ID 906 //
     /*  3318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3339 */   // (mul:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MULV_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_W),
     /*  3344 */   GIR_RootConstrainSelectedInstOperands,
     /*  3345 */   // GIR_Coverage, 906,
     /*  3345 */   GIR_Done,
     /*  3346 */ // Label 170: @3346
     /*  3346 */ GIM_Reject,
     /*  3347 */ // Label 156: @3347
     /*  3347 */ GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3380), // Rule ID 905 //
     /*  3352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3373 */   // (mul:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MULV_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_H),
     /*  3378 */   GIR_RootConstrainSelectedInstOperands,
     /*  3379 */   // GIR_Coverage, 905,
     /*  3379 */   GIR_Done,
     /*  3380 */ // Label 171: @3380
     /*  3380 */ GIM_Reject,
     /*  3381 */ // Label 157: @3381
     /*  3381 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3414), // Rule ID 904 //
     /*  3386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3407 */   // (mul:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MULV_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MULV_B),
     /*  3412 */   GIR_RootConstrainSelectedInstOperands,
     /*  3413 */   // GIR_Coverage, 904,
     /*  3413 */   GIR_Done,
     /*  3414 */ // Label 172: @3414
     /*  3414 */ GIM_Reject,
     /*  3415 */ // Label 158: @3415
     /*  3415 */ GIM_Reject,
     /*  3416 */ // Label 3: @3416
     /*  3416 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 179*/ GIMT_Encode4(3684),
     /*  3427 */ /*GILLT_s32*//*Label 173*/ GIMT_Encode4(3459),
     /*  3431 */ /*GILLT_s64*//*Label 174*/ GIMT_Encode4(3514), GIMT_Encode4(0),
     /*  3439 */ /*GILLT_v2s64*//*Label 175*/ GIMT_Encode4(3548), GIMT_Encode4(0),
     /*  3447 */ /*GILLT_v4s32*//*Label 176*/ GIMT_Encode4(3582),
     /*  3451 */ /*GILLT_v8s16*//*Label 177*/ GIMT_Encode4(3616),
     /*  3455 */ /*GILLT_v16s8*//*Label 178*/ GIMT_Encode4(3650),
     /*  3459 */ // Label 173: @3459
     /*  3459 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(3513),
     /*  3464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3482 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(3497), // Rule ID 326 //
     /*  3487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3490 */     // (sdiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV),
     /*  3495 */     GIR_RootConstrainSelectedInstOperands,
     /*  3496 */     // GIR_Coverage, 326,
     /*  3496 */     GIR_Done,
     /*  3497 */   // Label 181: @3497
     /*  3497 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3512), // Rule ID 1172 //
     /*  3502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3505 */     // (sdiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIV_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3505 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_MMR6),
     /*  3510 */     GIR_RootConstrainSelectedInstOperands,
     /*  3511 */     // GIR_Coverage, 1172,
     /*  3511 */     GIR_Done,
     /*  3512 */   // Label 182: @3512
     /*  3512 */   GIM_Reject,
     /*  3513 */ // Label 180: @3513
     /*  3513 */ GIM_Reject,
     /*  3514 */ // Label 174: @3514
     /*  3514 */ GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3547), // Rule ID 341 //
     /*  3519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3540 */   // (sdiv:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DDIV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DDIV),
     /*  3545 */   GIR_RootConstrainSelectedInstOperands,
     /*  3546 */   // GIR_Coverage, 341,
     /*  3546 */   GIR_Done,
     /*  3547 */ // Label 183: @3547
     /*  3547 */ GIM_Reject,
     /*  3548 */ // Label 175: @3548
     /*  3548 */ GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3581), // Rule ID 647 //
     /*  3553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3570 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3574 */   // (sdiv:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (DIV_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_D),
     /*  3579 */   GIR_RootConstrainSelectedInstOperands,
     /*  3580 */   // GIR_Coverage, 647,
     /*  3580 */   GIR_Done,
     /*  3581 */ // Label 184: @3581
     /*  3581 */ GIM_Reject,
     /*  3582 */ // Label 176: @3582
     /*  3582 */ GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3615), // Rule ID 646 //
     /*  3587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3608 */   // (sdiv:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DIV_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_W),
     /*  3613 */   GIR_RootConstrainSelectedInstOperands,
     /*  3614 */   // GIR_Coverage, 646,
     /*  3614 */   GIR_Done,
     /*  3615 */ // Label 185: @3615
     /*  3615 */ GIM_Reject,
     /*  3616 */ // Label 177: @3616
     /*  3616 */ GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3649), // Rule ID 645 //
     /*  3621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3642 */   // (sdiv:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DIV_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_H),
     /*  3647 */   GIR_RootConstrainSelectedInstOperands,
     /*  3648 */   // GIR_Coverage, 645,
     /*  3648 */   GIR_Done,
     /*  3649 */ // Label 186: @3649
     /*  3649 */ GIM_Reject,
     /*  3650 */ // Label 178: @3650
     /*  3650 */ GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3683), // Rule ID 644 //
     /*  3655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3676 */   // (sdiv:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DIV_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_S_B),
     /*  3681 */   GIR_RootConstrainSelectedInstOperands,
     /*  3682 */   // GIR_Coverage, 644,
     /*  3682 */   GIR_Done,
     /*  3683 */ // Label 187: @3683
     /*  3683 */ GIM_Reject,
     /*  3684 */ // Label 179: @3684
     /*  3684 */ GIM_Reject,
     /*  3685 */ // Label 4: @3685
     /*  3685 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 194*/ GIMT_Encode4(3953),
     /*  3696 */ /*GILLT_s32*//*Label 188*/ GIMT_Encode4(3728),
     /*  3700 */ /*GILLT_s64*//*Label 189*/ GIMT_Encode4(3783), GIMT_Encode4(0),
     /*  3708 */ /*GILLT_v2s64*//*Label 190*/ GIMT_Encode4(3817), GIMT_Encode4(0),
     /*  3716 */ /*GILLT_v4s32*//*Label 191*/ GIMT_Encode4(3851),
     /*  3720 */ /*GILLT_v8s16*//*Label 192*/ GIMT_Encode4(3885),
     /*  3724 */ /*GILLT_v16s8*//*Label 193*/ GIMT_Encode4(3919),
     /*  3728 */ // Label 188: @3728
     /*  3728 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(3782),
     /*  3733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  3736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  3739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  3751 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(3766), // Rule ID 327 //
     /*  3756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  3759 */     // (udiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIVU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIVU),
     /*  3764 */     GIR_RootConstrainSelectedInstOperands,
     /*  3765 */     // GIR_Coverage, 327,
     /*  3765 */     GIR_Done,
     /*  3766 */   // Label 196: @3766
     /*  3766 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(3781), // Rule ID 1173 //
     /*  3771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  3774 */     // (udiv:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (DIVU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  3774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIVU_MMR6),
     /*  3779 */     GIR_RootConstrainSelectedInstOperands,
     /*  3780 */     // GIR_Coverage, 1173,
     /*  3780 */     GIR_Done,
     /*  3781 */   // Label 197: @3781
     /*  3781 */   GIM_Reject,
     /*  3782 */ // Label 195: @3782
     /*  3782 */ GIM_Reject,
     /*  3783 */ // Label 189: @3783
     /*  3783 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(3816), // Rule ID 342 //
     /*  3788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  3791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  3794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  3797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  3809 */   // (udiv:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DDIVU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  3809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DDIVU),
     /*  3814 */   GIR_RootConstrainSelectedInstOperands,
     /*  3815 */   // GIR_Coverage, 342,
     /*  3815 */   GIR_Done,
     /*  3816 */ // Label 198: @3816
     /*  3816 */ GIM_Reject,
     /*  3817 */ // Label 190: @3817
     /*  3817 */ GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(3850), // Rule ID 651 //
     /*  3822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  3828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  3831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3839 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  3843 */   // (udiv:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (DIV_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  3843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_D),
     /*  3848 */   GIR_RootConstrainSelectedInstOperands,
     /*  3849 */   // GIR_Coverage, 651,
     /*  3849 */   GIR_Done,
     /*  3850 */ // Label 199: @3850
     /*  3850 */ GIM_Reject,
     /*  3851 */ // Label 191: @3851
     /*  3851 */ GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(3884), // Rule ID 650 //
     /*  3856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  3862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  3865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  3877 */   // (udiv:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DIV_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  3877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_W),
     /*  3882 */   GIR_RootConstrainSelectedInstOperands,
     /*  3883 */   // GIR_Coverage, 650,
     /*  3883 */   GIR_Done,
     /*  3884 */ // Label 200: @3884
     /*  3884 */ GIM_Reject,
     /*  3885 */ // Label 192: @3885
     /*  3885 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(3918), // Rule ID 649 //
     /*  3890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  3896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  3899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  3911 */   // (udiv:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DIV_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  3911 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_H),
     /*  3916 */   GIR_RootConstrainSelectedInstOperands,
     /*  3917 */   // GIR_Coverage, 649,
     /*  3917 */   GIR_Done,
     /*  3918 */ // Label 201: @3918
     /*  3918 */ GIM_Reject,
     /*  3919 */ // Label 193: @3919
     /*  3919 */ GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(3952), // Rule ID 648 //
     /*  3924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  3927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  3930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  3933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  3945 */   // (udiv:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DIV_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  3945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DIV_U_B),
     /*  3950 */   GIR_RootConstrainSelectedInstOperands,
     /*  3951 */   // GIR_Coverage, 648,
     /*  3951 */   GIR_Done,
     /*  3952 */ // Label 202: @3952
     /*  3952 */ GIM_Reject,
     /*  3953 */ // Label 194: @3953
     /*  3953 */ GIM_Reject,
     /*  3954 */ // Label 5: @3954
     /*  3954 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 209*/ GIMT_Encode4(4222),
     /*  3965 */ /*GILLT_s32*//*Label 203*/ GIMT_Encode4(3997),
     /*  3969 */ /*GILLT_s64*//*Label 204*/ GIMT_Encode4(4052), GIMT_Encode4(0),
     /*  3977 */ /*GILLT_v2s64*//*Label 205*/ GIMT_Encode4(4086), GIMT_Encode4(0),
     /*  3985 */ /*GILLT_v4s32*//*Label 206*/ GIMT_Encode4(4120),
     /*  3989 */ /*GILLT_v8s16*//*Label 207*/ GIMT_Encode4(4154),
     /*  3993 */ /*GILLT_v16s8*//*Label 208*/ GIMT_Encode4(4188),
     /*  3997 */ // Label 203: @3997
     /*  3997 */ GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(4051),
     /*  4002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4020 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(4035), // Rule ID 328 //
     /*  4025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  4028 */     // (srem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MOD:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD),
     /*  4033 */     GIR_RootConstrainSelectedInstOperands,
     /*  4034 */     // GIR_Coverage, 328,
     /*  4034 */     GIR_Done,
     /*  4035 */   // Label 211: @4035
     /*  4035 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(4050), // Rule ID 1177 //
     /*  4040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4043 */     // (srem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MOD_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4043 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_MMR6),
     /*  4048 */     GIR_RootConstrainSelectedInstOperands,
     /*  4049 */     // GIR_Coverage, 1177,
     /*  4049 */     GIR_Done,
     /*  4050 */   // Label 212: @4050
     /*  4050 */   GIM_Reject,
     /*  4051 */ // Label 210: @4051
     /*  4051 */ GIM_Reject,
     /*  4052 */ // Label 204: @4052
     /*  4052 */ GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(4085), // Rule ID 343 //
     /*  4057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  4060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4078 */   // (srem:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMOD:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMOD),
     /*  4083 */   GIR_RootConstrainSelectedInstOperands,
     /*  4084 */   // GIR_Coverage, 343,
     /*  4084 */   GIR_Done,
     /*  4085 */ // Label 213: @4085
     /*  4085 */ GIM_Reject,
     /*  4086 */ // Label 205: @4086
     /*  4086 */ GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(4119), // Rule ID 887 //
     /*  4091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4112 */   // (srem:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MOD_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_D),
     /*  4117 */   GIR_RootConstrainSelectedInstOperands,
     /*  4118 */   // GIR_Coverage, 887,
     /*  4118 */   GIR_Done,
     /*  4119 */ // Label 214: @4119
     /*  4119 */ GIM_Reject,
     /*  4120 */ // Label 206: @4120
     /*  4120 */ GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(4153), // Rule ID 886 //
     /*  4125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4142 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4146 */   // (srem:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MOD_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4146 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_W),
     /*  4151 */   GIR_RootConstrainSelectedInstOperands,
     /*  4152 */   // GIR_Coverage, 886,
     /*  4152 */   GIR_Done,
     /*  4153 */ // Label 215: @4153
     /*  4153 */ GIM_Reject,
     /*  4154 */ // Label 207: @4154
     /*  4154 */ GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(4187), // Rule ID 885 //
     /*  4159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4180 */   // (srem:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MOD_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_H),
     /*  4185 */   GIR_RootConstrainSelectedInstOperands,
     /*  4186 */   // GIR_Coverage, 885,
     /*  4186 */   GIR_Done,
     /*  4187 */ // Label 216: @4187
     /*  4187 */ GIM_Reject,
     /*  4188 */ // Label 208: @4188
     /*  4188 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(4221), // Rule ID 884 //
     /*  4193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4214 */   // (srem:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MOD_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  4214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_S_B),
     /*  4219 */   GIR_RootConstrainSelectedInstOperands,
     /*  4220 */   // GIR_Coverage, 884,
     /*  4220 */   GIR_Done,
     /*  4221 */ // Label 217: @4221
     /*  4221 */ GIM_Reject,
     /*  4222 */ // Label 209: @4222
     /*  4222 */ GIM_Reject,
     /*  4223 */ // Label 6: @4223
     /*  4223 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 224*/ GIMT_Encode4(4491),
     /*  4234 */ /*GILLT_s32*//*Label 218*/ GIMT_Encode4(4266),
     /*  4238 */ /*GILLT_s64*//*Label 219*/ GIMT_Encode4(4321), GIMT_Encode4(0),
     /*  4246 */ /*GILLT_v2s64*//*Label 220*/ GIMT_Encode4(4355), GIMT_Encode4(0),
     /*  4254 */ /*GILLT_v4s32*//*Label 221*/ GIMT_Encode4(4389),
     /*  4258 */ /*GILLT_v8s16*//*Label 222*/ GIMT_Encode4(4423),
     /*  4262 */ /*GILLT_v16s8*//*Label 223*/ GIMT_Encode4(4457),
     /*  4266 */ // Label 218: @4266
     /*  4266 */ GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(4320),
     /*  4271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4289 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(4304), // Rule ID 329 //
     /*  4294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /*  4297 */     // (urem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4297 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MODU),
     /*  4302 */     GIR_RootConstrainSelectedInstOperands,
     /*  4303 */     // GIR_Coverage, 329,
     /*  4303 */     GIR_Done,
     /*  4304 */   // Label 226: @4304
     /*  4304 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(4319), // Rule ID 1178 //
     /*  4309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4312 */     // (urem:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MODU_MMR6),
     /*  4317 */     GIR_RootConstrainSelectedInstOperands,
     /*  4318 */     // GIR_Coverage, 1178,
     /*  4318 */     GIR_Done,
     /*  4319 */   // Label 227: @4319
     /*  4319 */   GIM_Reject,
     /*  4320 */ // Label 225: @4320
     /*  4320 */ GIM_Reject,
     /*  4321 */ // Label 219: @4321
     /*  4321 */ GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(4354), // Rule ID 344 //
     /*  4326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /*  4329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4347 */   // (urem:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMODU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4347 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMODU),
     /*  4352 */   GIR_RootConstrainSelectedInstOperands,
     /*  4353 */   // GIR_Coverage, 344,
     /*  4353 */   GIR_Done,
     /*  4354 */ // Label 228: @4354
     /*  4354 */ GIM_Reject,
     /*  4355 */ // Label 220: @4355
     /*  4355 */ GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(4388), // Rule ID 891 //
     /*  4360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4381 */   // (urem:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MOD_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_D),
     /*  4386 */   GIR_RootConstrainSelectedInstOperands,
     /*  4387 */   // GIR_Coverage, 891,
     /*  4387 */   GIR_Done,
     /*  4388 */ // Label 229: @4388
     /*  4388 */ GIM_Reject,
     /*  4389 */ // Label 221: @4389
     /*  4389 */ GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(4422), // Rule ID 890 //
     /*  4394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4415 */   // (urem:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MOD_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4415 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_W),
     /*  4420 */   GIR_RootConstrainSelectedInstOperands,
     /*  4421 */   // GIR_Coverage, 890,
     /*  4421 */   GIR_Done,
     /*  4422 */ // Label 230: @4422
     /*  4422 */ GIM_Reject,
     /*  4423 */ // Label 222: @4423
     /*  4423 */ GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(4456), // Rule ID 889 //
     /*  4428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4449 */   // (urem:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MOD_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  4449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_H),
     /*  4454 */   GIR_RootConstrainSelectedInstOperands,
     /*  4455 */   // GIR_Coverage, 889,
     /*  4455 */   GIR_Done,
     /*  4456 */ // Label 231: @4456
     /*  4456 */ GIM_Reject,
     /*  4457 */ // Label 223: @4457
     /*  4457 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(4490), // Rule ID 888 //
     /*  4462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  4468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  4471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  4483 */   // (urem:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MOD_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  4483 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MOD_U_B),
     /*  4488 */   GIR_RootConstrainSelectedInstOperands,
     /*  4489 */   // GIR_Coverage, 888,
     /*  4489 */   GIR_Done,
     /*  4490 */ // Label 232: @4490
     /*  4490 */ GIM_Reject,
     /*  4491 */ // Label 224: @4491
     /*  4491 */ GIM_Reject,
     /*  4492 */ // Label 7: @4492
     /*  4492 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 239*/ GIMT_Encode4(5047),
     /*  4503 */ /*GILLT_s32*//*Label 233*/ GIMT_Encode4(4535),
     /*  4507 */ /*GILLT_s64*//*Label 234*/ GIMT_Encode4(4809), GIMT_Encode4(0),
     /*  4515 */ /*GILLT_v2s64*//*Label 235*/ GIMT_Encode4(4911), GIMT_Encode4(0),
     /*  4523 */ /*GILLT_v4s32*//*Label 236*/ GIMT_Encode4(4945),
     /*  4527 */ /*GILLT_v8s16*//*Label 237*/ GIMT_Encode4(4979),
     /*  4531 */ /*GILLT_v16s8*//*Label 238*/ GIMT_Encode4(5013),
     /*  4535 */ // Label 233: @4535
     /*  4535 */ GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(4808),
     /*  4540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  4543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  4546 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(4588), // Rule ID 41 //
     /*  4551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  4554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4570 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  4574 */     // MIs[1] Operand 1
     /*  4574 */     // No operand predicates
     /*  4574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4576 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (ANDi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  4576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDi),
     /*  4579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  4581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  4583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  4586 */     GIR_RootConstrainSelectedInstOperands,
     /*  4587 */     // GIR_Coverage, 41,
     /*  4587 */     GIR_EraseRootFromParent_Done,
     /*  4588 */   // Label 241: @4588
     /*  4588 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(4630), // Rule ID 2168 //
     /*  4593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  4596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExtAndi16),
     /*  4616 */     // MIs[1] Operand 1
     /*  4616 */     // No operand predicates
     /*  4616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4618 */     // (and:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)  =>  (ANDI16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)
     /*  4618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDI16_MM),
     /*  4621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4623 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  4625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  4628 */     GIR_RootConstrainSelectedInstOperands,
     /*  4629 */     // GIR_Coverage, 2168,
     /*  4629 */     GIR_EraseRootFromParent_Done,
     /*  4630 */   // Label 242: @4630
     /*  4630 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(4672), // Rule ID 2327 //
     /*  4635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  4650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  4654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExtAndi16),
     /*  4658 */     // MIs[1] Operand 1
     /*  4658 */     // No operand predicates
     /*  4658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4660 */     // (and:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)  =>  (ANDI16_MMR6:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExtAndi16>>:$imm)
     /*  4660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ANDI16_MMR6),
     /*  4663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4665 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  4667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  4670 */     GIR_RootConstrainSelectedInstOperands,
     /*  4671 */     // GIR_Coverage, 2327,
     /*  4671 */     GIR_EraseRootFromParent_Done,
     /*  4672 */   // Label 243: @4672
     /*  4672 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(4699), // Rule ID 51 //
     /*  4677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  4680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4692 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND),
     /*  4697 */     GIR_RootConstrainSelectedInstOperands,
     /*  4698 */     // GIR_Coverage, 51,
     /*  4698 */     GIR_Done,
     /*  4699 */   // Label 244: @4699
     /*  4699 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(4726), // Rule ID 1061 //
     /*  4704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  4707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  4719 */     // (and:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (AND16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  4719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND16_MM),
     /*  4724 */     GIR_RootConstrainSelectedInstOperands,
     /*  4725 */     // GIR_Coverage, 1061,
     /*  4725 */     GIR_Done,
     /*  4726 */   // Label 245: @4726
     /*  4726 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(4753), // Rule ID 1077 //
     /*  4731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  4734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4746 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_MM),
     /*  4751 */     GIR_RootConstrainSelectedInstOperands,
     /*  4752 */     // GIR_Coverage, 1077,
     /*  4752 */     GIR_Done,
     /*  4753 */   // Label 246: @4753
     /*  4753 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(4780), // Rule ID 1170 //
     /*  4758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  4761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  4773 */     // (and:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (AND_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  4773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_MMR6),
     /*  4778 */     GIR_RootConstrainSelectedInstOperands,
     /*  4779 */     // GIR_Coverage, 1170,
     /*  4779 */     GIR_Done,
     /*  4780 */   // Label 247: @4780
     /*  4780 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(4807), // Rule ID 1824 //
     /*  4785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  4788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  4800 */     // (and:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (AndRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  4800 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AndRxRxRy16),
     /*  4805 */     GIR_RootConstrainSelectedInstOperands,
     /*  4806 */     // GIR_Coverage, 1824,
     /*  4806 */     GIR_Done,
     /*  4807 */   // Label 248: @4807
     /*  4807 */   GIM_Reject,
     /*  4808 */ // Label 240: @4808
     /*  4808 */ GIM_Reject,
     /*  4809 */ // Label 234: @4809
     /*  4809 */ GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(4910),
     /*  4814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  4817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  4820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4824 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(4886), // Rule ID 269 //
     /*  4829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /*  4832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  4836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  4840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  4844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  4848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4858 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  4869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  4871 */     // (and:{ *:[i64] } (add:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt), 255:{ *:[i64] })  =>  (BADDu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BADDu),
     /*  4874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  4876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  4880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  4884 */     GIR_RootConstrainSelectedInstOperands,
     /*  4885 */     // GIR_Coverage, 269,
     /*  4885 */     GIR_EraseRootFromParent_Done,
     /*  4886 */   // Label 250: @4886
     /*  4886 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(4909), // Rule ID 206 //
     /*  4891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  4894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  4902 */     // (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (AND64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  4902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND64),
     /*  4907 */     GIR_RootConstrainSelectedInstOperands,
     /*  4908 */     // GIR_Coverage, 206,
     /*  4908 */     GIR_Done,
     /*  4909 */   // Label 251: @4909
     /*  4909 */   GIM_Reject,
     /*  4910 */ // Label 249: @4910
     /*  4910 */ GIM_Reject,
     /*  4911 */ // Label 235: @4911
     /*  4911 */ GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(4944), // Rule ID 518 //
     /*  4916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  4922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  4925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  4937 */   // (and:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AND_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  4937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_D_PSEUDO),
     /*  4942 */   GIR_RootConstrainSelectedInstOperands,
     /*  4943 */   // GIR_Coverage, 518,
     /*  4943 */   GIR_Done,
     /*  4944 */ // Label 252: @4944
     /*  4944 */ GIM_Reject,
     /*  4945 */ // Label 236: @4945
     /*  4945 */ GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(4978), // Rule ID 517 //
     /*  4950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  4956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  4959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  4971 */   // (and:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AND_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  4971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_W_PSEUDO),
     /*  4976 */   GIR_RootConstrainSelectedInstOperands,
     /*  4977 */   // GIR_Coverage, 517,
     /*  4977 */   GIR_Done,
     /*  4978 */ // Label 253: @4978
     /*  4978 */ GIM_Reject,
     /*  4979 */ // Label 237: @4979
     /*  4979 */ GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(5012), // Rule ID 516 //
     /*  4984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  4987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  4990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  4993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  4997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5005 */   // (and:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AND_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  5005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V_H_PSEUDO),
     /*  5010 */   GIR_RootConstrainSelectedInstOperands,
     /*  5011 */   // GIR_Coverage, 516,
     /*  5011 */   GIR_Done,
     /*  5012 */ // Label 254: @5012
     /*  5012 */ GIM_Reject,
     /*  5013 */ // Label 238: @5013
     /*  5013 */ GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(5046), // Rule ID 515 //
     /*  5018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  5024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  5027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5039 */   // (and:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AND_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  5039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::AND_V),
     /*  5044 */   GIR_RootConstrainSelectedInstOperands,
     /*  5045 */   // GIR_Coverage, 515,
     /*  5045 */   GIR_Done,
     /*  5046 */ // Label 255: @5046
     /*  5046 */ GIM_Reject,
     /*  5047 */ // Label 239: @5047
     /*  5047 */ GIM_Reject,
     /*  5048 */ // Label 8: @5048
     /*  5048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 262*/ GIMT_Encode4(5451),
     /*  5059 */ /*GILLT_s32*//*Label 256*/ GIMT_Encode4(5091),
     /*  5063 */ /*GILLT_s64*//*Label 257*/ GIMT_Encode4(5281), GIMT_Encode4(0),
     /*  5071 */ /*GILLT_v2s64*//*Label 258*/ GIMT_Encode4(5315), GIMT_Encode4(0),
     /*  5079 */ /*GILLT_v4s32*//*Label 259*/ GIMT_Encode4(5349),
     /*  5083 */ /*GILLT_v8s16*//*Label 260*/ GIMT_Encode4(5383),
     /*  5087 */ /*GILLT_v16s8*//*Label 261*/ GIMT_Encode4(5417),
     /*  5091 */ // Label 256: @5091
     /*  5091 */ GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(5280),
     /*  5096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5102 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(5144), // Rule ID 42 //
     /*  5107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5126 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  5130 */     // MIs[1] Operand 1
     /*  5130 */     // No operand predicates
     /*  5130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5132 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (ORi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  5132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ORi),
     /*  5135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  5142 */     GIR_RootConstrainSelectedInstOperands,
     /*  5143 */     // GIR_Coverage, 42,
     /*  5143 */     GIR_EraseRootFromParent_Done,
     /*  5144 */   // Label 264: @5144
     /*  5144 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(5171), // Rule ID 52 //
     /*  5149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5164 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR),
     /*  5169 */     GIR_RootConstrainSelectedInstOperands,
     /*  5170 */     // GIR_Coverage, 52,
     /*  5170 */     GIR_Done,
     /*  5171 */   // Label 265: @5171
     /*  5171 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(5198), // Rule ID 1063 //
     /*  5176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5191 */     // (or:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (OR16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  5191 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR16_MM),
     /*  5196 */     GIR_RootConstrainSelectedInstOperands,
     /*  5197 */     // GIR_Coverage, 1063,
     /*  5197 */     GIR_Done,
     /*  5198 */   // Label 266: @5198
     /*  5198 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(5225), // Rule ID 1078 //
     /*  5203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5218 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5218 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_MM),
     /*  5223 */     GIR_RootConstrainSelectedInstOperands,
     /*  5224 */     // GIR_Coverage, 1078,
     /*  5224 */     GIR_Done,
     /*  5225 */   // Label 267: @5225
     /*  5225 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(5252), // Rule ID 1183 //
     /*  5230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5245 */     // (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (OR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_MMR6),
     /*  5250 */     GIR_RootConstrainSelectedInstOperands,
     /*  5251 */     // GIR_Coverage, 1183,
     /*  5251 */     GIR_Done,
     /*  5252 */   // Label 268: @5252
     /*  5252 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(5279), // Rule ID 1826 //
     /*  5257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  5260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5272 */     // (or:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (OrRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  5272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OrRxRxRy16),
     /*  5277 */     GIR_RootConstrainSelectedInstOperands,
     /*  5278 */     // GIR_Coverage, 1826,
     /*  5278 */     GIR_Done,
     /*  5279 */   // Label 269: @5279
     /*  5279 */   GIM_Reject,
     /*  5280 */ // Label 263: @5280
     /*  5280 */ GIM_Reject,
     /*  5281 */ // Label 257: @5281
     /*  5281 */ GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(5314), // Rule ID 207 //
     /*  5286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  5289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  5292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  5295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  5307 */   // (or:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (OR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  5307 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /*  5312 */   GIR_RootConstrainSelectedInstOperands,
     /*  5313 */   // GIR_Coverage, 207,
     /*  5313 */   GIR_Done,
     /*  5314 */ // Label 270: @5314
     /*  5314 */ GIM_Reject,
     /*  5315 */ // Label 258: @5315
     /*  5315 */ GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(5348), // Rule ID 924 //
     /*  5320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  5326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  5329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  5341 */   // (or:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (OR_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  5341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_D_PSEUDO),
     /*  5346 */   GIR_RootConstrainSelectedInstOperands,
     /*  5347 */   // GIR_Coverage, 924,
     /*  5347 */   GIR_Done,
     /*  5348 */ // Label 271: @5348
     /*  5348 */ GIM_Reject,
     /*  5349 */ // Label 259: @5349
     /*  5349 */ GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(5382), // Rule ID 923 //
     /*  5354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  5360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  5363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  5375 */   // (or:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (OR_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  5375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_W_PSEUDO),
     /*  5380 */   GIR_RootConstrainSelectedInstOperands,
     /*  5381 */   // GIR_Coverage, 923,
     /*  5381 */   GIR_Done,
     /*  5382 */ // Label 272: @5382
     /*  5382 */ GIM_Reject,
     /*  5383 */ // Label 260: @5383
     /*  5383 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(5416), // Rule ID 922 //
     /*  5388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  5394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  5397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  5409 */   // (or:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (OR_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  5409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V_H_PSEUDO),
     /*  5414 */   GIR_RootConstrainSelectedInstOperands,
     /*  5415 */   // GIR_Coverage, 922,
     /*  5415 */   GIR_Done,
     /*  5416 */ // Label 273: @5416
     /*  5416 */ GIM_Reject,
     /*  5417 */ // Label 261: @5417
     /*  5417 */ GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(5450), // Rule ID 921 //
     /*  5422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  5425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  5428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  5431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  5443 */   // (or:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (OR_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  5443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::OR_V),
     /*  5448 */   GIR_RootConstrainSelectedInstOperands,
     /*  5449 */   // GIR_Coverage, 921,
     /*  5449 */   GIR_Done,
     /*  5450 */ // Label 274: @5450
     /*  5450 */ GIM_Reject,
     /*  5451 */ // Label 262: @5451
     /*  5451 */ GIM_Reject,
     /*  5452 */ // Label 9: @5452
     /*  5452 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 281*/ GIMT_Encode4(6343),
     /*  5463 */ /*GILLT_s32*//*Label 275*/ GIMT_Encode4(5495),
     /*  5467 */ /*GILLT_s64*//*Label 276*/ GIMT_Encode4(6112), GIMT_Encode4(0),
     /*  5475 */ /*GILLT_v2s64*//*Label 277*/ GIMT_Encode4(6207), GIMT_Encode4(0),
     /*  5483 */ /*GILLT_v4s32*//*Label 278*/ GIMT_Encode4(6241),
     /*  5487 */ /*GILLT_v8s16*//*Label 279*/ GIMT_Encode4(6275),
     /*  5491 */ /*GILLT_v16s8*//*Label 280*/ GIMT_Encode4(6309),
     /*  5495 */ // Label 275: @5495
     /*  5495 */ GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(6111),
     /*  5500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  5503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  5506 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(5565), // Rule ID 54 //
     /*  5511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5530 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5550 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /*  5553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5563 */     GIR_RootConstrainSelectedInstOperands,
     /*  5564 */     // GIR_Coverage, 54,
     /*  5564 */     GIR_EraseRootFromParent_Done,
     /*  5565 */   // Label 283: @5565
     /*  5565 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(5624), // Rule ID 1080 //
     /*  5570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5609 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MM),
     /*  5612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5622 */     GIR_RootConstrainSelectedInstOperands,
     /*  5623 */     // GIR_Coverage, 1080,
     /*  5623 */     GIR_EraseRootFromParent_Done,
     /*  5624 */   // Label 284: @5624
     /*  5624 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(5683), // Rule ID 1182 //
     /*  5629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  5640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  5644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  5648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  5652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5662 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5668 */     // (xor:{ *:[i32] } (or:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt), -1:{ *:[i32] })  =>  (NOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /*  5671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  5677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  5681 */     GIR_RootConstrainSelectedInstOperands,
     /*  5682 */     // GIR_Coverage, 1182,
     /*  5682 */     GIR_EraseRootFromParent_Done,
     /*  5683 */   // Label 285: @5683
     /*  5683 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(5712), // Rule ID 1209 //
     /*  5688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5703 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] })  =>  (NOT16_MMR6:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs)
     /*  5703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MMR6),
     /*  5706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5710 */     GIR_RootConstrainSelectedInstOperands,
     /*  5711 */     // GIR_Coverage, 1209,
     /*  5711 */     GIR_EraseRootFromParent_Done,
     /*  5712 */   // Label 286: @5712
     /*  5712 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(5741), // Rule ID 1062 //
     /*  5717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  5720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5732 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] })  =>  (NOT16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs)
     /*  5732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MM),
     /*  5735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5739 */     GIR_RootConstrainSelectedInstOperands,
     /*  5740 */     // GIR_Coverage, 1062,
     /*  5740 */     GIR_EraseRootFromParent_Done,
     /*  5741 */   // Label 287: @5741
     /*  5741 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(5776), // Rule ID 1397 //
     /*  5746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5761 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /*  5764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5766 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5768 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5774 */     GIR_RootConstrainSelectedInstOperands,
     /*  5775 */     // GIR_Coverage, 1397,
     /*  5775 */     GIR_EraseRootFromParent_Done,
     /*  5776 */   // Label 288: @5776
     /*  5776 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(5805), // Rule ID 1821 //
     /*  5781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  5784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  5792 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5796 */     // (xor:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, -1:{ *:[i32] })  =>  (NotRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r)
     /*  5796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NotRxRy16),
     /*  5799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /*  5801 */     GIR_RootToRootCopy, /*OpIdx*/1, // r
     /*  5803 */     GIR_RootConstrainSelectedInstOperands,
     /*  5804 */     // GIR_Coverage, 1821,
     /*  5804 */     GIR_EraseRootFromParent_Done,
     /*  5805 */   // Label 289: @5805
     /*  5805 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(5834), // Rule ID 2163 //
     /*  5810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  5813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5825 */     // (xor:{ *:[i32] } GPRMM16:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOT16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$in)
     /*  5825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MM),
     /*  5828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5830 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5832 */     GIR_RootConstrainSelectedInstOperands,
     /*  5833 */     // GIR_Coverage, 2163,
     /*  5833 */     GIR_EraseRootFromParent_Done,
     /*  5834 */   // Label 290: @5834
     /*  5834 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(5869), // Rule ID 2164 //
     /*  5839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /*  5842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5850 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5854 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MM),
     /*  5857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5859 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5867 */     GIR_RootConstrainSelectedInstOperands,
     /*  5868 */     // GIR_Coverage, 2164,
     /*  5868 */     GIR_EraseRootFromParent_Done,
     /*  5869 */   // Label 291: @5869
     /*  5869 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(5898), // Rule ID 2330 //
     /*  5874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  5885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5889 */     // (xor:{ *:[i32] } GPRMM16:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOT16_MMR6:{ *:[i32] } GPRMM16:{ *:[i32] }:$in)
     /*  5889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOT16_MMR6),
     /*  5892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5894 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5896 */     GIR_RootConstrainSelectedInstOperands,
     /*  5897 */     // GIR_Coverage, 2330,
     /*  5897 */     GIR_EraseRootFromParent_Done,
     /*  5898 */   // Label 292: @5898
     /*  5898 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(5933), // Rule ID 2331 //
     /*  5903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  5906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5914 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  5918 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$in, -1:{ *:[i32] })  =>  (NOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$in, ZERO:{ *:[i32] })
     /*  5918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /*  5921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  5923 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /*  5925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  5931 */     GIR_RootConstrainSelectedInstOperands,
     /*  5932 */     // GIR_Coverage, 2331,
     /*  5932 */     GIR_EraseRootFromParent_Done,
     /*  5933 */   // Label 293: @5933
     /*  5933 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(5975), // Rule ID 43 //
     /*  5938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  5953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  5957 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_imm32ZExt16),
     /*  5961 */     // MIs[1] Operand 1
     /*  5961 */     // No operand predicates
     /*  5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  5963 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_imm32ZExt16>>:$imm16)  =>  (XORi:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$imm16)
     /*  5963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /*  5966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /*  5968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  5970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  5973 */     GIR_RootConstrainSelectedInstOperands,
     /*  5974 */     // GIR_Coverage, 43,
     /*  5974 */     GIR_EraseRootFromParent_Done,
     /*  5975 */   // Label 294: @5975
     /*  5975 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(6002), // Rule ID 53 //
     /*  5980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /*  5983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  5995 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  5995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /*  6000 */     GIR_RootConstrainSelectedInstOperands,
     /*  6001 */     // GIR_Coverage, 53,
     /*  6001 */     GIR_Done,
     /*  6002 */   // Label 295: @6002
     /*  6002 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(6029), // Rule ID 1065 //
     /*  6007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  6010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /*  6022 */     // (xor:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)  =>  (XOR16_MM:{ *:[i32] } GPRMM16Opnd:{ *:[i32] }:$rs, GPRMM16Opnd:{ *:[i32] }:$rt)
     /*  6022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR16_MM),
     /*  6027 */     GIR_RootConstrainSelectedInstOperands,
     /*  6028 */     // GIR_Coverage, 1065,
     /*  6028 */     GIR_Done,
     /*  6029 */   // Label 296: @6029
     /*  6029 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(6056), // Rule ID 1079 //
     /*  6034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /*  6037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6049 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /*  6054 */     GIR_RootConstrainSelectedInstOperands,
     /*  6055 */     // GIR_Coverage, 1079,
     /*  6055 */     GIR_Done,
     /*  6056 */   // Label 297: @6056
     /*  6056 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(6083), // Rule ID 1186 //
     /*  6061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /*  6064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6076 */     // (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (XOR_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /*  6076 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_MMR6),
     /*  6081 */     GIR_RootConstrainSelectedInstOperands,
     /*  6082 */     // GIR_Coverage, 1186,
     /*  6082 */     GIR_Done,
     /*  6083 */   // Label 298: @6083
     /*  6083 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(6110), // Rule ID 1828 //
     /*  6088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /*  6091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /*  6103 */     // (xor:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)  =>  (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$l, CPU16Regs:{ *:[i32] }:$r)
     /*  6103 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /*  6108 */     GIR_RootConstrainSelectedInstOperands,
     /*  6109 */     // GIR_Coverage, 1828,
     /*  6109 */     GIR_Done,
     /*  6110 */   // Label 299: @6110
     /*  6110 */   GIM_Reject,
     /*  6111 */ // Label 282: @6111
     /*  6111 */ GIM_Reject,
     /*  6112 */ // Label 276: @6112
     /*  6112 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(6206),
     /*  6117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  6120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  6123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6127 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(6182), // Rule ID 209 //
     /*  6132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  6135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  6139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  6143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  6147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  6151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  6165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  6167 */     // (xor:{ *:[i64] } (or:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt), -1:{ *:[i64] })  =>  (NOR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  6167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR64),
     /*  6170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  6172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*  6176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rt
     /*  6180 */     GIR_RootConstrainSelectedInstOperands,
     /*  6181 */     // GIR_Coverage, 209,
     /*  6181 */     GIR_EraseRootFromParent_Done,
     /*  6182 */   // Label 301: @6182
     /*  6182 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(6205), // Rule ID 208 //
     /*  6187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /*  6190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6198 */     // (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (XOR64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /*  6198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /*  6203 */     GIR_RootConstrainSelectedInstOperands,
     /*  6204 */     // GIR_Coverage, 208,
     /*  6204 */     GIR_Done,
     /*  6205 */   // Label 302: @6205
     /*  6205 */   GIM_Reject,
     /*  6206 */ // Label 300: @6206
     /*  6206 */ GIM_Reject,
     /*  6207 */ // Label 277: @6207
     /*  6207 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(6240), // Rule ID 1040 //
     /*  6212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  6218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  6221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6233 */   // (xor:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (XOR_V_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /*  6233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_D_PSEUDO),
     /*  6238 */   GIR_RootConstrainSelectedInstOperands,
     /*  6239 */   // GIR_Coverage, 1040,
     /*  6239 */   GIR_Done,
     /*  6240 */ // Label 303: @6240
     /*  6240 */ GIM_Reject,
     /*  6241 */ // Label 278: @6241
     /*  6241 */ GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(6274), // Rule ID 1039 //
     /*  6246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  6252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  6255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6267 */   // (xor:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (XOR_V_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /*  6267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_W_PSEUDO),
     /*  6272 */   GIR_RootConstrainSelectedInstOperands,
     /*  6273 */   // GIR_Coverage, 1039,
     /*  6273 */   GIR_Done,
     /*  6274 */ // Label 304: @6274
     /*  6274 */ GIM_Reject,
     /*  6275 */ // Label 279: @6275
     /*  6275 */ GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(6308), // Rule ID 1038 //
     /*  6280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  6286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  6289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6301 */   // (xor:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (XOR_V_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /*  6301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V_H_PSEUDO),
     /*  6306 */   GIR_RootConstrainSelectedInstOperands,
     /*  6307 */   // GIR_Coverage, 1038,
     /*  6307 */   GIR_Done,
     /*  6308 */ // Label 305: @6308
     /*  6308 */ GIM_Reject,
     /*  6309 */ // Label 280: @6309
     /*  6309 */ GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(6342), // Rule ID 1037 //
     /*  6314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  6320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  6323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6335 */   // (xor:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (XOR_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /*  6335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::XOR_V),
     /*  6340 */   GIR_RootConstrainSelectedInstOperands,
     /*  6341 */   // GIR_Coverage, 1037,
     /*  6341 */   GIR_Done,
     /*  6342 */ // Label 306: @6342
     /*  6342 */ GIM_Reject,
     /*  6343 */ // Label 281: @6343
     /*  6343 */ GIM_Reject,
     /*  6344 */ // Label 10: @6344
     /*  6344 */ GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(6416),
     /*  6349 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  6352 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  6355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  6361 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(6388), // Rule ID 180 //
     /*  6366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsNotSoftFloat_NotFP64bit_NotInMips16Mode),
     /*  6369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /*  6373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6381 */     // (MipsBuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)  =>  (BuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)
     /*  6381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BuildPairF64),
     /*  6386 */     GIR_RootConstrainSelectedInstOperands,
     /*  6387 */     // GIR_Coverage, 180,
     /*  6387 */     GIR_Done,
     /*  6388 */   // Label 308: @6388
     /*  6388 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(6415), // Rule ID 181 //
     /*  6393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit_IsNotSoftFloat_NotInMips16Mode),
     /*  6396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  6400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6408 */     // (MipsBuildPairF64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)  =>  (BuildPairF64_64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$lo, GPR32Opnd:{ *:[i32] }:$hi)
     /*  6408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BuildPairF64_64),
     /*  6413 */     GIR_RootConstrainSelectedInstOperands,
     /*  6414 */     // GIR_Coverage, 181,
     /*  6414 */     GIR_Done,
     /*  6415 */   // Label 309: @6415
     /*  6415 */   GIM_Reject,
     /*  6416 */ // Label 307: @6416
     /*  6416 */ GIM_Reject,
     /*  6417 */ // Label 11: @6417
     /*  6417 */ GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(6488),
     /*  6422 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  6425 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  6428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  6431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  6435 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(6461), // Rule ID 719 //
     /*  6440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasMips64_HasStdEnc),
     /*  6443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  6447 */     // MIs[0] rs
     /*  6447 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6452 */     // (build_vector:{ *:[v2i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rs)  =>  (FILL_D:{ *:[v2i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /*  6452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_D),
     /*  6455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6459 */     GIR_RootConstrainSelectedInstOperands,
     /*  6460 */     // GIR_Coverage, 719,
     /*  6460 */     GIR_EraseRootFromParent_Done,
     /*  6461 */   // Label 311: @6461
     /*  6461 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(6487), // Rule ID 721 //
     /*  6466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  6473 */     // MIs[0] fs
     /*  6473 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6478 */     // (build_vector:{ *:[v2f64] } FGR64:{ *:[f64] }:$fs, FGR64:{ *:[f64] }:$fs)  =>  (FILL_FD_PSEUDO:{ *:[v2f64] } FGR64:{ *:[f64] }:$fs)
     /*  6478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_FD_PSEUDO),
     /*  6481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6483 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /*  6485 */     GIR_RootConstrainSelectedInstOperands,
     /*  6486 */     // GIR_Coverage, 721,
     /*  6486 */     GIR_EraseRootFromParent_Done,
     /*  6487 */   // Label 312: @6487
     /*  6487 */   GIM_Reject,
     /*  6488 */ // Label 310: @6488
     /*  6488 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(6579),
     /*  6493 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  6496 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  6499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  6506 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(6542), // Rule ID 718 //
     /*  6511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6518 */     // MIs[0] rs
     /*  6518 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6523 */     // MIs[0] rs
     /*  6523 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6528 */     // MIs[0] rs
     /*  6528 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6533 */     // (build_vector:{ *:[v4i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_W:{ *:[v4i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_W),
     /*  6536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6540 */     GIR_RootConstrainSelectedInstOperands,
     /*  6541 */     // GIR_Coverage, 718,
     /*  6541 */     GIR_EraseRootFromParent_Done,
     /*  6542 */   // Label 314: @6542
     /*  6542 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(6578), // Rule ID 720 //
     /*  6547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6554 */     // MIs[0] fs
     /*  6554 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6559 */     // MIs[0] fs
     /*  6559 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6564 */     // MIs[0] fs
     /*  6564 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6569 */     // (build_vector:{ *:[v4f32] } FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs, FGR32:{ *:[f32] }:$fs)  =>  (FILL_FW_PSEUDO:{ *:[v4f32] } FGR32:{ *:[f32] }:$fs)
     /*  6569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_FW_PSEUDO),
     /*  6572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6574 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /*  6576 */     GIR_RootConstrainSelectedInstOperands,
     /*  6577 */     // GIR_Coverage, 720,
     /*  6577 */     GIR_EraseRootFromParent_Done,
     /*  6578 */   // Label 315: @6578
     /*  6578 */   GIM_Reject,
     /*  6579 */ // Label 313: @6579
     /*  6579 */ GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(6648), // Rule ID 717 //
     /*  6584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6587 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /*  6590 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  6593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  6600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6604 */   // MIs[0] rs
     /*  6604 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6609 */   // MIs[0] rs
     /*  6609 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6614 */   // MIs[0] rs
     /*  6614 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6619 */   // MIs[0] rs
     /*  6619 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6624 */   // MIs[0] rs
     /*  6624 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6629 */   // MIs[0] rs
     /*  6629 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6634 */   // MIs[0] rs
     /*  6634 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6639 */   // (build_vector:{ *:[v8i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_H:{ *:[v8i16] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_H),
     /*  6642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6644 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6646 */   GIR_RootConstrainSelectedInstOperands,
     /*  6647 */   // GIR_Coverage, 717,
     /*  6647 */   GIR_EraseRootFromParent_Done,
     /*  6648 */ // Label 316: @6648
     /*  6648 */ GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(6757), // Rule ID 716 //
     /*  6653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /*  6656 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/17,
     /*  6659 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  6662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  6669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6673 */   // MIs[0] rs
     /*  6673 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/2, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6678 */   // MIs[0] rs
     /*  6678 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6683 */   // MIs[0] rs
     /*  6683 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/4, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6688 */   // MIs[0] rs
     /*  6688 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/5, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6693 */   // MIs[0] rs
     /*  6693 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/6, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6698 */   // MIs[0] rs
     /*  6698 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/7, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6703 */   // MIs[0] rs
     /*  6703 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/8, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6708 */   // MIs[0] rs
     /*  6708 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/9, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6713 */   // MIs[0] rs
     /*  6713 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/10, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6718 */   // MIs[0] rs
     /*  6718 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/11, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6723 */   // MIs[0] rs
     /*  6723 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/12, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6728 */   // MIs[0] rs
     /*  6728 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/13, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6733 */   // MIs[0] rs
     /*  6733 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/14, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6738 */   // MIs[0] rs
     /*  6738 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/15, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6743 */   // MIs[0] rs
     /*  6743 */   GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/16, /*OtherMI*/0, /*OtherOpIdx*/1,
     /*  6748 */   // (build_vector:{ *:[v16i8] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rs)  =>  (FILL_B:{ *:[v16i8] } GPR32Opnd:{ *:[i32] }:$rs)
     /*  6748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FILL_B),
     /*  6751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /*  6753 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  6755 */   GIR_RootConstrainSelectedInstOperands,
     /*  6756 */   // GIR_Coverage, 716,
     /*  6756 */   GIR_EraseRootFromParent_Done,
     /*  6757 */ // Label 317: @6757
     /*  6757 */ GIM_Reject,
     /*  6758 */ // Label 12: @6758
     /*  6758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 326*/ GIMT_Encode4(11068),
     /*  6769 */ /*GILLT_s32*//*Label 318*/ GIMT_Encode4(6801),
     /*  6773 */ /*GILLT_s64*//*Label 319*/ GIMT_Encode4(7078),
     /*  6777 */ /*GILLT_v2s16*//*Label 320*/ GIMT_Encode4(7134),
     /*  6781 */ /*GILLT_v2s64*//*Label 321*/ GIMT_Encode4(7194),
     /*  6785 */ /*GILLT_v4s8*//*Label 322*/ GIMT_Encode4(8329),
     /*  6789 */ /*GILLT_v4s32*//*Label 323*/ GIMT_Encode4(8389),
     /*  6793 */ /*GILLT_v8s16*//*Label 324*/ GIMT_Encode4(9458),
     /*  6797 */ /*GILLT_v16s8*//*Label 325*/ GIMT_Encode4(10383),
     /*  6801 */ // Label 318: @6801
     /*  6801 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(6827), // Rule ID 135 //
     /*  6806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  6809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6820 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1),
     /*  6825 */   GIR_RootConstrainSelectedInstOperands,
     /*  6826 */   // GIR_Coverage, 135,
     /*  6826 */   GIR_Done,
     /*  6827 */ // Label 327: @6827
     /*  6827 */ GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(6853), // Rule ID 136 //
     /*  6832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  6835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6846 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1),
     /*  6851 */   GIR_RootConstrainSelectedInstOperands,
     /*  6852 */   // GIR_Coverage, 136,
     /*  6852 */   GIR_Done,
     /*  6853 */ // Label 328: @6853
     /*  6853 */ GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(6879), // Rule ID 1160 //
     /*  6858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /*  6861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6872 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1_MM:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1_MM),
     /*  6877 */   GIR_RootConstrainSelectedInstOperands,
     /*  6878 */   // GIR_Coverage, 1160,
     /*  6878 */   GIR_Done,
     /*  6879 */ // Label 329: @6879
     /*  6879 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(6905), // Rule ID 1161 //
     /*  6884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /*  6887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6894 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6898 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1_MM:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6898 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1_MM),
     /*  6903 */   GIR_RootConstrainSelectedInstOperands,
     /*  6904 */   // GIR_Coverage, 1161,
     /*  6904 */   GIR_Done,
     /*  6905 */ // Label 330: @6905
     /*  6905 */ GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(6931), // Rule ID 1175 //
     /*  6910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /*  6913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6924 */   // (bitconvert:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)  =>  (MTC1_MMR6:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$rt)
     /*  6924 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MTC1_MMR6),
     /*  6929 */   GIR_RootConstrainSelectedInstOperands,
     /*  6930 */   // GIR_Coverage, 1175,
     /*  6930 */   GIR_Done,
     /*  6931 */ // Label 331: @6931
     /*  6931 */ GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(6957), // Rule ID 1176 //
     /*  6936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /*  6939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  6942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  6950 */   // (bitconvert:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MFC1_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs)
     /*  6950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MFC1_MMR6),
     /*  6955 */   GIR_RootConstrainSelectedInstOperands,
     /*  6956 */   // GIR_Coverage, 1176,
     /*  6956 */   GIR_Done,
     /*  6957 */ // Label 332: @6957
     /*  6957 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(6987), // Rule ID 1909 //
     /*  6962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  6965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  6968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  6976 */   // (bitconvert:{ *:[i32] } DSPR:{ *:[v2i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } DSPR:{ *:[v2i16] }:$src, GPR32:{ *:[i32] })
     /*  6976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  6981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR32RegClassID),
     /*  6986 */   // GIR_Coverage, 1909,
     /*  6986 */   GIR_Done,
     /*  6987 */ // Label 333: @6987
     /*  6987 */ GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(7017), // Rule ID 1910 //
     /*  6992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  6995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  6998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7006 */   // (bitconvert:{ *:[i32] } DSPR:{ *:[v4i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[i32] } DSPR:{ *:[v4i8] }:$src, GPR32:{ *:[i32] })
     /*  7006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7016 */   // GIR_Coverage, 1910,
     /*  7016 */   GIR_Done,
     /*  7017 */ // Label 334: @7017
     /*  7017 */ GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(7047), // Rule ID 1913 //
     /*  7022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /*  7028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7036 */   // (bitconvert:{ *:[f32] } DSPR:{ *:[v2i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } DSPR:{ *:[v2i16] }:$src, FGR32:{ *:[i32] })
     /*  7036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7046 */   // GIR_Coverage, 1913,
     /*  7046 */   GIR_Done,
     /*  7047 */ // Label 335: @7047
     /*  7047 */ GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(7077), // Rule ID 1914 //
     /*  7052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /*  7058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7066 */   // (bitconvert:{ *:[f32] } DSPR:{ *:[v4i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[f32] } DSPR:{ *:[v4i8] }:$src, FGR32:{ *:[i32] })
     /*  7066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7071 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7076 */   // GIR_Coverage, 1914,
     /*  7076 */   GIR_Done,
     /*  7077 */ // Label 336: @7077
     /*  7077 */ GIM_Reject,
     /*  7078 */ // Label 319: @7078
     /*  7078 */ GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(7133),
     /*  7083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  7086 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(7109), // Rule ID 137 //
     /*  7091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  7094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  7098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  7102 */     // (bitconvert:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMTC1:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$rt)
     /*  7102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMTC1),
     /*  7107 */     GIR_RootConstrainSelectedInstOperands,
     /*  7108 */     // GIR_Coverage, 137,
     /*  7108 */     GIR_Done,
     /*  7109 */   // Label 338: @7109
     /*  7109 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(7132), // Rule ID 138 //
     /*  7114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /*  7117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /*  7121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /*  7125 */     // (bitconvert:{ *:[i64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (DMFC1:{ *:[i64] } FGR64Opnd:{ *:[f64] }:$fs)
     /*  7125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMFC1),
     /*  7130 */     GIR_RootConstrainSelectedInstOperands,
     /*  7131 */     // GIR_Coverage, 138,
     /*  7131 */     GIR_Done,
     /*  7132 */   // Label 339: @7132
     /*  7132 */   GIM_Reject,
     /*  7133 */ // Label 337: @7133
     /*  7133 */ GIM_Reject,
     /*  7134 */ // Label 320: @7134
     /*  7134 */ GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(7193),
     /*  7139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  7142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7146 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(7169), // Rule ID 1911 //
     /*  7151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  7158 */     // (bitconvert:{ *:[v2i16] } GPR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } GPR32:{ *:[i32] }:$src, DSPR:{ *:[i32] })
     /*  7158 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7168 */     // GIR_Coverage, 1911,
     /*  7168 */     GIR_Done,
     /*  7169 */   // Label 341: @7169
     /*  7169 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(7192), // Rule ID 1915 //
     /*  7174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  7177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  7181 */     // (bitconvert:{ *:[v2i16] } FGR32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i16] } FGR32:{ *:[f32] }:$src, DSPR:{ *:[i32] })
     /*  7181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  7191 */     // GIR_Coverage, 1915,
     /*  7191 */     GIR_Done,
     /*  7192 */   // Label 342: @7192
     /*  7192 */   GIM_Reject,
     /*  7193 */ // Label 340: @7193
     /*  7193 */ GIM_Reject,
     /*  7194 */ // Label 321: @7194
     /*  7194 */ GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(7220), // Rule ID 1996 //
     /*  7199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  7202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  7205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7209 */   // (bitconvert:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$src, MSA128D:{ *:[i32] })
     /*  7209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7219 */   // GIR_Coverage, 1996,
     /*  7219 */   GIR_Done,
     /*  7220 */ // Label 343: @7220
     /*  7220 */ GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(7246), // Rule ID 1999 //
     /*  7225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  7228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  7231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7235 */   // (bitconvert:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v2i64:{ *:[v2i64] }:$src, MSA128D:{ *:[i32] })
     /*  7235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7245 */   // GIR_Coverage, 1999,
     /*  7245 */   GIR_Done,
     /*  7246 */ // Label 344: @7246
     /*  7246 */ GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(7272), // Rule ID 2016 //
     /*  7251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7261 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src, MSA128D:{ *:[i32] })
     /*  7261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7271 */   // GIR_Coverage, 2016,
     /*  7271 */   GIR_Done,
     /*  7272 */ // Label 345: @7272
     /*  7272 */ GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(7298), // Rule ID 2017 //
     /*  7277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7287 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src, MSA128D:{ *:[i32] })
     /*  7287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7297 */   // GIR_Coverage, 2017,
     /*  7297 */   GIR_Done,
     /*  7298 */ // Label 346: @7298
     /*  7298 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(7324), // Rule ID 2018 //
     /*  7303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7313 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src, MSA128D:{ *:[i32] })
     /*  7313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7318 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7323 */   // GIR_Coverage, 2018,
     /*  7323 */   GIR_Done,
     /*  7324 */ // Label 347: @7324
     /*  7324 */ GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(7350), // Rule ID 2019 //
     /*  7329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7339 */   // (bitconvert:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src, MSA128D:{ *:[i32] })
     /*  7339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7344 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7349 */   // GIR_Coverage, 2019,
     /*  7349 */   GIR_Done,
     /*  7350 */ // Label 348: @7350
     /*  7350 */ GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(7376), // Rule ID 2020 //
     /*  7355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7365 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src, MSA128D:{ *:[i32] })
     /*  7365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7375 */   // GIR_Coverage, 2020,
     /*  7375 */   GIR_Done,
     /*  7376 */ // Label 349: @7376
     /*  7376 */ GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(7402), // Rule ID 2026 //
     /*  7381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7391 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src, MSA128D:{ *:[i32] })
     /*  7391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7396 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7401 */   // GIR_Coverage, 2026,
     /*  7401 */   GIR_Done,
     /*  7402 */ // Label 350: @7402
     /*  7402 */ GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(7428), // Rule ID 2027 //
     /*  7407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7417 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src, MSA128D:{ *:[i32] })
     /*  7417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7422 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7427 */   // GIR_Coverage, 2027,
     /*  7427 */   GIR_Done,
     /*  7428 */ // Label 351: @7428
     /*  7428 */ GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(7454), // Rule ID 2028 //
     /*  7433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7443 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src, MSA128D:{ *:[i32] })
     /*  7443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7448 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7453 */   // GIR_Coverage, 2028,
     /*  7453 */   GIR_Done,
     /*  7454 */ // Label 352: @7454
     /*  7454 */ GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(7480), // Rule ID 2029 //
     /*  7459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7469 */   // (bitconvert:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src, MSA128D:{ *:[i32] })
     /*  7469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7479 */   // GIR_Coverage, 2029,
     /*  7479 */   GIR_Done,
     /*  7480 */ // Label 353: @7480
     /*  7480 */ GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(7506), // Rule ID 2030 //
     /*  7485 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  7488 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  7491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7495 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src, MSA128D:{ *:[i32] })
     /*  7495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7500 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7505 */   // GIR_Coverage, 2030,
     /*  7505 */   GIR_Done,
     /*  7506 */ // Label 354: @7506
     /*  7506 */ GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(7623), // Rule ID 2035 //
     /*  7511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7521 */   // (bitconvert:{ *:[v2i64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7521 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /*  7524 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7528 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7533 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7537 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  7542 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  7545 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  7549 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7554 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  7557 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /*  7560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  7562 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  7565 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7569 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7574 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  7577 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  7582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  7585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  7589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7594 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7597 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  7607 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7614 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7622 */   // GIR_Coverage, 2035,
     /*  7622 */   GIR_EraseRootFromParent_Done,
     /*  7623 */ // Label 355: @7623
     /*  7623 */ GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(7740), // Rule ID 2036 //
     /*  7628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  7634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7638 */   // (bitconvert:{ *:[v2f64] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7638 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /*  7641 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7645 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7650 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7654 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  7659 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  7662 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  7666 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7671 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  7674 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /*  7677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  7679 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  7682 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7686 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7691 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  7694 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  7699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  7702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  7706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7711 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7714 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  7724 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7734 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7739 */   // GIR_Coverage, 2036,
     /*  7739 */   GIR_EraseRootFromParent_Done,
     /*  7740 */ // Label 356: @7740
     /*  7740 */ GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(7810), // Rule ID 2040 //
     /*  7745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7755 */   // (bitconvert:{ *:[v2i64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7755 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7758 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7762 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7767 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7771 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7788 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7791 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7804 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7809 */   // GIR_Coverage, 2040,
     /*  7809 */   GIR_EraseRootFromParent_Done,
     /*  7810 */ // Label 357: @7810
     /*  7810 */ GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(7880), // Rule ID 2041 //
     /*  7815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7825 */   // (bitconvert:{ *:[v2f64] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7825 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7828 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7832 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7837 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7841 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7858 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7861 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7871 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7879 */   // GIR_Coverage, 2041,
     /*  7879 */   GIR_EraseRootFromParent_Done,
     /*  7880 */ // Label 358: @7880
     /*  7880 */ GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(7950), // Rule ID 2045 //
     /*  7885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7895 */   // (bitconvert:{ *:[v2i64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7895 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7898 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7902 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7907 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7911 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7928 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  7931 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  7934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  7936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  7941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  7944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7949 */   // GIR_Coverage, 2045,
     /*  7949 */   GIR_EraseRootFromParent_Done,
     /*  7950 */ // Label 359: @7950
     /*  7950 */ GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(8020), // Rule ID 2046 //
     /*  7955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  7958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  7961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  7965 */   // (bitconvert:{ *:[v2f64] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  7965 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  7968 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  7972 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7977 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  7981 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  7986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  7989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  7993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  7998 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8001 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8011 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8019 */   // GIR_Coverage, 2046,
     /*  8019 */   GIR_EraseRootFromParent_Done,
     /*  8020 */ // Label 360: @8020
     /*  8020 */ GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(8097), // Rule ID 2050 //
     /*  8025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8035 */   // (bitconvert:{ *:[v2i64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8035 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8038 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8042 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8047 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8051 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8068 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8071 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8081 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8096 */   // GIR_Coverage, 2050,
     /*  8096 */   GIR_EraseRootFromParent_Done,
     /*  8097 */ // Label 361: @8097
     /*  8097 */ GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(8174), // Rule ID 2051 //
     /*  8102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8112 */   // (bitconvert:{ *:[v2f64] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8112 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8115 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8119 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8124 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8128 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8145 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8148 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8158 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8163 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8165 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8173 */   // GIR_Coverage, 2051,
     /*  8173 */   GIR_EraseRootFromParent_Done,
     /*  8174 */ // Label 362: @8174
     /*  8174 */ GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(8251), // Rule ID 2055 //
     /*  8179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8189 */   // (bitconvert:{ *:[v2i64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2i64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8189 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8192 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8196 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8201 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8205 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8210 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8213 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8217 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8222 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8225 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8235 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8250 */   // GIR_Coverage, 2055,
     /*  8250 */   GIR_EraseRootFromParent_Done,
     /*  8251 */ // Label 363: @8251
     /*  8251 */ GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(8328), // Rule ID 2056 //
     /*  8256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8266 */   // (bitconvert:{ *:[v2f64] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v2f64] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128D:{ *:[i32] })
     /*  8266 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  8269 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8273 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8282 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  8290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  8294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8299 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8302 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8312 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8317 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128DRegClassID),
     /*  8327 */   // GIR_Coverage, 2056,
     /*  8327 */   GIR_EraseRootFromParent_Done,
     /*  8328 */ // Label 364: @8328
     /*  8328 */ GIM_Reject,
     /*  8329 */ // Label 322: @8329
     /*  8329 */ GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(8388),
     /*  8334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  8337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8341 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(8364), // Rule ID 1912 //
     /*  8346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  8349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /*  8353 */     // (bitconvert:{ *:[v4i8] } GPR32:{ *:[i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i8] } GPR32:{ *:[i32] }:$src, DSPR:{ *:[i32] })
     /*  8353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8358 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8363 */     // GIR_Coverage, 1912,
     /*  8363 */     GIR_Done,
     /*  8364 */   // Label 366: @8364
     /*  8364 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(8387), // Rule ID 1916 //
     /*  8369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /*  8372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /*  8376 */     // (bitconvert:{ *:[v4i8] } FGR32:{ *:[f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i8] } FGR32:{ *:[f32] }:$src, DSPR:{ *:[i32] })
     /*  8376 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /*  8386 */     // GIR_Coverage, 1916,
     /*  8386 */     GIR_Done,
     /*  8387 */   // Label 367: @8387
     /*  8387 */   GIM_Reject,
     /*  8388 */ // Label 365: @8388
     /*  8388 */ GIM_Reject,
     /*  8389 */ // Label 323: @8389
     /*  8389 */ GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(8415), // Rule ID 1995 //
     /*  8394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  8397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8404 */   // (bitconvert:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$src, MSA128W:{ *:[i32] })
     /*  8404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8409 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8414 */   // GIR_Coverage, 1995,
     /*  8414 */   GIR_Done,
     /*  8415 */ // Label 368: @8415
     /*  8415 */ GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(8441), // Rule ID 1998 //
     /*  8420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  8423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  8426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8430 */   // (bitconvert:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v4i32:{ *:[v4i32] }:$src, MSA128W:{ *:[i32] })
     /*  8430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8435 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8440 */   // GIR_Coverage, 1998,
     /*  8440 */   GIR_Done,
     /*  8441 */ // Label 369: @8441
     /*  8441 */ GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(8467), // Rule ID 2011 //
     /*  8446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8456 */   // (bitconvert:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src, MSA128W:{ *:[i32] })
     /*  8456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8466 */   // GIR_Coverage, 2011,
     /*  8466 */   GIR_Done,
     /*  8467 */ // Label 370: @8467
     /*  8467 */ GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(8493), // Rule ID 2012 //
     /*  8472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8482 */   // (bitconvert:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src, MSA128W:{ *:[i32] })
     /*  8482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8492 */   // GIR_Coverage, 2012,
     /*  8492 */   GIR_Done,
     /*  8493 */ // Label 371: @8493
     /*  8493 */ GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(8519), // Rule ID 2013 //
     /*  8498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8508 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] })
     /*  8508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8518 */   // GIR_Coverage, 2013,
     /*  8518 */   GIR_Done,
     /*  8519 */ // Label 372: @8519
     /*  8519 */ GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(8545), // Rule ID 2014 //
     /*  8524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8534 */   // (bitconvert:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src, MSA128W:{ *:[i32] })
     /*  8534 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8539 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8544 */   // GIR_Coverage, 2014,
     /*  8544 */   GIR_Done,
     /*  8545 */ // Label 373: @8545
     /*  8545 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(8571), // Rule ID 2015 //
     /*  8550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8560 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] })
     /*  8560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8570 */   // GIR_Coverage, 2015,
     /*  8570 */   GIR_Done,
     /*  8571 */ // Label 374: @8571
     /*  8571 */ GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(8597), // Rule ID 2021 //
     /*  8576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8586 */   // (bitconvert:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src, MSA128W:{ *:[i32] })
     /*  8586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8596 */   // GIR_Coverage, 2021,
     /*  8596 */   GIR_Done,
     /*  8597 */ // Label 375: @8597
     /*  8597 */ GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(8623), // Rule ID 2022 //
     /*  8602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8612 */   // (bitconvert:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src, MSA128W:{ *:[i32] })
     /*  8612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8617 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8622 */   // GIR_Coverage, 2022,
     /*  8622 */   GIR_Done,
     /*  8623 */ // Label 376: @8623
     /*  8623 */ GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(8649), // Rule ID 2023 //
     /*  8628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8638 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] })
     /*  8638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8648 */   // GIR_Coverage, 2023,
     /*  8648 */   GIR_Done,
     /*  8649 */ // Label 377: @8649
     /*  8649 */ GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(8675), // Rule ID 2024 //
     /*  8654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8664 */   // (bitconvert:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src, MSA128W:{ *:[i32] })
     /*  8664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8674 */   // GIR_Coverage, 2024,
     /*  8674 */   GIR_Done,
     /*  8675 */ // Label 378: @8675
     /*  8675 */ GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(8701), // Rule ID 2025 //
     /*  8680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  8683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  8686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8690 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] })
     /*  8690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8700 */   // GIR_Coverage, 2025,
     /*  8700 */   GIR_Done,
     /*  8701 */ // Label 379: @8701
     /*  8701 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(8771), // Rule ID 2033 //
     /*  8706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8716 */   // (bitconvert:{ *:[v4i32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  8719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  8737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  8740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  8744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8752 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8755 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8762 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8770 */   // GIR_Coverage, 2033,
     /*  8770 */   GIR_EraseRootFromParent_Done,
     /*  8771 */ // Label 380: @8771
     /*  8771 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(8841), // Rule ID 2034 //
     /*  8776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  8782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8786 */   // (bitconvert:{ *:[v4f32] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8786 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  8789 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8793 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8798 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8802 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  8807 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  8810 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  8814 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8822 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /*  8825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8835 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8840 */   // GIR_Coverage, 2034,
     /*  8840 */   GIR_EraseRootFromParent_Done,
     /*  8841 */ // Label 381: @8841
     /*  8841 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(8918), // Rule ID 2038 //
     /*  8846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8856 */   // (bitconvert:{ *:[v4i32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8856 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  8859 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8863 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8868 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8872 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8889 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8892 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8917 */   // GIR_Coverage, 2038,
     /*  8917 */   GIR_EraseRootFromParent_Done,
     /*  8918 */ // Label 382: @8918
     /*  8918 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(8995), // Rule ID 2039 //
     /*  8923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  8926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  8929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8933 */   // (bitconvert:{ *:[v4f32] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  8933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  8936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  8949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  8954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  8957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  8961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  8966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  8969 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  8979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  8981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  8984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  8986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  8989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  8994 */   // GIR_Coverage, 2039,
     /*  8994 */   GIR_EraseRootFromParent_Done,
     /*  8995 */ // Label 383: @8995
     /*  8995 */ GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(9072), // Rule ID 2043 //
     /*  9000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9010 */   // (bitconvert:{ *:[v4i32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9022 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9026 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9043 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9046 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9056 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9066 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9071 */   // GIR_Coverage, 2043,
     /*  9071 */   GIR_EraseRootFromParent_Done,
     /*  9072 */ // Label 384: @9072
     /*  9072 */ GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(9149), // Rule ID 2044 //
     /*  9077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9087 */   // (bitconvert:{ *:[v4f32] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9087 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9090 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9094 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9099 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9103 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9108 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9111 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9115 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9120 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9123 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9140 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9148 */   // GIR_Coverage, 2044,
     /*  9148 */   GIR_EraseRootFromParent_Done,
     /*  9149 */ // Label 385: @9149
     /*  9149 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(9226), // Rule ID 2060 //
     /*  9154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9164 */   // (bitconvert:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9164 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9167 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9171 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9176 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9180 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9185 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9188 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9192 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9197 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9200 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9220 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9225 */   // GIR_Coverage, 2060,
     /*  9225 */   GIR_EraseRootFromParent_Done,
     /*  9226 */ // Label 386: @9226
     /*  9226 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(9303), // Rule ID 2061 //
     /*  9231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9241 */   // (bitconvert:{ *:[v4f32] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2i64:{ *:[v2i64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9241 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9244 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9248 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9253 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9257 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9274 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9277 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9302 */   // GIR_Coverage, 2061,
     /*  9302 */   GIR_EraseRootFromParent_Done,
     /*  9303 */ // Label 387: @9303
     /*  9303 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(9380), // Rule ID 2065 //
     /*  9308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9318 */   // (bitconvert:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9318 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9321 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9325 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9330 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9334 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9351 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9354 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9374 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9379 */   // GIR_Coverage, 2065,
     /*  9379 */   GIR_EraseRootFromParent_Done,
     /*  9380 */ // Label 388: @9380
     /*  9380 */ GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(9457), // Rule ID 2066 //
     /*  9385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9395 */   // (bitconvert:{ *:[v4f32] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v4f32] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } v2f64:{ *:[v2f64] }:$src, MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128W:{ *:[i32] })
     /*  9395 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  9398 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9402 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9407 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9411 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9416 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  9419 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /*  9423 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9428 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9431 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /*  9456 */   // GIR_Coverage, 2066,
     /*  9456 */   GIR_EraseRootFromParent_Done,
     /*  9457 */ // Label 389: @9457
     /*  9457 */ GIM_Reject,
     /*  9458 */ // Label 324: @9458
     /*  9458 */ GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(9484), // Rule ID 1994 //
     /*  9463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  9466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9473 */   // (bitconvert:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$src, MSA128H:{ *:[i32] })
     /*  9473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9483 */   // GIR_Coverage, 1994,
     /*  9483 */   GIR_Done,
     /*  9484 */ // Label 390: @9484
     /*  9484 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(9510), // Rule ID 1997 //
     /*  9489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /*  9492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  9495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9499 */   // (bitconvert:{ *:[v8f16] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } v8i16:{ *:[v8i16] }:$src, MSA128H:{ *:[i32] })
     /*  9499 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9504 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9509 */   // GIR_Coverage, 1997,
     /*  9509 */   GIR_Done,
     /*  9510 */ // Label 391: @9510
     /*  9510 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(9536), // Rule ID 2006 //
     /*  9515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9525 */   // (bitconvert:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src, MSA128H:{ *:[i32] })
     /*  9525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9530 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9535 */   // GIR_Coverage, 2006,
     /*  9535 */   GIR_Done,
     /*  9536 */ // Label 392: @9536
     /*  9536 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(9562), // Rule ID 2007 //
     /*  9541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9551 */   // (bitconvert:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] })
     /*  9551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9556 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9561 */   // GIR_Coverage, 2007,
     /*  9561 */   GIR_Done,
     /*  9562 */ // Label 393: @9562
     /*  9562 */ GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(9588), // Rule ID 2008 //
     /*  9567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9577 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] })
     /*  9577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9582 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9587 */   // GIR_Coverage, 2008,
     /*  9587 */   GIR_Done,
     /*  9588 */ // Label 394: @9588
     /*  9588 */ GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(9614), // Rule ID 2009 //
     /*  9593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9603 */   // (bitconvert:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] })
     /*  9603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9613 */   // GIR_Coverage, 2009,
     /*  9613 */   GIR_Done,
     /*  9614 */ // Label 395: @9614
     /*  9614 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(9640), // Rule ID 2010 //
     /*  9619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /*  9622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  9625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9629 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] })
     /*  9629 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9634 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9639 */   // GIR_Coverage, 2010,
     /*  9639 */   GIR_Done,
     /*  9640 */ // Label 396: @9640
     /*  9640 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(9717), // Rule ID 2031 //
     /*  9645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9655 */   // (bitconvert:{ *:[v8i16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9655 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  9658 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9662 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9667 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9671 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  9676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  9679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  9683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9688 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9691 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9701 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9716 */   // GIR_Coverage, 2031,
     /*  9716 */   GIR_EraseRootFromParent_Done,
     /*  9717 */ // Label 397: @9717
     /*  9717 */ GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(9794), // Rule ID 2032 //
     /*  9722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  9728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9732 */   // (bitconvert:{ *:[v8f16] } v16i8:{ *:[v16i8] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9732 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  9735 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9739 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9744 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9748 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /*  9753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  9756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /*  9760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9765 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9768 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9788 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9793 */   // GIR_Coverage, 2032,
     /*  9793 */   GIR_EraseRootFromParent_Done,
     /*  9794 */ // Label 398: @9794
     /*  9794 */ GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(9871), // Rule ID 2048 //
     /*  9799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9809 */   // (bitconvert:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9809 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9812 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9816 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9821 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9825 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9842 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9845 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9855 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9857 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9860 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9862 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9865 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9870 */   // GIR_Coverage, 2048,
     /*  9870 */   GIR_EraseRootFromParent_Done,
     /*  9871 */ // Label 399: @9871
     /*  9871 */ GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(9948), // Rule ID 2049 //
     /*  9876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9886 */   // (bitconvert:{ *:[v8f16] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4i32:{ *:[v4i32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9886 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9889 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9893 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9898 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9902 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9919 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9922 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /*  9932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  9934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  9939 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  9942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9947 */   // GIR_Coverage, 2049,
     /*  9947 */   GIR_EraseRootFromParent_Done,
     /*  9948 */ // Label 400: @9948
     /*  9948 */ GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(10025), // Rule ID 2053 //
     /*  9953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /*  9956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  9959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9963 */   // (bitconvert:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /*  9963 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  9966 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  9970 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9975 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  9979 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /*  9984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  9987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /*  9991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  9996 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  9999 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10011 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10014 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10019 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10024 */   // GIR_Coverage, 2053,
     /* 10024 */   GIR_EraseRootFromParent_Done,
     /* 10025 */ // Label 401: @10025
     /* 10025 */ GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(10102), // Rule ID 2054 //
     /* 10030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10040 */   // (bitconvert:{ *:[v8f16] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v4f32:{ *:[v4f32] }:$src, MSA128H:{ *:[i32] }), 177:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10040 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10043 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10047 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10052 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10056 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10061 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10064 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10068 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10073 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10076 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10101 */   // GIR_Coverage, 2054,
     /* 10101 */   GIR_EraseRootFromParent_Done,
     /* 10102 */ // Label 402: @10102
     /* 10102 */ GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(10172), // Rule ID 2058 //
     /* 10107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10117 */   // (bitconvert:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10117 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10120 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10124 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10129 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10133 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10150 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10153 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10166 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10171 */   // GIR_Coverage, 2058,
     /* 10171 */   GIR_EraseRootFromParent_Done,
     /* 10172 */ // Label 403: @10172
     /* 10172 */ GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(10242), // Rule ID 2059 //
     /* 10177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10187 */   // (bitconvert:{ *:[v8f16] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2i64:{ *:[v2i64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10187 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10190 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10194 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10199 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10203 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10220 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10223 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10241 */   // GIR_Coverage, 2059,
     /* 10241 */   GIR_EraseRootFromParent_Done,
     /* 10242 */ // Label 404: @10242
     /* 10242 */ GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(10312), // Rule ID 2063 //
     /* 10247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10257 */   // (bitconvert:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8i16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10257 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10260 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10264 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10269 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10273 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10290 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10293 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10306 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10311 */   // GIR_Coverage, 2063,
     /* 10311 */   GIR_EraseRootFromParent_Done,
     /* 10312 */ // Label 405: @10312
     /* 10312 */ GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(10382), // Rule ID 2064 //
     /* 10317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10327 */   // (bitconvert:{ *:[v8f16] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v8f16] } (SHF_H:{ *:[v8i16] } (COPY_TO_REGCLASS:{ *:[v8i16] } v2f64:{ *:[v2f64] }:$src, MSA128H:{ *:[i32] }), 27:{ *:[i32] }), MSA128H:{ *:[i32] })
     /* 10327 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 10330 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10334 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10339 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10343 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 10351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_H),
     /* 10355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10360 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10363 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10373 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10376 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 10381 */   // GIR_Coverage, 2064,
     /* 10381 */   GIR_EraseRootFromParent_Done,
     /* 10382 */ // Label 406: @10382
     /* 10382 */ GIM_Reject,
     /* 10383 */ // Label 325: @10383
     /* 10383 */ GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(10409), // Rule ID 2000 //
     /* 10388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10398 */   // (bitconvert:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src, MSA128B:{ *:[i32] })
     /* 10398 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10403 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10408 */   // GIR_Coverage, 2000,
     /* 10408 */   GIR_Done,
     /* 10409 */ // Label 407: @10409
     /* 10409 */ GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(10435), // Rule ID 2001 //
     /* 10414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10424 */   // (bitconvert:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src, MSA128B:{ *:[i32] })
     /* 10424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10434 */   // GIR_Coverage, 2001,
     /* 10434 */   GIR_Done,
     /* 10435 */ // Label 408: @10435
     /* 10435 */ GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(10461), // Rule ID 2002 //
     /* 10440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10450 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src, MSA128B:{ *:[i32] })
     /* 10450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10460 */   // GIR_Coverage, 2002,
     /* 10460 */   GIR_Done,
     /* 10461 */ // Label 409: @10461
     /* 10461 */ GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(10487), // Rule ID 2003 //
     /* 10466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10476 */   // (bitconvert:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src, MSA128B:{ *:[i32] })
     /* 10476 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10486 */   // GIR_Coverage, 2003,
     /* 10486 */   GIR_Done,
     /* 10487 */ // Label 410: @10487
     /* 10487 */ GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(10513), // Rule ID 2004 //
     /* 10492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10502 */   // (bitconvert:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src, MSA128B:{ *:[i32] })
     /* 10502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10507 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10512 */   // GIR_Coverage, 2004,
     /* 10512 */   GIR_Done,
     /* 10513 */ // Label 411: @10513
     /* 10513 */ GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(10539), // Rule ID 2005 //
     /* 10518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsLE),
     /* 10521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10528 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src, MSA128B:{ *:[i32] })
     /* 10528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10538 */   // GIR_Coverage, 2005,
     /* 10538 */   GIR_Done,
     /* 10539 */ // Label 412: @10539
     /* 10539 */ GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(10616), // Rule ID 2037 //
     /* 10544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10554 */   // (bitconvert:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v8i16:{ *:[v8i16] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10554 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10557 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10561 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10566 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10570 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10587 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10590 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10600 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10610 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10615 */   // GIR_Coverage, 2037,
     /* 10615 */   GIR_EraseRootFromParent_Done,
     /* 10616 */ // Label 413: @10616
     /* 10616 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(10693), // Rule ID 2042 //
     /* 10621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 10627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10631 */   // (bitconvert:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v8f16:{ *:[v8f16] }:$src, MSA128B:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10631 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10634 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10638 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10643 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10647 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10652 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10655 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10659 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10664 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10667 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10687 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10692 */   // GIR_Coverage, 2042,
     /* 10692 */   GIR_EraseRootFromParent_Done,
     /* 10693 */ // Label 414: @10693
     /* 10693 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(10763), // Rule ID 2047 //
     /* 10698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10708 */   // (bitconvert:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v4i32:{ *:[v4i32] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10708 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10711 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10715 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10720 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10724 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10729 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10732 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10736 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10741 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10744 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10762 */   // GIR_Coverage, 2047,
     /* 10762 */   GIR_EraseRootFromParent_Done,
     /* 10763 */ // Label 415: @10763
     /* 10763 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(10833), // Rule ID 2052 //
     /* 10768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 10774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10778 */   // (bitconvert:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v4f32:{ *:[v4f32] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10778 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 10781 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10785 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10790 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10794 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 10802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10811 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10814 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/27,
     /* 10817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10832 */   // GIR_Coverage, 2052,
     /* 10832 */   GIR_EraseRootFromParent_Done,
     /* 10833 */ // Label 416: @10833
     /* 10833 */ GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(10950), // Rule ID 2057 //
     /* 10838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10848 */   // (bitconvert:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v2i64:{ *:[v2i64] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10848 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 10851 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10855 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10860 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10864 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10869 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 10872 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10876 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10881 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 10884 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /* 10887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 10889 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 10892 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10896 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10901 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 10904 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 10909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 10912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /* 10916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10921 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 10924 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 10934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 10936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 10941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 10944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10949 */   // GIR_Coverage, 2057,
     /* 10949 */   GIR_EraseRootFromParent_Done,
     /* 10950 */ // Label 417: @10950
     /* 10950 */ GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(11067), // Rule ID 2062 //
     /* 10955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_IsBE),
     /* 10958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 10961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10965 */   // (bitconvert:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src)  =>  (COPY_TO_REGCLASS:{ *:[v16i8] } (SHF_W:{ *:[v4i32] } (COPY_TO_REGCLASS:{ *:[v4i32] } (SHF_B:{ *:[v16i8] } (COPY_TO_REGCLASS:{ *:[v16i8] } v2f64:{ *:[v2f64] }:$src, MSA128B:{ *:[i32] }), 27:{ *:[i32] }), MSA128W:{ *:[i32] }), 177:{ *:[i32] }), MSA128B:{ *:[i32] })
     /* 10965 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 10968 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 10972 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10977 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 10981 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 10986 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 10989 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SHF_B),
     /* 10993 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 10998 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 11001 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/27,
     /* 11004 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 11006 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 11009 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11013 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11018 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 11021 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 11026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 11029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SHF_W),
     /* 11033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 11038 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 11041 */   GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(177),
     /* 11051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 11053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 11056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 11058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 11061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 11066 */   // GIR_Coverage, 2062,
     /* 11066 */   GIR_EraseRootFromParent_Done,
     /* 11067 */ // Label 418: @11067
     /* 11067 */ GIM_Reject,
     /* 11068 */ // Label 326: @11068
     /* 11068 */ GIM_Reject,
     /* 11069 */ // Label 13: @11069
     /* 11069 */ GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(11133), // Rule ID 1985 //
     /* 11074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11077 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11080 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11083 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 11087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11091 */   // MIs[0] Operand 1
     /* 11091 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11103 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11107 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11111 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11113 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LWX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX),
     /* 11116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11118 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11122 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11131 */   GIR_RootConstrainSelectedInstOperands,
     /* 11132 */   // GIR_Coverage, 1985,
     /* 11132 */   GIR_EraseRootFromParent_Done,
     /* 11133 */ // Label 419: @11133
     /* 11133 */ GIM_Reject,
     /* 11134 */ // Label 14: @11134
     /* 11134 */ GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(11201), // Rule ID 1984 //
     /* 11139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11142 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11145 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11159 */   // MIs[0] Operand 1
     /* 11159 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11171 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11175 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11181 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LHX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX),
     /* 11184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11186 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11190 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11199 */   GIR_RootConstrainSelectedInstOperands,
     /* 11200 */   // GIR_Coverage, 1984,
     /* 11200 */   GIR_EraseRootFromParent_Done,
     /* 11201 */ // Label 420: @11201
     /* 11201 */ GIM_Reject,
     /* 11202 */ // Label 15: @11202
     /* 11202 */ GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(11269), // Rule ID 1983 //
     /* 11207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 11210 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 11213 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 11216 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11227 */   // MIs[0] Operand 1
     /* 11227 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /* 11231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 11235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 11239 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 11243 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 11247 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 11249 */   // (ld:{ *:[i32] } (add:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBUX:{ *:[i32] } i32:{ *:[i32] }:$base, i32:{ *:[i32] }:$index)
     /* 11249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX),
     /* 11252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 11254 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // base
     /* 11258 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // index
     /* 11262 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 11267 */   GIR_RootConstrainSelectedInstOperands,
     /* 11268 */   // GIR_Coverage, 1983,
     /* 11268 */   GIR_EraseRootFromParent_Done,
     /* 11269 */ // Label 421: @11269
     /* 11269 */ GIM_Reject,
     /* 11270 */ // Label 16: @11270
     /* 11270 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 424*/ GIMT_Encode4(11461),
     /* 11281 */ /*GILLT_s32*//*Label 422*/ GIMT_Encode4(11289),
     /* 11285 */ /*GILLT_s64*//*Label 423*/ GIMT_Encode4(11416),
     /* 11289 */ // Label 422: @11289
     /* 11289 */ GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(11415),
     /* 11294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 11300 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(11338), // Rule ID 25 //
     /* 11305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11319 */     // MIs[0] ptr
     /* 11319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11331 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (ATOMIC_CMP_SWAP_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I8),
     /* 11336 */     GIR_RootConstrainSelectedInstOperands,
     /* 11337 */     // GIR_Coverage, 25,
     /* 11337 */     GIR_Done,
     /* 11338 */   // Label 426: @11338
     /* 11338 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(11376), // Rule ID 26 //
     /* 11343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11357 */     // MIs[0] ptr
     /* 11357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11369 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (ATOMIC_CMP_SWAP_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I16),
     /* 11374 */     GIR_RootConstrainSelectedInstOperands,
     /* 11375 */     // GIR_Coverage, 26,
     /* 11375 */     GIR_Done,
     /* 11376 */   // Label 427: @11376
     /* 11376 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(11414), // Rule ID 27 //
     /* 11381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11395 */     // MIs[0] ptr
     /* 11395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11407 */     // (atomic_cmp_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (ATOMIC_CMP_SWAP_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$cmp, GPR32:{ *:[i32] }:$swap)
     /* 11407 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I32),
     /* 11412 */     GIR_RootConstrainSelectedInstOperands,
     /* 11413 */     // GIR_Coverage, 27,
     /* 11413 */     GIR_Done,
     /* 11414 */   // Label 428: @11414
     /* 11414 */   GIM_Reject,
     /* 11415 */ // Label 425: @11415
     /* 11415 */ GIM_Reject,
     /* 11416 */ // Label 423: @11416
     /* 11416 */ GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(11460), // Rule ID 191 //
     /* 11421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 11430 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11441 */   // MIs[0] ptr
     /* 11441 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11449 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11453 */   // (atomic_cmp_swap:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$cmp, GPR64:{ *:[i64] }:$swap)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (ATOMIC_CMP_SWAP_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$cmp, GPR64:{ *:[i64] }:$swap)
     /* 11453 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_CMP_SWAP_I64),
     /* 11458 */   GIR_RootConstrainSelectedInstOperands,
     /* 11459 */   // GIR_Coverage, 191,
     /* 11459 */   GIR_Done,
     /* 11460 */ // Label 429: @11460
     /* 11460 */ GIM_Reject,
     /* 11461 */ // Label 424: @11461
     /* 11461 */ GIM_Reject,
     /* 11462 */ // Label 17: @11462
     /* 11462 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 432*/ GIMT_Encode4(11631),
     /* 11473 */ /*GILLT_s32*//*Label 430*/ GIMT_Encode4(11481),
     /* 11477 */ /*GILLT_s64*//*Label 431*/ GIMT_Encode4(11593),
     /* 11481 */ // Label 430: @11481
     /* 11481 */ GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(11592),
     /* 11486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11489 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(11523), // Rule ID 22 //
     /* 11494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11497 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11508 */     // MIs[0] ptr
     /* 11508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11516 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i8>>  =>  (ATOMIC_SWAP_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I8),
     /* 11521 */     GIR_RootConstrainSelectedInstOperands,
     /* 11522 */     // GIR_Coverage, 22,
     /* 11522 */     GIR_Done,
     /* 11523 */   // Label 434: @11523
     /* 11523 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(11557), // Rule ID 23 //
     /* 11528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11531 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11542 */     // MIs[0] ptr
     /* 11542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11550 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i16>>  =>  (ATOMIC_SWAP_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I16),
     /* 11555 */     GIR_RootConstrainSelectedInstOperands,
     /* 11556 */     // GIR_Coverage, 23,
     /* 11556 */     GIR_Done,
     /* 11557 */   // Label 435: @11557
     /* 11557 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(11591), // Rule ID 24 //
     /* 11562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11576 */     // MIs[0] ptr
     /* 11576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11584 */     // (atomic_swap:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_swap_i32>>  =>  (ATOMIC_SWAP_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11584 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I32),
     /* 11589 */     GIR_RootConstrainSelectedInstOperands,
     /* 11590 */     // GIR_Coverage, 24,
     /* 11590 */     GIR_Done,
     /* 11591 */   // Label 436: @11591
     /* 11591 */   GIM_Reject,
     /* 11592 */ // Label 433: @11592
     /* 11592 */ GIM_Reject,
     /* 11593 */ // Label 431: @11593
     /* 11593 */ GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(11630), // Rule ID 190 //
     /* 11598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11604 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11615 */   // MIs[0] ptr
     /* 11615 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11623 */   // (atomic_swap:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_swap_i64>>  =>  (ATOMIC_SWAP_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_SWAP_I64),
     /* 11628 */   GIR_RootConstrainSelectedInstOperands,
     /* 11629 */   // GIR_Coverage, 190,
     /* 11629 */   GIR_Done,
     /* 11630 */ // Label 437: @11630
     /* 11630 */ GIM_Reject,
     /* 11631 */ // Label 432: @11631
     /* 11631 */ GIM_Reject,
     /* 11632 */ // Label 18: @11632
     /* 11632 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 440*/ GIMT_Encode4(11801),
     /* 11643 */ /*GILLT_s32*//*Label 438*/ GIMT_Encode4(11651),
     /* 11647 */ /*GILLT_s64*//*Label 439*/ GIMT_Encode4(11763),
     /* 11651 */ // Label 438: @11651
     /* 11651 */ GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(11762),
     /* 11656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11659 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(11693), // Rule ID 4 //
     /* 11664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11667 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11678 */     // MIs[0] ptr
     /* 11678 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11686 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i8>>  =>  (ATOMIC_LOAD_ADD_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11686 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I8),
     /* 11691 */     GIR_RootConstrainSelectedInstOperands,
     /* 11692 */     // GIR_Coverage, 4,
     /* 11692 */     GIR_Done,
     /* 11693 */   // Label 442: @11693
     /* 11693 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(11727), // Rule ID 5 //
     /* 11698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11701 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11712 */     // MIs[0] ptr
     /* 11712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11720 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i16>>  =>  (ATOMIC_LOAD_ADD_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11720 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I16),
     /* 11725 */     GIR_RootConstrainSelectedInstOperands,
     /* 11726 */     // GIR_Coverage, 5,
     /* 11726 */     GIR_Done,
     /* 11727 */   // Label 443: @11727
     /* 11727 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(11761), // Rule ID 6 //
     /* 11732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11746 */     // MIs[0] ptr
     /* 11746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11754 */     // (atomic_load_add:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_add_i32>>  =>  (ATOMIC_LOAD_ADD_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I32),
     /* 11759 */     GIR_RootConstrainSelectedInstOperands,
     /* 11760 */     // GIR_Coverage, 6,
     /* 11760 */     GIR_Done,
     /* 11761 */   // Label 444: @11761
     /* 11761 */   GIM_Reject,
     /* 11762 */ // Label 441: @11762
     /* 11762 */ GIM_Reject,
     /* 11763 */ // Label 439: @11763
     /* 11763 */ GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(11800), // Rule ID 184 //
     /* 11768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11771 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11785 */   // MIs[0] ptr
     /* 11785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11793 */   // (atomic_load_add:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_add_i64>>  =>  (ATOMIC_LOAD_ADD_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_ADD_I64),
     /* 11798 */   GIR_RootConstrainSelectedInstOperands,
     /* 11799 */   // GIR_Coverage, 184,
     /* 11799 */   GIR_Done,
     /* 11800 */ // Label 445: @11800
     /* 11800 */ GIM_Reject,
     /* 11801 */ // Label 440: @11801
     /* 11801 */ GIM_Reject,
     /* 11802 */ // Label 19: @11802
     /* 11802 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 448*/ GIMT_Encode4(11971),
     /* 11813 */ /*GILLT_s32*//*Label 446*/ GIMT_Encode4(11821),
     /* 11817 */ /*GILLT_s64*//*Label 447*/ GIMT_Encode4(11933),
     /* 11821 */ // Label 446: @11821
     /* 11821 */ GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(11932),
     /* 11826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11829 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(11863), // Rule ID 7 //
     /* 11834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11837 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 11844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11848 */     // MIs[0] ptr
     /* 11848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11856 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i8>>  =>  (ATOMIC_LOAD_SUB_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I8),
     /* 11861 */     GIR_RootConstrainSelectedInstOperands,
     /* 11862 */     // GIR_Coverage, 7,
     /* 11862 */     GIR_Done,
     /* 11863 */   // Label 450: @11863
     /* 11863 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(11897), // Rule ID 8 //
     /* 11868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 11878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11882 */     // MIs[0] ptr
     /* 11882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11890 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i16>>  =>  (ATOMIC_LOAD_SUB_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11890 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I16),
     /* 11895 */     GIR_RootConstrainSelectedInstOperands,
     /* 11896 */     // GIR_Coverage, 8,
     /* 11896 */     GIR_Done,
     /* 11897 */   // Label 451: @11897
     /* 11897 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(11931), // Rule ID 9 //
     /* 11902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11905 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 11912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11916 */     // MIs[0] ptr
     /* 11916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 11924 */     // (atomic_load_sub:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_sub_i32>>  =>  (ATOMIC_LOAD_SUB_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 11924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I32),
     /* 11929 */     GIR_RootConstrainSelectedInstOperands,
     /* 11930 */     // GIR_Coverage, 9,
     /* 11930 */     GIR_Done,
     /* 11931 */   // Label 452: @11931
     /* 11931 */   GIM_Reject,
     /* 11932 */ // Label 449: @11932
     /* 11932 */ GIM_Reject,
     /* 11933 */ // Label 447: @11933
     /* 11933 */ GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(11970), // Rule ID 185 //
     /* 11938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 11941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 11944 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 11951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11955 */   // MIs[0] ptr
     /* 11955 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 11959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 11963 */   // (atomic_load_sub:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_sub_i64>>  =>  (ATOMIC_LOAD_SUB_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 11963 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_SUB_I64),
     /* 11968 */   GIR_RootConstrainSelectedInstOperands,
     /* 11969 */   // GIR_Coverage, 185,
     /* 11969 */   GIR_Done,
     /* 11970 */ // Label 453: @11970
     /* 11970 */ GIM_Reject,
     /* 11971 */ // Label 448: @11971
     /* 11971 */ GIM_Reject,
     /* 11972 */ // Label 20: @11972
     /* 11972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 456*/ GIMT_Encode4(12141),
     /* 11983 */ /*GILLT_s32*//*Label 454*/ GIMT_Encode4(11991),
     /* 11987 */ /*GILLT_s64*//*Label 455*/ GIMT_Encode4(12103),
     /* 11991 */ // Label 454: @11991
     /* 11991 */ GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(12102),
     /* 11996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 11999 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(12033), // Rule ID 10 //
     /* 12004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12018 */     // MIs[0] ptr
     /* 12018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12026 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i8>>  =>  (ATOMIC_LOAD_AND_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I8),
     /* 12031 */     GIR_RootConstrainSelectedInstOperands,
     /* 12032 */     // GIR_Coverage, 10,
     /* 12032 */     GIR_Done,
     /* 12033 */   // Label 458: @12033
     /* 12033 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(12067), // Rule ID 11 //
     /* 12038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12052 */     // MIs[0] ptr
     /* 12052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12060 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i16>>  =>  (ATOMIC_LOAD_AND_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I16),
     /* 12065 */     GIR_RootConstrainSelectedInstOperands,
     /* 12066 */     // GIR_Coverage, 11,
     /* 12066 */     GIR_Done,
     /* 12067 */   // Label 459: @12067
     /* 12067 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(12101), // Rule ID 12 //
     /* 12072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12075 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12086 */     // MIs[0] ptr
     /* 12086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12094 */     // (atomic_load_and:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_and_i32>>  =>  (ATOMIC_LOAD_AND_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12094 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I32),
     /* 12099 */     GIR_RootConstrainSelectedInstOperands,
     /* 12100 */     // GIR_Coverage, 12,
     /* 12100 */     GIR_Done,
     /* 12101 */   // Label 460: @12101
     /* 12101 */   GIM_Reject,
     /* 12102 */ // Label 457: @12102
     /* 12102 */ GIM_Reject,
     /* 12103 */ // Label 455: @12103
     /* 12103 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(12140), // Rule ID 186 //
     /* 12108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12114 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12125 */   // MIs[0] ptr
     /* 12125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12133 */   // (atomic_load_and:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_and_i64>>  =>  (ATOMIC_LOAD_AND_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_AND_I64),
     /* 12138 */   GIR_RootConstrainSelectedInstOperands,
     /* 12139 */   // GIR_Coverage, 186,
     /* 12139 */   GIR_Done,
     /* 12140 */ // Label 461: @12140
     /* 12140 */ GIM_Reject,
     /* 12141 */ // Label 456: @12141
     /* 12141 */ GIM_Reject,
     /* 12142 */ // Label 21: @12142
     /* 12142 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 464*/ GIMT_Encode4(12311),
     /* 12153 */ /*GILLT_s32*//*Label 462*/ GIMT_Encode4(12161),
     /* 12157 */ /*GILLT_s64*//*Label 463*/ GIMT_Encode4(12273),
     /* 12161 */ // Label 462: @12161
     /* 12161 */ GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(12272),
     /* 12166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12169 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(12203), // Rule ID 19 //
     /* 12174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12177 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12188 */     // MIs[0] ptr
     /* 12188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12196 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i8>>  =>  (ATOMIC_LOAD_NAND_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I8),
     /* 12201 */     GIR_RootConstrainSelectedInstOperands,
     /* 12202 */     // GIR_Coverage, 19,
     /* 12202 */     GIR_Done,
     /* 12203 */   // Label 466: @12203
     /* 12203 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(12237), // Rule ID 20 //
     /* 12208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12211 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12222 */     // MIs[0] ptr
     /* 12222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12230 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i16>>  =>  (ATOMIC_LOAD_NAND_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I16),
     /* 12235 */     GIR_RootConstrainSelectedInstOperands,
     /* 12236 */     // GIR_Coverage, 20,
     /* 12236 */     GIR_Done,
     /* 12237 */   // Label 467: @12237
     /* 12237 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(12271), // Rule ID 21 //
     /* 12242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12256 */     // MIs[0] ptr
     /* 12256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12264 */     // (atomic_load_nand:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>>  =>  (ATOMIC_LOAD_NAND_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I32),
     /* 12269 */     GIR_RootConstrainSelectedInstOperands,
     /* 12270 */     // GIR_Coverage, 21,
     /* 12270 */     GIR_Done,
     /* 12271 */   // Label 468: @12271
     /* 12271 */   GIM_Reject,
     /* 12272 */ // Label 465: @12272
     /* 12272 */ GIM_Reject,
     /* 12273 */ // Label 463: @12273
     /* 12273 */ GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(12310), // Rule ID 189 //
     /* 12278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12295 */   // MIs[0] ptr
     /* 12295 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12303 */   // (atomic_load_nand:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>>  =>  (ATOMIC_LOAD_NAND_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_NAND_I64),
     /* 12308 */   GIR_RootConstrainSelectedInstOperands,
     /* 12309 */   // GIR_Coverage, 189,
     /* 12309 */   GIR_Done,
     /* 12310 */ // Label 469: @12310
     /* 12310 */ GIM_Reject,
     /* 12311 */ // Label 464: @12311
     /* 12311 */ GIM_Reject,
     /* 12312 */ // Label 22: @12312
     /* 12312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 472*/ GIMT_Encode4(12481),
     /* 12323 */ /*GILLT_s32*//*Label 470*/ GIMT_Encode4(12331),
     /* 12327 */ /*GILLT_s64*//*Label 471*/ GIMT_Encode4(12443),
     /* 12331 */ // Label 470: @12331
     /* 12331 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(12442),
     /* 12336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12339 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(12373), // Rule ID 13 //
     /* 12344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12347 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12358 */     // MIs[0] ptr
     /* 12358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12366 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i8>>  =>  (ATOMIC_LOAD_OR_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I8),
     /* 12371 */     GIR_RootConstrainSelectedInstOperands,
     /* 12372 */     // GIR_Coverage, 13,
     /* 12372 */     GIR_Done,
     /* 12373 */   // Label 474: @12373
     /* 12373 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(12407), // Rule ID 14 //
     /* 12378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12381 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12392 */     // MIs[0] ptr
     /* 12392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12400 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i16>>  =>  (ATOMIC_LOAD_OR_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I16),
     /* 12405 */     GIR_RootConstrainSelectedInstOperands,
     /* 12406 */     // GIR_Coverage, 14,
     /* 12406 */     GIR_Done,
     /* 12407 */   // Label 475: @12407
     /* 12407 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(12441), // Rule ID 15 //
     /* 12412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12415 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12426 */     // MIs[0] ptr
     /* 12426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12434 */     // (atomic_load_or:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_or_i32>>  =>  (ATOMIC_LOAD_OR_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I32),
     /* 12439 */     GIR_RootConstrainSelectedInstOperands,
     /* 12440 */     // GIR_Coverage, 15,
     /* 12440 */     GIR_Done,
     /* 12441 */   // Label 476: @12441
     /* 12441 */   GIM_Reject,
     /* 12442 */ // Label 473: @12442
     /* 12442 */ GIM_Reject,
     /* 12443 */ // Label 471: @12443
     /* 12443 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(12480), // Rule ID 187 //
     /* 12448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12454 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12465 */   // MIs[0] ptr
     /* 12465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12473 */   // (atomic_load_or:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_or_i64>>  =>  (ATOMIC_LOAD_OR_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_OR_I64),
     /* 12478 */   GIR_RootConstrainSelectedInstOperands,
     /* 12479 */   // GIR_Coverage, 187,
     /* 12479 */   GIR_Done,
     /* 12480 */ // Label 477: @12480
     /* 12480 */ GIM_Reject,
     /* 12481 */ // Label 472: @12481
     /* 12481 */ GIM_Reject,
     /* 12482 */ // Label 23: @12482
     /* 12482 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 480*/ GIMT_Encode4(12651),
     /* 12493 */ /*GILLT_s32*//*Label 478*/ GIMT_Encode4(12501),
     /* 12497 */ /*GILLT_s64*//*Label 479*/ GIMT_Encode4(12613),
     /* 12501 */ // Label 478: @12501
     /* 12501 */ GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(12612),
     /* 12506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12509 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(12543), // Rule ID 16 //
     /* 12514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12517 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12528 */     // MIs[0] ptr
     /* 12528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12536 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i8>>  =>  (ATOMIC_LOAD_XOR_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I8),
     /* 12541 */     GIR_RootConstrainSelectedInstOperands,
     /* 12542 */     // GIR_Coverage, 16,
     /* 12542 */     GIR_Done,
     /* 12543 */   // Label 482: @12543
     /* 12543 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(12577), // Rule ID 17 //
     /* 12548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12562 */     // MIs[0] ptr
     /* 12562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12570 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i16>>  =>  (ATOMIC_LOAD_XOR_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12570 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I16),
     /* 12575 */     GIR_RootConstrainSelectedInstOperands,
     /* 12576 */     // GIR_Coverage, 17,
     /* 12576 */     GIR_Done,
     /* 12577 */   // Label 483: @12577
     /* 12577 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(12611), // Rule ID 18 //
     /* 12582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12596 */     // MIs[0] ptr
     /* 12596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12604 */     // (atomic_load_xor:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_xor_i32>>  =>  (ATOMIC_LOAD_XOR_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I32),
     /* 12609 */     GIR_RootConstrainSelectedInstOperands,
     /* 12610 */     // GIR_Coverage, 18,
     /* 12610 */     GIR_Done,
     /* 12611 */   // Label 484: @12611
     /* 12611 */   GIM_Reject,
     /* 12612 */ // Label 481: @12612
     /* 12612 */ GIM_Reject,
     /* 12613 */ // Label 479: @12613
     /* 12613 */ GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(12650), // Rule ID 188 //
     /* 12618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12624 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12635 */   // MIs[0] ptr
     /* 12635 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12643 */   // (atomic_load_xor:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_xor_i64>>  =>  (ATOMIC_LOAD_XOR_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_XOR_I64),
     /* 12648 */   GIR_RootConstrainSelectedInstOperands,
     /* 12649 */   // GIR_Coverage, 188,
     /* 12649 */   GIR_Done,
     /* 12650 */ // Label 485: @12650
     /* 12650 */ GIM_Reject,
     /* 12651 */ // Label 480: @12651
     /* 12651 */ GIM_Reject,
     /* 12652 */ // Label 24: @12652
     /* 12652 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 488*/ GIMT_Encode4(12821),
     /* 12663 */ /*GILLT_s32*//*Label 486*/ GIMT_Encode4(12671),
     /* 12667 */ /*GILLT_s64*//*Label 487*/ GIMT_Encode4(12783),
     /* 12671 */ // Label 486: @12671
     /* 12671 */ GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(12782),
     /* 12676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12679 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(12713), // Rule ID 31 //
     /* 12684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12698 */     // MIs[0] ptr
     /* 12698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12706 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i8>>  =>  (ATOMIC_LOAD_MAX_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I8),
     /* 12711 */     GIR_RootConstrainSelectedInstOperands,
     /* 12712 */     // GIR_Coverage, 31,
     /* 12712 */     GIR_Done,
     /* 12713 */   // Label 490: @12713
     /* 12713 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(12747), // Rule ID 32 //
     /* 12718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12732 */     // MIs[0] ptr
     /* 12732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12740 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i16>>  =>  (ATOMIC_LOAD_MAX_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I16),
     /* 12745 */     GIR_RootConstrainSelectedInstOperands,
     /* 12746 */     // GIR_Coverage, 32,
     /* 12746 */     GIR_Done,
     /* 12747 */   // Label 491: @12747
     /* 12747 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(12781), // Rule ID 33 //
     /* 12752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12755 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12766 */     // MIs[0] ptr
     /* 12766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12774 */     // (atomic_load_max:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_max_i32>>  =>  (ATOMIC_LOAD_MAX_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I32),
     /* 12779 */     GIR_RootConstrainSelectedInstOperands,
     /* 12780 */     // GIR_Coverage, 33,
     /* 12780 */     GIR_Done,
     /* 12781 */   // Label 492: @12781
     /* 12781 */   GIM_Reject,
     /* 12782 */ // Label 489: @12782
     /* 12782 */ GIM_Reject,
     /* 12783 */ // Label 487: @12783
     /* 12783 */ GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(12820), // Rule ID 193 //
     /* 12788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12794 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12805 */   // MIs[0] ptr
     /* 12805 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12813 */   // (atomic_load_max:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_max_i64>>  =>  (ATOMIC_LOAD_MAX_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MAX_I64),
     /* 12818 */   GIR_RootConstrainSelectedInstOperands,
     /* 12819 */   // GIR_Coverage, 193,
     /* 12819 */   GIR_Done,
     /* 12820 */ // Label 493: @12820
     /* 12820 */ GIM_Reject,
     /* 12821 */ // Label 488: @12821
     /* 12821 */ GIM_Reject,
     /* 12822 */ // Label 25: @12822
     /* 12822 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 496*/ GIMT_Encode4(12991),
     /* 12833 */ /*GILLT_s32*//*Label 494*/ GIMT_Encode4(12841),
     /* 12837 */ /*GILLT_s64*//*Label 495*/ GIMT_Encode4(12953),
     /* 12841 */ // Label 494: @12841
     /* 12841 */ GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(12952),
     /* 12846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 12849 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(12883), // Rule ID 28 //
     /* 12854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12868 */     // MIs[0] ptr
     /* 12868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12876 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i8>>  =>  (ATOMIC_LOAD_MIN_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I8),
     /* 12881 */     GIR_RootConstrainSelectedInstOperands,
     /* 12882 */     // GIR_Coverage, 28,
     /* 12882 */     GIR_Done,
     /* 12883 */   // Label 498: @12883
     /* 12883 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(12917), // Rule ID 29 //
     /* 12888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12891 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 12898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12902 */     // MIs[0] ptr
     /* 12902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12910 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i16>>  =>  (ATOMIC_LOAD_MIN_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I16),
     /* 12915 */     GIR_RootConstrainSelectedInstOperands,
     /* 12916 */     // GIR_Coverage, 29,
     /* 12916 */     GIR_Done,
     /* 12917 */   // Label 499: @12917
     /* 12917 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(12951), // Rule ID 30 //
     /* 12922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 12932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12936 */     // MIs[0] ptr
     /* 12936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 12944 */     // (atomic_load_min:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_min_i32>>  =>  (ATOMIC_LOAD_MIN_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 12944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I32),
     /* 12949 */     GIR_RootConstrainSelectedInstOperands,
     /* 12950 */     // GIR_Coverage, 30,
     /* 12950 */     GIR_Done,
     /* 12951 */   // Label 500: @12951
     /* 12951 */   GIM_Reject,
     /* 12952 */ // Label 497: @12952
     /* 12952 */ GIM_Reject,
     /* 12953 */ // Label 495: @12953
     /* 12953 */ GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(12990), // Rule ID 192 //
     /* 12958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 12961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 12964 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 12971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12975 */   // MIs[0] ptr
     /* 12975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 12979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 12983 */   // (atomic_load_min:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_min_i64>>  =>  (ATOMIC_LOAD_MIN_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 12983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_MIN_I64),
     /* 12988 */   GIR_RootConstrainSelectedInstOperands,
     /* 12989 */   // GIR_Coverage, 192,
     /* 12989 */   GIR_Done,
     /* 12990 */ // Label 501: @12990
     /* 12990 */ GIM_Reject,
     /* 12991 */ // Label 496: @12991
     /* 12991 */ GIM_Reject,
     /* 12992 */ // Label 26: @12992
     /* 12992 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 504*/ GIMT_Encode4(13161),
     /* 13003 */ /*GILLT_s32*//*Label 502*/ GIMT_Encode4(13011),
     /* 13007 */ /*GILLT_s64*//*Label 503*/ GIMT_Encode4(13123),
     /* 13011 */ // Label 502: @13011
     /* 13011 */ GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(13122),
     /* 13016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13019 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(13053), // Rule ID 37 //
     /* 13024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 13034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13038 */     // MIs[0] ptr
     /* 13038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13046 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i8>>  =>  (ATOMIC_LOAD_UMAX_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13046 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I8),
     /* 13051 */     GIR_RootConstrainSelectedInstOperands,
     /* 13052 */     // GIR_Coverage, 37,
     /* 13052 */     GIR_Done,
     /* 13053 */   // Label 506: @13053
     /* 13053 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(13087), // Rule ID 38 //
     /* 13058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13061 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 13068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13072 */     // MIs[0] ptr
     /* 13072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13080 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i16>>  =>  (ATOMIC_LOAD_UMAX_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I16),
     /* 13085 */     GIR_RootConstrainSelectedInstOperands,
     /* 13086 */     // GIR_Coverage, 38,
     /* 13086 */     GIR_Done,
     /* 13087 */   // Label 507: @13087
     /* 13087 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(13121), // Rule ID 39 //
     /* 13092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 13102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13106 */     // MIs[0] ptr
     /* 13106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13114 */     // (atomic_load_umax:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umax_i32>>  =>  (ATOMIC_LOAD_UMAX_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13114 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I32),
     /* 13119 */     GIR_RootConstrainSelectedInstOperands,
     /* 13120 */     // GIR_Coverage, 39,
     /* 13120 */     GIR_Done,
     /* 13121 */   // Label 508: @13121
     /* 13121 */   GIM_Reject,
     /* 13122 */ // Label 505: @13122
     /* 13122 */ GIM_Reject,
     /* 13123 */ // Label 503: @13123
     /* 13123 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(13160), // Rule ID 195 //
     /* 13128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13131 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 13134 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 13141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13145 */   // MIs[0] ptr
     /* 13145 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13153 */   // (atomic_load_umax:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_umax_i64>>  =>  (ATOMIC_LOAD_UMAX_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMAX_I64),
     /* 13158 */   GIR_RootConstrainSelectedInstOperands,
     /* 13159 */   // GIR_Coverage, 195,
     /* 13159 */   GIR_Done,
     /* 13160 */ // Label 509: @13160
     /* 13160 */ GIM_Reject,
     /* 13161 */ // Label 504: @13161
     /* 13161 */ GIM_Reject,
     /* 13162 */ // Label 27: @13162
     /* 13162 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 512*/ GIMT_Encode4(13331),
     /* 13173 */ /*GILLT_s32*//*Label 510*/ GIMT_Encode4(13181),
     /* 13177 */ /*GILLT_s64*//*Label 511*/ GIMT_Encode4(13293),
     /* 13181 */ // Label 510: @13181
     /* 13181 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(13292),
     /* 13186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 13189 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(13223), // Rule ID 34 //
     /* 13194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 13204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13208 */     // MIs[0] ptr
     /* 13208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13216 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i8>>  =>  (ATOMIC_LOAD_UMIN_I8:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I8),
     /* 13221 */     GIR_RootConstrainSelectedInstOperands,
     /* 13222 */     // GIR_Coverage, 34,
     /* 13222 */     GIR_Done,
     /* 13223 */   // Label 514: @13223
     /* 13223 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(13257), // Rule ID 35 //
     /* 13228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 13238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13242 */     // MIs[0] ptr
     /* 13242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13250 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i16>>  =>  (ATOMIC_LOAD_UMIN_I16:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I16),
     /* 13255 */     GIR_RootConstrainSelectedInstOperands,
     /* 13256 */     // GIR_Coverage, 35,
     /* 13256 */     GIR_Done,
     /* 13257 */   // Label 515: @13257
     /* 13257 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(13291), // Rule ID 36 //
     /* 13262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13265 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 13272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13276 */     // MIs[0] ptr
     /* 13276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 13284 */     // (atomic_load_umin:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_umin_i32>>  =>  (ATOMIC_LOAD_UMIN_I32:{ *:[i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$incr)
     /* 13284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I32),
     /* 13289 */     GIR_RootConstrainSelectedInstOperands,
     /* 13290 */     // GIR_Coverage, 36,
     /* 13290 */     GIR_Done,
     /* 13291 */   // Label 516: @13291
     /* 13291 */   GIM_Reject,
     /* 13292 */ // Label 513: @13292
     /* 13292 */ GIM_Reject,
     /* 13293 */ // Label 511: @13293
     /* 13293 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(13330), // Rule ID 194 //
     /* 13298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 13301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 13304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 13311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13315 */   // MIs[0] ptr
     /* 13315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 13319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13323 */   // (atomic_load_umin:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_umin_i64>>  =>  (ATOMIC_LOAD_UMIN_I64:{ *:[i64] } iPTR:{ *:[iPTR] }:$ptr, GPR64:{ *:[i64] }:$incr)
     /* 13323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ATOMIC_LOAD_UMIN_I64),
     /* 13328 */   GIR_RootConstrainSelectedInstOperands,
     /* 13329 */   // GIR_Coverage, 194,
     /* 13329 */   GIR_Done,
     /* 13330 */ // Label 517: @13330
     /* 13330 */ GIM_Reject,
     /* 13331 */ // Label 512: @13331
     /* 13331 */ GIM_Reject,
     /* 13332 */ // Label 28: @13332
     /* 13332 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 520*/ GIMT_Encode4(18052),
     /* 13343 */ /*GILLT_s32*//*Label 518*/ GIMT_Encode4(13351),
     /* 13347 */ /*GILLT_s64*//*Label 519*/ GIMT_Encode4(18018),
     /* 13351 */ // Label 518: @13351
     /* 13351 */ GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(13459), // Rule ID 2361 //
     /* 13356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13367 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13371 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13375 */   // MIs[1] Operand 1
     /* 13375 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13380 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13384 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13388 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13392 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13396 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13400 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13404 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13408 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13412 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13416 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13420 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13424 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13428 */   // MIs[4] Operand 1
     /* 13428 */   // No operand predicates
     /* 13428 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13433 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13437 */   // MIs[0] offset
     /* 13437 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13440 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13442 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT0 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT0),
     /* 13445 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13449 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13452 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13454 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13457 */   GIR_RootConstrainSelectedInstOperands,
     /* 13458 */   // GIR_Coverage, 2361,
     /* 13458 */   GIR_EraseRootFromParent_Done,
     /* 13459 */ // Label 521: @13459
     /* 13459 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(13574), // Rule ID 2362 //
     /* 13464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13475 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13479 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13483 */   // MIs[1] Operand 1
     /* 13483 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13488 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13492 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13496 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13500 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13504 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13508 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13512 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13516 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13520 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13531 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13535 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13539 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13543 */   // MIs[4] Operand 1
     /* 13543 */   // No operand predicates
     /* 13543 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13548 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13552 */   // MIs[0] offset
     /* 13552 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13555 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13557 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT032 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT032),
     /* 13560 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13564 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13567 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13569 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13572 */   GIR_RootConstrainSelectedInstOperands,
     /* 13573 */   // GIR_Coverage, 2362,
     /* 13573 */   GIR_EraseRootFromParent_Done,
     /* 13574 */ // Label 522: @13574
     /* 13574 */ GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(13682), // Rule ID 2363 //
     /* 13579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13590 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13594 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13598 */   // MIs[1] Operand 1
     /* 13598 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 13603 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13607 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13611 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13615 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13619 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13623 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13627 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13631 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13635 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13639 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13643 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13647 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13651 */   // MIs[4] Operand 1
     /* 13651 */   // No operand predicates
     /* 13651 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13656 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13660 */   // MIs[0] offset
     /* 13660 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13663 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13665 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT1 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT1),
     /* 13668 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13672 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13675 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13677 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13680 */   GIR_RootConstrainSelectedInstOperands,
     /* 13681 */   // GIR_Coverage, 2363,
     /* 13681 */   GIR_EraseRootFromParent_Done,
     /* 13682 */ // Label 523: @13682
     /* 13682 */ GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(13797), // Rule ID 2364 //
     /* 13687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13690 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13694 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13698 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13702 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13706 */   // MIs[1] Operand 1
     /* 13706 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 13711 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13715 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13719 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13723 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13727 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 13731 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13735 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13739 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13743 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13754 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13758 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13762 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13766 */   // MIs[4] Operand 1
     /* 13766 */   // No operand predicates
     /* 13766 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13771 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13775 */   // MIs[0] offset
     /* 13775 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13778 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13780 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p), GPR64Opnd:{ *:[i64] }:$rs), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT132 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT132),
     /* 13783 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs
     /* 13787 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13790 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13792 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13795 */   GIR_RootConstrainSelectedInstOperands,
     /* 13796 */   // GIR_Coverage, 2364,
     /* 13796 */   GIR_EraseRootFromParent_Done,
     /* 13797 */ // Label 524: @13797
     /* 13797 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(13905), // Rule ID 270 //
     /* 13802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13805 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13809 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13813 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13817 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13821 */   // MIs[1] Operand 1
     /* 13821 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13826 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13830 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13834 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13838 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13842 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13847 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 13851 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13855 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13859 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13863 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 13867 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13871 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13875 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13879 */   // MIs[4] Operand 1
     /* 13879 */   // No operand predicates
     /* 13879 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13883 */   // MIs[0] offset
     /* 13883 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 13886 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 13888 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT0 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 13888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT0),
     /* 13891 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 13895 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 13898 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 13900 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 13903 */   GIR_RootConstrainSelectedInstOperands,
     /* 13904 */   // GIR_Coverage, 270,
     /* 13904 */   GIR_EraseRootFromParent_Done,
     /* 13905 */ // Label 525: @13905
     /* 13905 */ GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(14020), // Rule ID 271 //
     /* 13910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 13913 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 13917 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 13921 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 13925 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 13929 */   // MIs[1] Operand 1
     /* 13929 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 13934 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 13938 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 13942 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 13946 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 13950 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 13955 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 13959 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 13963 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 13967 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 13971 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 13982 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 13986 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 13990 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 13994 */   // MIs[4] Operand 1
     /* 13994 */   // No operand predicates
     /* 13994 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 13998 */   // MIs[0] offset
     /* 13998 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14001 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14003 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT032 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14003 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT032),
     /* 14006 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14010 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14013 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14015 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14018 */   GIR_RootConstrainSelectedInstOperands,
     /* 14019 */   // GIR_Coverage, 271,
     /* 14019 */   GIR_EraseRootFromParent_Done,
     /* 14020 */ // Label 526: @14020
     /* 14020 */ GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(14128), // Rule ID 272 //
     /* 14025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 14028 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14032 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14036 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14040 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14044 */   // MIs[1] Operand 1
     /* 14044 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14049 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14053 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 14057 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14061 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14065 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14070 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 14074 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14078 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 14082 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 14086 */   GIM_CheckConstantInt8, /*MI*/3, /*Op*/1, 1,
     /* 14090 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14094 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14098 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14102 */   // MIs[4] Operand 1
     /* 14102 */   // No operand predicates
     /* 14102 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14106 */   // MIs[0] offset
     /* 14106 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14109 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14111 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 1:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT1 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT1),
     /* 14114 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14118 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14121 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14123 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14126 */   GIR_RootConstrainSelectedInstOperands,
     /* 14127 */   // GIR_Coverage, 272,
     /* 14127 */   GIR_EraseRootFromParent_Done,
     /* 14128 */ // Label 527: @14128
     /* 14128 */ GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(14243), // Rule ID 273 //
     /* 14133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 14136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14144 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14148 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14152 */   // MIs[1] Operand 1
     /* 14152 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14157 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 14161 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 14165 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 14169 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 14173 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14178 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 14182 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 14186 */   GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 14190 */   GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 14194 */   GIM_CheckConstantInt, /*MI*/3, /*Op*/1, GIMT_Encode8(4294967296),
     /* 14205 */   GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 14209 */   GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 14213 */   GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5_64),
     /* 14217 */   // MIs[4] Operand 1
     /* 14217 */   // No operand predicates
     /* 14217 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14221 */   // MIs[0] offset
     /* 14221 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14224 */   GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 14226 */   // (brcond (setcc:{ *:[i32] } (and:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, (shl:{ *:[i64] } 4294967296:{ *:[i64] }, (imm:{ *:[i64] })<<P:Predicate_immZExt5_64>>:$p)), 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BBIT132 GPR64Opnd:{ *:[i64] }:$rs, (imm:{ *:[i64] }):$p, (bb:{ *:[Other] }):$offset)
     /* 14226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BBIT132),
     /* 14229 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs
     /* 14233 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // p
     /* 14236 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14238 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14241 */   GIR_RootConstrainSelectedInstOperands,
     /* 14242 */   // GIR_Coverage, 273,
     /* 14242 */   GIR_EraseRootFromParent_Done,
     /* 14243 */ // Label 528: @14243
     /* 14243 */ GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(14300), // Rule ID 94 //
     /* 14248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14251 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14255 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14259 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14263 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14267 */   // MIs[1] Operand 1
     /* 14267 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14272 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14277 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14281 */   // MIs[0] offset
     /* 14281 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14286 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ),
     /* 14289 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14293 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14295 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14298 */   GIR_RootConstrainSelectedInstOperands,
     /* 14299 */   // GIR_Coverage, 94,
     /* 14299 */   GIR_EraseRootFromParent_Done,
     /* 14300 */ // Label 529: @14300
     /* 14300 */ GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(14357), // Rule ID 95 //
     /* 14305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14316 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14320 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14324 */   // MIs[1] Operand 1
     /* 14324 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14329 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14334 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14338 */   // MIs[0] offset
     /* 14338 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14341 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14343 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ),
     /* 14346 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14350 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14352 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14355 */   GIR_RootConstrainSelectedInstOperands,
     /* 14356 */   // GIR_Coverage, 95,
     /* 14356 */   GIR_EraseRootFromParent_Done,
     /* 14357 */ // Label 530: @14357
     /* 14357 */ GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(14414), // Rule ID 96 //
     /* 14362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14373 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14377 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14381 */   // MIs[1] Operand 1
     /* 14381 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14386 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14391 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14395 */   // MIs[0] offset
     /* 14395 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14398 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14400 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ),
     /* 14403 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14407 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14409 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14412 */   GIR_RootConstrainSelectedInstOperands,
     /* 14413 */   // GIR_Coverage, 96,
     /* 14413 */   GIR_EraseRootFromParent_Done,
     /* 14414 */ // Label 531: @14414
     /* 14414 */ GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(14471), // Rule ID 97 //
     /* 14419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14422 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14426 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14430 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14434 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14438 */   // MIs[1] Operand 1
     /* 14438 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14443 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14448 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14452 */   // MIs[0] offset
     /* 14452 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14455 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14457 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ),
     /* 14460 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14464 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14466 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14469 */   GIR_RootConstrainSelectedInstOperands,
     /* 14470 */   // GIR_Coverage, 97,
     /* 14470 */   GIR_EraseRootFromParent_Done,
     /* 14471 */ // Label 532: @14471
     /* 14471 */ GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(14528), // Rule ID 245 //
     /* 14476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14487 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14491 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14495 */   // MIs[1] Operand 1
     /* 14495 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14500 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14505 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14509 */   // MIs[0] offset
     /* 14509 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14514 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ64),
     /* 14517 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14521 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14523 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14526 */   GIR_RootConstrainSelectedInstOperands,
     /* 14527 */   // GIR_Coverage, 245,
     /* 14527 */   GIR_EraseRootFromParent_Done,
     /* 14528 */ // Label 533: @14528
     /* 14528 */ GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(14585), // Rule ID 246 //
     /* 14533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14544 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14548 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14552 */   // MIs[1] Operand 1
     /* 14552 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14557 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14562 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14566 */   // MIs[0] offset
     /* 14566 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14569 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14571 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ64),
     /* 14574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14578 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14580 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14583 */   GIR_RootConstrainSelectedInstOperands,
     /* 14584 */   // GIR_Coverage, 246,
     /* 14584 */   GIR_EraseRootFromParent_Done,
     /* 14585 */ // Label 534: @14585
     /* 14585 */ GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(14642), // Rule ID 247 //
     /* 14590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14605 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14609 */   // MIs[1] Operand 1
     /* 14609 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14614 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14619 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14623 */   // MIs[0] offset
     /* 14623 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14628 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ64),
     /* 14631 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14635 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14637 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14640 */   GIR_RootConstrainSelectedInstOperands,
     /* 14641 */   // GIR_Coverage, 247,
     /* 14641 */   GIR_EraseRootFromParent_Done,
     /* 14642 */ // Label 535: @14642
     /* 14642 */ GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(14699), // Rule ID 248 //
     /* 14647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 14650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14658 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 14662 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 14666 */   // MIs[1] Operand 1
     /* 14666 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14671 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 14676 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14680 */   // MIs[0] offset
     /* 14680 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14683 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14685 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, 0:{ *:[i64] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ64 GPR64Opnd:{ *:[i64] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ64),
     /* 14688 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14692 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14694 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14697 */   GIR_RootConstrainSelectedInstOperands,
     /* 14698 */   // GIR_Coverage, 248,
     /* 14698 */   GIR_EraseRootFromParent_Done,
     /* 14699 */ // Label 536: @14699
     /* 14699 */ GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(14756), // Rule ID 1109 //
     /* 14704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14715 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14719 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14723 */   // MIs[1] Operand 1
     /* 14723 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 14728 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14733 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14737 */   // MIs[0] offset
     /* 14737 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14740 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14742 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGEZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ_MM),
     /* 14745 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14749 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14751 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14754 */   GIR_RootConstrainSelectedInstOperands,
     /* 14755 */   // GIR_Coverage, 1109,
     /* 14755 */   GIR_EraseRootFromParent_Done,
     /* 14756 */ // Label 537: @14756
     /* 14756 */ GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(14813), // Rule ID 1110 //
     /* 14761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14764 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14768 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14772 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14776 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14780 */   // MIs[1] Operand 1
     /* 14780 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 14785 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14790 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14794 */   // MIs[0] offset
     /* 14794 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14797 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14799 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BGTZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGTZ_MM),
     /* 14802 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14806 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14808 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14811 */   GIR_RootConstrainSelectedInstOperands,
     /* 14812 */   // GIR_Coverage, 1110,
     /* 14812 */   GIR_EraseRootFromParent_Done,
     /* 14813 */ // Label 538: @14813
     /* 14813 */ GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(14870), // Rule ID 1111 //
     /* 14818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14821 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14825 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14829 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14833 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14837 */   // MIs[1] Operand 1
     /* 14837 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 14842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14847 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14851 */   // MIs[0] offset
     /* 14851 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14854 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14856 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLEZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ_MM),
     /* 14859 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14863 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14865 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14868 */   GIR_RootConstrainSelectedInstOperands,
     /* 14869 */   // GIR_Coverage, 1111,
     /* 14869 */   GIR_EraseRootFromParent_Done,
     /* 14870 */ // Label 539: @14870
     /* 14870 */ GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(14927), // Rule ID 1112 //
     /* 14875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 14878 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14882 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14886 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14890 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14894 */   // MIs[1] Operand 1
     /* 14894 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 14899 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14904 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14908 */   // MIs[0] offset
     /* 14908 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14913 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, 0:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BLTZ_MM GPR32Opnd:{ *:[i32] }:$rs, (bb:{ *:[Other] }):$offset)
     /* 14913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLTZ_MM),
     /* 14916 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 14920 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 14922 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14925 */   GIR_RootConstrainSelectedInstOperands,
     /* 14926 */   // GIR_Coverage, 1112,
     /* 14926 */   GIR_EraseRootFromParent_Done,
     /* 14927 */ // Label 540: @14927
     /* 14927 */ GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(14990), // Rule ID 1402 //
     /* 14932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 14939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 14943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 14947 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 14951 */   // MIs[1] Operand 1
     /* 14951 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 14956 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 14961 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 14965 */   // MIs[0] dst
     /* 14965 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 14968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 14970 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 14970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 14973 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 14977 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 14983 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 14985 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 14988 */   GIR_RootConstrainSelectedInstOperands,
     /* 14989 */   // GIR_Coverage, 1402,
     /* 14989 */   GIR_EraseRootFromParent_Done,
     /* 14990 */ // Label 541: @14990
     /* 14990 */ GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(15053), // Rule ID 1403 //
     /* 14995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 14998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15006 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15010 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15014 */   // MIs[1] Operand 1
     /* 15014 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15019 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15024 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15028 */   // MIs[0] dst
     /* 15028 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15031 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15033 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 15036 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15040 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15046 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15048 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15051 */   GIR_RootConstrainSelectedInstOperands,
     /* 15052 */   // GIR_Coverage, 1403,
     /* 15052 */   GIR_EraseRootFromParent_Done,
     /* 15053 */ // Label 542: @15053
     /* 15053 */ GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(15116), // Rule ID 1548 //
     /* 15058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15069 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15073 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15077 */   // MIs[1] Operand 1
     /* 15077 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15082 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15087 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15091 */   // MIs[0] dst
     /* 15091 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15094 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15096 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE64 GPR64:{ *:[i64] }:$lhs, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 15096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 15099 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15109 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15111 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15114 */   GIR_RootConstrainSelectedInstOperands,
     /* 15115 */   // GIR_Coverage, 1548,
     /* 15115 */   GIR_EraseRootFromParent_Done,
     /* 15116 */ // Label 543: @15116
     /* 15116 */ GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(15179), // Rule ID 1549 //
     /* 15121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15124 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15128 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15132 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15136 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15140 */   // MIs[1] Operand 1
     /* 15140 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15145 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15150 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15154 */   // MIs[0] dst
     /* 15154 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15157 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15159 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ64 GPR64:{ *:[i64] }:$lhs, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 15159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ64),
     /* 15162 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15166 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15172 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15174 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15177 */   GIR_RootConstrainSelectedInstOperands,
     /* 15178 */   // GIR_Coverage, 1549,
     /* 15178 */   GIR_EraseRootFromParent_Done,
     /* 15179 */ // Label 544: @15179
     /* 15179 */ GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(15233), // Rule ID 1852 //
     /* 15184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 15187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15195 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15199 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15203 */   // MIs[1] Operand 1
     /* 15203 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15208 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 15213 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15217 */   // MIs[0] targ16
     /* 15217 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15222 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$targ16)  =>  (BeqzRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 15222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BeqzRxImm16),
     /* 15225 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 15229 */   GIR_RootToRootCopy, /*OpIdx*/1, // targ16
     /* 15231 */   GIR_RootConstrainSelectedInstOperands,
     /* 15232 */   // GIR_Coverage, 1852,
     /* 15232 */   GIR_EraseRootFromParent_Done,
     /* 15233 */ // Label 545: @15233
     /* 15233 */ GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(15287), // Rule ID 1861 //
     /* 15238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 15241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15249 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15253 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15257 */   // MIs[1] Operand 1
     /* 15257 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15262 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 15267 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15271 */   // MIs[0] targ16
     /* 15271 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15274 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15276 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$targ16)  =>  (BnezRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 15276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BnezRxImm16),
     /* 15279 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 15283 */   GIR_RootToRootCopy, /*OpIdx*/1, // targ16
     /* 15285 */   GIR_RootConstrainSelectedInstOperands,
     /* 15286 */   // GIR_Coverage, 1861,
     /* 15286 */   GIR_EraseRootFromParent_Done,
     /* 15287 */ // Label 546: @15287
     /* 15287 */ GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(15350), // Rule ID 2191 //
     /* 15292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15303 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15307 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15311 */   // MIs[1] Operand 1
     /* 15311 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15316 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15321 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15325 */   // MIs[0] dst
     /* 15325 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15328 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15330 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNE_MM GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 15333 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15337 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15343 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15345 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15348 */   GIR_RootConstrainSelectedInstOperands,
     /* 15349 */   // GIR_Coverage, 2191,
     /* 15349 */   GIR_EraseRootFromParent_Done,
     /* 15350 */ // Label 547: @15350
     /* 15350 */ GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(15413), // Rule ID 2192 //
     /* 15355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15370 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15374 */   // MIs[1] Operand 1
     /* 15374 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15384 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15388 */   // MIs[0] dst
     /* 15388 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15393 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM GPR32:{ *:[i32] }:$lhs, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 15393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 15396 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15400 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 15406 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15408 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15411 */   GIR_RootConstrainSelectedInstOperands,
     /* 15412 */   // GIR_Coverage, 2192,
     /* 15412 */   GIR_EraseRootFromParent_Done,
     /* 15413 */ // Label 548: @15413
     /* 15413 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(15470), // Rule ID 2338 //
     /* 15418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 15421 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15425 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15429 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15433 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15437 */   // MIs[1] Operand 1
     /* 15437 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15442 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15447 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15451 */   // MIs[0] dst
     /* 15451 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15456 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BNEZC_MMR6 GPR32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNEZC_MMR6),
     /* 15459 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15463 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15465 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15468 */   GIR_RootConstrainSelectedInstOperands,
     /* 15469 */   // GIR_Coverage, 2338,
     /* 15469 */   GIR_EraseRootFromParent_Done,
     /* 15470 */ // Label 549: @15470
     /* 15470 */ GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(15527), // Rule ID 2339 //
     /* 15475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 15478 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15482 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15486 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15490 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15494 */   // MIs[1] Operand 1
     /* 15494 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15499 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15504 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 15508 */   // MIs[0] dst
     /* 15508 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15511 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15513 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 GPR32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15513 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 15516 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15520 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15522 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15525 */   GIR_RootConstrainSelectedInstOperands,
     /* 15526 */   // GIR_Coverage, 2339,
     /* 15526 */   GIR_EraseRootFromParent_Done,
     /* 15527 */ // Label 550: @15527
     /* 15527 */ GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(15579), // Rule ID 1413 //
     /* 15532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15543 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15547 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15551 */   // MIs[1] Operand 1
     /* 15551 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15556 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15560 */   // MIs[0] dst
     /* 15560 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15563 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15565 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, 1:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ),
     /* 15568 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15572 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15574 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15577 */   GIR_RootConstrainSelectedInstOperands,
     /* 15578 */   // GIR_Coverage, 1413,
     /* 15578 */   GIR_EraseRootFromParent_Done,
     /* 15579 */ // Label 551: @15579
     /* 15579 */ GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(15631), // Rule ID 1414 //
     /* 15584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15595 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15599 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15603 */   // MIs[1] Operand 1
     /* 15603 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15608 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15612 */   // MIs[0] dst
     /* 15612 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15615 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15617 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, -1:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ),
     /* 15620 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15624 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15626 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15629 */   GIR_RootConstrainSelectedInstOperands,
     /* 15630 */   // GIR_Coverage, 1414,
     /* 15630 */   GIR_EraseRootFromParent_Done,
     /* 15631 */ // Label 552: @15631
     /* 15631 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(15683), // Rule ID 1559 //
     /* 15636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15647 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15651 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15655 */   // MIs[1] Operand 1
     /* 15655 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15660 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15664 */   // MIs[0] dst
     /* 15664 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15667 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15669 */   // (brcond (setcc:{ *:[i32] } i64:{ *:[i64] }:$lhs, 1:{ *:[i64] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ64 i64:{ *:[i64] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ64),
     /* 15672 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15676 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15678 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15681 */   GIR_RootConstrainSelectedInstOperands,
     /* 15682 */   // GIR_Coverage, 1559,
     /* 15682 */   GIR_EraseRootFromParent_Done,
     /* 15683 */ // Label 553: @15683
     /* 15683 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(15735), // Rule ID 1560 //
     /* 15688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 15691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15699 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15703 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15707 */   // MIs[1] Operand 1
     /* 15707 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15712 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15716 */   // MIs[0] dst
     /* 15716 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15721 */   // (brcond (setcc:{ *:[i32] } i64:{ *:[i64] }:$lhs, -1:{ *:[i64] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ64 i64:{ *:[i64] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ64),
     /* 15724 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15728 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15730 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15733 */   GIR_RootConstrainSelectedInstOperands,
     /* 15734 */   // GIR_Coverage, 1560,
     /* 15734 */   GIR_EraseRootFromParent_Done,
     /* 15735 */ // Label 554: @15735
     /* 15735 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(15787), // Rule ID 2202 //
     /* 15740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15751 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15755 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15759 */   // MIs[1] Operand 1
     /* 15759 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 15764 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 1,
     /* 15768 */   // MIs[0] dst
     /* 15768 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15773 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, 1:{ *:[i32] }, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BLEZ_MM i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BLEZ_MM),
     /* 15776 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15780 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15782 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15785 */   GIR_RootConstrainSelectedInstOperands,
     /* 15786 */   // GIR_Coverage, 2202,
     /* 15786 */   GIR_EraseRootFromParent_Done,
     /* 15787 */ // Label 555: @15787
     /* 15787 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(15839), // Rule ID 2203 //
     /* 15792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 15795 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15803 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15807 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15811 */   // MIs[1] Operand 1
     /* 15811 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 15816 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, uint8_t(-1),
     /* 15820 */   // MIs[0] dst
     /* 15820 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15823 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15825 */   // (brcond (setcc:{ *:[i32] } i32:{ *:[i32] }:$lhs, -1:{ *:[i32] }, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BGEZ_MM i32:{ *:[i32] }:$lhs, (bb:{ *:[Other] }):$dst)
     /* 15825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BGEZ_MM),
     /* 15828 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 15832 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 15834 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15837 */   GIR_RootConstrainSelectedInstOperands,
     /* 15838 */   // GIR_Coverage, 2203,
     /* 15838 */   GIR_EraseRootFromParent_Done,
     /* 15839 */ // Label 556: @15839
     /* 15839 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(15901), // Rule ID 92 //
     /* 15844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15847 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15851 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15855 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15859 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15863 */   // MIs[1] Operand 1
     /* 15863 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15868 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15873 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15878 */   // MIs[0] offset
     /* 15878 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15881 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15883 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 15886 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 15890 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 15894 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 15896 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15899 */   GIR_RootConstrainSelectedInstOperands,
     /* 15900 */   // GIR_Coverage, 92,
     /* 15900 */   GIR_EraseRootFromParent_Done,
     /* 15901 */ // Label 557: @15901
     /* 15901 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(15963), // Rule ID 93 //
     /* 15906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 15909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15917 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 15921 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 15925 */   // MIs[1] Operand 1
     /* 15925 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 15930 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15935 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 15940 */   // MIs[0] offset
     /* 15940 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 15943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 15945 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 15945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 15948 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 15952 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 15956 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 15958 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 15961 */   GIR_RootConstrainSelectedInstOperands,
     /* 15962 */   // GIR_Coverage, 93,
     /* 15962 */   GIR_EraseRootFromParent_Done,
     /* 15963 */ // Label 558: @15963
     /* 15963 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(16025), // Rule ID 243 //
     /* 15968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 15971 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 15975 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 15979 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 15983 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 15987 */   // MIs[1] Operand 1
     /* 15987 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 15992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 15997 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16002 */   // MIs[0] offset
     /* 16002 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16007 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ64 GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ64),
     /* 16010 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16014 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16018 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16020 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16023 */   GIR_RootConstrainSelectedInstOperands,
     /* 16024 */   // GIR_Coverage, 243,
     /* 16024 */   GIR_EraseRootFromParent_Done,
     /* 16025 */ // Label 559: @16025
     /* 16025 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(16087), // Rule ID 244 //
     /* 16030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 16033 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16037 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16041 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16045 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16049 */   // MIs[1] Operand 1
     /* 16049 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 16054 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16059 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16064 */   // MIs[0] offset
     /* 16064 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16067 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16069 */   // (brcond (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE64 GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 16072 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16080 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16082 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16085 */   GIR_RootConstrainSelectedInstOperands,
     /* 16086 */   // GIR_Coverage, 244,
     /* 16086 */   GIR_EraseRootFromParent_Done,
     /* 16087 */ // Label 560: @16087
     /* 16087 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(16149), // Rule ID 1107 //
     /* 16092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 16095 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16099 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16103 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16107 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16111 */   // MIs[1] Operand 1
     /* 16111 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16116 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16121 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16126 */   // MIs[0] offset
     /* 16126 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16131 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BEQ_MM GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 16134 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16138 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16142 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16144 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16147 */   GIR_RootConstrainSelectedInstOperands,
     /* 16148 */   // GIR_Coverage, 1107,
     /* 16148 */   GIR_EraseRootFromParent_Done,
     /* 16149 */ // Label 561: @16149
     /* 16149 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(16211), // Rule ID 1108 //
     /* 16154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 16157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16165 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16169 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16173 */   // MIs[1] Operand 1
     /* 16173 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 16178 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16188 */   // MIs[0] offset
     /* 16188 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16193 */   // (brcond (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$offset)  =>  (BNE_MM GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, (bb:{ *:[Other] }):$offset)
     /* 16193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 16196 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 16200 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 16204 */   GIR_RootToRootCopy, /*OpIdx*/1, // offset
     /* 16206 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16209 */   GIR_RootConstrainSelectedInstOperands,
     /* 16210 */   // GIR_Coverage, 1108,
     /* 16210 */   GIR_EraseRootFromParent_Done,
     /* 16211 */ // Label 562: @16211
     /* 16211 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(16296), // Rule ID 1404 //
     /* 16216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16219 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16223 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16227 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16231 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16235 */   // MIs[1] Operand 1
     /* 16235 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 16240 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16245 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16250 */   // MIs[0] dst
     /* 16250 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16253 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16255 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16255 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16258 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 16262 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16267 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16271 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16275 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16280 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16283 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16289 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16291 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16294 */   GIR_RootConstrainSelectedInstOperands,
     /* 16295 */   // GIR_Coverage, 1404,
     /* 16295 */   GIR_EraseRootFromParent_Done,
     /* 16296 */ // Label 563: @16296
     /* 16296 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(16381), // Rule ID 1405 //
     /* 16301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16304 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16308 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16312 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16316 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16320 */   // MIs[1] Operand 1
     /* 16320 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 16325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16330 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16335 */   // MIs[0] dst
     /* 16335 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16340 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 16347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16352 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16356 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16368 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16374 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16376 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16379 */   GIR_RootConstrainSelectedInstOperands,
     /* 16380 */   // GIR_Coverage, 1405,
     /* 16380 */   GIR_EraseRootFromParent_Done,
     /* 16381 */ // Label 564: @16381
     /* 16381 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(16466), // Rule ID 1410 //
     /* 16386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16389 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16393 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16397 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16401 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16405 */   // MIs[1] Operand 1
     /* 16405 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 16410 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16415 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16420 */   // MIs[0] dst
     /* 16420 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16423 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16425 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 16432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16437 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16441 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16450 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16453 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16459 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16461 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16464 */   GIR_RootConstrainSelectedInstOperands,
     /* 16465 */   // GIR_Coverage, 1410,
     /* 16465 */   GIR_EraseRootFromParent_Done,
     /* 16466 */ // Label 565: @16466
     /* 16466 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(16551), // Rule ID 1411 //
     /* 16471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 16474 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16478 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16482 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16486 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16490 */   // MIs[1] Operand 1
     /* 16490 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 16495 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16500 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 16505 */   // MIs[0] dst
     /* 16505 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16508 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16510 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 16517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16522 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16526 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16538 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16544 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16546 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16549 */   GIR_RootConstrainSelectedInstOperands,
     /* 16550 */   // GIR_Coverage, 1411,
     /* 16550 */   GIR_EraseRootFromParent_Done,
     /* 16551 */ // Label 566: @16551
     /* 16551 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(16636), // Rule ID 1550 //
     /* 16556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16559 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16563 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16567 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16571 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16575 */   // MIs[1] Operand 1
     /* 16575 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 16580 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16585 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16590 */   // MIs[0] dst
     /* 16590 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16595 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 16602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16607 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16611 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16620 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16623 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16629 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16631 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16634 */   GIR_RootConstrainSelectedInstOperands,
     /* 16635 */   // GIR_Coverage, 1550,
     /* 16635 */   GIR_EraseRootFromParent_Done,
     /* 16636 */ // Label 567: @16636
     /* 16636 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(16721), // Rule ID 1551 //
     /* 16641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16644 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16648 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16652 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16656 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16660 */   // MIs[1] Operand 1
     /* 16660 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 16665 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16670 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16675 */   // MIs[0] dst
     /* 16675 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16680 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16680 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16683 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 16687 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16692 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16696 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16714 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16716 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16719 */   GIR_RootConstrainSelectedInstOperands,
     /* 16720 */   // GIR_Coverage, 1551,
     /* 16720 */   GIR_EraseRootFromParent_Done,
     /* 16721 */ // Label 568: @16721
     /* 16721 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(16806), // Rule ID 1556 //
     /* 16726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16729 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16737 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16741 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16745 */   // MIs[1] Operand 1
     /* 16745 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 16750 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16755 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16760 */   // MIs[0] dst
     /* 16760 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16763 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16765 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16765 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16768 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 16772 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16777 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16793 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16799 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16801 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16804 */   GIR_RootConstrainSelectedInstOperands,
     /* 16805 */   // GIR_Coverage, 1556,
     /* 16805 */   GIR_EraseRootFromParent_Done,
     /* 16806 */ // Label 569: @16806
     /* 16806 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(16891), // Rule ID 1557 //
     /* 16811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 16814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16822 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 16826 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 16830 */   // MIs[1] Operand 1
     /* 16830 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 16835 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16840 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 16845 */   // MIs[0] dst
     /* 16845 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16850 */   // (brcond (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 16850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 16853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 16857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 16862 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 16866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 16870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 16872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ),
     /* 16875 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 16878 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 16884 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 16886 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 16889 */   GIR_RootConstrainSelectedInstOperands,
     /* 16890 */   // GIR_Coverage, 1557,
     /* 16890 */   GIR_EraseRootFromParent_Done,
     /* 16891 */ // Label 570: @16891
     /* 16891 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(16950), // Rule ID 1850 //
     /* 16896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 16899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16907 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16911 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16915 */   // MIs[1] Operand 1
     /* 16915 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 16920 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16925 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16930 */   // MIs[0] imm16
     /* 16930 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16935 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8CmpX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 16935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8CmpX16),
     /* 16938 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 16942 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 16946 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 16948 */   GIR_RootConstrainSelectedInstOperands,
     /* 16949 */   // GIR_Coverage, 1850,
     /* 16949 */   GIR_EraseRootFromParent_Done,
     /* 16950 */ // Label 571: @16950
     /* 16950 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(17009), // Rule ID 1853 //
     /* 16955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 16958 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 16962 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 16966 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 16970 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 16974 */   // MIs[1] Operand 1
     /* 16974 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 16979 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16984 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 16989 */   // MIs[0] imm16
     /* 16989 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 16992 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 16994 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETGT:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8SltX16 CPU16Regs:{ *:[i32] }:$ry, CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$imm16)
     /* 16994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8SltX16),
     /* 16997 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17001 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17005 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17007 */   GIR_RootConstrainSelectedInstOperands,
     /* 17008 */   // GIR_Coverage, 1853,
     /* 17008 */   GIR_EraseRootFromParent_Done,
     /* 17009 */ // Label 572: @17009
     /* 17009 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(17068), // Rule ID 1854 //
     /* 17014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17025 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17029 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17033 */   // MIs[1] Operand 1
     /* 17033 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17038 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17043 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17048 */   // MIs[0] imm16
     /* 17048 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17053 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8SltX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8SltX16),
     /* 17056 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17060 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17064 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17066 */   GIR_RootConstrainSelectedInstOperands,
     /* 17067 */   // GIR_Coverage, 1854,
     /* 17067 */   GIR_EraseRootFromParent_Done,
     /* 17068 */ // Label 573: @17068
     /* 17068 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(17127), // Rule ID 1856 //
     /* 17073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17084 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17088 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17092 */   // MIs[1] Operand 1
     /* 17092 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 17097 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17102 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17107 */   // MIs[0] imm16
     /* 17107 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17110 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17112 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLT:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8SltX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17112 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8SltX16),
     /* 17115 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17119 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17123 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17125 */   GIR_RootConstrainSelectedInstOperands,
     /* 17126 */   // GIR_Coverage, 1856,
     /* 17126 */   GIR_EraseRootFromParent_Done,
     /* 17127 */ // Label 574: @17127
     /* 17127 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(17186), // Rule ID 1858 //
     /* 17132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17135 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17139 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17143 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17147 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17151 */   // MIs[1] Operand 1
     /* 17151 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17156 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17161 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17166 */   // MIs[0] imm16
     /* 17166 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17169 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17171 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BteqzT8SltX16 CPU16Regs:{ *:[i32] }:$ry, CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$imm16)
     /* 17171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BteqzT8SltX16),
     /* 17174 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17178 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17182 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17184 */   GIR_RootConstrainSelectedInstOperands,
     /* 17185 */   // GIR_Coverage, 1858,
     /* 17185 */   GIR_EraseRootFromParent_Done,
     /* 17186 */ // Label 575: @17186
     /* 17186 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(17245), // Rule ID 1859 //
     /* 17191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17194 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17198 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17202 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17206 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17210 */   // MIs[1] Operand 1
     /* 17210 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 17215 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17220 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17225 */   // MIs[0] imm16
     /* 17225 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17228 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17230 */   // (brcond (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$imm16)  =>  (BtnezT8CmpX16 CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, (bb:{ *:[Other] }):$imm16)
     /* 17230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BtnezT8CmpX16),
     /* 17233 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rx
     /* 17237 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // ry
     /* 17241 */   GIR_RootToRootCopy, /*OpIdx*/1, // imm16
     /* 17243 */   GIR_RootConstrainSelectedInstOperands,
     /* 17244 */   // GIR_Coverage, 1859,
     /* 17244 */   GIR_EraseRootFromParent_Done,
     /* 17245 */ // Label 576: @17245
     /* 17245 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(17330), // Rule ID 2193 //
     /* 17250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17253 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17257 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17261 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17265 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17269 */   // MIs[1] Operand 1
     /* 17269 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17274 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17279 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17284 */   // MIs[0] dst
     /* 17284 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17287 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17289 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17301 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17317 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17323 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17325 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17328 */   GIR_RootConstrainSelectedInstOperands,
     /* 17329 */   // GIR_Coverage, 2193,
     /* 17329 */   GIR_EraseRootFromParent_Done,
     /* 17330 */ // Label 577: @17330
     /* 17330 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(17415), // Rule ID 2194 //
     /* 17335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17346 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17350 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17354 */   // MIs[1] Operand 1
     /* 17354 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 17359 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17364 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17369 */   // MIs[0] dst
     /* 17369 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17372 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17374 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17374 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17377 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17381 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17386 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17390 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17402 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17408 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17410 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17413 */   GIR_RootConstrainSelectedInstOperands,
     /* 17414 */   // GIR_Coverage, 2194,
     /* 17414 */   GIR_EraseRootFromParent_Done,
     /* 17415 */ // Label 578: @17415
     /* 17415 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(17500), // Rule ID 2199 //
     /* 17420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17423 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17427 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17431 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17435 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17439 */   // MIs[1] Operand 1
     /* 17439 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17444 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17449 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17454 */   // MIs[0] dst
     /* 17454 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17457 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17459 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17471 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17475 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17479 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17487 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17493 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17495 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17498 */   GIR_RootConstrainSelectedInstOperands,
     /* 17499 */   // GIR_Coverage, 2199,
     /* 17499 */   GIR_EraseRootFromParent_Done,
     /* 17500 */ // Label 579: @17500
     /* 17500 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(17585), // Rule ID 2200 //
     /* 17505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17508 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17512 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17516 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17520 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17524 */   // MIs[1] Operand 1
     /* 17524 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 17529 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17534 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17539 */   // MIs[0] dst
     /* 17539 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17544 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQ_MM (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17544 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17547 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17551 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17556 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17560 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQ_MM),
     /* 17569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17578 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17580 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17583 */   GIR_RootConstrainSelectedInstOperands,
     /* 17584 */   // GIR_Coverage, 2200,
     /* 17584 */   GIR_EraseRootFromParent_Done,
     /* 17585 */ // Label 580: @17585
     /* 17585 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(17664), // Rule ID 2340 //
     /* 17590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17605 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17609 */   // MIs[1] Operand 1
     /* 17609 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 17614 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17624 */   // MIs[0] dst
     /* 17624 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17627 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17629 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), (bb:{ *:[Other] }):$dst)
     /* 17629 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17632 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17636 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17641 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17645 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17649 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17654 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17657 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17659 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17662 */   GIR_RootConstrainSelectedInstOperands,
     /* 17663 */   // GIR_Coverage, 2340,
     /* 17663 */   GIR_EraseRootFromParent_Done,
     /* 17664 */ // Label 581: @17664
     /* 17664 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(17743), // Rule ID 2341 //
     /* 17669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17672 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17676 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17680 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17684 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17688 */   // MIs[1] Operand 1
     /* 17688 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 17693 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17698 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17703 */   // MIs[0] dst
     /* 17703 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17706 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17708 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), (bb:{ *:[Other] }):$dst)
     /* 17708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17720 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17724 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17728 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17733 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17736 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17738 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17741 */   GIR_RootConstrainSelectedInstOperands,
     /* 17742 */   // GIR_Coverage, 2341,
     /* 17742 */   GIR_EraseRootFromParent_Done,
     /* 17743 */ // Label 582: @17743
     /* 17743 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(17822), // Rule ID 2346 //
     /* 17748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17751 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17755 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17759 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17763 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17767 */   // MIs[1] Operand 1
     /* 17767 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 17772 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17777 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17782 */   // MIs[0] dst
     /* 17782 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17785 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17787 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), (bb:{ *:[Other] }):$dst)
     /* 17787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 17794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17803 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17815 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17817 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17820 */   GIR_RootConstrainSelectedInstOperands,
     /* 17821 */   // GIR_Coverage, 2346,
     /* 17821 */   GIR_EraseRootFromParent_Done,
     /* 17822 */ // Label 583: @17822
     /* 17822 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(17901), // Rule ID 2347 //
     /* 17827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17830 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 17834 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 17838 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 17842 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 17846 */   // MIs[1] Operand 1
     /* 17846 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 17851 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17856 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17861 */   // MIs[0] dst
     /* 17861 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 17866 */   // (brcond (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), (bb:{ *:[Other] }):$dst)  =>  (BEQZC_MMR6 (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), (bb:{ *:[Other] }):$dst)
     /* 17866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 17869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 17873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 17878 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 17882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 17886 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 17888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BEQZC_MMR6),
     /* 17891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 17894 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17896 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17899 */   GIR_RootConstrainSelectedInstOperands,
     /* 17900 */   // GIR_Coverage, 2347,
     /* 17900 */   GIR_EraseRootFromParent_Done,
     /* 17901 */ // Label 584: @17901
     /* 17901 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(17934), // Rule ID 1412 //
     /* 17906 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 17909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17913 */   // MIs[0] dst
     /* 17913 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17916 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE GPR32:{ *:[i32] }:$cond, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE),
     /* 17919 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 17921 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17927 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17929 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17932 */   GIR_RootConstrainSelectedInstOperands,
     /* 17933 */   // GIR_Coverage, 1412,
     /* 17933 */   GIR_EraseRootFromParent_Done,
     /* 17934 */ // Label 585: @17934
     /* 17934 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(17956), // Rule ID 1862 //
     /* 17939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 17942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 17946 */   // MIs[0] targ16
     /* 17946 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17949 */   // (brcond CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)  =>  (BnezRxImm16 CPU16Regs:{ *:[i32] }:$rx, (bb:{ *:[Other] }):$targ16)
     /* 17949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BnezRxImm16),
     /* 17954 */   GIR_RootConstrainSelectedInstOperands,
     /* 17955 */   // GIR_Coverage, 1862,
     /* 17955 */   GIR_Done,
     /* 17956 */ // Label 586: @17956
     /* 17956 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(17989), // Rule ID 2201 //
     /* 17961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 17964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 17968 */   // MIs[0] dst
     /* 17968 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 17971 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE_MM GPR32:{ *:[i32] }:$cond, ZERO:{ *:[i32] }, (bb:{ *:[Other] }):$dst)
     /* 17971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE_MM),
     /* 17974 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 17976 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 17982 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 17984 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 17987 */   GIR_RootConstrainSelectedInstOperands,
     /* 17988 */   // GIR_Coverage, 2201,
     /* 17988 */   GIR_EraseRootFromParent_Done,
     /* 17989 */ // Label 587: @17989
     /* 17989 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(18017), // Rule ID 2348 //
     /* 17994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 17997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18001 */   // MIs[0] dst
     /* 18001 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 18004 */   // (brcond GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNEZC_MMR6 GPR32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst)
     /* 18004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BNEZC_MMR6),
     /* 18009 */   GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 18015 */   GIR_RootConstrainSelectedInstOperands,
     /* 18016 */   // GIR_Coverage, 2348,
     /* 18016 */   GIR_Done,
     /* 18017 */ // Label 588: @18017
     /* 18017 */ GIM_Reject,
     /* 18018 */ // Label 519: @18018
     /* 18018 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(18051), // Rule ID 1558 //
     /* 18023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 18026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 18030 */   // MIs[0] dst
     /* 18030 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/1,
     /* 18033 */   // (brcond GPR64:{ *:[i64] }:$cond, (bb:{ *:[Other] }):$dst)  =>  (BNE64 GPR64:{ *:[i64] }:$cond, ZERO_64:{ *:[i64] }, (bb:{ *:[Other] }):$dst)
     /* 18033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BNE64),
     /* 18036 */   GIR_RootToRootCopy, /*OpIdx*/0, // cond
     /* 18038 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 18044 */   GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 18046 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::AT*/0,
     /* 18049 */   GIR_RootConstrainSelectedInstOperands,
     /* 18050 */   // GIR_Coverage, 1558,
     /* 18050 */   GIR_EraseRootFromParent_Done,
     /* 18051 */ // Label 589: @18051
     /* 18051 */ GIM_Reject,
     /* 18052 */ // Label 520: @18052
     /* 18052 */ GIM_Reject,
     /* 18053 */ // Label 29: @18053
     /* 18053 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(20050),
     /* 18058 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 18061 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(18108), // Rule ID 428 //
     /* 18066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt8),
     /* 18096 */     // MIs[1] Operand 1
     /* 18096 */     // No operand predicates
     /* 18096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18098 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8098:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immZExt8>>:$imm)  =>  (REPL_QB:{ *:[v4i8] } (imm:{ *:[i32] }):$imm)
     /* 18098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_QB),
     /* 18101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18106 */     GIR_RootConstrainSelectedInstOperands,
     /* 18107 */     // GIR_Coverage, 428,
     /* 18107 */     GIR_EraseRootFromParent_Done,
     /* 18108 */   // Label 591: @18108
     /* 18108 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(18155), // Rule ID 429 //
     /* 18113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt10),
     /* 18143 */     // MIs[1] Operand 1
     /* 18143 */     // No operand predicates
     /* 18143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18145 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8097:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immSExt10>>:$imm)  =>  (REPL_PH:{ *:[v2i16] } (imm:{ *:[i32] }):$imm)
     /* 18145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_PH),
     /* 18148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18153 */     GIR_RootConstrainSelectedInstOperands,
     /* 18154 */     // GIR_Coverage, 429,
     /* 18154 */     GIR_EraseRootFromParent_Done,
     /* 18155 */   // Label 592: @18155
     /* 18155 */   GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(18202), // Rule ID 1288 //
     /* 18160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 18163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immSExt10),
     /* 18190 */     // MIs[1] Operand 1
     /* 18190 */     // No operand predicates
     /* 18190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18192 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8097:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immSExt10>>:$imm)  =>  (REPL_PH_MM:{ *:[v2i16] } (imm:{ *:[i32] }):$imm)
     /* 18192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_PH_MM),
     /* 18195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18200 */     GIR_RootConstrainSelectedInstOperands,
     /* 18201 */     // GIR_Coverage, 1288,
     /* 18201 */     GIR_EraseRootFromParent_Done,
     /* 18202 */   // Label 593: @18202
     /* 18202 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(18249), // Rule ID 1289 //
     /* 18207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 18210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 18229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 18233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt8),
     /* 18237 */     // MIs[1] Operand 1
     /* 18237 */     // No operand predicates
     /* 18237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 18239 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8098:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_immZExt8>>:$imm)  =>  (REPL_QB_MM:{ *:[v4i8] } (imm:{ *:[i32] }):$imm)
     /* 18239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPL_QB_MM),
     /* 18242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 18244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 18247 */     GIR_RootConstrainSelectedInstOperands,
     /* 18248 */     // GIR_Coverage, 1289,
     /* 18248 */     GIR_EraseRootFromParent_Done,
     /* 18249 */   // Label 594: @18249
     /* 18249 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(18285), // Rule ID 362 //
     /* 18254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_raddu_w_qb),
     /* 18262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18276 */     // (intrinsic_wo_chain:{ *:[i32] } 8095:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (RADDU_W_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 18276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RADDU_W_QB),
     /* 18279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 18283 */     GIR_RootConstrainSelectedInstOperands,
     /* 18284 */     // GIR_Coverage, 362,
     /* 18284 */     GIR_EraseRootFromParent_Done,
     /* 18285 */   // Label 595: @18285
     /* 18285 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(18321), // Rule ID 369 //
     /* 18290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phl),
     /* 18298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 18304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18312 */     // (intrinsic_wo_chain:{ *:[i32] } 8077:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECEQ_W_PHL:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 18312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHL),
     /* 18315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18319 */     GIR_RootConstrainSelectedInstOperands,
     /* 18320 */     // GIR_Coverage, 369,
     /* 18320 */     GIR_EraseRootFromParent_Done,
     /* 18321 */   // Label 596: @18321
     /* 18321 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(18357), // Rule ID 370 //
     /* 18326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phr),
     /* 18334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 18340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18348 */     // (intrinsic_wo_chain:{ *:[i32] } 8078:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECEQ_W_PHR:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 18348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHR),
     /* 18351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18355 */     GIR_RootConstrainSelectedInstOperands,
     /* 18356 */     // GIR_Coverage, 370,
     /* 18356 */     GIR_EraseRootFromParent_Done,
     /* 18357 */   // Label 597: @18357
     /* 18357 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(18393), // Rule ID 371 //
     /* 18362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbl),
     /* 18370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18384 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8079:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBL),
     /* 18387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18391 */     GIR_RootConstrainSelectedInstOperands,
     /* 18392 */     // GIR_Coverage, 371,
     /* 18392 */     GIR_EraseRootFromParent_Done,
     /* 18393 */   // Label 598: @18393
     /* 18393 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(18429), // Rule ID 372 //
     /* 18398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbr),
     /* 18406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18420 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8081:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBR),
     /* 18423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18427 */     GIR_RootConstrainSelectedInstOperands,
     /* 18428 */     // GIR_Coverage, 372,
     /* 18428 */     GIR_EraseRootFromParent_Done,
     /* 18429 */   // Label 599: @18429
     /* 18429 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(18465), // Rule ID 373 //
     /* 18434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbla),
     /* 18442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18456 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8080:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBLA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBLA),
     /* 18459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18463 */     GIR_RootConstrainSelectedInstOperands,
     /* 18464 */     // GIR_Coverage, 373,
     /* 18464 */     GIR_EraseRootFromParent_Done,
     /* 18465 */   // Label 600: @18465
     /* 18465 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(18501), // Rule ID 374 //
     /* 18470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbra),
     /* 18478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18492 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8082:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEQU_PH_QBRA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBRA),
     /* 18495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18499 */     GIR_RootConstrainSelectedInstOperands,
     /* 18500 */     // GIR_Coverage, 374,
     /* 18500 */     GIR_EraseRootFromParent_Done,
     /* 18501 */   // Label 601: @18501
     /* 18501 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(18537), // Rule ID 375 //
     /* 18506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbl),
     /* 18514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18528 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8083:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBL),
     /* 18531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18535 */     GIR_RootConstrainSelectedInstOperands,
     /* 18536 */     // GIR_Coverage, 375,
     /* 18536 */     GIR_EraseRootFromParent_Done,
     /* 18537 */   // Label 602: @18537
     /* 18537 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(18573), // Rule ID 376 //
     /* 18542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbr),
     /* 18550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18564 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8085:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBR),
     /* 18567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18571 */     GIR_RootConstrainSelectedInstOperands,
     /* 18572 */     // GIR_Coverage, 376,
     /* 18572 */     GIR_EraseRootFromParent_Done,
     /* 18573 */   // Label 603: @18573
     /* 18573 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(18609), // Rule ID 377 //
     /* 18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbla),
     /* 18586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18600 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8084:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBLA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBLA),
     /* 18603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18607 */     GIR_RootConstrainSelectedInstOperands,
     /* 18608 */     // GIR_Coverage, 377,
     /* 18608 */     GIR_EraseRootFromParent_Done,
     /* 18609 */   // Label 604: @18609
     /* 18609 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(18645), // Rule ID 378 //
     /* 18614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbra),
     /* 18622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 18628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18636 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8086:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PRECEU_PH_QBRA:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 18636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBRA),
     /* 18639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18643 */     GIR_RootConstrainSelectedInstOperands,
     /* 18644 */     // GIR_Coverage, 378,
     /* 18644 */     GIR_EraseRootFromParent_Done,
     /* 18645 */   // Label 605: @18645
     /* 18645 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(18681), // Rule ID 426 //
     /* 18650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bitrev),
     /* 18658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 18661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18672 */     // (intrinsic_wo_chain:{ *:[i32] } 7651:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (BITREV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BITREV),
     /* 18675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18679 */     GIR_RootConstrainSelectedInstOperands,
     /* 18680 */     // GIR_Coverage, 426,
     /* 18680 */     GIR_EraseRootFromParent_Done,
     /* 18681 */   // Label 606: @18681
     /* 18681 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(18717), // Rule ID 430 //
     /* 18686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 18694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 18697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18708 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8098:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (REPLV_QB:{ *:[v4i8] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_QB),
     /* 18711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18715 */     GIR_RootConstrainSelectedInstOperands,
     /* 18716 */     // GIR_Coverage, 430,
     /* 18716 */     GIR_EraseRootFromParent_Done,
     /* 18717 */   // Label 607: @18717
     /* 18717 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(18753), // Rule ID 431 //
     /* 18722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 18725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 18730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 18733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 18736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 18740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 18744 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8097:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (REPLV_PH:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 18744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_PH),
     /* 18747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 18749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 18751 */     GIR_RootConstrainSelectedInstOperands,
     /* 18752 */     // GIR_Coverage, 431,
     /* 18752 */     GIR_EraseRootFromParent_Done,
     /* 18753 */   // Label 608: @18753
     /* 18753 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(18789), // Rule ID 680 //
     /* 18758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fclass_w),
     /* 18766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18780 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7803:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FCLASS_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCLASS_W),
     /* 18783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18785 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18787 */     GIR_RootConstrainSelectedInstOperands,
     /* 18788 */     // GIR_Coverage, 680,
     /* 18788 */     GIR_EraseRootFromParent_Done,
     /* 18789 */   // Label 609: @18789
     /* 18789 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(18825), // Rule ID 681 //
     /* 18794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fclass_d),
     /* 18802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 18808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18816 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7802:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FCLASS_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 18816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCLASS_D),
     /* 18819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18821 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18823 */     GIR_RootConstrainSelectedInstOperands,
     /* 18824 */     // GIR_Coverage, 681,
     /* 18824 */     GIR_EraseRootFromParent_Done,
     /* 18825 */   // Label 610: @18825
     /* 18825 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(18861), // Rule ID 704 //
     /* 18830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupl_w),
     /* 18838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18852 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7829:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8f16] }:$ws)  =>  (FEXUPL_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8f16] }:$ws)
     /* 18852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPL_W),
     /* 18855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18857 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18859 */     GIR_RootConstrainSelectedInstOperands,
     /* 18860 */     // GIR_Coverage, 704,
     /* 18860 */     GIR_EraseRootFromParent_Done,
     /* 18861 */   // Label 611: @18861
     /* 18861 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(18897), // Rule ID 705 //
     /* 18866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupl_d),
     /* 18874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18888 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7828:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXUPL_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPL_D),
     /* 18891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18893 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18895 */     GIR_RootConstrainSelectedInstOperands,
     /* 18896 */     // GIR_Coverage, 705,
     /* 18896 */     GIR_EraseRootFromParent_Done,
     /* 18897 */   // Label 612: @18897
     /* 18897 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(18933), // Rule ID 706 //
     /* 18902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupr_w),
     /* 18910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18924 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7831:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8f16] }:$ws)  =>  (FEXUPR_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8f16] }:$ws)
     /* 18924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPR_W),
     /* 18927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18929 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18931 */     GIR_RootConstrainSelectedInstOperands,
     /* 18932 */     // GIR_Coverage, 706,
     /* 18932 */     GIR_EraseRootFromParent_Done,
     /* 18933 */   // Label 613: @18933
     /* 18933 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(18969), // Rule ID 707 //
     /* 18938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexupr_d),
     /* 18946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 18949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 18952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 18956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18960 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7830:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXUPR_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 18960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXUPR_D),
     /* 18963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 18965 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 18967 */     GIR_RootConstrainSelectedInstOperands,
     /* 18968 */     // GIR_Coverage, 707,
     /* 18968 */     GIR_EraseRootFromParent_Done,
     /* 18969 */   // Label 614: @18969
     /* 18969 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(19005), // Rule ID 712 //
     /* 18974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 18977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffql_w),
     /* 18982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 18985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 18988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 18992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 18996 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7837:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (FFQL_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 18996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQL_W),
     /* 18999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19001 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19003 */     GIR_RootConstrainSelectedInstOperands,
     /* 19004 */     // GIR_Coverage, 712,
     /* 19004 */     GIR_EraseRootFromParent_Done,
     /* 19005 */   // Label 615: @19005
     /* 19005 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(19041), // Rule ID 713 //
     /* 19010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffql_d),
     /* 19018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19032 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7836:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFQL_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQL_D),
     /* 19035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19037 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19039 */     GIR_RootConstrainSelectedInstOperands,
     /* 19040 */     // GIR_Coverage, 713,
     /* 19040 */     GIR_EraseRootFromParent_Done,
     /* 19041 */   // Label 616: @19041
     /* 19041 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(19077), // Rule ID 714 //
     /* 19046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffqr_w),
     /* 19054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19068 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7839:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (FFQR_W:{ *:[v4f32] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQR_W),
     /* 19071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19073 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19075 */     GIR_RootConstrainSelectedInstOperands,
     /* 19076 */     // GIR_Coverage, 714,
     /* 19076 */     GIR_EraseRootFromParent_Done,
     /* 19077 */   // Label 617: @19077
     /* 19077 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(19113), // Rule ID 715 //
     /* 19082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ffqr_d),
     /* 19090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19104 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7838:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFQR_D:{ *:[v2f64] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FFQR_D),
     /* 19107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19109 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19111 */     GIR_RootConstrainSelectedInstOperands,
     /* 19112 */     // GIR_Coverage, 715,
     /* 19112 */     GIR_EraseRootFromParent_Done,
     /* 19113 */   // Label 618: @19113
     /* 19113 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(19149), // Rule ID 740 //
     /* 19118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frcp_w),
     /* 19126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19140 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7861:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRCP_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRCP_W),
     /* 19143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19145 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19147 */     GIR_RootConstrainSelectedInstOperands,
     /* 19148 */     // GIR_Coverage, 740,
     /* 19148 */     GIR_EraseRootFromParent_Done,
     /* 19149 */   // Label 619: @19149
     /* 19149 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(19185), // Rule ID 741 //
     /* 19154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frcp_d),
     /* 19162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19176 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7860:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRCP_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRCP_D),
     /* 19179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19181 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19183 */     GIR_RootConstrainSelectedInstOperands,
     /* 19184 */     // GIR_Coverage, 741,
     /* 19184 */     GIR_EraseRootFromParent_Done,
     /* 19185 */   // Label 620: @19185
     /* 19185 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(19221), // Rule ID 742 //
     /* 19190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frsqrt_w),
     /* 19198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19212 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7865:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRSQRT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRSQRT_W),
     /* 19215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19217 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19219 */     GIR_RootConstrainSelectedInstOperands,
     /* 19220 */     // GIR_Coverage, 742,
     /* 19220 */     GIR_EraseRootFromParent_Done,
     /* 19221 */   // Label 621: @19221
     /* 19221 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(19257), // Rule ID 743 //
     /* 19226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_frsqrt_d),
     /* 19234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19248 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7864:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRSQRT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FRSQRT_D),
     /* 19251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19253 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19255 */     GIR_RootConstrainSelectedInstOperands,
     /* 19256 */     // GIR_Coverage, 743,
     /* 19256 */     GIR_EraseRootFromParent_Done,
     /* 19257 */   // Label 622: @19257
     /* 19257 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(19293), // Rule ID 770 //
     /* 19262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_s_w),
     /* 19270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7893:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTINT_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_S_W),
     /* 19287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19289 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19291 */     GIR_RootConstrainSelectedInstOperands,
     /* 19292 */     // GIR_Coverage, 770,
     /* 19292 */     GIR_EraseRootFromParent_Done,
     /* 19293 */   // Label 623: @19293
     /* 19293 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(19329), // Rule ID 771 //
     /* 19298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_s_d),
     /* 19306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19320 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7892:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTINT_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_S_D),
     /* 19323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19325 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19327 */     GIR_RootConstrainSelectedInstOperands,
     /* 19328 */     // GIR_Coverage, 771,
     /* 19328 */     GIR_EraseRootFromParent_Done,
     /* 19329 */   // Label 624: @19329
     /* 19329 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(19365), // Rule ID 772 //
     /* 19334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_u_w),
     /* 19342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19356 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7895:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTINT_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 19356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_U_W),
     /* 19359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19361 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19363 */     GIR_RootConstrainSelectedInstOperands,
     /* 19364 */     // GIR_Coverage, 772,
     /* 19364 */     GIR_EraseRootFromParent_Done,
     /* 19365 */   // Label 625: @19365
     /* 19365 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(19401), // Rule ID 773 //
     /* 19370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftint_u_d),
     /* 19378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19392 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7894:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTINT_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 19392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTINT_U_D),
     /* 19395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19397 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19399 */     GIR_RootConstrainSelectedInstOperands,
     /* 19400 */     // GIR_Coverage, 773,
     /* 19400 */     GIR_EraseRootFromParent_Done,
     /* 19401 */   // Label 626: @19401
     /* 19401 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(19437), // Rule ID 908 //
     /* 19406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_b),
     /* 19414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 19417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 19420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 19424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 19428 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8050:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (NLOC_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 19428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_B),
     /* 19431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19433 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19435 */     GIR_RootConstrainSelectedInstOperands,
     /* 19436 */     // GIR_Coverage, 908,
     /* 19436 */     GIR_EraseRootFromParent_Done,
     /* 19437 */   // Label 627: @19437
     /* 19437 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(19473), // Rule ID 909 //
     /* 19442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_h),
     /* 19450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 19453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 19456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 19464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8052:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (NLOC_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 19464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_H),
     /* 19467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19469 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19471 */     GIR_RootConstrainSelectedInstOperands,
     /* 19472 */     // GIR_Coverage, 909,
     /* 19472 */     GIR_EraseRootFromParent_Done,
     /* 19473 */   // Label 628: @19473
     /* 19473 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(19509), // Rule ID 910 //
     /* 19478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_w),
     /* 19486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 19489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 19492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 19500 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8053:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (NLOC_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 19500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_W),
     /* 19503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19505 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19507 */     GIR_RootConstrainSelectedInstOperands,
     /* 19508 */     // GIR_Coverage, 910,
     /* 19508 */     GIR_EraseRootFromParent_Done,
     /* 19509 */   // Label 629: @19509
     /* 19509 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(19545), // Rule ID 911 //
     /* 19514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 19517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_nloc_d),
     /* 19522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 19525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 19528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 19536 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8051:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (NLOC_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 19536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NLOC_D),
     /* 19539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 19541 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 19543 */     GIR_RootConstrainSelectedInstOperands,
     /* 19544 */     // GIR_Coverage, 911,
     /* 19544 */     GIR_EraseRootFromParent_Done,
     /* 19545 */   // Label 630: @19545
     /* 19545 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(19581), // Rule ID 1251 //
     /* 19550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phl),
     /* 19558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 19564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19572 */     // (intrinsic_wo_chain:{ *:[i32] } 8077:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (PRECEQ_W_PHL_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 19572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHL_MM),
     /* 19575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19579 */     GIR_RootConstrainSelectedInstOperands,
     /* 19580 */     // GIR_Coverage, 1251,
     /* 19580 */     GIR_EraseRootFromParent_Done,
     /* 19581 */   // Label 631: @19581
     /* 19581 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(19617), // Rule ID 1252 //
     /* 19586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceq_w_phr),
     /* 19594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 19600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19608 */     // (intrinsic_wo_chain:{ *:[i32] } 8078:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (PRECEQ_W_PHR_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 19608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQ_W_PHR_MM),
     /* 19611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19615 */     GIR_RootConstrainSelectedInstOperands,
     /* 19616 */     // GIR_Coverage, 1252,
     /* 19616 */     GIR_EraseRootFromParent_Done,
     /* 19617 */   // Label 632: @19617
     /* 19617 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(19653), // Rule ID 1253 //
     /* 19622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbl),
     /* 19630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19644 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8079:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBL_MM),
     /* 19647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19651 */     GIR_RootConstrainSelectedInstOperands,
     /* 19652 */     // GIR_Coverage, 1253,
     /* 19652 */     GIR_EraseRootFromParent_Done,
     /* 19653 */   // Label 633: @19653
     /* 19653 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(19689), // Rule ID 1254 //
     /* 19658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbla),
     /* 19666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19680 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8080:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBLA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBLA_MM),
     /* 19683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19687 */     GIR_RootConstrainSelectedInstOperands,
     /* 19688 */     // GIR_Coverage, 1254,
     /* 19688 */     GIR_EraseRootFromParent_Done,
     /* 19689 */   // Label 634: @19689
     /* 19689 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(19725), // Rule ID 1255 //
     /* 19694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbr),
     /* 19702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19716 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8081:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBR_MM),
     /* 19719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19723 */     GIR_RootConstrainSelectedInstOperands,
     /* 19724 */     // GIR_Coverage, 1255,
     /* 19724 */     GIR_EraseRootFromParent_Done,
     /* 19725 */   // Label 635: @19725
     /* 19725 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(19761), // Rule ID 1256 //
     /* 19730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precequ_ph_qbra),
     /* 19738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19752 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8082:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEQU_PH_QBRA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEQU_PH_QBRA_MM),
     /* 19755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19759 */     GIR_RootConstrainSelectedInstOperands,
     /* 19760 */     // GIR_Coverage, 1256,
     /* 19760 */     GIR_EraseRootFromParent_Done,
     /* 19761 */   // Label 636: @19761
     /* 19761 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(19797), // Rule ID 1257 //
     /* 19766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbl),
     /* 19774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19788 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8083:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBL_MM),
     /* 19791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19795 */     GIR_RootConstrainSelectedInstOperands,
     /* 19796 */     // GIR_Coverage, 1257,
     /* 19796 */     GIR_EraseRootFromParent_Done,
     /* 19797 */   // Label 637: @19797
     /* 19797 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(19833), // Rule ID 1258 //
     /* 19802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbla),
     /* 19810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19824 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8084:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBLA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBLA_MM),
     /* 19827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19831 */     GIR_RootConstrainSelectedInstOperands,
     /* 19832 */     // GIR_Coverage, 1258,
     /* 19832 */     GIR_EraseRootFromParent_Done,
     /* 19833 */   // Label 638: @19833
     /* 19833 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(19869), // Rule ID 1259 //
     /* 19838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbr),
     /* 19846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19860 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8085:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBR_MM),
     /* 19863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19867 */     GIR_RootConstrainSelectedInstOperands,
     /* 19868 */     // GIR_Coverage, 1259,
     /* 19868 */     GIR_EraseRootFromParent_Done,
     /* 19869 */   // Label 639: @19869
     /* 19869 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(19905), // Rule ID 1260 //
     /* 19874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_preceu_ph_qbra),
     /* 19882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19896 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8086:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (PRECEU_PH_QBRA_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECEU_PH_QBRA_MM),
     /* 19899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19903 */     GIR_RootConstrainSelectedInstOperands,
     /* 19904 */     // GIR_Coverage, 1260,
     /* 19904 */     GIR_EraseRootFromParent_Done,
     /* 19905 */   // Label 640: @19905
     /* 19905 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(19941), // Rule ID 1286 //
     /* 19910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_raddu_w_qb),
     /* 19918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 19921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 19924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19932 */     // (intrinsic_wo_chain:{ *:[i32] } 8095:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (RADDU_W_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 19932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RADDU_W_QB_MM),
     /* 19935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19939 */     GIR_RootConstrainSelectedInstOperands,
     /* 19940 */     // GIR_Coverage, 1286,
     /* 19940 */     GIR_EraseRootFromParent_Done,
     /* 19941 */   // Label 641: @19941
     /* 19941 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(19977), // Rule ID 1290 //
     /* 19946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_ph),
     /* 19954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 19957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 19960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 19964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 19968 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8097:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (REPLV_PH_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 19968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_PH_MM),
     /* 19971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 19973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 19975 */     GIR_RootConstrainSelectedInstOperands,
     /* 19976 */     // GIR_Coverage, 1290,
     /* 19976 */     GIR_EraseRootFromParent_Done,
     /* 19977 */   // Label 642: @19977
     /* 19977 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(20013), // Rule ID 1291 //
     /* 19982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 19985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_repl_qb),
     /* 19990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 19993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 19996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20004 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8098:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (REPLV_QB_MM:{ *:[v4i8] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 20004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::REPLV_QB_MM),
     /* 20007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 20009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 20011 */     GIR_RootConstrainSelectedInstOperands,
     /* 20012 */     // GIR_Coverage, 1291,
     /* 20012 */     GIR_EraseRootFromParent_Done,
     /* 20013 */   // Label 643: @20013
     /* 20013 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(20049), // Rule ID 1301 //
     /* 20018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bitrev),
     /* 20026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 20029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20040 */     // (intrinsic_wo_chain:{ *:[i32] } 7651:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (BITREV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 20040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BITREV_MM),
     /* 20043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 20045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 20047 */     GIR_RootConstrainSelectedInstOperands,
     /* 20048 */     // GIR_Coverage, 1301,
     /* 20048 */     GIR_EraseRootFromParent_Done,
     /* 20049 */   // Label 644: @20049
     /* 20049 */   GIM_Reject,
     /* 20050 */ // Label 590: @20050
     /* 20050 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(29803),
     /* 20055 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 20058 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(20104), // Rule ID 938 //
     /* 20063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_b),
     /* 20071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20085 */     // MIs[0] m
     /* 20085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20093 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8099:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SAT_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_B),
     /* 20096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20098 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20100 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20102 */     GIR_RootConstrainSelectedInstOperands,
     /* 20103 */     // GIR_Coverage, 938,
     /* 20103 */     GIR_EraseRootFromParent_Done,
     /* 20104 */   // Label 646: @20104
     /* 20104 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(20150), // Rule ID 939 //
     /* 20109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_h),
     /* 20117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20131 */     // MIs[0] m
     /* 20131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20134 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20139 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8101:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SAT_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_H),
     /* 20142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20144 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20146 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20148 */     GIR_RootConstrainSelectedInstOperands,
     /* 20149 */     // GIR_Coverage, 939,
     /* 20149 */     GIR_EraseRootFromParent_Done,
     /* 20150 */   // Label 647: @20150
     /* 20150 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(20196), // Rule ID 940 //
     /* 20155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_w),
     /* 20163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20177 */     // MIs[0] m
     /* 20177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20185 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8102:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SAT_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_W),
     /* 20188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20190 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20192 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20194 */     GIR_RootConstrainSelectedInstOperands,
     /* 20195 */     // GIR_Coverage, 940,
     /* 20195 */     GIR_EraseRootFromParent_Done,
     /* 20196 */   // Label 648: @20196
     /* 20196 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(20242), // Rule ID 941 //
     /* 20201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_s_d),
     /* 20209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20223 */     // MIs[0] m
     /* 20223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20231 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8100:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SAT_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_S_D),
     /* 20234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20236 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20238 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20240 */     GIR_RootConstrainSelectedInstOperands,
     /* 20241 */     // GIR_Coverage, 941,
     /* 20241 */     GIR_EraseRootFromParent_Done,
     /* 20242 */   // Label 649: @20242
     /* 20242 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(20288), // Rule ID 942 //
     /* 20247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_b),
     /* 20255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20269 */     // MIs[0] m
     /* 20269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20277 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8103:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SAT_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_B),
     /* 20280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20282 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20284 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20286 */     GIR_RootConstrainSelectedInstOperands,
     /* 20287 */     // GIR_Coverage, 942,
     /* 20287 */     GIR_EraseRootFromParent_Done,
     /* 20288 */   // Label 650: @20288
     /* 20288 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(20334), // Rule ID 943 //
     /* 20293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_h),
     /* 20301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20315 */     // MIs[0] m
     /* 20315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20323 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8105:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SAT_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_H),
     /* 20326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20328 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20330 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20332 */     GIR_RootConstrainSelectedInstOperands,
     /* 20333 */     // GIR_Coverage, 943,
     /* 20333 */     GIR_EraseRootFromParent_Done,
     /* 20334 */   // Label 651: @20334
     /* 20334 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(20380), // Rule ID 944 //
     /* 20339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_w),
     /* 20347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20361 */     // MIs[0] m
     /* 20361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20369 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8106:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SAT_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_W),
     /* 20372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20374 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20376 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20378 */     GIR_RootConstrainSelectedInstOperands,
     /* 20379 */     // GIR_Coverage, 944,
     /* 20379 */     GIR_EraseRootFromParent_Done,
     /* 20380 */   // Label 652: @20380
     /* 20380 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(20426), // Rule ID 945 //
     /* 20385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sat_u_d),
     /* 20393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20407 */     // MIs[0] m
     /* 20407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20410 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20415 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8104:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SAT_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SAT_U_D),
     /* 20418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20420 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20422 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20424 */     GIR_RootConstrainSelectedInstOperands,
     /* 20425 */     // GIR_Coverage, 945,
     /* 20425 */     GIR_EraseRootFromParent_Done,
     /* 20426 */   // Label 653: @20426
     /* 20426 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(20472), // Rule ID 985 //
     /* 20431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_b),
     /* 20439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20453 */     // MIs[0] m
     /* 20453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20456 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20461 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8158:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SRARI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_B),
     /* 20464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20466 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20468 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20470 */     GIR_RootConstrainSelectedInstOperands,
     /* 20471 */     // GIR_Coverage, 985,
     /* 20471 */     GIR_EraseRootFromParent_Done,
     /* 20472 */   // Label 654: @20472
     /* 20472 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(20518), // Rule ID 986 //
     /* 20477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_h),
     /* 20485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20499 */     // MIs[0] m
     /* 20499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20507 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8160:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SRARI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_H),
     /* 20510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20512 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20514 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20516 */     GIR_RootConstrainSelectedInstOperands,
     /* 20517 */     // GIR_Coverage, 986,
     /* 20517 */     GIR_EraseRootFromParent_Done,
     /* 20518 */   // Label 655: @20518
     /* 20518 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(20564), // Rule ID 987 //
     /* 20523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_w),
     /* 20531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20545 */     // MIs[0] m
     /* 20545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20553 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8161:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SRARI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_W),
     /* 20556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20558 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20560 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20562 */     GIR_RootConstrainSelectedInstOperands,
     /* 20563 */     // GIR_Coverage, 987,
     /* 20563 */     GIR_EraseRootFromParent_Done,
     /* 20564 */   // Label 656: @20564
     /* 20564 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(20610), // Rule ID 988 //
     /* 20569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srari_d),
     /* 20577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20591 */     // MIs[0] m
     /* 20591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20599 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8159:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SRARI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRARI_D),
     /* 20602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20604 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20606 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20608 */     GIR_RootConstrainSelectedInstOperands,
     /* 20609 */     // GIR_Coverage, 988,
     /* 20609 */     GIR_EraseRootFromParent_Done,
     /* 20610 */   // Label 657: @20610
     /* 20610 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(20656), // Rule ID 1001 //
     /* 20615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_b),
     /* 20623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 20626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 20629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 20637 */     // MIs[0] m
     /* 20637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20640 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 20645 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8174:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$m)  =>  (SRLRI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_B),
     /* 20648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20650 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20652 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20654 */     GIR_RootConstrainSelectedInstOperands,
     /* 20655 */     // GIR_Coverage, 1001,
     /* 20655 */     GIR_EraseRootFromParent_Done,
     /* 20656 */   // Label 658: @20656
     /* 20656 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(20702), // Rule ID 1002 //
     /* 20661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_h),
     /* 20669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 20672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 20675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 20683 */     // MIs[0] m
     /* 20683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 20691 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8176:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$m)  =>  (SRLRI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_H),
     /* 20694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20696 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20698 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20700 */     GIR_RootConstrainSelectedInstOperands,
     /* 20701 */     // GIR_Coverage, 1002,
     /* 20701 */     GIR_EraseRootFromParent_Done,
     /* 20702 */   // Label 659: @20702
     /* 20702 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(20748), // Rule ID 1003 //
     /* 20707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_w),
     /* 20715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 20718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 20721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 20729 */     // MIs[0] m
     /* 20729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 20737 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8177:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$m)  =>  (SRLRI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_W),
     /* 20740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20742 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20744 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20746 */     GIR_RootConstrainSelectedInstOperands,
     /* 20747 */     // GIR_Coverage, 1003,
     /* 20747 */     GIR_EraseRootFromParent_Done,
     /* 20748 */   // Label 660: @20748
     /* 20748 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(20794), // Rule ID 1004 //
     /* 20753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 20756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlri_d),
     /* 20761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 20764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 20767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 20775 */     // MIs[0] m
     /* 20775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 20778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt6),
     /* 20783 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8175:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt6>>:$m)  =>  (SRLRI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$m)
     /* 20783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLRI_D),
     /* 20786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 20788 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 20790 */     GIR_RootToRootCopy, /*OpIdx*/3, // m
     /* 20792 */     GIR_RootConstrainSelectedInstOperands,
     /* 20793 */     // GIR_Coverage, 1004,
     /* 20793 */     GIR_EraseRootFromParent_Done,
     /* 20794 */   // Label 661: @20794
     /* 20794 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(20850), // Rule ID 385 //
     /* 20799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 20802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 20807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 20810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 20813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 20836 */     // MIs[1] Operand 1
     /* 20836 */     // No operand predicates
     /* 20836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20838 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8117:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$rs_sa)  =>  (SHRA_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_PH),
     /* 20841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20848 */     GIR_RootConstrainSelectedInstOperands,
     /* 20849 */     // GIR_Coverage, 385,
     /* 20849 */     GIR_EraseRootFromParent_Done,
     /* 20850 */   // Label 662: @20850
     /* 20850 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(20906), // Rule ID 389 //
     /* 20855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 20858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 20863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 20866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 20869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 20880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 20892 */     // MIs[1] Operand 1
     /* 20892 */     // No operand predicates
     /* 20892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20894 */     // (intrinsic_wo_chain:{ *:[i32] } 8119:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$rs_sa)  =>  (SHRA_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_W),
     /* 20897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20904 */     GIR_RootConstrainSelectedInstOperands,
     /* 20905 */     // GIR_Coverage, 389,
     /* 20905 */     GIR_EraseRootFromParent_Done,
     /* 20906 */   // Label 663: @20906
     /* 20906 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(20962), // Rule ID 480 //
     /* 20911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 20914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 20919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 20922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 20925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 20944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 20948 */     // MIs[1] Operand 1
     /* 20948 */     // No operand predicates
     /* 20948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 20950 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8118:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$rs_sa)  =>  (SHRA_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 20950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_QB),
     /* 20953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 20955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 20957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 20960 */     GIR_RootConstrainSelectedInstOperands,
     /* 20961 */     // GIR_Coverage, 480,
     /* 20961 */     GIR_EraseRootFromParent_Done,
     /* 20962 */   // Label 664: @20962
     /* 20962 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(21018), // Rule ID 1245 //
     /* 20967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 20970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 20975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 20978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 20981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 20984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 20992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 20996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21004 */     // MIs[1] Operand 1
     /* 21004 */     // No operand predicates
     /* 21004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21006 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8117:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$sa)  =>  (SHRA_R_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_PH_MM),
     /* 21009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21016 */     GIR_RootConstrainSelectedInstOperands,
     /* 21017 */     // GIR_Coverage, 1245,
     /* 21017 */     GIR_EraseRootFromParent_Done,
     /* 21018 */   // Label 665: @21018
     /* 21018 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(21074), // Rule ID 1249 //
     /* 21023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 21026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 21031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 21060 */     // MIs[1] Operand 1
     /* 21060 */     // No operand predicates
     /* 21060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21062 */     // (intrinsic_wo_chain:{ *:[i32] } 8119:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$sa)  =>  (SHRA_R_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_W_MM),
     /* 21065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21072 */     GIR_RootConstrainSelectedInstOperands,
     /* 21073 */     // GIR_Coverage, 1249,
     /* 21073 */     GIR_EraseRootFromParent_Done,
     /* 21074 */   // Label 666: @21074
     /* 21074 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(21130), // Rule ID 1324 //
     /* 21079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 21082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 21087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21112 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21116 */     // MIs[1] Operand 1
     /* 21116 */     // No operand predicates
     /* 21116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21118 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8118:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$sa)  =>  (SHRA_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 21118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_R_QB_MMR2),
     /* 21121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 21123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 21128 */     GIR_RootConstrainSelectedInstOperands,
     /* 21129 */     // GIR_Coverage, 1324,
     /* 21129 */     GIR_EraseRootFromParent_Done,
     /* 21130 */   // Label 667: @21130
     /* 21130 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(21182), // Rule ID 1939 //
     /* 21135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 21143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21168 */     // MIs[1] Operand 1
     /* 21168 */     // No operand predicates
     /* 21168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21170 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8115:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHRA_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 21170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_PH),
     /* 21173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21175 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21180 */     GIR_RootConstrainSelectedInstOperands,
     /* 21181 */     // GIR_Coverage, 1939,
     /* 21181 */     GIR_EraseRootFromParent_Done,
     /* 21182 */   // Label 668: @21182
     /* 21182 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(21234), // Rule ID 1940 //
     /* 21187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 21195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21216 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 21220 */     // MIs[1] Operand 1
     /* 21220 */     // No operand predicates
     /* 21220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21222 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8120:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHRL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 21222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRL_PH),
     /* 21225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21227 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21232 */     GIR_RootConstrainSelectedInstOperands,
     /* 21233 */     // GIR_Coverage, 1940,
     /* 21233 */     GIR_EraseRootFromParent_Done,
     /* 21234 */   // Label 669: @21234
     /* 21234 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(21286), // Rule ID 1945 //
     /* 21239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 21247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21272 */     // MIs[1] Operand 1
     /* 21272 */     // No operand predicates
     /* 21272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21274 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8116:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHRA_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 21274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRA_QB),
     /* 21277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21279 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21284 */     GIR_RootConstrainSelectedInstOperands,
     /* 21285 */     // GIR_Coverage, 1945,
     /* 21285 */     GIR_EraseRootFromParent_Done,
     /* 21286 */   // Label 670: @21286
     /* 21286 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(21338), // Rule ID 1946 //
     /* 21291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 21299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 21316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 21320 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 21324 */     // MIs[1] Operand 1
     /* 21324 */     // No operand predicates
     /* 21324 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 21326 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8121:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHRL_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 21326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRL_QB),
     /* 21329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21331 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 21333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 21336 */     GIR_RootConstrainSelectedInstOperands,
     /* 21337 */     // GIR_Coverage, 1946,
     /* 21337 */     GIR_EraseRootFromParent_Done,
     /* 21338 */   // Label 671: @21338
     /* 21338 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(21386), // Rule ID 355 //
     /* 21343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_qb),
     /* 21351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21372 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7587:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDU_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_QB),
     /* 21375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21384 */     GIR_RootConstrainSelectedInstOperands,
     /* 21385 */     // GIR_Coverage, 355,
     /* 21385 */     GIR_EraseRootFromParent_Done,
     /* 21386 */   // Label 672: @21386
     /* 21386 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(21434), // Rule ID 356 //
     /* 21391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_qb),
     /* 21399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21420 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8210:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBU_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_QB),
     /* 21423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21432 */     GIR_RootConstrainSelectedInstOperands,
     /* 21433 */     // GIR_Coverage, 356,
     /* 21433 */     GIR_EraseRootFromParent_Done,
     /* 21434 */   // Label 673: @21434
     /* 21434 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(21482), // Rule ID 357 //
     /* 21439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_ph),
     /* 21447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21468 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7565:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_PH),
     /* 21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21480 */     GIR_RootConstrainSelectedInstOperands,
     /* 21481 */     // GIR_Coverage, 357,
     /* 21481 */     GIR_EraseRootFromParent_Done,
     /* 21482 */   // Label 674: @21482
     /* 21482 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(21530), // Rule ID 358 //
     /* 21487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_ph),
     /* 21495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21516 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8185:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_PH),
     /* 21519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 21528 */     GIR_RootConstrainSelectedInstOperands,
     /* 21529 */     // GIR_Coverage, 358,
     /* 21529 */     GIR_EraseRootFromParent_Done,
     /* 21530 */   // Label 675: @21530
     /* 21530 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(21575), // Rule ID 361 //
     /* 21535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_modsub),
     /* 21543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21564 */     // (intrinsic_wo_chain:{ *:[i32] } 8015:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODSUB:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 21564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MODSUB),
     /* 21567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21573 */     GIR_RootConstrainSelectedInstOperands,
     /* 21574 */     // GIR_Coverage, 361,
     /* 21574 */     GIR_EraseRootFromParent_Done,
     /* 21575 */   // Label 676: @21575
     /* 21575 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(21620), // Rule ID 365 //
     /* 21580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_qb_ph),
     /* 21588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21609 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8091:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQ_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_QB_PH),
     /* 21612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21618 */     GIR_RootConstrainSelectedInstOperands,
     /* 21619 */     // GIR_Coverage, 365,
     /* 21619 */     GIR_EraseRootFromParent_Done,
     /* 21620 */   // Label 677: @21620
     /* 21620 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(21665), // Rule ID 366 //
     /* 21625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_ph_w),
     /* 21633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21654 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8090:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 21654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_PH_W),
     /* 21657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21663 */     GIR_RootConstrainSelectedInstOperands,
     /* 21664 */     // GIR_Coverage, 366,
     /* 21664 */     GIR_EraseRootFromParent_Done,
     /* 21665 */   // Label 678: @21665
     /* 21665 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(21710), // Rule ID 380 //
     /* 21670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 21678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21699 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8121:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRLV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_QB),
     /* 21702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21708 */     GIR_RootConstrainSelectedInstOperands,
     /* 21709 */     // GIR_Coverage, 380,
     /* 21709 */     GIR_EraseRootFromParent_Done,
     /* 21710 */   // Label 679: @21710
     /* 21710 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(21755), // Rule ID 384 //
     /* 21715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 21723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21744 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8115:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_PH),
     /* 21747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21753 */     GIR_RootConstrainSelectedInstOperands,
     /* 21754 */     // GIR_Coverage, 384,
     /* 21754 */     GIR_EraseRootFromParent_Done,
     /* 21755 */   // Label 680: @21755
     /* 21755 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(21800), // Rule ID 386 //
     /* 21760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 21768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21789 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8117:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_PH),
     /* 21792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21798 */     GIR_RootConstrainSelectedInstOperands,
     /* 21799 */     // GIR_Coverage, 386,
     /* 21799 */     GIR_EraseRootFromParent_Done,
     /* 21800 */   // Label 681: @21800
     /* 21800 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(21845), // Rule ID 390 //
     /* 21805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 21813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 21816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 21819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 21822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 21834 */     // (intrinsic_wo_chain:{ *:[i32] } 8119:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 21834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_W),
     /* 21837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 21841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 21843 */     GIR_RootConstrainSelectedInstOperands,
     /* 21844 */     // GIR_Coverage, 390,
     /* 21844 */     GIR_EraseRootFromParent_Done,
     /* 21845 */   // Label 682: @21845
     /* 21845 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(21890), // Rule ID 427 //
     /* 21850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 21853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_packrl_ph),
     /* 21858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 21861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 21864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 21867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21879 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8062:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PACKRL_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 21879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PACKRL_PH),
     /* 21882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21888 */     GIR_RootConstrainSelectedInstOperands,
     /* 21889 */     // GIR_Coverage, 427,
     /* 21889 */     GIR_EraseRootFromParent_Done,
     /* 21890 */   // Label 683: @21890
     /* 21890 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(21935), // Rule ID 451 //
     /* 21895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_qb),
     /* 21903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21924 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7588:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_QB),
     /* 21927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21933 */     GIR_RootConstrainSelectedInstOperands,
     /* 21934 */     // GIR_Coverage, 451,
     /* 21934 */     GIR_EraseRootFromParent_Done,
     /* 21935 */   // Label 684: @21935
     /* 21935 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(21980), // Rule ID 452 //
     /* 21940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_r_qb),
     /* 21948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 21957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 21969 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7589:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 21969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_R_QB),
     /* 21972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 21974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 21976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 21978 */     GIR_RootConstrainSelectedInstOperands,
     /* 21979 */     // GIR_Coverage, 452,
     /* 21979 */     GIR_EraseRootFromParent_Done,
     /* 21980 */   // Label 685: @21980
     /* 21980 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(22025), // Rule ID 453 //
     /* 21985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 21988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_qb),
     /* 21993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 21996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 21999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 22002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22014 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8211:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 22014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_QB),
     /* 22017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22023 */     GIR_RootConstrainSelectedInstOperands,
     /* 22024 */     // GIR_Coverage, 453,
     /* 22024 */     GIR_EraseRootFromParent_Done,
     /* 22025 */   // Label 686: @22025
     /* 22025 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(22070), // Rule ID 454 //
     /* 22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_r_qb),
     /* 22038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 22047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22059 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8212:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 22059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_R_QB),
     /* 22062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22068 */     GIR_RootConstrainSelectedInstOperands,
     /* 22069 */     // GIR_Coverage, 454,
     /* 22069 */     GIR_EraseRootFromParent_Done,
     /* 22070 */   // Label 687: @22070
     /* 22070 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(22115), // Rule ID 455 //
     /* 22075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_ph),
     /* 22083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22104 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7567:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_PH),
     /* 22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22113 */     GIR_RootConstrainSelectedInstOperands,
     /* 22114 */     // GIR_Coverage, 455,
     /* 22114 */     GIR_EraseRootFromParent_Done,
     /* 22115 */   // Label 688: @22115
     /* 22115 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(22160), // Rule ID 456 //
     /* 22120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_ph),
     /* 22128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22149 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7568:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_PH),
     /* 22152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22158 */     GIR_RootConstrainSelectedInstOperands,
     /* 22159 */     // GIR_Coverage, 456,
     /* 22159 */     GIR_EraseRootFromParent_Done,
     /* 22160 */   // Label 689: @22160
     /* 22160 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(22205), // Rule ID 457 //
     /* 22165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_ph),
     /* 22173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22194 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8187:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_PH),
     /* 22197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22203 */     GIR_RootConstrainSelectedInstOperands,
     /* 22204 */     // GIR_Coverage, 457,
     /* 22204 */     GIR_EraseRootFromParent_Done,
     /* 22205 */   // Label 690: @22205
     /* 22205 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(22250), // Rule ID 458 //
     /* 22210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_ph),
     /* 22218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 22227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22239 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8188:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_R_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 22239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_PH),
     /* 22242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22248 */     GIR_RootConstrainSelectedInstOperands,
     /* 22249 */     // GIR_Coverage, 458,
     /* 22249 */     GIR_EraseRootFromParent_Done,
     /* 22250 */   // Label 691: @22250
     /* 22250 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(22295), // Rule ID 459 //
     /* 22255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_w),
     /* 22263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22284 */     // (intrinsic_wo_chain:{ *:[i32] } 7570:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_W),
     /* 22287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22293 */     GIR_RootConstrainSelectedInstOperands,
     /* 22294 */     // GIR_Coverage, 459,
     /* 22294 */     GIR_EraseRootFromParent_Done,
     /* 22295 */   // Label 692: @22295
     /* 22295 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(22340), // Rule ID 460 //
     /* 22300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_w),
     /* 22308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22329 */     // (intrinsic_wo_chain:{ *:[i32] } 7569:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_W),
     /* 22332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22338 */     GIR_RootConstrainSelectedInstOperands,
     /* 22339 */     // GIR_Coverage, 460,
     /* 22339 */     GIR_EraseRootFromParent_Done,
     /* 22340 */   // Label 693: @22340
     /* 22340 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(22385), // Rule ID 461 //
     /* 22345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_w),
     /* 22353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22374 */     // (intrinsic_wo_chain:{ *:[i32] } 8190:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_W),
     /* 22377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22383 */     GIR_RootConstrainSelectedInstOperands,
     /* 22384 */     // GIR_Coverage, 461,
     /* 22384 */     GIR_EraseRootFromParent_Done,
     /* 22385 */   // Label 694: @22385
     /* 22385 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(22430), // Rule ID 462 //
     /* 22390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_w),
     /* 22398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 22401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 22404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22419 */     // (intrinsic_wo_chain:{ *:[i32] } 8189:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_R_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 22419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_W),
     /* 22422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 22426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 22428 */     GIR_RootConstrainSelectedInstOperands,
     /* 22429 */     // GIR_Coverage, 462,
     /* 22429 */     GIR_EraseRootFromParent_Done,
     /* 22430 */   // Label 695: @22430
     /* 22430 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(22475), // Rule ID 479 //
     /* 22435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 22443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22464 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8116:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_QB),
     /* 22467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22473 */     GIR_RootConstrainSelectedInstOperands,
     /* 22474 */     // GIR_Coverage, 479,
     /* 22474 */     GIR_EraseRootFromParent_Done,
     /* 22475 */   // Label 696: @22475
     /* 22475 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(22520), // Rule ID 481 //
     /* 22480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 22488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 22491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 22494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22509 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8118:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRAV_R_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_QB),
     /* 22512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22518 */     GIR_RootConstrainSelectedInstOperands,
     /* 22519 */     // GIR_Coverage, 481,
     /* 22519 */     GIR_EraseRootFromParent_Done,
     /* 22520 */   // Label 697: @22520
     /* 22520 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(22565), // Rule ID 482 //
     /* 22525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 22528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 22533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 22536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 22539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 22542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 22550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 22554 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8120:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHRLV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 22554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_PH),
     /* 22557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 22559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 22561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 22563 */     GIR_RootConstrainSelectedInstOperands,
     /* 22564 */     // GIR_Coverage, 482,
     /* 22564 */     GIR_EraseRootFromParent_Done,
     /* 22565 */   // Label 698: @22565
     /* 22565 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(22610), // Rule ID 491 //
     /* 22570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_b),
     /* 22578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22599 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7560:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADD_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_B),
     /* 22602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22604 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22606 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22608 */     GIR_RootConstrainSelectedInstOperands,
     /* 22609 */     // GIR_Coverage, 491,
     /* 22609 */     GIR_EraseRootFromParent_Done,
     /* 22610 */   // Label 699: @22610
     /* 22610 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(22655), // Rule ID 492 //
     /* 22615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_h),
     /* 22623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22644 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7562:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADD_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_H),
     /* 22647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22649 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22651 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22653 */     GIR_RootConstrainSelectedInstOperands,
     /* 22654 */     // GIR_Coverage, 492,
     /* 22654 */     GIR_EraseRootFromParent_Done,
     /* 22655 */   // Label 700: @22655
     /* 22655 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(22700), // Rule ID 493 //
     /* 22660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_w),
     /* 22668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 22671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 22674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 22677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22689 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7563:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADD_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 22689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_W),
     /* 22692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22694 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22696 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22698 */     GIR_RootConstrainSelectedInstOperands,
     /* 22699 */     // GIR_Coverage, 493,
     /* 22699 */     GIR_EraseRootFromParent_Done,
     /* 22700 */   // Label 701: @22700
     /* 22700 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(22745), // Rule ID 494 //
     /* 22705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_add_a_d),
     /* 22713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 22716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 22719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 22722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22734 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7561:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADD_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 22734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADD_A_D),
     /* 22737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22739 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22741 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22743 */     GIR_RootConstrainSelectedInstOperands,
     /* 22744 */     // GIR_Coverage, 494,
     /* 22744 */     GIR_EraseRootFromParent_Done,
     /* 22745 */   // Label 702: @22745
     /* 22745 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(22790), // Rule ID 495 //
     /* 22750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_b),
     /* 22758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22779 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7571:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_B),
     /* 22782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22784 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22786 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22788 */     GIR_RootConstrainSelectedInstOperands,
     /* 22789 */     // GIR_Coverage, 495,
     /* 22789 */     GIR_EraseRootFromParent_Done,
     /* 22790 */   // Label 703: @22790
     /* 22790 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(22835), // Rule ID 496 //
     /* 22795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_h),
     /* 22803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22824 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7573:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 22824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_H),
     /* 22827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22829 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22831 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22833 */     GIR_RootConstrainSelectedInstOperands,
     /* 22834 */     // GIR_Coverage, 496,
     /* 22834 */     GIR_EraseRootFromParent_Done,
     /* 22835 */   // Label 704: @22835
     /* 22835 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(22880), // Rule ID 497 //
     /* 22840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_w),
     /* 22848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 22851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 22854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 22857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 22869 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7574:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 22869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_W),
     /* 22872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22874 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22876 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22878 */     GIR_RootConstrainSelectedInstOperands,
     /* 22879 */     // GIR_Coverage, 497,
     /* 22879 */     GIR_EraseRootFromParent_Done,
     /* 22880 */   // Label 705: @22880
     /* 22880 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(22925), // Rule ID 498 //
     /* 22885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_a_d),
     /* 22893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 22896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 22899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 22902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 22914 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7572:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 22914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_A_D),
     /* 22917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22919 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22921 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22923 */     GIR_RootConstrainSelectedInstOperands,
     /* 22924 */     // GIR_Coverage, 498,
     /* 22924 */     GIR_EraseRootFromParent_Done,
     /* 22925 */   // Label 706: @22925
     /* 22925 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(22970), // Rule ID 499 //
     /* 22930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_b),
     /* 22938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 22941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 22944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 22947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 22959 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7575:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 22959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_B),
     /* 22962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 22964 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 22966 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 22968 */     GIR_RootConstrainSelectedInstOperands,
     /* 22969 */     // GIR_Coverage, 499,
     /* 22969 */     GIR_EraseRootFromParent_Done,
     /* 22970 */   // Label 707: @22970
     /* 22970 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(23015), // Rule ID 500 //
     /* 22975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 22978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_h),
     /* 22983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 22986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 22989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 22992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 22996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23004 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7577:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_H),
     /* 23007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23009 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23011 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23013 */     GIR_RootConstrainSelectedInstOperands,
     /* 23014 */     // GIR_Coverage, 500,
     /* 23014 */     GIR_EraseRootFromParent_Done,
     /* 23015 */   // Label 708: @23015
     /* 23015 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(23060), // Rule ID 501 //
     /* 23020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_w),
     /* 23028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23049 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7578:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_W),
     /* 23052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23054 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23056 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23058 */     GIR_RootConstrainSelectedInstOperands,
     /* 23059 */     // GIR_Coverage, 501,
     /* 23059 */     GIR_EraseRootFromParent_Done,
     /* 23060 */   // Label 709: @23060
     /* 23060 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(23105), // Rule ID 502 //
     /* 23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_s_d),
     /* 23073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23094 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7576:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_S_D),
     /* 23097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23099 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23101 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23103 */     GIR_RootConstrainSelectedInstOperands,
     /* 23104 */     // GIR_Coverage, 502,
     /* 23104 */     GIR_EraseRootFromParent_Done,
     /* 23105 */   // Label 710: @23105
     /* 23105 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(23150), // Rule ID 503 //
     /* 23110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_b),
     /* 23118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23139 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7579:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ADDS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_B),
     /* 23142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23144 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23146 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23148 */     GIR_RootConstrainSelectedInstOperands,
     /* 23149 */     // GIR_Coverage, 503,
     /* 23149 */     GIR_EraseRootFromParent_Done,
     /* 23150 */   // Label 711: @23150
     /* 23150 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(23195), // Rule ID 504 //
     /* 23155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_h),
     /* 23163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23184 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7581:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ADDS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_H),
     /* 23187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23189 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23191 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23193 */     GIR_RootConstrainSelectedInstOperands,
     /* 23194 */     // GIR_Coverage, 504,
     /* 23194 */     GIR_EraseRootFromParent_Done,
     /* 23195 */   // Label 712: @23195
     /* 23195 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(23240), // Rule ID 505 //
     /* 23200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_w),
     /* 23208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23229 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7582:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ADDS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_W),
     /* 23232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23234 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23236 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23238 */     GIR_RootConstrainSelectedInstOperands,
     /* 23239 */     // GIR_Coverage, 505,
     /* 23239 */     GIR_EraseRootFromParent_Done,
     /* 23240 */   // Label 713: @23240
     /* 23240 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(23285), // Rule ID 506 //
     /* 23245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adds_u_d),
     /* 23253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23274 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7580:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ADDS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDS_U_D),
     /* 23277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23279 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23281 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23283 */     GIR_RootConstrainSelectedInstOperands,
     /* 23284 */     // GIR_Coverage, 506,
     /* 23284 */     GIR_EraseRootFromParent_Done,
     /* 23285 */   // Label 714: @23285
     /* 23285 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(23330), // Rule ID 520 //
     /* 23290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_b),
     /* 23298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23319 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7602:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ASUB_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_B),
     /* 23322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23324 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23326 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23328 */     GIR_RootConstrainSelectedInstOperands,
     /* 23329 */     // GIR_Coverage, 520,
     /* 23329 */     GIR_EraseRootFromParent_Done,
     /* 23330 */   // Label 715: @23330
     /* 23330 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(23375), // Rule ID 521 //
     /* 23335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_h),
     /* 23343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23364 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7604:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ASUB_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_H),
     /* 23367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23369 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23371 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23373 */     GIR_RootConstrainSelectedInstOperands,
     /* 23374 */     // GIR_Coverage, 521,
     /* 23374 */     GIR_EraseRootFromParent_Done,
     /* 23375 */   // Label 716: @23375
     /* 23375 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(23420), // Rule ID 522 //
     /* 23380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_w),
     /* 23388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23409 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7605:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ASUB_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_W),
     /* 23412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23414 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23416 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23418 */     GIR_RootConstrainSelectedInstOperands,
     /* 23419 */     // GIR_Coverage, 522,
     /* 23419 */     GIR_EraseRootFromParent_Done,
     /* 23420 */   // Label 717: @23420
     /* 23420 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(23465), // Rule ID 523 //
     /* 23425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_s_d),
     /* 23433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23454 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7603:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ASUB_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_S_D),
     /* 23457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23459 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23461 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23463 */     GIR_RootConstrainSelectedInstOperands,
     /* 23464 */     // GIR_Coverage, 523,
     /* 23464 */     GIR_EraseRootFromParent_Done,
     /* 23465 */   // Label 718: @23465
     /* 23465 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(23510), // Rule ID 524 //
     /* 23470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_b),
     /* 23478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23499 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7606:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (ASUB_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_B),
     /* 23502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23504 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23506 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23508 */     GIR_RootConstrainSelectedInstOperands,
     /* 23509 */     // GIR_Coverage, 524,
     /* 23509 */     GIR_EraseRootFromParent_Done,
     /* 23510 */   // Label 719: @23510
     /* 23510 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(23555), // Rule ID 525 //
     /* 23515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_h),
     /* 23523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23544 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7608:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (ASUB_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_H),
     /* 23547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23549 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23551 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23553 */     GIR_RootConstrainSelectedInstOperands,
     /* 23554 */     // GIR_Coverage, 525,
     /* 23554 */     GIR_EraseRootFromParent_Done,
     /* 23555 */   // Label 720: @23555
     /* 23555 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(23600), // Rule ID 526 //
     /* 23560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_w),
     /* 23568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23589 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7609:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (ASUB_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_W),
     /* 23592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23594 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23596 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23598 */     GIR_RootConstrainSelectedInstOperands,
     /* 23599 */     // GIR_Coverage, 526,
     /* 23599 */     GIR_EraseRootFromParent_Done,
     /* 23600 */   // Label 721: @23600
     /* 23600 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(23645), // Rule ID 527 //
     /* 23605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_asub_u_d),
     /* 23613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23634 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7607:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (ASUB_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ASUB_U_D),
     /* 23637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23639 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23641 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23643 */     GIR_RootConstrainSelectedInstOperands,
     /* 23644 */     // GIR_Coverage, 527,
     /* 23644 */     GIR_EraseRootFromParent_Done,
     /* 23645 */   // Label 722: @23645
     /* 23645 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(23690), // Rule ID 528 //
     /* 23650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_b),
     /* 23658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23679 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7610:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVE_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_B),
     /* 23682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23684 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23686 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23688 */     GIR_RootConstrainSelectedInstOperands,
     /* 23689 */     // GIR_Coverage, 528,
     /* 23689 */     GIR_EraseRootFromParent_Done,
     /* 23690 */   // Label 723: @23690
     /* 23690 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(23735), // Rule ID 529 //
     /* 23695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_h),
     /* 23703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23724 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7612:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVE_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_H),
     /* 23727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23729 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23731 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23733 */     GIR_RootConstrainSelectedInstOperands,
     /* 23734 */     // GIR_Coverage, 529,
     /* 23734 */     GIR_EraseRootFromParent_Done,
     /* 23735 */   // Label 724: @23735
     /* 23735 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(23780), // Rule ID 530 //
     /* 23740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_w),
     /* 23748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23769 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7613:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVE_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_W),
     /* 23772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23774 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23776 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23778 */     GIR_RootConstrainSelectedInstOperands,
     /* 23779 */     // GIR_Coverage, 530,
     /* 23779 */     GIR_EraseRootFromParent_Done,
     /* 23780 */   // Label 725: @23780
     /* 23780 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(23825), // Rule ID 531 //
     /* 23785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_s_d),
     /* 23793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23814 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7611:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVE_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_S_D),
     /* 23817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23819 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23821 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23823 */     GIR_RootConstrainSelectedInstOperands,
     /* 23824 */     // GIR_Coverage, 531,
     /* 23824 */     GIR_EraseRootFromParent_Done,
     /* 23825 */   // Label 726: @23825
     /* 23825 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(23870), // Rule ID 532 //
     /* 23830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_b),
     /* 23838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 23841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 23844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 23847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 23859 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7614:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVE_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 23859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_B),
     /* 23862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23864 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23866 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23868 */     GIR_RootConstrainSelectedInstOperands,
     /* 23869 */     // GIR_Coverage, 532,
     /* 23869 */     GIR_EraseRootFromParent_Done,
     /* 23870 */   // Label 727: @23870
     /* 23870 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(23915), // Rule ID 533 //
     /* 23875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_h),
     /* 23883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 23886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 23889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 23892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 23904 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7616:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVE_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 23904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_H),
     /* 23907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23909 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23911 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23913 */     GIR_RootConstrainSelectedInstOperands,
     /* 23914 */     // GIR_Coverage, 533,
     /* 23914 */     GIR_EraseRootFromParent_Done,
     /* 23915 */   // Label 728: @23915
     /* 23915 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(23960), // Rule ID 534 //
     /* 23920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_w),
     /* 23928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 23931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 23934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 23937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 23949 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7617:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVE_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 23949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_W),
     /* 23952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23954 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 23956 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 23958 */     GIR_RootConstrainSelectedInstOperands,
     /* 23959 */     // GIR_Coverage, 534,
     /* 23959 */     GIR_EraseRootFromParent_Done,
     /* 23960 */   // Label 729: @23960
     /* 23960 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(24005), // Rule ID 535 //
     /* 23965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 23968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ave_u_d),
     /* 23973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 23976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 23979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 23982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 23994 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7615:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVE_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 23994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVE_U_D),
     /* 23997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 23999 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24001 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24003 */     GIR_RootConstrainSelectedInstOperands,
     /* 24004 */     // GIR_Coverage, 535,
     /* 24004 */     GIR_EraseRootFromParent_Done,
     /* 24005 */   // Label 730: @24005
     /* 24005 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(24050), // Rule ID 536 //
     /* 24010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_b),
     /* 24018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 24021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24039 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7618:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVER_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_B),
     /* 24042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24044 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24046 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24048 */     GIR_RootConstrainSelectedInstOperands,
     /* 24049 */     // GIR_Coverage, 536,
     /* 24049 */     GIR_EraseRootFromParent_Done,
     /* 24050 */   // Label 731: @24050
     /* 24050 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(24095), // Rule ID 537 //
     /* 24055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_h),
     /* 24063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24084 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7620:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVER_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_H),
     /* 24087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24089 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24091 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24093 */     GIR_RootConstrainSelectedInstOperands,
     /* 24094 */     // GIR_Coverage, 537,
     /* 24094 */     GIR_EraseRootFromParent_Done,
     /* 24095 */   // Label 732: @24095
     /* 24095 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(24140), // Rule ID 538 //
     /* 24100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_w),
     /* 24108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24129 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7621:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVER_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_W),
     /* 24132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24134 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24136 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24138 */     GIR_RootConstrainSelectedInstOperands,
     /* 24139 */     // GIR_Coverage, 538,
     /* 24139 */     GIR_EraseRootFromParent_Done,
     /* 24140 */   // Label 733: @24140
     /* 24140 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(24185), // Rule ID 539 //
     /* 24145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_s_d),
     /* 24153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24174 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7619:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVER_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_S_D),
     /* 24177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24179 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24181 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24183 */     GIR_RootConstrainSelectedInstOperands,
     /* 24184 */     // GIR_Coverage, 539,
     /* 24184 */     GIR_EraseRootFromParent_Done,
     /* 24185 */   // Label 734: @24185
     /* 24185 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(24230), // Rule ID 540 //
     /* 24190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_b),
     /* 24198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 24201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24219 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7622:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (AVER_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_B),
     /* 24222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24224 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24226 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24228 */     GIR_RootConstrainSelectedInstOperands,
     /* 24229 */     // GIR_Coverage, 540,
     /* 24229 */     GIR_EraseRootFromParent_Done,
     /* 24230 */   // Label 735: @24230
     /* 24230 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(24275), // Rule ID 541 //
     /* 24235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_h),
     /* 24243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24264 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7624:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (AVER_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_H),
     /* 24267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24269 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24271 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24273 */     GIR_RootConstrainSelectedInstOperands,
     /* 24274 */     // GIR_Coverage, 541,
     /* 24274 */     GIR_EraseRootFromParent_Done,
     /* 24275 */   // Label 736: @24275
     /* 24275 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(24320), // Rule ID 542 //
     /* 24280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_w),
     /* 24288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24309 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7625:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (AVER_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_W),
     /* 24312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24314 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24316 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24318 */     GIR_RootConstrainSelectedInstOperands,
     /* 24319 */     // GIR_Coverage, 542,
     /* 24319 */     GIR_EraseRootFromParent_Done,
     /* 24320 */   // Label 737: @24320
     /* 24320 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(24365), // Rule ID 543 //
     /* 24325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_aver_u_d),
     /* 24333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24354 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7623:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (AVER_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 24354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::AVER_U_D),
     /* 24357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24359 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24361 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24363 */     GIR_RootConstrainSelectedInstOperands,
     /* 24364 */     // GIR_Coverage, 543,
     /* 24364 */     GIR_EraseRootFromParent_Done,
     /* 24365 */   // Label 738: @24365
     /* 24365 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(24410), // Rule ID 652 //
     /* 24370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_h),
     /* 24378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24399 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7757:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DOTP_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_H),
     /* 24402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24404 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24406 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24408 */     GIR_RootConstrainSelectedInstOperands,
     /* 24409 */     // GIR_Coverage, 652,
     /* 24409 */     GIR_EraseRootFromParent_Done,
     /* 24410 */   // Label 739: @24410
     /* 24410 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(24455), // Rule ID 653 //
     /* 24415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_w),
     /* 24423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24444 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7758:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DOTP_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_W),
     /* 24447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24449 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24451 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24453 */     GIR_RootConstrainSelectedInstOperands,
     /* 24454 */     // GIR_Coverage, 653,
     /* 24454 */     GIR_EraseRootFromParent_Done,
     /* 24455 */   // Label 740: @24455
     /* 24455 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(24500), // Rule ID 654 //
     /* 24460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_s_d),
     /* 24468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24489 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7756:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DOTP_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_S_D),
     /* 24492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24494 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24496 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24498 */     GIR_RootConstrainSelectedInstOperands,
     /* 24499 */     // GIR_Coverage, 654,
     /* 24499 */     GIR_EraseRootFromParent_Done,
     /* 24500 */   // Label 741: @24500
     /* 24500 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(24545), // Rule ID 655 //
     /* 24505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_h),
     /* 24513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 24519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 24522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 24534 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7760:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DOTP_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 24534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_H),
     /* 24537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24539 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24541 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24543 */     GIR_RootConstrainSelectedInstOperands,
     /* 24544 */     // GIR_Coverage, 655,
     /* 24544 */     GIR_EraseRootFromParent_Done,
     /* 24545 */   // Label 742: @24545
     /* 24545 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(24590), // Rule ID 656 //
     /* 24550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_w),
     /* 24558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 24564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 24567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24579 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7761:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DOTP_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 24579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_W),
     /* 24582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24584 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24586 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24588 */     GIR_RootConstrainSelectedInstOperands,
     /* 24589 */     // GIR_Coverage, 656,
     /* 24589 */     GIR_EraseRootFromParent_Done,
     /* 24590 */   // Label 743: @24590
     /* 24590 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(24635), // Rule ID 657 //
     /* 24595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dotp_u_d),
     /* 24603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24624 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7759:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DOTP_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 24624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DOTP_U_D),
     /* 24627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24629 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24631 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24633 */     GIR_RootConstrainSelectedInstOperands,
     /* 24634 */     // GIR_Coverage, 657,
     /* 24634 */     GIR_EraseRootFromParent_Done,
     /* 24635 */   // Label 744: @24635
     /* 24635 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(24680), // Rule ID 672 //
     /* 24640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fcaf_w),
     /* 24648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24669 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7799:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FCAF_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCAF_W),
     /* 24672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24674 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24676 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24678 */     GIR_RootConstrainSelectedInstOperands,
     /* 24679 */     // GIR_Coverage, 672,
     /* 24679 */     GIR_EraseRootFromParent_Done,
     /* 24680 */   // Label 745: @24680
     /* 24680 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(24725), // Rule ID 673 //
     /* 24685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fcaf_d),
     /* 24693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24714 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7798:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FCAF_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FCAF_D),
     /* 24717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24719 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24721 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24723 */     GIR_RootConstrainSelectedInstOperands,
     /* 24724 */     // GIR_Coverage, 673,
     /* 24724 */     GIR_EraseRootFromParent_Done,
     /* 24725 */   // Label 746: @24725
     /* 24725 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(24770), // Rule ID 698 //
     /* 24730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexdo_h),
     /* 24738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 24741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 24751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24759 */     // (intrinsic_wo_chain:{ *:[v8f16] } 7824:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FEXDO_H:{ *:[v8f16] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXDO_H),
     /* 24762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24764 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24766 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24768 */     GIR_RootConstrainSelectedInstOperands,
     /* 24769 */     // GIR_Coverage, 698,
     /* 24769 */     GIR_EraseRootFromParent_Done,
     /* 24770 */   // Label 747: @24770
     /* 24770 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(24815), // Rule ID 699 //
     /* 24775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fexdo_w),
     /* 24783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24804 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7825:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FEXDO_W:{ *:[v4f32] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXDO_W),
     /* 24807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24809 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24811 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24813 */     GIR_RootConstrainSelectedInstOperands,
     /* 24814 */     // GIR_Coverage, 699,
     /* 24814 */     GIR_EraseRootFromParent_Done,
     /* 24815 */   // Label 748: @24815
     /* 24815 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(24860), // Rule ID 726 //
     /* 24820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_w),
     /* 24828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24849 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7851:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMAX_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_W),
     /* 24852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24854 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24856 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24858 */     GIR_RootConstrainSelectedInstOperands,
     /* 24859 */     // GIR_Coverage, 726,
     /* 24859 */     GIR_EraseRootFromParent_Done,
     /* 24860 */   // Label 749: @24860
     /* 24860 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(24905), // Rule ID 727 //
     /* 24865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_d),
     /* 24873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24894 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7850:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMAX_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_D),
     /* 24897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24899 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24901 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24903 */     GIR_RootConstrainSelectedInstOperands,
     /* 24904 */     // GIR_Coverage, 727,
     /* 24904 */     GIR_EraseRootFromParent_Done,
     /* 24905 */   // Label 750: @24905
     /* 24905 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(24950), // Rule ID 728 //
     /* 24910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_a_w),
     /* 24918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 24921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 24924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 24927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 24939 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7849:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMAX_A_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 24939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_A_W),
     /* 24942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24944 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24946 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24948 */     GIR_RootConstrainSelectedInstOperands,
     /* 24949 */     // GIR_Coverage, 728,
     /* 24949 */     GIR_EraseRootFromParent_Done,
     /* 24950 */   // Label 751: @24950
     /* 24950 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(24995), // Rule ID 729 //
     /* 24955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 24958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmax_a_d),
     /* 24963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 24966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 24969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 24972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 24984 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7848:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMAX_A_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 24984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMAX_A_D),
     /* 24987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 24989 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 24991 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 24993 */     GIR_RootConstrainSelectedInstOperands,
     /* 24994 */     // GIR_Coverage, 729,
     /* 24994 */     GIR_EraseRootFromParent_Done,
     /* 24995 */   // Label 752: @24995
     /* 24995 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(25040), // Rule ID 730 //
     /* 25000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_w),
     /* 25008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25029 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7855:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMIN_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_W),
     /* 25032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25034 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25036 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25038 */     GIR_RootConstrainSelectedInstOperands,
     /* 25039 */     // GIR_Coverage, 730,
     /* 25039 */     GIR_EraseRootFromParent_Done,
     /* 25040 */   // Label 753: @25040
     /* 25040 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(25085), // Rule ID 731 //
     /* 25045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_d),
     /* 25053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25074 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7854:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMIN_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_D),
     /* 25077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25079 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25081 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25083 */     GIR_RootConstrainSelectedInstOperands,
     /* 25084 */     // GIR_Coverage, 731,
     /* 25084 */     GIR_EraseRootFromParent_Done,
     /* 25085 */   // Label 754: @25085
     /* 25085 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(25130), // Rule ID 732 //
     /* 25090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_a_w),
     /* 25098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25119 */     // (intrinsic_wo_chain:{ *:[v4f32] } 7853:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMIN_A_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_A_W),
     /* 25122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25124 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25126 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25128 */     GIR_RootConstrainSelectedInstOperands,
     /* 25129 */     // GIR_Coverage, 732,
     /* 25129 */     GIR_EraseRootFromParent_Done,
     /* 25130 */   // Label 755: @25130
     /* 25130 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(25175), // Rule ID 733 //
     /* 25135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fmin_a_d),
     /* 25143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25164 */     // (intrinsic_wo_chain:{ *:[v2f64] } 7852:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMIN_A_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMIN_A_D),
     /* 25167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25169 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25171 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25173 */     GIR_RootConstrainSelectedInstOperands,
     /* 25174 */     // GIR_Coverage, 733,
     /* 25174 */     GIR_EraseRootFromParent_Done,
     /* 25175 */   // Label 756: @25175
     /* 25175 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(25220), // Rule ID 744 //
     /* 25180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsaf_w),
     /* 25188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25209 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7867:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSAF_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSAF_W),
     /* 25212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25214 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25216 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25218 */     GIR_RootConstrainSelectedInstOperands,
     /* 25219 */     // GIR_Coverage, 744,
     /* 25219 */     GIR_EraseRootFromParent_Done,
     /* 25220 */   // Label 757: @25220
     /* 25220 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(25265), // Rule ID 745 //
     /* 25225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsaf_d),
     /* 25233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25254 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7866:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSAF_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSAF_D),
     /* 25257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25259 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25261 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25263 */     GIR_RootConstrainSelectedInstOperands,
     /* 25264 */     // GIR_Coverage, 745,
     /* 25264 */     GIR_EraseRootFromParent_Done,
     /* 25265 */   // Label 758: @25265
     /* 25265 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(25310), // Rule ID 746 //
     /* 25270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fseq_w),
     /* 25278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25299 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7869:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSEQ_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSEQ_W),
     /* 25302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25304 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25306 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25308 */     GIR_RootConstrainSelectedInstOperands,
     /* 25309 */     // GIR_Coverage, 746,
     /* 25309 */     GIR_EraseRootFromParent_Done,
     /* 25310 */   // Label 759: @25310
     /* 25310 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(25355), // Rule ID 747 //
     /* 25315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fseq_d),
     /* 25323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25344 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7868:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSEQ_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSEQ_D),
     /* 25347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25349 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25351 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25353 */     GIR_RootConstrainSelectedInstOperands,
     /* 25354 */     // GIR_Coverage, 747,
     /* 25354 */     GIR_EraseRootFromParent_Done,
     /* 25355 */   // Label 760: @25355
     /* 25355 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(25400), // Rule ID 748 //
     /* 25360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsle_w),
     /* 25368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25389 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7871:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSLE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLE_W),
     /* 25392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25394 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25396 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25398 */     GIR_RootConstrainSelectedInstOperands,
     /* 25399 */     // GIR_Coverage, 748,
     /* 25399 */     GIR_EraseRootFromParent_Done,
     /* 25400 */   // Label 761: @25400
     /* 25400 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(25445), // Rule ID 749 //
     /* 25405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsle_d),
     /* 25413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25434 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7870:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSLE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLE_D),
     /* 25437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25439 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25441 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25443 */     GIR_RootConstrainSelectedInstOperands,
     /* 25444 */     // GIR_Coverage, 749,
     /* 25444 */     GIR_EraseRootFromParent_Done,
     /* 25445 */   // Label 762: @25445
     /* 25445 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(25490), // Rule ID 750 //
     /* 25450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fslt_w),
     /* 25458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7873:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSLT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLT_W),
     /* 25482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25484 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25486 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25488 */     GIR_RootConstrainSelectedInstOperands,
     /* 25489 */     // GIR_Coverage, 750,
     /* 25489 */     GIR_EraseRootFromParent_Done,
     /* 25490 */   // Label 763: @25490
     /* 25490 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(25535), // Rule ID 751 //
     /* 25495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fslt_d),
     /* 25503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25524 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7872:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSLT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSLT_D),
     /* 25527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25529 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25531 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25533 */     GIR_RootConstrainSelectedInstOperands,
     /* 25534 */     // GIR_Coverage, 751,
     /* 25534 */     GIR_EraseRootFromParent_Done,
     /* 25535 */   // Label 764: @25535
     /* 25535 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(25580), // Rule ID 752 //
     /* 25540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsne_w),
     /* 25548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25569 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7875:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSNE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSNE_W),
     /* 25572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25574 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25576 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25578 */     GIR_RootConstrainSelectedInstOperands,
     /* 25579 */     // GIR_Coverage, 752,
     /* 25579 */     GIR_EraseRootFromParent_Done,
     /* 25580 */   // Label 765: @25580
     /* 25580 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(25625), // Rule ID 753 //
     /* 25585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsne_d),
     /* 25593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25614 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7874:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSNE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSNE_D),
     /* 25617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25619 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25621 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25623 */     GIR_RootConstrainSelectedInstOperands,
     /* 25624 */     // GIR_Coverage, 753,
     /* 25624 */     GIR_EraseRootFromParent_Done,
     /* 25625 */   // Label 766: @25625
     /* 25625 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(25670), // Rule ID 754 //
     /* 25630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsor_w),
     /* 25638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25659 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7877:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSOR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSOR_W),
     /* 25662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25664 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25666 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25668 */     GIR_RootConstrainSelectedInstOperands,
     /* 25669 */     // GIR_Coverage, 754,
     /* 25669 */     GIR_EraseRootFromParent_Done,
     /* 25670 */   // Label 767: @25670
     /* 25670 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(25715), // Rule ID 755 //
     /* 25675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsor_d),
     /* 25683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25704 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7876:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSOR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSOR_D),
     /* 25707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25709 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25711 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25713 */     GIR_RootConstrainSelectedInstOperands,
     /* 25714 */     // GIR_Coverage, 755,
     /* 25714 */     GIR_EraseRootFromParent_Done,
     /* 25715 */   // Label 768: @25715
     /* 25715 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(25760), // Rule ID 760 //
     /* 25720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsueq_w),
     /* 25728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25749 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7883:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUEQ_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUEQ_W),
     /* 25752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25754 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25756 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25758 */     GIR_RootConstrainSelectedInstOperands,
     /* 25759 */     // GIR_Coverage, 760,
     /* 25759 */     GIR_EraseRootFromParent_Done,
     /* 25760 */   // Label 769: @25760
     /* 25760 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(25805), // Rule ID 761 //
     /* 25765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsueq_d),
     /* 25773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25794 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7882:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUEQ_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUEQ_D),
     /* 25797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25799 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25801 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25803 */     GIR_RootConstrainSelectedInstOperands,
     /* 25804 */     // GIR_Coverage, 761,
     /* 25804 */     GIR_EraseRootFromParent_Done,
     /* 25805 */   // Label 770: @25805
     /* 25805 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(25850), // Rule ID 762 //
     /* 25810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsule_w),
     /* 25818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25839 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7885:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSULE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULE_W),
     /* 25842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25844 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25846 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25848 */     GIR_RootConstrainSelectedInstOperands,
     /* 25849 */     // GIR_Coverage, 762,
     /* 25849 */     GIR_EraseRootFromParent_Done,
     /* 25850 */   // Label 771: @25850
     /* 25850 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(25895), // Rule ID 763 //
     /* 25855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsule_d),
     /* 25863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25884 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7884:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSULE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULE_D),
     /* 25887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25889 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25891 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25893 */     GIR_RootConstrainSelectedInstOperands,
     /* 25894 */     // GIR_Coverage, 763,
     /* 25894 */     GIR_EraseRootFromParent_Done,
     /* 25895 */   // Label 772: @25895
     /* 25895 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(25940), // Rule ID 764 //
     /* 25900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsult_w),
     /* 25908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 25911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 25914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 25917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 25929 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7887:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSULT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 25929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULT_W),
     /* 25932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25934 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25936 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25938 */     GIR_RootConstrainSelectedInstOperands,
     /* 25939 */     // GIR_Coverage, 764,
     /* 25939 */     GIR_EraseRootFromParent_Done,
     /* 25940 */   // Label 773: @25940
     /* 25940 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(25985), // Rule ID 765 //
     /* 25945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsult_d),
     /* 25953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 25956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 25959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 25962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 25974 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7886:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSULT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 25974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSULT_D),
     /* 25977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 25979 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 25981 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 25983 */     GIR_RootConstrainSelectedInstOperands,
     /* 25984 */     // GIR_Coverage, 765,
     /* 25984 */     GIR_EraseRootFromParent_Done,
     /* 25985 */   // Label 774: @25985
     /* 25985 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(26030), // Rule ID 766 //
     /* 25990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 25993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsun_w),
     /* 25998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26019 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7889:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUN_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUN_W),
     /* 26022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26024 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26026 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26028 */     GIR_RootConstrainSelectedInstOperands,
     /* 26029 */     // GIR_Coverage, 766,
     /* 26029 */     GIR_EraseRootFromParent_Done,
     /* 26030 */   // Label 775: @26030
     /* 26030 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(26075), // Rule ID 767 //
     /* 26035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsun_d),
     /* 26043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26064 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7888:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUN_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUN_D),
     /* 26067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26069 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26071 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26073 */     GIR_RootConstrainSelectedInstOperands,
     /* 26074 */     // GIR_Coverage, 767,
     /* 26074 */     GIR_EraseRootFromParent_Done,
     /* 26075 */   // Label 776: @26075
     /* 26075 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(26120), // Rule ID 768 //
     /* 26080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsune_w),
     /* 26088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26109 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7891:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUNE_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUNE_W),
     /* 26112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26114 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26116 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26118 */     GIR_RootConstrainSelectedInstOperands,
     /* 26119 */     // GIR_Coverage, 768,
     /* 26119 */     GIR_EraseRootFromParent_Done,
     /* 26120 */   // Label 777: @26120
     /* 26120 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(26165), // Rule ID 769 //
     /* 26125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_fsune_d),
     /* 26133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26154 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7890:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUNE_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUNE_D),
     /* 26157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26159 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26161 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26163 */     GIR_RootConstrainSelectedInstOperands,
     /* 26164 */     // GIR_Coverage, 769,
     /* 26164 */     GIR_EraseRootFromParent_Done,
     /* 26165 */   // Label 778: @26165
     /* 26165 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(26210), // Rule ID 774 //
     /* 26170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftq_h),
     /* 26178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26199 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7896:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FTQ_H:{ *:[v8i16] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 26199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTQ_H),
     /* 26202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26204 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26206 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26208 */     GIR_RootConstrainSelectedInstOperands,
     /* 26209 */     // GIR_Coverage, 774,
     /* 26209 */     GIR_EraseRootFromParent_Done,
     /* 26210 */   // Label 779: @26210
     /* 26210 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(26255), // Rule ID 775 //
     /* 26215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ftq_w),
     /* 26223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26244 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7897:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FTQ_W:{ *:[v4i32] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 26244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FTQ_W),
     /* 26247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26249 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26251 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26253 */     GIR_RootConstrainSelectedInstOperands,
     /* 26254 */     // GIR_Coverage, 775,
     /* 26254 */     GIR_EraseRootFromParent_Done,
     /* 26255 */   // Label 780: @26255
     /* 26255 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(26300), // Rule ID 780 //
     /* 26260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_h),
     /* 26268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26289 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7903:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HADD_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_H),
     /* 26292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26294 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26296 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26298 */     GIR_RootConstrainSelectedInstOperands,
     /* 26299 */     // GIR_Coverage, 780,
     /* 26299 */     GIR_EraseRootFromParent_Done,
     /* 26300 */   // Label 781: @26300
     /* 26300 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(26345), // Rule ID 781 //
     /* 26305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_w),
     /* 26313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26334 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7904:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HADD_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_W),
     /* 26337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26339 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26341 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26343 */     GIR_RootConstrainSelectedInstOperands,
     /* 26344 */     // GIR_Coverage, 781,
     /* 26344 */     GIR_EraseRootFromParent_Done,
     /* 26345 */   // Label 782: @26345
     /* 26345 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(26390), // Rule ID 782 //
     /* 26350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_s_d),
     /* 26358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26379 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7902:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HADD_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_S_D),
     /* 26382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26384 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26386 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26388 */     GIR_RootConstrainSelectedInstOperands,
     /* 26389 */     // GIR_Coverage, 782,
     /* 26389 */     GIR_EraseRootFromParent_Done,
     /* 26390 */   // Label 783: @26390
     /* 26390 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(26435), // Rule ID 783 //
     /* 26395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_h),
     /* 26403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26424 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7906:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HADD_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_H),
     /* 26427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26429 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26431 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26433 */     GIR_RootConstrainSelectedInstOperands,
     /* 26434 */     // GIR_Coverage, 783,
     /* 26434 */     GIR_EraseRootFromParent_Done,
     /* 26435 */   // Label 784: @26435
     /* 26435 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(26480), // Rule ID 784 //
     /* 26440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_w),
     /* 26448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26469 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7907:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HADD_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_W),
     /* 26472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26474 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26476 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26478 */     GIR_RootConstrainSelectedInstOperands,
     /* 26479 */     // GIR_Coverage, 784,
     /* 26479 */     GIR_EraseRootFromParent_Done,
     /* 26480 */   // Label 785: @26480
     /* 26480 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(26525), // Rule ID 785 //
     /* 26485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hadd_u_d),
     /* 26493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26514 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7905:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HADD_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HADD_U_D),
     /* 26517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26519 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26521 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26523 */     GIR_RootConstrainSelectedInstOperands,
     /* 26524 */     // GIR_Coverage, 785,
     /* 26524 */     GIR_EraseRootFromParent_Done,
     /* 26525 */   // Label 786: @26525
     /* 26525 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(26570), // Rule ID 786 //
     /* 26530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_h),
     /* 26538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26559 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7909:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HSUB_S_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_H),
     /* 26562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26564 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26566 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26568 */     GIR_RootConstrainSelectedInstOperands,
     /* 26569 */     // GIR_Coverage, 786,
     /* 26569 */     GIR_EraseRootFromParent_Done,
     /* 26570 */   // Label 787: @26570
     /* 26570 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(26615), // Rule ID 787 //
     /* 26575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_w),
     /* 26583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26604 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7910:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HSUB_S_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_W),
     /* 26607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26609 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26611 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26613 */     GIR_RootConstrainSelectedInstOperands,
     /* 26614 */     // GIR_Coverage, 787,
     /* 26614 */     GIR_EraseRootFromParent_Done,
     /* 26615 */   // Label 788: @26615
     /* 26615 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(26660), // Rule ID 788 //
     /* 26620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_s_d),
     /* 26628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26649 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7908:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HSUB_S_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_S_D),
     /* 26652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26654 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26656 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26658 */     GIR_RootConstrainSelectedInstOperands,
     /* 26659 */     // GIR_Coverage, 788,
     /* 26659 */     GIR_EraseRootFromParent_Done,
     /* 26660 */   // Label 789: @26660
     /* 26660 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(26705), // Rule ID 789 //
     /* 26665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_h),
     /* 26673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26694 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7912:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (HSUB_U_H:{ *:[v8i16] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_H),
     /* 26697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26699 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26701 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26703 */     GIR_RootConstrainSelectedInstOperands,
     /* 26704 */     // GIR_Coverage, 789,
     /* 26704 */     GIR_EraseRootFromParent_Done,
     /* 26705 */   // Label 790: @26705
     /* 26705 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(26750), // Rule ID 790 //
     /* 26710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_w),
     /* 26718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26739 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7913:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (HSUB_U_W:{ *:[v4i32] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_W),
     /* 26742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26744 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26746 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26748 */     GIR_RootConstrainSelectedInstOperands,
     /* 26749 */     // GIR_Coverage, 790,
     /* 26749 */     GIR_EraseRootFromParent_Done,
     /* 26750 */   // Label 791: @26750
     /* 26750 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(26795), // Rule ID 791 //
     /* 26755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_hsub_u_d),
     /* 26763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26784 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7911:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (HSUB_U_D:{ *:[v2i64] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::HSUB_U_D),
     /* 26787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26789 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26791 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26793 */     GIR_RootConstrainSelectedInstOperands,
     /* 26794 */     // GIR_Coverage, 791,
     /* 26794 */     GIR_EraseRootFromParent_Done,
     /* 26795 */   // Label 792: @26795
     /* 26795 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(26840), // Rule ID 844 //
     /* 26800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_b),
     /* 26808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 26811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 26829 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7967:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 26829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_B),
     /* 26832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26834 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26836 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26838 */     GIR_RootConstrainSelectedInstOperands,
     /* 26839 */     // GIR_Coverage, 844,
     /* 26839 */     GIR_EraseRootFromParent_Done,
     /* 26840 */   // Label 793: @26840
     /* 26840 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(26885), // Rule ID 845 //
     /* 26845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_h),
     /* 26853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 26856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 26859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 26862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 26874 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7969:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 26874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_H),
     /* 26877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26879 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26881 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26883 */     GIR_RootConstrainSelectedInstOperands,
     /* 26884 */     // GIR_Coverage, 845,
     /* 26884 */     GIR_EraseRootFromParent_Done,
     /* 26885 */   // Label 794: @26885
     /* 26885 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(26930), // Rule ID 846 //
     /* 26890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_w),
     /* 26898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 26901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 26904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 26907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 26919 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7970:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 26919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_W),
     /* 26922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26924 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26926 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26928 */     GIR_RootConstrainSelectedInstOperands,
     /* 26929 */     // GIR_Coverage, 846,
     /* 26929 */     GIR_EraseRootFromParent_Done,
     /* 26930 */   // Label 795: @26930
     /* 26930 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(26975), // Rule ID 847 //
     /* 26935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_max_a_d),
     /* 26943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 26946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 26949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 26952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 26964 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7968:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 26964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MAX_A_D),
     /* 26967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 26969 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 26971 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 26973 */     GIR_RootConstrainSelectedInstOperands,
     /* 26974 */     // GIR_Coverage, 847,
     /* 26974 */     GIR_EraseRootFromParent_Done,
     /* 26975 */   // Label 796: @26975
     /* 26975 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(27020), // Rule ID 864 //
     /* 26980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 26983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_b),
     /* 26988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 26991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 26994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 26997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27009 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7987:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_A_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_B),
     /* 27012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27014 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27016 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27018 */     GIR_RootConstrainSelectedInstOperands,
     /* 27019 */     // GIR_Coverage, 864,
     /* 27019 */     GIR_EraseRootFromParent_Done,
     /* 27020 */   // Label 797: @27020
     /* 27020 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(27065), // Rule ID 865 //
     /* 27025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_h),
     /* 27033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27054 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7989:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_A_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_H),
     /* 27057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27059 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27061 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27063 */     GIR_RootConstrainSelectedInstOperands,
     /* 27064 */     // GIR_Coverage, 865,
     /* 27064 */     GIR_EraseRootFromParent_Done,
     /* 27065 */   // Label 798: @27065
     /* 27065 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(27110), // Rule ID 866 //
     /* 27070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_w),
     /* 27078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27099 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7990:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_A_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_W),
     /* 27102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27104 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27106 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27108 */     GIR_RootConstrainSelectedInstOperands,
     /* 27109 */     // GIR_Coverage, 866,
     /* 27109 */     GIR_EraseRootFromParent_Done,
     /* 27110 */   // Label 799: @27110
     /* 27110 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(27155), // Rule ID 867 //
     /* 27115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_min_a_d),
     /* 27123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27144 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7988:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_A_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_A_D),
     /* 27147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27149 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27151 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27153 */     GIR_RootConstrainSelectedInstOperands,
     /* 27154 */     // GIR_Coverage, 867,
     /* 27154 */     GIR_EraseRootFromParent_Done,
     /* 27155 */   // Label 800: @27155
     /* 27155 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(27200), // Rule ID 900 //
     /* 27160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_q_h),
     /* 27168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27189 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8029:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MUL_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_Q_H),
     /* 27192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27194 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27196 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27198 */     GIR_RootConstrainSelectedInstOperands,
     /* 27199 */     // GIR_Coverage, 900,
     /* 27199 */     GIR_EraseRootFromParent_Done,
     /* 27200 */   // Label 801: @27200
     /* 27200 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(27245), // Rule ID 901 //
     /* 27205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_q_w),
     /* 27213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27234 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8030:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MUL_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_Q_W),
     /* 27237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27239 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27241 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27243 */     GIR_RootConstrainSelectedInstOperands,
     /* 27244 */     // GIR_Coverage, 901,
     /* 27244 */     GIR_EraseRootFromParent_Done,
     /* 27245 */   // Label 802: @27245
     /* 27245 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(27290), // Rule ID 902 //
     /* 27250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulr_q_h),
     /* 27258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27279 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8040:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MULR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULR_Q_H),
     /* 27282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27284 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27286 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27288 */     GIR_RootConstrainSelectedInstOperands,
     /* 27289 */     // GIR_Coverage, 902,
     /* 27289 */     GIR_EraseRootFromParent_Done,
     /* 27290 */   // Label 803: @27290
     /* 27290 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(27335), // Rule ID 903 //
     /* 27295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulr_q_w),
     /* 27303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27324 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8041:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MULR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULR_Q_W),
     /* 27327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27329 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27331 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27333 */     GIR_RootConstrainSelectedInstOperands,
     /* 27334 */     // GIR_Coverage, 903,
     /* 27334 */     GIR_EraseRootFromParent_Done,
     /* 27335 */   // Label 804: @27335
     /* 27335 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(27380), // Rule ID 981 //
     /* 27340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_b),
     /* 27348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27369 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8154:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRAR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_B),
     /* 27372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27374 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27376 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27378 */     GIR_RootConstrainSelectedInstOperands,
     /* 27379 */     // GIR_Coverage, 981,
     /* 27379 */     GIR_EraseRootFromParent_Done,
     /* 27380 */   // Label 805: @27380
     /* 27380 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(27425), // Rule ID 982 //
     /* 27385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_h),
     /* 27393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27414 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8156:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRAR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_H),
     /* 27417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27419 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27421 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27423 */     GIR_RootConstrainSelectedInstOperands,
     /* 27424 */     // GIR_Coverage, 982,
     /* 27424 */     GIR_EraseRootFromParent_Done,
     /* 27425 */   // Label 806: @27425
     /* 27425 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(27470), // Rule ID 983 //
     /* 27430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_w),
     /* 27438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27459 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8157:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRAR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_W),
     /* 27462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27464 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27466 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27468 */     GIR_RootConstrainSelectedInstOperands,
     /* 27469 */     // GIR_Coverage, 983,
     /* 27469 */     GIR_EraseRootFromParent_Done,
     /* 27470 */   // Label 807: @27470
     /* 27470 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(27515), // Rule ID 984 //
     /* 27475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srar_d),
     /* 27483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27504 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8155:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRAR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRAR_D),
     /* 27507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27509 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27511 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27513 */     GIR_RootConstrainSelectedInstOperands,
     /* 27514 */     // GIR_Coverage, 984,
     /* 27514 */     GIR_EraseRootFromParent_Done,
     /* 27515 */   // Label 808: @27515
     /* 27515 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(27560), // Rule ID 997 //
     /* 27520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_b),
     /* 27528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27549 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8170:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRLR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_B),
     /* 27552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27554 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27556 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27558 */     GIR_RootConstrainSelectedInstOperands,
     /* 27559 */     // GIR_Coverage, 997,
     /* 27559 */     GIR_EraseRootFromParent_Done,
     /* 27560 */   // Label 809: @27560
     /* 27560 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(27605), // Rule ID 998 //
     /* 27565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_h),
     /* 27573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27594 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8172:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRLR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_H),
     /* 27597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27599 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27601 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27603 */     GIR_RootConstrainSelectedInstOperands,
     /* 27604 */     // GIR_Coverage, 998,
     /* 27604 */     GIR_EraseRootFromParent_Done,
     /* 27605 */   // Label 810: @27605
     /* 27605 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(27650), // Rule ID 999 //
     /* 27610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_w),
     /* 27618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27639 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8173:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRLR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_W),
     /* 27642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27644 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27646 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27648 */     GIR_RootConstrainSelectedInstOperands,
     /* 27649 */     // GIR_Coverage, 999,
     /* 27649 */     GIR_EraseRootFromParent_Done,
     /* 27650 */   // Label 811: @27650
     /* 27650 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(27695), // Rule ID 1000 //
     /* 27655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_srlr_d),
     /* 27663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27684 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8171:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRLR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRLR_D),
     /* 27687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27689 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27691 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27693 */     GIR_RootConstrainSelectedInstOperands,
     /* 27694 */     // GIR_Coverage, 1000,
     /* 27694 */     GIR_EraseRootFromParent_Done,
     /* 27695 */   // Label 812: @27695
     /* 27695 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(27740), // Rule ID 1009 //
     /* 27700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_b),
     /* 27708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27729 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8191:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBS_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_B),
     /* 27732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27734 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27736 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27738 */     GIR_RootConstrainSelectedInstOperands,
     /* 27739 */     // GIR_Coverage, 1009,
     /* 27739 */     GIR_EraseRootFromParent_Done,
     /* 27740 */   // Label 813: @27740
     /* 27740 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(27785), // Rule ID 1010 //
     /* 27745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_h),
     /* 27753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27774 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8193:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBS_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_H),
     /* 27777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27779 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27781 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27783 */     GIR_RootConstrainSelectedInstOperands,
     /* 27784 */     // GIR_Coverage, 1010,
     /* 27784 */     GIR_EraseRootFromParent_Done,
     /* 27785 */   // Label 814: @27785
     /* 27785 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(27830), // Rule ID 1011 //
     /* 27790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_w),
     /* 27798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27819 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8194:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBS_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_W),
     /* 27822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27824 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27826 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27828 */     GIR_RootConstrainSelectedInstOperands,
     /* 27829 */     // GIR_Coverage, 1011,
     /* 27829 */     GIR_EraseRootFromParent_Done,
     /* 27830 */   // Label 815: @27830
     /* 27830 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(27875), // Rule ID 1012 //
     /* 27835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_s_d),
     /* 27843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 27846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 27849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 27852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 27864 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8192:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBS_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 27864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_S_D),
     /* 27867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27869 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27871 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27873 */     GIR_RootConstrainSelectedInstOperands,
     /* 27874 */     // GIR_Coverage, 1012,
     /* 27874 */     GIR_EraseRootFromParent_Done,
     /* 27875 */   // Label 816: @27875
     /* 27875 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(27920), // Rule ID 1013 //
     /* 27880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_b),
     /* 27888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 27891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 27894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 27897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 27909 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8195:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 27909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_B),
     /* 27912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27914 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27916 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27918 */     GIR_RootConstrainSelectedInstOperands,
     /* 27919 */     // GIR_Coverage, 1013,
     /* 27919 */     GIR_EraseRootFromParent_Done,
     /* 27920 */   // Label 817: @27920
     /* 27920 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(27965), // Rule ID 1014 //
     /* 27925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_h),
     /* 27933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 27936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 27939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 27942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 27954 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8197:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 27954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_H),
     /* 27957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 27959 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 27961 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 27963 */     GIR_RootConstrainSelectedInstOperands,
     /* 27964 */     // GIR_Coverage, 1014,
     /* 27964 */     GIR_EraseRootFromParent_Done,
     /* 27965 */   // Label 818: @27965
     /* 27965 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(28010), // Rule ID 1015 //
     /* 27970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 27973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_w),
     /* 27978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 27981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 27984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 27987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 27999 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8198:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 27999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_W),
     /* 28002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28004 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28006 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28008 */     GIR_RootConstrainSelectedInstOperands,
     /* 28009 */     // GIR_Coverage, 1015,
     /* 28009 */     GIR_EraseRootFromParent_Done,
     /* 28010 */   // Label 819: @28010
     /* 28010 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(28055), // Rule ID 1016 //
     /* 28015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subs_u_d),
     /* 28023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28044 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8196:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBS_U_D),
     /* 28047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28049 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28051 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28053 */     GIR_RootConstrainSelectedInstOperands,
     /* 28054 */     // GIR_Coverage, 1016,
     /* 28054 */     GIR_EraseRootFromParent_Done,
     /* 28055 */   // Label 820: @28055
     /* 28055 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(28100), // Rule ID 1017 //
     /* 28060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_b),
     /* 28068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 28071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 28077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28089 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8199:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBSUS_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 28089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_B),
     /* 28092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28094 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28096 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28098 */     GIR_RootConstrainSelectedInstOperands,
     /* 28099 */     // GIR_Coverage, 1017,
     /* 28099 */     GIR_EraseRootFromParent_Done,
     /* 28100 */   // Label 821: @28100
     /* 28100 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(28145), // Rule ID 1018 //
     /* 28105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_h),
     /* 28113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 28122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28134 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8201:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBSUS_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 28134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_H),
     /* 28137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28139 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28141 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28143 */     GIR_RootConstrainSelectedInstOperands,
     /* 28144 */     // GIR_Coverage, 1018,
     /* 28144 */     GIR_EraseRootFromParent_Done,
     /* 28145 */   // Label 822: @28145
     /* 28145 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(28190), // Rule ID 1019 //
     /* 28150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_w),
     /* 28158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28179 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8202:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBSUS_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_W),
     /* 28182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28184 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28186 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28188 */     GIR_RootConstrainSelectedInstOperands,
     /* 28189 */     // GIR_Coverage, 1019,
     /* 28189 */     GIR_EraseRootFromParent_Done,
     /* 28190 */   // Label 823: @28190
     /* 28190 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(28235), // Rule ID 1020 //
     /* 28195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsus_u_d),
     /* 28203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28224 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8200:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBSUS_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUS_U_D),
     /* 28227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28229 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28231 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28233 */     GIR_RootConstrainSelectedInstOperands,
     /* 28234 */     // GIR_Coverage, 1020,
     /* 28234 */     GIR_EraseRootFromParent_Done,
     /* 28235 */   // Label 824: @28235
     /* 28235 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(28280), // Rule ID 1021 //
     /* 28240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_b),
     /* 28248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 28251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 28254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 28257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 28269 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8203:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SUBSUU_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 28269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_B),
     /* 28272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28274 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28276 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28278 */     GIR_RootConstrainSelectedInstOperands,
     /* 28279 */     // GIR_Coverage, 1021,
     /* 28279 */     GIR_EraseRootFromParent_Done,
     /* 28280 */   // Label 825: @28280
     /* 28280 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(28325), // Rule ID 1022 //
     /* 28285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_h),
     /* 28293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 28296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 28299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 28302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 28314 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8205:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SUBSUU_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 28314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_H),
     /* 28317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28319 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28321 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28323 */     GIR_RootConstrainSelectedInstOperands,
     /* 28324 */     // GIR_Coverage, 1022,
     /* 28324 */     GIR_EraseRootFromParent_Done,
     /* 28325 */   // Label 826: @28325
     /* 28325 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(28370), // Rule ID 1023 //
     /* 28330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_w),
     /* 28338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 28341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 28344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 28347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 28359 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8206:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SUBSUU_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 28359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_W),
     /* 28362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28364 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28366 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28368 */     GIR_RootConstrainSelectedInstOperands,
     /* 28369 */     // GIR_Coverage, 1023,
     /* 28369 */     GIR_EraseRootFromParent_Done,
     /* 28370 */   // Label 827: @28370
     /* 28370 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(28415), // Rule ID 1024 //
     /* 28375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 28378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subsuu_s_d),
     /* 28383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 28386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 28389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 28392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 28404 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8204:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SUBSUU_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 28404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBSUU_S_D),
     /* 28407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 28409 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 28411 */     GIR_RootToRootCopy, /*OpIdx*/3, // wt
     /* 28413 */     GIR_RootConstrainSelectedInstOperands,
     /* 28414 */     // GIR_Coverage, 1024,
     /* 28414 */     GIR_EraseRootFromParent_Done,
     /* 28415 */   // Label 828: @28415
     /* 28415 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(28463), // Rule ID 1223 //
     /* 28420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_ph),
     /* 28428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28449 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7565:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_PH_MM),
     /* 28452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28461 */     GIR_RootConstrainSelectedInstOperands,
     /* 28462 */     // GIR_Coverage, 1223,
     /* 28462 */     GIR_EraseRootFromParent_Done,
     /* 28463 */   // Label 829: @28463
     /* 28463 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(28511), // Rule ID 1225 //
     /* 28468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_qb),
     /* 28476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 28485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28497 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7587:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDU_S_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 28497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_QB_MM),
     /* 28500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28509 */     GIR_RootConstrainSelectedInstOperands,
     /* 28510 */     // GIR_Coverage, 1225,
     /* 28510 */     GIR_EraseRootFromParent_Done,
     /* 28511 */   // Label 830: @28511
     /* 28511 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(28556), // Rule ID 1246 //
     /* 28516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_ph),
     /* 28524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28545 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8115:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_PH_MM),
     /* 28548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28554 */     GIR_RootConstrainSelectedInstOperands,
     /* 28555 */     // GIR_Coverage, 1246,
     /* 28555 */     GIR_EraseRootFromParent_Done,
     /* 28556 */   // Label 831: @28556
     /* 28556 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(28601), // Rule ID 1247 //
     /* 28561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_ph),
     /* 28569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28590 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8117:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_PH_MM),
     /* 28593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28599 */     GIR_RootConstrainSelectedInstOperands,
     /* 28600 */     // GIR_Coverage, 1247,
     /* 28600 */     GIR_EraseRootFromParent_Done,
     /* 28601 */   // Label 832: @28601
     /* 28601 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(28646), // Rule ID 1248 //
     /* 28606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_w),
     /* 28614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 28617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28635 */     // (intrinsic_wo_chain:{ *:[i32] } 8119:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_W_MM),
     /* 28638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28644 */     GIR_RootConstrainSelectedInstOperands,
     /* 28645 */     // GIR_Coverage, 1248,
     /* 28645 */     GIR_EraseRootFromParent_Done,
     /* 28646 */   // Label 833: @28646
     /* 28646 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(28691), // Rule ID 1250 //
     /* 28651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_qb),
     /* 28659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28680 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8121:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRLV_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 28680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_QB_MM),
     /* 28683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 28687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 28689 */     GIR_RootConstrainSelectedInstOperands,
     /* 28690 */     // GIR_Coverage, 1250,
     /* 28690 */     GIR_EraseRootFromParent_Done,
     /* 28691 */   // Label 834: @28691
     /* 28691 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(28739), // Rule ID 1261 //
     /* 28696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_ph),
     /* 28704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28725 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8185:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_PH_MM),
     /* 28728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28737 */     GIR_RootConstrainSelectedInstOperands,
     /* 28738 */     // GIR_Coverage, 1261,
     /* 28738 */     GIR_EraseRootFromParent_Done,
     /* 28739 */   // Label 835: @28739
     /* 28739 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(28787), // Rule ID 1263 //
     /* 28744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_qb),
     /* 28752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 28758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 28761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28773 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8210:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBU_S_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 28773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_QB_MM),
     /* 28776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 28785 */     GIR_RootConstrainSelectedInstOperands,
     /* 28786 */     // GIR_Coverage, 1263,
     /* 28786 */     GIR_EraseRootFromParent_Done,
     /* 28787 */   // Label 836: @28787
     /* 28787 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(28832), // Rule ID 1273 //
     /* 28792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_ph_w),
     /* 28800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28821 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8090:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_PH_W_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 28821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_PH_W_MM),
     /* 28824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28830 */     GIR_RootConstrainSelectedInstOperands,
     /* 28831 */     // GIR_Coverage, 1273,
     /* 28831 */     GIR_EraseRootFromParent_Done,
     /* 28832 */   // Label 837: @28832
     /* 28832 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(28877), // Rule ID 1274 //
     /* 28837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_qb_ph),
     /* 28845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 28848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28866 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8091:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQ_QB_PH_MM:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_QB_PH_MM),
     /* 28869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28875 */     GIR_RootConstrainSelectedInstOperands,
     /* 28876 */     // GIR_Coverage, 1274,
     /* 28876 */     GIR_EraseRootFromParent_Done,
     /* 28877 */   // Label 838: @28877
     /* 28877 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(28922), // Rule ID 1293 //
     /* 28882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_packrl_ph),
     /* 28890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28911 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8062:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PACKRL_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 28911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PACKRL_PH_MM),
     /* 28914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28920 */     GIR_RootConstrainSelectedInstOperands,
     /* 28921 */     // GIR_Coverage, 1293,
     /* 28921 */     GIR_EraseRootFromParent_Done,
     /* 28922 */   // Label 839: @28922
     /* 28922 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(28967), // Rule ID 1299 //
     /* 28927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 28930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_modsub),
     /* 28935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 28938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 28941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 28944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 28956 */     // (intrinsic_wo_chain:{ *:[i32] } 8015:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MODSUB_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 28956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MODSUB_MM),
     /* 28959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 28961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 28963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 28965 */     GIR_RootConstrainSelectedInstOperands,
     /* 28966 */     // GIR_Coverage, 1299,
     /* 28966 */     GIR_EraseRootFromParent_Done,
     /* 28967 */   // Label 840: @28967
     /* 28967 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(29012), // Rule ID 1312 //
     /* 28972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 28975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_ph),
     /* 28980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 28983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 28986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 28989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 28997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29001 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7567:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_PH_MMR2),
     /* 29004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29010 */     GIR_RootConstrainSelectedInstOperands,
     /* 29011 */     // GIR_Coverage, 1312,
     /* 29011 */     GIR_EraseRootFromParent_Done,
     /* 29012 */   // Label 841: @29012
     /* 29012 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(29057), // Rule ID 1313 //
     /* 29017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_ph),
     /* 29025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29046 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7568:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDQH_R_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_PH_MMR2),
     /* 29049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29055 */     GIR_RootConstrainSelectedInstOperands,
     /* 29056 */     // GIR_Coverage, 1313,
     /* 29056 */     GIR_EraseRootFromParent_Done,
     /* 29057 */   // Label 842: @29057
     /* 29057 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(29102), // Rule ID 1314 //
     /* 29062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_w),
     /* 29070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29091 */     // (intrinsic_wo_chain:{ *:[i32] } 7570:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_W_MMR2),
     /* 29094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29100 */     GIR_RootConstrainSelectedInstOperands,
     /* 29101 */     // GIR_Coverage, 1314,
     /* 29101 */     GIR_EraseRootFromParent_Done,
     /* 29102 */   // Label 843: @29102
     /* 29102 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(29147), // Rule ID 1315 //
     /* 29107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addqh_r_w),
     /* 29115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29136 */     // (intrinsic_wo_chain:{ *:[i32] } 7569:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQH_R_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQH_R_W_MMR2),
     /* 29139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29145 */     GIR_RootConstrainSelectedInstOperands,
     /* 29146 */     // GIR_Coverage, 1315,
     /* 29146 */     GIR_EraseRootFromParent_Done,
     /* 29147 */   // Label 844: @29147
     /* 29147 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(29192), // Rule ID 1318 //
     /* 29152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_qb),
     /* 29160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29181 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7588:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_QB_MMR2),
     /* 29184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29190 */     GIR_RootConstrainSelectedInstOperands,
     /* 29191 */     // GIR_Coverage, 1318,
     /* 29191 */     GIR_EraseRootFromParent_Done,
     /* 29192 */   // Label 845: @29192
     /* 29192 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(29237), // Rule ID 1319 //
     /* 29197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_adduh_r_qb),
     /* 29205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29226 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7589:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ADDUH_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDUH_R_QB_MMR2),
     /* 29229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29235 */     GIR_RootConstrainSelectedInstOperands,
     /* 29236 */     // GIR_Coverage, 1319,
     /* 29236 */     GIR_EraseRootFromParent_Done,
     /* 29237 */   // Label 846: @29237
     /* 29237 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(29282), // Rule ID 1325 //
     /* 29242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_qb),
     /* 29250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29271 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8116:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_QB_MMR2),
     /* 29274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29280 */     GIR_RootConstrainSelectedInstOperands,
     /* 29281 */     // GIR_Coverage, 1325,
     /* 29281 */     GIR_EraseRootFromParent_Done,
     /* 29282 */   // Label 847: @29282
     /* 29282 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(29327), // Rule ID 1326 //
     /* 29287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shra_r_qb),
     /* 29295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29316 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8118:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRAV_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRAV_R_QB_MMR2),
     /* 29319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29325 */     GIR_RootConstrainSelectedInstOperands,
     /* 29326 */     // GIR_Coverage, 1326,
     /* 29326 */     GIR_EraseRootFromParent_Done,
     /* 29327 */   // Label 848: @29327
     /* 29327 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(29372), // Rule ID 1331 //
     /* 29332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shrl_ph),
     /* 29340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29361 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8120:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHRLV_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 29361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHRLV_PH_MMR2),
     /* 29364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 29368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29370 */     GIR_RootConstrainSelectedInstOperands,
     /* 29371 */     // GIR_Coverage, 1331,
     /* 29371 */     GIR_EraseRootFromParent_Done,
     /* 29372 */   // Label 849: @29372
     /* 29372 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(29417), // Rule ID 1332 //
     /* 29377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_ph),
     /* 29385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29406 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8187:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_PH_MMR2),
     /* 29409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29415 */     GIR_RootConstrainSelectedInstOperands,
     /* 29416 */     // GIR_Coverage, 1332,
     /* 29416 */     GIR_EraseRootFromParent_Done,
     /* 29417 */   // Label 850: @29417
     /* 29417 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(29462), // Rule ID 1333 //
     /* 29422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_ph),
     /* 29430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29451 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8188:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBQH_R_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 29451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_PH_MMR2),
     /* 29454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29460 */     GIR_RootConstrainSelectedInstOperands,
     /* 29461 */     // GIR_Coverage, 1333,
     /* 29461 */     GIR_EraseRootFromParent_Done,
     /* 29462 */   // Label 851: @29462
     /* 29462 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(29507), // Rule ID 1334 //
     /* 29467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_w),
     /* 29475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29496 */     // (intrinsic_wo_chain:{ *:[i32] } 8190:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_W_MMR2),
     /* 29499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29505 */     GIR_RootConstrainSelectedInstOperands,
     /* 29506 */     // GIR_Coverage, 1334,
     /* 29506 */     GIR_EraseRootFromParent_Done,
     /* 29507 */   // Label 852: @29507
     /* 29507 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(29552), // Rule ID 1335 //
     /* 29512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subqh_r_w),
     /* 29520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29541 */     // (intrinsic_wo_chain:{ *:[i32] } 8189:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQH_R_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 29541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQH_R_W_MMR2),
     /* 29544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29550 */     GIR_RootConstrainSelectedInstOperands,
     /* 29551 */     // GIR_Coverage, 1335,
     /* 29551 */     GIR_EraseRootFromParent_Done,
     /* 29552 */   // Label 853: @29552
     /* 29552 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(29597), // Rule ID 1338 //
     /* 29557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_qb),
     /* 29565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29586 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8211:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_QB_MMR2),
     /* 29589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29595 */     GIR_RootConstrainSelectedInstOperands,
     /* 29596 */     // GIR_Coverage, 1338,
     /* 29596 */     GIR_EraseRootFromParent_Done,
     /* 29597 */   // Label 854: @29597
     /* 29597 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(29642), // Rule ID 1339 //
     /* 29602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 29605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subuh_r_qb),
     /* 29610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29631 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8212:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (SUBUH_R_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 29631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBUH_R_QB_MMR2),
     /* 29634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 29638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 29640 */     GIR_RootConstrainSelectedInstOperands,
     /* 29641 */     // GIR_Coverage, 1339,
     /* 29641 */     GIR_EraseRootFromParent_Done,
     /* 29642 */   // Label 855: @29642
     /* 29642 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(29682), // Rule ID 1921 //
     /* 29647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_ph),
     /* 29655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29668 */     // (intrinsic_wo_chain:{ *:[v2i16] } 7564:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (ADDQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 29668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_PH),
     /* 29671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29673 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29675 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29680 */     GIR_RootConstrainSelectedInstOperands,
     /* 29681 */     // GIR_Coverage, 1921,
     /* 29681 */     GIR_EraseRootFromParent_Done,
     /* 29682 */   // Label 856: @29682
     /* 29682 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(29722), // Rule ID 1923 //
     /* 29687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_ph),
     /* 29695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 29701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 29704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29708 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8184:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (SUBQ_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 29708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_PH),
     /* 29711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29713 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29715 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29720 */     GIR_RootConstrainSelectedInstOperands,
     /* 29721 */     // GIR_Coverage, 1923,
     /* 29721 */     GIR_EraseRootFromParent_Done,
     /* 29722 */   // Label 857: @29722
     /* 29722 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(29762), // Rule ID 1927 //
     /* 29727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_qb),
     /* 29735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29748 */     // (intrinsic_wo_chain:{ *:[v4i8] } 7585:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (ADDU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /* 29748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_QB),
     /* 29751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29753 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29755 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29760 */     GIR_RootConstrainSelectedInstOperands,
     /* 29761 */     // GIR_Coverage, 1927,
     /* 29761 */     GIR_EraseRootFromParent_Done,
     /* 29762 */   // Label 858: @29762
     /* 29762 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(29802), // Rule ID 1929 //
     /* 29767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 29770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_qb),
     /* 29775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 29778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 29781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 29784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29788 */     // (intrinsic_wo_chain:{ *:[v4i8] } 8208:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)  =>  (SUBU_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, v4i8:{ *:[v4i8] }:$b)
     /* 29788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_QB),
     /* 29791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 29793 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 29795 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 29797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 29800 */     GIR_RootConstrainSelectedInstOperands,
     /* 29801 */     // GIR_Coverage, 1929,
     /* 29801 */     GIR_EraseRootFromParent_Done,
     /* 29802 */   // Label 859: @29802
     /* 29802 */   GIM_Reject,
     /* 29803 */ // Label 645: @29803
     /* 29803 */ GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(32317),
     /* 29808 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 29811 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(29866), // Rule ID 477 //
     /* 29816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_ph_w),
     /* 29824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29845 */     // MIs[0] sa
     /* 29845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29853 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8088:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_PH_W),
     /* 29856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29860 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29862 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29864 */     GIR_RootConstrainSelectedInstOperands,
     /* 29865 */     // GIR_Coverage, 477,
     /* 29865 */     GIR_EraseRootFromParent_Done,
     /* 29866 */   // Label 861: @29866
     /* 29866 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(29921), // Rule ID 478 //
     /* 29871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_r_ph_w),
     /* 29879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 29882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 29892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29900 */     // MIs[0] sa
     /* 29900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29908 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8089:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_R_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_R_PH_W),
     /* 29911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29915 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29917 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29919 */     GIR_RootConstrainSelectedInstOperands,
     /* 29920 */     // GIR_Coverage, 478,
     /* 29920 */     GIR_EraseRootFromParent_Done,
     /* 29921 */   // Label 862: @29921
     /* 29921 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(29976), // Rule ID 483 //
     /* 29926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_append),
     /* 29934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 29955 */     // MIs[0] sa
     /* 29955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 29958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 29963 */     // (intrinsic_wo_chain:{ *:[i32] } 7601:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (APPEND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 29963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::APPEND),
     /* 29966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 29968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 29970 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 29972 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 29974 */     GIR_RootConstrainSelectedInstOperands,
     /* 29975 */     // GIR_Coverage, 483,
     /* 29975 */     GIR_EraseRootFromParent_Done,
     /* 29976 */   // Label 863: @29976
     /* 29976 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(30031), // Rule ID 484 //
     /* 29981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 29984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_balign),
     /* 29989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 29992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 29995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 29998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30010 */     // MIs[0] sa
     /* 30010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt2),
     /* 30018 */     // (intrinsic_wo_chain:{ *:[i32] } 7626:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt2>>:$sa)  =>  (BALIGN:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BALIGN),
     /* 30021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30025 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30027 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30029 */     GIR_RootConstrainSelectedInstOperands,
     /* 30030 */     // GIR_Coverage, 484,
     /* 30030 */     GIR_EraseRootFromParent_Done,
     /* 30031 */   // Label 864: @30031
     /* 30031 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(30086), // Rule ID 485 //
     /* 30036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 30039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_prepend),
     /* 30044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30065 */     // MIs[0] sa
     /* 30065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30068 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30073 */     // (intrinsic_wo_chain:{ *:[i32] } 8094:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PREPEND:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PREPEND),
     /* 30076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30080 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30082 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30084 */     GIR_RootConstrainSelectedInstOperands,
     /* 30085 */     // GIR_Coverage, 485,
     /* 30085 */     GIR_EraseRootFromParent_Done,
     /* 30086 */   // Label 865: @30086
     /* 30086 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(30141), // Rule ID 953 //
     /* 30091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_b),
     /* 30099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30120 */     // MIs[0] n
     /* 30120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt4),
     /* 30128 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8126:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt4>>:$n)  =>  (SLDI_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_B),
     /* 30131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30133 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30135 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30137 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30139 */     GIR_RootConstrainSelectedInstOperands,
     /* 30140 */     // GIR_Coverage, 953,
     /* 30140 */     GIR_EraseRootFromParent_Done,
     /* 30141 */   // Label 866: @30141
     /* 30141 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(30196), // Rule ID 954 //
     /* 30146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_h),
     /* 30154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30175 */     // MIs[0] n
     /* 30175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt3),
     /* 30183 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8128:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt3>>:$n)  =>  (SLDI_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_H),
     /* 30186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30188 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30190 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30192 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30194 */     GIR_RootConstrainSelectedInstOperands,
     /* 30195 */     // GIR_Coverage, 954,
     /* 30195 */     GIR_EraseRootFromParent_Done,
     /* 30196 */   // Label 867: @30196
     /* 30196 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(30251), // Rule ID 955 //
     /* 30201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_w),
     /* 30209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30230 */     // MIs[0] n
     /* 30230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30233 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt2),
     /* 30238 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8129:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt2>>:$n)  =>  (SLDI_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_W),
     /* 30241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30243 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30245 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30247 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30249 */     GIR_RootConstrainSelectedInstOperands,
     /* 30250 */     // GIR_Coverage, 955,
     /* 30250 */     GIR_EraseRootFromParent_Done,
     /* 30251 */   // Label 868: @30251
     /* 30251 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(30306), // Rule ID 956 //
     /* 30256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sldi_d),
     /* 30264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30285 */     // MIs[0] n
     /* 30285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt1),
     /* 30293 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8127:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] })<<P:Predicate_timmZExt1>>:$n)  =>  (SLDI_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, (timm:{ *:[i32] }):$n)
     /* 30293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLDI_D),
     /* 30296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30298 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30300 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30302 */     GIR_RootToRootCopy, /*OpIdx*/4, // n
     /* 30304 */     GIR_RootConstrainSelectedInstOperands,
     /* 30305 */     // GIR_Coverage, 956,
     /* 30305 */     GIR_EraseRootFromParent_Done,
     /* 30306 */   // Label 869: @30306
     /* 30306 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(30361), // Rule ID 1349 //
     /* 30311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_ph_w),
     /* 30319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 30322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 30332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30340 */     // MIs[0] sa
     /* 30340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30348 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8088:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_PH_W_MMR2:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_PH_W_MMR2),
     /* 30351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30355 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30357 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30359 */     GIR_RootConstrainSelectedInstOperands,
     /* 30360 */     // GIR_Coverage, 1349,
     /* 30360 */     GIR_EraseRootFromParent_Done,
     /* 30361 */   // Label 870: @30361
     /* 30361 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(30416), // Rule ID 1350 //
     /* 30366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_sra_r_ph_w),
     /* 30374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 30377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 30387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30395 */     // MIs[0] sa
     /* 30395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30403 */     // (intrinsic_wo_chain:{ *:[v2i16] } 8089:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PRECR_SRA_R_PH_W_MMR2:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_SRA_R_PH_W_MMR2),
     /* 30406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30410 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30412 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30414 */     GIR_RootConstrainSelectedInstOperands,
     /* 30415 */     // GIR_Coverage, 1350,
     /* 30415 */     GIR_EraseRootFromParent_Done,
     /* 30416 */   // Label 871: @30416
     /* 30416 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(30471), // Rule ID 1351 //
     /* 30421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_prepend),
     /* 30429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30450 */     // MIs[0] sa
     /* 30450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30458 */     // (intrinsic_wo_chain:{ *:[i32] } 8094:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (PREPEND_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PREPEND_MMR2),
     /* 30461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30465 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30467 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30469 */     GIR_RootConstrainSelectedInstOperands,
     /* 30470 */     // GIR_Coverage, 1351,
     /* 30470 */     GIR_EraseRootFromParent_Done,
     /* 30471 */   // Label 872: @30471
     /* 30471 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(30526), // Rule ID 1352 //
     /* 30476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_append),
     /* 30484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30505 */     // MIs[0] sa
     /* 30505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 30508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt5),
     /* 30513 */     // (intrinsic_wo_chain:{ *:[i32] } 7601:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt5>>:$sa)  =>  (APPEND_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$sa, GPR32Opnd:{ *:[i32] }:$src)
     /* 30513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::APPEND_MMR2),
     /* 30516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30520 */     GIR_RootToRootCopy, /*OpIdx*/4, // sa
     /* 30522 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30524 */     GIR_RootConstrainSelectedInstOperands,
     /* 30525 */     // GIR_Coverage, 1352,
     /* 30525 */     GIR_EraseRootFromParent_Done,
     /* 30526 */   // Label 873: @30526
     /* 30526 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(30588), // Rule ID 1327 //
     /* 30531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 30534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_balign),
     /* 30539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 30542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 30545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 30548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 30560 */     // MIs[0] bp
     /* 30560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 30564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 30568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2),
     /* 30572 */     // MIs[1] Operand 1
     /* 30572 */     // No operand predicates
     /* 30572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 30574 */     // (intrinsic_wo_chain:{ *:[i32] } 7626:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt2>>:$bp)  =>  (BALIGN_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$bp, GPR32Opnd:{ *:[i32] }:$src)
     /* 30574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BALIGN_MMR2),
     /* 30577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 30579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 30581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // bp
     /* 30584 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 30586 */     GIR_RootConstrainSelectedInstOperands,
     /* 30587 */     // GIR_Coverage, 1327,
     /* 30587 */     GIR_EraseRootFromParent_Done,
     /* 30588 */   // Label 874: @30588
     /* 30588 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(30642), // Rule ID 552 //
     /* 30593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_b),
     /* 30601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 30613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30629 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7635:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (BINSL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 30629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_B),
     /* 30632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30634 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30636 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30638 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30640 */     GIR_RootConstrainSelectedInstOperands,
     /* 30641 */     // GIR_Coverage, 552,
     /* 30641 */     GIR_EraseRootFromParent_Done,
     /* 30642 */   // Label 875: @30642
     /* 30642 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(30696), // Rule ID 553 //
     /* 30647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_h),
     /* 30655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 30667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30683 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7637:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (BINSL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 30683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_H),
     /* 30686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30688 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30690 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30692 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30694 */     GIR_RootConstrainSelectedInstOperands,
     /* 30695 */     // GIR_Coverage, 553,
     /* 30695 */     GIR_EraseRootFromParent_Done,
     /* 30696 */   // Label 876: @30696
     /* 30696 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(30750), // Rule ID 554 //
     /* 30701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_w),
     /* 30709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 30721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30737 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7638:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (BINSL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 30737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_W),
     /* 30740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30742 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30744 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30746 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30748 */     GIR_RootConstrainSelectedInstOperands,
     /* 30749 */     // GIR_Coverage, 554,
     /* 30749 */     GIR_EraseRootFromParent_Done,
     /* 30750 */   // Label 877: @30750
     /* 30750 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(30804), // Rule ID 555 //
     /* 30755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsl_d),
     /* 30763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 30775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30791 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7636:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (BINSL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 30791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSL_D),
     /* 30794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30796 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30798 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30800 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30802 */     GIR_RootConstrainSelectedInstOperands,
     /* 30803 */     // GIR_Coverage, 555,
     /* 30803 */     GIR_EraseRootFromParent_Done,
     /* 30804 */   // Label 878: @30804
     /* 30804 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(30858), // Rule ID 560 //
     /* 30809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_b),
     /* 30817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 30820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 30823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 30826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 30829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 30845 */     // (intrinsic_wo_chain:{ *:[v16i8] } 7643:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (BINSR_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 30845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_B),
     /* 30848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30850 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30852 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30854 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30856 */     GIR_RootConstrainSelectedInstOperands,
     /* 30857 */     // GIR_Coverage, 560,
     /* 30857 */     GIR_EraseRootFromParent_Done,
     /* 30858 */   // Label 879: @30858
     /* 30858 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(30912), // Rule ID 561 //
     /* 30863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_h),
     /* 30871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 30874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 30877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 30880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 30883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 30899 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7645:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (BINSR_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 30899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_H),
     /* 30902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30904 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30906 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30908 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30910 */     GIR_RootConstrainSelectedInstOperands,
     /* 30911 */     // GIR_Coverage, 561,
     /* 30911 */     GIR_EraseRootFromParent_Done,
     /* 30912 */   // Label 880: @30912
     /* 30912 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(30966), // Rule ID 562 //
     /* 30917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_w),
     /* 30925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 30928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 30931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 30934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 30937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 30953 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7646:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (BINSR_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 30953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_W),
     /* 30956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 30958 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 30960 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 30962 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 30964 */     GIR_RootConstrainSelectedInstOperands,
     /* 30965 */     // GIR_Coverage, 562,
     /* 30965 */     GIR_EraseRootFromParent_Done,
     /* 30966 */   // Label 881: @30966
     /* 30966 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(31020), // Rule ID 563 //
     /* 30971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 30974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_binsr_d),
     /* 30979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 30982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 30985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 30988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 30991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 30999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31007 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7644:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (BINSR_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 31007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BINSR_D),
     /* 31010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31012 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31014 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31016 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31018 */     GIR_RootConstrainSelectedInstOperands,
     /* 31019 */     // GIR_Coverage, 563,
     /* 31019 */     GIR_EraseRootFromParent_Done,
     /* 31020 */   // Label 882: @31020
     /* 31020 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(31074), // Rule ID 658 //
     /* 31025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_h),
     /* 31033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31061 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7764:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPADD_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_H),
     /* 31064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31066 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31068 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31070 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31072 */     GIR_RootConstrainSelectedInstOperands,
     /* 31073 */     // GIR_Coverage, 658,
     /* 31073 */     GIR_EraseRootFromParent_Done,
     /* 31074 */   // Label 883: @31074
     /* 31074 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(31128), // Rule ID 659 //
     /* 31079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_w),
     /* 31087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31115 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7765:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPADD_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_W),
     /* 31118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31120 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31122 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31124 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31126 */     GIR_RootConstrainSelectedInstOperands,
     /* 31127 */     // GIR_Coverage, 659,
     /* 31127 */     GIR_EraseRootFromParent_Done,
     /* 31128 */   // Label 884: @31128
     /* 31128 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(31182), // Rule ID 660 //
     /* 31133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_s_d),
     /* 31141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31169 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7763:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPADD_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_S_D),
     /* 31172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31174 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31176 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31178 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31180 */     GIR_RootConstrainSelectedInstOperands,
     /* 31181 */     // GIR_Coverage, 660,
     /* 31181 */     GIR_EraseRootFromParent_Done,
     /* 31182 */   // Label 885: @31182
     /* 31182 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(31236), // Rule ID 661 //
     /* 31187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_h),
     /* 31195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31223 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7767:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPADD_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_H),
     /* 31226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31228 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31230 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31232 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31234 */     GIR_RootConstrainSelectedInstOperands,
     /* 31235 */     // GIR_Coverage, 661,
     /* 31235 */     GIR_EraseRootFromParent_Done,
     /* 31236 */   // Label 886: @31236
     /* 31236 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(31290), // Rule ID 662 //
     /* 31241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_w),
     /* 31249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31277 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7768:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPADD_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_W),
     /* 31280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31282 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31284 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31286 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31288 */     GIR_RootConstrainSelectedInstOperands,
     /* 31289 */     // GIR_Coverage, 662,
     /* 31289 */     GIR_EraseRootFromParent_Done,
     /* 31290 */   // Label 887: @31290
     /* 31290 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(31344), // Rule ID 663 //
     /* 31295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpadd_u_d),
     /* 31303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31331 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7766:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPADD_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPADD_U_D),
     /* 31334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31336 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31338 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31340 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31342 */     GIR_RootConstrainSelectedInstOperands,
     /* 31343 */     // GIR_Coverage, 663,
     /* 31343 */     GIR_EraseRootFromParent_Done,
     /* 31344 */   // Label 888: @31344
     /* 31344 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(31398), // Rule ID 664 //
     /* 31349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_h),
     /* 31357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31385 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7784:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPSUB_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_H),
     /* 31388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31390 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31392 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31394 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31396 */     GIR_RootConstrainSelectedInstOperands,
     /* 31397 */     // GIR_Coverage, 664,
     /* 31397 */     GIR_EraseRootFromParent_Done,
     /* 31398 */   // Label 889: @31398
     /* 31398 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(31452), // Rule ID 665 //
     /* 31403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_w),
     /* 31411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31439 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7785:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPSUB_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_W),
     /* 31442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31444 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31446 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31448 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31450 */     GIR_RootConstrainSelectedInstOperands,
     /* 31451 */     // GIR_Coverage, 665,
     /* 31451 */     GIR_EraseRootFromParent_Done,
     /* 31452 */   // Label 890: @31452
     /* 31452 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(31506), // Rule ID 666 //
     /* 31457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_s_d),
     /* 31465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31493 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7783:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPSUB_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_S_D),
     /* 31496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31498 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31500 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31502 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31504 */     GIR_RootConstrainSelectedInstOperands,
     /* 31505 */     // GIR_Coverage, 666,
     /* 31505 */     GIR_EraseRootFromParent_Done,
     /* 31506 */   // Label 891: @31506
     /* 31506 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(31560), // Rule ID 667 //
     /* 31511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_h),
     /* 31519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 31528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 31531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 31547 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7787:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (DPSUB_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 31547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_H),
     /* 31550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31552 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31554 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31556 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31558 */     GIR_RootConstrainSelectedInstOperands,
     /* 31559 */     // GIR_Coverage, 667,
     /* 31559 */     GIR_EraseRootFromParent_Done,
     /* 31560 */   // Label 892: @31560
     /* 31560 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(31614), // Rule ID 668 //
     /* 31565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_w),
     /* 31573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31601 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7788:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (DPSUB_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_W),
     /* 31604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31606 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31608 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31610 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31612 */     GIR_RootConstrainSelectedInstOperands,
     /* 31613 */     // GIR_Coverage, 668,
     /* 31613 */     GIR_EraseRootFromParent_Done,
     /* 31614 */   // Label 893: @31614
     /* 31614 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(31668), // Rule ID 669 //
     /* 31619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_dpsub_u_d),
     /* 31627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 31630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 31633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 31647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31655 */     // (intrinsic_wo_chain:{ *:[v2i64] } 7786:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (DPSUB_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DPSUB_U_D),
     /* 31658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31660 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31662 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31664 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31666 */     GIR_RootConstrainSelectedInstOperands,
     /* 31667 */     // GIR_Coverage, 669,
     /* 31667 */     GIR_EraseRootFromParent_Done,
     /* 31668 */   // Label 894: @31668
     /* 31668 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(31722), // Rule ID 836 //
     /* 31673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_madd_q_h),
     /* 31681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31709 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7954:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MADD_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_Q_H),
     /* 31712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31714 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31716 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31718 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31720 */     GIR_RootConstrainSelectedInstOperands,
     /* 31721 */     // GIR_Coverage, 836,
     /* 31721 */     GIR_EraseRootFromParent_Done,
     /* 31722 */   // Label 895: @31722
     /* 31722 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(31776), // Rule ID 837 //
     /* 31727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_madd_q_w),
     /* 31735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31763 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7955:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MADD_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_Q_W),
     /* 31766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31768 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31770 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31772 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31774 */     GIR_RootConstrainSelectedInstOperands,
     /* 31775 */     // GIR_Coverage, 837,
     /* 31775 */     GIR_EraseRootFromParent_Done,
     /* 31776 */   // Label 896: @31776
     /* 31776 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(31830), // Rule ID 838 //
     /* 31781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_maddr_q_h),
     /* 31789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31817 */     // (intrinsic_wo_chain:{ *:[v8i16] } 7956:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MADDR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDR_Q_H),
     /* 31820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31822 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31824 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31826 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31828 */     GIR_RootConstrainSelectedInstOperands,
     /* 31829 */     // GIR_Coverage, 838,
     /* 31829 */     GIR_EraseRootFromParent_Done,
     /* 31830 */   // Label 897: @31830
     /* 31830 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(31884), // Rule ID 839 //
     /* 31835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_maddr_q_w),
     /* 31843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31871 */     // (intrinsic_wo_chain:{ *:[v4i32] } 7957:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MADDR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADDR_Q_W),
     /* 31874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31876 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31878 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31880 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31882 */     GIR_RootConstrainSelectedInstOperands,
     /* 31883 */     // GIR_Coverage, 839,
     /* 31883 */     GIR_EraseRootFromParent_Done,
     /* 31884 */   // Label 898: @31884
     /* 31884 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(31938), // Rule ID 892 //
     /* 31889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msub_q_h),
     /* 31897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 31900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 31903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 31906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 31909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 31925 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8018:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MSUB_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 31925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_Q_H),
     /* 31928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31930 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31932 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31934 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31936 */     GIR_RootConstrainSelectedInstOperands,
     /* 31937 */     // GIR_Coverage, 892,
     /* 31937 */     GIR_EraseRootFromParent_Done,
     /* 31938 */   // Label 899: @31938
     /* 31938 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(31992), // Rule ID 893 //
     /* 31943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 31946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msub_q_w),
     /* 31951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 31954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 31957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 31960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 31963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 31979 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8019:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MSUB_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 31979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_Q_W),
     /* 31982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 31984 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 31986 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 31988 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 31990 */     GIR_RootConstrainSelectedInstOperands,
     /* 31991 */     // GIR_Coverage, 893,
     /* 31991 */     GIR_EraseRootFromParent_Done,
     /* 31992 */   // Label 900: @31992
     /* 31992 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(32046), // Rule ID 894 //
     /* 31997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msubr_q_h),
     /* 32005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 32017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32033 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8020:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MSUBR_Q_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 32033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBR_Q_H),
     /* 32036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32038 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32040 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32042 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32044 */     GIR_RootConstrainSelectedInstOperands,
     /* 32045 */     // GIR_Coverage, 894,
     /* 32045 */     GIR_EraseRootFromParent_Done,
     /* 32046 */   // Label 901: @32046
     /* 32046 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(32100), // Rule ID 895 //
     /* 32051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_msubr_q_w),
     /* 32059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 32071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32087 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8021:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MSUBR_Q_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 32087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUBR_Q_W),
     /* 32090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32092 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32094 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32096 */     GIR_RootToRootCopy, /*OpIdx*/4, // wt
     /* 32098 */     GIR_RootConstrainSelectedInstOperands,
     /* 32099 */     // GIR_Coverage, 895,
     /* 32099 */     GIR_EraseRootFromParent_Done,
     /* 32100 */   // Label 902: @32100
     /* 32100 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(32154), // Rule ID 949 //
     /* 32105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_b),
     /* 32113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 32116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 32119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 32122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 32137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32141 */     // (intrinsic_wo_chain:{ *:[v16i8] } 8122:{ *:[iPTR] }, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_B),
     /* 32144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32146 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32148 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32152 */     GIR_RootConstrainSelectedInstOperands,
     /* 32153 */     // GIR_Coverage, 949,
     /* 32153 */     GIR_EraseRootFromParent_Done,
     /* 32154 */   // Label 903: @32154
     /* 32154 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(32208), // Rule ID 950 //
     /* 32159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_h),
     /* 32167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 32170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 32173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 32176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 32191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32195 */     // (intrinsic_wo_chain:{ *:[v8i16] } 8124:{ *:[iPTR] }, MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_H),
     /* 32198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32200 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32202 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32206 */     GIR_RootConstrainSelectedInstOperands,
     /* 32207 */     // GIR_Coverage, 950,
     /* 32207 */     GIR_EraseRootFromParent_Done,
     /* 32208 */   // Label 904: @32208
     /* 32208 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(32262), // Rule ID 951 //
     /* 32213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_w),
     /* 32221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 32224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 32227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 32230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 32245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32249 */     // (intrinsic_wo_chain:{ *:[v4i32] } 8125:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_W),
     /* 32252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32254 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32256 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32260 */     GIR_RootConstrainSelectedInstOperands,
     /* 32261 */     // GIR_Coverage, 951,
     /* 32261 */     GIR_EraseRootFromParent_Done,
     /* 32262 */   // Label 905: @32262
     /* 32262 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(32316), // Rule ID 952 //
     /* 32267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 32270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_sld_d),
     /* 32275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 32278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 32281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 32284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 32287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 32299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32303 */     // (intrinsic_wo_chain:{ *:[v2i64] } 8123:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SLD_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, GPR32Opnd:{ *:[i32] }:$rt)
     /* 32303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLD_D),
     /* 32306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 32308 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 32310 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 32312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rt
     /* 32314 */     GIR_RootConstrainSelectedInstOperands,
     /* 32315 */     // GIR_Coverage, 952,
     /* 32315 */     GIR_EraseRootFromParent_Done,
     /* 32316 */   // Label 906: @32316
     /* 32316 */   GIM_Reject,
     /* 32317 */ // Label 860: @32317
     /* 32317 */ GIM_Reject,
     /* 32318 */ // Label 30: @32318
     /* 32318 */ GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(32349), // Rule ID 354 //
     /* 32323 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 32326 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_bposge32),
     /* 32331 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32338 */   // (intrinsic_w_chain:{ *:[i32] } 7669:{ *:[iPTR] })  =>  (BPOSGE32_PSEUDO:{ *:[i32] })
     /* 32338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BPOSGE32_PSEUDO),
     /* 32341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 32343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32347 */   GIR_RootConstrainSelectedInstOperands,
     /* 32348 */   // GIR_Coverage, 354,
     /* 32348 */   GIR_EraseRootFromParent_Done,
     /* 32349 */ // Label 907: @32349
     /* 32349 */ GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(33286),
     /* 32354 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 32357 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(32398), // Rule ID 441 //
     /* 32362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_rddsp),
     /* 32370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32377 */     // MIs[0] mask
     /* 32377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32380 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt10),
     /* 32385 */     // (intrinsic_w_chain:{ *:[i32] } 8096:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timmZExt10>>:$mask)  =>  (RDDSP:{ *:[i32] } (timm:{ *:[i32] }):$mask)
     /* 32385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RDDSP),
     /* 32388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32390 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32396 */     GIR_RootConstrainSelectedInstOperands,
     /* 32397 */     // GIR_Coverage, 441,
     /* 32397 */     GIR_EraseRootFromParent_Done,
     /* 32398 */   // Label 909: @32398
     /* 32398 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(32434), // Rule ID 1287 //
     /* 32403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_rddsp),
     /* 32411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32418 */     // MIs[0] mask
     /* 32418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32421 */     // (intrinsic_w_chain:{ *:[i32] } 8096:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timmZExt7>>:$mask)  =>  (RDDSP_MM:{ *:[i32] } (timm:{ *:[i32] }):$mask)
     /* 32421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::RDDSP_MM),
     /* 32424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32426 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32432 */     GIR_RootConstrainSelectedInstOperands,
     /* 32433 */     // GIR_Coverage, 1287,
     /* 32433 */     GIR_EraseRootFromParent_Done,
     /* 32434 */   // Label 910: @32434
     /* 32434 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(32475), // Rule ID 442 //
     /* 32439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_NotInMicroMips),
     /* 32442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_wrdsp),
     /* 32447 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 32450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32454 */     // MIs[0] mask
     /* 32454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timmZExt10),
     /* 32462 */     // (intrinsic_void 8225:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] })<<P:Predicate_timmZExt10>>:$mask)  =>  (WRDSP GPR32Opnd:{ *:[i32] }:$rs, (timm:{ *:[i32] }):$mask)
     /* 32462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::WRDSP),
     /* 32465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32467 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32473 */     GIR_RootConstrainSelectedInstOperands,
     /* 32474 */     // GIR_Coverage, 442,
     /* 32474 */     GIR_EraseRootFromParent_Done,
     /* 32475 */   // Label 911: @32475
     /* 32475 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(32511), // Rule ID 1298 //
     /* 32480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_wrdsp),
     /* 32488 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 32491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32495 */     // MIs[0] mask
     /* 32495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 32498 */     // (intrinsic_void 8225:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (timm:{ *:[i32] })<<P:Predicate_timmZExt7>>:$mask)  =>  (WRDSP_MM GPR32Opnd:{ *:[i32] }:$rt, (timm:{ *:[i32] }):$mask)
     /* 32498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::WRDSP_MM),
     /* 32501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 32503 */     GIR_RootToRootCopy, /*OpIdx*/2, // mask
     /* 32505 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32509 */     GIR_RootConstrainSelectedInstOperands,
     /* 32510 */     // GIR_Coverage, 1298,
     /* 32510 */     GIR_EraseRootFromParent_Done,
     /* 32511 */   // Label 912: @32511
     /* 32511 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(32554), // Rule ID 363 //
     /* 32516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_ph),
     /* 32524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 32527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32538 */     // (intrinsic_w_chain:{ *:[v2i16] } 7557:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ABSQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_PH),
     /* 32541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32552 */     GIR_RootConstrainSelectedInstOperands,
     /* 32553 */     // GIR_Coverage, 363,
     /* 32553 */     GIR_EraseRootFromParent_Done,
     /* 32554 */   // Label 913: @32554
     /* 32554 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(32597), // Rule ID 364 //
     /* 32559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_w),
     /* 32567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 32573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32581 */     // (intrinsic_w_chain:{ *:[i32] } 7559:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ABSQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 32581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_W),
     /* 32584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32595 */     GIR_RootConstrainSelectedInstOperands,
     /* 32596 */     // GIR_Coverage, 364,
     /* 32596 */     GIR_EraseRootFromParent_Done,
     /* 32597 */   // Label 914: @32597
     /* 32597 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(32640), // Rule ID 450 //
     /* 32602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 32605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_qb),
     /* 32610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 32613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32624 */     // (intrinsic_w_chain:{ *:[v4i8] } 7558:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (ABSQ_S_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_QB),
     /* 32627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 32629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32638 */     GIR_RootConstrainSelectedInstOperands,
     /* 32639 */     // GIR_Coverage, 450,
     /* 32639 */     GIR_EraseRootFromParent_Done,
     /* 32640 */   // Label 915: @32640
     /* 32640 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(32683), // Rule ID 1230 //
     /* 32645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_ph),
     /* 32653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 32656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32667 */     // (intrinsic_w_chain:{ *:[v2i16] } 7557:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs)  =>  (ABSQ_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs)
     /* 32667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_PH_MM),
     /* 32670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32681 */     GIR_RootConstrainSelectedInstOperands,
     /* 32682 */     // GIR_Coverage, 1230,
     /* 32682 */     GIR_EraseRootFromParent_Done,
     /* 32683 */   // Label 916: @32683
     /* 32683 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(32726), // Rule ID 1231 //
     /* 32688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 32691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_w),
     /* 32696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 32699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 32702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 32710 */     // (intrinsic_w_chain:{ *:[i32] } 7559:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ABSQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 32710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_W_MM),
     /* 32713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32717 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32724 */     GIR_RootConstrainSelectedInstOperands,
     /* 32725 */     // GIR_Coverage, 1231,
     /* 32725 */     GIR_EraseRootFromParent_Done,
     /* 32726 */   // Label 917: @32726
     /* 32726 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(32769), // Rule ID 1311 //
     /* 32731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 32734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_absq_s_qb),
     /* 32739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 32742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32753 */     // (intrinsic_w_chain:{ *:[v4i8] } 7558:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs)  =>  (ABSQ_S_QB_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs)
     /* 32753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ABSQ_S_QB_MMR2),
     /* 32756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 32758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 32760 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 32763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32767 */     GIR_RootConstrainSelectedInstOperands,
     /* 32768 */     // GIR_Coverage, 1311,
     /* 32768 */     GIR_EraseRootFromParent_Done,
     /* 32769 */   // Label 918: @32769
     /* 32769 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(32812), // Rule ID 417 //
     /* 32774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_eq_qb),
     /* 32782 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32796 */     // (intrinsic_void 7735:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_EQ_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_EQ_QB),
     /* 32799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32810 */     GIR_RootConstrainSelectedInstOperands,
     /* 32811 */     // GIR_Coverage, 417,
     /* 32811 */     GIR_EraseRootFromParent_Done,
     /* 32812 */   // Label 919: @32812
     /* 32812 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(32855), // Rule ID 418 //
     /* 32817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_lt_qb),
     /* 32825 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32839 */     // (intrinsic_void 7737:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LT_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LT_QB),
     /* 32842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32849 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32853 */     GIR_RootConstrainSelectedInstOperands,
     /* 32854 */     // GIR_Coverage, 418,
     /* 32854 */     GIR_EraseRootFromParent_Done,
     /* 32855 */   // Label 920: @32855
     /* 32855 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(32898), // Rule ID 419 //
     /* 32860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_le_qb),
     /* 32868 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 32871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 32874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32882 */     // (intrinsic_void 7736:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LE_QB DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 32882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LE_QB),
     /* 32885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32896 */     GIR_RootConstrainSelectedInstOperands,
     /* 32897 */     // GIR_Coverage, 419,
     /* 32897 */     GIR_EraseRootFromParent_Done,
     /* 32898 */   // Label 921: @32898
     /* 32898 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(32941), // Rule ID 423 //
     /* 32903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_eq_ph),
     /* 32911 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32925 */     // (intrinsic_void 7726:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_EQ_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_PH),
     /* 32928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32939 */     GIR_RootConstrainSelectedInstOperands,
     /* 32940 */     // GIR_Coverage, 423,
     /* 32940 */     GIR_EraseRootFromParent_Done,
     /* 32941 */   // Label 922: @32941
     /* 32941 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(32984), // Rule ID 424 //
     /* 32946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_lt_ph),
     /* 32954 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 32957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 32960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 32968 */     // (intrinsic_void 7728:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LT_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 32968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_PH),
     /* 32971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 32973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 32975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 32978 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 32982 */     GIR_RootConstrainSelectedInstOperands,
     /* 32983 */     // GIR_Coverage, 424,
     /* 32983 */     GIR_EraseRootFromParent_Done,
     /* 32984 */   // Label 923: @32984
     /* 32984 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(33027), // Rule ID 425 //
     /* 32989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 32992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_le_ph),
     /* 32997 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33011 */     // (intrinsic_void 7727:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LE_PH DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_PH),
     /* 33014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33021 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33025 */     GIR_RootConstrainSelectedInstOperands,
     /* 33026 */     // GIR_Coverage, 425,
     /* 33026 */     GIR_EraseRootFromParent_Done,
     /* 33027 */   // Label 924: @33027
     /* 33027 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(33070), // Rule ID 1302 //
     /* 33032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_eq_ph),
     /* 33040 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33054 */     // (intrinsic_void 7726:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_EQ_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_PH_MM),
     /* 33057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33068 */     GIR_RootConstrainSelectedInstOperands,
     /* 33069 */     // GIR_Coverage, 1302,
     /* 33069 */     GIR_EraseRootFromParent_Done,
     /* 33070 */   // Label 925: @33070
     /* 33070 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(33113), // Rule ID 1303 //
     /* 33075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_lt_ph),
     /* 33083 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33097 */     // (intrinsic_void 7728:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LT_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_PH_MM),
     /* 33100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33111 */     GIR_RootConstrainSelectedInstOperands,
     /* 33112 */     // GIR_Coverage, 1303,
     /* 33112 */     GIR_EraseRootFromParent_Done,
     /* 33113 */   // Label 926: @33113
     /* 33113 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(33156), // Rule ID 1304 //
     /* 33118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmp_le_ph),
     /* 33126 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s16,
     /* 33129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33140 */     // (intrinsic_void 7727:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (CMP_LE_PH_MM DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_PH_MM),
     /* 33143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33154 */     GIR_RootConstrainSelectedInstOperands,
     /* 33155 */     // GIR_Coverage, 1304,
     /* 33155 */     GIR_EraseRootFromParent_Done,
     /* 33156 */   // Label 927: @33156
     /* 33156 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(33199), // Rule ID 1308 //
     /* 33161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_eq_qb),
     /* 33169 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33183 */     // (intrinsic_void 7735:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_EQ_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_EQ_QB_MM),
     /* 33186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33197 */     GIR_RootConstrainSelectedInstOperands,
     /* 33198 */     // GIR_Coverage, 1308,
     /* 33198 */     GIR_EraseRootFromParent_Done,
     /* 33199 */   // Label 928: @33199
     /* 33199 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(33242), // Rule ID 1309 //
     /* 33204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_lt_qb),
     /* 33212 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33226 */     // (intrinsic_void 7737:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LT_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LT_QB_MM),
     /* 33229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33240 */     GIR_RootConstrainSelectedInstOperands,
     /* 33241 */     // GIR_Coverage, 1309,
     /* 33241 */     GIR_EraseRootFromParent_Done,
     /* 33242 */   // Label 929: @33242
     /* 33242 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(33285), // Rule ID 1310 //
     /* 33247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_cmpu_le_qb),
     /* 33255 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s8,
     /* 33258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33269 */     // (intrinsic_void 7736:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPU_LE_QB_MM DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 33269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPU_LE_QB_MM),
     /* 33272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 33274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 33279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33283 */     GIR_RootConstrainSelectedInstOperands,
     /* 33284 */     // GIR_Coverage, 1310,
     /* 33284 */     GIR_EraseRootFromParent_Done,
     /* 33285 */   // Label 930: @33285
     /* 33285 */   GIM_Reject,
     /* 33286 */ // Label 908: @33286
     /* 33286 */ GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(37411),
     /* 33291 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 33294 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(33358), // Rule ID 382 //
     /* 33299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33336 */     // MIs[1] Operand 1
     /* 33336 */     // No operand predicates
     /* 33336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33338 */     // (intrinsic_w_chain:{ *:[v2i16] } 8113:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$rs_sa)  =>  (SHLL_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 33338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_PH),
     /* 33341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 33348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33356 */     GIR_RootConstrainSelectedInstOperands,
     /* 33357 */     // GIR_Coverage, 382,
     /* 33357 */     GIR_EraseRootFromParent_Done,
     /* 33358 */   // Label 932: @33358
     /* 33358 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(33422), // Rule ID 387 //
     /* 33363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 33371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 33400 */     // MIs[1] Operand 1
     /* 33400 */     // No operand predicates
     /* 33400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33402 */     // (intrinsic_w_chain:{ *:[i32] } 8114:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$rs_sa)  =>  (SHLL_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$rs_sa)
     /* 33402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_W),
     /* 33405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs_sa
     /* 33412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33415 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33420 */     GIR_RootConstrainSelectedInstOperands,
     /* 33421 */     // GIR_Coverage, 387,
     /* 33421 */     GIR_EraseRootFromParent_Done,
     /* 33422 */   // Label 933: @33422
     /* 33422 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(33486), // Rule ID 1239 //
     /* 33427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33464 */     // MIs[1] Operand 1
     /* 33464 */     // No operand predicates
     /* 33464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33466 */     // (intrinsic_w_chain:{ *:[v2i16] } 8113:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$sa)  =>  (SHLL_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 33466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_PH_MM),
     /* 33469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 33471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 33476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33484 */     GIR_RootConstrainSelectedInstOperands,
     /* 33485 */     // GIR_Coverage, 1239,
     /* 33485 */     GIR_EraseRootFromParent_Done,
     /* 33486 */   // Label 934: @33486
     /* 33486 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(33550), // Rule ID 1244 //
     /* 33491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 33494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 33499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 33528 */     // MIs[1] Operand 1
     /* 33528 */     // No operand predicates
     /* 33528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33530 */     // (intrinsic_w_chain:{ *:[i32] } 8114:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$sa)  =>  (SHLL_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, (imm:{ *:[i32] }):$sa)
     /* 33530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_S_W_MM),
     /* 33533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 33535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // sa
     /* 33540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33543 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 33548 */     GIR_RootConstrainSelectedInstOperands,
     /* 33549 */     // GIR_Coverage, 1244,
     /* 33549 */     GIR_EraseRootFromParent_Done,
     /* 33550 */   // Label 935: @33550
     /* 33550 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(33605), // Rule ID 1938 //
     /* 33555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 33563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 33588 */     // MIs[1] Operand 1
     /* 33588 */     // No operand predicates
     /* 33588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33590 */     // (intrinsic_w_chain:{ *:[v2i16] } 8111:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)  =>  (SHLL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$shamt)
     /* 33590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_PH),
     /* 33593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33595 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 33597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 33600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33603 */     GIR_RootConstrainSelectedInstOperands,
     /* 33604 */     // GIR_Coverage, 1938,
     /* 33604 */     GIR_EraseRootFromParent_Done,
     /* 33605 */   // Label 936: @33605
     /* 33605 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(33660), // Rule ID 1944 //
     /* 33610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 33618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 33635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 33639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt3),
     /* 33643 */     // MIs[1] Operand 1
     /* 33643 */     // No operand predicates
     /* 33643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 33645 */     // (intrinsic_w_chain:{ *:[v4i8] } 8112:{ *:[iPTR] }, v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)  =>  (SHLL_QB:{ *:[v4i8] } v4i8:{ *:[v4i8] }:$a, (imm:{ *:[i32] })<<P:Predicate_immZExt3>>:$shamt)
     /* 33645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLL_QB),
     /* 33648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33650 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 33652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 33655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33658 */     GIR_RootConstrainSelectedInstOperands,
     /* 33659 */     // GIR_Coverage, 1944,
     /* 33659 */     GIR_EraseRootFromParent_Done,
     /* 33660 */   // Label 937: @33660
     /* 33660 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(33712), // Rule ID 359 //
     /* 33665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_w),
     /* 33673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33694 */     // (intrinsic_w_chain:{ *:[i32] } 7566:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_W),
     /* 33697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 33706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33710 */     GIR_RootConstrainSelectedInstOperands,
     /* 33711 */     // GIR_Coverage, 359,
     /* 33711 */     GIR_EraseRootFromParent_Done,
     /* 33712 */   // Label 938: @33712
     /* 33712 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(33764), // Rule ID 360 //
     /* 33717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_w),
     /* 33725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 33728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33746 */     // (intrinsic_w_chain:{ *:[i32] } 8186:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_W),
     /* 33749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 33758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33762 */     GIR_RootConstrainSelectedInstOperands,
     /* 33763 */     // GIR_Coverage, 360,
     /* 33763 */     GIR_EraseRootFromParent_Done,
     /* 33764 */   // Label 939: @33764
     /* 33764 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(33816), // Rule ID 367 //
     /* 33769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_rs_ph_w),
     /* 33777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 33783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33798 */     // (intrinsic_w_chain:{ *:[v2i16] } 8092:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_RS_PH_W:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 33798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_RS_PH_W),
     /* 33801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33807 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33814 */     GIR_RootConstrainSelectedInstOperands,
     /* 33815 */     // GIR_Coverage, 367,
     /* 33815 */     GIR_EraseRootFromParent_Done,
     /* 33816 */   // Label 940: @33816
     /* 33816 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(33868), // Rule ID 368 //
     /* 33821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrqu_s_qb_ph),
     /* 33829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 33838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33850 */     // (intrinsic_w_chain:{ *:[v4i8] } 8093:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQU_S_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 33850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQU_S_QB_PH),
     /* 33853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 33857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 33859 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33866 */     GIR_RootConstrainSelectedInstOperands,
     /* 33867 */     // GIR_Coverage, 368,
     /* 33867 */     GIR_EraseRootFromParent_Done,
     /* 33868 */   // Label 941: @33868
     /* 33868 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(33920), // Rule ID 379 //
     /* 33873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 33881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 33884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 33887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33902 */     // (intrinsic_w_chain:{ *:[v4i8] } 8112:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_QB),
     /* 33905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 33911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33918 */     GIR_RootConstrainSelectedInstOperands,
     /* 33919 */     // GIR_Coverage, 379,
     /* 33919 */     GIR_EraseRootFromParent_Done,
     /* 33920 */   // Label 942: @33920
     /* 33920 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(33972), // Rule ID 381 //
     /* 33925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 33933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 33954 */     // (intrinsic_w_chain:{ *:[v2i16] } 8111:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 33954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_PH),
     /* 33957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 33959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 33961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 33963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 33966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 33970 */     GIR_RootConstrainSelectedInstOperands,
     /* 33971 */     // GIR_Coverage, 381,
     /* 33971 */     GIR_EraseRootFromParent_Done,
     /* 33972 */   // Label 943: @33972
     /* 33972 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(34024), // Rule ID 383 //
     /* 33977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 33980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 33985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 33988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 33991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 33994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 33998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34006 */     // (intrinsic_w_chain:{ *:[v2i16] } 8113:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 34006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_PH),
     /* 34009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 34013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 34015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 34018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34022 */     GIR_RootConstrainSelectedInstOperands,
     /* 34023 */     // GIR_Coverage, 383,
     /* 34023 */     GIR_EraseRootFromParent_Done,
     /* 34024 */   // Label 944: @34024
     /* 34024 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(34076), // Rule ID 388 //
     /* 34029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 34037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 34043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34058 */     // (intrinsic_w_chain:{ *:[i32] } 8114:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)  =>  (SHLLV_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs_sa)
     /* 34058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_W),
     /* 34061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 34065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs_sa
     /* 34067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 34070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34074 */     GIR_RootConstrainSelectedInstOperands,
     /* 34075 */     // GIR_Coverage, 388,
     /* 34075 */     GIR_EraseRootFromParent_Done,
     /* 34076 */   // Label 945: @34076
     /* 34076 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(34128), // Rule ID 391 //
     /* 34081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbl),
     /* 34089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34110 */     // (intrinsic_w_chain:{ *:[v2i16] } 8034:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBL:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBL),
     /* 34113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34126 */     GIR_RootConstrainSelectedInstOperands,
     /* 34127 */     // GIR_Coverage, 391,
     /* 34127 */     GIR_EraseRootFromParent_Done,
     /* 34128 */   // Label 946: @34128
     /* 34128 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(34180), // Rule ID 392 //
     /* 34133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbr),
     /* 34141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34162 */     // (intrinsic_w_chain:{ *:[v2i16] } 8035:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBR:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBR),
     /* 34165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34178 */     GIR_RootConstrainSelectedInstOperands,
     /* 34179 */     // GIR_Coverage, 392,
     /* 34179 */     GIR_EraseRootFromParent_Done,
     /* 34180 */   // Label 947: @34180
     /* 34180 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(34232), // Rule ID 393 //
     /* 34185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phl),
     /* 34193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34214 */     // (intrinsic_w_chain:{ *:[i32] } 8032:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHL:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHL),
     /* 34217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34230 */     GIR_RootConstrainSelectedInstOperands,
     /* 34231 */     // GIR_Coverage, 393,
     /* 34231 */     GIR_EraseRootFromParent_Done,
     /* 34232 */   // Label 948: @34232
     /* 34232 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(34284), // Rule ID 394 //
     /* 34237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phr),
     /* 34245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34266 */     // (intrinsic_w_chain:{ *:[i32] } 8033:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHR:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHR),
     /* 34269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34282 */     GIR_RootConstrainSelectedInstOperands,
     /* 34283 */     // GIR_Coverage, 394,
     /* 34283 */     GIR_EraseRootFromParent_Done,
     /* 34284 */   // Label 949: @34284
     /* 34284 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(34336), // Rule ID 395 //
     /* 34289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_ph),
     /* 34297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34318 */     // (intrinsic_w_chain:{ *:[v2i16] } 8036:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_RS_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_PH),
     /* 34321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 34330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34334 */     GIR_RootConstrainSelectedInstOperands,
     /* 34335 */     // GIR_Coverage, 395,
     /* 34335 */     GIR_EraseRootFromParent_Done,
     /* 34336 */   // Label 950: @34336
     /* 34336 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(34385), // Rule ID 420 //
     /* 34341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_eq_qb),
     /* 34349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34370 */     // (intrinsic_w_chain:{ *:[i32] } 7732:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_EQ_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_EQ_QB),
     /* 34373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34383 */     GIR_RootConstrainSelectedInstOperands,
     /* 34384 */     // GIR_Coverage, 420,
     /* 34384 */     GIR_EraseRootFromParent_Done,
     /* 34385 */   // Label 951: @34385
     /* 34385 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(34434), // Rule ID 421 //
     /* 34390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_lt_qb),
     /* 34398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34419 */     // (intrinsic_w_chain:{ *:[i32] } 7734:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LT_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LT_QB),
     /* 34422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34432 */     GIR_RootConstrainSelectedInstOperands,
     /* 34433 */     // GIR_Coverage, 421,
     /* 34433 */     GIR_EraseRootFromParent_Done,
     /* 34434 */   // Label 952: @34434
     /* 34434 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(34483), // Rule ID 422 //
     /* 34439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_le_qb),
     /* 34447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34468 */     // (intrinsic_w_chain:{ *:[i32] } 7733:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LE_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LE_QB),
     /* 34471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34481 */     GIR_RootConstrainSelectedInstOperands,
     /* 34482 */     // GIR_Coverage, 422,
     /* 34482 */     GIR_EraseRootFromParent_Done,
     /* 34483 */   // Label 953: @34483
     /* 34483 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(34532), // Rule ID 432 //
     /* 34488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_qb),
     /* 34496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 34499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34517 */     // (intrinsic_w_chain:{ *:[v4i8] } 8076:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PICK_QB:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_QB),
     /* 34520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34530 */     GIR_RootConstrainSelectedInstOperands,
     /* 34531 */     // GIR_Coverage, 432,
     /* 34531 */     GIR_EraseRootFromParent_Done,
     /* 34532 */   // Label 954: @34532
     /* 34532 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(34581), // Rule ID 433 //
     /* 34537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_ph),
     /* 34545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34566 */     // (intrinsic_w_chain:{ *:[v2i16] } 8075:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PICK_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_PH),
     /* 34569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34579 */     GIR_RootConstrainSelectedInstOperands,
     /* 34580 */     // GIR_Coverage, 433,
     /* 34580 */     GIR_EraseRootFromParent_Done,
     /* 34581 */   // Label 955: @34581
     /* 34581 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(34630), // Rule ID 437 //
     /* 34586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 34589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_insv),
     /* 34594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 34600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 34603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34615 */     // (intrinsic_w_chain:{ *:[i32] } 7934:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)  =>  (INSV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)
     /* 34615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSV),
     /* 34618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 34620 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 34622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 34624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34628 */     GIR_RootConstrainSelectedInstOperands,
     /* 34629 */     // GIR_Coverage, 437,
     /* 34629 */     GIR_EraseRootFromParent_Done,
     /* 34630 */   // Label 956: @34630
     /* 34630 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(34682), // Rule ID 443 //
     /* 34635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_ph),
     /* 34643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34664 */     // (intrinsic_w_chain:{ *:[v2i16] } 7584:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_PH),
     /* 34667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34680 */     GIR_RootConstrainSelectedInstOperands,
     /* 34681 */     // GIR_Coverage, 443,
     /* 34681 */     GIR_EraseRootFromParent_Done,
     /* 34682 */   // Label 957: @34682
     /* 34682 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(34734), // Rule ID 444 //
     /* 34687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_ph),
     /* 34695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34716 */     // (intrinsic_w_chain:{ *:[v2i16] } 7586:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_PH),
     /* 34719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34732 */     GIR_RootConstrainSelectedInstOperands,
     /* 34733 */     // GIR_Coverage, 444,
     /* 34733 */     GIR_EraseRootFromParent_Done,
     /* 34734 */   // Label 958: @34734
     /* 34734 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(34786), // Rule ID 445 //
     /* 34739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_ph),
     /* 34747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34768 */     // (intrinsic_w_chain:{ *:[v2i16] } 8207:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_PH),
     /* 34771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34784 */     GIR_RootConstrainSelectedInstOperands,
     /* 34785 */     // GIR_Coverage, 445,
     /* 34785 */     GIR_EraseRootFromParent_Done,
     /* 34786 */   // Label 959: @34786
     /* 34786 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(34838), // Rule ID 446 //
     /* 34791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_ph),
     /* 34799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 34802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 34805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 34808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34820 */     // (intrinsic_w_chain:{ *:[v2i16] } 8209:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 34820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_PH),
     /* 34823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 34832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34836 */     GIR_RootConstrainSelectedInstOperands,
     /* 34837 */     // GIR_Coverage, 446,
     /* 34837 */     GIR_EraseRootFromParent_Done,
     /* 34838 */   // Label 960: @34838
     /* 34838 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(34890), // Rule ID 447 //
     /* 34843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_eq_qb),
     /* 34851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34872 */     // (intrinsic_w_chain:{ *:[i32] } 7729:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_EQ_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_EQ_QB),
     /* 34875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34881 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34888 */     GIR_RootConstrainSelectedInstOperands,
     /* 34889 */     // GIR_Coverage, 447,
     /* 34889 */     GIR_EraseRootFromParent_Done,
     /* 34890 */   // Label 961: @34890
     /* 34890 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(34942), // Rule ID 448 //
     /* 34895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_lt_qb),
     /* 34903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34924 */     // (intrinsic_w_chain:{ *:[i32] } 7731:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LT_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LT_QB),
     /* 34927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34940 */     GIR_RootConstrainSelectedInstOperands,
     /* 34941 */     // GIR_Coverage, 448,
     /* 34941 */     GIR_EraseRootFromParent_Done,
     /* 34942 */   // Label 962: @34942
     /* 34942 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(34994), // Rule ID 449 //
     /* 34947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 34950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_le_qb),
     /* 34955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 34958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 34961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 34964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 34968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 34976 */     // (intrinsic_w_chain:{ *:[i32] } 7730:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LE_QB:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 34976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LE_QB),
     /* 34979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 34981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 34983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 34985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 34988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 34992 */     GIR_RootConstrainSelectedInstOperands,
     /* 34993 */     // GIR_Coverage, 449,
     /* 34993 */     GIR_EraseRootFromParent_Done,
     /* 34994 */   // Label 963: @34994
     /* 34994 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(35046), // Rule ID 463 //
     /* 34999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_s_ph),
     /* 35007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35028 */     // (intrinsic_w_chain:{ *:[v2i16] } 8031:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MUL_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_S_PH),
     /* 35031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35044 */     GIR_RootConstrainSelectedInstOperands,
     /* 35045 */     // GIR_Coverage, 463,
     /* 35045 */     GIR_EraseRootFromParent_Done,
     /* 35046 */   // Label 964: @35046
     /* 35046 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(35098), // Rule ID 464 //
     /* 35051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_w),
     /* 35059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35080 */     // (intrinsic_w_chain:{ *:[i32] } 8039:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_S_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_W),
     /* 35083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35096 */     GIR_RootConstrainSelectedInstOperands,
     /* 35097 */     // GIR_Coverage, 464,
     /* 35097 */     GIR_EraseRootFromParent_Done,
     /* 35098 */   // Label 965: @35098
     /* 35098 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(35150), // Rule ID 465 //
     /* 35103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_w),
     /* 35111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35132 */     // (intrinsic_w_chain:{ *:[i32] } 8037:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_RS_W:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_W),
     /* 35135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35148 */     GIR_RootConstrainSelectedInstOperands,
     /* 35149 */     // GIR_Coverage, 465,
     /* 35149 */     GIR_EraseRootFromParent_Done,
     /* 35150 */   // Label 966: @35150
     /* 35150 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(35202), // Rule ID 466 //
     /* 35155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_ph),
     /* 35163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35184 */     // (intrinsic_w_chain:{ *:[v2i16] } 8038:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_S_PH:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_PH),
     /* 35187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35200 */     GIR_RootConstrainSelectedInstOperands,
     /* 35201 */     // GIR_Coverage, 466,
     /* 35201 */     GIR_EraseRootFromParent_Done,
     /* 35202 */   // Label 967: @35202
     /* 35202 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(35251), // Rule ID 476 //
     /* 35207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 35210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_qb_ph),
     /* 35215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35236 */     // (intrinsic_w_chain:{ *:[v4i8] } 8087:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECR_QB_PH:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_QB_PH),
     /* 35239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35249 */     GIR_RootConstrainSelectedInstOperands,
     /* 35250 */     // GIR_Coverage, 476,
     /* 35250 */     GIR_EraseRootFromParent_Done,
     /* 35251 */   // Label 968: @35251
     /* 35251 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(35303), // Rule ID 1224 //
     /* 35256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addq_s_w),
     /* 35264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35285 */     // (intrinsic_w_chain:{ *:[i32] } 7566:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (ADDQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDQ_S_W_MM),
     /* 35288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 35297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35301 */     GIR_RootConstrainSelectedInstOperands,
     /* 35302 */     // GIR_Coverage, 1224,
     /* 35302 */     GIR_EraseRootFromParent_Done,
     /* 35303 */   // Label 969: @35303
     /* 35303 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(35352), // Rule ID 1232 //
     /* 35308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_insv),
     /* 35316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35337 */     // (intrinsic_w_chain:{ *:[i32] } 7934:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)  =>  (INSV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$src, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSV_MM),
     /* 35340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 35342 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 35344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35350 */     GIR_RootConstrainSelectedInstOperands,
     /* 35351 */     // GIR_Coverage, 1232,
     /* 35351 */     GIR_EraseRootFromParent_Done,
     /* 35352 */   // Label 970: @35352
     /* 35352 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(35404), // Rule ID 1240 //
     /* 35357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_ph),
     /* 35365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35386 */     // (intrinsic_w_chain:{ *:[v2i16] } 8111:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_PH_MM),
     /* 35389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35402 */     GIR_RootConstrainSelectedInstOperands,
     /* 35403 */     // GIR_Coverage, 1240,
     /* 35403 */     GIR_EraseRootFromParent_Done,
     /* 35404 */   // Label 971: @35404
     /* 35404 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(35456), // Rule ID 1241 //
     /* 35409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_ph),
     /* 35417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35438 */     // (intrinsic_w_chain:{ *:[v2i16] } 8113:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_S_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_PH_MM),
     /* 35441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35454 */     GIR_RootConstrainSelectedInstOperands,
     /* 35455 */     // GIR_Coverage, 1241,
     /* 35455 */     GIR_EraseRootFromParent_Done,
     /* 35456 */   // Label 972: @35456
     /* 35456 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(35508), // Rule ID 1242 //
     /* 35461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_qb),
     /* 35469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35490 */     // (intrinsic_w_chain:{ *:[v4i8] } 8112:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_QB_MM),
     /* 35493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35502 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35506 */     GIR_RootConstrainSelectedInstOperands,
     /* 35507 */     // GIR_Coverage, 1242,
     /* 35507 */     GIR_EraseRootFromParent_Done,
     /* 35508 */   // Label 973: @35508
     /* 35508 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(35560), // Rule ID 1243 //
     /* 35513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_shll_s_w),
     /* 35521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35542 */     // (intrinsic_w_chain:{ *:[i32] } 8114:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SHLLV_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 35542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SHLLV_S_W_MM),
     /* 35545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rt
     /* 35549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs
     /* 35551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35558 */     GIR_RootConstrainSelectedInstOperands,
     /* 35559 */     // GIR_Coverage, 1243,
     /* 35559 */     GIR_EraseRootFromParent_Done,
     /* 35560 */   // Label 974: @35560
     /* 35560 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(35612), // Rule ID 1262 //
     /* 35565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subq_s_w),
     /* 35573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35594 */     // (intrinsic_w_chain:{ *:[i32] } 8186:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (SUBQ_S_W_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBQ_S_W_MM),
     /* 35597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 35606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35610 */     GIR_RootConstrainSelectedInstOperands,
     /* 35611 */     // GIR_Coverage, 1262,
     /* 35611 */     GIR_EraseRootFromParent_Done,
     /* 35612 */   // Label 975: @35612
     /* 35612 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(35664), // Rule ID 1268 //
     /* 35617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phl),
     /* 35625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35646 */     // (intrinsic_w_chain:{ *:[i32] } 8032:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHL_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHL_MM),
     /* 35649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35658 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35662 */     GIR_RootConstrainSelectedInstOperands,
     /* 35663 */     // GIR_Coverage, 1268,
     /* 35663 */     GIR_EraseRootFromParent_Done,
     /* 35664 */   // Label 976: @35664
     /* 35664 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(35716), // Rule ID 1269 //
     /* 35669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleq_s_w_phr),
     /* 35677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 35680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35698 */     // (intrinsic_w_chain:{ *:[i32] } 8033:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEQ_S_W_PHR_MM:{ *:[i32] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEQ_S_W_PHR_MM),
     /* 35701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35714 */     GIR_RootConstrainSelectedInstOperands,
     /* 35715 */     // GIR_Coverage, 1269,
     /* 35715 */     GIR_EraseRootFromParent_Done,
     /* 35716 */   // Label 977: @35716
     /* 35716 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(35768), // Rule ID 1270 //
     /* 35721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbl),
     /* 35729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35750 */     // (intrinsic_w_chain:{ *:[v2i16] } 8034:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBL_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBL_MM),
     /* 35753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35766 */     GIR_RootConstrainSelectedInstOperands,
     /* 35767 */     // GIR_Coverage, 1270,
     /* 35767 */     GIR_EraseRootFromParent_Done,
     /* 35768 */   // Label 978: @35768
     /* 35768 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(35820), // Rule ID 1271 //
     /* 35773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_muleu_s_ph_qbr),
     /* 35781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 35787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35802 */     // (intrinsic_w_chain:{ *:[v2i16] } 8035:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULEU_S_PH_QBR_MM:{ *:[v2i16] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULEU_S_PH_QBR_MM),
     /* 35805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35818 */     GIR_RootConstrainSelectedInstOperands,
     /* 35819 */     // GIR_Coverage, 1271,
     /* 35819 */     GIR_EraseRootFromParent_Done,
     /* 35820 */   // Label 979: @35820
     /* 35820 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(35872), // Rule ID 1272 //
     /* 35825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_ph),
     /* 35833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35854 */     // (intrinsic_w_chain:{ *:[v2i16] } 8036:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_RS_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_PH_MM),
     /* 35857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 35866 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35870 */     GIR_RootConstrainSelectedInstOperands,
     /* 35871 */     // GIR_Coverage, 1272,
     /* 35871 */     GIR_EraseRootFromParent_Done,
     /* 35872 */   // Label 980: @35872
     /* 35872 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(35924), // Rule ID 1275 //
     /* 35877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrqu_s_qb_ph),
     /* 35885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 35888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35906 */     // (intrinsic_w_chain:{ *:[v4i8] } 8093:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECRQU_S_QB_PH_MM:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 35906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQU_S_QB_PH_MM),
     /* 35909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35922 */     GIR_RootConstrainSelectedInstOperands,
     /* 35923 */     // GIR_Coverage, 1275,
     /* 35923 */     GIR_EraseRootFromParent_Done,
     /* 35924 */   // Label 981: @35924
     /* 35924 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(35976), // Rule ID 1276 //
     /* 35929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precrq_rs_ph_w),
     /* 35937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 35943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 35946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 35950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 35958 */     // (intrinsic_w_chain:{ *:[v2i16] } 8092:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (PRECRQ_RS_PH_W_MM:{ *:[v2i16] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 35958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECRQ_RS_PH_W_MM),
     /* 35961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 35963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 35965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 35967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag22*/0,
     /* 35970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 35974 */     GIR_RootConstrainSelectedInstOperands,
     /* 35975 */     // GIR_Coverage, 1276,
     /* 35975 */     GIR_EraseRootFromParent_Done,
     /* 35976 */   // Label 982: @35976
     /* 35976 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(36025), // Rule ID 1294 //
     /* 35981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 35984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_ph),
     /* 35989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 35992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 35995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 35998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36010 */     // (intrinsic_w_chain:{ *:[v2i16] } 8075:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PICK_PH_MM:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_PH_MM),
     /* 36013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36023 */     GIR_RootConstrainSelectedInstOperands,
     /* 36024 */     // GIR_Coverage, 1294,
     /* 36024 */     GIR_EraseRootFromParent_Done,
     /* 36025 */   // Label 983: @36025
     /* 36025 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(36074), // Rule ID 1295 //
     /* 36030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_pick_qb),
     /* 36038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 36041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36059 */     // (intrinsic_w_chain:{ *:[v4i8] } 8076:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (PICK_QB_MM:{ *:[v4i8] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PICK_QB_MM),
     /* 36062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36072 */     GIR_RootConstrainSelectedInstOperands,
     /* 36073 */     // GIR_Coverage, 1295,
     /* 36073 */     GIR_EraseRootFromParent_Done,
     /* 36074 */   // Label 984: @36074
     /* 36074 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(36123), // Rule ID 1305 //
     /* 36079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_eq_qb),
     /* 36087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36108 */     // (intrinsic_w_chain:{ *:[i32] } 7732:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_EQ_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_EQ_QB_MM),
     /* 36111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36121 */     GIR_RootConstrainSelectedInstOperands,
     /* 36122 */     // GIR_Coverage, 1305,
     /* 36122 */     GIR_EraseRootFromParent_Done,
     /* 36123 */   // Label 985: @36123
     /* 36123 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(36172), // Rule ID 1306 //
     /* 36128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_lt_qb),
     /* 36136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36157 */     // (intrinsic_w_chain:{ *:[i32] } 7734:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LT_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LT_QB_MM),
     /* 36160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36170 */     GIR_RootConstrainSelectedInstOperands,
     /* 36171 */     // GIR_Coverage, 1306,
     /* 36171 */     GIR_EraseRootFromParent_Done,
     /* 36172 */   // Label 986: @36172
     /* 36172 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(36221), // Rule ID 1307 //
     /* 36177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 36180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgu_le_qb),
     /* 36185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36206 */     // (intrinsic_w_chain:{ *:[i32] } 7733:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGU_LE_QB_MM:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGU_LE_QB_MM),
     /* 36209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36215 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36219 */     GIR_RootConstrainSelectedInstOperands,
     /* 36220 */     // GIR_Coverage, 1307,
     /* 36220 */     GIR_EraseRootFromParent_Done,
     /* 36221 */   // Label 987: @36221
     /* 36221 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(36273), // Rule ID 1316 //
     /* 36226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_ph),
     /* 36234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36255 */     // (intrinsic_w_chain:{ *:[v2i16] } 7584:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_PH_MMR2),
     /* 36258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36271 */     GIR_RootConstrainSelectedInstOperands,
     /* 36272 */     // GIR_Coverage, 1316,
     /* 36272 */     GIR_EraseRootFromParent_Done,
     /* 36273 */   // Label 988: @36273
     /* 36273 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(36325), // Rule ID 1317 //
     /* 36278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addu_s_ph),
     /* 36286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36307 */     // (intrinsic_w_chain:{ *:[v2i16] } 7586:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (ADDU_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDU_S_PH_MMR2),
     /* 36310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36323 */     GIR_RootConstrainSelectedInstOperands,
     /* 36324 */     // GIR_Coverage, 1317,
     /* 36324 */     GIR_EraseRootFromParent_Done,
     /* 36325 */   // Label 989: @36325
     /* 36325 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(36377), // Rule ID 1328 //
     /* 36330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_eq_qb),
     /* 36338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36359 */     // (intrinsic_w_chain:{ *:[i32] } 7729:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_EQ_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_EQ_QB_MMR2),
     /* 36362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36375 */     GIR_RootConstrainSelectedInstOperands,
     /* 36376 */     // GIR_Coverage, 1328,
     /* 36376 */     GIR_EraseRootFromParent_Done,
     /* 36377 */   // Label 990: @36377
     /* 36377 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(36429), // Rule ID 1329 //
     /* 36382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_lt_qb),
     /* 36390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36411 */     // (intrinsic_w_chain:{ *:[i32] } 7731:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LT_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LT_QB_MMR2),
     /* 36414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36427 */     GIR_RootConstrainSelectedInstOperands,
     /* 36428 */     // GIR_Coverage, 1329,
     /* 36428 */     GIR_EraseRootFromParent_Done,
     /* 36429 */   // Label 991: @36429
     /* 36429 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(36481), // Rule ID 1330 //
     /* 36434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_cmpgdu_le_qb),
     /* 36442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s8,
     /* 36448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s8,
     /* 36451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36463 */     // (intrinsic_w_chain:{ *:[i32] } 7730:{ *:[iPTR] }, DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)  =>  (CMPGDU_LE_QB_MMR2:{ *:[i32] } DSPROpnd:{ *:[v4i8] }:$rs, DSPROpnd:{ *:[v4i8] }:$rt)
     /* 36463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMPGDU_LE_QB_MMR2),
     /* 36466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCCond*/0,
     /* 36475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36479 */     GIR_RootConstrainSelectedInstOperands,
     /* 36480 */     // GIR_Coverage, 1330,
     /* 36480 */     GIR_EraseRootFromParent_Done,
     /* 36481 */   // Label 992: @36481
     /* 36481 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(36533), // Rule ID 1336 //
     /* 36486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_ph),
     /* 36494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36515 */     // (intrinsic_w_chain:{ *:[v2i16] } 8207:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_PH_MMR2),
     /* 36518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36531 */     GIR_RootConstrainSelectedInstOperands,
     /* 36532 */     // GIR_Coverage, 1336,
     /* 36532 */     GIR_EraseRootFromParent_Done,
     /* 36533 */   // Label 993: @36533
     /* 36533 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(36585), // Rule ID 1337 //
     /* 36538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_subu_s_ph),
     /* 36546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36567 */     // (intrinsic_w_chain:{ *:[v2i16] } 8209:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (SUBU_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SUBU_S_PH_MMR2),
     /* 36570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36576 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36583 */     GIR_RootConstrainSelectedInstOperands,
     /* 36584 */     // GIR_Coverage, 1337,
     /* 36584 */     GIR_EraseRootFromParent_Done,
     /* 36585 */   // Label 994: @36585
     /* 36585 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(36637), // Rule ID 1344 //
     /* 36590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_s_ph),
     /* 36598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36619 */     // (intrinsic_w_chain:{ *:[v2i16] } 8031:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MUL_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_S_PH_MMR2),
     /* 36622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36635 */     GIR_RootConstrainSelectedInstOperands,
     /* 36636 */     // GIR_Coverage, 1344,
     /* 36636 */     GIR_EraseRootFromParent_Done,
     /* 36637 */   // Label 995: @36637
     /* 36637 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(36689), // Rule ID 1345 //
     /* 36642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_rs_w),
     /* 36650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36671 */     // (intrinsic_w_chain:{ *:[i32] } 8037:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_RS_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 36671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_RS_W_MMR2),
     /* 36674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36687 */     GIR_RootConstrainSelectedInstOperands,
     /* 36688 */     // GIR_Coverage, 1345,
     /* 36688 */     GIR_EraseRootFromParent_Done,
     /* 36689 */   // Label 996: @36689
     /* 36689 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(36741), // Rule ID 1346 //
     /* 36694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_ph),
     /* 36702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36723 */     // (intrinsic_w_chain:{ *:[v2i16] } 8038:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (MULQ_S_PH_MMR2:{ *:[v2i16] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_PH_MMR2),
     /* 36726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36739 */     GIR_RootConstrainSelectedInstOperands,
     /* 36740 */     // GIR_Coverage, 1346,
     /* 36740 */     GIR_EraseRootFromParent_Done,
     /* 36741 */   // Label 997: @36741
     /* 36741 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(36793), // Rule ID 1347 //
     /* 36746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mulq_s_w),
     /* 36754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36775 */     // (intrinsic_w_chain:{ *:[i32] } 8039:{ *:[iPTR] }, GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MULQ_S_W_MMR2:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 36775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MULQ_S_W_MMR2),
     /* 36778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36791 */     GIR_RootConstrainSelectedInstOperands,
     /* 36792 */     // GIR_Coverage, 1347,
     /* 36792 */     GIR_EraseRootFromParent_Done,
     /* 36793 */   // Label 998: @36793
     /* 36793 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(36842), // Rule ID 1348 //
     /* 36798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2_InMicroMips),
     /* 36801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_precr_qb_ph),
     /* 36806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s8,
     /* 36809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36827 */     // (intrinsic_w_chain:{ *:[v4i8] } 8087:{ *:[iPTR] }, DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)  =>  (PRECR_QB_PH_MMR2:{ *:[v4i8] } DSPROpnd:{ *:[v2i16] }:$rs, DSPROpnd:{ *:[v2i16] }:$rt)
     /* 36827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::PRECR_QB_PH_MMR2),
     /* 36830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 36834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 36836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36840 */     GIR_RootConstrainSelectedInstOperands,
     /* 36841 */     // GIR_Coverage, 1348,
     /* 36841 */     GIR_EraseRootFromParent_Done,
     /* 36842 */   // Label 999: @36842
     /* 36842 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(36886), // Rule ID 1925 //
     /* 36847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSPR2),
     /* 36850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_mul_ph),
     /* 36855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s16,
     /* 36858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s16,
     /* 36861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s16,
     /* 36864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::DSPRRegClassID),
     /* 36868 */     // (intrinsic_w_chain:{ *:[v2i16] } 8028:{ *:[iPTR] }, v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)  =>  (MUL_PH:{ *:[v2i16] } v2i16:{ *:[v2i16] }:$a, v2i16:{ *:[v2i16] }:$b)
     /* 36868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MUL_PH),
     /* 36871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36873 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36875 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag21*/0,
     /* 36880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36884 */     GIR_RootConstrainSelectedInstOperands,
     /* 36885 */     // GIR_Coverage, 1925,
     /* 36885 */     GIR_EraseRootFromParent_Done,
     /* 36886 */   // Label 1000: @36886
     /* 36886 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(36930), // Rule ID 1931 //
     /* 36891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 36894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addsc),
     /* 36899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36912 */     // (intrinsic_w_chain:{ *:[i32] } 7583:{ *:[iPTR] }, i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)  =>  (ADDSC:{ *:[i32] } i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)
     /* 36912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDSC),
     /* 36915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36917 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36919 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPCarry*/0,
     /* 36924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36928 */     GIR_RootConstrainSelectedInstOperands,
     /* 36929 */     // GIR_Coverage, 1931,
     /* 36929 */     GIR_EraseRootFromParent_Done,
     /* 36930 */   // Label 1001: @36930
     /* 36930 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(36974), // Rule ID 1933 //
     /* 36935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 36938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_addwc),
     /* 36943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 36946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 36949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 36956 */     // (intrinsic_w_chain:{ *:[i32] } 7598:{ *:[iPTR] }, i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)  =>  (ADDWC:{ *:[i32] } i32:{ *:[i32] }:$a, i32:{ *:[i32] }:$b)
     /* 36956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ADDWC),
     /* 36959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 36961 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 36963 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 36965 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for Mips::DSPOutFlag20*/0,
     /* 36968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 36972 */     GIR_RootConstrainSelectedInstOperands,
     /* 36973 */     // GIR_Coverage, 1933,
     /* 36973 */     GIR_EraseRootFromParent_Done,
     /* 36974 */   // Label 1002: @36974
     /* 36974 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(37020), // Rule ID 487 //
     /* 36979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 36982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ldr_d),
     /* 36987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 36990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 36993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 36997 */     // MIs[0] ptr
     /* 36997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37005 */     // (intrinsic_w_chain:{ *:[v2i64] } 7948:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (LDR_D:{ *:[v2i64] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LDR_D),
     /* 37008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37010 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37012 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37018 */     GIR_RootConstrainSelectedInstOperands,
     /* 37019 */     // GIR_Coverage, 487,
     /* 37019 */     GIR_EraseRootFromParent_Done,
     /* 37020 */   // Label 1003: @37020
     /* 37020 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(37066), // Rule ID 488 //
     /* 37025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_ldr_w),
     /* 37033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 37036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 37043 */     // MIs[0] ptr
     /* 37043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37051 */     // (intrinsic_w_chain:{ *:[v4i32] } 7949:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (LDR_W:{ *:[v4i32] } iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LDR_W),
     /* 37054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37056 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37058 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37064 */     GIR_RootConstrainSelectedInstOperands,
     /* 37065 */     // GIR_Coverage, 488,
     /* 37065 */     GIR_EraseRootFromParent_Done,
     /* 37066 */   // Label 1004: @37066
     /* 37066 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(37108), // Rule ID 434 //
     /* 37071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lwx),
     /* 37079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37089 */     // MIs[0] base
     /* 37089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37093 */     // (intrinsic_w_chain:{ *:[i32] } 7952:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LWX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX),
     /* 37096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37098 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37100 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37106 */     GIR_RootConstrainSelectedInstOperands,
     /* 37107 */     // GIR_Coverage, 434,
     /* 37107 */     GIR_EraseRootFromParent_Done,
     /* 37108 */   // Label 1005: @37108
     /* 37108 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(37150), // Rule ID 435 //
     /* 37113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lhx),
     /* 37121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37131 */     // MIs[0] base
     /* 37131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37135 */     // (intrinsic_w_chain:{ *:[i32] } 7950:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LHX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX),
     /* 37138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37140 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37142 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37148 */     GIR_RootConstrainSelectedInstOperands,
     /* 37149 */     // GIR_Coverage, 435,
     /* 37149 */     GIR_EraseRootFromParent_Done,
     /* 37150 */   // Label 1006: @37150
     /* 37150 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(37192), // Rule ID 436 //
     /* 37155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP),
     /* 37158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lbux),
     /* 37163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37173 */     // MIs[0] base
     /* 37173 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37177 */     // (intrinsic_w_chain:{ *:[i32] } 7939:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LBUX:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX),
     /* 37180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37182 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37184 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37190 */     GIR_RootConstrainSelectedInstOperands,
     /* 37191 */     // GIR_Coverage, 436,
     /* 37191 */     GIR_EraseRootFromParent_Done,
     /* 37192 */   // Label 1007: @37192
     /* 37192 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(37234), // Rule ID 1277 //
     /* 37197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lbux),
     /* 37205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37215 */     // MIs[0] base
     /* 37215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37219 */     // (intrinsic_w_chain:{ *:[i32] } 7939:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LBUX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LBUX_MM),
     /* 37222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37224 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37226 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37232 */     GIR_RootConstrainSelectedInstOperands,
     /* 37233 */     // GIR_Coverage, 1277,
     /* 37233 */     GIR_EraseRootFromParent_Done,
     /* 37234 */   // Label 1008: @37234
     /* 37234 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(37276), // Rule ID 1278 //
     /* 37239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lhx),
     /* 37247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37257 */     // MIs[0] base
     /* 37257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37261 */     // (intrinsic_w_chain:{ *:[i32] } 7950:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LHX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LHX_MM),
     /* 37264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37266 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37268 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37274 */     GIR_RootConstrainSelectedInstOperands,
     /* 37275 */     // GIR_Coverage, 1278,
     /* 37275 */     GIR_EraseRootFromParent_Done,
     /* 37276 */   // Label 1009: @37276
     /* 37276 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(37318), // Rule ID 1279 //
     /* 37281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_InMicroMips),
     /* 37284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::mips_lwx),
     /* 37289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37299 */     // MIs[0] base
     /* 37299 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37303 */     // (intrinsic_w_chain:{ *:[i32] } 7952:{ *:[iPTR] }, iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)  =>  (LWX_MM:{ *:[i32] } iPTR:{ *:[iPTR] }:$base, iPTR:{ *:[i32] }:$index)
     /* 37303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LWX_MM),
     /* 37306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37308 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 37310 */     GIR_RootToRootCopy, /*OpIdx*/3, // index
     /* 37312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37316 */     GIR_RootConstrainSelectedInstOperands,
     /* 37317 */     // GIR_Coverage, 1279,
     /* 37317 */     GIR_EraseRootFromParent_Done,
     /* 37318 */   // Label 1010: @37318
     /* 37318 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(37364), // Rule ID 489 //
     /* 37323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_str_d),
     /* 37331 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 37334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 37341 */     // MIs[0] ptr
     /* 37341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37349 */     // (intrinsic_void 8182:{ *:[iPTR] }, MSA128DOpnd:{ *:[v2i64] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (STR_D MSA128DOpnd:{ *:[v2i64] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::STR_D),
     /* 37352 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 37354 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37356 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37362 */     GIR_RootConstrainSelectedInstOperands,
     /* 37363 */     // GIR_Coverage, 489,
     /* 37363 */     GIR_EraseRootFromParent_Done,
     /* 37364 */   // Label 1011: @37364
     /* 37364 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(37410), // Rule ID 490 //
     /* 37369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotInMips16Mode),
     /* 37372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::mips_str_w),
     /* 37377 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 37380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 37383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 37387 */     // MIs[0] ptr
     /* 37387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 37391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37395 */     // (intrinsic_void 8183:{ *:[iPTR] }, MSA128WOpnd:{ *:[v4i32] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)  =>  (STR_W MSA128WOpnd:{ *:[v4i32] }:$dst, iPTR:{ *:[iPTR] }:$ptr, GPR32:{ *:[i32] }:$imm)
     /* 37395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::STR_W),
     /* 37398 */     GIR_RootToRootCopy, /*OpIdx*/1, // dst
     /* 37400 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 37402 */     GIR_RootToRootCopy, /*OpIdx*/3, // imm
     /* 37404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 37408 */     GIR_RootConstrainSelectedInstOperands,
     /* 37409 */     // GIR_Coverage, 490,
     /* 37409 */     GIR_EraseRootFromParent_Done,
     /* 37410 */   // Label 1012: @37410
     /* 37410 */   GIM_Reject,
     /* 37411 */ // Label 931: @37411
     /* 37411 */ GIM_Reject,
     /* 37412 */ // Label 31: @37412
     /* 37412 */ GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(37477), // Rule ID 1582 //
     /* 37417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 37420 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 37423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37434 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 37434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 37458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37461 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37466 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37471 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37476 */   // GIR_Coverage, 1582,
     /* 37476 */   GIR_EraseRootFromParent_Done,
     /* 37477 */ // Label 1013: @37477
     /* 37477 */ GIM_Reject,
     /* 37478 */ // Label 32: @37478
     /* 37478 */ GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(37541), // Rule ID 1575 //
     /* 37483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 37486 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 37492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37500 */   // (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$src)  =>  (SLL:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i32] })
     /* 37500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 37503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 37507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37512 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 37518 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 37523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37528 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 37531 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37533 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 37539 */   GIR_RootConstrainSelectedInstOperands,
     /* 37540 */   // GIR_Coverage, 1575,
     /* 37540 */   GIR_EraseRootFromParent_Done,
     /* 37541 */ // Label 1014: @37541
     /* 37541 */ GIM_Reject,
     /* 37542 */ // Label 33: @37542
     /* 37542 */ GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(37602),
     /* 37547 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 37550 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(37576), // Rule ID 2158 //
     /* 37555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 37558 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immLi16),
     /* 37562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 37566 */     // MIs[0] Operand 1
     /* 37566 */     // No operand predicates
     /* 37566 */     // (imm:{ *:[i32] })<<P:Predicate_immLi16>>:$imm  =>  (LI16_MM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_immLi16>>:$imm)
     /* 37566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LI16_MM),
     /* 37569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 37571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 37574 */     GIR_RootConstrainSelectedInstOperands,
     /* 37575 */     // GIR_Coverage, 2158,
     /* 37575 */     GIR_EraseRootFromParent_Done,
     /* 37576 */   // Label 1016: @37576
     /* 37576 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(37601), // Rule ID 1849 //
     /* 37581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 37584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 37588 */     // MIs[0] Operand 1
     /* 37588 */     // No operand predicates
     /* 37588 */     // (imm:{ *:[i32] }):$imm  =>  (LwConstant32:{ *:[i32] } (imm:{ *:[i32] }):$imm, -1:{ *:[i32] })
     /* 37588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::LwConstant32),
     /* 37591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 37593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 37596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 37599 */     GIR_RootConstrainSelectedInstOperands,
     /* 37600 */     // GIR_Coverage, 1849,
     /* 37600 */     GIR_EraseRootFromParent_Done,
     /* 37601 */   // Label 1017: @37601
     /* 37601 */   GIM_Reject,
     /* 37602 */ // Label 1015: @37602
     /* 37602 */ GIM_Reject,
     /* 37603 */ // Label 34: @37603
     /* 37603 */ GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(39066),
     /* 37608 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 37611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 37614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37618 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(37723), // Rule ID 1631 //
     /* 37623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 37631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37652 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37656 */     // MIs[2] Operand 1
     /* 37656 */     // No operand predicates
     /* 37656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37658 */     // (sext:{ *:[i64] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRA:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRA),
     /* 37665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37670 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37717 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37722 */     // GIR_Coverage, 1631,
     /* 37722 */     GIR_EraseRootFromParent_Done,
     /* 37723 */   // Label 1019: @37723
     /* 37723 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(37828), // Rule ID 1627 //
     /* 37728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 37736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37757 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37761 */     // MIs[2] Operand 1
     /* 37761 */     // No operand predicates
     /* 37761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37763 */     // (sext:{ *:[i64] } (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRL:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37763 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37766 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRL),
     /* 37770 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37775 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37817 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37827 */     // GIR_Coverage, 1627,
     /* 37827 */     GIR_EraseRootFromParent_Done,
     /* 37828 */   // Label 1020: @37828
     /* 37828 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(37933), // Rule ID 1623 //
     /* 37833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 37841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 37858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 37862 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 37866 */     // MIs[2] Operand 1
     /* 37866 */     // No operand predicates
     /* 37866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 37868 */     // (sext:{ *:[i64] } (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SLL:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm5), sub_32:{ *:[i32] })
     /* 37868 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37871 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 37875 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37880 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/2, // imm5
     /* 37887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 37903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 37906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 37908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 37911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 37914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 37917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37922 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 37927 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37932 */     // GIR_Coverage, 1623,
     /* 37932 */     GIR_EraseRootFromParent_Done,
     /* 37933 */   // Label 1021: @37933
     /* 37933 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(38032), // Rule ID 1613 //
     /* 37938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 37942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 37946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 37950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 37954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 37964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 37966 */     // (sext:{ *:[i64] } (add:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (ADDu:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 37966 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 37969 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::ADDu),
     /* 37973 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 37978 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 37982 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 37986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 37988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 37991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 37995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38031 */     // GIR_Coverage, 1613,
     /* 38031 */     GIR_EraseRootFromParent_Done,
     /* 38032 */   // Label 1022: @38032
     /* 38032 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(38131), // Rule ID 1633 //
     /* 38037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 38045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38065 */     // (sext:{ *:[i64] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRAV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38065 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38068 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRAV),
     /* 38072 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38077 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38081 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38115 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38120 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38130 */     // GIR_Coverage, 1633,
     /* 38130 */     GIR_EraseRootFromParent_Done,
     /* 38131 */   // Label 1023: @38131
     /* 38131 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(38230), // Rule ID 1629 //
     /* 38136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /* 38144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38164 */     // (sext:{ *:[i64] } (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SRLV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38164 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38167 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SRLV),
     /* 38171 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38176 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38180 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38214 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38219 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38224 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38229 */     // GIR_Coverage, 1629,
     /* 38229 */     GIR_EraseRootFromParent_Done,
     /* 38230 */   // Label 1024: @38230
     /* 38230 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(38338), // Rule ID 1617 //
     /* 38235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 38238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 38246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38266 */     // (sext:{ *:[i64] } (mul:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MUL:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38266 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38269 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MUL),
     /* 38273 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38278 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38282 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38286 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for Mips::HI0*/0,
     /* 38289 */     GIR_SetImplicitDefDead, /*InsnID*/2, /*OpIdx for Mips::LO0*/1,
     /* 38292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38337 */     // GIR_Coverage, 1617,
     /* 38337 */     GIR_EraseRootFromParent_Done,
     /* 38338 */   // Label 1025: @38338
     /* 38338 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(38440), // Rule ID 1816 //
     /* 38343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 38354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38374 */     // (sext:{ *:[i64] } (mul:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MUL_R6:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38374 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38377 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MUL_R6),
     /* 38381 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38390 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38434 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38439 */     // GIR_Coverage, 1816,
     /* 38439 */     GIR_EraseRootFromParent_Done,
     /* 38440 */   // Label 1026: @38440
     /* 38440 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(38542), // Rule ID 1817 //
     /* 38445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SDIV),
     /* 38456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38476 */     // (sext:{ *:[i64] } (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (DIV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38476 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38479 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::DIV),
     /* 38483 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38492 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38526 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38541 */     // GIR_Coverage, 1817,
     /* 38541 */     GIR_EraseRootFromParent_Done,
     /* 38542 */   // Label 1027: @38542
     /* 38542 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(38641), // Rule ID 1625 //
     /* 38547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 38555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38575 */     // (sext:{ *:[i64] } (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SLLV:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLLV),
     /* 38582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38591 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38640 */     // GIR_Coverage, 1625,
     /* 38640 */     GIR_EraseRootFromParent_Done,
     /* 38641 */   // Label 1028: @38641
     /* 38641 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(38743), // Rule ID 1819 //
     /* 38646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SREM),
     /* 38657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38677 */     // (sext:{ *:[i64] } (srem:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MOD:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MOD),
     /* 38684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38689 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38693 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38727 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38742 */     // GIR_Coverage, 1819,
     /* 38742 */     GIR_EraseRootFromParent_Done,
     /* 38743 */   // Label 1029: @38743
     /* 38743 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(38842), // Rule ID 1615 //
     /* 38748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 38756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38776 */     // (sext:{ *:[i64] } (sub:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (SUBu:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SUBu),
     /* 38783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38792 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38841 */     // GIR_Coverage, 1615,
     /* 38841 */     GIR_EraseRootFromParent_Done,
     /* 38842 */   // Label 1030: @38842
     /* 38842 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(38944), // Rule ID 1818 //
     /* 38847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UDIV),
     /* 38858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38878 */     // (sext:{ *:[i64] } (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (DIVU:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::DIVU),
     /* 38885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38890 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38894 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 38898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 38900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 38903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 38907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 38914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 38917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 38919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 38922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 38925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 38928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 38938 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38943 */     // GIR_Coverage, 1818,
     /* 38943 */     GIR_EraseRootFromParent_Done,
     /* 38944 */   // Label 1031: @38944
     /* 38944 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(39046), // Rule ID 1820 //
     /* 38949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 38952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 38956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_UREM),
     /* 38960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 38964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 38968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 38978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 38980 */     // (sext:{ *:[i64] } (urem:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2))  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (MODU:{ *:[i32] } GPR32:{ *:[i32] }:$src, GPR32:{ *:[i32] }:$src2), sub_32:{ *:[i32] })
     /* 38980 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 38983 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::MODU),
     /* 38987 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 38992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 38996 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 39000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 39002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 39009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 39019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 39021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 39027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 39030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39045 */     // GIR_Coverage, 1820,
     /* 39045 */     GIR_EraseRootFromParent_Done,
     /* 39046 */   // Label 1032: @39046
     /* 39046 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(39065), // Rule ID 1585 //
     /* 39051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39058 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SLL64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src)
     /* 39058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 39063 */     GIR_RootConstrainSelectedInstOperands,
     /* 39064 */     // GIR_Coverage, 1585,
     /* 39064 */     GIR_Done,
     /* 39065 */   // Label 1033: @39065
     /* 39065 */   GIM_Reject,
     /* 39066 */ // Label 1018: @39066
     /* 39066 */ GIM_Reject,
     /* 39067 */ // Label 35: @39067
     /* 39067 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1036*/ GIMT_Encode4(39414),
     /* 39078 */ /*GILLT_s32*//*Label 1034*/ GIMT_Encode4(39086),
     /* 39082 */ /*GILLT_s64*//*Label 1035*/ GIMT_Encode4(39312),
     /* 39086 */ // Label 1034: @39086
     /* 39086 */ GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(39311),
     /* 39091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39094 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(39130), // Rule ID 106 //
     /* 39099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 39102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39110 */     // MIs[0] Operand 2
     /* 39110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39121 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i8:{ *:[Other] })  =>  (SEB:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB),
     /* 39124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39128 */     GIR_RootConstrainSelectedInstOperands,
     /* 39129 */     // GIR_Coverage, 106,
     /* 39129 */     GIR_EraseRootFromParent_Done,
     /* 39130 */   // Label 1038: @39130
     /* 39130 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(39166), // Rule ID 107 //
     /* 39135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 39138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39146 */     // MIs[0] Operand 2
     /* 39146 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39157 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i16:{ *:[Other] })  =>  (SEH:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH),
     /* 39160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39164 */     GIR_RootConstrainSelectedInstOperands,
     /* 39165 */     // GIR_Coverage, 107,
     /* 39165 */     GIR_EraseRootFromParent_Done,
     /* 39166 */   // Label 1039: @39166
     /* 39166 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(39202), // Rule ID 1101 //
     /* 39171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39182 */     // MIs[0] Operand 2
     /* 39182 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39193 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i8:{ *:[Other] })  =>  (SEB_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB_MM),
     /* 39196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39200 */     GIR_RootConstrainSelectedInstOperands,
     /* 39201 */     // GIR_Coverage, 1101,
     /* 39201 */     GIR_EraseRootFromParent_Done,
     /* 39202 */   // Label 1040: @39202
     /* 39202 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(39238), // Rule ID 1102 //
     /* 39207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39218 */     // MIs[0] Operand 2
     /* 39218 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39229 */     // (sext_inreg:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, i16:{ *:[Other] })  =>  (SEH_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt)
     /* 39229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH_MM),
     /* 39232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39236 */     GIR_RootConstrainSelectedInstOperands,
     /* 39237 */     // GIR_Coverage, 1102,
     /* 39237 */     GIR_EraseRootFromParent_Done,
     /* 39238 */   // Label 1041: @39238
     /* 39238 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(39274), // Rule ID 1907 //
     /* 39243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39254 */     // MIs[0] Operand 2
     /* 39254 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39265 */     // (sext_inreg:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val, i8:{ *:[Other] })  =>  (SebRx16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val)
     /* 39265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SebRx16),
     /* 39268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39270 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 39272 */     GIR_RootConstrainSelectedInstOperands,
     /* 39273 */     // GIR_Coverage, 1907,
     /* 39273 */     GIR_EraseRootFromParent_Done,
     /* 39274 */   // Label 1042: @39274
     /* 39274 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(39310), // Rule ID 1908 //
     /* 39279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39290 */     // MIs[0] Operand 2
     /* 39290 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39301 */     // (sext_inreg:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val, i16:{ *:[Other] })  =>  (SehRx16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$val)
     /* 39301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SehRx16),
     /* 39304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39306 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 39308 */     GIR_RootConstrainSelectedInstOperands,
     /* 39309 */     // GIR_Coverage, 1908,
     /* 39309 */     GIR_EraseRootFromParent_Done,
     /* 39310 */   // Label 1043: @39310
     /* 39310 */   GIM_Reject,
     /* 39311 */ // Label 1037: @39311
     /* 39311 */ GIM_Reject,
     /* 39312 */ // Label 1035: @39312
     /* 39312 */ GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(39413),
     /* 39317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 39320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39328 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(39356), // Rule ID 261 //
     /* 39333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_IsGP64bit),
     /* 39336 */     // MIs[0] Operand 2
     /* 39336 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 39347 */     // (sext_inreg:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, i8:{ *:[Other] })  =>  (SEB64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt)
     /* 39347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEB64),
     /* 39350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39354 */     GIR_RootConstrainSelectedInstOperands,
     /* 39355 */     // GIR_Coverage, 261,
     /* 39355 */     GIR_EraseRootFromParent_Done,
     /* 39356 */   // Label 1045: @39356
     /* 39356 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(39384), // Rule ID 262 //
     /* 39361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_IsGP64bit),
     /* 39364 */     // MIs[0] Operand 2
     /* 39364 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 39375 */     // (sext_inreg:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, i16:{ *:[Other] })  =>  (SEH64:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt)
     /* 39375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEH64),
     /* 39378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39382 */     GIR_RootConstrainSelectedInstOperands,
     /* 39383 */     // GIR_Coverage, 262,
     /* 39383 */     GIR_EraseRootFromParent_Done,
     /* 39384 */   // Label 1046: @39384
     /* 39384 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(39412), // Rule ID 1588 //
     /* 39389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39392 */     // MIs[0] Operand 2
     /* 39392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 39403 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SLL64_64:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 39403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL64_64),
     /* 39406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39408 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39410 */     GIR_RootConstrainSelectedInstOperands,
     /* 39411 */     // GIR_Coverage, 1588,
     /* 39411 */     GIR_EraseRootFromParent_Done,
     /* 39412 */   // Label 1047: @39412
     /* 39412 */   GIM_Reject,
     /* 39413 */ // Label 1044: @39413
     /* 39413 */ GIM_Reject,
     /* 39414 */ // Label 1036: @39414
     /* 39414 */ GIM_Reject,
     /* 39415 */ // Label 36: @39415
     /* 39415 */ GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(39615),
     /* 39420 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 39423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39430 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(39486), // Rule ID 280 //
     /* 39435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 39438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 39442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 39446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 39450 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 39454 */     // MIs[1] Operand 1
     /* 39454 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 39459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39471 */     // (zext:{ *:[i64] } (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETEQ:{ *:[Other] }))  =>  (SEQ:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 39471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEQ),
     /* 39474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 39480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 39484 */     GIR_RootConstrainSelectedInstOperands,
     /* 39485 */     // GIR_Coverage, 280,
     /* 39485 */     GIR_EraseRootFromParent_Done,
     /* 39486 */   // Label 1049: @39486
     /* 39486 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(39542), // Rule ID 282 //
     /* 39491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 39494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 39498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 39502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 39506 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 39510 */     // MIs[1] Operand 1
     /* 39510 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 39515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39527 */     // (zext:{ *:[i64] } (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETNE:{ *:[Other] }))  =>  (SNE:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 39527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SNE),
     /* 39530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs
     /* 39536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // rt
     /* 39540 */     GIR_RootConstrainSelectedInstOperands,
     /* 39541 */     // GIR_Coverage, 282,
     /* 39541 */     GIR_EraseRootFromParent_Done,
     /* 39542 */   // Label 1050: @39542
     /* 39542 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(39614),
     /* 39547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39551 */     GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(39590), // Rule ID 1583 //
     /* 39556 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39559 */       // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (DSRL:{ *:[i64] } (DSLL64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src), 32:{ *:[i32] })
     /* 39559 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 39562 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::DSLL64_32),
     /* 39566 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 39571 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 39575 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 39577 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRL),
     /* 39580 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39582 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 39585 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 39588 */       GIR_RootConstrainSelectedInstOperands,
     /* 39589 */       // GIR_Coverage, 1583,
     /* 39589 */       GIR_EraseRootFromParent_Done,
     /* 39590 */     // Label 1052: @39590
     /* 39590 */     GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(39613), // Rule ID 1586 //
     /* 39595 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 39598 */       // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (DEXT64_32:{ *:[i64] } GPR32:{ *:[i32] }:$src, 0:{ *:[i32] }, 32:{ *:[i32] })
     /* 39598 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DEXT64_32),
     /* 39601 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 39603 */       GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39605 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 39608 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 39611 */       GIR_RootConstrainSelectedInstOperands,
     /* 39612 */       // GIR_Coverage, 1586,
     /* 39612 */       GIR_EraseRootFromParent_Done,
     /* 39613 */     // Label 1053: @39613
     /* 39613 */     GIM_Reject,
     /* 39614 */   // Label 1051: @39614
     /* 39614 */   GIM_Reject,
     /* 39615 */ // Label 1048: @39615
     /* 39615 */ GIM_Reject,
     /* 39616 */ // Label 37: @39616
     /* 39616 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1060*/ GIMT_Encode4(41412),
     /* 39627 */ /*GILLT_s32*//*Label 1054*/ GIMT_Encode4(39659),
     /* 39631 */ /*GILLT_s64*//*Label 1055*/ GIMT_Encode4(39921), GIMT_Encode4(0),
     /* 39639 */ /*GILLT_v2s64*//*Label 1056*/ GIMT_Encode4(40062), GIMT_Encode4(0),
     /* 39647 */ /*GILLT_v4s32*//*Label 1057*/ GIMT_Encode4(40096),
     /* 39651 */ /*GILLT_v8s16*//*Label 1058*/ GIMT_Encode4(40364),
     /* 39655 */ /*GILLT_v16s8*//*Label 1059*/ GIMT_Encode4(40760),
     /* 39659 */ // Label 1054: @39659
     /* 39659 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(39920),
     /* 39664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 39667 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 39670 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(39712), // Rule ID 55 //
     /* 39675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 39678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39698 */     // MIs[1] Operand 1
     /* 39698 */     // No operand predicates
     /* 39698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39700 */     // (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SLL:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 39700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL),
     /* 39703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 39710 */     GIR_RootConstrainSelectedInstOperands,
     /* 39711 */     // GIR_Coverage, 55,
     /* 39711 */     GIR_EraseRootFromParent_Done,
     /* 39712 */   // Label 1062: @39712
     /* 39712 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(39754), // Rule ID 1831 //
     /* 39717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39736 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39740 */     // MIs[1] Operand 1
     /* 39740 */     // No operand predicates
     /* 39740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39742 */     // (shl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SllX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 39742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SllX16),
     /* 39745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 39747 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 39749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39752 */     GIR_RootConstrainSelectedInstOperands,
     /* 39753 */     // GIR_Coverage, 1831,
     /* 39753 */     GIR_EraseRootFromParent_Done,
     /* 39754 */   // Label 1063: @39754
     /* 39754 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(39796), // Rule ID 2170 //
     /* 39759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 39766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 39770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Shift),
     /* 39782 */     // MIs[1] Operand 1
     /* 39782 */     // No operand predicates
     /* 39782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39784 */     // (shl:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)  =>  (SLL16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)
     /* 39784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL16_MM),
     /* 39787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39789 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39794 */     GIR_RootConstrainSelectedInstOperands,
     /* 39795 */     // GIR_Coverage, 2170,
     /* 39795 */     GIR_EraseRootFromParent_Done,
     /* 39796 */   // Label 1064: @39796
     /* 39796 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(39838), // Rule ID 2171 //
     /* 39801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 39824 */     // MIs[1] Operand 1
     /* 39824 */     // No operand predicates
     /* 39824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39826 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SLL_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 39826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_MM),
     /* 39829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39831 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 39833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 39836 */     GIR_RootConstrainSelectedInstOperands,
     /* 39837 */     // GIR_Coverage, 2171,
     /* 39837 */     GIR_EraseRootFromParent_Done,
     /* 39838 */   // Label 1065: @39838
     /* 39838 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(39865), // Rule ID 61 //
     /* 39843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 39846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39858 */     // (shl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SLLV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 39858 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLLV),
     /* 39863 */     GIR_RootConstrainSelectedInstOperands,
     /* 39864 */     // GIR_Coverage, 61,
     /* 39864 */     GIR_Done,
     /* 39865 */   // Label 1066: @39865
     /* 39865 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(39892), // Rule ID 1834 //
     /* 39870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 39873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 39885 */     // (shl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SllvRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 39885 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SllvRxRy16),
     /* 39890 */     GIR_RootConstrainSelectedInstOperands,
     /* 39891 */     // GIR_Coverage, 1834,
     /* 39891 */     GIR_Done,
     /* 39892 */   // Label 1067: @39892
     /* 39892 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(39919), // Rule ID 2172 //
     /* 39897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 39900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 39912 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SLLV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 39912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLLV_MM),
     /* 39917 */     GIR_RootConstrainSelectedInstOperands,
     /* 39918 */     // GIR_Coverage, 2172,
     /* 39918 */     GIR_Done,
     /* 39919 */   // Label 1068: @39919
     /* 39919 */   GIM_Reject,
     /* 39920 */ // Label 1061: @39920
     /* 39920 */ GIM_Reject,
     /* 39921 */ // Label 1055: @39921
     /* 39921 */ GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(40061),
     /* 39926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 39929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 39932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39940 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(39974), // Rule ID 210 //
     /* 39945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 39948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 39956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 39960 */     // MIs[1] Operand 1
     /* 39960 */     // No operand predicates
     /* 39960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 39962 */     // (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSLL:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 39962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSLL),
     /* 39965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 39967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 39969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 39972 */     GIR_RootConstrainSelectedInstOperands,
     /* 39973 */     // GIR_Coverage, 210,
     /* 39973 */     GIR_EraseRootFromParent_Done,
     /* 39974 */   // Label 1070: @39974
     /* 39974 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(40041), // Rule ID 1576 //
     /* 39979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 39982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 39986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 39990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 39994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 39999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 40001 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSLLV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 40001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 40004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 40008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 40013 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 40019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 40024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 40029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSLLV),
     /* 40032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 40034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 40036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 40039 */     GIR_RootConstrainSelectedInstOperands,
     /* 40040 */     // GIR_Coverage, 1576,
     /* 40040 */     GIR_EraseRootFromParent_Done,
     /* 40041 */   // Label 1071: @40041
     /* 40041 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(40060), // Rule ID 216 //
     /* 40046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 40049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 40053 */     // (shl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSLLV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 40053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSLLV),
     /* 40058 */     GIR_RootConstrainSelectedInstOperands,
     /* 40059 */     // GIR_Coverage, 216,
     /* 40059 */     GIR_Done,
     /* 40060 */   // Label 1072: @40060
     /* 40060 */   GIM_Reject,
     /* 40061 */ // Label 1069: @40061
     /* 40061 */ GIM_Reject,
     /* 40062 */ // Label 1056: @40062
     /* 40062 */ GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(40095), // Rule ID 960 //
     /* 40067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 40073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 40076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 40088 */   // (shl:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SLL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 40088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_D),
     /* 40093 */   GIR_RootConstrainSelectedInstOperands,
     /* 40094 */   // GIR_Coverage, 960,
     /* 40094 */   GIR_Done,
     /* 40095 */ // Label 1073: @40095
     /* 40095 */ GIM_Reject,
     /* 40096 */ // Label 1057: @40096
     /* 40096 */ GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(40363),
     /* 40101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40111 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(40225), // Rule ID 2462 //
     /* 40116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40143 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 40146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40154 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40158 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40162 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40166 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40170 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40174 */     // MIs[3] Operand 1
     /* 40174 */     // No operand predicates
     /* 40174 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40178 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40182 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40186 */     // MIs[4] Operand 1
     /* 40186 */     // No operand predicates
     /* 40186 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40190 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40194 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40198 */     // MIs[5] Operand 1
     /* 40198 */     // No operand predicates
     /* 40198 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40202 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40206 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40210 */     // MIs[6] Operand 1
     /* 40210 */     // No operand predicates
     /* 40210 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 40212 */     // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SLL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 40212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40217 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 40223 */     GIR_RootConstrainSelectedInstOperands,
     /* 40224 */     // GIR_Coverage, 2462,
     /* 40224 */     GIR_EraseRootFromParent_Done,
     /* 40225 */   // Label 1075: @40225
     /* 40225 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(40339), // Rule ID 2071 //
     /* 40230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 40245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 40249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 40253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40257 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 40260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40268 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40272 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40276 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40280 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40284 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40288 */     // MIs[3] Operand 1
     /* 40288 */     // No operand predicates
     /* 40288 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40292 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40296 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40300 */     // MIs[4] Operand 1
     /* 40300 */     // No operand predicates
     /* 40300 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40304 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40308 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40312 */     // MIs[5] Operand 1
     /* 40312 */     // No operand predicates
     /* 40312 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40316 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40320 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 40324 */     // MIs[6] Operand 1
     /* 40324 */     // No operand predicates
     /* 40324 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 40326 */     // (shl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SLL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 40326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40331 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 40337 */     GIR_RootConstrainSelectedInstOperands,
     /* 40338 */     // GIR_Coverage, 2071,
     /* 40338 */     GIR_EraseRootFromParent_Done,
     /* 40339 */   // Label 1076: @40339
     /* 40339 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(40362), // Rule ID 959 //
     /* 40344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 40355 */     // (shl:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SLL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 40355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_W),
     /* 40360 */     GIR_RootConstrainSelectedInstOperands,
     /* 40361 */     // GIR_Coverage, 959,
     /* 40361 */     GIR_Done,
     /* 40362 */   // Label 1077: @40362
     /* 40362 */   GIM_Reject,
     /* 40363 */ // Label 1074: @40363
     /* 40363 */ GIM_Reject,
     /* 40364 */ // Label 1058: @40364
     /* 40364 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(40759),
     /* 40369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40379 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(40557), // Rule ID 2461 //
     /* 40384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40411 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 40414 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40422 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40426 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40430 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40434 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40438 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40442 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40454 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40458 */     // MIs[3] Operand 1
     /* 40458 */     // No operand predicates
     /* 40458 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40462 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40466 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40470 */     // MIs[4] Operand 1
     /* 40470 */     // No operand predicates
     /* 40470 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40474 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40478 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40482 */     // MIs[5] Operand 1
     /* 40482 */     // No operand predicates
     /* 40482 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40486 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40490 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40494 */     // MIs[6] Operand 1
     /* 40494 */     // No operand predicates
     /* 40494 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40498 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40502 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40506 */     // MIs[7] Operand 1
     /* 40506 */     // No operand predicates
     /* 40506 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40510 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40514 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40518 */     // MIs[8] Operand 1
     /* 40518 */     // No operand predicates
     /* 40518 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40522 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40526 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40530 */     // MIs[9] Operand 1
     /* 40530 */     // No operand predicates
     /* 40530 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40534 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40538 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40542 */     // MIs[10] Operand 1
     /* 40542 */     // No operand predicates
     /* 40542 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 40544 */     // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SLL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 40544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40549 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 40555 */     GIR_RootConstrainSelectedInstOperands,
     /* 40556 */     // GIR_Coverage, 2461,
     /* 40556 */     GIR_EraseRootFromParent_Done,
     /* 40557 */   // Label 1079: @40557
     /* 40557 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(40735), // Rule ID 2070 //
     /* 40562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 40577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 40581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 40585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40589 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 40592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40600 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40604 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40608 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40612 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40616 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40620 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40632 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40636 */     // MIs[3] Operand 1
     /* 40636 */     // No operand predicates
     /* 40636 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40640 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40644 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40648 */     // MIs[4] Operand 1
     /* 40648 */     // No operand predicates
     /* 40648 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40652 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40656 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40660 */     // MIs[5] Operand 1
     /* 40660 */     // No operand predicates
     /* 40660 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40664 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40668 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40672 */     // MIs[6] Operand 1
     /* 40672 */     // No operand predicates
     /* 40672 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40676 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40680 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40684 */     // MIs[7] Operand 1
     /* 40684 */     // No operand predicates
     /* 40684 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40688 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40692 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40696 */     // MIs[8] Operand 1
     /* 40696 */     // No operand predicates
     /* 40696 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40700 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40704 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40708 */     // MIs[9] Operand 1
     /* 40708 */     // No operand predicates
     /* 40708 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40712 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40716 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 40720 */     // MIs[10] Operand 1
     /* 40720 */     // No operand predicates
     /* 40720 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 40722 */     // (shl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SLL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 40722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 40727 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 40729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 40733 */     GIR_RootConstrainSelectedInstOperands,
     /* 40734 */     // GIR_Coverage, 2070,
     /* 40734 */     GIR_EraseRootFromParent_Done,
     /* 40735 */   // Label 1080: @40735
     /* 40735 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(40758), // Rule ID 958 //
     /* 40740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 40743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 40751 */     // (shl:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SLL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 40751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_H),
     /* 40756 */     GIR_RootConstrainSelectedInstOperands,
     /* 40757 */     // GIR_Coverage, 958,
     /* 40757 */     GIR_Done,
     /* 40758 */   // Label 1081: @40758
     /* 40758 */   GIM_Reject,
     /* 40759 */ // Label 1078: @40759
     /* 40759 */ GIM_Reject,
     /* 40760 */ // Label 1059: @40760
     /* 40760 */ GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(41411),
     /* 40765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 40771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 40775 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(41081), // Rule ID 2460 //
     /* 40780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 40783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 40787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 40791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 40795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 40799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 40803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 40807 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 40810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 40814 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 40818 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 40822 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 40826 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 40830 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 40834 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 40838 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 40842 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 40846 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 40850 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 40854 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 40858 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 40862 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 40866 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 40870 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 40874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 40878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40882 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40886 */     // MIs[3] Operand 1
     /* 40886 */     // No operand predicates
     /* 40886 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 40890 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40894 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40898 */     // MIs[4] Operand 1
     /* 40898 */     // No operand predicates
     /* 40898 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 40902 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40906 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40910 */     // MIs[5] Operand 1
     /* 40910 */     // No operand predicates
     /* 40910 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 40914 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40918 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40922 */     // MIs[6] Operand 1
     /* 40922 */     // No operand predicates
     /* 40922 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 40926 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40930 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40934 */     // MIs[7] Operand 1
     /* 40934 */     // No operand predicates
     /* 40934 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 40938 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40942 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40946 */     // MIs[8] Operand 1
     /* 40946 */     // No operand predicates
     /* 40946 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 40950 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40954 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40958 */     // MIs[9] Operand 1
     /* 40958 */     // No operand predicates
     /* 40958 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 40962 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40966 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40970 */     // MIs[10] Operand 1
     /* 40970 */     // No operand predicates
     /* 40970 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 40974 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40978 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40982 */     // MIs[11] Operand 1
     /* 40982 */     // No operand predicates
     /* 40982 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 40986 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 40990 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 40994 */     // MIs[12] Operand 1
     /* 40994 */     // No operand predicates
     /* 40994 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 40998 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41002 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41006 */     // MIs[13] Operand 1
     /* 41006 */     // No operand predicates
     /* 41006 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 41010 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41014 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41018 */     // MIs[14] Operand 1
     /* 41018 */     // No operand predicates
     /* 41018 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 41022 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41026 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41030 */     // MIs[15] Operand 1
     /* 41030 */     // No operand predicates
     /* 41030 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 41034 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41038 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41042 */     // MIs[16] Operand 1
     /* 41042 */     // No operand predicates
     /* 41042 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 41046 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41050 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41054 */     // MIs[17] Operand 1
     /* 41054 */     // No operand predicates
     /* 41054 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 41058 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41062 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41066 */     // MIs[18] Operand 1
     /* 41066 */     // No operand predicates
     /* 41066 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 41068 */     // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SLL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 41068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 41073 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 41075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 41079 */     GIR_RootConstrainSelectedInstOperands,
     /* 41080 */     // GIR_Coverage, 2460,
     /* 41080 */     GIR_EraseRootFromParent_Done,
     /* 41081 */   // Label 1083: @41081
     /* 41081 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(41387), // Rule ID 2069 //
     /* 41086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 41089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 41097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 41101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 41105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 41109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 41113 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 41116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 41120 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 41124 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 41128 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 41132 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 41136 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 41140 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 41144 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 41148 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 41152 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 41156 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 41160 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 41164 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 41168 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 41172 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 41176 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 41180 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 41184 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41188 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41192 */     // MIs[3] Operand 1
     /* 41192 */     // No operand predicates
     /* 41192 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 41196 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41200 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41204 */     // MIs[4] Operand 1
     /* 41204 */     // No operand predicates
     /* 41204 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 41208 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41212 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41216 */     // MIs[5] Operand 1
     /* 41216 */     // No operand predicates
     /* 41216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 41220 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41224 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41228 */     // MIs[6] Operand 1
     /* 41228 */     // No operand predicates
     /* 41228 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 41232 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41236 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41240 */     // MIs[7] Operand 1
     /* 41240 */     // No operand predicates
     /* 41240 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 41244 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41248 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41252 */     // MIs[8] Operand 1
     /* 41252 */     // No operand predicates
     /* 41252 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 41256 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41260 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41264 */     // MIs[9] Operand 1
     /* 41264 */     // No operand predicates
     /* 41264 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 41268 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41272 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41276 */     // MIs[10] Operand 1
     /* 41276 */     // No operand predicates
     /* 41276 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 41280 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41284 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41288 */     // MIs[11] Operand 1
     /* 41288 */     // No operand predicates
     /* 41288 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 41292 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41296 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41300 */     // MIs[12] Operand 1
     /* 41300 */     // No operand predicates
     /* 41300 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 41304 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41308 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41312 */     // MIs[13] Operand 1
     /* 41312 */     // No operand predicates
     /* 41312 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 41316 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41320 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41324 */     // MIs[14] Operand 1
     /* 41324 */     // No operand predicates
     /* 41324 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 41328 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41332 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41336 */     // MIs[15] Operand 1
     /* 41336 */     // No operand predicates
     /* 41336 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 41340 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41344 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41348 */     // MIs[16] Operand 1
     /* 41348 */     // No operand predicates
     /* 41348 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 41352 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41356 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41360 */     // MIs[17] Operand 1
     /* 41360 */     // No operand predicates
     /* 41360 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 41364 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41368 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 41372 */     // MIs[18] Operand 1
     /* 41372 */     // No operand predicates
     /* 41372 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 41374 */     // (shl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SLL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 41374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 41379 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 41381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 41385 */     GIR_RootConstrainSelectedInstOperands,
     /* 41386 */     // GIR_Coverage, 2069,
     /* 41386 */     GIR_EraseRootFromParent_Done,
     /* 41387 */   // Label 1084: @41387
     /* 41387 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(41410), // Rule ID 957 //
     /* 41392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 41395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 41399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 41403 */     // (shl:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SLL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 41403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SLL_B),
     /* 41408 */     GIR_RootConstrainSelectedInstOperands,
     /* 41409 */     // GIR_Coverage, 957,
     /* 41409 */     GIR_Done,
     /* 41410 */   // Label 1085: @41410
     /* 41410 */   GIM_Reject,
     /* 41411 */ // Label 1082: @41411
     /* 41411 */ GIM_Reject,
     /* 41412 */ // Label 1060: @41412
     /* 41412 */ GIM_Reject,
     /* 41413 */ // Label 38: @41413
     /* 41413 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1092*/ GIMT_Encode4(43209),
     /* 41424 */ /*GILLT_s32*//*Label 1086*/ GIMT_Encode4(41456),
     /* 41428 */ /*GILLT_s64*//*Label 1087*/ GIMT_Encode4(41718), GIMT_Encode4(0),
     /* 41436 */ /*GILLT_v2s64*//*Label 1088*/ GIMT_Encode4(41859), GIMT_Encode4(0),
     /* 41444 */ /*GILLT_v4s32*//*Label 1089*/ GIMT_Encode4(41893),
     /* 41448 */ /*GILLT_v8s16*//*Label 1090*/ GIMT_Encode4(42161),
     /* 41452 */ /*GILLT_v16s8*//*Label 1091*/ GIMT_Encode4(42557),
     /* 41456 */ // Label 1086: @41456
     /* 41456 */ GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(41717),
     /* 41461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 41464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 41467 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(41509), // Rule ID 57 //
     /* 41472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 41475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41495 */     // MIs[1] Operand 1
     /* 41495 */     // No operand predicates
     /* 41495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41497 */     // (srl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SRL:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 41497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL),
     /* 41500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 41507 */     GIR_RootConstrainSelectedInstOperands,
     /* 41508 */     // GIR_Coverage, 57,
     /* 41508 */     GIR_EraseRootFromParent_Done,
     /* 41509 */   // Label 1094: @41509
     /* 41509 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(41551), // Rule ID 1832 //
     /* 41514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 41517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41537 */     // MIs[1] Operand 1
     /* 41537 */     // No operand predicates
     /* 41537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41539 */     // (srl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SrlX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 41539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SrlX16),
     /* 41542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 41544 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 41546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41549 */     GIR_RootConstrainSelectedInstOperands,
     /* 41550 */     // GIR_Coverage, 1832,
     /* 41550 */     GIR_EraseRootFromParent_Done,
     /* 41551 */   // Label 1095: @41551
     /* 41551 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(41593), // Rule ID 2173 //
     /* 41556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 41563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPRMM16RegClassID),
     /* 41567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt2Shift),
     /* 41579 */     // MIs[1] Operand 1
     /* 41579 */     // No operand predicates
     /* 41579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41581 */     // (srl:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)  =>  (SRL16_MM:{ *:[i32] } GPRMM16:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt2Shift>>:$imm)
     /* 41581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL16_MM),
     /* 41584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41586 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 41588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41591 */     GIR_RootConstrainSelectedInstOperands,
     /* 41592 */     // GIR_Coverage, 2173,
     /* 41592 */     GIR_EraseRootFromParent_Done,
     /* 41593 */   // Label 1096: @41593
     /* 41593 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(41635), // Rule ID 2174 //
     /* 41598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 41621 */     // MIs[1] Operand 1
     /* 41621 */     // No operand predicates
     /* 41621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41623 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SRL_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 41623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_MM),
     /* 41626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41628 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 41630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 41633 */     GIR_RootConstrainSelectedInstOperands,
     /* 41634 */     // GIR_Coverage, 2174,
     /* 41634 */     GIR_EraseRootFromParent_Done,
     /* 41635 */   // Label 1097: @41635
     /* 41635 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(41662), // Rule ID 63 //
     /* 41640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 41643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41655 */     // (srl:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SRLV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 41655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRLV),
     /* 41660 */     GIR_RootConstrainSelectedInstOperands,
     /* 41661 */     // GIR_Coverage, 63,
     /* 41661 */     GIR_Done,
     /* 41662 */   // Label 1098: @41662
     /* 41662 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(41689), // Rule ID 1836 //
     /* 41667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 41670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 41682 */     // (srl:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SrlvRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 41682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SrlvRxRy16),
     /* 41687 */     GIR_RootConstrainSelectedInstOperands,
     /* 41688 */     // GIR_Coverage, 1836,
     /* 41688 */     GIR_Done,
     /* 41689 */   // Label 1099: @41689
     /* 41689 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(41716), // Rule ID 2175 //
     /* 41694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 41697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41709 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SRLV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 41709 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRLV_MM),
     /* 41714 */     GIR_RootConstrainSelectedInstOperands,
     /* 41715 */     // GIR_Coverage, 2175,
     /* 41715 */     GIR_Done,
     /* 41716 */   // Label 1100: @41716
     /* 41716 */   GIM_Reject,
     /* 41717 */ // Label 1093: @41717
     /* 41717 */ GIM_Reject,
     /* 41718 */ // Label 1087: @41718
     /* 41718 */ GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(41858),
     /* 41723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 41726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 41729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41737 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(41771), // Rule ID 212 //
     /* 41742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 41745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 41757 */     // MIs[1] Operand 1
     /* 41757 */     // No operand predicates
     /* 41757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41759 */     // (srl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSRL:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 41759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRL),
     /* 41762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 41769 */     GIR_RootConstrainSelectedInstOperands,
     /* 41770 */     // GIR_Coverage, 212,
     /* 41770 */     GIR_EraseRootFromParent_Done,
     /* 41771 */   // Label 1102: @41771
     /* 41771 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(41838), // Rule ID 1577 //
     /* 41776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 41779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 41787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 41791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 41798 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSRLV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 41798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 41801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 41805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 41810 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 41816 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 41821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 41826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRLV),
     /* 41829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 41831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 41833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 41836 */     GIR_RootConstrainSelectedInstOperands,
     /* 41837 */     // GIR_Coverage, 1577,
     /* 41837 */     GIR_EraseRootFromParent_Done,
     /* 41838 */   // Label 1103: @41838
     /* 41838 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(41857), // Rule ID 220 //
     /* 41843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 41846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 41850 */     // (srl:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSRLV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 41850 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSRLV),
     /* 41855 */     GIR_RootConstrainSelectedInstOperands,
     /* 41856 */     // GIR_Coverage, 220,
     /* 41856 */     GIR_Done,
     /* 41857 */   // Label 1104: @41857
     /* 41857 */   GIM_Reject,
     /* 41858 */ // Label 1101: @41858
     /* 41858 */ GIM_Reject,
     /* 41859 */ // Label 1088: @41859
     /* 41859 */ GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(41892), // Rule ID 992 //
     /* 41864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 41867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 41870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 41873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 41885 */   // (srl:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRL_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 41885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_D),
     /* 41890 */   GIR_RootConstrainSelectedInstOperands,
     /* 41891 */   // GIR_Coverage, 992,
     /* 41891 */   GIR_Done,
     /* 41892 */ // Label 1105: @41892
     /* 41892 */ GIM_Reject,
     /* 41893 */ // Label 1089: @41893
     /* 41893 */ GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(42160),
     /* 41898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 41901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 41904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 41908 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(42022), // Rule ID 2478 //
     /* 41913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 41916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 41920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 41924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 41928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 41932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 41936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 41940 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 41943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 41947 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 41951 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 41955 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 41959 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 41963 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41967 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41971 */     // MIs[3] Operand 1
     /* 41971 */     // No operand predicates
     /* 41971 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 41975 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41979 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41983 */     // MIs[4] Operand 1
     /* 41983 */     // No operand predicates
     /* 41983 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 41987 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 41991 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 41995 */     // MIs[5] Operand 1
     /* 41995 */     // No operand predicates
     /* 41995 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 41999 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42003 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42007 */     // MIs[6] Operand 1
     /* 42007 */     // No operand predicates
     /* 42007 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 42009 */     // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SRL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 42009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42014 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42020 */     GIR_RootConstrainSelectedInstOperands,
     /* 42021 */     // GIR_Coverage, 2478,
     /* 42021 */     GIR_EraseRootFromParent_Done,
     /* 42022 */   // Label 1107: @42022
     /* 42022 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(42136), // Rule ID 2079 //
     /* 42027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 42042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 42046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42054 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 42057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42065 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42069 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42073 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42077 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42081 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42085 */     // MIs[3] Operand 1
     /* 42085 */     // No operand predicates
     /* 42085 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42089 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42093 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42097 */     // MIs[4] Operand 1
     /* 42097 */     // No operand predicates
     /* 42097 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42101 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42105 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42109 */     // MIs[5] Operand 1
     /* 42109 */     // No operand predicates
     /* 42109 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42113 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42117 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 42121 */     // MIs[6] Operand 1
     /* 42121 */     // No operand predicates
     /* 42121 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 42123 */     // (srl:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SRL_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 42123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42128 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 42134 */     GIR_RootConstrainSelectedInstOperands,
     /* 42135 */     // GIR_Coverage, 2079,
     /* 42135 */     GIR_EraseRootFromParent_Done,
     /* 42136 */   // Label 1108: @42136
     /* 42136 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(42159), // Rule ID 991 //
     /* 42141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 42144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 42148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 42152 */     // (srl:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRL_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 42152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_W),
     /* 42157 */     GIR_RootConstrainSelectedInstOperands,
     /* 42158 */     // GIR_Coverage, 991,
     /* 42158 */     GIR_Done,
     /* 42159 */   // Label 1109: @42159
     /* 42159 */   GIM_Reject,
     /* 42160 */ // Label 1106: @42160
     /* 42160 */ GIM_Reject,
     /* 42161 */ // Label 1090: @42161
     /* 42161 */ GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(42556),
     /* 42166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42176 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(42354), // Rule ID 2477 //
     /* 42181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 42204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42208 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 42211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42215 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42219 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42223 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42227 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42231 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42235 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42239 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42243 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42247 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42251 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42255 */     // MIs[3] Operand 1
     /* 42255 */     // No operand predicates
     /* 42255 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42259 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42263 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42267 */     // MIs[4] Operand 1
     /* 42267 */     // No operand predicates
     /* 42267 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42271 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42275 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42279 */     // MIs[5] Operand 1
     /* 42279 */     // No operand predicates
     /* 42279 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42283 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42287 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42291 */     // MIs[6] Operand 1
     /* 42291 */     // No operand predicates
     /* 42291 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42295 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42299 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42303 */     // MIs[7] Operand 1
     /* 42303 */     // No operand predicates
     /* 42303 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42307 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42311 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42315 */     // MIs[8] Operand 1
     /* 42315 */     // No operand predicates
     /* 42315 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42319 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42323 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42327 */     // MIs[9] Operand 1
     /* 42327 */     // No operand predicates
     /* 42327 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42331 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42335 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42339 */     // MIs[10] Operand 1
     /* 42339 */     // No operand predicates
     /* 42339 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 42341 */     // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SRL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 42341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42346 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42352 */     GIR_RootConstrainSelectedInstOperands,
     /* 42353 */     // GIR_Coverage, 2477,
     /* 42353 */     GIR_EraseRootFromParent_Done,
     /* 42354 */   // Label 1111: @42354
     /* 42354 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(42532), // Rule ID 2078 //
     /* 42359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 42374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 42378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42386 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 42389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42397 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42401 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42405 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42409 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42413 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42417 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42429 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42433 */     // MIs[3] Operand 1
     /* 42433 */     // No operand predicates
     /* 42433 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42437 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42441 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42445 */     // MIs[4] Operand 1
     /* 42445 */     // No operand predicates
     /* 42445 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42449 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42453 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42457 */     // MIs[5] Operand 1
     /* 42457 */     // No operand predicates
     /* 42457 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42461 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42465 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42469 */     // MIs[6] Operand 1
     /* 42469 */     // No operand predicates
     /* 42469 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42473 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42477 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42481 */     // MIs[7] Operand 1
     /* 42481 */     // No operand predicates
     /* 42481 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42485 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42489 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42493 */     // MIs[8] Operand 1
     /* 42493 */     // No operand predicates
     /* 42493 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42497 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42501 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42505 */     // MIs[9] Operand 1
     /* 42505 */     // No operand predicates
     /* 42505 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42509 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42513 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 42517 */     // MIs[10] Operand 1
     /* 42517 */     // No operand predicates
     /* 42517 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 42519 */     // (srl:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SRL_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 42519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42524 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 42530 */     GIR_RootConstrainSelectedInstOperands,
     /* 42531 */     // GIR_Coverage, 2078,
     /* 42531 */     GIR_EraseRootFromParent_Done,
     /* 42532 */   // Label 1112: @42532
     /* 42532 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(42555), // Rule ID 990 //
     /* 42537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 42540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 42548 */     // (srl:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRL_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 42548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_H),
     /* 42553 */     GIR_RootConstrainSelectedInstOperands,
     /* 42554 */     // GIR_Coverage, 990,
     /* 42554 */     GIR_Done,
     /* 42555 */   // Label 1113: @42555
     /* 42555 */   GIM_Reject,
     /* 42556 */ // Label 1110: @42556
     /* 42556 */ GIM_Reject,
     /* 42557 */ // Label 1091: @42557
     /* 42557 */ GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(43208),
     /* 42562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 42572 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(42878), // Rule ID 2476 //
     /* 42577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 42600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42604 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 42607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42615 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42619 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42623 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42627 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42631 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42635 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42639 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 42643 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 42647 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 42651 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 42655 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 42659 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 42663 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 42667 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 42671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42683 */     // MIs[3] Operand 1
     /* 42683 */     // No operand predicates
     /* 42683 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42687 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42691 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42695 */     // MIs[4] Operand 1
     /* 42695 */     // No operand predicates
     /* 42695 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 42699 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42703 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42707 */     // MIs[5] Operand 1
     /* 42707 */     // No operand predicates
     /* 42707 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 42711 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42715 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42719 */     // MIs[6] Operand 1
     /* 42719 */     // No operand predicates
     /* 42719 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 42723 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42727 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42731 */     // MIs[7] Operand 1
     /* 42731 */     // No operand predicates
     /* 42731 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 42735 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42739 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42743 */     // MIs[8] Operand 1
     /* 42743 */     // No operand predicates
     /* 42743 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 42747 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42751 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42755 */     // MIs[9] Operand 1
     /* 42755 */     // No operand predicates
     /* 42755 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 42759 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42763 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42767 */     // MIs[10] Operand 1
     /* 42767 */     // No operand predicates
     /* 42767 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 42771 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42775 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42779 */     // MIs[11] Operand 1
     /* 42779 */     // No operand predicates
     /* 42779 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 42783 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42787 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42791 */     // MIs[12] Operand 1
     /* 42791 */     // No operand predicates
     /* 42791 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 42795 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42799 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42803 */     // MIs[13] Operand 1
     /* 42803 */     // No operand predicates
     /* 42803 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 42807 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42811 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42815 */     // MIs[14] Operand 1
     /* 42815 */     // No operand predicates
     /* 42815 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 42819 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42823 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42827 */     // MIs[15] Operand 1
     /* 42827 */     // No operand predicates
     /* 42827 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 42831 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42835 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42839 */     // MIs[16] Operand 1
     /* 42839 */     // No operand predicates
     /* 42839 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 42843 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42847 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42851 */     // MIs[17] Operand 1
     /* 42851 */     // No operand predicates
     /* 42851 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 42855 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42859 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42863 */     // MIs[18] Operand 1
     /* 42863 */     // No operand predicates
     /* 42863 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 42865 */     // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SRL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 42865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 42868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 42870 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 42872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 42876 */     GIR_RootConstrainSelectedInstOperands,
     /* 42877 */     // GIR_Coverage, 2476,
     /* 42877 */     GIR_EraseRootFromParent_Done,
     /* 42878 */   // Label 1115: @42878
     /* 42878 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(43184), // Rule ID 2077 //
     /* 42883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 42886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 42890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 42894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 42898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 42902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 42906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 42910 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 42913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 42917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 42921 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 42925 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 42929 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 42933 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 42937 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 42941 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 42945 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 42949 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 42953 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 42957 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 42961 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 42965 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 42969 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 42973 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 42977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 42981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42985 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 42989 */     // MIs[3] Operand 1
     /* 42989 */     // No operand predicates
     /* 42989 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 42993 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 42997 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43001 */     // MIs[4] Operand 1
     /* 43001 */     // No operand predicates
     /* 43001 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43005 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43009 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43013 */     // MIs[5] Operand 1
     /* 43013 */     // No operand predicates
     /* 43013 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43017 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43021 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43025 */     // MIs[6] Operand 1
     /* 43025 */     // No operand predicates
     /* 43025 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 43029 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43033 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43037 */     // MIs[7] Operand 1
     /* 43037 */     // No operand predicates
     /* 43037 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 43041 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43045 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43049 */     // MIs[8] Operand 1
     /* 43049 */     // No operand predicates
     /* 43049 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 43053 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43057 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43061 */     // MIs[9] Operand 1
     /* 43061 */     // No operand predicates
     /* 43061 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 43065 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43069 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43073 */     // MIs[10] Operand 1
     /* 43073 */     // No operand predicates
     /* 43073 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 43077 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43081 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43085 */     // MIs[11] Operand 1
     /* 43085 */     // No operand predicates
     /* 43085 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 43089 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43093 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43097 */     // MIs[12] Operand 1
     /* 43097 */     // No operand predicates
     /* 43097 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 43101 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43105 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43109 */     // MIs[13] Operand 1
     /* 43109 */     // No operand predicates
     /* 43109 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 43113 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43117 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43121 */     // MIs[14] Operand 1
     /* 43121 */     // No operand predicates
     /* 43121 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 43125 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43129 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43133 */     // MIs[15] Operand 1
     /* 43133 */     // No operand predicates
     /* 43133 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 43137 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43141 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43145 */     // MIs[16] Operand 1
     /* 43145 */     // No operand predicates
     /* 43145 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 43149 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43153 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43157 */     // MIs[17] Operand 1
     /* 43157 */     // No operand predicates
     /* 43157 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 43161 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43165 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 43169 */     // MIs[18] Operand 1
     /* 43169 */     // No operand predicates
     /* 43169 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 43171 */     // (srl:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SRL_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 43171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 43174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43176 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 43182 */     GIR_RootConstrainSelectedInstOperands,
     /* 43183 */     // GIR_Coverage, 2077,
     /* 43183 */     GIR_EraseRootFromParent_Done,
     /* 43184 */   // Label 1116: @43184
     /* 43184 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(43207), // Rule ID 989 //
     /* 43189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 43196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 43200 */     // (srl:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRL_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 43200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRL_B),
     /* 43205 */     GIR_RootConstrainSelectedInstOperands,
     /* 43206 */     // GIR_Coverage, 989,
     /* 43206 */     GIR_Done,
     /* 43207 */   // Label 1117: @43207
     /* 43207 */   GIM_Reject,
     /* 43208 */ // Label 1114: @43208
     /* 43208 */ GIM_Reject,
     /* 43209 */ // Label 1092: @43209
     /* 43209 */ GIM_Reject,
     /* 43210 */ // Label 39: @43210
     /* 43210 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1124*/ GIMT_Encode4(44964),
     /* 43221 */ /*GILLT_s32*//*Label 1118*/ GIMT_Encode4(43253),
     /* 43225 */ /*GILLT_s64*//*Label 1119*/ GIMT_Encode4(43473), GIMT_Encode4(0),
     /* 43233 */ /*GILLT_v2s64*//*Label 1120*/ GIMT_Encode4(43614), GIMT_Encode4(0),
     /* 43241 */ /*GILLT_v4s32*//*Label 1121*/ GIMT_Encode4(43648),
     /* 43245 */ /*GILLT_v8s16*//*Label 1122*/ GIMT_Encode4(43916),
     /* 43249 */ /*GILLT_v16s8*//*Label 1123*/ GIMT_Encode4(44312),
     /* 43253 */ // Label 1118: @43253
     /* 43253 */ GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(43472),
     /* 43258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 43261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 43264 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(43306), // Rule ID 59 //
     /* 43269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 43272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43292 */     // MIs[1] Operand 1
     /* 43292 */     // No operand predicates
     /* 43292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43294 */     // (sra:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (SRA:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 43294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA),
     /* 43297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 43304 */     GIR_RootConstrainSelectedInstOperands,
     /* 43305 */     // GIR_Coverage, 59,
     /* 43305 */     GIR_EraseRootFromParent_Done,
     /* 43306 */   // Label 1126: @43306
     /* 43306 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(43348), // Rule ID 1833 //
     /* 43311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 43314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43334 */     // MIs[1] Operand 1
     /* 43334 */     // No operand predicates
     /* 43334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43336 */     // (sra:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SraX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$in, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 43336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SraX16),
     /* 43339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rx]
     /* 43341 */     GIR_RootToRootCopy, /*OpIdx*/1, // in
     /* 43343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 43346 */     GIR_RootConstrainSelectedInstOperands,
     /* 43347 */     // GIR_Coverage, 1833,
     /* 43347 */     GIR_EraseRootFromParent_Done,
     /* 43348 */   // Label 1127: @43348
     /* 43348 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(43390), // Rule ID 2176 //
     /* 43353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 43356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 43376 */     // MIs[1] Operand 1
     /* 43376 */     // No operand predicates
     /* 43376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43378 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)  =>  (SRA_MM:{ *:[i32] } GPR32:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$imm)
     /* 43378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_MM),
     /* 43381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43383 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 43385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 43388 */     GIR_RootConstrainSelectedInstOperands,
     /* 43389 */     // GIR_Coverage, 2176,
     /* 43389 */     GIR_EraseRootFromParent_Done,
     /* 43390 */   // Label 1128: @43390
     /* 43390 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(43417), // Rule ID 65 //
     /* 43395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 43398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43410 */     // (sra:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (SRAV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 43410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRAV),
     /* 43415 */     GIR_RootConstrainSelectedInstOperands,
     /* 43416 */     // GIR_Coverage, 65,
     /* 43416 */     GIR_Done,
     /* 43417 */   // Label 1129: @43417
     /* 43417 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(43444), // Rule ID 1835 //
     /* 43422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 43425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 43437 */     // (sra:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)  =>  (SravRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$r, CPU16Regs:{ *:[i32] }:$ra)
     /* 43437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SravRxRy16),
     /* 43442 */     GIR_RootConstrainSelectedInstOperands,
     /* 43443 */     // GIR_Coverage, 1835,
     /* 43443 */     GIR_Done,
     /* 43444 */   // Label 1130: @43444
     /* 43444 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(43471), // Rule ID 2177 //
     /* 43449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 43452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43464 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)  =>  (SRAV_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs)
     /* 43464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRAV_MM),
     /* 43469 */     GIR_RootConstrainSelectedInstOperands,
     /* 43470 */     // GIR_Coverage, 2177,
     /* 43470 */     GIR_Done,
     /* 43471 */   // Label 1131: @43471
     /* 43471 */   GIM_Reject,
     /* 43472 */ // Label 1125: @43472
     /* 43472 */ GIM_Reject,
     /* 43473 */ // Label 1119: @43473
     /* 43473 */ GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(43613),
     /* 43478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 43481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 43484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43492 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(43526), // Rule ID 214 //
     /* 43497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 43500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 43512 */     // MIs[1] Operand 1
     /* 43512 */     // No operand predicates
     /* 43512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43514 */     // (sra:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DSRA:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 43514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRA),
     /* 43517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 43524 */     GIR_RootConstrainSelectedInstOperands,
     /* 43525 */     // GIR_Coverage, 214,
     /* 43525 */     GIR_EraseRootFromParent_Done,
     /* 43526 */   // Label 1133: @43526
     /* 43526 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(43593), // Rule ID 1578 //
     /* 43531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 43534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 43542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 43546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 43553 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DSRAV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 43553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 43556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 43560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 43565 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 43571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 43576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 43581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSRAV),
     /* 43584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 43586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 43588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 43591 */     GIR_RootConstrainSelectedInstOperands,
     /* 43592 */     // GIR_Coverage, 1578,
     /* 43592 */     GIR_EraseRootFromParent_Done,
     /* 43593 */   // Label 1134: @43593
     /* 43593 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(43612), // Rule ID 218 //
     /* 43598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_NotInMicroMips),
     /* 43601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 43605 */     // (sra:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DSRAV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 43605 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DSRAV),
     /* 43610 */     GIR_RootConstrainSelectedInstOperands,
     /* 43611 */     // GIR_Coverage, 218,
     /* 43611 */     GIR_Done,
     /* 43612 */   // Label 1135: @43612
     /* 43612 */   GIM_Reject,
     /* 43613 */ // Label 1132: @43613
     /* 43613 */ GIM_Reject,
     /* 43614 */ // Label 1120: @43614
     /* 43614 */ GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(43647), // Rule ID 976 //
     /* 43619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 43625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 43628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 43640 */   // (sra:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (SRA_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 43640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_D),
     /* 43645 */   GIR_RootConstrainSelectedInstOperands,
     /* 43646 */   // GIR_Coverage, 976,
     /* 43646 */   GIR_Done,
     /* 43647 */ // Label 1136: @43647
     /* 43647 */ GIM_Reject,
     /* 43648 */ // Label 1121: @43648
     /* 43648 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(43915),
     /* 43653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43663 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(43777), // Rule ID 2482 //
     /* 43668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43679 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 43691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43695 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 43698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43706 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43710 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43722 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43726 */     // MIs[3] Operand 1
     /* 43726 */     // No operand predicates
     /* 43726 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43730 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43734 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43738 */     // MIs[4] Operand 1
     /* 43738 */     // No operand predicates
     /* 43738 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43742 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43746 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43750 */     // MIs[5] Operand 1
     /* 43750 */     // No operand predicates
     /* 43750 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43754 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43758 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43762 */     // MIs[6] Operand 1
     /* 43762 */     // No operand predicates
     /* 43762 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 43764 */     // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>), v4i32:{ *:[v4i32] }:$wt))  =>  (SRA_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 43764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43769 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 43775 */     GIR_RootConstrainSelectedInstOperands,
     /* 43776 */     // GIR_Coverage, 2482,
     /* 43776 */     GIR_EraseRootFromParent_Done,
     /* 43777 */   // Label 1138: @43777
     /* 43777 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(43891), // Rule ID 2083 //
     /* 43782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 43797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 43801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 43805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43809 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/5,
     /* 43812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43820 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43824 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 43832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43836 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43840 */     // MIs[3] Operand 1
     /* 43840 */     // No operand predicates
     /* 43840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 43844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43848 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43852 */     // MIs[4] Operand 1
     /* 43852 */     // No operand predicates
     /* 43852 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 43856 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43860 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43864 */     // MIs[5] Operand 1
     /* 43864 */     // No operand predicates
     /* 43864 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 43868 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 43872 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst31),
     /* 43876 */     // MIs[6] Operand 1
     /* 43876 */     // No operand predicates
     /* 43876 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /* 43878 */     // (sra:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, (and:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$wt, (build_vector:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst31>>)))  =>  (SRA_W:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$ws, v4i32:{ *:[v4i32] }:$wt)
     /* 43878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 43883 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 43885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 43889 */     GIR_RootConstrainSelectedInstOperands,
     /* 43890 */     // GIR_Coverage, 2083,
     /* 43890 */     GIR_EraseRootFromParent_Done,
     /* 43891 */   // Label 1139: @43891
     /* 43891 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(43914), // Rule ID 975 //
     /* 43896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 43899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 43907 */     // (sra:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (SRA_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 43907 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_W),
     /* 43912 */     GIR_RootConstrainSelectedInstOperands,
     /* 43913 */     // GIR_Coverage, 975,
     /* 43913 */     GIR_Done,
     /* 43914 */   // Label 1140: @43914
     /* 43914 */   GIM_Reject,
     /* 43915 */ // Label 1137: @43915
     /* 43915 */ GIM_Reject,
     /* 43916 */ // Label 1122: @43916
     /* 43916 */ GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(44311),
     /* 43921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 43924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 43927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 43931 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(44109), // Rule ID 2481 //
     /* 43936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 43939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 43943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 43947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 43951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 43955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 43959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 43963 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 43966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 43970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 43974 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 43978 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 43982 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 43986 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 43990 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 43994 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 43998 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44002 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44006 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44010 */     // MIs[3] Operand 1
     /* 44010 */     // No operand predicates
     /* 44010 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44014 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44018 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44022 */     // MIs[4] Operand 1
     /* 44022 */     // No operand predicates
     /* 44022 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44026 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44030 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44034 */     // MIs[5] Operand 1
     /* 44034 */     // No operand predicates
     /* 44034 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44038 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44042 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44046 */     // MIs[6] Operand 1
     /* 44046 */     // No operand predicates
     /* 44046 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44050 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44054 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44058 */     // MIs[7] Operand 1
     /* 44058 */     // No operand predicates
     /* 44058 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44062 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44066 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44070 */     // MIs[8] Operand 1
     /* 44070 */     // No operand predicates
     /* 44070 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44074 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44078 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44082 */     // MIs[9] Operand 1
     /* 44082 */     // No operand predicates
     /* 44082 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44086 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44090 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44094 */     // MIs[10] Operand 1
     /* 44094 */     // No operand predicates
     /* 44094 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 44096 */     // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>), v8i16:{ *:[v8i16] }:$wt))  =>  (SRA_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 44096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44101 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 44107 */     GIR_RootConstrainSelectedInstOperands,
     /* 44108 */     // GIR_Coverage, 2481,
     /* 44108 */     GIR_EraseRootFromParent_Done,
     /* 44109 */   // Label 1142: @44109
     /* 44109 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(44287), // Rule ID 2082 //
     /* 44114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 44129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 44133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 44137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44141 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/9,
     /* 44144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44148 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44152 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44156 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44160 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44164 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44168 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44172 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44184 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44188 */     // MIs[3] Operand 1
     /* 44188 */     // No operand predicates
     /* 44188 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44192 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44196 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44200 */     // MIs[4] Operand 1
     /* 44200 */     // No operand predicates
     /* 44200 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44204 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44208 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44212 */     // MIs[5] Operand 1
     /* 44212 */     // No operand predicates
     /* 44212 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44216 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44220 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44224 */     // MIs[6] Operand 1
     /* 44224 */     // No operand predicates
     /* 44224 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44228 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44232 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44236 */     // MIs[7] Operand 1
     /* 44236 */     // No operand predicates
     /* 44236 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44240 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44244 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44248 */     // MIs[8] Operand 1
     /* 44248 */     // No operand predicates
     /* 44248 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44252 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44256 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44260 */     // MIs[9] Operand 1
     /* 44260 */     // No operand predicates
     /* 44260 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44264 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44268 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst15),
     /* 44272 */     // MIs[10] Operand 1
     /* 44272 */     // No operand predicates
     /* 44272 */     GIM_CheckIsSafeToFold, /*NumInsns*/10,
     /* 44274 */     // (sra:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, (and:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$wt, (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst15>>)))  =>  (SRA_H:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$ws, v8i16:{ *:[v8i16] }:$wt)
     /* 44274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44279 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 44285 */     GIR_RootConstrainSelectedInstOperands,
     /* 44286 */     // GIR_Coverage, 2082,
     /* 44286 */     GIR_EraseRootFromParent_Done,
     /* 44287 */   // Label 1143: @44287
     /* 44287 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(44310), // Rule ID 974 //
     /* 44292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 44295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 44299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 44303 */     // (sra:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (SRA_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 44303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_H),
     /* 44308 */     GIR_RootConstrainSelectedInstOperands,
     /* 44309 */     // GIR_Coverage, 974,
     /* 44309 */     GIR_Done,
     /* 44310 */   // Label 1144: @44310
     /* 44310 */   GIM_Reject,
     /* 44311 */ // Label 1141: @44311
     /* 44311 */ GIM_Reject,
     /* 44312 */ // Label 1123: @44312
     /* 44312 */ GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(44963),
     /* 44317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44327 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(44633), // Rule ID 2480 //
     /* 44332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 44355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44359 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 44362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44370 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44374 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44378 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44382 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44386 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44390 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44394 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 44398 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 44402 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 44406 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 44410 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 44414 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 44418 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 44422 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 44426 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44430 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44434 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44438 */     // MIs[3] Operand 1
     /* 44438 */     // No operand predicates
     /* 44438 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44442 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44446 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44450 */     // MIs[4] Operand 1
     /* 44450 */     // No operand predicates
     /* 44450 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44454 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44458 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44462 */     // MIs[5] Operand 1
     /* 44462 */     // No operand predicates
     /* 44462 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44466 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44470 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44474 */     // MIs[6] Operand 1
     /* 44474 */     // No operand predicates
     /* 44474 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44478 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44482 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44486 */     // MIs[7] Operand 1
     /* 44486 */     // No operand predicates
     /* 44486 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44490 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44494 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44498 */     // MIs[8] Operand 1
     /* 44498 */     // No operand predicates
     /* 44498 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44502 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44506 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44510 */     // MIs[9] Operand 1
     /* 44510 */     // No operand predicates
     /* 44510 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44514 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44518 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44522 */     // MIs[10] Operand 1
     /* 44522 */     // No operand predicates
     /* 44522 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 44526 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44530 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44534 */     // MIs[11] Operand 1
     /* 44534 */     // No operand predicates
     /* 44534 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 44538 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44542 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44546 */     // MIs[12] Operand 1
     /* 44546 */     // No operand predicates
     /* 44546 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 44550 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44554 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44558 */     // MIs[13] Operand 1
     /* 44558 */     // No operand predicates
     /* 44558 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 44562 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44566 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44570 */     // MIs[14] Operand 1
     /* 44570 */     // No operand predicates
     /* 44570 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 44574 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44578 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44582 */     // MIs[15] Operand 1
     /* 44582 */     // No operand predicates
     /* 44582 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 44586 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44590 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44594 */     // MIs[16] Operand 1
     /* 44594 */     // No operand predicates
     /* 44594 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 44598 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44602 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44606 */     // MIs[17] Operand 1
     /* 44606 */     // No operand predicates
     /* 44606 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 44610 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44614 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44618 */     // MIs[18] Operand 1
     /* 44618 */     // No operand predicates
     /* 44618 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 44620 */     // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>), v16i8:{ *:[v16i8] }:$wt))  =>  (SRA_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 44620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44625 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 44631 */     GIR_RootConstrainSelectedInstOperands,
     /* 44632 */     // GIR_Coverage, 2480,
     /* 44632 */     GIR_EraseRootFromParent_Done,
     /* 44633 */   // Label 1146: @44633
     /* 44633 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(44939), // Rule ID 2081 //
     /* 44638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 44641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 44645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 44649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 44653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 44657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 44661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR),
     /* 44665 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/17,
     /* 44668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 44672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 44676 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_s32,
     /* 44680 */     GIM_CheckType, /*MI*/2, /*Op*/4, /*Type*/GILLT_s32,
     /* 44684 */     GIM_CheckType, /*MI*/2, /*Op*/5, /*Type*/GILLT_s32,
     /* 44688 */     GIM_CheckType, /*MI*/2, /*Op*/6, /*Type*/GILLT_s32,
     /* 44692 */     GIM_CheckType, /*MI*/2, /*Op*/7, /*Type*/GILLT_s32,
     /* 44696 */     GIM_CheckType, /*MI*/2, /*Op*/8, /*Type*/GILLT_s32,
     /* 44700 */     GIM_CheckType, /*MI*/2, /*Op*/9, /*Type*/GILLT_s32,
     /* 44704 */     GIM_CheckType, /*MI*/2, /*Op*/10, /*Type*/GILLT_s32,
     /* 44708 */     GIM_CheckType, /*MI*/2, /*Op*/11, /*Type*/GILLT_s32,
     /* 44712 */     GIM_CheckType, /*MI*/2, /*Op*/12, /*Type*/GILLT_s32,
     /* 44716 */     GIM_CheckType, /*MI*/2, /*Op*/13, /*Type*/GILLT_s32,
     /* 44720 */     GIM_CheckType, /*MI*/2, /*Op*/14, /*Type*/GILLT_s32,
     /* 44724 */     GIM_CheckType, /*MI*/2, /*Op*/15, /*Type*/GILLT_s32,
     /* 44728 */     GIM_CheckType, /*MI*/2, /*Op*/16, /*Type*/GILLT_s32,
     /* 44732 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 44736 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44740 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44744 */     // MIs[3] Operand 1
     /* 44744 */     // No operand predicates
     /* 44744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /* 44748 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44752 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44756 */     // MIs[4] Operand 1
     /* 44756 */     // No operand predicates
     /* 44756 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/3, // MIs[5]
     /* 44760 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44764 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44768 */     // MIs[5] Operand 1
     /* 44768 */     // No operand predicates
     /* 44768 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/2, /*OpIdx*/4, // MIs[6]
     /* 44772 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44776 */     GIM_CheckI64ImmPredicate, /*MI*/6, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44780 */     // MIs[6] Operand 1
     /* 44780 */     // No operand predicates
     /* 44780 */     GIM_RecordInsn, /*DefineMI*/7, /*MI*/2, /*OpIdx*/5, // MIs[7]
     /* 44784 */     GIM_CheckOpcode, /*MI*/7, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44788 */     GIM_CheckI64ImmPredicate, /*MI*/7, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44792 */     // MIs[7] Operand 1
     /* 44792 */     // No operand predicates
     /* 44792 */     GIM_RecordInsn, /*DefineMI*/8, /*MI*/2, /*OpIdx*/6, // MIs[8]
     /* 44796 */     GIM_CheckOpcode, /*MI*/8, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44800 */     GIM_CheckI64ImmPredicate, /*MI*/8, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44804 */     // MIs[8] Operand 1
     /* 44804 */     // No operand predicates
     /* 44804 */     GIM_RecordInsn, /*DefineMI*/9, /*MI*/2, /*OpIdx*/7, // MIs[9]
     /* 44808 */     GIM_CheckOpcode, /*MI*/9, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44812 */     GIM_CheckI64ImmPredicate, /*MI*/9, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44816 */     // MIs[9] Operand 1
     /* 44816 */     // No operand predicates
     /* 44816 */     GIM_RecordInsn, /*DefineMI*/10, /*MI*/2, /*OpIdx*/8, // MIs[10]
     /* 44820 */     GIM_CheckOpcode, /*MI*/10, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44824 */     GIM_CheckI64ImmPredicate, /*MI*/10, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44828 */     // MIs[10] Operand 1
     /* 44828 */     // No operand predicates
     /* 44828 */     GIM_RecordInsn, /*DefineMI*/11, /*MI*/2, /*OpIdx*/9, // MIs[11]
     /* 44832 */     GIM_CheckOpcode, /*MI*/11, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44836 */     GIM_CheckI64ImmPredicate, /*MI*/11, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44840 */     // MIs[11] Operand 1
     /* 44840 */     // No operand predicates
     /* 44840 */     GIM_RecordInsn, /*DefineMI*/12, /*MI*/2, /*OpIdx*/10, // MIs[12]
     /* 44844 */     GIM_CheckOpcode, /*MI*/12, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44848 */     GIM_CheckI64ImmPredicate, /*MI*/12, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44852 */     // MIs[12] Operand 1
     /* 44852 */     // No operand predicates
     /* 44852 */     GIM_RecordInsn, /*DefineMI*/13, /*MI*/2, /*OpIdx*/11, // MIs[13]
     /* 44856 */     GIM_CheckOpcode, /*MI*/13, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44860 */     GIM_CheckI64ImmPredicate, /*MI*/13, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44864 */     // MIs[13] Operand 1
     /* 44864 */     // No operand predicates
     /* 44864 */     GIM_RecordInsn, /*DefineMI*/14, /*MI*/2, /*OpIdx*/12, // MIs[14]
     /* 44868 */     GIM_CheckOpcode, /*MI*/14, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44872 */     GIM_CheckI64ImmPredicate, /*MI*/14, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44876 */     // MIs[14] Operand 1
     /* 44876 */     // No operand predicates
     /* 44876 */     GIM_RecordInsn, /*DefineMI*/15, /*MI*/2, /*OpIdx*/13, // MIs[15]
     /* 44880 */     GIM_CheckOpcode, /*MI*/15, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44884 */     GIM_CheckI64ImmPredicate, /*MI*/15, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44888 */     // MIs[15] Operand 1
     /* 44888 */     // No operand predicates
     /* 44888 */     GIM_RecordInsn, /*DefineMI*/16, /*MI*/2, /*OpIdx*/14, // MIs[16]
     /* 44892 */     GIM_CheckOpcode, /*MI*/16, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44896 */     GIM_CheckI64ImmPredicate, /*MI*/16, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44900 */     // MIs[16] Operand 1
     /* 44900 */     // No operand predicates
     /* 44900 */     GIM_RecordInsn, /*DefineMI*/17, /*MI*/2, /*OpIdx*/15, // MIs[17]
     /* 44904 */     GIM_CheckOpcode, /*MI*/17, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44908 */     GIM_CheckI64ImmPredicate, /*MI*/17, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44912 */     // MIs[17] Operand 1
     /* 44912 */     // No operand predicates
     /* 44912 */     GIM_RecordInsn, /*DefineMI*/18, /*MI*/2, /*OpIdx*/16, // MIs[18]
     /* 44916 */     GIM_CheckOpcode, /*MI*/18, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 44920 */     GIM_CheckI64ImmPredicate, /*MI*/18, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immi32Cst7),
     /* 44924 */     // MIs[18] Operand 1
     /* 44924 */     // No operand predicates
     /* 44924 */     GIM_CheckIsSafeToFold, /*NumInsns*/18,
     /* 44926 */     // (sra:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, (and:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$wt, (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>, (imm:{ *:[i32] })<<P:Predicate_immi32Cst7>>)))  =>  (SRA_B:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$ws, v16i8:{ *:[v16i8] }:$wt)
     /* 44926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 44931 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 44933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 44937 */     GIR_RootConstrainSelectedInstOperands,
     /* 44938 */     // GIR_Coverage, 2081,
     /* 44938 */     GIR_EraseRootFromParent_Done,
     /* 44939 */   // Label 1147: @44939
     /* 44939 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(44962), // Rule ID 973 //
     /* 44944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 44947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 44955 */     // (sra:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (SRA_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 44955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::SRA_B),
     /* 44960 */     GIR_RootConstrainSelectedInstOperands,
     /* 44961 */     // GIR_Coverage, 973,
     /* 44961 */     GIR_Done,
     /* 44962 */   // Label 1148: @44962
     /* 44962 */   GIM_Reject,
     /* 44963 */ // Label 1145: @44963
     /* 44963 */ GIM_Reject,
     /* 44964 */ // Label 1124: @44964
     /* 44964 */ GIM_Reject,
     /* 44965 */ // Label 40: @44965
     /* 44965 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1151*/ GIMT_Encode4(45252),
     /* 44976 */ /*GILLT_s32*//*Label 1149*/ GIMT_Encode4(44984),
     /* 44980 */ /*GILLT_s64*//*Label 1150*/ GIMT_Encode4(45111),
     /* 44984 */ // Label 1149: @44984
     /* 44984 */ GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(45110),
     /* 44989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 44992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 44995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 44999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45003 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(45037), // Rule ID 67 //
     /* 45008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 45011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 45023 */     // MIs[1] Operand 1
     /* 45023 */     // No operand predicates
     /* 45023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45025 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (ROTR:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR),
     /* 45028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45035 */     GIR_RootConstrainSelectedInstOperands,
     /* 45036 */     // GIR_Coverage, 67,
     /* 45036 */     GIR_EraseRootFromParent_Done,
     /* 45037 */   // Label 1153: @45037
     /* 45037 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(45071), // Rule ID 1081 //
     /* 45042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt5),
     /* 45057 */     // MIs[1] Operand 1
     /* 45057 */     // No operand predicates
     /* 45057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45059 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt5>>:$shamt)  =>  (ROTR_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR_MM),
     /* 45062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45069 */     GIR_RootConstrainSelectedInstOperands,
     /* 45070 */     // GIR_Coverage, 1081,
     /* 45070 */     GIR_EraseRootFromParent_Done,
     /* 45071 */   // Label 1154: @45071
     /* 45071 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(45090), // Rule ID 68 //
     /* 45076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 45079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45083 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ROTRV:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ROTRV),
     /* 45088 */     GIR_RootConstrainSelectedInstOperands,
     /* 45089 */     // GIR_Coverage, 68,
     /* 45089 */     GIR_Done,
     /* 45090 */   // Label 1155: @45090
     /* 45090 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(45109), // Rule ID 1082 //
     /* 45095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45102 */     // (rotr:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (ROTRV_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::ROTRV_MM),
     /* 45107 */     GIR_RootConstrainSelectedInstOperands,
     /* 45108 */     // GIR_Coverage, 1082,
     /* 45108 */     GIR_Done,
     /* 45109 */   // Label 1156: @45109
     /* 45109 */   GIM_Reject,
     /* 45110 */ // Label 1152: @45110
     /* 45110 */ GIM_Reject,
     /* 45111 */ // Label 1150: @45111
     /* 45111 */ GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(45251),
     /* 45116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 45119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 45122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45130 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(45164), // Rule ID 222 //
     /* 45135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips),
     /* 45138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 45146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt6),
     /* 45150 */     // MIs[1] Operand 1
     /* 45150 */     // No operand predicates
     /* 45150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45152 */     // (rotr:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] })<<P:Predicate_immZExt6>>:$shamt)  =>  (DROTR:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, (imm:{ *:[i32] }):$shamt)
     /* 45152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DROTR),
     /* 45155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // shamt
     /* 45162 */     GIR_RootConstrainSelectedInstOperands,
     /* 45163 */     // GIR_Coverage, 222,
     /* 45163 */     GIR_EraseRootFromParent_Done,
     /* 45164 */   // Label 1158: @45164
     /* 45164 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(45231), // Rule ID 1579 //
     /* 45169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit),
     /* 45172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 45176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 45180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 45184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 45191 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (trunc:{ *:[i32] } GPR64:{ *:[i64] }:$rs))  =>  (DROTRV:{ *:[i64] } GPR64:{ *:[i64] }:$rt, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$rs, sub_32:{ *:[i32] }))
     /* 45191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 45198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45203 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // rs
     /* 45209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(Mips::DSPRRegClassID),
     /* 45214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DROTRV),
     /* 45222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rt
     /* 45226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45229 */     GIR_RootConstrainSelectedInstOperands,
     /* 45230 */     // GIR_Coverage, 1579,
     /* 45230 */     GIR_EraseRootFromParent_Done,
     /* 45231 */   // Label 1159: @45231
     /* 45231 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(45250), // Rule ID 223 //
     /* 45236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc_NotInMicroMips),
     /* 45239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45243 */     // (rotr:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)  =>  (DROTRV:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rt, GPR32Opnd:{ *:[i32] }:$rs)
     /* 45243 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DROTRV),
     /* 45248 */     GIR_RootConstrainSelectedInstOperands,
     /* 45249 */     // GIR_Coverage, 223,
     /* 45249 */     GIR_Done,
     /* 45250 */   // Label 1160: @45250
     /* 45250 */   GIM_Reject,
     /* 45251 */ // Label 1157: @45251
     /* 45251 */ GIM_Reject,
     /* 45252 */ // Label 1151: @45252
     /* 45252 */ GIM_Reject,
     /* 45253 */ // Label 41: @45253
     /* 45253 */ GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(47783),
     /* 45258 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 45261 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1164*/ GIMT_Encode4(45446),
     /* 45272 */   /*GILLT_s32*//*Label 1162*/ GIMT_Encode4(45280),
     /* 45276 */   /*GILLT_s64*//*Label 1163*/ GIMT_Encode4(45363),
     /* 45280 */   // Label 1162: @45280
     /* 45280 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(45362),
     /* 45285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45292 */     GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(45325), // Rule ID 1415 //
     /* 45297 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45300 */       // MIs[0] Operand 1
     /* 45300 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45305 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45309 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45313 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTiu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45313 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu),
     /* 45316 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45318 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45320 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45323 */       GIR_RootConstrainSelectedInstOperands,
     /* 45324 */       // GIR_Coverage, 1415,
     /* 45324 */       GIR_EraseRootFromParent_Done,
     /* 45325 */     // Label 1166: @45325
     /* 45325 */     GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(45361), // Rule ID 1416 //
     /* 45330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45333 */       // MIs[0] Operand 1
     /* 45333 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45338 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45342 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45346 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTu:{ *:[i32] } ZERO:{ *:[i32] }, GPR32:{ *:[i32] }:$lhs)
     /* 45346 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 45349 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45351 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45357 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45359 */       GIR_RootConstrainSelectedInstOperands,
     /* 45360 */       // GIR_Coverage, 1416,
     /* 45360 */       GIR_EraseRootFromParent_Done,
     /* 45361 */     // Label 1167: @45361
     /* 45361 */     GIM_Reject,
     /* 45362 */   // Label 1165: @45362
     /* 45362 */   GIM_Reject,
     /* 45363 */   // Label 1163: @45363
     /* 45363 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(45445),
     /* 45368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 45371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45375 */     GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(45408), // Rule ID 1561 //
     /* 45380 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 45383 */       // MIs[0] Operand 1
     /* 45383 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45388 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45392 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45396 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTiu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 1:{ *:[i64] })
     /* 45396 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu64),
     /* 45399 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45401 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45403 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45406 */       GIR_RootConstrainSelectedInstOperands,
     /* 45407 */       // GIR_Coverage, 1561,
     /* 45407 */       GIR_EraseRootFromParent_Done,
     /* 45408 */     // Label 1169: @45408
     /* 45408 */     GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(45444), // Rule ID 1562 //
     /* 45413 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 45416 */       // MIs[0] Operand 1
     /* 45416 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45421 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45425 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45429 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } ZERO_64:{ *:[i64] }, GPR64:{ *:[i64] }:$lhs)
     /* 45429 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 45432 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45434 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45440 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45442 */       GIR_RootConstrainSelectedInstOperands,
     /* 45443 */       // GIR_Coverage, 1562,
     /* 45443 */       GIR_EraseRootFromParent_Done,
     /* 45444 */     // Label 1170: @45444
     /* 45444 */     GIM_Reject,
     /* 45445 */   // Label 1168: @45445
     /* 45445 */   GIM_Reject,
     /* 45446 */   // Label 1164: @45446
     /* 45446 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1173*/ GIMT_Encode4(45829),
     /* 45457 */   /*GILLT_s32*//*Label 1171*/ GIMT_Encode4(45465),
     /* 45461 */   /*GILLT_s64*//*Label 1172*/ GIMT_Encode4(45751),
     /* 45465 */   // Label 1171: @45465
     /* 45465 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(45750),
     /* 45470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45473 */     GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(45510), // Rule ID 1883 //
     /* 45478 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 45481 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45485 */       // MIs[0] Operand 1
     /* 45485 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45490 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45494 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45498 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SltiuCCRxImmX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45498 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltiuCCRxImmX16),
     /* 45501 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 45503 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45505 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45508 */       GIR_RootConstrainSelectedInstOperands,
     /* 45509 */       // GIR_Coverage, 1883,
     /* 45509 */       GIR_EraseRootFromParent_Done,
     /* 45510 */     // Label 1175: @45510
     /* 45510 */     GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(45600), // Rule ID 1885 //
     /* 45515 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 45518 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45522 */       // MIs[0] Operand 1
     /* 45522 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 45527 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 45531 */       GIM_CheckConstantInt, /*MI*/0, /*Op*/3, GIMT_Encode8(-32769),
     /* 45542 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, -32769:{ *:[i32] }, SETGT:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltiCCRxImmX16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, -32768:{ *:[i32] }), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 45542 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 45545 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 45549 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45554 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 45557 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 45559 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45562 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltiCCRxImmX16),
     /* 45566 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45571 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 45575 */       GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 45585 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 45587 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 45590 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 45592 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45595 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 45598 */       GIR_RootConstrainSelectedInstOperands,
     /* 45599 */       // GIR_Coverage, 1885,
     /* 45599 */       GIR_EraseRootFromParent_Done,
     /* 45600 */     // Label 1176: @45600
     /* 45600 */     GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(45637), // Rule ID 2204 //
     /* 45605 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45608 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45612 */       // MIs[0] Operand 1
     /* 45612 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45617 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45621 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45625 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTiu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 1:{ *:[i32] })
     /* 45625 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu_MM),
     /* 45628 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45630 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45632 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45635 */       GIR_RootConstrainSelectedInstOperands,
     /* 45636 */       // GIR_Coverage, 2204,
     /* 45636 */       GIR_EraseRootFromParent_Done,
     /* 45637 */     // Label 1177: @45637
     /* 45637 */     GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(45677), // Rule ID 2205 //
     /* 45642 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45645 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45649 */       // MIs[0] Operand 1
     /* 45649 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45654 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45658 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 45662 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } ZERO:{ *:[i32] }, GPR32:{ *:[i32] }:$lhs)
     /* 45662 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 45665 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45667 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 45673 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 45675 */       GIR_RootConstrainSelectedInstOperands,
     /* 45676 */       // GIR_Coverage, 2205,
     /* 45676 */       GIR_EraseRootFromParent_Done,
     /* 45677 */     // Label 1178: @45677
     /* 45677 */     GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(45713), // Rule ID 49 //
     /* 45682 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45685 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45689 */       // MIs[0] Operand 1
     /* 45689 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45694 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45698 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45702 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45702 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 45705 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45707 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45709 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45711 */       GIR_RootConstrainSelectedInstOperands,
     /* 45712 */       // GIR_Coverage, 49,
     /* 45712 */       GIR_EraseRootFromParent_Done,
     /* 45713 */     // Label 1179: @45713
     /* 45713 */     GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(45749), // Rule ID 50 //
     /* 45718 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45721 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45725 */       // MIs[0] Operand 1
     /* 45725 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45730 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45734 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45738 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45738 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 45741 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45743 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45745 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45747 */       GIR_RootConstrainSelectedInstOperands,
     /* 45748 */       // GIR_Coverage, 50,
     /* 45748 */       GIR_EraseRootFromParent_Done,
     /* 45749 */     // Label 1180: @45749
     /* 45749 */     GIM_Reject,
     /* 45750 */   // Label 1174: @45750
     /* 45750 */   GIM_Reject,
     /* 45751 */   // Label 1172: @45751
     /* 45751 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(45828),
     /* 45756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 45759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45763 */     GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(45795), // Rule ID 204 //
     /* 45768 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 45771 */       // MIs[0] Operand 1
     /* 45771 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45776 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45780 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45784 */       // (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETLT:{ *:[Other] })  =>  (SLT64:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 45784 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 45787 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45789 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45791 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45793 */       GIR_RootConstrainSelectedInstOperands,
     /* 45794 */       // GIR_Coverage, 204,
     /* 45794 */       GIR_EraseRootFromParent_Done,
     /* 45795 */     // Label 1182: @45795
     /* 45795 */     GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(45827), // Rule ID 205 //
     /* 45800 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsGP64bit_NotInMips16Mode),
     /* 45803 */       // MIs[0] Operand 1
     /* 45803 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45808 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45812 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 45816 */       // (setcc:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 45816 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 45819 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45821 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45823 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45825 */       GIR_RootConstrainSelectedInstOperands,
     /* 45826 */       // GIR_Coverage, 205,
     /* 45826 */       GIR_EraseRootFromParent_Done,
     /* 45827 */     // Label 1183: @45827
     /* 45827 */     GIM_Reject,
     /* 45828 */   // Label 1181: @45828
     /* 45828 */   GIM_Reject,
     /* 45829 */   // Label 1173: @45829
     /* 45829 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1186*/ GIMT_Encode4(46746),
     /* 45840 */   /*GILLT_s32*//*Label 1184*/ GIMT_Encode4(45848),
     /* 45844 */   /*GILLT_s64*//*Label 1185*/ GIMT_Encode4(46329),
     /* 45848 */   // Label 1184: @45848
     /* 45848 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(46328),
     /* 45853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 45856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45860 */     GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(45892), // Rule ID 1075 //
     /* 45865 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45868 */       // MIs[0] Operand 1
     /* 45868 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 45873 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45877 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45881 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETLT:{ *:[Other] })  =>  (SLT_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 45884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45886 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45888 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45890 */       GIR_RootConstrainSelectedInstOperands,
     /* 45891 */       // GIR_Coverage, 1075,
     /* 45891 */       GIR_EraseRootFromParent_Done,
     /* 45892 */     // Label 1188: @45892
     /* 45892 */     GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(45924), // Rule ID 1076 //
     /* 45897 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 45900 */       // MIs[0] Operand 1
     /* 45900 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 45905 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45909 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45913 */       // (setcc:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt, SETULT:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 45913 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 45916 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 45918 */       GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /* 45920 */       GIR_RootToRootCopy, /*OpIdx*/3, // rt
     /* 45922 */       GIR_RootConstrainSelectedInstOperands,
     /* 45923 */       // GIR_Coverage, 1076,
     /* 45923 */       GIR_EraseRootFromParent_Done,
     /* 45924 */     // Label 1189: @45924
     /* 45924 */     GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(45980), // Rule ID 1417 //
     /* 45929 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45932 */       // MIs[0] Operand 1
     /* 45932 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 45937 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45941 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45945 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu:{ *:[i32] } (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 45945 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 45948 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 45952 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 45957 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 45961 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 45965 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 45967 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu),
     /* 45970 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 45972 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 45975 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 45978 */       GIR_RootConstrainSelectedInstOperands,
     /* 45979 */       // GIR_Coverage, 1417,
     /* 45979 */       GIR_EraseRootFromParent_Done,
     /* 45980 */     // Label 1190: @45980
     /* 45980 */     GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(46039), // Rule ID 1418 //
     /* 45985 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 45988 */       // MIs[0] Operand 1
     /* 45988 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 45993 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 45997 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46001 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu:{ *:[i32] } ZERO:{ *:[i32] }, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs))
     /* 46001 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46004 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 46008 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46013 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46017 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46021 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46023 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46026 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46028 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 46034 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46037 */       GIR_RootConstrainSelectedInstOperands,
     /* 46038 */       // GIR_Coverage, 1418,
     /* 46038 */       GIR_EraseRootFromParent_Done,
     /* 46039 */     // Label 1191: @46039
     /* 46039 */     GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(46095), // Rule ID 1419 //
     /* 46044 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46047 */       // MIs[0] Operand 1
     /* 46047 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46052 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46056 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46060 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 46060 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46063 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46067 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46072 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46076 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46080 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46082 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46085 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46087 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46090 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46093 */       GIR_RootConstrainSelectedInstOperands,
     /* 46094 */       // GIR_Coverage, 1419,
     /* 46094 */       GIR_EraseRootFromParent_Done,
     /* 46095 */     // Label 1192: @46095
     /* 46095 */     GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(46151), // Rule ID 1420 //
     /* 46100 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46103 */       // MIs[0] Operand 1
     /* 46103 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 46108 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46112 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46116 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 46116 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46119 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46123 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46128 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46132 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46136 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46138 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46141 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46143 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46146 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46149 */       GIR_RootConstrainSelectedInstOperands,
     /* 46150 */       // GIR_Coverage, 1420,
     /* 46150 */       GIR_EraseRootFromParent_Done,
     /* 46151 */     // Label 1193: @46151
     /* 46151 */     GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(46183), // Rule ID 1421 //
     /* 46156 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46159 */       // MIs[0] Operand 1
     /* 46159 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46164 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46168 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46172 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 46172 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46175 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46177 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46179 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46181 */       GIR_RootConstrainSelectedInstOperands,
     /* 46182 */       // GIR_Coverage, 1421,
     /* 46182 */       GIR_EraseRootFromParent_Done,
     /* 46183 */     // Label 1194: @46183
     /* 46183 */     GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(46215), // Rule ID 1422 //
     /* 46188 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46191 */       // MIs[0] Operand 1
     /* 46191 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 46196 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46200 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46204 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 46204 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46207 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46209 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46211 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46213 */       GIR_RootConstrainSelectedInstOperands,
     /* 46214 */       // GIR_Coverage, 1422,
     /* 46214 */       GIR_EraseRootFromParent_Done,
     /* 46215 */     // Label 1195: @46215
     /* 46215 */     GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(46271), // Rule ID 1423 //
     /* 46220 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46223 */       // MIs[0] Operand 1
     /* 46223 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46228 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46232 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46236 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46236 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46239 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 46243 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46248 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46252 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46256 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46258 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46261 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46263 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46266 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46269 */       GIR_RootConstrainSelectedInstOperands,
     /* 46270 */       // GIR_Coverage, 1423,
     /* 46270 */       GIR_EraseRootFromParent_Done,
     /* 46271 */     // Label 1196: @46271
     /* 46271 */     GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(46327), // Rule ID 1424 //
     /* 46276 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 46279 */       // MIs[0] Operand 1
     /* 46279 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 46284 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46288 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46292 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46292 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46295 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 46299 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46304 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46308 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46312 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46314 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46317 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46319 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46322 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46325 */       GIR_RootConstrainSelectedInstOperands,
     /* 46326 */       // GIR_Coverage, 1424,
     /* 46326 */       GIR_EraseRootFromParent_Done,
     /* 46327 */     // Label 1197: @46327
     /* 46327 */     GIM_Reject,
     /* 46328 */   // Label 1187: @46328
     /* 46328 */   GIM_Reject,
     /* 46329 */   // Label 1185: @46329
     /* 46329 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(46745),
     /* 46334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 46337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 46341 */     GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(46397), // Rule ID 1563 //
     /* 46346 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46349 */       // MIs[0] Operand 1
     /* 46349 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 46354 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46358 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46362 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu64:{ *:[i32] } (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i64] })
     /* 46362 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 46365 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 46369 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46374 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46378 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46382 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46384 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu64),
     /* 46387 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46389 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46392 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46395 */       GIR_RootConstrainSelectedInstOperands,
     /* 46396 */       // GIR_Coverage, 1563,
     /* 46396 */       GIR_EraseRootFromParent_Done,
     /* 46397 */     // Label 1199: @46397
     /* 46397 */     GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(46456), // Rule ID 1564 //
     /* 46402 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46405 */       // MIs[0] Operand 1
     /* 46405 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 46410 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46414 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46418 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } ZERO_64:{ *:[i64] }, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs))
     /* 46418 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 46421 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 46425 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46430 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46434 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46438 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46440 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46443 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46445 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO_64), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 46451 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46454 */       GIR_RootConstrainSelectedInstOperands,
     /* 46455 */       // GIR_Coverage, 1564,
     /* 46455 */       GIR_EraseRootFromParent_Done,
     /* 46456 */     // Label 1200: @46456
     /* 46456 */     GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(46512), // Rule ID 1565 //
     /* 46461 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46464 */       // MIs[0] Operand 1
     /* 46464 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46469 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46473 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46477 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), 1:{ *:[i32] })
     /* 46477 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46480 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46484 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46489 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46493 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46497 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46499 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46502 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46504 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46507 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46510 */       GIR_RootConstrainSelectedInstOperands,
     /* 46511 */       // GIR_Coverage, 1565,
     /* 46511 */       GIR_EraseRootFromParent_Done,
     /* 46512 */     // Label 1201: @46512
     /* 46512 */     GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(46568), // Rule ID 1566 //
     /* 46517 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46520 */       // MIs[0] Operand 1
     /* 46520 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 46525 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46529 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46533 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), 1:{ *:[i32] })
     /* 46533 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46536 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46540 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46545 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46549 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46553 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46555 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46558 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46560 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46563 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46566 */       GIR_RootConstrainSelectedInstOperands,
     /* 46567 */       // GIR_Coverage, 1566,
     /* 46567 */       GIR_EraseRootFromParent_Done,
     /* 46568 */     // Label 1202: @46568
     /* 46568 */     GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(46600), // Rule ID 1567 //
     /* 46573 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46576 */       // MIs[0] Operand 1
     /* 46576 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46581 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46585 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46589 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs)
     /* 46589 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46592 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46594 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46596 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46598 */       GIR_RootConstrainSelectedInstOperands,
     /* 46599 */       // GIR_Coverage, 1567,
     /* 46599 */       GIR_EraseRootFromParent_Done,
     /* 46600 */     // Label 1203: @46600
     /* 46600 */     GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(46632), // Rule ID 1568 //
     /* 46605 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46608 */       // MIs[0] Operand 1
     /* 46608 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 46613 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46617 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46621 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs)
     /* 46621 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46624 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 46626 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46628 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46630 */       GIR_RootConstrainSelectedInstOperands,
     /* 46631 */       // GIR_Coverage, 1568,
     /* 46631 */       GIR_EraseRootFromParent_Done,
     /* 46632 */     // Label 1204: @46632
     /* 46632 */     GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(46688), // Rule ID 1569 //
     /* 46637 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46640 */       // MIs[0] Operand 1
     /* 46640 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46645 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46649 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46653 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i32] })
     /* 46653 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46656 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 46660 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46665 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46669 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46673 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46675 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46678 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46680 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46683 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46686 */       GIR_RootConstrainSelectedInstOperands,
     /* 46687 */       // GIR_Coverage, 1569,
     /* 46687 */       GIR_EraseRootFromParent_Done,
     /* 46688 */     // Label 1205: @46688
     /* 46688 */     GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(46744), // Rule ID 1570 //
     /* 46693 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips3_HasStdEnc_IsGP64bit_NotInMicroMips),
     /* 46696 */       // MIs[0] Operand 1
     /* 46696 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 46701 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46705 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 46709 */       // (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi:{ *:[i32] } (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), 1:{ *:[i32] })
     /* 46709 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46712 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 46716 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46721 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46725 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46729 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46731 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi),
     /* 46734 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 46736 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46739 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46742 */       GIR_RootConstrainSelectedInstOperands,
     /* 46743 */       // GIR_Coverage, 1570,
     /* 46743 */       GIR_EraseRootFromParent_Done,
     /* 46744 */     // Label 1206: @46744
     /* 46744 */     GIM_Reject,
     /* 46745 */   // Label 1198: @46745
     /* 46745 */   GIM_Reject,
     /* 46746 */   // Label 1186: @46746
     /* 46746 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(47782),
     /* 46751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 46754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 46757 */     GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(46817), // Rule ID 1882 //
     /* 46762 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46765 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46769 */       // MIs[0] Operand 1
     /* 46769 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 46774 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46778 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46782 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SltiuCCRxImmX16:{ *:[i32] } (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 46782 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46785 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46789 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46794 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46798 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46802 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46804 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltiuCCRxImmX16),
     /* 46807 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 46809 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46812 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 46815 */       GIR_RootConstrainSelectedInstOperands,
     /* 46816 */       // GIR_Coverage, 1882,
     /* 46816 */       GIR_EraseRootFromParent_Done,
     /* 46817 */     // Label 1208: @46817
     /* 46817 */     GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(46894), // Rule ID 1884 //
     /* 46822 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46825 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46829 */       // MIs[0] Operand 1
     /* 46829 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 46834 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46838 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46842 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 46842 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 46845 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 46849 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46854 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 46857 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 46859 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46862 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46866 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46871 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46875 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46879 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46881 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46884 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 46886 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 46889 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 46892 */       GIR_RootConstrainSelectedInstOperands,
     /* 46893 */       // GIR_Coverage, 1884,
     /* 46893 */       GIR_EraseRootFromParent_Done,
     /* 46894 */     // Label 1209: @46894
     /* 46894 */     GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(46930), // Rule ID 1886 //
     /* 46899 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46902 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46906 */       // MIs[0] Operand 1
     /* 46906 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 46911 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46915 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46919 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs)
     /* 46919 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46922 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 46924 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 46926 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 46928 */       GIR_RootConstrainSelectedInstOperands,
     /* 46929 */       // GIR_Coverage, 1886,
     /* 46929 */       GIR_EraseRootFromParent_Done,
     /* 46930 */     // Label 1210: @46930
     /* 46930 */     GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(47007), // Rule ID 1887 //
     /* 46935 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 46938 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46942 */       // MIs[0] Operand 1
     /* 46942 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 46947 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46951 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 46955 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs), (LiRxImm16:{ *:[i32] } 1:{ *:[i32] }))
     /* 46955 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 46958 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImm16),
     /* 46962 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46967 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 46970 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 46972 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 46975 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 46979 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 46984 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 46988 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 46992 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 46994 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 46997 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 46999 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47002 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47005 */       GIR_RootConstrainSelectedInstOperands,
     /* 47006 */       // GIR_Coverage, 1887,
     /* 47006 */       GIR_EraseRootFromParent_Done,
     /* 47007 */     // Label 1211: @47007
     /* 47007 */     GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(47043), // Rule ID 1888 //
     /* 47012 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47015 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47019 */       // MIs[0] Operand 1
     /* 47019 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 47024 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47028 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47032 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETLT:{ *:[Other] })  =>  (SltCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry)
     /* 47032 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltCCRxRy16),
     /* 47035 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47037 */       GIR_RootToRootCopy, /*OpIdx*/2, // rx
     /* 47039 */       GIR_RootToRootCopy, /*OpIdx*/3, // ry
     /* 47041 */       GIR_RootConstrainSelectedInstOperands,
     /* 47042 */       // GIR_Coverage, 1888,
     /* 47042 */       GIR_EraseRootFromParent_Done,
     /* 47043 */     // Label 1212: @47043
     /* 47043 */     GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(47120), // Rule ID 1890 //
     /* 47048 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47051 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47055 */       // MIs[0] Operand 1
     /* 47055 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 47060 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47064 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47068 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } (LiRxImmX16:{ *:[i32] } 0:{ *:[i32] }), (XorRxRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs))
     /* 47068 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47071 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47075 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47080 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47084 */       GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47088 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47090 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47093 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47097 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47102 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 47105 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47107 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47110 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47112 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47115 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47118 */       GIR_RootConstrainSelectedInstOperands,
     /* 47119 */       // GIR_Coverage, 1890,
     /* 47119 */       GIR_EraseRootFromParent_Done,
     /* 47120 */     // Label 1213: @47120
     /* 47120 */     GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(47197), // Rule ID 1891 //
     /* 47125 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47128 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47132 */       // MIs[0] Operand 1
     /* 47132 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 47137 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47141 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47145 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 47145 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47148 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47152 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47157 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 47160 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47162 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47165 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47169 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47174 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47178 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47182 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47184 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47187 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47189 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47192 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47195 */       GIR_RootConstrainSelectedInstOperands,
     /* 47196 */       // GIR_Coverage, 1891,
     /* 47196 */       GIR_EraseRootFromParent_Done,
     /* 47197 */     // Label 1214: @47197
     /* 47197 */     GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(47233), // Rule ID 1892 //
     /* 47202 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47205 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47209 */       // MIs[0] Operand 1
     /* 47209 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 47214 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47218 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47222 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs)
     /* 47222 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47225 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47227 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47229 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47231 */       GIR_RootConstrainSelectedInstOperands,
     /* 47232 */       // GIR_Coverage, 1892,
     /* 47232 */       GIR_EraseRootFromParent_Done,
     /* 47233 */     // Label 1215: @47233
     /* 47233 */     GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(47310), // Rule ID 1893 //
     /* 47238 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47241 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47245 */       // MIs[0] Operand 1
     /* 47245 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 47250 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47254 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47258 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$lhs, CPU16Regs:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XorRxRxRy16:{ *:[i32] } (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rhs, CPU16Regs:{ *:[i32] }:$lhs), (LiRxImmX16:{ *:[i32] } 1:{ *:[i32] }))
     /* 47258 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 47261 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::LiRxImmX16),
     /* 47265 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47270 */       GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 47273 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 47275 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47278 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47282 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47287 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47291 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47295 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47297 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XorRxRxRy16),
     /* 47300 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rz]
     /* 47302 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47305 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 47308 */       GIR_RootConstrainSelectedInstOperands,
     /* 47309 */       // GIR_Coverage, 1893,
     /* 47309 */       GIR_EraseRootFromParent_Done,
     /* 47310 */     // Label 1216: @47310
     /* 47310 */     GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(47346), // Rule ID 1894 //
     /* 47315 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 47318 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47322 */       // MIs[0] Operand 1
     /* 47322 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 47327 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47331 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 47335 */       // (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry, SETULT:{ *:[Other] })  =>  (SltuCCRxRy16:{ *:[i32] } CPU16Regs:{ *:[i32] }:$rx, CPU16Regs:{ *:[i32] }:$ry)
     /* 47335 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SltuCCRxRy16),
     /* 47338 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[cc]
     /* 47340 */       GIR_RootToRootCopy, /*OpIdx*/2, // rx
     /* 47342 */       GIR_RootToRootCopy, /*OpIdx*/3, // ry
     /* 47344 */       GIR_RootConstrainSelectedInstOperands,
     /* 47345 */       // GIR_Coverage, 1894,
     /* 47345 */       GIR_EraseRootFromParent_Done,
     /* 47346 */     // Label 1217: @47346
     /* 47346 */     GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(47406), // Rule ID 2206 //
     /* 47351 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47354 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47358 */       // MIs[0] Operand 1
     /* 47358 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 47363 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47367 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47371 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] })  =>  (SLTiu_MM:{ *:[i32] } (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47371 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47374 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 47378 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47383 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47387 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47391 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47393 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTiu_MM),
     /* 47396 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47398 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47401 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47404 */       GIR_RootConstrainSelectedInstOperands,
     /* 47405 */       // GIR_Coverage, 2206,
     /* 47405 */       GIR_EraseRootFromParent_Done,
     /* 47406 */     // Label 1218: @47406
     /* 47406 */     GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(47469), // Rule ID 2207 //
     /* 47411 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47414 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47418 */       // MIs[0] Operand 1
     /* 47418 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 47423 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47427 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47431 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } ZERO:{ *:[i32] }, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs))
     /* 47431 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47434 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 47438 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47443 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47447 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47451 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47453 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47456 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47458 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 47464 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47467 */       GIR_RootConstrainSelectedInstOperands,
     /* 47468 */       // GIR_Coverage, 2207,
     /* 47468 */       GIR_EraseRootFromParent_Done,
     /* 47469 */     // Label 1219: @47469
     /* 47469 */     GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(47529), // Rule ID 2208 //
     /* 47474 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47477 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47481 */       // MIs[0] Operand 1
     /* 47481 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 47486 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47490 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47494 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 47494 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47497 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47501 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47506 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47510 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47514 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47516 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47519 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47521 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47524 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47527 */       GIR_RootConstrainSelectedInstOperands,
     /* 47528 */       // GIR_Coverage, 2208,
     /* 47528 */       GIR_EraseRootFromParent_Done,
     /* 47529 */     // Label 1220: @47529
     /* 47529 */     GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(47589), // Rule ID 2209 //
     /* 47534 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47537 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47541 */       // MIs[0] Operand 1
     /* 47541 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 47546 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47550 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47554 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), 1:{ *:[i32] })
     /* 47554 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47557 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47561 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47566 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47570 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47574 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47576 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47579 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47581 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47584 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47587 */       GIR_RootConstrainSelectedInstOperands,
     /* 47588 */       // GIR_Coverage, 2209,
     /* 47588 */       GIR_EraseRootFromParent_Done,
     /* 47589 */     // Label 1221: @47589
     /* 47589 */     GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(47625), // Rule ID 2210 //
     /* 47594 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47597 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47601 */       // MIs[0] Operand 1
     /* 47601 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 47606 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47610 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47614 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] })  =>  (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 47614 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47617 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47619 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47621 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47623 */       GIR_RootConstrainSelectedInstOperands,
     /* 47624 */       // GIR_Coverage, 2210,
     /* 47624 */       GIR_EraseRootFromParent_Done,
     /* 47625 */     // Label 1222: @47625
     /* 47625 */     GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(47661), // Rule ID 2211 //
     /* 47630 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47633 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47637 */       // MIs[0] Operand 1
     /* 47637 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 47642 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47646 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47650 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] })  =>  (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs)
     /* 47650 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47653 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 47655 */       GIR_RootToRootCopy, /*OpIdx*/3, // rhs
     /* 47657 */       GIR_RootToRootCopy, /*OpIdx*/2, // lhs
     /* 47659 */       GIR_RootConstrainSelectedInstOperands,
     /* 47660 */       // GIR_Coverage, 2211,
     /* 47660 */       GIR_EraseRootFromParent_Done,
     /* 47661 */     // Label 1223: @47661
     /* 47661 */     GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(47721), // Rule ID 2212 //
     /* 47666 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47669 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47673 */       // MIs[0] Operand 1
     /* 47673 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 47678 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47682 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47686 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47686 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47689 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 47693 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47698 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47702 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47706 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47708 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47711 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47713 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47716 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47719 */       GIR_RootConstrainSelectedInstOperands,
     /* 47720 */       // GIR_Coverage, 2212,
     /* 47720 */       GIR_EraseRootFromParent_Done,
     /* 47721 */     // Label 1224: @47721
     /* 47721 */     GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(47781), // Rule ID 2213 //
     /* 47726 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 47729 */       GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47733 */       // MIs[0] Operand 1
     /* 47733 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 47738 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47742 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 47746 */       // (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] })  =>  (XORi_MM:{ *:[i32] } (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), 1:{ *:[i32] })
     /* 47746 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 47749 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 47753 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 47758 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 47762 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 47766 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 47768 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::XORi_MM),
     /* 47771 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rt]
     /* 47773 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 47776 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 47779 */       GIR_RootConstrainSelectedInstOperands,
     /* 47780 */       // GIR_Coverage, 2213,
     /* 47780 */       GIR_EraseRootFromParent_Done,
     /* 47781 */     // Label 1225: @47781
     /* 47781 */     GIM_Reject,
     /* 47782 */   // Label 1207: @47782
     /* 47782 */   GIM_Reject,
     /* 47783 */ // Label 1161: @47783
     /* 47783 */ GIM_Reject,
     /* 47784 */ // Label 42: @47784
     /* 47784 */ GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(49489),
     /* 47789 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 47792 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1229*/ GIMT_Encode4(48287),
     /* 47803 */   /*GILLT_s32*//*Label 1227*/ GIMT_Encode4(47811),
     /* 47807 */   /*GILLT_s64*//*Label 1228*/ GIMT_Encode4(48049),
     /* 47811 */   // Label 1227: @47811
     /* 47811 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(48048),
     /* 47816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 47819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 47823 */     GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(47855), // Rule ID 312 //
     /* 47828 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47831 */       // MIs[0] Operand 1
     /* 47831 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 47836 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47840 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47844 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47844 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S),
     /* 47847 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47849 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47851 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47853 */       GIR_RootConstrainSelectedInstOperands,
     /* 47854 */       // GIR_Coverage, 312,
     /* 47854 */       GIR_EraseRootFromParent_Done,
     /* 47855 */     // Label 1231: @47855
     /* 47855 */     GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(47887), // Rule ID 313 //
     /* 47860 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47863 */       // MIs[0] Operand 1
     /* 47863 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 47868 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47872 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47876 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47876 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S),
     /* 47879 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47881 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47883 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47885 */       GIR_RootConstrainSelectedInstOperands,
     /* 47886 */       // GIR_Coverage, 313,
     /* 47886 */       GIR_EraseRootFromParent_Done,
     /* 47887 */     // Label 1232: @47887
     /* 47887 */     GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(47919), // Rule ID 314 //
     /* 47892 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47895 */       // MIs[0] Operand 1
     /* 47895 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 47900 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47904 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47908 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47908 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S),
     /* 47911 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47913 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47915 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47917 */       GIR_RootConstrainSelectedInstOperands,
     /* 47918 */       // GIR_Coverage, 314,
     /* 47918 */       GIR_EraseRootFromParent_Done,
     /* 47919 */     // Label 1233: @47919
     /* 47919 */     GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(47951), // Rule ID 315 //
     /* 47924 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47927 */       // MIs[0] Operand 1
     /* 47927 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 47932 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47936 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47940 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47940 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_S),
     /* 47943 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47945 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47947 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47949 */       GIR_RootConstrainSelectedInstOperands,
     /* 47950 */       // GIR_Coverage, 315,
     /* 47950 */       GIR_EraseRootFromParent_Done,
     /* 47951 */     // Label 1234: @47951
     /* 47951 */     GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(47983), // Rule ID 316 //
     /* 47956 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47959 */       // MIs[0] Operand 1
     /* 47959 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 47964 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47968 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 47972 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 47972 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_S),
     /* 47975 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 47977 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 47979 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 47981 */       GIR_RootConstrainSelectedInstOperands,
     /* 47982 */       // GIR_Coverage, 316,
     /* 47982 */       GIR_EraseRootFromParent_Done,
     /* 47983 */     // Label 1235: @47983
     /* 47983 */     GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(48015), // Rule ID 317 //
     /* 47988 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 47991 */       // MIs[0] Operand 1
     /* 47991 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 47996 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48000 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48004 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48004 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_S),
     /* 48007 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48009 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48011 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48013 */       GIR_RootConstrainSelectedInstOperands,
     /* 48014 */       // GIR_Coverage, 317,
     /* 48014 */       GIR_EraseRootFromParent_Done,
     /* 48015 */     // Label 1236: @48015
     /* 48015 */     GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(48047), // Rule ID 318 //
     /* 48020 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48023 */       // MIs[0] Operand 1
     /* 48023 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48028 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48032 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48036 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_S:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48036 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_S),
     /* 48039 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48041 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48043 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48045 */       GIR_RootConstrainSelectedInstOperands,
     /* 48046 */       // GIR_Coverage, 318,
     /* 48046 */       GIR_EraseRootFromParent_Done,
     /* 48047 */     // Label 1237: @48047
     /* 48047 */     GIM_Reject,
     /* 48048 */   // Label 1230: @48048
     /* 48048 */   GIM_Reject,
     /* 48049 */   // Label 1228: @48049
     /* 48049 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(48286),
     /* 48054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48061 */     GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(48093), // Rule ID 319 //
     /* 48066 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48069 */       // MIs[0] Operand 1
     /* 48069 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48074 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48078 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48082 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48082 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D),
     /* 48085 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48087 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48089 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48091 */       GIR_RootConstrainSelectedInstOperands,
     /* 48092 */       // GIR_Coverage, 319,
     /* 48092 */       GIR_EraseRootFromParent_Done,
     /* 48093 */     // Label 1239: @48093
     /* 48093 */     GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(48125), // Rule ID 320 //
     /* 48098 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48101 */       // MIs[0] Operand 1
     /* 48101 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48106 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48110 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48114 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48114 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D),
     /* 48117 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48119 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48121 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48123 */       GIR_RootConstrainSelectedInstOperands,
     /* 48124 */       // GIR_Coverage, 320,
     /* 48124 */       GIR_EraseRootFromParent_Done,
     /* 48125 */     // Label 1240: @48125
     /* 48125 */     GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(48157), // Rule ID 321 //
     /* 48130 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48133 */       // MIs[0] Operand 1
     /* 48133 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48138 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48142 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48146 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48146 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D),
     /* 48149 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48151 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48153 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48155 */       GIR_RootConstrainSelectedInstOperands,
     /* 48156 */       // GIR_Coverage, 321,
     /* 48156 */       GIR_EraseRootFromParent_Done,
     /* 48157 */     // Label 1241: @48157
     /* 48157 */     GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(48189), // Rule ID 322 //
     /* 48162 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48165 */       // MIs[0] Operand 1
     /* 48165 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48170 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48174 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48178 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48178 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_D),
     /* 48181 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48183 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48185 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48187 */       GIR_RootConstrainSelectedInstOperands,
     /* 48188 */       // GIR_Coverage, 322,
     /* 48188 */       GIR_EraseRootFromParent_Done,
     /* 48189 */     // Label 1242: @48189
     /* 48189 */     GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(48221), // Rule ID 323 //
     /* 48194 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48197 */       // MIs[0] Operand 1
     /* 48197 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48202 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48206 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48210 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48210 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_D),
     /* 48213 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48215 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48217 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48219 */       GIR_RootConstrainSelectedInstOperands,
     /* 48220 */       // GIR_Coverage, 323,
     /* 48220 */       GIR_EraseRootFromParent_Done,
     /* 48221 */     // Label 1243: @48221
     /* 48221 */     GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(48253), // Rule ID 324 //
     /* 48226 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48229 */       // MIs[0] Operand 1
     /* 48229 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48234 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48238 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48242 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48242 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_D),
     /* 48245 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48247 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48249 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48251 */       GIR_RootConstrainSelectedInstOperands,
     /* 48252 */       // GIR_Coverage, 324,
     /* 48252 */       GIR_EraseRootFromParent_Done,
     /* 48253 */     // Label 1244: @48253
     /* 48253 */     GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(48285), // Rule ID 325 //
     /* 48258 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 48261 */       // MIs[0] Operand 1
     /* 48261 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48266 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48270 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48274 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_D:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48274 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_D),
     /* 48277 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48279 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48281 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48283 */       GIR_RootConstrainSelectedInstOperands,
     /* 48284 */       // GIR_Coverage, 325,
     /* 48284 */       GIR_EraseRootFromParent_Done,
     /* 48285 */     // Label 1245: @48285
     /* 48285 */     GIM_Reject,
     /* 48286 */   // Label 1238: @48286
     /* 48286 */   GIM_Reject,
     /* 48287 */   // Label 1229: @48287
     /* 48287 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1248*/ GIMT_Encode4(48782),
     /* 48298 */   /*GILLT_s32*//*Label 1246*/ GIMT_Encode4(48306),
     /* 48302 */   /*GILLT_s64*//*Label 1247*/ GIMT_Encode4(48544),
     /* 48306 */   // Label 1246: @48306
     /* 48306 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(48543),
     /* 48311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 48314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48318 */     GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(48350), // Rule ID 1193 //
     /* 48323 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48326 */       // MIs[0] Operand 1
     /* 48326 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48331 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48335 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48339 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48339 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S_MMR6),
     /* 48342 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48344 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48346 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48348 */       GIR_RootConstrainSelectedInstOperands,
     /* 48349 */       // GIR_Coverage, 1193,
     /* 48349 */       GIR_EraseRootFromParent_Done,
     /* 48350 */     // Label 1250: @48350
     /* 48350 */     GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(48382), // Rule ID 1194 //
     /* 48355 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48358 */       // MIs[0] Operand 1
     /* 48358 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48363 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48367 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48371 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48371 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S_MMR6),
     /* 48374 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48376 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48378 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48380 */       GIR_RootConstrainSelectedInstOperands,
     /* 48381 */       // GIR_Coverage, 1194,
     /* 48381 */       GIR_EraseRootFromParent_Done,
     /* 48382 */     // Label 1251: @48382
     /* 48382 */     GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(48414), // Rule ID 1195 //
     /* 48387 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48390 */       // MIs[0] Operand 1
     /* 48390 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48395 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48399 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48403 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48403 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S_MMR6),
     /* 48406 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48408 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48410 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48412 */       GIR_RootConstrainSelectedInstOperands,
     /* 48413 */       // GIR_Coverage, 1195,
     /* 48413 */       GIR_EraseRootFromParent_Done,
     /* 48414 */     // Label 1252: @48414
     /* 48414 */     GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(48446), // Rule ID 1196 //
     /* 48419 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48422 */       // MIs[0] Operand 1
     /* 48422 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48427 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48431 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48435 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_S_MMR6),
     /* 48438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48440 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48442 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48444 */       GIR_RootConstrainSelectedInstOperands,
     /* 48445 */       // GIR_Coverage, 1196,
     /* 48445 */       GIR_EraseRootFromParent_Done,
     /* 48446 */     // Label 1253: @48446
     /* 48446 */     GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(48478), // Rule ID 1197 //
     /* 48451 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48454 */       // MIs[0] Operand 1
     /* 48454 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48459 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48463 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48467 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48467 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_S_MMR6),
     /* 48470 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48472 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48474 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48476 */       GIR_RootConstrainSelectedInstOperands,
     /* 48477 */       // GIR_Coverage, 1197,
     /* 48477 */       GIR_EraseRootFromParent_Done,
     /* 48478 */     // Label 1254: @48478
     /* 48478 */     GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(48510), // Rule ID 1198 //
     /* 48483 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48486 */       // MIs[0] Operand 1
     /* 48486 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48491 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48495 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48499 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48499 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_S_MMR6),
     /* 48502 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48504 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48506 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48508 */       GIR_RootConstrainSelectedInstOperands,
     /* 48509 */       // GIR_Coverage, 1198,
     /* 48509 */       GIR_EraseRootFromParent_Done,
     /* 48510 */     // Label 1255: @48510
     /* 48510 */     GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(48542), // Rule ID 1199 //
     /* 48515 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48518 */       // MIs[0] Operand 1
     /* 48518 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48523 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48527 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 48531 */       // (setcc:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_S_MMR6:{ *:[i32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 48531 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_S_MMR6),
     /* 48534 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48536 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48538 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48540 */       GIR_RootConstrainSelectedInstOperands,
     /* 48541 */       // GIR_Coverage, 1199,
     /* 48541 */       GIR_EraseRootFromParent_Done,
     /* 48542 */     // Label 1256: @48542
     /* 48542 */     GIM_Reject,
     /* 48543 */   // Label 1249: @48543
     /* 48543 */   GIM_Reject,
     /* 48544 */   // Label 1247: @48544
     /* 48544 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(48781),
     /* 48549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 48556 */     GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(48588), // Rule ID 1200 //
     /* 48561 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48564 */       // MIs[0] Operand 1
     /* 48564 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNO),
     /* 48569 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48573 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48577 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUO:{ *:[Other] })  =>  (CMP_UN_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48577 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D_MMR6),
     /* 48580 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48582 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48584 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48586 */       GIR_RootConstrainSelectedInstOperands,
     /* 48587 */       // GIR_Coverage, 1200,
     /* 48587 */       GIR_EraseRootFromParent_Done,
     /* 48588 */     // Label 1258: @48588
     /* 48588 */     GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(48620), // Rule ID 1201 //
     /* 48593 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48596 */       // MIs[0] Operand 1
     /* 48596 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 48601 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48605 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48609 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOEQ:{ *:[Other] })  =>  (CMP_EQ_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48609 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D_MMR6),
     /* 48612 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48614 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48616 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48618 */       GIR_RootConstrainSelectedInstOperands,
     /* 48619 */       // GIR_Coverage, 1201,
     /* 48619 */       GIR_EraseRootFromParent_Done,
     /* 48620 */     // Label 1259: @48620
     /* 48620 */     GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(48652), // Rule ID 1202 //
     /* 48625 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48628 */       // MIs[0] Operand 1
     /* 48628 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UEQ),
     /* 48633 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48637 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48641 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETUEQ:{ *:[Other] })  =>  (CMP_UEQ_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48641 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D_MMR6),
     /* 48644 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48646 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48648 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48650 */       GIR_RootConstrainSelectedInstOperands,
     /* 48651 */       // GIR_Coverage, 1202,
     /* 48651 */       GIR_EraseRootFromParent_Done,
     /* 48652 */     // Label 1260: @48652
     /* 48652 */     GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(48684), // Rule ID 1203 //
     /* 48657 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48660 */       // MIs[0] Operand 1
     /* 48660 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 48665 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48669 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48673 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLT:{ *:[Other] })  =>  (CMP_LT_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48673 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LT_D_MMR6),
     /* 48676 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48678 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48680 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48682 */       GIR_RootConstrainSelectedInstOperands,
     /* 48683 */       // GIR_Coverage, 1203,
     /* 48683 */       GIR_EraseRootFromParent_Done,
     /* 48684 */     // Label 1261: @48684
     /* 48684 */     GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(48716), // Rule ID 1204 //
     /* 48689 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48692 */       // MIs[0] Operand 1
     /* 48692 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULT),
     /* 48697 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48701 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48705 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULT:{ *:[Other] })  =>  (CMP_ULT_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48705 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULT_D_MMR6),
     /* 48708 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48710 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48712 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48714 */       GIR_RootConstrainSelectedInstOperands,
     /* 48715 */       // GIR_Coverage, 1204,
     /* 48715 */       GIR_EraseRootFromParent_Done,
     /* 48716 */     // Label 1262: @48716
     /* 48716 */     GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(48748), // Rule ID 1205 //
     /* 48721 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48724 */       // MIs[0] Operand 1
     /* 48724 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 48729 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48733 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48737 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETOLE:{ *:[Other] })  =>  (CMP_LE_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48737 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_LE_D_MMR6),
     /* 48740 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48742 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48744 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48746 */       GIR_RootConstrainSelectedInstOperands,
     /* 48747 */       // GIR_Coverage, 1205,
     /* 48747 */       GIR_EraseRootFromParent_Done,
     /* 48748 */     // Label 1263: @48748
     /* 48748 */     GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(48780), // Rule ID 1206 //
     /* 48753 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 48756 */       // MIs[0] Operand 1
     /* 48756 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ULE),
     /* 48761 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48765 */       GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 48769 */       // (setcc:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft, SETULE:{ *:[Other] })  =>  (CMP_ULE_D_MMR6:{ *:[i32] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 48769 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CMP_ULE_D_MMR6),
     /* 48772 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 48774 */       GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 48776 */       GIR_RootToRootCopy, /*OpIdx*/3, // ft
     /* 48778 */       GIR_RootConstrainSelectedInstOperands,
     /* 48779 */       // GIR_Coverage, 1206,
     /* 48779 */       GIR_EraseRootFromParent_Done,
     /* 48780 */     // Label 1264: @48780
     /* 48780 */     GIM_Reject,
     /* 48781 */   // Label 1257: @48781
     /* 48781 */   GIM_Reject,
     /* 48782 */   // Label 1248: @48782
     /* 48782 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1267*/ GIMT_Encode4(49135),
     /* 48793 */   /*GILLT_s32*//*Label 1265*/ GIMT_Encode4(48801),
     /* 48797 */   /*GILLT_s64*//*Label 1266*/ GIMT_Encode4(48968),
     /* 48801 */   // Label 1265: @48801
     /* 48801 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(48967),
     /* 48806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 48809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 48813 */     GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(48864), // Rule ID 1755 //
     /* 48818 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48821 */       // MIs[0] Operand 1
     /* 48821 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 48826 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UEQ_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48826 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48829 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S),
     /* 48833 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48838 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48842 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48846 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48848 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48851 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48853 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48856 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48862 */       GIR_RootConstrainSelectedInstOperands,
     /* 48863 */       // GIR_Coverage, 1755,
     /* 48863 */       GIR_EraseRootFromParent_Done,
     /* 48864 */     // Label 1269: @48864
     /* 48864 */     GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(48915), // Rule ID 1756 //
     /* 48869 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48872 */       // MIs[0] Operand 1
     /* 48872 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 48877 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETO:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UN_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48877 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48880 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S),
     /* 48884 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48889 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48893 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48897 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48899 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48902 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48904 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48907 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48913 */       GIR_RootConstrainSelectedInstOperands,
     /* 48914 */       // GIR_Coverage, 1756,
     /* 48914 */       GIR_EraseRootFromParent_Done,
     /* 48915 */     // Label 1270: @48915
     /* 48915 */     GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(48966), // Rule ID 1757 //
     /* 48920 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48923 */       // MIs[0] Operand 1
     /* 48923 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 48928 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_EQ_S:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 48928 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48931 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S),
     /* 48935 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 48940 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 48944 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 48948 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 48950 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 48953 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 48955 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 48958 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 48964 */       GIR_RootConstrainSelectedInstOperands,
     /* 48965 */       // GIR_Coverage, 1757,
     /* 48965 */       GIR_EraseRootFromParent_Done,
     /* 48966 */     // Label 1271: @48966
     /* 48966 */     GIM_Reject,
     /* 48967 */   // Label 1268: @48967
     /* 48967 */   GIM_Reject,
     /* 48968 */   // Label 1266: @48968
     /* 48968 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(49134),
     /* 48973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 48976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 48980 */     GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(49031), // Rule ID 1764 //
     /* 48985 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 48988 */       // MIs[0] Operand 1
     /* 48988 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 48993 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UEQ_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 48993 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 48996 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D),
     /* 49000 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49005 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49009 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49013 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49015 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49018 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49020 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49023 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49029 */       GIR_RootConstrainSelectedInstOperands,
     /* 49030 */       // GIR_Coverage, 1764,
     /* 49030 */       GIR_EraseRootFromParent_Done,
     /* 49031 */     // Label 1273: @49031
     /* 49031 */     GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(49082), // Rule ID 1765 //
     /* 49036 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49039 */       // MIs[0] Operand 1
     /* 49039 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49044 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETO:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_UN_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49044 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49047 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D),
     /* 49051 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49056 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49060 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49064 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49066 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49069 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49071 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49074 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49080 */       GIR_RootConstrainSelectedInstOperands,
     /* 49081 */       // GIR_Coverage, 1765,
     /* 49081 */       GIR_EraseRootFromParent_Done,
     /* 49082 */     // Label 1274: @49082
     /* 49082 */     GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(49133), // Rule ID 1766 //
     /* 49087 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 49090 */       // MIs[0] Operand 1
     /* 49090 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49095 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR:{ *:[i32] } (CMP_EQ_D:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49095 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49098 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D),
     /* 49102 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49107 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49111 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49115 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49117 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR),
     /* 49120 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49122 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49125 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49131 */       GIR_RootConstrainSelectedInstOperands,
     /* 49132 */       // GIR_Coverage, 1766,
     /* 49132 */       GIR_EraseRootFromParent_Done,
     /* 49133 */     // Label 1275: @49133
     /* 49133 */     GIM_Reject,
     /* 49134 */   // Label 1272: @49134
     /* 49134 */   GIM_Reject,
     /* 49135 */   // Label 1267: @49135
     /* 49135 */   GIM_SwitchType, /*MI*/0, /*Op*/2, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1278*/ GIMT_Encode4(49488),
     /* 49146 */   /*GILLT_s32*//*Label 1276*/ GIMT_Encode4(49154),
     /* 49150 */   /*GILLT_s64*//*Label 1277*/ GIMT_Encode4(49321),
     /* 49154 */   // Label 1276: @49154
     /* 49154 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(49320),
     /* 49159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49166 */     GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(49217), // Rule ID 2305 //
     /* 49171 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49174 */       // MIs[0] Operand 1
     /* 49174 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49179 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UEQ_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49179 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49182 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_S_MMR6),
     /* 49186 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49191 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49195 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49199 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49201 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49204 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49206 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49209 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49215 */       GIR_RootConstrainSelectedInstOperands,
     /* 49216 */       // GIR_Coverage, 2305,
     /* 49216 */       GIR_EraseRootFromParent_Done,
     /* 49217 */     // Label 1280: @49217
     /* 49217 */     GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(49268), // Rule ID 2306 //
     /* 49222 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49225 */       // MIs[0] Operand 1
     /* 49225 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49230 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETO:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UN_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49230 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49233 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_S_MMR6),
     /* 49237 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49242 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49246 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49250 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49252 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49255 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49257 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49260 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49266 */       GIR_RootConstrainSelectedInstOperands,
     /* 49267 */       // GIR_Coverage, 2306,
     /* 49267 */       GIR_EraseRootFromParent_Done,
     /* 49268 */     // Label 1281: @49268
     /* 49268 */     GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(49319), // Rule ID 2307 //
     /* 49273 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49276 */       // MIs[0] Operand 1
     /* 49276 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49281 */       // (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_EQ_S_MMR6:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs), ZERO:{ *:[i32] })
     /* 49281 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49284 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_S_MMR6),
     /* 49288 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49293 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49297 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49301 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49303 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49306 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49308 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49311 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49317 */       GIR_RootConstrainSelectedInstOperands,
     /* 49318 */       // GIR_Coverage, 2307,
     /* 49318 */       GIR_EraseRootFromParent_Done,
     /* 49319 */     // Label 1282: @49319
     /* 49319 */     GIM_Reject,
     /* 49320 */   // Label 1279: @49320
     /* 49320 */   GIM_Reject,
     /* 49321 */   // Label 1277: @49321
     /* 49321 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(49487),
     /* 49326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 49329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49333 */     GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(49384), // Rule ID 2314 //
     /* 49338 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49341 */       // MIs[0] Operand 1
     /* 49341 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ONE),
     /* 49346 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETONE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UEQ_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49346 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49349 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UEQ_D_MMR6),
     /* 49353 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49358 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49362 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49366 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49368 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49371 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49373 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49376 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49382 */       GIR_RootConstrainSelectedInstOperands,
     /* 49383 */       // GIR_Coverage, 2314,
     /* 49383 */       GIR_EraseRootFromParent_Done,
     /* 49384 */     // Label 1284: @49384
     /* 49384 */     GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(49435), // Rule ID 2315 //
     /* 49389 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49392 */       // MIs[0] Operand 1
     /* 49392 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_ORD),
     /* 49397 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETO:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_UN_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49397 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49400 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_UN_D_MMR6),
     /* 49404 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49409 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49413 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49417 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49419 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49422 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49424 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49427 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49433 */       GIR_RootConstrainSelectedInstOperands,
     /* 49434 */       // GIR_Coverage, 2315,
     /* 49434 */       GIR_EraseRootFromParent_Done,
     /* 49435 */     // Label 1285: @49435
     /* 49435 */     GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(49486), // Rule ID 2316 //
     /* 49440 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 49443 */       // MIs[0] Operand 1
     /* 49443 */       GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 49448 */       // (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] })  =>  (NOR_MMR6:{ *:[i32] } (CMP_EQ_D_MMR6:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs), ZERO:{ *:[i32] })
     /* 49448 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 49451 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::CMP_EQ_D_MMR6),
     /* 49455 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 49460 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // lhs
     /* 49464 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rhs
     /* 49468 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 49470 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NOR_MMR6),
     /* 49473 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49475 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 49478 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(Mips::ZERO), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 49484 */       GIR_RootConstrainSelectedInstOperands,
     /* 49485 */       // GIR_Coverage, 2316,
     /* 49485 */       GIR_EraseRootFromParent_Done,
     /* 49486 */     // Label 1286: @49486
     /* 49486 */     GIM_Reject,
     /* 49487 */   // Label 1283: @49487
     /* 49487 */   GIM_Reject,
     /* 49488 */   // Label 1278: @49488
     /* 49488 */   GIM_Reject,
     /* 49489 */ // Label 1226: @49489
     /* 49489 */ GIM_Reject,
     /* 49490 */ // Label 43: @49490
     /* 49490 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1293*/ GIMT_Encode4(61527),
     /* 49501 */ /*GILLT_s32*//*Label 1287*/ GIMT_Encode4(49533),
     /* 49505 */ /*GILLT_s64*//*Label 1288*/ GIMT_Encode4(56210), GIMT_Encode4(0),
     /* 49513 */ /*GILLT_v2s64*//*Label 1289*/ GIMT_Encode4(61237), GIMT_Encode4(0),
     /* 49521 */ /*GILLT_v4s32*//*Label 1290*/ GIMT_Encode4(61311),
     /* 49525 */ /*GILLT_v8s16*//*Label 1291*/ GIMT_Encode4(61385),
     /* 49529 */ /*GILLT_v16s8*//*Label 1292*/ GIMT_Encode4(61432),
     /* 49533 */ // Label 1287: @49533
     /* 49533 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(49609), // Rule ID 1643 //
     /* 49538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49562 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49566 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49570 */   // MIs[1] Operand 1
     /* 49570 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49575 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49580 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49588 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49594 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49594 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 49597 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49599 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49601 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49605 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49607 */   GIR_RootConstrainSelectedInstOperands,
     /* 49608 */   // GIR_Coverage, 1643,
     /* 49608 */   GIR_EraseRootFromParent_Done,
     /* 49609 */ // Label 1294: @49609
     /* 49609 */ GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(49685), // Rule ID 1647 //
     /* 49614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49623 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49630 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49634 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49642 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49646 */   // MIs[1] Operand 1
     /* 49646 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49651 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49656 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49668 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49670 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 49673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49675 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49677 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49681 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49683 */   GIR_RootConstrainSelectedInstOperands,
     /* 49684 */   // GIR_Coverage, 1647,
     /* 49684 */   GIR_EraseRootFromParent_Done,
     /* 49685 */ // Label 1295: @49685
     /* 49685 */ GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(49761), // Rule ID 1675 //
     /* 49690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49706 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49710 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49714 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 49718 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 49722 */   // MIs[1] Operand 1
     /* 49722 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49727 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 49732 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49740 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49744 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49746 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I),
     /* 49749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49751 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49753 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49757 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49759 */   GIR_RootConstrainSelectedInstOperands,
     /* 49760 */   // GIR_Coverage, 1675,
     /* 49760 */   GIR_EraseRootFromParent_Done,
     /* 49761 */ // Label 1296: @49761
     /* 49761 */ GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(49837), // Rule ID 1686 //
     /* 49766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49782 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49786 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49790 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 49794 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 49798 */   // MIs[1] Operand 1
     /* 49798 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49803 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 49808 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49816 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49820 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49822 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 49822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 49825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 49827 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49829 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49833 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49835 */   GIR_RootConstrainSelectedInstOperands,
     /* 49836 */   // GIR_Coverage, 1686,
     /* 49836 */   GIR_EraseRootFromParent_Done,
     /* 49837 */ // Label 1297: @49837
     /* 49837 */ GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(49913), // Rule ID 1699 //
     /* 49842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49858 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49866 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49870 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49874 */   // MIs[1] Operand 1
     /* 49874 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 49879 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49884 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49892 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49898 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 49898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 49901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 49903 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49905 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49909 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49911 */   GIR_RootConstrainSelectedInstOperands,
     /* 49912 */   // GIR_Coverage, 1699,
     /* 49912 */   GIR_EraseRootFromParent_Done,
     /* 49913 */ // Label 1298: @49913
     /* 49913 */ GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(49989), // Rule ID 1702 //
     /* 49918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 49924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 49927 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 49930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49934 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 49938 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 49942 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 49946 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 49950 */   // MIs[1] Operand 1
     /* 49950 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 49955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 49960 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 49964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49968 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 49972 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 49974 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 49974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 49977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 49979 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 49981 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 49985 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 49987 */   GIR_RootConstrainSelectedInstOperands,
     /* 49988 */   // GIR_Coverage, 1702,
     /* 49988 */   GIR_EraseRootFromParent_Done,
     /* 49989 */ // Label 1299: @49989
     /* 49989 */ GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(50065), // Rule ID 1712 //
     /* 49994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 49997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50018 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 50022 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 50026 */   // MIs[1] Operand 1
     /* 50026 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50031 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 50036 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50044 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50048 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50050 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_S),
     /* 50053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50055 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50057 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50061 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50063 */   GIR_RootConstrainSelectedInstOperands,
     /* 50064 */   // GIR_Coverage, 1712,
     /* 50064 */   GIR_EraseRootFromParent_Done,
     /* 50065 */ // Label 1300: @50065
     /* 50065 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(50141), // Rule ID 1715 //
     /* 50070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50086 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50090 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50094 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 50098 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 50102 */   // MIs[1] Operand 1
     /* 50102 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50107 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 50112 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50120 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50124 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50126 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 50129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50131 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50133 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50137 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50139 */   GIR_RootConstrainSelectedInstOperands,
     /* 50140 */   // GIR_Coverage, 1715,
     /* 50140 */   GIR_EraseRootFromParent_Done,
     /* 50141 */ // Label 1301: @50141
     /* 50141 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(50217), // Rule ID 1876 //
     /* 50146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 50149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50174 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50178 */   // MIs[1] Operand 1
     /* 50178 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50188 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50192 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50196 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50202 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBeqZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 50202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBeqZ),
     /* 50205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 50207 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 50209 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 50211 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 50215 */   GIR_RootConstrainSelectedInstOperands,
     /* 50216 */   // GIR_Coverage, 1876,
     /* 50216 */   GIR_EraseRootFromParent_Done,
     /* 50217 */ // Label 1302: @50217
     /* 50217 */ GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(50293), // Rule ID 1879 //
     /* 50222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 50225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50231 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50238 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50242 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50246 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50250 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50254 */   // MIs[1] Operand 1
     /* 50254 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50259 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50264 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50272 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 50276 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50278 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, 0:{ *:[i32] }, SETNE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBneZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 50278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBneZ),
     /* 50281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 50283 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 50285 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 50287 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 50291 */   GIR_RootConstrainSelectedInstOperands,
     /* 50292 */   // GIR_Coverage, 1879,
     /* 50292 */   GIR_EraseRootFromParent_Done,
     /* 50293 */ // Label 1303: @50293
     /* 50293 */ GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(50369), // Rule ID 2225 //
     /* 50298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50307 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50314 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50318 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50322 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50326 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50330 */   // MIs[1] Operand 1
     /* 50330 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50335 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50340 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50348 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50354 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 50357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50359 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50361 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50365 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50367 */   GIR_RootConstrainSelectedInstOperands,
     /* 50368 */   // GIR_Coverage, 2225,
     /* 50368 */   GIR_EraseRootFromParent_Done,
     /* 50369 */ // Label 1304: @50369
     /* 50369 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(50445), // Rule ID 2229 //
     /* 50374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 50377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50383 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50390 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50394 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50398 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50402 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50406 */   // MIs[1] Operand 1
     /* 50406 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50411 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50416 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50424 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50428 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50430 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 50433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50435 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50437 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50441 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50443 */   GIR_RootConstrainSelectedInstOperands,
     /* 50444 */   // GIR_Coverage, 2229,
     /* 50444 */   GIR_EraseRootFromParent_Done,
     /* 50445 */ // Label 1305: @50445
     /* 50445 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(50521), // Rule ID 2239 //
     /* 50450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50474 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50478 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50482 */   // MIs[1] Operand 1
     /* 50482 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50487 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50492 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50500 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50504 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50506 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 50509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50511 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50513 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50517 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50519 */   GIR_RootConstrainSelectedInstOperands,
     /* 50520 */   // GIR_Coverage, 2239,
     /* 50520 */   GIR_EraseRootFromParent_Done,
     /* 50521 */ // Label 1306: @50521
     /* 50521 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(50597), // Rule ID 2243 //
     /* 50526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50532 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50535 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50550 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50554 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50558 */   // MIs[1] Operand 1
     /* 50558 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50563 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50568 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50580 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50582 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$F)
     /* 50582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 50585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50587 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50589 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50593 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50595 */   GIR_RootConstrainSelectedInstOperands,
     /* 50596 */   // GIR_Coverage, 2243,
     /* 50596 */   GIR_EraseRootFromParent_Done,
     /* 50597 */ // Label 1307: @50597
     /* 50597 */ GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(50673), // Rule ID 2273 //
     /* 50602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50618 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50622 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50626 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50630 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50634 */   // MIs[1] Operand 1
     /* 50634 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 50639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50644 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50652 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50656 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50658 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 50661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50663 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50665 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50669 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50671 */   GIR_RootConstrainSelectedInstOperands,
     /* 50672 */   // GIR_Coverage, 2273,
     /* 50672 */   GIR_EraseRootFromParent_Done,
     /* 50673 */ // Label 1308: @50673
     /* 50673 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(50749), // Rule ID 2276 //
     /* 50678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 50681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50694 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50698 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50702 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50706 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50710 */   // MIs[1] Operand 1
     /* 50710 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 50715 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50720 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 50724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 50732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50734 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$lhs, FGR32:{ *:[f32] }:$F)
     /* 50734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 50737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 50739 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50741 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50745 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50747 */   GIR_RootConstrainSelectedInstOperands,
     /* 50748 */   // GIR_Coverage, 2276,
     /* 50748 */   GIR_EraseRootFromParent_Done,
     /* 50749 */ // Label 1309: @50749
     /* 50749 */ GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(50847), // Rule ID 1634 //
     /* 50754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50778 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50782 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50786 */   // MIs[1] Operand 1
     /* 50786 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 50791 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50796 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50811 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 50811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 50814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 50818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 50831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 50836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50838 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50843 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50845 */   GIR_RootConstrainSelectedInstOperands,
     /* 50846 */   // GIR_Coverage, 1634,
     /* 50846 */   GIR_EraseRootFromParent_Done,
     /* 50847 */ // Label 1310: @50847
     /* 50847 */ GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(50945), // Rule ID 1635 //
     /* 50852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50880 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50884 */   // MIs[1] Operand 1
     /* 50884 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 50889 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50894 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50903 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50907 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 50909 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 50909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 50912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 50916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 50921 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 50925 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 50929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 50931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 50934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 50936 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 50938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 50941 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 50943 */   GIR_RootConstrainSelectedInstOperands,
     /* 50944 */   // GIR_Coverage, 1635,
     /* 50944 */   GIR_EraseRootFromParent_Done,
     /* 50945 */ // Label 1311: @50945
     /* 50945 */ GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(51043), // Rule ID 1638 //
     /* 50950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 50953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 50956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 50959 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 50962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50966 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 50970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 50974 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 50978 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 50982 */   // MIs[1] Operand 1
     /* 50982 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 50987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 50997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51007 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 51014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51034 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51039 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51041 */   GIR_RootConstrainSelectedInstOperands,
     /* 51042 */   // GIR_Coverage, 1638,
     /* 51042 */   GIR_EraseRootFromParent_Done,
     /* 51043 */ // Label 1312: @51043
     /* 51043 */ GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(51141), // Rule ID 1639 //
     /* 51048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51072 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51076 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51080 */   // MIs[1] Operand 1
     /* 51080 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 51085 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51090 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51105 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 51112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51117 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51132 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51137 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51139 */   GIR_RootConstrainSelectedInstOperands,
     /* 51140 */   // GIR_Coverage, 1639,
     /* 51140 */   GIR_EraseRootFromParent_Done,
     /* 51141 */ // Label 1313: @51141
     /* 51141 */ GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(51239), // Rule ID 1642 //
     /* 51146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51174 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51178 */   // MIs[1] Operand 1
     /* 51178 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 51183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51188 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51203 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 51210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51230 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51235 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51237 */   GIR_RootConstrainSelectedInstOperands,
     /* 51238 */   // GIR_Coverage, 1642,
     /* 51238 */   GIR_EraseRootFromParent_Done,
     /* 51239 */ // Label 1314: @51239
     /* 51239 */ GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(51337), // Rule ID 1645 //
     /* 51244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51268 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51272 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51276 */   // MIs[1] Operand 1
     /* 51276 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 51281 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51301 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 51308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51313 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51317 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 51326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51328 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51333 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51335 */   GIR_RootConstrainSelectedInstOperands,
     /* 51336 */   // GIR_Coverage, 1645,
     /* 51336 */   GIR_EraseRootFromParent_Done,
     /* 51337 */ // Label 1315: @51337
     /* 51337 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(51435), // Rule ID 1656 //
     /* 51342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51370 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51374 */   // MIs[1] Operand 1
     /* 51374 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 51379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51384 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51399 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 51406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51411 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51426 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51431 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51433 */   GIR_RootConstrainSelectedInstOperands,
     /* 51434 */   // GIR_Coverage, 1656,
     /* 51434 */   GIR_EraseRootFromParent_Done,
     /* 51435 */ // Label 1316: @51435
     /* 51435 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(51533), // Rule ID 1657 //
     /* 51440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51464 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51468 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51472 */   // MIs[1] Operand 1
     /* 51472 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 51477 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51482 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51495 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51497 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 51504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51524 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51529 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51531 */   GIR_RootConstrainSelectedInstOperands,
     /* 51532 */   // GIR_Coverage, 1657,
     /* 51532 */   GIR_EraseRootFromParent_Done,
     /* 51533 */ // Label 1317: @51533
     /* 51533 */ GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(51631), // Rule ID 1660 //
     /* 51538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51562 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51566 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51570 */   // MIs[1] Operand 1
     /* 51570 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 51575 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51580 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51589 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51595 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 51602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51607 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51611 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51622 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51627 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51629 */   GIR_RootConstrainSelectedInstOperands,
     /* 51630 */   // GIR_Coverage, 1660,
     /* 51630 */   GIR_EraseRootFromParent_Done,
     /* 51631 */ // Label 1318: @51631
     /* 51631 */ GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(51729), // Rule ID 1661 //
     /* 51636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51660 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51664 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51668 */   // MIs[1] Operand 1
     /* 51668 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 51673 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51678 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51687 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51693 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 51693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 51700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51705 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I),
     /* 51718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51720 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51725 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51727 */   GIR_RootConstrainSelectedInstOperands,
     /* 51728 */   // GIR_Coverage, 1661,
     /* 51728 */   GIR_EraseRootFromParent_Done,
     /* 51729 */ // Label 1319: @51729
     /* 51729 */ GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(51827), // Rule ID 1674 //
     /* 51734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51758 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51762 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51766 */   // MIs[1] Operand 1
     /* 51766 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 51771 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51776 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51785 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51791 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 51794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 51798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51803 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51807 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I),
     /* 51816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51818 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51823 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51825 */   GIR_RootConstrainSelectedInstOperands,
     /* 51826 */   // GIR_Coverage, 1674,
     /* 51826 */   GIR_EraseRootFromParent_Done,
     /* 51827 */ // Label 1320: @51827
     /* 51827 */ GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(51925), // Rule ID 1684 //
     /* 51832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51856 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 51860 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 51864 */   // MIs[1] Operand 1
     /* 51864 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 51869 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 51879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51889 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 51889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 51892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 51896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51901 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 51905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 51909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 51911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 51914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 51916 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 51918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 51921 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 51923 */   GIR_RootConstrainSelectedInstOperands,
     /* 51924 */   // GIR_Coverage, 1684,
     /* 51924 */   GIR_EraseRootFromParent_Done,
     /* 51925 */ // Label 1321: @51925
     /* 51925 */ GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(52023), // Rule ID 1690 //
     /* 51930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 51933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 51936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 51939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 51942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 51950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 51954 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 51958 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 51962 */   // MIs[1] Operand 1
     /* 51962 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 51967 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51972 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 51977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51981 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 51985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 51987 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 51987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 51990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 51994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 51999 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52003 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52014 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52019 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52021 */   GIR_RootConstrainSelectedInstOperands,
     /* 52022 */   // GIR_Coverage, 1690,
     /* 52022 */   GIR_EraseRootFromParent_Done,
     /* 52023 */ // Label 1322: @52023
     /* 52023 */ GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(52121), // Rule ID 1691 //
     /* 52028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52044 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52056 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52060 */   // MIs[1] Operand 1
     /* 52060 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 52065 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52070 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52085 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 52092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52112 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52117 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52119 */   GIR_RootConstrainSelectedInstOperands,
     /* 52120 */   // GIR_Coverage, 1691,
     /* 52120 */   GIR_EraseRootFromParent_Done,
     /* 52121 */ // Label 1323: @52121
     /* 52121 */ GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(52219), // Rule ID 1694 //
     /* 52126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52150 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52154 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52158 */   // MIs[1] Operand 1
     /* 52158 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 52163 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52168 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52183 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 52190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52195 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52199 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52210 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52215 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52217 */   GIR_RootConstrainSelectedInstOperands,
     /* 52218 */   // GIR_Coverage, 1694,
     /* 52218 */   GIR_EraseRootFromParent_Done,
     /* 52219 */ // Label 1324: @52219
     /* 52219 */ GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(52317), // Rule ID 1695 //
     /* 52224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52248 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52252 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52256 */   // MIs[1] Operand 1
     /* 52256 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 52261 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52266 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52275 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52281 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 52288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52293 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52297 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52308 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52313 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52315 */   GIR_RootConstrainSelectedInstOperands,
     /* 52316 */   // GIR_Coverage, 1695,
     /* 52316 */   GIR_EraseRootFromParent_Done,
     /* 52317 */ // Label 1325: @52317
     /* 52317 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(52415), // Rule ID 1698 //
     /* 52322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52346 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52350 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52354 */   // MIs[1] Operand 1
     /* 52354 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 52359 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52364 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52373 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52377 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52379 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 52386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52391 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52395 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52406 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52411 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52413 */   GIR_RootConstrainSelectedInstOperands,
     /* 52414 */   // GIR_Coverage, 1698,
     /* 52414 */   GIR_EraseRootFromParent_Done,
     /* 52415 */ // Label 1326: @52415
     /* 52415 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(52513), // Rule ID 1700 //
     /* 52420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52429 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52444 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 52448 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 52452 */   // MIs[1] Operand 1
     /* 52452 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 52457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52462 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 52467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52477 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 52484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52489 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52493 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 52502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52504 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52506 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52509 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52511 */   GIR_RootConstrainSelectedInstOperands,
     /* 52512 */   // GIR_Coverage, 1700,
     /* 52512 */   GIR_EraseRootFromParent_Done,
     /* 52513 */ // Label 1327: @52513
     /* 52513 */ GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(52611), // Rule ID 1703 //
     /* 52518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52542 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52546 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52550 */   // MIs[1] Operand 1
     /* 52550 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 52555 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52560 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52575 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52575 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52578 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 52582 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52587 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52591 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52595 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52602 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52607 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52609 */   GIR_RootConstrainSelectedInstOperands,
     /* 52610 */   // GIR_Coverage, 1703,
     /* 52610 */   GIR_EraseRootFromParent_Done,
     /* 52611 */ // Label 1328: @52611
     /* 52611 */ GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(52709), // Rule ID 1704 //
     /* 52616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52625 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52632 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52636 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52640 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52644 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52648 */   // MIs[1] Operand 1
     /* 52648 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 52653 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52658 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52667 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52671 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52673 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52673 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52676 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 52680 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52685 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52689 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52700 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52705 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52707 */   GIR_RootConstrainSelectedInstOperands,
     /* 52708 */   // GIR_Coverage, 1704,
     /* 52708 */   GIR_EraseRootFromParent_Done,
     /* 52709 */ // Label 1329: @52709
     /* 52709 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(52807), // Rule ID 1707 //
     /* 52714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52738 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52742 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52746 */   // MIs[1] Operand 1
     /* 52746 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 52751 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52756 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52765 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52769 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52771 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52771 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52774 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 52778 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52783 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52787 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52798 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52800 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52803 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52805 */   GIR_RootConstrainSelectedInstOperands,
     /* 52806 */   // GIR_Coverage, 1707,
     /* 52806 */   GIR_EraseRootFromParent_Done,
     /* 52807 */ // Label 1330: @52807
     /* 52807 */ GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(52905), // Rule ID 1708 //
     /* 52812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52818 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52821 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52828 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52832 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52840 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52844 */   // MIs[1] Operand 1
     /* 52844 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 52849 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52863 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52869 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 52869 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 52872 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 52876 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52881 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52885 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S),
     /* 52894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52896 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52898 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52901 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 52903 */   GIR_RootConstrainSelectedInstOperands,
     /* 52904 */   // GIR_Coverage, 1708,
     /* 52904 */   GIR_EraseRootFromParent_Done,
     /* 52905 */ // Label 1331: @52905
     /* 52905 */ GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(53003), // Rule ID 1711 //
     /* 52910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 52913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 52916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 52919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 52922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 52930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 52934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 52938 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 52942 */   // MIs[1] Operand 1
     /* 52942 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 52947 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52952 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 52957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 52965 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 52967 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 52967 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 52970 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 52974 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 52979 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 52983 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 52987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 52989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_S),
     /* 52992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 52994 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 52996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 52999 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53001 */   GIR_RootConstrainSelectedInstOperands,
     /* 53002 */   // GIR_Coverage, 1711,
     /* 53002 */   GIR_EraseRootFromParent_Done,
     /* 53003 */ // Label 1332: @53003
     /* 53003 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(53101), // Rule ID 1713 //
     /* 53008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 53011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53032 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 53036 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 53040 */   // MIs[1] Operand 1
     /* 53040 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 53045 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 53050 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 53055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53059 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 53063 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53065 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 53065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 53068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 53072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53077 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53081 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 53090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 53092 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53097 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53099 */   GIR_RootConstrainSelectedInstOperands,
     /* 53100 */   // GIR_Coverage, 1713,
     /* 53100 */   GIR_EraseRootFromParent_Done,
     /* 53101 */ // Label 1333: @53101
     /* 53101 */ GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(53182), // Rule ID 1868 //
     /* 53106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53115 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53122 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53126 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53130 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53134 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53138 */   // MIs[1] Operand 1
     /* 53138 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 53143 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53148 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53157 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53161 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53163 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETGE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b)
     /* 53163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSlt),
     /* 53166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53168 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53170 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53172 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53176 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53180 */   GIR_RootConstrainSelectedInstOperands,
     /* 53181 */   // GIR_Coverage, 1868,
     /* 53181 */   GIR_EraseRootFromParent_Done,
     /* 53182 */ // Label 1334: @53182
     /* 53182 */ GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(53263), // Rule ID 1869 //
     /* 53187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53196 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53211 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53215 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53219 */   // MIs[1] Operand 1
     /* 53219 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 53224 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53229 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53238 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53242 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53244 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETGT:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZSlt),
     /* 53247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53249 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53251 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53253 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53257 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53261 */   GIR_RootConstrainSelectedInstOperands,
     /* 53262 */   // GIR_Coverage, 1869,
     /* 53262 */   GIR_EraseRootFromParent_Done,
     /* 53263 */ // Label 1335: @53263
     /* 53263 */ GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(53344), // Rule ID 1870 //
     /* 53268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53277 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53284 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53288 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53292 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53296 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53300 */   // MIs[1] Operand 1
     /* 53300 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 53305 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53310 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53323 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53325 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETUGE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b)
     /* 53325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSltu),
     /* 53328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53330 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53332 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53334 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53338 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53342 */   GIR_RootConstrainSelectedInstOperands,
     /* 53343 */   // GIR_Coverage, 1870,
     /* 53343 */   GIR_EraseRootFromParent_Done,
     /* 53344 */ // Label 1336: @53344
     /* 53344 */ GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(53425), // Rule ID 1871 //
     /* 53349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53358 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53365 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53369 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53373 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53377 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53381 */   // MIs[1] Operand 1
     /* 53381 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 53386 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53391 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53400 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53404 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53406 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETUGT:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZSltu),
     /* 53409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53411 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53413 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53415 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53419 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53423 */   GIR_RootConstrainSelectedInstOperands,
     /* 53424 */   // GIR_Coverage, 1871,
     /* 53424 */   GIR_EraseRootFromParent_Done,
     /* 53425 */ // Label 1337: @53425
     /* 53425 */ GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(53506), // Rule ID 1873 //
     /* 53430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53439 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53446 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53450 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53454 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53458 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53462 */   // MIs[1] Operand 1
     /* 53462 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 53467 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53472 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53481 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53487 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETLE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSlt:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSlt),
     /* 53490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53492 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53494 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53496 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53500 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53504 */   GIR_RootConstrainSelectedInstOperands,
     /* 53505 */   // GIR_Coverage, 1873,
     /* 53505 */   GIR_EraseRootFromParent_Done,
     /* 53506 */ // Label 1338: @53506
     /* 53506 */ GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(53587), // Rule ID 1874 //
     /* 53511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53520 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53527 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53535 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53539 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53543 */   // MIs[1] Operand 1
     /* 53543 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 53548 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53553 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53562 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53566 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53568 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETULE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZSltu:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZSltu),
     /* 53571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53573 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53575 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53577 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53581 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53585 */   GIR_RootConstrainSelectedInstOperands,
     /* 53586 */   // GIR_Coverage, 1874,
     /* 53586 */   GIR_EraseRootFromParent_Done,
     /* 53587 */ // Label 1339: @53587
     /* 53587 */ GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(53668), // Rule ID 1875 //
     /* 53592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53608 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53612 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53616 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53620 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53624 */   // MIs[1] Operand 1
     /* 53624 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 53629 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53634 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53643 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53647 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53649 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETEQ:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBteqZCmp:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53649 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBteqZCmp),
     /* 53652 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53654 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53656 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53658 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53662 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53666 */   GIR_RootConstrainSelectedInstOperands,
     /* 53667 */   // GIR_Coverage, 1875,
     /* 53667 */   GIR_EraseRootFromParent_Done,
     /* 53668 */ // Label 1340: @53668
     /* 53668 */ GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(53749), // Rule ID 1878 //
     /* 53673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 53676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53697 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53701 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53705 */   // MIs[1] Operand 1
     /* 53705 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 53710 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53715 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53724 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 53728 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53730 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$b, SETNE:{ *:[Other] }), CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelTBtneZCmp:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$b, CPU16Regs:{ *:[i32] }:$a)
     /* 53730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelTBtneZCmp),
     /* 53733 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 53735 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 53737 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 53739 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // b
     /* 53743 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // a
     /* 53747 */   GIR_RootConstrainSelectedInstOperands,
     /* 53748 */   // GIR_Coverage, 1878,
     /* 53748 */   GIR_EraseRootFromParent_Done,
     /* 53749 */ // Label 1341: @53749
     /* 53749 */ GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(53847), // Rule ID 2216 //
     /* 53754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53778 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53782 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53786 */   // MIs[1] Operand 1
     /* 53786 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 53791 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53796 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53801 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53805 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53809 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53811 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 53811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 53814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 53818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53823 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53827 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 53836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 53838 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53843 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53845 */   GIR_RootConstrainSelectedInstOperands,
     /* 53846 */   // GIR_Coverage, 2216,
     /* 53846 */   GIR_EraseRootFromParent_Done,
     /* 53847 */ // Label 1342: @53847
     /* 53847 */ GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(53945), // Rule ID 2217 //
     /* 53852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53855 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53858 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53861 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53876 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53880 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53884 */   // MIs[1] Operand 1
     /* 53884 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 53889 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53894 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53903 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53907 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 53909 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 53909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 53912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 53916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 53921 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 53925 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 53929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 53931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 53934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 53936 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 53938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 53941 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 53943 */   GIR_RootConstrainSelectedInstOperands,
     /* 53944 */   // GIR_Coverage, 2217,
     /* 53944 */   GIR_EraseRootFromParent_Done,
     /* 53945 */ // Label 1343: @53945
     /* 53945 */ GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(54043), // Rule ID 2220 //
     /* 53950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 53953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 53956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 53959 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 53962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53966 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 53970 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 53974 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 53978 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 53982 */   // MIs[1] Operand 1
     /* 53982 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 53987 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 53997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54005 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54007 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54023 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54027 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54034 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54036 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54039 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54041 */   GIR_RootConstrainSelectedInstOperands,
     /* 54042 */   // GIR_Coverage, 2220,
     /* 54042 */   GIR_EraseRootFromParent_Done,
     /* 54043 */ // Label 1344: @54043
     /* 54043 */ GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(54141), // Rule ID 2221 //
     /* 54048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54072 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54076 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54080 */   // MIs[1] Operand 1
     /* 54080 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 54085 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54090 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54103 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54105 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54105 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54108 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54112 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54117 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54132 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54134 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54137 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54139 */   GIR_RootConstrainSelectedInstOperands,
     /* 54140 */   // GIR_Coverage, 2221,
     /* 54140 */   GIR_EraseRootFromParent_Done,
     /* 54141 */ // Label 1345: @54141
     /* 54141 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(54239), // Rule ID 2224 //
     /* 54146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54155 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54162 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54166 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54170 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54174 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54178 */   // MIs[1] Operand 1
     /* 54178 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 54183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54188 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54203 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54219 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54223 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54228 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54230 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54232 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54235 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54237 */   GIR_RootConstrainSelectedInstOperands,
     /* 54238 */   // GIR_Coverage, 2224,
     /* 54238 */   GIR_EraseRootFromParent_Done,
     /* 54239 */ // Label 1346: @54239
     /* 54239 */ GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(54337), // Rule ID 2227 //
     /* 54244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 54247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54253 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54260 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54264 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54268 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54272 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54276 */   // MIs[1] Operand 1
     /* 54276 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 54281 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54295 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54301 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54313 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54317 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54321 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 54326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54328 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54333 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54335 */   GIR_RootConstrainSelectedInstOperands,
     /* 54336 */   // GIR_Coverage, 2227,
     /* 54336 */   GIR_EraseRootFromParent_Done,
     /* 54337 */ // Label 1347: @54337
     /* 54337 */ GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(54435), // Rule ID 2230 //
     /* 54342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54358 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54366 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54370 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54374 */   // MIs[1] Operand 1
     /* 54374 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 54379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54384 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54397 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54399 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54411 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54426 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54428 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54431 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54433 */   GIR_RootConstrainSelectedInstOperands,
     /* 54434 */   // GIR_Coverage, 2230,
     /* 54434 */   GIR_EraseRootFromParent_Done,
     /* 54435 */ // Label 1348: @54435
     /* 54435 */ GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(54533), // Rule ID 2231 //
     /* 54440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54464 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54468 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54472 */   // MIs[1] Operand 1
     /* 54472 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 54477 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54482 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54495 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54497 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54524 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54529 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54531 */   GIR_RootConstrainSelectedInstOperands,
     /* 54532 */   // GIR_Coverage, 2231,
     /* 54532 */   GIR_EraseRootFromParent_Done,
     /* 54533 */ // Label 1349: @54533
     /* 54533 */ GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(54631), // Rule ID 2234 //
     /* 54538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54554 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54558 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54562 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54566 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54570 */   // MIs[1] Operand 1
     /* 54570 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 54575 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54580 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54589 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54595 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54607 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54611 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54622 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54624 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54627 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54629 */   GIR_RootConstrainSelectedInstOperands,
     /* 54630 */   // GIR_Coverage, 2234,
     /* 54630 */   GIR_EraseRootFromParent_Done,
     /* 54631 */ // Label 1350: @54631
     /* 54631 */ GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(54729), // Rule ID 2235 //
     /* 54636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54660 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54664 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54668 */   // MIs[1] Operand 1
     /* 54668 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 54673 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54678 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54683 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54687 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54693 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR32:{ *:[i32] }:$F)
     /* 54693 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54696 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 54700 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54705 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54709 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54720 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54725 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54727 */   GIR_RootConstrainSelectedInstOperands,
     /* 54728 */   // GIR_Coverage, 2235,
     /* 54728 */   GIR_EraseRootFromParent_Done,
     /* 54729 */ // Label 1351: @54729
     /* 54729 */ GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(54827), // Rule ID 2238 //
     /* 54734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54758 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54762 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54766 */   // MIs[1] Operand 1
     /* 54766 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 54771 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54776 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54781 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54785 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54789 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54791 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVZ_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54803 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54807 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_MM),
     /* 54816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54818 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54820 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54823 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54825 */   GIR_RootConstrainSelectedInstOperands,
     /* 54826 */   // GIR_Coverage, 2238,
     /* 54826 */   GIR_EraseRootFromParent_Done,
     /* 54827 */ // Label 1352: @54827
     /* 54827 */ GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(54925), // Rule ID 2241 //
     /* 54832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54856 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54860 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54864 */   // MIs[1] Operand 1
     /* 54864 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 54869 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54874 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54887 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54889 */   // (select:{ *:[i32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR32:{ *:[i32] }:$F)
     /* 54889 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54892 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 54896 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54901 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 54905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 54909 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 54911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 54914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 54916 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 54918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 54921 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 54923 */   GIR_RootConstrainSelectedInstOperands,
     /* 54924 */   // GIR_Coverage, 2241,
     /* 54924 */   GIR_EraseRootFromParent_Done,
     /* 54925 */ // Label 1353: @54925
     /* 54925 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(55023), // Rule ID 2264 //
     /* 54930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 54933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 54936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 54939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 54942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54946 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 54950 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 54954 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 54958 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 54962 */   // MIs[1] Operand 1
     /* 54962 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 54967 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54972 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 54977 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54981 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 54985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 54987 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 54987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 54990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 54994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 54999 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55003 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55007 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55014 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55016 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55019 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55021 */   GIR_RootConstrainSelectedInstOperands,
     /* 55022 */   // GIR_Coverage, 2264,
     /* 55022 */   GIR_EraseRootFromParent_Done,
     /* 55023 */ // Label 1354: @55023
     /* 55023 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(55121), // Rule ID 2265 //
     /* 55028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55044 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55048 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55056 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55060 */   // MIs[1] Operand 1
     /* 55060 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 55065 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55070 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55085 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 55092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55097 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55112 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55117 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55119 */   GIR_RootConstrainSelectedInstOperands,
     /* 55120 */   // GIR_Coverage, 2265,
     /* 55120 */   GIR_EraseRootFromParent_Done,
     /* 55121 */ // Label 1355: @55121
     /* 55121 */ GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(55219), // Rule ID 2268 //
     /* 55126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55150 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55154 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55158 */   // MIs[1] Operand 1
     /* 55158 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 55163 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55168 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55181 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55183 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 55183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 55190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55195 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55199 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55210 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55215 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55217 */   GIR_RootConstrainSelectedInstOperands,
     /* 55218 */   // GIR_Coverage, 2268,
     /* 55218 */   GIR_EraseRootFromParent_Done,
     /* 55219 */ // Label 1356: @55219
     /* 55219 */ GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(55317), // Rule ID 2269 //
     /* 55224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55240 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55244 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55248 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55252 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55256 */   // MIs[1] Operand 1
     /* 55256 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 55261 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55266 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55275 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55279 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55281 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR32:{ *:[f32] }:$F)
     /* 55281 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55284 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 55288 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55293 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55297 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55308 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55313 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55315 */   GIR_RootConstrainSelectedInstOperands,
     /* 55316 */   // GIR_Coverage, 2269,
     /* 55316 */   GIR_EraseRootFromParent_Done,
     /* 55317 */ // Label 1357: @55317
     /* 55317 */ GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(55415), // Rule ID 2272 //
     /* 55322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55346 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55350 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55354 */   // MIs[1] Operand 1
     /* 55354 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 55359 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55364 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55373 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55377 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55379 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVZ_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55379 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55382 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 55386 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55391 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55395 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_S_MM),
     /* 55404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55406 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55408 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55411 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55413 */   GIR_RootConstrainSelectedInstOperands,
     /* 55414 */   // GIR_Coverage, 2272,
     /* 55414 */   GIR_EraseRootFromParent_Done,
     /* 55415 */ // Label 1358: @55415
     /* 55415 */ GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(55513), // Rule ID 2274 //
     /* 55420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55429 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55436 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 55440 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 55444 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 55448 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 55452 */   // MIs[1] Operand 1
     /* 55452 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 55457 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55462 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55471 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55475 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 55477 */   // (select:{ *:[f32] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR32:{ *:[f32] }:$F)
     /* 55477 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 55480 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 55484 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 55489 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 55493 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 55497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 55499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 55502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55504 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55506 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 55509 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55511 */   GIR_RootConstrainSelectedInstOperands,
     /* 55512 */   // GIR_Coverage, 2274,
     /* 55512 */   GIR_EraseRootFromParent_Done,
     /* 55513 */ // Label 1359: @55513
     /* 55513 */ GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(55553), // Rule ID 295 //
     /* 55518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 55521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55538 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55542 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55546 */   // (select:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$cond, GPR32Opnd:{ *:[i32] }:$T, GPR32Opnd:{ *:[i32] }:$F)  =>  (PseudoSELECT_I:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$cond, GPR32Opnd:{ *:[i32] }:$T, GPR32Opnd:{ *:[i32] }:$F)
     /* 55546 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_I),
     /* 55551 */   GIR_RootConstrainSelectedInstOperands,
     /* 55552 */   // GIR_Coverage, 295,
     /* 55552 */   GIR_Done,
     /* 55553 */ // Label 1360: @55553
     /* 55553 */ GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(55593), // Rule ID 297 //
     /* 55558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 55561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55567 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55578 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55582 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55586 */   // (select:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$cond, FGR32Opnd:{ *:[f32] }:$T, FGR32Opnd:{ *:[f32] }:$F)  =>  (PseudoSELECT_S:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$cond, FGR32Opnd:{ *:[f32] }:$T, FGR32Opnd:{ *:[f32] }:$F)
     /* 55586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_S),
     /* 55591 */   GIR_RootConstrainSelectedInstOperands,
     /* 55592 */   // GIR_Coverage, 297,
     /* 55592 */   GIR_Done,
     /* 55593 */ // Label 1361: @55593
     /* 55593 */ GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(55639), // Rule ID 334 //
     /* 55598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 55601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55607 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 55618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55622 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55626 */   // (select:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)  =>  (SEL_S:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 55626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEL_S),
     /* 55629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55631 */   GIR_RootToRootCopy, /*OpIdx*/1, // fd_in
     /* 55633 */   GIR_RootToRootCopy, /*OpIdx*/3, // fs
     /* 55635 */   GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 55637 */   GIR_RootConstrainSelectedInstOperands,
     /* 55638 */   // GIR_Coverage, 334,
     /* 55638 */   GIR_EraseRootFromParent_Done,
     /* 55639 */ // Label 1362: @55639
     /* 55639 */ GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(55685), // Rule ID 1213 //
     /* 55644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 55647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGRCCRegClassID),
     /* 55664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55668 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55672 */   // (select:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)  =>  (SEL_S_MMR6:{ *:[f32] } FGRCCOpnd:{ *:[i32] }:$fd_in, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 55672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SEL_S_MMR6),
     /* 55675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55677 */   GIR_RootToRootCopy, /*OpIdx*/1, // fd_in
     /* 55679 */   GIR_RootToRootCopy, /*OpIdx*/3, // fs
     /* 55681 */   GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 55683 */   GIR_RootConstrainSelectedInstOperands,
     /* 55684 */   // GIR_Coverage, 1213,
     /* 55684 */   GIR_EraseRootFromParent_Done,
     /* 55685 */ // Label 1363: @55685
     /* 55685 */ GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(55731), // Rule ID 1646 //
     /* 55690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55714 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55718 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I),
     /* 55721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55723 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55725 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55727 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55729 */   GIR_RootConstrainSelectedInstOperands,
     /* 55730 */   // GIR_Coverage, 1646,
     /* 55730 */   GIR_EraseRootFromParent_Done,
     /* 55731 */ // Label 1364: @55731
     /* 55731 */ GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(55777), // Rule ID 1685 //
     /* 55736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 55742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 55756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55764 */   // (select:{ *:[i32] } GPR64:{ *:[i64] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I64_I:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR64:{ *:[i64] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I),
     /* 55767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55769 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55771 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55773 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55775 */   GIR_RootConstrainSelectedInstOperands,
     /* 55776 */   // GIR_Coverage, 1685,
     /* 55776 */   GIR_EraseRootFromParent_Done,
     /* 55777 */ // Label 1365: @55777
     /* 55777 */ GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(55823), // Rule ID 1701 //
     /* 55782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55791 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55806 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55810 */   // (select:{ *:[f32] } GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 55810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S),
     /* 55813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55815 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55817 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55819 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55821 */   GIR_RootConstrainSelectedInstOperands,
     /* 55822 */   // GIR_Coverage, 1701,
     /* 55822 */   GIR_EraseRootFromParent_Done,
     /* 55823 */ // Label 1366: @55823
     /* 55823 */ GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(55869), // Rule ID 1714 //
     /* 55828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 55831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 55834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55837 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 55848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55852 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 55856 */   // (select:{ *:[f32] } GPR64:{ *:[i64] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I64_S:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR64:{ *:[i64] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 55856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_S),
     /* 55859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 55861 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55863 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55865 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55867 */   GIR_RootConstrainSelectedInstOperands,
     /* 55868 */   // GIR_Coverage, 1714,
     /* 55868 */   GIR_EraseRootFromParent_Done,
     /* 55869 */ // Label 1367: @55869
     /* 55869 */ GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(55915), // Rule ID 1880 //
     /* 55874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 55877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55898 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::CPU16RegsRegClassID),
     /* 55902 */   // (select:{ *:[i32] } CPU16Regs:{ *:[i32] }:$a, CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y)  =>  (SelBneZ:{ *:[i32] } CPU16Regs:{ *:[i32] }:$x, CPU16Regs:{ *:[i32] }:$y, CPU16Regs:{ *:[i32] }:$a)
     /* 55902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::SelBneZ),
     /* 55905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_]
     /* 55907 */   GIR_RootToRootCopy, /*OpIdx*/2, // x
     /* 55909 */   GIR_RootToRootCopy, /*OpIdx*/3, // y
     /* 55911 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 55913 */   GIR_RootConstrainSelectedInstOperands,
     /* 55914 */   // GIR_Coverage, 1880,
     /* 55914 */   GIR_EraseRootFromParent_Done,
     /* 55915 */ // Label 1368: @55915
     /* 55915 */ GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(55961), // Rule ID 2228 //
     /* 55920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotMips32r6_NotMips64r6),
     /* 55923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55944 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55948 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 55951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55953 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 55955 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 55957 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 55959 */   GIR_RootConstrainSelectedInstOperands,
     /* 55960 */   // GIR_Coverage, 2228,
     /* 55960 */   GIR_EraseRootFromParent_Done,
     /* 55961 */ // Label 1369: @55961
     /* 55961 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(56007), // Rule ID 2242 //
     /* 55966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 55969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 55972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 55975 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 55978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55986 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55990 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 55994 */   // (select:{ *:[i32] } GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$F)  =>  (MOVN_I_MM:{ *:[i32] } GPR32:{ *:[i32] }:$T, GPR32:{ *:[i32] }:$cond, GPR32:{ *:[i32] }:$F)
     /* 55994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_MM),
     /* 55997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 55999 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56001 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 56003 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56005 */   GIR_RootConstrainSelectedInstOperands,
     /* 56006 */   // GIR_Coverage, 2242,
     /* 56006 */   GIR_EraseRootFromParent_Done,
     /* 56007 */ // Label 1370: @56007
     /* 56007 */ GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(56053), // Rule ID 2275 //
     /* 56012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6),
     /* 56015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56021 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 56040 */   // (select:{ *:[f32] } GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$T, FGR32:{ *:[f32] }:$F)  =>  (MOVN_I_S_MM:{ *:[f32] } FGR32:{ *:[f32] }:$T, GPR32:{ *:[i32] }:$cond, FGR32:{ *:[f32] }:$F)
     /* 56040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_S_MM),
     /* 56043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56045 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56047 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 56049 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56051 */   GIR_RootConstrainSelectedInstOperands,
     /* 56052 */   // GIR_Coverage, 2275,
     /* 56052 */   GIR_EraseRootFromParent_Done,
     /* 56053 */ // Label 1371: @56053
     /* 56053 */ GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(56131), // Rule ID 1783 //
     /* 56058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 56061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56067 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56074 */   // (select:{ *:[i32] } i32:{ *:[i32] }:$cond, i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$f)  =>  (OR:{ *:[i32] } (SELNEZ:{ *:[i32] } i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$cond), (SELEQZ:{ *:[i32] } i32:{ *:[i32] }:$f, i32:{ *:[i32] }:$cond))
     /* 56074 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 56077 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ),
     /* 56081 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56086 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 56090 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 56099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ),
     /* 56103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56108 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 56112 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR),
     /* 56121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56123 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 56129 */   GIR_RootConstrainSelectedInstOperands,
     /* 56130 */   // GIR_Coverage, 1783,
     /* 56130 */   GIR_EraseRootFromParent_Done,
     /* 56131 */ // Label 1372: @56131
     /* 56131 */ GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(56209), // Rule ID 2292 //
     /* 56136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 56139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 56145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 56148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56152 */   // (select:{ *:[i32] } i32:{ *:[i32] }:$cond, i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$f)  =>  (OR_MM:{ *:[i32] } (SELNEZ_MMR6:{ *:[i32] } i32:{ *:[i32] }:$t, i32:{ *:[i32] }:$cond), (SELEQZ_MMR6:{ *:[i32] } i32:{ *:[i32] }:$f, i32:{ *:[i32] }:$cond))
     /* 56152 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 56155 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ_MMR6),
     /* 56159 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56164 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 56168 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 56174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 56177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ_MMR6),
     /* 56181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 56186 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 56190 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 56194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 56196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR_MM),
     /* 56199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 56204 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 56207 */   GIR_RootConstrainSelectedInstOperands,
     /* 56208 */   // GIR_Coverage, 2292,
     /* 56208 */   GIR_EraseRootFromParent_Done,
     /* 56209 */ // Label 1373: @56209
     /* 56209 */ GIM_Reject,
     /* 56210 */ // Label 1288: @56210
     /* 56210 */ GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(56286), // Rule ID 1673 //
     /* 56215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56231 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56235 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56239 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56243 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56247 */   // MIs[1] Operand 1
     /* 56247 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56252 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56257 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56265 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56269 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56271 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 56274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56276 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56278 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56282 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56284 */   GIR_RootConstrainSelectedInstOperands,
     /* 56285 */   // GIR_Coverage, 1673,
     /* 56285 */   GIR_EraseRootFromParent_Done,
     /* 56286 */ // Label 1374: @56286
     /* 56286 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(56362), // Rule ID 1677 //
     /* 56291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56307 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56311 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56315 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56319 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56323 */   // MIs[1] Operand 1
     /* 56323 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56333 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56341 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56347 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I64),
     /* 56350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56352 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56354 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56358 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56360 */   GIR_RootConstrainSelectedInstOperands,
     /* 56361 */   // GIR_Coverage, 1677,
     /* 56361 */   GIR_EraseRootFromParent_Done,
     /* 56362 */ // Label 1375: @56362
     /* 56362 */ GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(56438), // Rule ID 1683 //
     /* 56367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56376 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56383 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56391 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56395 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56399 */   // MIs[1] Operand 1
     /* 56399 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56404 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56409 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56421 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56423 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56423 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 56426 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56428 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56430 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56434 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56436 */   GIR_RootConstrainSelectedInstOperands,
     /* 56437 */   // GIR_Coverage, 1683,
     /* 56437 */   GIR_EraseRootFromParent_Done,
     /* 56438 */ // Label 1376: @56438
     /* 56438 */ GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(56514), // Rule ID 1689 //
     /* 56443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56467 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56471 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56475 */   // MIs[1] Operand 1
     /* 56475 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56480 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56485 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56489 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56493 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56499 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$F)
     /* 56499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 56502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 56504 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56506 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56510 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56512 */   GIR_RootConstrainSelectedInstOperands,
     /* 56513 */   // GIR_Coverage, 1689,
     /* 56513 */   GIR_EraseRootFromParent_Done,
     /* 56514 */ // Label 1377: @56514
     /* 56514 */ GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(56590), // Rule ID 1725 //
     /* 56519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56543 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56547 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56551 */   // MIs[1] Operand 1
     /* 56551 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56556 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56561 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56573 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56575 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 56575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 56578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56580 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56582 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56586 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56588 */   GIR_RootConstrainSelectedInstOperands,
     /* 56589 */   // GIR_Coverage, 1725,
     /* 56589 */   GIR_EraseRootFromParent_Done,
     /* 56590 */ // Label 1378: @56590
     /* 56590 */ GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(56666), // Rule ID 1728 //
     /* 56595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56604 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56619 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56623 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56627 */   // MIs[1] Operand 1
     /* 56627 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56632 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56637 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56641 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56645 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56651 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 56651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 56654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56656 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56658 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56662 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56664 */   GIR_RootConstrainSelectedInstOperands,
     /* 56665 */   // GIR_Coverage, 1728,
     /* 56665 */   GIR_EraseRootFromParent_Done,
     /* 56666 */ // Label 1379: @56666
     /* 56666 */ GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(56742), // Rule ID 1746 //
     /* 56671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56687 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56691 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56695 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56699 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56703 */   // MIs[1] Operand 1
     /* 56703 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56708 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56713 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56725 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56727 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 56730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56732 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56734 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56738 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56740 */   GIR_RootConstrainSelectedInstOperands,
     /* 56741 */   // GIR_Coverage, 1746,
     /* 56741 */   GIR_EraseRootFromParent_Done,
     /* 56742 */ // Label 1380: @56742
     /* 56742 */ GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(56818), // Rule ID 1748 //
     /* 56747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56756 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56763 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56767 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56775 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56779 */   // MIs[1] Operand 1
     /* 56779 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 56784 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56789 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56797 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56803 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_D64),
     /* 56806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56808 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56810 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56814 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56816 */   GIR_RootConstrainSelectedInstOperands,
     /* 56817 */   // GIR_Coverage, 1748,
     /* 56817 */   GIR_EraseRootFromParent_Done,
     /* 56818 */ // Label 1381: @56818
     /* 56818 */ GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(56894), // Rule ID 1751 //
     /* 56823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56847 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 56851 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 56855 */   // MIs[1] Operand 1
     /* 56855 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56860 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 56865 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56869 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56873 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56877 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56879 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 56882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56884 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56886 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56890 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56892 */   GIR_RootConstrainSelectedInstOperands,
     /* 56893 */   // GIR_Coverage, 1751,
     /* 56893 */   GIR_EraseRootFromParent_Done,
     /* 56894 */ // Label 1382: @56894
     /* 56894 */ GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(56970), // Rule ID 1754 //
     /* 56899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 56902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56908 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56923 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 56927 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 56931 */   // MIs[1] Operand 1
     /* 56931 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 56936 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 56941 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 56945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56949 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 56953 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 56955 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, 0:{ *:[i64] }, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$lhs, FGR64:{ *:[f64] }:$F)
     /* 56955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 56958 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 56960 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 56962 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 56966 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 56968 */   GIR_RootConstrainSelectedInstOperands,
     /* 56969 */   // GIR_Coverage, 1754,
     /* 56969 */   GIR_EraseRootFromParent_Done,
     /* 56970 */ // Label 1383: @56970
     /* 56970 */ GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(57046), // Rule ID 2286 //
     /* 56975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 56978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 56981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 56984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 56987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 56991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 56995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 56999 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57003 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57007 */   // MIs[1] Operand 1
     /* 57007 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 57012 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57017 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 57021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57025 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57031 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 57031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 57034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 57036 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57038 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57042 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57044 */   GIR_RootConstrainSelectedInstOperands,
     /* 57045 */   // GIR_Coverage, 2286,
     /* 57045 */   GIR_EraseRootFromParent_Done,
     /* 57046 */ // Label 1384: @57046
     /* 57046 */ GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(57122), // Rule ID 2289 //
     /* 57051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 57054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57067 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57071 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57079 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57083 */   // MIs[1] Operand 1
     /* 57083 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 57088 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57093 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 0,
     /* 57097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57101 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 57105 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57107 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, 0:{ *:[i32] }, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$lhs, AFGR64:{ *:[f64] }:$F)
     /* 57107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 57110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 57112 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57114 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57118 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57120 */   GIR_RootConstrainSelectedInstOperands,
     /* 57121 */   // GIR_Coverage, 2289,
     /* 57121 */   GIR_EraseRootFromParent_Done,
     /* 57122 */ // Label 1385: @57122
     /* 57122 */ GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(57220), // Rule ID 1648 //
     /* 57127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57151 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57155 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57159 */   // MIs[1] Operand 1
     /* 57159 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 57164 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57169 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57178 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57182 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57184 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 57191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57196 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57200 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57204 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57211 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57216 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57218 */   GIR_RootConstrainSelectedInstOperands,
     /* 57219 */   // GIR_Coverage, 1648,
     /* 57219 */   GIR_EraseRootFromParent_Done,
     /* 57220 */ // Label 1386: @57220
     /* 57220 */ GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(57318), // Rule ID 1649 //
     /* 57225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57249 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57253 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57257 */   // MIs[1] Operand 1
     /* 57257 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 57262 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57267 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57280 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57282 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 57289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57294 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57298 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57309 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57314 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57316 */   GIR_RootConstrainSelectedInstOperands,
     /* 57317 */   // GIR_Coverage, 1649,
     /* 57317 */   GIR_EraseRootFromParent_Done,
     /* 57318 */ // Label 1387: @57318
     /* 57318 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(57416), // Rule ID 1652 //
     /* 57323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57339 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57343 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57347 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57351 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57355 */   // MIs[1] Operand 1
     /* 57355 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 57360 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57365 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57370 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57374 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57378 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57380 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 57387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57392 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57396 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57407 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57412 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57414 */   GIR_RootConstrainSelectedInstOperands,
     /* 57415 */   // GIR_Coverage, 1652,
     /* 57415 */   GIR_EraseRootFromParent_Done,
     /* 57416 */ // Label 1388: @57416
     /* 57416 */ GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(57514), // Rule ID 1653 //
     /* 57421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57430 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57437 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57441 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57445 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57449 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57453 */   // MIs[1] Operand 1
     /* 57453 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 57458 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57463 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57476 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57478 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 57485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57490 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57494 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57505 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57510 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57512 */   GIR_RootConstrainSelectedInstOperands,
     /* 57513 */   // GIR_Coverage, 1653,
     /* 57513 */   GIR_EraseRootFromParent_Done,
     /* 57514 */ // Label 1389: @57514
     /* 57514 */ GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(57612), // Rule ID 1664 //
     /* 57519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57535 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57539 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57543 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57547 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57551 */   // MIs[1] Operand 1
     /* 57551 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 57556 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57570 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57574 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57576 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 57583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57588 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57592 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57596 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57603 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57608 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57610 */   GIR_RootConstrainSelectedInstOperands,
     /* 57611 */   // GIR_Coverage, 1664,
     /* 57611 */   GIR_EraseRootFromParent_Done,
     /* 57612 */ // Label 1390: @57612
     /* 57612 */ GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(57710), // Rule ID 1665 //
     /* 57617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57633 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57637 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57641 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57645 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57649 */   // MIs[1] Operand 1
     /* 57649 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 57654 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57659 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57668 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57672 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57674 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 57681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57686 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57690 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57701 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57706 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57708 */   GIR_RootConstrainSelectedInstOperands,
     /* 57709 */   // GIR_Coverage, 1665,
     /* 57709 */   GIR_EraseRootFromParent_Done,
     /* 57710 */ // Label 1391: @57710
     /* 57710 */ GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(57808), // Rule ID 1668 //
     /* 57715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57724 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57731 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57735 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57739 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57743 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57747 */   // MIs[1] Operand 1
     /* 57747 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 57752 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57757 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57762 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57766 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57770 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57772 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57772 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57775 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 57779 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57784 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57788 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57792 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57794 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57797 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57799 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57804 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57806 */   GIR_RootConstrainSelectedInstOperands,
     /* 57807 */   // GIR_Coverage, 1668,
     /* 57807 */   GIR_EraseRootFromParent_Done,
     /* 57808 */ // Label 1392: @57808
     /* 57808 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(57906), // Rule ID 1669 //
     /* 57813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57822 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57829 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57833 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57837 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 57841 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 57845 */   // MIs[1] Operand 1
     /* 57845 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 57850 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57855 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57864 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57868 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57870 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), GPR64:{ *:[i64] }:$F)
     /* 57870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 57877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57897 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 57902 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 57904 */   GIR_RootConstrainSelectedInstOperands,
     /* 57905 */   // GIR_Coverage, 1669,
     /* 57905 */   GIR_EraseRootFromParent_Done,
     /* 57906 */ // Label 1393: @57906
     /* 57906 */ GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(58004), // Rule ID 1672 //
     /* 57911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 57914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 57917 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 57920 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 57923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57927 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 57931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 57935 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 57939 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 57943 */   // MIs[1] Operand 1
     /* 57943 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 57948 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 57958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 57966 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 57968 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 57968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 57971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 57975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 57980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 57984 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 57988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 57990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_I64),
     /* 57993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 57995 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 57997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58000 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58002 */   GIR_RootConstrainSelectedInstOperands,
     /* 58003 */   // GIR_Coverage, 1672,
     /* 58003 */   GIR_EraseRootFromParent_Done,
     /* 58004 */ // Label 1394: @58004
     /* 58004 */ GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(58102), // Rule ID 1676 //
     /* 58009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58025 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58029 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58033 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 58037 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 58041 */   // MIs[1] Operand 1
     /* 58041 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 58046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58051 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58060 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58064 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58066 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVZ_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 58069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 58073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58078 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58082 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_I64),
     /* 58091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58093 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58098 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58100 */   GIR_RootConstrainSelectedInstOperands,
     /* 58101 */   // GIR_Coverage, 1676,
     /* 58101 */   GIR_EraseRootFromParent_Done,
     /* 58102 */ // Label 1395: @58102
     /* 58102 */ GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(58200), // Rule ID 1681 //
     /* 58107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58123 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58127 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58131 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58135 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58139 */   // MIs[1] Operand 1
     /* 58139 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58144 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58149 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58158 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58162 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58164 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58176 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58180 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 58189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58191 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58196 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58198 */   GIR_RootConstrainSelectedInstOperands,
     /* 58199 */   // GIR_Coverage, 1681,
     /* 58199 */   GIR_EraseRootFromParent_Done,
     /* 58200 */ // Label 1396: @58200
     /* 58200 */ GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(58298), // Rule ID 1687 //
     /* 58205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58229 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 58233 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 58237 */   // MIs[1] Operand 1
     /* 58237 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58242 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58247 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58256 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 58260 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58262 */   // (select:{ *:[i64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), GPR64:{ *:[i64] }:$F)
     /* 58262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 58265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 58269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58278 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 58287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 58289 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58291 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58294 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58296 */   GIR_RootConstrainSelectedInstOperands,
     /* 58297 */   // GIR_Coverage, 1687,
     /* 58297 */   GIR_EraseRootFromParent_Done,
     /* 58298 */ // Label 1397: @58298
     /* 58298 */ GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(58396), // Rule ID 1716 //
     /* 58303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58327 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58331 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58335 */   // MIs[1] Operand 1
     /* 58335 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 58340 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58345 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58360 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58360 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58363 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58367 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58372 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58376 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58387 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58392 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58394 */   GIR_RootConstrainSelectedInstOperands,
     /* 58395 */   // GIR_Coverage, 1716,
     /* 58395 */   GIR_EraseRootFromParent_Done,
     /* 58396 */ // Label 1398: @58396
     /* 58396 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(58494), // Rule ID 1717 //
     /* 58401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58417 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58421 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58429 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58433 */   // MIs[1] Operand 1
     /* 58433 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 58438 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58443 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58452 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58456 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58458 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 58465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58470 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58474 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58485 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58490 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58492 */   GIR_RootConstrainSelectedInstOperands,
     /* 58493 */   // GIR_Coverage, 1717,
     /* 58493 */   GIR_EraseRootFromParent_Done,
     /* 58494 */ // Label 1399: @58494
     /* 58494 */ GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(58592), // Rule ID 1720 //
     /* 58499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58508 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58523 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58527 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58531 */   // MIs[1] Operand 1
     /* 58531 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 58536 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58541 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58546 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58550 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58554 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58556 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 58556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58568 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58572 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58576 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58583 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58588 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58590 */   GIR_RootConstrainSelectedInstOperands,
     /* 58591 */   // GIR_Coverage, 1720,
     /* 58591 */   GIR_EraseRootFromParent_Done,
     /* 58592 */ // Label 1400: @58592
     /* 58592 */ GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(58690), // Rule ID 1721 //
     /* 58597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58613 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58617 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58621 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58625 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58629 */   // MIs[1] Operand 1
     /* 58629 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 58634 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58639 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58648 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58654 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 58654 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58657 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 58661 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58666 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58670 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58681 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58683 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58686 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58688 */   GIR_RootConstrainSelectedInstOperands,
     /* 58689 */   // GIR_Coverage, 1721,
     /* 58689 */   GIR_EraseRootFromParent_Done,
     /* 58690 */ // Label 1401: @58690
     /* 58690 */ GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(58788), // Rule ID 1724 //
     /* 58695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58711 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58715 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58719 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58723 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58727 */   // MIs[1] Operand 1
     /* 58727 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 58732 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58737 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58746 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58750 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58752 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58764 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58768 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58772 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32),
     /* 58777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58779 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58784 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58786 */   GIR_RootConstrainSelectedInstOperands,
     /* 58787 */   // GIR_Coverage, 1724,
     /* 58787 */   GIR_EraseRootFromParent_Done,
     /* 58788 */ // Label 1402: @58788
     /* 58788 */ GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(58886), // Rule ID 1726 //
     /* 58793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58817 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58821 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58825 */   // MIs[1] Operand 1
     /* 58825 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 58830 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58835 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 58848 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58850 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 58850 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58853 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 58857 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58862 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58866 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58870 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 58875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58877 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58879 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58882 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58884 */   GIR_RootConstrainSelectedInstOperands,
     /* 58885 */   // GIR_Coverage, 1726,
     /* 58885 */   GIR_EraseRootFromParent_Done,
     /* 58886 */ // Label 1403: @58886
     /* 58886 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(58984), // Rule ID 1729 //
     /* 58891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58900 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 58903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58907 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 58911 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 58915 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 58919 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 58923 */   // MIs[1] Operand 1
     /* 58923 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 58928 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58933 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 58938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58942 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 58946 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 58948 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 58948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 58951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 58955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 58960 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 58964 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 58968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 58970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 58973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 58975 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 58977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 58980 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 58982 */   GIR_RootConstrainSelectedInstOperands,
     /* 58983 */   // GIR_Coverage, 1729,
     /* 58983 */   GIR_EraseRootFromParent_Done,
     /* 58984 */ // Label 1404: @58984
     /* 58984 */ GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(59082), // Rule ID 1730 //
     /* 58989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 58992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 58995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 58998 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59005 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59009 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59013 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59017 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59021 */   // MIs[1] Operand 1
     /* 59021 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 59026 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59031 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59044 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59046 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 59053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59062 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59073 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59078 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59080 */   GIR_RootConstrainSelectedInstOperands,
     /* 59081 */   // GIR_Coverage, 1730,
     /* 59081 */   GIR_EraseRootFromParent_Done,
     /* 59082 */ // Label 1405: @59082
     /* 59082 */ GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(59180), // Rule ID 1733 //
     /* 59087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59115 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59119 */   // MIs[1] Operand 1
     /* 59119 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 59124 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59129 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59138 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59142 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59144 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT),
     /* 59151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59156 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59160 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59164 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59171 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59176 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59178 */   GIR_RootConstrainSelectedInstOperands,
     /* 59179 */   // GIR_Coverage, 1733,
     /* 59179 */   GIR_EraseRootFromParent_Done,
     /* 59180 */ // Label 1406: @59180
     /* 59180 */ GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(59278), // Rule ID 1734 //
     /* 59185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59201 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59205 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59209 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59213 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59217 */   // MIs[1] Operand 1
     /* 59217 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 59222 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59227 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59236 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59240 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59242 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu),
     /* 59249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59254 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59258 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59269 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59271 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59274 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59276 */   GIR_RootConstrainSelectedInstOperands,
     /* 59277 */   // GIR_Coverage, 1734,
     /* 59277 */   GIR_EraseRootFromParent_Done,
     /* 59278 */ // Label 1407: @59278
     /* 59278 */ GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(59376), // Rule ID 1737 //
     /* 59283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59292 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59299 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59303 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59307 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59311 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59315 */   // MIs[1] Operand 1
     /* 59315 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 59320 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59325 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59334 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59338 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59340 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59340 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59343 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 59347 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59352 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59356 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59360 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59367 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59372 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59374 */   GIR_RootConstrainSelectedInstOperands,
     /* 59375 */   // GIR_Coverage, 1737,
     /* 59375 */   GIR_EraseRootFromParent_Done,
     /* 59376 */ // Label 1408: @59376
     /* 59376 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(59474), // Rule ID 1738 //
     /* 59381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59397 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59401 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59405 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59409 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59413 */   // MIs[1] Operand 1
     /* 59413 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 59418 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59423 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59436 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59438 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59438 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59441 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 59445 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59450 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59454 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59458 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59465 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59470 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59472 */   GIR_RootConstrainSelectedInstOperands,
     /* 59473 */   // GIR_Coverage, 1738,
     /* 59473 */   GIR_EraseRootFromParent_Done,
     /* 59474 */ // Label 1409: @59474
     /* 59474 */ GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(59572), // Rule ID 1741 //
     /* 59479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59495 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59499 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59503 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59507 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59511 */   // MIs[1] Operand 1
     /* 59511 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 59516 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59521 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59526 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59530 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59536 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLT64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59536 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59539 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT64),
     /* 59543 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59548 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59552 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59556 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59563 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59568 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59570 */   GIR_RootConstrainSelectedInstOperands,
     /* 59571 */   // GIR_Coverage, 1741,
     /* 59571 */   GIR_EraseRootFromParent_Done,
     /* 59572 */ // Label 1410: @59572
     /* 59572 */ GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(59670), // Rule ID 1742 //
     /* 59577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59586 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59593 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59597 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59601 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59605 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59609 */   // MIs[1] Operand 1
     /* 59609 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 59614 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59619 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59628 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59632 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59634 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (SLTu64:{ *:[i32] } GPR64:{ *:[i64] }:$rhs, GPR64:{ *:[i64] }:$lhs), FGR64:{ *:[f64] }:$F)
     /* 59634 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59637 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu64),
     /* 59641 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59646 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59650 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59661 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59666 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59668 */   GIR_RootConstrainSelectedInstOperands,
     /* 59669 */   // GIR_Coverage, 1742,
     /* 59669 */   GIR_EraseRootFromParent_Done,
     /* 59670 */ // Label 1411: @59670
     /* 59670 */ GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(59768), // Rule ID 1745 //
     /* 59675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59699 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59703 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59707 */   // MIs[1] Operand 1
     /* 59707 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 59712 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59717 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59726 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59730 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59732 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 59739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59744 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59748 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D64),
     /* 59757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59759 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59764 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59766 */   GIR_RootConstrainSelectedInstOperands,
     /* 59767 */   // GIR_Coverage, 1745,
     /* 59767 */   GIR_EraseRootFromParent_Done,
     /* 59768 */ // Label 1412: @59768
     /* 59768 */ GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(59866), // Rule ID 1747 //
     /* 59773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59782 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59797 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59801 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 59805 */   // MIs[1] Operand 1
     /* 59805 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 59810 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59815 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 59820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59824 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59828 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59830 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVZ_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 59833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 59837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59842 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59846 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I64_D64),
     /* 59855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59857 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59859 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59862 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59864 */   GIR_RootConstrainSelectedInstOperands,
     /* 59865 */   // GIR_Coverage, 1747,
     /* 59865 */   GIR_EraseRootFromParent_Done,
     /* 59866 */ // Label 1413: @59866
     /* 59866 */ GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(59964), // Rule ID 1749 //
     /* 59871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59880 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59887 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59895 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 59899 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 59903 */   // MIs[1] Operand 1
     /* 59903 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 59908 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59913 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 59918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59926 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 59928 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 59928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 59931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR),
     /* 59935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 59940 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 59944 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 59948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 59950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 59953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 59955 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 59957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 59960 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 59962 */   GIR_RootConstrainSelectedInstOperands,
     /* 59963 */   // GIR_Coverage, 1749,
     /* 59963 */   GIR_EraseRootFromParent_Done,
     /* 59964 */ // Label 1414: @59964
     /* 59964 */ GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(60062), // Rule ID 1752 //
     /* 59969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 59972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 59975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 59978 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 59981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 59985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 59989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 59993 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 59997 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 60001 */   // MIs[1] Operand 1
     /* 60001 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 60006 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60011 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60020 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60026 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }), FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, (XOR64:{ *:[i64] } GPR64:{ *:[i64] }:$lhs, GPR64:{ *:[i64] }:$rhs), FGR64:{ *:[f64] }:$F)
     /* 60026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 60029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR64),
     /* 60033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60038 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60042 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 60051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60053 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60058 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60060 */   GIR_RootConstrainSelectedInstOperands,
     /* 60061 */   // GIR_Coverage, 1752,
     /* 60061 */   GIR_EraseRootFromParent_Done,
     /* 60062 */ // Label 1415: @60062
     /* 60062 */ GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(60160), // Rule ID 2277 //
     /* 60067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60083 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60087 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60091 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60095 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60099 */   // MIs[1] Operand 1
     /* 60099 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 60104 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60109 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60118 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60122 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60124 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60124 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60127 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 60131 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60136 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60140 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60144 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60151 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60156 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60158 */   GIR_RootConstrainSelectedInstOperands,
     /* 60159 */   // GIR_Coverage, 2277,
     /* 60159 */   GIR_EraseRootFromParent_Done,
     /* 60160 */ // Label 1416: @60160
     /* 60160 */ GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(60258), // Rule ID 2278 //
     /* 60165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60174 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60189 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60193 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60197 */   // MIs[1] Operand 1
     /* 60197 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 60202 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60207 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60216 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60220 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60222 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60222 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60225 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 60229 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60234 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60238 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60249 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60254 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60256 */   GIR_RootConstrainSelectedInstOperands,
     /* 60257 */   // GIR_Coverage, 2278,
     /* 60257 */   GIR_EraseRootFromParent_Done,
     /* 60258 */ // Label 1417: @60258
     /* 60258 */ GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(60356), // Rule ID 2281 //
     /* 60263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60279 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60283 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60287 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60291 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60295 */   // MIs[1] Operand 1
     /* 60295 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 60300 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60305 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60320 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLT_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 60320 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60323 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLT_MM),
     /* 60327 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60332 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60336 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60347 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60352 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60354 */   GIR_RootConstrainSelectedInstOperands,
     /* 60355 */   // GIR_Coverage, 2281,
     /* 60355 */   GIR_EraseRootFromParent_Done,
     /* 60356 */ // Label 1418: @60356
     /* 60356 */ GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(60454), // Rule ID 2282 //
     /* 60361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60370 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60377 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60381 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60385 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60389 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60393 */   // MIs[1] Operand 1
     /* 60393 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 60398 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60403 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60412 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60416 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60418 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (SLTu_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rhs, GPR32:{ *:[i32] }:$lhs), AFGR64:{ *:[f64] }:$F)
     /* 60418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SLTu_MM),
     /* 60425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60430 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60434 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60445 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60450 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60452 */   GIR_RootConstrainSelectedInstOperands,
     /* 60453 */   // GIR_Coverage, 2282,
     /* 60453 */   GIR_EraseRootFromParent_Done,
     /* 60454 */ // Label 1419: @60454
     /* 60454 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(60552), // Rule ID 2285 //
     /* 60459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60468 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60483 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60487 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60491 */   // MIs[1] Operand 1
     /* 60491 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 60496 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60501 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60510 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60514 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60516 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVZ_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60516 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60519 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 60523 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60528 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60532 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVZ_I_D32_MM),
     /* 60541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60543 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60548 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60550 */   GIR_RootConstrainSelectedInstOperands,
     /* 60551 */   // GIR_Coverage, 2285,
     /* 60551 */   GIR_EraseRootFromParent_Done,
     /* 60552 */ // Label 1420: @60552
     /* 60552 */ GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(60650), // Rule ID 2287 //
     /* 60557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 60560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60566 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60573 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 60577 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /* 60581 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 60585 */   GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 60589 */   // MIs[1] Operand 1
     /* 60589 */   GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 60594 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60599 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60608 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 60614 */   // (select:{ *:[f64] } (setcc:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }), AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, (XOR_MM:{ *:[i32] } GPR32:{ *:[i32] }:$lhs, GPR32:{ *:[i32] }:$rhs), AFGR64:{ *:[f64] }:$F)
     /* 60614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 60617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::XOR_MM),
     /* 60621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 60626 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // lhs
     /* 60630 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // rhs
     /* 60634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 60636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 60639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60641 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 60646 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60648 */   GIR_RootConstrainSelectedInstOperands,
     /* 60649 */   // GIR_Coverage, 2287,
     /* 60649 */   GIR_EraseRootFromParent_Done,
     /* 60650 */ // Label 1421: @60650
     /* 60650 */ GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(60690), // Rule ID 296 //
     /* 60655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotMips4_32),
     /* 60658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60679 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60683 */   // (select:{ *:[i64] } GPR32Opnd:{ *:[i32] }:$cond, GPR64Opnd:{ *:[i64] }:$T, GPR64Opnd:{ *:[i64] }:$F)  =>  (PseudoSELECT_I64:{ *:[i64] } GPR32Opnd:{ *:[i32] }:$cond, GPR64Opnd:{ *:[i64] }:$T, GPR64Opnd:{ *:[i64] }:$F)
     /* 60683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_I64),
     /* 60688 */   GIR_RootConstrainSelectedInstOperands,
     /* 60689 */   // GIR_Coverage, 296,
     /* 60689 */   GIR_Done,
     /* 60690 */ // Label 1422: @60690
     /* 60690 */ GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(60730), // Rule ID 298 //
     /* 60695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotMips4_32),
     /* 60698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60715 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60719 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60723 */   // (select:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, AFGR64Opnd:{ *:[f64] }:$T, AFGR64Opnd:{ *:[f64] }:$F)  =>  (PseudoSELECT_D32:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, AFGR64Opnd:{ *:[f64] }:$T, AFGR64Opnd:{ *:[f64] }:$F)
     /* 60723 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_D32),
     /* 60728 */   GIR_RootConstrainSelectedInstOperands,
     /* 60729 */   // GIR_Coverage, 298,
     /* 60729 */   GIR_Done,
     /* 60730 */ // Label 1423: @60730
     /* 60730 */ GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(60770), // Rule ID 299 //
     /* 60735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotMips4_32),
     /* 60738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60759 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60763 */   // (select:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, FGR64Opnd:{ *:[f64] }:$T, FGR64Opnd:{ *:[f64] }:$F)  =>  (PseudoSELECT_D64:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$cond, FGR64Opnd:{ *:[f64] }:$T, FGR64Opnd:{ *:[f64] }:$F)
     /* 60763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoSELECT_D64),
     /* 60768 */   GIR_RootConstrainSelectedInstOperands,
     /* 60769 */   // GIR_Coverage, 299,
     /* 60769 */   GIR_Done,
     /* 60770 */ // Label 1424: @60770
     /* 60770 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(60816), // Rule ID 1682 //
     /* 60775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60784 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60803 */   // (select:{ *:[i64] } GPR32:{ *:[i32] }:$cond, GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR32:{ *:[i32] }:$cond, GPR64:{ *:[i64] }:$F)
     /* 60803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_I64),
     /* 60806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 60808 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60810 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60812 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60814 */   GIR_RootConstrainSelectedInstOperands,
     /* 60815 */   // GIR_Coverage, 1682,
     /* 60815 */   GIR_EraseRootFromParent_Done,
     /* 60816 */ // Label 1425: @60816
     /* 60816 */ GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(60862), // Rule ID 1688 //
     /* 60821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 60827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60830 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60845 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60849 */   // (select:{ *:[i64] } GPR64:{ *:[i64] }:$cond, GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$F)  =>  (MOVN_I64_I64:{ *:[i64] } GPR64:{ *:[i64] }:$T, GPR64:{ *:[i64] }:$cond, GPR64:{ *:[i64] }:$F)
     /* 60849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_I64),
     /* 60852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 60854 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60856 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60858 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60860 */   GIR_RootConstrainSelectedInstOperands,
     /* 60861 */   // GIR_Coverage, 1688,
     /* 60861 */   GIR_EraseRootFromParent_Done,
     /* 60862 */ // Label 1426: @60862
     /* 60862 */ GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(60908), // Rule ID 1727 //
     /* 60867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60876 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60891 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 60895 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$F)
     /* 60895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32),
     /* 60898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60900 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60902 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60904 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60906 */   GIR_RootConstrainSelectedInstOperands,
     /* 60907 */   // GIR_Coverage, 1727,
     /* 60907 */   GIR_EraseRootFromParent_Done,
     /* 60908 */ // Label 1427: @60908
     /* 60908 */ GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(60954), // Rule ID 1750 //
     /* 60913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 60919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60922 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 60933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60937 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60941 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, FGR64:{ *:[f64] }:$F)
     /* 60941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D64),
     /* 60944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60946 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60948 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60950 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60952 */   GIR_RootConstrainSelectedInstOperands,
     /* 60953 */   // GIR_Coverage, 1750,
     /* 60953 */   GIR_EraseRootFromParent_Done,
     /* 60954 */ // Label 1428: @60954
     /* 60954 */ GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(61000), // Rule ID 1753 //
     /* 60959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips4_32_HasStdEnc_IsFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 60962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 60965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 60968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 60971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 60979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60983 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 60987 */   // (select:{ *:[f64] } GPR64:{ *:[i64] }:$cond, FGR64:{ *:[f64] }:$T, FGR64:{ *:[f64] }:$F)  =>  (MOVN_I64_D64:{ *:[f64] } FGR64:{ *:[f64] }:$T, GPR64:{ *:[i64] }:$cond, FGR64:{ *:[f64] }:$F)
     /* 60987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I64_D64),
     /* 60990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 60992 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 60994 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 60996 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 60998 */   GIR_RootConstrainSelectedInstOperands,
     /* 60999 */   // GIR_Coverage, 1753,
     /* 60999 */   GIR_EraseRootFromParent_Done,
     /* 61000 */ // Label 1429: @61000
     /* 61000 */ GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(61046), // Rule ID 2288 //
     /* 61005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit_NotMips32r6),
     /* 61008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61014 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61029 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 61033 */   // (select:{ *:[f64] } GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$T, AFGR64:{ *:[f64] }:$F)  =>  (MOVN_I_D32_MM:{ *:[f64] } AFGR64:{ *:[f64] }:$T, GPR32:{ *:[i32] }:$cond, AFGR64:{ *:[f64] }:$F)
     /* 61033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MOVN_I_D32_MM),
     /* 61036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61038 */   GIR_RootToRootCopy, /*OpIdx*/2, // T
     /* 61040 */   GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 61042 */   GIR_RootToRootCopy, /*OpIdx*/3, // F
     /* 61044 */   GIR_RootConstrainSelectedInstOperands,
     /* 61045 */   // GIR_Coverage, 2288,
     /* 61045 */   GIR_EraseRootFromParent_Done,
     /* 61046 */ // Label 1430: @61046
     /* 61046 */ GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(61124), // Rule ID 1794 //
     /* 61051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 61054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61067 */   // (select:{ *:[i64] } i64:{ *:[i64] }:$cond, i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$f)  =>  (OR64:{ *:[i64] } (SELNEZ64:{ *:[i64] } i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$cond), (SELEQZ64:{ *:[i64] } i64:{ *:[i64] }:$f, i64:{ *:[i64] }:$cond))
     /* 61067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 61070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SELEQZ64),
     /* 61074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61079 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 61083 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 61089 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 61092 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ64),
     /* 61096 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 61105 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 61111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /* 61114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 61116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 61119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 61122 */   GIR_RootConstrainSelectedInstOperands,
     /* 61123 */   // GIR_Coverage, 1794,
     /* 61123 */   GIR_EraseRootFromParent_Done,
     /* 61124 */ // Label 1431: @61124
     /* 61124 */ GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(61236), // Rule ID 1805 //
     /* 61129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc),
     /* 61132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 61141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61145 */   // (select:{ *:[i64] } i32:{ *:[i32] }:$cond, i64:{ *:[i64] }:$t, i64:{ *:[i64] }:$f)  =>  (OR64:{ *:[i64] } (SELNEZ64:{ *:[i64] } i64:{ *:[i64] }:$t, (SLL64_32:{ *:[i64] } i32:{ *:[i32] }:$cond)), (SELEQZ64:{ *:[i64] } i64:{ *:[i64] }:$f, (SLL64_32:{ *:[i64] } i32:{ *:[i32] }:$cond)))
     /* 61145 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 61148 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 61152 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61157 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 61163 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 61166 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(Mips::SELEQZ64),
     /* 61170 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61175 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // f
     /* 61179 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 61182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 61184 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 61187 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(Mips::SLL64_32),
     /* 61191 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61196 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // cond
     /* 61200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 61202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 61205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::SELNEZ64),
     /* 61209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 61214 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // t
     /* 61218 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 61221 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 61223 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::OR64),
     /* 61226 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 61228 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 61231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 61234 */   GIR_RootConstrainSelectedInstOperands,
     /* 61235 */   // GIR_Coverage, 1805,
     /* 61235 */   GIR_EraseRootFromParent_Done,
     /* 61236 */ // Label 1432: @61236
     /* 61236 */ GIM_Reject,
     /* 61237 */ // Label 1289: @61237
     /* 61237 */ GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(61310),
     /* 61242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 61245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 61248 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 61251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61259 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61263 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 61267 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(61288), // Rule ID 583 //
     /* 61272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61275 */     // (vselect:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$wt, MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (BSEL_D_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 61275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_D_PSEUDO),
     /* 61278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61280 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61282 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61284 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61286 */     GIR_RootConstrainSelectedInstOperands,
     /* 61287 */     // GIR_Coverage, 583,
     /* 61287 */     GIR_EraseRootFromParent_Done,
     /* 61288 */   // Label 1434: @61288
     /* 61288 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(61309), // Rule ID 585 //
     /* 61293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61296 */     // (vselect:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$wt, MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (BSEL_FD_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 61296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_FD_PSEUDO),
     /* 61299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61301 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61303 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61305 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61307 */     GIR_RootConstrainSelectedInstOperands,
     /* 61308 */     // GIR_Coverage, 585,
     /* 61308 */     GIR_EraseRootFromParent_Done,
     /* 61309 */   // Label 1435: @61309
     /* 61309 */   GIM_Reject,
     /* 61310 */ // Label 1433: @61310
     /* 61310 */ GIM_Reject,
     /* 61311 */ // Label 1290: @61311
     /* 61311 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(61384),
     /* 61316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 61319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 61322 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 61325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61337 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 61341 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(61362), // Rule ID 582 //
     /* 61346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61349 */     // (vselect:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$wt, MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (BSEL_W_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 61349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_W_PSEUDO),
     /* 61352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61354 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61356 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61358 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61360 */     GIR_RootConstrainSelectedInstOperands,
     /* 61361 */     // GIR_Coverage, 582,
     /* 61361 */     GIR_EraseRootFromParent_Done,
     /* 61362 */   // Label 1437: @61362
     /* 61362 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(61383), // Rule ID 584 //
     /* 61367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61370 */     // (vselect:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$wt, MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (BSEL_FW_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 61370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_FW_PSEUDO),
     /* 61373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61375 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61377 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61379 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61381 */     GIR_RootConstrainSelectedInstOperands,
     /* 61382 */     // GIR_Coverage, 584,
     /* 61382 */     GIR_EraseRootFromParent_Done,
     /* 61383 */   // Label 1438: @61383
     /* 61383 */   GIM_Reject,
     /* 61384 */ // Label 1436: @61384
     /* 61384 */ GIM_Reject,
     /* 61385 */ // Label 1291: @61385
     /* 61385 */ GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(61431), // Rule ID 581 //
     /* 61390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 61396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 61399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 61402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61414 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 61418 */   // (vselect:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$wt, MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (BSEL_H_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 61418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_H_PSEUDO),
     /* 61421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61423 */   GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61425 */   GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61427 */   GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61429 */   GIR_RootConstrainSelectedInstOperands,
     /* 61430 */   // GIR_Coverage, 581,
     /* 61430 */   GIR_EraseRootFromParent_Done,
     /* 61431 */ // Label 1439: @61431
     /* 61431 */ GIM_Reject,
     /* 61432 */ // Label 1292: @61432
     /* 61432 */ GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(61526),
     /* 61437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 61440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 61443 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 61446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61458 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 61462 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(61483), // Rule ID 568 //
     /* 61467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61470 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wd_in)  =>  (BMNZ_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BMNZ_V),
     /* 61473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61475 */     GIR_RootToRootCopy, /*OpIdx*/3, // wd_in
     /* 61477 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 61479 */     GIR_RootToRootCopy, /*OpIdx*/1, // wt
     /* 61481 */     GIR_RootConstrainSelectedInstOperands,
     /* 61482 */     // GIR_Coverage, 568,
     /* 61482 */     GIR_EraseRootFromParent_Done,
     /* 61483 */   // Label 1441: @61483
     /* 61483 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(61504), // Rule ID 570 //
     /* 61488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61491 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (BMZ_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BMZ_V),
     /* 61494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61496 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd_in
     /* 61498 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61500 */     GIR_RootToRootCopy, /*OpIdx*/1, // wt
     /* 61502 */     GIR_RootConstrainSelectedInstOperands,
     /* 61503 */     // GIR_Coverage, 570,
     /* 61503 */     GIR_EraseRootFromParent_Done,
     /* 61504 */   // Label 1442: @61504
     /* 61504 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(61525), // Rule ID 580 //
     /* 61509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 61512 */     // (vselect:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$wt, MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (BSEL_V:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 61512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::BSEL_V),
     /* 61515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 61517 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 61519 */     GIR_RootToRootCopy, /*OpIdx*/3, // ws
     /* 61521 */     GIR_RootToRootCopy, /*OpIdx*/2, // wt
     /* 61523 */     GIR_RootConstrainSelectedInstOperands,
     /* 61524 */     // GIR_Coverage, 580,
     /* 61524 */     GIR_EraseRootFromParent_Done,
     /* 61525 */   // Label 1443: @61525
     /* 61525 */   GIM_Reject,
     /* 61526 */ // Label 1440: @61526
     /* 61526 */ GIM_Reject,
     /* 61527 */ // Label 1293: @61527
     /* 61527 */ GIM_Reject,
     /* 61528 */ // Label 44: @61528
     /* 61528 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1446*/ GIMT_Encode4(61636),
     /* 61539 */ /*GILLT_s32*//*Label 1444*/ GIMT_Encode4(61547),
     /* 61543 */ /*GILLT_s64*//*Label 1445*/ GIMT_Encode4(61602),
     /* 61547 */ // Label 1444: @61547
     /* 61547 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(61601),
     /* 61552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61570 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(61585), // Rule ID 331 //
     /* 61575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 61578 */     // (mulhu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUHU:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61578 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUHU),
     /* 61583 */     GIR_RootConstrainSelectedInstOperands,
     /* 61584 */     // GIR_Coverage, 331,
     /* 61584 */     GIR_Done,
     /* 61585 */   // Label 1448: @61585
     /* 61585 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(61600), // Rule ID 1181 //
     /* 61590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 61593 */     // (mulhu:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUHU_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUHU_MMR6),
     /* 61598 */     GIR_RootConstrainSelectedInstOperands,
     /* 61599 */     // GIR_Coverage, 1181,
     /* 61599 */     GIR_Done,
     /* 61600 */   // Label 1449: @61600
     /* 61600 */   GIM_Reject,
     /* 61601 */ // Label 1447: @61601
     /* 61601 */ GIM_Reject,
     /* 61602 */ // Label 1445: @61602
     /* 61602 */ GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(61635), // Rule ID 346 //
     /* 61607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 61610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61628 */   // (mulhu:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUHU:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 61628 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUHU),
     /* 61633 */   GIR_RootConstrainSelectedInstOperands,
     /* 61634 */   // GIR_Coverage, 346,
     /* 61634 */   GIR_Done,
     /* 61635 */ // Label 1450: @61635
     /* 61635 */ GIM_Reject,
     /* 61636 */ // Label 1446: @61636
     /* 61636 */ GIM_Reject,
     /* 61637 */ // Label 45: @61637
     /* 61637 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1453*/ GIMT_Encode4(61745),
     /* 61648 */ /*GILLT_s32*//*Label 1451*/ GIMT_Encode4(61656),
     /* 61652 */ /*GILLT_s64*//*Label 1452*/ GIMT_Encode4(61711),
     /* 61656 */ // Label 1451: @61656
     /* 61656 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(61710),
     /* 61661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61675 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 61679 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(61694), // Rule ID 330 //
     /* 61684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 61687 */     // (mulhs:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUH:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61687 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUH),
     /* 61692 */     GIR_RootConstrainSelectedInstOperands,
     /* 61693 */     // GIR_Coverage, 330,
     /* 61693 */     GIR_Done,
     /* 61694 */   // Label 1455: @61694
     /* 61694 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(61709), // Rule ID 1180 //
     /* 61699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 61702 */     // (mulhs:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)  =>  (MUH_MMR6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, GPR32Opnd:{ *:[i32] }:$rt)
     /* 61702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MUH_MMR6),
     /* 61707 */     GIR_RootConstrainSelectedInstOperands,
     /* 61708 */     // GIR_Coverage, 1180,
     /* 61708 */     GIR_Done,
     /* 61709 */   // Label 1456: @61709
     /* 61709 */   GIM_Reject,
     /* 61710 */ // Label 1454: @61710
     /* 61710 */ GIM_Reject,
     /* 61711 */ // Label 1452: @61711
     /* 61711 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(61744), // Rule ID 345 //
     /* 61716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 61719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 61737 */   // (mulhs:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)  =>  (DMUH:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, GPR64Opnd:{ *:[i64] }:$rt)
     /* 61737 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DMUH),
     /* 61742 */   GIR_RootConstrainSelectedInstOperands,
     /* 61743 */   // GIR_Coverage, 345,
     /* 61743 */   GIR_Done,
     /* 61744 */ // Label 1457: @61744
     /* 61744 */ GIM_Reject,
     /* 61745 */ // Label 1453: @61745
     /* 61745 */ GIM_Reject,
     /* 61746 */ // Label 46: @61746
     /* 61746 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1462*/ GIMT_Encode4(62658),
     /* 61757 */ /*GILLT_s32*//*Label 1458*/ GIMT_Encode4(61781),
     /* 61761 */ /*GILLT_s64*//*Label 1459*/ GIMT_Encode4(61985), GIMT_Encode4(0),
     /* 61769 */ /*GILLT_v2s64*//*Label 1460*/ GIMT_Encode4(62350), GIMT_Encode4(0),
     /* 61777 */ /*GILLT_v4s32*//*Label 1461*/ GIMT_Encode4(62504),
     /* 61781 */ // Label 1458: @61781
     /* 61781 */ GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(61984),
     /* 61786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 61789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 61792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61796 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(61853), // Rule ID 163 //
     /* 61801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 61808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 61812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 61816 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 61820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 61836 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr)  =>  (MADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_S),
     /* 61839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61841 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 61843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 61847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 61851 */     GIR_RootConstrainSelectedInstOperands,
     /* 61852 */     // GIR_Coverage, 163,
     /* 61852 */     GIR_EraseRootFromParent_Done,
     /* 61853 */   // Label 1464: @61853
     /* 61853 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(61910), // Rule ID 2352 //
     /* 61858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 61861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 61869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 61873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 61877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 61881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 61893 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft))  =>  (MADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_S),
     /* 61896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61898 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 61900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 61904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 61908 */     GIR_RootConstrainSelectedInstOperands,
     /* 61909 */     // GIR_Coverage, 2352,
     /* 61909 */     GIR_EraseRootFromParent_Done,
     /* 61910 */   // Label 1465: @61910
     /* 61910 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(61933), // Rule ID 151 //
     /* 61915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 61918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61926 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_S),
     /* 61931 */     GIR_RootConstrainSelectedInstOperands,
     /* 61932 */     // GIR_Coverage, 151,
     /* 61932 */     GIR_Done,
     /* 61933 */   // Label 1466: @61933
     /* 61933 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(61956), // Rule ID 1130 //
     /* 61938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 61941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61949 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 61949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_S_MM),
     /* 61954 */     GIR_RootConstrainSelectedInstOperands,
     /* 61955 */     // GIR_Coverage, 1130,
     /* 61955 */     GIR_Done,
     /* 61956 */   // Label 1467: @61956
     /* 61956 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(61983), // Rule ID 1188 //
     /* 61961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 61964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 61972 */     // (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FADD_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 61972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FADD_S_MMR6),
     /* 61975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 61977 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 61979 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 61981 */     GIR_RootConstrainSelectedInstOperands,
     /* 61982 */     // GIR_Coverage, 1188,
     /* 61982 */     GIR_EraseRootFromParent_Done,
     /* 61983 */   // Label 1468: @61983
     /* 61983 */   GIM_Reject,
     /* 61984 */ // Label 1463: @61984
     /* 61984 */ GIM_Reject,
     /* 61985 */ // Label 1459: @61985
     /* 61985 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(62349),
     /* 61990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 61993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 61996 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(62057), // Rule ID 165 //
     /* 62001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62040 */     // (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr)  =>  (MADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D32),
     /* 62043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62045 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62055 */     GIR_RootConstrainSelectedInstOperands,
     /* 62056 */     // GIR_Coverage, 165,
     /* 62056 */     GIR_EraseRootFromParent_Done,
     /* 62057 */   // Label 1470: @62057
     /* 62057 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(62118), // Rule ID 167 //
     /* 62062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62101 */     // (fadd:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr)  =>  (MADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D64),
     /* 62104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62106 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62116 */     GIR_RootConstrainSelectedInstOperands,
     /* 62117 */     // GIR_Coverage, 167,
     /* 62117 */     GIR_EraseRootFromParent_Done,
     /* 62118 */   // Label 1471: @62118
     /* 62118 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(62179), // Rule ID 2353 //
     /* 62123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62162 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft))  =>  (MADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D32),
     /* 62165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62167 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 62169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62177 */     GIR_RootConstrainSelectedInstOperands,
     /* 62178 */     // GIR_Coverage, 2353,
     /* 62178 */     GIR_EraseRootFromParent_Done,
     /* 62179 */   // Label 1472: @62179
     /* 62179 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(62240), // Rule ID 2354 //
     /* 62184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62223 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft))  =>  (MADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MADD_D64),
     /* 62226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62228 */     GIR_RootToRootCopy, /*OpIdx*/1, // fr
     /* 62230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62238 */     GIR_RootConstrainSelectedInstOperands,
     /* 62239 */     // GIR_Coverage, 2354,
     /* 62239 */     GIR_EraseRootFromParent_Done,
     /* 62240 */   // Label 1473: @62240
     /* 62240 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(62267), // Rule ID 152 //
     /* 62245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 62248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62260 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D32),
     /* 62265 */     GIR_RootConstrainSelectedInstOperands,
     /* 62266 */     // GIR_Coverage, 152,
     /* 62266 */     GIR_Done,
     /* 62267 */   // Label 1474: @62267
     /* 62267 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(62294), // Rule ID 153 //
     /* 62272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 62275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62287 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D64),
     /* 62292 */     GIR_RootConstrainSelectedInstOperands,
     /* 62293 */     // GIR_Coverage, 153,
     /* 62293 */     GIR_Done,
     /* 62294 */   // Label 1475: @62294
     /* 62294 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(62321), // Rule ID 1134 //
     /* 62299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 62302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62314 */     // (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D32_MM),
     /* 62319 */     GIR_RootConstrainSelectedInstOperands,
     /* 62320 */     // GIR_Coverage, 1134,
     /* 62320 */     GIR_Done,
     /* 62321 */   // Label 1476: @62321
     /* 62321 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(62348), // Rule ID 1135 //
     /* 62326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 62329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62341 */     // (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FADD_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D64_MM),
     /* 62346 */     GIR_RootConstrainSelectedInstOperands,
     /* 62347 */     // GIR_Coverage, 1135,
     /* 62347 */     GIR_Done,
     /* 62348 */   // Label 1477: @62348
     /* 62348 */   GIM_Reject,
     /* 62349 */ // Label 1469: @62349
     /* 62349 */ GIM_Reject,
     /* 62350 */ // Label 1460: @62350
     /* 62350 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(62503),
     /* 62355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62365 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(62422), // Rule ID 2459 //
     /* 62370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62405 */     // (fadd:{ *:[v2f64] } (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt), MSA128DOpnd:{ *:[v2f64] }:$wd)  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 62408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62410 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd
     /* 62412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62420 */     GIR_RootConstrainSelectedInstOperands,
     /* 62421 */     // GIR_Coverage, 2459,
     /* 62421 */     GIR_EraseRootFromParent_Done,
     /* 62422 */   // Label 1479: @62422
     /* 62422 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(62479), // Rule ID 1989 //
     /* 62427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 62446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 62450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62462 */     // (fadd:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 62465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62467 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 62469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62477 */     GIR_RootConstrainSelectedInstOperands,
     /* 62478 */     // GIR_Coverage, 1989,
     /* 62478 */     GIR_EraseRootFromParent_Done,
     /* 62479 */   // Label 1480: @62479
     /* 62479 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(62502), // Rule ID 671 //
     /* 62484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 62487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 62495 */     // (fadd:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 62495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_D),
     /* 62500 */     GIR_RootConstrainSelectedInstOperands,
     /* 62501 */     // GIR_Coverage, 671,
     /* 62501 */     GIR_Done,
     /* 62502 */   // Label 1481: @62502
     /* 62502 */   GIM_Reject,
     /* 62503 */ // Label 1478: @62503
     /* 62503 */ GIM_Reject,
     /* 62504 */ // Label 1461: @62504
     /* 62504 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(62657),
     /* 62509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62519 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(62576), // Rule ID 2458 //
     /* 62524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62559 */     // (fadd:{ *:[v4f32] } (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt), MSA128WOpnd:{ *:[v4f32] }:$wd)  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 62562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62564 */     GIR_RootToRootCopy, /*OpIdx*/2, // wd
     /* 62566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62574 */     GIR_RootConstrainSelectedInstOperands,
     /* 62575 */     // GIR_Coverage, 2458,
     /* 62575 */     GIR_EraseRootFromParent_Done,
     /* 62576 */   // Label 1483: @62576
     /* 62576 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(62633), // Rule ID 1988 //
     /* 62581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 62584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 62592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 62600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 62604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62616 */     // (fadd:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 62619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 62621 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 62623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 62627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 62631 */     GIR_RootConstrainSelectedInstOperands,
     /* 62632 */     // GIR_Coverage, 1988,
     /* 62632 */     GIR_EraseRootFromParent_Done,
     /* 62633 */   // Label 1484: @62633
     /* 62633 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(62656), // Rule ID 670 //
     /* 62638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 62641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 62649 */     // (fadd:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 62649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FADD_W),
     /* 62654 */     GIR_RootConstrainSelectedInstOperands,
     /* 62655 */     // GIR_Coverage, 670,
     /* 62655 */     GIR_Done,
     /* 62656 */   // Label 1485: @62656
     /* 62656 */   GIM_Reject,
     /* 62657 */ // Label 1482: @62657
     /* 62657 */ GIM_Reject,
     /* 62658 */ // Label 1462: @62658
     /* 62658 */ GIM_Reject,
     /* 62659 */ // Label 47: @62659
     /* 62659 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1490*/ GIMT_Encode4(63270),
     /* 62670 */ /*GILLT_s32*//*Label 1486*/ GIMT_Encode4(62694),
     /* 62674 */ /*GILLT_s64*//*Label 1487*/ GIMT_Encode4(62841), GIMT_Encode4(0),
     /* 62682 */ /*GILLT_v2s64*//*Label 1488*/ GIMT_Encode4(63084), GIMT_Encode4(0),
     /* 62690 */ /*GILLT_v4s32*//*Label 1489*/ GIMT_Encode4(63177),
     /* 62694 */ // Label 1486: @62694
     /* 62694 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(62840),
     /* 62699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 62702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 62705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62709 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(62766), // Rule ID 164 //
     /* 62714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 62729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 62733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62749 */     // (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr)  =>  (MSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_S),
     /* 62752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62754 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62764 */     GIR_RootConstrainSelectedInstOperands,
     /* 62765 */     // GIR_Coverage, 164,
     /* 62765 */     GIR_EraseRootFromParent_Done,
     /* 62766 */   // Label 1492: @62766
     /* 62766 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(62789), // Rule ID 160 //
     /* 62771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 62774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62782 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_S),
     /* 62787 */     GIR_RootConstrainSelectedInstOperands,
     /* 62788 */     // GIR_Coverage, 160,
     /* 62788 */     GIR_Done,
     /* 62789 */   // Label 1493: @62789
     /* 62789 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(62812), // Rule ID 1133 //
     /* 62794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 62797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62805 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 62805 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_S_MM),
     /* 62810 */     GIR_RootConstrainSelectedInstOperands,
     /* 62811 */     // GIR_Coverage, 1133,
     /* 62811 */     GIR_Done,
     /* 62812 */   // Label 1494: @62812
     /* 62812 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(62839), // Rule ID 1189 //
     /* 62817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 62820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 62828 */     // (fsub:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FSUB_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 62828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FSUB_S_MMR6),
     /* 62831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62833 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 62835 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 62837 */     GIR_RootConstrainSelectedInstOperands,
     /* 62838 */     // GIR_Coverage, 1189,
     /* 62838 */     GIR_EraseRootFromParent_Done,
     /* 62839 */   // Label 1495: @62839
     /* 62839 */   GIM_Reject,
     /* 62840 */ // Label 1491: @62840
     /* 62840 */ GIM_Reject,
     /* 62841 */ // Label 1487: @62841
     /* 62841 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(63083),
     /* 62846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 62849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 62852 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(62913), // Rule ID 166 //
     /* 62857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62876 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62896 */     // (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr)  =>  (MSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_D32),
     /* 62899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62901 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62911 */     GIR_RootConstrainSelectedInstOperands,
     /* 62912 */     // GIR_Coverage, 166,
     /* 62912 */     GIR_EraseRootFromParent_Done,
     /* 62913 */   // Label 1497: @62913
     /* 62913 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(62974), // Rule ID 168 //
     /* 62918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 62921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 62929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 62933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 62937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 62941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 62955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 62957 */     // (fsub:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr)  =>  (MSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 62957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MSUB_D64),
     /* 62960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 62962 */     GIR_RootToRootCopy, /*OpIdx*/2, // fr
     /* 62964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fs
     /* 62968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // ft
     /* 62972 */     GIR_RootConstrainSelectedInstOperands,
     /* 62973 */     // GIR_Coverage, 168,
     /* 62973 */     GIR_EraseRootFromParent_Done,
     /* 62974 */   // Label 1498: @62974
     /* 62974 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(63001), // Rule ID 161 //
     /* 62979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 62982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 62994 */     // (fsub:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 62994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D32),
     /* 62999 */     GIR_RootConstrainSelectedInstOperands,
     /* 63000 */     // GIR_Coverage, 161,
     /* 63000 */     GIR_Done,
     /* 63001 */   // Label 1499: @63001
     /* 63001 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(63028), // Rule ID 162 //
     /* 63006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 63009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63021 */     // (fsub:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D64),
     /* 63026 */     GIR_RootConstrainSelectedInstOperands,
     /* 63027 */     // GIR_Coverage, 162,
     /* 63027 */     GIR_Done,
     /* 63028 */   // Label 1500: @63028
     /* 63028 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(63055), // Rule ID 1140 //
     /* 63033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 63036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63048 */     // (fsub:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63048 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D32_MM),
     /* 63053 */     GIR_RootConstrainSelectedInstOperands,
     /* 63054 */     // GIR_Coverage, 1140,
     /* 63054 */     GIR_Done,
     /* 63055 */   // Label 1501: @63055
     /* 63055 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(63082), // Rule ID 1141 //
     /* 63060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 63063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63075 */     // (fsub:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FSUB_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D64_MM),
     /* 63080 */     GIR_RootConstrainSelectedInstOperands,
     /* 63081 */     // GIR_Coverage, 1141,
     /* 63081 */     GIR_Done,
     /* 63082 */   // Label 1502: @63082
     /* 63082 */   GIM_Reject,
     /* 63083 */ // Label 1496: @63083
     /* 63083 */ GIM_Reject,
     /* 63084 */ // Label 1488: @63084
     /* 63084 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(63176),
     /* 63089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63103 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(63156), // Rule ID 1987 //
     /* 63108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 63111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 63119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63139 */     // (fsub:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FMSUB_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMSUB_D),
     /* 63142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63144 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 63146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 63150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 63154 */     GIR_RootConstrainSelectedInstOperands,
     /* 63155 */     // GIR_Coverage, 1987,
     /* 63155 */     GIR_EraseRootFromParent_Done,
     /* 63156 */   // Label 1504: @63156
     /* 63156 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(63175), // Rule ID 759 //
     /* 63161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63168 */     // (fsub:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FSUB_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_D),
     /* 63173 */     GIR_RootConstrainSelectedInstOperands,
     /* 63174 */     // GIR_Coverage, 759,
     /* 63174 */     GIR_Done,
     /* 63175 */   // Label 1505: @63175
     /* 63175 */   GIM_Reject,
     /* 63176 */ // Label 1503: @63176
     /* 63176 */ GIM_Reject,
     /* 63177 */ // Label 1489: @63177
     /* 63177 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(63269),
     /* 63182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63196 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(63249), // Rule ID 1986 //
     /* 63201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowFPOpFusion_HasMSA_HasStdEnc),
     /* 63204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 63212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63232 */     // (fsub:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FMSUB_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMSUB_W),
     /* 63235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63237 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd
     /* 63239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // ws
     /* 63243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // wt
     /* 63247 */     GIR_RootConstrainSelectedInstOperands,
     /* 63248 */     // GIR_Coverage, 1986,
     /* 63248 */     GIR_EraseRootFromParent_Done,
     /* 63249 */   // Label 1507: @63249
     /* 63249 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(63268), // Rule ID 758 //
     /* 63254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63261 */     // (fsub:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FSUB_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSUB_W),
     /* 63266 */     GIR_RootConstrainSelectedInstOperands,
     /* 63267 */     // GIR_Coverage, 758,
     /* 63267 */     GIR_Done,
     /* 63268 */   // Label 1508: @63268
     /* 63268 */   GIM_Reject,
     /* 63269 */ // Label 1506: @63269
     /* 63269 */ GIM_Reject,
     /* 63270 */ // Label 1490: @63270
     /* 63270 */ GIM_Reject,
     /* 63271 */ // Label 48: @63271
     /* 63271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1513*/ GIMT_Encode4(63757),
     /* 63282 */ /*GILLT_s32*//*Label 1509*/ GIMT_Encode4(63306),
     /* 63286 */ /*GILLT_s64*//*Label 1510*/ GIMT_Encode4(63380), GIMT_Encode4(0),
     /* 63294 */ /*GILLT_v2s64*//*Label 1511*/ GIMT_Encode4(63501), GIMT_Encode4(0),
     /* 63302 */ /*GILLT_v4s32*//*Label 1512*/ GIMT_Encode4(63629),
     /* 63306 */ // Label 1509: @63306
     /* 63306 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(63379),
     /* 63311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63329 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(63344), // Rule ID 157 //
     /* 63334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 63337 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_S),
     /* 63342 */     GIR_RootConstrainSelectedInstOperands,
     /* 63343 */     // GIR_Coverage, 157,
     /* 63343 */     GIR_Done,
     /* 63344 */   // Label 1515: @63344
     /* 63344 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(63359), // Rule ID 1132 //
     /* 63349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 63352 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_S_MM),
     /* 63357 */     GIR_RootConstrainSelectedInstOperands,
     /* 63358 */     // GIR_Coverage, 1132,
     /* 63358 */     GIR_Done,
     /* 63359 */   // Label 1516: @63359
     /* 63359 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(63378), // Rule ID 1190 //
     /* 63364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 63367 */     // (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FMUL_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 63367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FMUL_S_MMR6),
     /* 63370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 63372 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 63374 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 63376 */     GIR_RootConstrainSelectedInstOperands,
     /* 63377 */     // GIR_Coverage, 1190,
     /* 63377 */     GIR_EraseRootFromParent_Done,
     /* 63378 */   // Label 1517: @63378
     /* 63378 */   GIM_Reject,
     /* 63379 */ // Label 1514: @63379
     /* 63379 */ GIM_Reject,
     /* 63380 */ // Label 1510: @63380
     /* 63380 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(63500),
     /* 63385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63391 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(63418), // Rule ID 158 //
     /* 63396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 63399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63411 */     // (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D32),
     /* 63416 */     GIR_RootConstrainSelectedInstOperands,
     /* 63417 */     // GIR_Coverage, 158,
     /* 63417 */     GIR_Done,
     /* 63418 */   // Label 1519: @63418
     /* 63418 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(63445), // Rule ID 159 //
     /* 63423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 63426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63438 */     // (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D64),
     /* 63443 */     GIR_RootConstrainSelectedInstOperands,
     /* 63444 */     // GIR_Coverage, 159,
     /* 63444 */     GIR_Done,
     /* 63445 */   // Label 1520: @63445
     /* 63445 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(63472), // Rule ID 1138 //
     /* 63450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 63453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63465 */     // (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 63465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D32_MM),
     /* 63470 */     GIR_RootConstrainSelectedInstOperands,
     /* 63471 */     // GIR_Coverage, 1138,
     /* 63471 */     GIR_Done,
     /* 63472 */   // Label 1521: @63472
     /* 63472 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(63499), // Rule ID 1139 //
     /* 63477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 63480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 63492 */     // (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FMUL_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 63492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D64_MM),
     /* 63497 */     GIR_RootConstrainSelectedInstOperands,
     /* 63498 */     // GIR_Coverage, 1139,
     /* 63498 */     GIR_Done,
     /* 63499 */   // Label 1522: @63499
     /* 63499 */   GIM_Reject,
     /* 63500 */ // Label 1518: @63500
     /* 63500 */ GIM_Reject,
     /* 63501 */ // Label 1511: @63501
     /* 63501 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(63628),
     /* 63506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63516 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(63560), // Rule ID 2395 //
     /* 63521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 63528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63547 */     // (fmul:{ *:[v2f64] } (fexp2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wt), MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FEXP2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D),
     /* 63550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63552 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 63554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63558 */     GIR_RootConstrainSelectedInstOperands,
     /* 63559 */     // GIR_Coverage, 2395,
     /* 63559 */     GIR_EraseRootFromParent_Done,
     /* 63560 */   // Label 1524: @63560
     /* 63560 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(63604), // Rule ID 701 //
     /* 63565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63591 */     // (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, (fexp2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wt))  =>  (FEXP2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D),
     /* 63594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63596 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 63598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63602 */     GIR_RootConstrainSelectedInstOperands,
     /* 63603 */     // GIR_Coverage, 701,
     /* 63603 */     GIR_EraseRootFromParent_Done,
     /* 63604 */   // Label 1525: @63604
     /* 63604 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(63627), // Rule ID 737 //
     /* 63609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63620 */     // (fmul:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMUL_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63620 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_D),
     /* 63625 */     GIR_RootConstrainSelectedInstOperands,
     /* 63626 */     // GIR_Coverage, 737,
     /* 63626 */     GIR_Done,
     /* 63627 */   // Label 1526: @63627
     /* 63627 */   GIM_Reject,
     /* 63628 */ // Label 1523: @63628
     /* 63628 */ GIM_Reject,
     /* 63629 */ // Label 1512: @63629
     /* 63629 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(63756),
     /* 63634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63644 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(63688), // Rule ID 2394 //
     /* 63649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 63656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63675 */     // (fmul:{ *:[v4f32] } (fexp2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wt), MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FEXP2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W),
     /* 63678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63680 */     GIR_RootToRootCopy, /*OpIdx*/2, // ws
     /* 63682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63686 */     GIR_RootConstrainSelectedInstOperands,
     /* 63687 */     // GIR_Coverage, 2394,
     /* 63687 */     GIR_EraseRootFromParent_Done,
     /* 63688 */   // Label 1528: @63688
     /* 63688 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(63732), // Rule ID 700 //
     /* 63693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 63704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FEXP2),
     /* 63708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 63719 */     // (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, (fexp2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wt))  =>  (FEXP2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W),
     /* 63722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 63724 */     GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 63726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // wt
     /* 63730 */     GIR_RootConstrainSelectedInstOperands,
     /* 63731 */     // GIR_Coverage, 700,
     /* 63731 */     GIR_EraseRootFromParent_Done,
     /* 63732 */   // Label 1529: @63732
     /* 63732 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(63755), // Rule ID 736 //
     /* 63737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63748 */     // (fmul:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMUL_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMUL_W),
     /* 63753 */     GIR_RootConstrainSelectedInstOperands,
     /* 63754 */     // GIR_Coverage, 736,
     /* 63754 */     GIR_Done,
     /* 63755 */   // Label 1530: @63755
     /* 63755 */   GIM_Reject,
     /* 63756 */ // Label 1527: @63756
     /* 63756 */ GIM_Reject,
     /* 63757 */ // Label 1513: @63757
     /* 63757 */ GIM_Reject,
     /* 63758 */ // Label 49: @63758
     /* 63758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1533*/ GIMT_Encode4(63863),
     /* 63769 */ /*GILLT_v2s64*//*Label 1531*/ GIMT_Encode4(63781), GIMT_Encode4(0),
     /* 63777 */ /*GILLT_v4s32*//*Label 1532*/ GIMT_Encode4(63822),
     /* 63781 */ // Label 1531: @63781
     /* 63781 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(63821), // Rule ID 725 //
     /* 63786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 63792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 63795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 63798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63810 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 63814 */   // (fma:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FMADD_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 63814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMADD_D),
     /* 63819 */   GIR_RootConstrainSelectedInstOperands,
     /* 63820 */   // GIR_Coverage, 725,
     /* 63820 */   GIR_Done,
     /* 63821 */ // Label 1534: @63821
     /* 63821 */ GIM_Reject,
     /* 63822 */ // Label 1532: @63822
     /* 63822 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(63862), // Rule ID 724 //
     /* 63827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 63830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 63833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 63836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 63839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63851 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 63855 */   // (fma:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FMADD_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 63855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FMADD_W),
     /* 63860 */   GIR_RootConstrainSelectedInstOperands,
     /* 63861 */   // GIR_Coverage, 724,
     /* 63861 */   GIR_Done,
     /* 63862 */ // Label 1535: @63862
     /* 63862 */ GIM_Reject,
     /* 63863 */ // Label 1533: @63863
     /* 63863 */ GIM_Reject,
     /* 63864 */ // Label 50: @63864
     /* 63864 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1540*/ GIMT_Encode4(64162),
     /* 63875 */ /*GILLT_s32*//*Label 1536*/ GIMT_Encode4(63899),
     /* 63879 */ /*GILLT_s64*//*Label 1537*/ GIMT_Encode4(63973), GIMT_Encode4(0),
     /* 63887 */ /*GILLT_v2s64*//*Label 1538*/ GIMT_Encode4(64094), GIMT_Encode4(0),
     /* 63895 */ /*GILLT_v4s32*//*Label 1539*/ GIMT_Encode4(64128),
     /* 63899 */ // Label 1536: @63899
     /* 63899 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(63972),
     /* 63904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 63907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 63910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 63922 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(63937), // Rule ID 154 //
     /* 63927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 63930 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_S),
     /* 63935 */     GIR_RootConstrainSelectedInstOperands,
     /* 63936 */     // GIR_Coverage, 154,
     /* 63936 */     GIR_Done,
     /* 63937 */   // Label 1542: @63937
     /* 63937 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(63952), // Rule ID 1131 //
     /* 63942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 63945 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 63945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_S_MM),
     /* 63950 */     GIR_RootConstrainSelectedInstOperands,
     /* 63951 */     // GIR_Coverage, 1131,
     /* 63951 */     GIR_Done,
     /* 63952 */   // Label 1543: @63952
     /* 63952 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(63971), // Rule ID 1191 //
     /* 63957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 63960 */     // (fdiv:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)  =>  (FDIV_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$ft, FGR32Opnd:{ *:[f32] }:$fs)
     /* 63960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::FDIV_S_MMR6),
     /* 63963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 63965 */     GIR_RootToRootCopy, /*OpIdx*/2, // ft
     /* 63967 */     GIR_RootToRootCopy, /*OpIdx*/1, // fs
     /* 63969 */     GIR_RootConstrainSelectedInstOperands,
     /* 63970 */     // GIR_Coverage, 1191,
     /* 63970 */     GIR_EraseRootFromParent_Done,
     /* 63971 */   // Label 1544: @63971
     /* 63971 */   GIM_Reject,
     /* 63972 */ // Label 1541: @63972
     /* 63972 */ GIM_Reject,
     /* 63973 */ // Label 1537: @63973
     /* 63973 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(64093),
     /* 63978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 63981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 63984 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(64011), // Rule ID 155 //
     /* 63989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 63992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 63996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64004 */     // (fdiv:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64004 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D32),
     /* 64009 */     GIR_RootConstrainSelectedInstOperands,
     /* 64010 */     // GIR_Coverage, 155,
     /* 64010 */     GIR_Done,
     /* 64011 */   // Label 1546: @64011
     /* 64011 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(64038), // Rule ID 156 //
     /* 64016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 64019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64031 */     // (fdiv:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 64031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D64),
     /* 64036 */     GIR_RootConstrainSelectedInstOperands,
     /* 64037 */     // GIR_Coverage, 156,
     /* 64037 */     GIR_Done,
     /* 64038 */   // Label 1547: @64038
     /* 64038 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(64065), // Rule ID 1136 //
     /* 64043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 64046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64058 */     // (fdiv:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D32_MM),
     /* 64063 */     GIR_RootConstrainSelectedInstOperands,
     /* 64064 */     // GIR_Coverage, 1136,
     /* 64064 */     GIR_Done,
     /* 64065 */   // Label 1548: @64065
     /* 64065 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(64092), // Rule ID 1137 //
     /* 64070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 64073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64085 */     // (fdiv:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)  =>  (FDIV_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 64085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D64_MM),
     /* 64090 */     GIR_RootConstrainSelectedInstOperands,
     /* 64091 */     // GIR_Coverage, 1137,
     /* 64091 */     GIR_Done,
     /* 64092 */   // Label 1549: @64092
     /* 64092 */   GIM_Reject,
     /* 64093 */ // Label 1545: @64093
     /* 64093 */ GIM_Reject,
     /* 64094 */ // Label 1538: @64094
     /* 64094 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(64127), // Rule ID 697 //
     /* 64099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 64108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64120 */   // (fdiv:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)  =>  (FDIV_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws, MSA128DOpnd:{ *:[v2f64] }:$wt)
     /* 64120 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_D),
     /* 64125 */   GIR_RootConstrainSelectedInstOperands,
     /* 64126 */   // GIR_Coverage, 697,
     /* 64126 */   GIR_Done,
     /* 64127 */ // Label 1550: @64127
     /* 64127 */ GIM_Reject,
     /* 64128 */ // Label 1539: @64128
     /* 64128 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(64161), // Rule ID 696 //
     /* 64133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 64142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64154 */   // (fdiv:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)  =>  (FDIV_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws, MSA128WOpnd:{ *:[v4f32] }:$wt)
     /* 64154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FDIV_W),
     /* 64159 */   GIR_RootConstrainSelectedInstOperands,
     /* 64160 */   // GIR_Coverage, 696,
     /* 64160 */   GIR_Done,
     /* 64161 */ // Label 1551: @64161
     /* 64161 */ GIM_Reject,
     /* 64162 */ // Label 1540: @64162
     /* 64162 */ GIM_Reject,
     /* 64163 */ // Label 51: @64163
     /* 64163 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1554*/ GIMT_Encode4(64240),
     /* 64174 */ /*GILLT_v2s64*//*Label 1552*/ GIMT_Encode4(64186), GIMT_Encode4(0),
     /* 64182 */ /*GILLT_v4s32*//*Label 1553*/ GIMT_Encode4(64213),
     /* 64186 */ // Label 1552: @64186
     /* 64186 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(64212), // Rule ID 703 //
     /* 64191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64205 */   // (fexp2:{ *:[v2f64] } MSA128D:{ *:[v2f64] }:$ws)  =>  (FEXP2_D_1_PSEUDO:{ *:[v2f64] } MSA128D:{ *:[v2f64] }:$ws)
     /* 64205 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FEXP2_D_1_PSEUDO),
     /* 64210 */   GIR_RootConstrainSelectedInstOperands,
     /* 64211 */   // GIR_Coverage, 703,
     /* 64211 */   GIR_Done,
     /* 64212 */ // Label 1555: @64212
     /* 64212 */ GIM_Reject,
     /* 64213 */ // Label 1553: @64213
     /* 64213 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(64239), // Rule ID 702 //
     /* 64218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64232 */   // (fexp2:{ *:[v4f32] } MSA128W:{ *:[v4f32] }:$ws)  =>  (FEXP2_W_1_PSEUDO:{ *:[v4f32] } MSA128W:{ *:[v4f32] }:$ws)
     /* 64232 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FEXP2_W_1_PSEUDO),
     /* 64237 */   GIR_RootConstrainSelectedInstOperands,
     /* 64238 */   // GIR_Coverage, 702,
     /* 64238 */   GIR_Done,
     /* 64239 */ // Label 1556: @64239
     /* 64239 */ GIM_Reject,
     /* 64240 */ // Label 1554: @64240
     /* 64240 */ GIM_Reject,
     /* 64241 */ // Label 52: @64241
     /* 64241 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1559*/ GIMT_Encode4(64318),
     /* 64252 */ /*GILLT_v2s64*//*Label 1557*/ GIMT_Encode4(64264), GIMT_Encode4(0),
     /* 64260 */ /*GILLT_v4s32*//*Label 1558*/ GIMT_Encode4(64291),
     /* 64264 */ // Label 1557: @64264
     /* 64264 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(64290), // Rule ID 723 //
     /* 64269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 64275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 64283 */   // (flog2:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FLOG2_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 64283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FLOG2_D),
     /* 64288 */   GIR_RootConstrainSelectedInstOperands,
     /* 64289 */   // GIR_Coverage, 723,
     /* 64289 */   GIR_Done,
     /* 64290 */ // Label 1560: @64290
     /* 64290 */ GIM_Reject,
     /* 64291 */ // Label 1558: @64291
     /* 64291 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(64317), // Rule ID 722 //
     /* 64296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 64299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 64302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 64310 */   // (flog2:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FLOG2_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 64310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FLOG2_W),
     /* 64315 */   GIR_RootConstrainSelectedInstOperands,
     /* 64316 */   // GIR_Coverage, 722,
     /* 64316 */   GIR_Done,
     /* 64317 */ // Label 1561: @64317
     /* 64317 */ GIM_Reject,
     /* 64318 */ // Label 1559: @64318
     /* 64318 */ GIM_Reject,
     /* 64319 */ // Label 53: @64319
     /* 64319 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1564*/ GIMT_Encode4(65687),
     /* 64330 */ /*GILLT_s32*//*Label 1562*/ GIMT_Encode4(64338),
     /* 64334 */ /*GILLT_s64*//*Label 1563*/ GIMT_Encode4(64865),
     /* 64338 */ // Label 1562: @64338
     /* 64338 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(64864),
     /* 64343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 64346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64350 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(64426), // Rule ID 1460 //
     /* 64355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64400 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64407 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S),
     /* 64410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64424 */     GIR_RootConstrainSelectedInstOperands,
     /* 64425 */     // GIR_Coverage, 1460,
     /* 64425 */     GIR_EraseRootFromParent_Done,
     /* 64426 */   // Label 1566: @64426
     /* 64426 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(64502), // Rule ID 2244 //
     /* 64431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64483 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S_MM),
     /* 64486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64500 */     GIR_RootConstrainSelectedInstOperands,
     /* 64501 */     // GIR_Coverage, 2244,
     /* 64501 */     GIR_EraseRootFromParent_Done,
     /* 64502 */   // Label 1567: @64502
     /* 64502 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(64578), // Rule ID 2430 //
     /* 64507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 64535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64559 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)))  =>  (NMADD_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S),
     /* 64562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 64568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64576 */     GIR_RootConstrainSelectedInstOperands,
     /* 64577 */     // GIR_Coverage, 2430,
     /* 64577 */     GIR_EraseRootFromParent_Done,
     /* 64578 */   // Label 1568: @64578
     /* 64578 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(64654), // Rule ID 2516 //
     /* 64583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64607 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 64611 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64615 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64619 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64635 */     // (fneg:{ *:[f32] } (fadd:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)))  =>  (NMADD_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_S_MM),
     /* 64638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 64644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64652 */     GIR_RootConstrainSelectedInstOperands,
     /* 64653 */     // GIR_Coverage, 2516,
     /* 64653 */     GIR_EraseRootFromParent_Done,
     /* 64654 */   // Label 1569: @64654
     /* 64654 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(64730), // Rule ID 1461 //
     /* 64659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 64670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64711 */     // (fneg:{ *:[f32] } (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMSUB_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_S),
     /* 64714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64728 */     GIR_RootConstrainSelectedInstOperands,
     /* 64729 */     // GIR_Coverage, 1461,
     /* 64729 */     GIR_EraseRootFromParent_Done,
     /* 64730 */   // Label 1570: @64730
     /* 64730 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(64806), // Rule ID 2245 //
     /* 64735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotMips32r6),
     /* 64738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 64746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 64750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 64754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 64766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 64770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64787 */     // (fneg:{ *:[f32] } (fsub:{ *:[f32] } (fmul:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft), FGR32Opnd:{ *:[f32] }:$fr))  =>  (NMSUB_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fr, FGR32Opnd:{ *:[f32] }:$fs, FGR32Opnd:{ *:[f32] }:$ft)
     /* 64787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_S_MM),
     /* 64790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64804 */     GIR_RootConstrainSelectedInstOperands,
     /* 64805 */     // GIR_Coverage, 2245,
     /* 64805 */     GIR_EraseRootFromParent_Done,
     /* 64806 */   // Label 1571: @64806
     /* 64806 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(64825), // Rule ID 129 //
     /* 64811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat),
     /* 64814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64818 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S),
     /* 64823 */     GIR_RootConstrainSelectedInstOperands,
     /* 64824 */     // GIR_Coverage, 129,
     /* 64824 */     GIR_Done,
     /* 64825 */   // Label 1572: @64825
     /* 64825 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(64844), // Rule ID 1153 //
     /* 64830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 64833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64837 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S_MM),
     /* 64842 */     GIR_RootConstrainSelectedInstOperands,
     /* 64843 */     // GIR_Coverage, 1153,
     /* 64843 */     GIR_Done,
     /* 64844 */   // Label 1573: @64844
     /* 64844 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(64863), // Rule ID 1192 //
     /* 64849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips_IsNotSoftFloat),
     /* 64852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 64856 */     // (fneg:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FNEG_S_MMR6:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 64856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_S_MMR6),
     /* 64861 */     GIR_RootConstrainSelectedInstOperands,
     /* 64862 */     // GIR_Coverage, 1192,
     /* 64862 */     GIR_Done,
     /* 64863 */   // Label 1574: @64863
     /* 64863 */   GIM_Reject,
     /* 64864 */ // Label 1565: @64864
     /* 64864 */ GIM_Reject,
     /* 64865 */ // Label 1563: @64865
     /* 64865 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(65686),
     /* 64870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 64873 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(64953), // Rule ID 1462 //
     /* 64878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 64897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 64901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 64913 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 64917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 64932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 64934 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 64934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32),
     /* 64937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 64939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 64943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 64947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 64951 */     GIR_RootConstrainSelectedInstOperands,
     /* 64952 */     // GIR_Coverage, 1462,
     /* 64952 */     GIR_EraseRootFromParent_Done,
     /* 64953 */   // Label 1576: @64953
     /* 64953 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(65033), // Rule ID 1464 //
     /* 64958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 64961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 64965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 64969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 64973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 64977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 64981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 64985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 64989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 64993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 64997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65014 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D64),
     /* 65017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65031 */     GIR_RootConstrainSelectedInstOperands,
     /* 65032 */     // GIR_Coverage, 1464,
     /* 65032 */     GIR_EraseRootFromParent_Done,
     /* 65033 */   // Label 1577: @65033
     /* 65033 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(65113), // Rule ID 2246 //
     /* 65038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65069 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65073 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65094 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32_MM),
     /* 65097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65111 */     GIR_RootConstrainSelectedInstOperands,
     /* 65112 */     // GIR_Coverage, 2246,
     /* 65112 */     GIR_EraseRootFromParent_Done,
     /* 65113 */   // Label 1578: @65113
     /* 65113 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(65193), // Rule ID 2431 //
     /* 65118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65158 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65174 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32),
     /* 65177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65191 */     GIR_RootConstrainSelectedInstOperands,
     /* 65192 */     // GIR_Coverage, 2431,
     /* 65192 */     GIR_EraseRootFromParent_Done,
     /* 65193 */   // Label 1579: @65193
     /* 65193 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(65273), // Rule ID 2432 //
     /* 65198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65238 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65254 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D64),
     /* 65257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65271 */     GIR_RootConstrainSelectedInstOperands,
     /* 65272 */     // GIR_Coverage, 2432,
     /* 65272 */     GIR_EraseRootFromParent_Done,
     /* 65273 */   // Label 1580: @65273
     /* 65273 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(65353), // Rule ID 2517 //
     /* 65278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FADD),
     /* 65293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 65310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65334 */     // (fneg:{ *:[f64] } (fadd:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)))  =>  (NMADD_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMADD_D32_MM),
     /* 65337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // fr
     /* 65343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65351 */     GIR_RootConstrainSelectedInstOperands,
     /* 65352 */     // GIR_Coverage, 2517,
     /* 65352 */     GIR_EraseRootFromParent_Done,
     /* 65353 */   // Label 1581: @65353
     /* 65353 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(65433), // Rule ID 1463 //
     /* 65358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_NoNaNsFPMath_NotFP64bit_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65381 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65385 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65389 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65414 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D32),
     /* 65417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65431 */     GIR_RootConstrainSelectedInstOperands,
     /* 65432 */     // GIR_Coverage, 1463,
     /* 65432 */     GIR_EraseRootFromParent_Done,
     /* 65433 */   // Label 1582: @65433
     /* 65433 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(65513), // Rule ID 1465 //
     /* 65438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_HasMips4_32r2_HasStdEnc_IsFP64bit_NoNaNsFPMath_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 65441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65494 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft), FGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fr, FGR64Opnd:{ *:[f64] }:$fs, FGR64Opnd:{ *:[f64] }:$ft)
     /* 65494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D64),
     /* 65497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65511 */     GIR_RootConstrainSelectedInstOperands,
     /* 65512 */     // GIR_Coverage, 1465,
     /* 65512 */     GIR_EraseRootFromParent_Done,
     /* 65513 */   // Label 1583: @65513
     /* 65513 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(65593), // Rule ID 2247 //
     /* 65518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMadd4_InMicroMips_NoNaNsFPMath_NotFP64bit_NotMips32r6),
     /* 65521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 65529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 65533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 65537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 65541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 65545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 65549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 65553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 65557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 65574 */     // (fneg:{ *:[f64] } (fsub:{ *:[f64] } (fmul:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft), AFGR64Opnd:{ *:[f64] }:$fr))  =>  (NMSUB_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fr, AFGR64Opnd:{ *:[f64] }:$fs, AFGR64Opnd:{ *:[f64] }:$ft)
     /* 65574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::NMSUB_D32_MM),
     /* 65577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 65579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // fr
     /* 65583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // fs
     /* 65587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // ft
     /* 65591 */     GIR_RootConstrainSelectedInstOperands,
     /* 65592 */     // GIR_Coverage, 2247,
     /* 65592 */     GIR_EraseRootFromParent_Done,
     /* 65593 */   // Label 1584: @65593
     /* 65593 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(65616), // Rule ID 130 //
     /* 65598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 65601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65609 */     // (fneg:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 65609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D32),
     /* 65614 */     GIR_RootConstrainSelectedInstOperands,
     /* 65615 */     // GIR_Coverage, 130,
     /* 65615 */     GIR_Done,
     /* 65616 */   // Label 1585: @65616
     /* 65616 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(65639), // Rule ID 131 //
     /* 65621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 65624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65632 */     // (fneg:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D64),
     /* 65637 */     GIR_RootConstrainSelectedInstOperands,
     /* 65638 */     // GIR_Coverage, 131,
     /* 65638 */     GIR_Done,
     /* 65639 */   // Label 1586: @65639
     /* 65639 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(65662), // Rule ID 1154 //
     /* 65644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 65647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65655 */     // (fneg:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 65655 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D32_MM),
     /* 65660 */     GIR_RootConstrainSelectedInstOperands,
     /* 65661 */     // GIR_Coverage, 1154,
     /* 65661 */     GIR_Done,
     /* 65662 */   // Label 1587: @65662
     /* 65662 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(65685), // Rule ID 1155 //
     /* 65667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 65670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65678 */     // (fneg:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FNEG_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65678 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FNEG_D64_MM),
     /* 65683 */     GIR_RootConstrainSelectedInstOperands,
     /* 65684 */     // GIR_Coverage, 1155,
     /* 65684 */     GIR_Done,
     /* 65685 */   // Label 1588: @65685
     /* 65685 */   GIM_Reject,
     /* 65686 */ // Label 1575: @65686
     /* 65686 */ GIM_Reject,
     /* 65687 */ // Label 1564: @65687
     /* 65687 */ GIM_Reject,
     /* 65688 */ // Label 54: @65688
     /* 65688 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1591*/ GIMT_Encode4(65865),
     /* 65699 */ /*GILLT_s32*//*Label 1589*/ GIMT_Encode4(65707),
     /* 65703 */ /*GILLT_s64*//*Label 1590*/ GIMT_Encode4(65734),
     /* 65707 */ // Label 1589: @65707
     /* 65707 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(65733), // Rule ID 1056 //
     /* 65712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65726 */   // (fpextend:{ *:[f32] } MSA128F16:{ *:[f16] }:$ws)  =>  (MSA_FP_EXTEND_W_PSEUDO:{ *:[f32] } MSA128F16:{ *:[f16] }:$ws)
     /* 65726 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_EXTEND_W_PSEUDO),
     /* 65731 */   GIR_RootConstrainSelectedInstOperands,
     /* 65732 */   // GIR_Coverage, 1056,
     /* 65732 */   GIR_Done,
     /* 65733 */ // Label 1592: @65733
     /* 65733 */ GIM_Reject,
     /* 65734 */ // Label 1590: @65734
     /* 65734 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(65760), // Rule ID 1058 //
     /* 65739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 65745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65753 */   // (fpextend:{ *:[f64] } MSA128F16:{ *:[f16] }:$ws)  =>  (MSA_FP_EXTEND_D_PSEUDO:{ *:[f64] } MSA128F16:{ *:[f16] }:$ws)
     /* 65753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_EXTEND_D_PSEUDO),
     /* 65758 */   GIR_RootConstrainSelectedInstOperands,
     /* 65759 */   // GIR_Coverage, 1058,
     /* 65759 */   GIR_Done,
     /* 65760 */ // Label 1593: @65760
     /* 65760 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(65786), // Rule ID 1449 //
     /* 65765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips),
     /* 65768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65779 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D32_S:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D32_S),
     /* 65784 */   GIR_RootConstrainSelectedInstOperands,
     /* 65785 */   // GIR_Coverage, 1449,
     /* 65785 */   GIR_Done,
     /* 65786 */ // Label 1594: @65786
     /* 65786 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(65812), // Rule ID 1459 //
     /* 65791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips),
     /* 65794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65805 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D64_S:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65805 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D64_S),
     /* 65810 */   GIR_RootConstrainSelectedInstOperands,
     /* 65811 */   // GIR_Coverage, 1459,
     /* 65811 */   GIR_Done,
     /* 65812 */ // Label 1595: @65812
     /* 65812 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(65838), // Rule ID 2258 //
     /* 65817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit),
     /* 65820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65831 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D64_S_MM:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D64_S_MM),
     /* 65836 */   GIR_RootConstrainSelectedInstOperands,
     /* 65837 */   // GIR_Coverage, 2258,
     /* 65837 */   GIR_Done,
     /* 65838 */ // Label 1596: @65838
     /* 65838 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(65864), // Rule ID 2260 //
     /* 65843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit),
     /* 65846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65857 */   // (fpextend:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)  =>  (CVT_D32_S_MM:{ *:[f64] } FGR32Opnd:{ *:[f32] }:$src)
     /* 65857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_D32_S_MM),
     /* 65862 */   GIR_RootConstrainSelectedInstOperands,
     /* 65863 */   // GIR_Coverage, 2260,
     /* 65863 */   GIR_Done,
     /* 65864 */ // Label 1597: @65864
     /* 65864 */ GIM_Reject,
     /* 65865 */ // Label 1591: @65865
     /* 65865 */ GIM_Reject,
     /* 65866 */ // Label 55: @65866
     /* 65866 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 1600*/ GIMT_Encode4(66028),
     /* 65877 */ /*GILLT_s16*//*Label 1598*/ GIMT_Encode4(65885),
     /* 65881 */ /*GILLT_s32*//*Label 1599*/ GIMT_Encode4(65938),
     /* 65885 */ // Label 1598: @65885
     /* 65885 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(65911), // Rule ID 1057 //
     /* 65890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 65896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65904 */   // (fpround:{ *:[f16] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (MSA_FP_ROUND_W_PSEUDO:{ *:[f16] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 65904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_ROUND_W_PSEUDO),
     /* 65909 */   GIR_RootConstrainSelectedInstOperands,
     /* 65910 */   // GIR_Coverage, 1057,
     /* 65910 */   GIR_Done,
     /* 65911 */ // Label 1601: @65911
     /* 65911 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(65937), // Rule ID 1059 //
     /* 65916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 65919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128F16RegClassID),
     /* 65926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65930 */   // (fpround:{ *:[f16] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (MSA_FP_ROUND_D_PSEUDO:{ *:[f16] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 65930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MSA_FP_ROUND_D_PSEUDO),
     /* 65935 */   GIR_RootConstrainSelectedInstOperands,
     /* 65936 */   // GIR_Coverage, 1059,
     /* 65936 */   GIR_Done,
     /* 65937 */ // Label 1602: @65937
     /* 65937 */ GIM_Reject,
     /* 65938 */ // Label 1599: @65938
     /* 65938 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(66027),
     /* 65943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 65946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 65950 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(65969), // Rule ID 1448 //
     /* 65955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotFP64bit_NotInMicroMips),
     /* 65958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 65962 */     // (fpround:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D32:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)
     /* 65962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D32),
     /* 65967 */     GIR_RootConstrainSelectedInstOperands,
     /* 65968 */     // GIR_Coverage, 1448,
     /* 65968 */     GIR_Done,
     /* 65969 */   // Label 1604: @65969
     /* 65969 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(65988), // Rule ID 1458 //
     /* 65974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_NotInMicroMips),
     /* 65977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 65981 */     // (fpround:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D64:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)
     /* 65981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D64),
     /* 65986 */     GIR_RootConstrainSelectedInstOperands,
     /* 65987 */     // GIR_Coverage, 1458,
     /* 65987 */     GIR_Done,
     /* 65988 */   // Label 1605: @65988
     /* 65988 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(66007), // Rule ID 2257 //
     /* 65993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit),
     /* 65996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66000 */     // (fpround:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D64_MM:{ *:[f32] } FGR64Opnd:{ *:[f64] }:$src)
     /* 66000 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D64_MM),
     /* 66005 */     GIR_RootConstrainSelectedInstOperands,
     /* 66006 */     // GIR_Coverage, 2257,
     /* 66006 */     GIR_Done,
     /* 66007 */   // Label 1606: @66007
     /* 66007 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(66026), // Rule ID 2259 //
     /* 66012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotFP64bit),
     /* 66015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66019 */     // (fpround:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)  =>  (CVT_S_D32_MM:{ *:[f32] } AFGR64Opnd:{ *:[f64] }:$src)
     /* 66019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CVT_S_D32_MM),
     /* 66024 */     GIR_RootConstrainSelectedInstOperands,
     /* 66025 */     // GIR_Coverage, 2259,
     /* 66025 */     GIR_Done,
     /* 66026 */   // Label 1607: @66026
     /* 66026 */   GIM_Reject,
     /* 66027 */ // Label 1603: @66027
     /* 66027 */ GIM_Reject,
     /* 66028 */ // Label 1600: @66028
     /* 66028 */ GIM_Reject,
     /* 66029 */ // Label 56: @66029
     /* 66029 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1610*/ GIMT_Encode4(66106),
     /* 66040 */ /*GILLT_v2s64*//*Label 1608*/ GIMT_Encode4(66052), GIMT_Encode4(0),
     /* 66048 */ /*GILLT_v4s32*//*Label 1609*/ GIMT_Encode4(66079),
     /* 66052 */ // Label 1608: @66052
     /* 66052 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(66078), // Rule ID 777 //
     /* 66057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66071 */   // (fp_to_sint:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTRUNC_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66071 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_S_D),
     /* 66076 */   GIR_RootConstrainSelectedInstOperands,
     /* 66077 */   // GIR_Coverage, 777,
     /* 66077 */   GIR_Done,
     /* 66078 */ // Label 1611: @66078
     /* 66078 */ GIM_Reject,
     /* 66079 */ // Label 1609: @66079
     /* 66079 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(66105), // Rule ID 776 //
     /* 66084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66098 */   // (fp_to_sint:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTRUNC_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_S_W),
     /* 66103 */   GIR_RootConstrainSelectedInstOperands,
     /* 66104 */   // GIR_Coverage, 776,
     /* 66104 */   GIR_Done,
     /* 66105 */ // Label 1612: @66105
     /* 66105 */ GIM_Reject,
     /* 66106 */ // Label 1610: @66106
     /* 66106 */ GIM_Reject,
     /* 66107 */ // Label 57: @66107
     /* 66107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1615*/ GIMT_Encode4(66184),
     /* 66118 */ /*GILLT_v2s64*//*Label 1613*/ GIMT_Encode4(66130), GIMT_Encode4(0),
     /* 66126 */ /*GILLT_v4s32*//*Label 1614*/ GIMT_Encode4(66157),
     /* 66130 */ // Label 1613: @66130
     /* 66130 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(66156), // Rule ID 779 //
     /* 66135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66149 */   // (fp_to_uint:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FTRUNC_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66149 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_U_D),
     /* 66154 */   GIR_RootConstrainSelectedInstOperands,
     /* 66155 */   // GIR_Coverage, 779,
     /* 66155 */   GIR_Done,
     /* 66156 */ // Label 1616: @66156
     /* 66156 */ GIM_Reject,
     /* 66157 */ // Label 1614: @66157
     /* 66157 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(66183), // Rule ID 778 //
     /* 66162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66176 */   // (fp_to_uint:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FTRUNC_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FTRUNC_U_W),
     /* 66181 */   GIR_RootConstrainSelectedInstOperands,
     /* 66182 */   // GIR_Coverage, 778,
     /* 66182 */   GIR_Done,
     /* 66183 */ // Label 1617: @66183
     /* 66183 */ GIM_Reject,
     /* 66184 */ // Label 1615: @66184
     /* 66184 */ GIM_Reject,
     /* 66185 */ // Label 58: @66185
     /* 66185 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1622*/ GIMT_Encode4(66437),
     /* 66196 */ /*GILLT_s32*//*Label 1618*/ GIMT_Encode4(66220),
     /* 66200 */ /*GILLT_s64*//*Label 1619*/ GIMT_Encode4(66304), GIMT_Encode4(0),
     /* 66208 */ /*GILLT_v2s64*//*Label 1620*/ GIMT_Encode4(66383), GIMT_Encode4(0),
     /* 66216 */ /*GILLT_v4s32*//*Label 1621*/ GIMT_Encode4(66410),
     /* 66220 */ // Label 1618: @66220
     /* 66220 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(66243), // Rule ID 1443 //
     /* 66225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66236 */   // (sint_to_fp:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_S_W:{ *:[f32] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_S_W),
     /* 66241 */   GIR_RootConstrainSelectedInstOperands,
     /* 66242 */   // GIR_Coverage, 1443,
     /* 66242 */   GIR_Done,
     /* 66243 */ // Label 1623: @66243
     /* 66243 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(66303), // Rule ID 1453 //
     /* 66248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 66262 */   // (sint_to_fp:{ *:[f32] } GPR64Opnd:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[f32] } (PseudoCVT_S_L:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src), sub_lo:{ *:[i32] })
     /* 66262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 66265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_S_L),
     /* 66269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 66274 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 66278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 66280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 66283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 66285 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(Mips::sub_lo),
     /* 66292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66302 */   // GIR_Coverage, 1453,
     /* 66302 */   GIR_EraseRootFromParent_Done,
     /* 66303 */ // Label 1624: @66303
     /* 66303 */ GIM_Reject,
     /* 66304 */ // Label 1619: @66304
     /* 66304 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(66330), // Rule ID 1446 //
     /* 66309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_NotFP64bit),
     /* 66312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66323 */   // (sint_to_fp:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_D32_W:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D32_W),
     /* 66328 */   GIR_RootConstrainSelectedInstOperands,
     /* 66329 */   // GIR_Coverage, 1446,
     /* 66329 */   GIR_Done,
     /* 66330 */ // Label 1625: @66330
     /* 66330 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(66356), // Rule ID 1452 //
     /* 66335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 66349 */   // (sint_to_fp:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)  =>  (PseudoCVT_D64_W:{ *:[f64] } GPR32Opnd:{ *:[i32] }:$src)
     /* 66349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D64_W),
     /* 66354 */   GIR_RootConstrainSelectedInstOperands,
     /* 66355 */   // GIR_Coverage, 1452,
     /* 66355 */   GIR_Done,
     /* 66356 */ // Label 1626: @66356
     /* 66356 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(66382), // Rule ID 1454 //
     /* 66361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsFP64bit),
     /* 66364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 66375 */   // (sint_to_fp:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src)  =>  (PseudoCVT_D64_L:{ *:[f64] } GPR64Opnd:{ *:[i64] }:$src)
     /* 66375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PseudoCVT_D64_L),
     /* 66380 */   GIR_RootConstrainSelectedInstOperands,
     /* 66381 */   // GIR_Coverage, 1454,
     /* 66381 */   GIR_Done,
     /* 66382 */ // Label 1627: @66382
     /* 66382 */ GIM_Reject,
     /* 66383 */ // Label 1620: @66383
     /* 66383 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(66409), // Rule ID 709 //
     /* 66388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66402 */   // (sint_to_fp:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (FFINT_S_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 66402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_S_D),
     /* 66407 */   GIR_RootConstrainSelectedInstOperands,
     /* 66408 */   // GIR_Coverage, 709,
     /* 66408 */   GIR_Done,
     /* 66409 */ // Label 1628: @66409
     /* 66409 */ GIM_Reject,
     /* 66410 */ // Label 1621: @66410
     /* 66410 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(66436), // Rule ID 708 //
     /* 66415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66429 */   // (sint_to_fp:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFINT_S_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 66429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_S_W),
     /* 66434 */   GIR_RootConstrainSelectedInstOperands,
     /* 66435 */   // GIR_Coverage, 708,
     /* 66435 */   GIR_Done,
     /* 66436 */ // Label 1629: @66436
     /* 66436 */ GIM_Reject,
     /* 66437 */ // Label 1622: @66437
     /* 66437 */ GIM_Reject,
     /* 66438 */ // Label 59: @66438
     /* 66438 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1632*/ GIMT_Encode4(66515),
     /* 66449 */ /*GILLT_v2s64*//*Label 1630*/ GIMT_Encode4(66461), GIMT_Encode4(0),
     /* 66457 */ /*GILLT_v4s32*//*Label 1631*/ GIMT_Encode4(66488),
     /* 66461 */ // Label 1630: @66461
     /* 66461 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(66487), // Rule ID 711 //
     /* 66466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66480 */   // (uint_to_fp:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (FFINT_U_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 66480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_U_D),
     /* 66485 */   GIR_RootConstrainSelectedInstOperands,
     /* 66486 */   // GIR_Coverage, 711,
     /* 66486 */   GIR_Done,
     /* 66487 */ // Label 1633: @66487
     /* 66487 */ GIM_Reject,
     /* 66488 */ // Label 1631: @66488
     /* 66488 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(66514), // Rule ID 710 //
     /* 66493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66507 */   // (uint_to_fp:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (FFINT_U_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 66507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FFINT_U_W),
     /* 66512 */   GIR_RootConstrainSelectedInstOperands,
     /* 66513 */   // GIR_Coverage, 710,
     /* 66513 */   GIR_Done,
     /* 66514 */ // Label 1634: @66514
     /* 66514 */ GIM_Reject,
     /* 66515 */ // Label 1632: @66515
     /* 66515 */ GIM_Reject,
     /* 66516 */ // Label 60: @66516
     /* 66516 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1639*/ GIMT_Encode4(66755),
     /* 66527 */ /*GILLT_s32*//*Label 1635*/ GIMT_Encode4(66551),
     /* 66531 */ /*GILLT_s64*//*Label 1636*/ GIMT_Encode4(66599), GIMT_Encode4(0),
     /* 66539 */ /*GILLT_v2s64*//*Label 1637*/ GIMT_Encode4(66701), GIMT_Encode4(0),
     /* 66547 */ /*GILLT_v4s32*//*Label 1638*/ GIMT_Encode4(66728),
     /* 66551 */ // Label 1635: @66551
     /* 66551 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(66598),
     /* 66556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66567 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(66582), // Rule ID 126 //
     /* 66572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotInMicroMips_UseAbs),
     /* 66575 */     // (fabs:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FABS_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 66575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_S),
     /* 66580 */     GIR_RootConstrainSelectedInstOperands,
     /* 66581 */     // GIR_Coverage, 126,
     /* 66581 */     GIR_Done,
     /* 66582 */   // Label 1641: @66582
     /* 66582 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(66597), // Rule ID 1152 //
     /* 66587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_UseAbs),
     /* 66590 */     // (fabs:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FABS_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 66590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_S_MM),
     /* 66595 */     GIR_RootConstrainSelectedInstOperands,
     /* 66596 */     // GIR_Coverage, 1152,
     /* 66596 */     GIR_Done,
     /* 66597 */   // Label 1642: @66597
     /* 66597 */   GIM_Reject,
     /* 66598 */ // Label 1640: @66598
     /* 66598 */ GIM_Reject,
     /* 66599 */ // Label 1636: @66599
     /* 66599 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(66700),
     /* 66604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66607 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(66630), // Rule ID 127 //
     /* 66612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips_UseAbs),
     /* 66615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66623 */     // (fabs:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 66623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D32),
     /* 66628 */     GIR_RootConstrainSelectedInstOperands,
     /* 66629 */     // GIR_Coverage, 127,
     /* 66629 */     GIR_Done,
     /* 66630 */   // Label 1644: @66630
     /* 66630 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(66653), // Rule ID 128 //
     /* 66635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips_UseAbs),
     /* 66638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66646 */     // (fabs:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 66646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D64),
     /* 66651 */     GIR_RootConstrainSelectedInstOperands,
     /* 66652 */     // GIR_Coverage, 128,
     /* 66652 */     GIR_Done,
     /* 66653 */   // Label 1645: @66653
     /* 66653 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(66676), // Rule ID 1150 //
     /* 66658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 66661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 66669 */     // (fabs:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 66669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D32_MM),
     /* 66674 */     GIR_RootConstrainSelectedInstOperands,
     /* 66675 */     // GIR_Coverage, 1150,
     /* 66675 */     GIR_Done,
     /* 66676 */   // Label 1646: @66676
     /* 66676 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(66699), // Rule ID 1151 //
     /* 66681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 66684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66692 */     // (fabs:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FABS_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 66692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D64_MM),
     /* 66697 */     GIR_RootConstrainSelectedInstOperands,
     /* 66698 */     // GIR_Coverage, 1151,
     /* 66698 */     GIR_Done,
     /* 66699 */   // Label 1647: @66699
     /* 66699 */   GIM_Reject,
     /* 66700 */ // Label 1643: @66700
     /* 66700 */ GIM_Reject,
     /* 66701 */ // Label 1637: @66701
     /* 66701 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(66727), // Rule ID 1043 //
     /* 66706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 66712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 66720 */   // (fabs:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FABS_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 66720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_D),
     /* 66725 */   GIR_RootConstrainSelectedInstOperands,
     /* 66726 */   // GIR_Coverage, 1043,
     /* 66726 */   GIR_Done,
     /* 66727 */ // Label 1648: @66727
     /* 66727 */ GIM_Reject,
     /* 66728 */ // Label 1638: @66728
     /* 66728 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(66754), // Rule ID 1042 //
     /* 66733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 66736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 66739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 66747 */   // (fabs:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FABS_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 66747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FABS_W),
     /* 66752 */   GIR_RootConstrainSelectedInstOperands,
     /* 66753 */   // GIR_Coverage, 1042,
     /* 66753 */   GIR_Done,
     /* 66754 */ // Label 1649: @66754
     /* 66754 */ GIM_Reject,
     /* 66755 */ // Label 1639: @66755
     /* 66755 */ GIM_Reject,
     /* 66756 */ // Label 61: @66756
     /* 66756 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1652*/ GIMT_Encode4(66829),
     /* 66767 */ /*GILLT_s32*//*Label 1650*/ GIMT_Encode4(66775),
     /* 66771 */ /*GILLT_s64*//*Label 1651*/ GIMT_Encode4(66802),
     /* 66775 */ // Label 1650: @66775
     /* 66775 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(66801), // Rule ID 1790 //
     /* 66780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66790 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$src)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$src, f32:{ *:[f32] }:$src)
     /* 66790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 66793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 66795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66797 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66799 */   GIR_RootConstrainSelectedInstOperands,
     /* 66800 */   // GIR_Coverage, 1790,
     /* 66800 */   GIR_EraseRootFromParent_Done,
     /* 66801 */ // Label 1653: @66801
     /* 66801 */ GIM_Reject,
     /* 66802 */ // Label 1651: @66802
     /* 66802 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(66828), // Rule ID 1791 //
     /* 66807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66817 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$src)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$src, f64:{ *:[f64] }:$src)
     /* 66817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 66820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[fd]
     /* 66822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66824 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 66826 */   GIR_RootConstrainSelectedInstOperands,
     /* 66827 */   // GIR_Coverage, 1791,
     /* 66827 */   GIR_EraseRootFromParent_Done,
     /* 66828 */ // Label 1654: @66828
     /* 66828 */ GIM_Reject,
     /* 66829 */ // Label 1652: @66829
     /* 66829 */ GIM_Reject,
     /* 66830 */ // Label 62: @66830
     /* 66830 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1657*/ GIMT_Encode4(66901),
     /* 66841 */ /*GILLT_s32*//*Label 1655*/ GIMT_Encode4(66849),
     /* 66845 */ /*GILLT_s64*//*Label 1656*/ GIMT_Encode4(66875),
     /* 66849 */ // Label 1655: @66849
     /* 66849 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(66874), // Rule ID 1788 //
     /* 66854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 66863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66867 */   // (fminnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MIN_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 66867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S),
     /* 66872 */   GIR_RootConstrainSelectedInstOperands,
     /* 66873 */   // GIR_Coverage, 1788,
     /* 66873 */   GIR_Done,
     /* 66874 */ // Label 1658: @66874
     /* 66874 */ GIM_Reject,
     /* 66875 */ // Label 1656: @66875
     /* 66875 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(66900), // Rule ID 1789 //
     /* 66880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 66889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66893 */   // (fminnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MIN_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 66893 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_D),
     /* 66898 */   GIR_RootConstrainSelectedInstOperands,
     /* 66899 */   // GIR_Coverage, 1789,
     /* 66899 */   GIR_Done,
     /* 66900 */ // Label 1659: @66900
     /* 66900 */ GIM_Reject,
     /* 66901 */ // Label 1657: @66901
     /* 66901 */ GIM_Reject,
     /* 66902 */ // Label 63: @66902
     /* 66902 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1662*/ GIMT_Encode4(66973),
     /* 66913 */ /*GILLT_s32*//*Label 1660*/ GIMT_Encode4(66921),
     /* 66917 */ /*GILLT_s64*//*Label 1661*/ GIMT_Encode4(66947),
     /* 66921 */ // Label 1660: @66921
     /* 66921 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(66946), // Rule ID 1786 //
     /* 66926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 66932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 66935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 66939 */   // (fmaxnum_ieee:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)  =>  (MAX_S:{ *:[f32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
     /* 66939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S),
     /* 66944 */   GIR_RootConstrainSelectedInstOperands,
     /* 66945 */   // GIR_Coverage, 1786,
     /* 66945 */   GIR_Done,
     /* 66946 */ // Label 1663: @66946
     /* 66946 */ GIM_Reject,
     /* 66947 */ // Label 1661: @66947
     /* 66947 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(66972), // Rule ID 1787 //
     /* 66952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc_NotInMicroMips),
     /* 66955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 66958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 66961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 66965 */   // (fmaxnum_ieee:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)  =>  (MAX_D:{ *:[f64] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
     /* 66965 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_D),
     /* 66970 */   GIR_RootConstrainSelectedInstOperands,
     /* 66971 */   // GIR_Coverage, 1787,
     /* 66971 */   GIR_Done,
     /* 66972 */ // Label 1664: @66972
     /* 66972 */ GIM_Reject,
     /* 66973 */ // Label 1662: @66973
     /* 66973 */ GIM_Reject,
     /* 66974 */ // Label 64: @66974
     /* 66974 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1669*/ GIMT_Encode4(67141),
     /* 66985 */ /*GILLT_v2s64*//*Label 1665*/ GIMT_Encode4(67005), GIMT_Encode4(0),
     /* 66993 */ /*GILLT_v4s32*//*Label 1666*/ GIMT_Encode4(67039),
     /* 66997 */ /*GILLT_v8s16*//*Label 1667*/ GIMT_Encode4(67073),
     /* 67001 */ /*GILLT_v16s8*//*Label 1668*/ GIMT_Encode4(67107),
     /* 67005 */ // Label 1665: @67005
     /* 67005 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(67038), // Rule ID 871 //
     /* 67010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67031 */   // (smin:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_D),
     /* 67036 */   GIR_RootConstrainSelectedInstOperands,
     /* 67037 */   // GIR_Coverage, 871,
     /* 67037 */   GIR_Done,
     /* 67038 */ // Label 1670: @67038
     /* 67038 */ GIM_Reject,
     /* 67039 */ // Label 1666: @67039
     /* 67039 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(67072), // Rule ID 870 //
     /* 67044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67065 */   // (smin:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67065 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_W),
     /* 67070 */   GIR_RootConstrainSelectedInstOperands,
     /* 67071 */   // GIR_Coverage, 870,
     /* 67071 */   GIR_Done,
     /* 67072 */ // Label 1671: @67072
     /* 67072 */ GIM_Reject,
     /* 67073 */ // Label 1667: @67073
     /* 67073 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(67106), // Rule ID 869 //
     /* 67078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67099 */   // (smin:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_H),
     /* 67104 */   GIR_RootConstrainSelectedInstOperands,
     /* 67105 */   // GIR_Coverage, 869,
     /* 67105 */   GIR_Done,
     /* 67106 */ // Label 1672: @67106
     /* 67106 */ GIM_Reject,
     /* 67107 */ // Label 1668: @67107
     /* 67107 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(67140), // Rule ID 868 //
     /* 67112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67133 */   // (smin:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_S_B),
     /* 67138 */   GIR_RootConstrainSelectedInstOperands,
     /* 67139 */   // GIR_Coverage, 868,
     /* 67139 */   GIR_Done,
     /* 67140 */ // Label 1673: @67140
     /* 67140 */ GIM_Reject,
     /* 67141 */ // Label 1669: @67141
     /* 67141 */ GIM_Reject,
     /* 67142 */ // Label 65: @67142
     /* 67142 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1678*/ GIMT_Encode4(67309),
     /* 67153 */ /*GILLT_v2s64*//*Label 1674*/ GIMT_Encode4(67173), GIMT_Encode4(0),
     /* 67161 */ /*GILLT_v4s32*//*Label 1675*/ GIMT_Encode4(67207),
     /* 67165 */ /*GILLT_v8s16*//*Label 1676*/ GIMT_Encode4(67241),
     /* 67169 */ /*GILLT_v16s8*//*Label 1677*/ GIMT_Encode4(67275),
     /* 67173 */ // Label 1674: @67173
     /* 67173 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(67206), // Rule ID 851 //
     /* 67178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67199 */   // (smax:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_S_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_D),
     /* 67204 */   GIR_RootConstrainSelectedInstOperands,
     /* 67205 */   // GIR_Coverage, 851,
     /* 67205 */   GIR_Done,
     /* 67206 */ // Label 1679: @67206
     /* 67206 */ GIM_Reject,
     /* 67207 */ // Label 1675: @67207
     /* 67207 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(67240), // Rule ID 850 //
     /* 67212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67233 */   // (smax:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_S_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_W),
     /* 67238 */   GIR_RootConstrainSelectedInstOperands,
     /* 67239 */   // GIR_Coverage, 850,
     /* 67239 */   GIR_Done,
     /* 67240 */ // Label 1680: @67240
     /* 67240 */ GIM_Reject,
     /* 67241 */ // Label 1676: @67241
     /* 67241 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(67274), // Rule ID 849 //
     /* 67246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67267 */   // (smax:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_S_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67267 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_H),
     /* 67272 */   GIR_RootConstrainSelectedInstOperands,
     /* 67273 */   // GIR_Coverage, 849,
     /* 67273 */   GIR_Done,
     /* 67274 */ // Label 1681: @67274
     /* 67274 */ GIM_Reject,
     /* 67275 */ // Label 1677: @67275
     /* 67275 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(67308), // Rule ID 848 //
     /* 67280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67301 */   // (smax:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_S_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_S_B),
     /* 67306 */   GIR_RootConstrainSelectedInstOperands,
     /* 67307 */   // GIR_Coverage, 848,
     /* 67307 */   GIR_Done,
     /* 67308 */ // Label 1682: @67308
     /* 67308 */ GIM_Reject,
     /* 67309 */ // Label 1678: @67309
     /* 67309 */ GIM_Reject,
     /* 67310 */ // Label 66: @67310
     /* 67310 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1687*/ GIMT_Encode4(67477),
     /* 67321 */ /*GILLT_v2s64*//*Label 1683*/ GIMT_Encode4(67341), GIMT_Encode4(0),
     /* 67329 */ /*GILLT_v4s32*//*Label 1684*/ GIMT_Encode4(67375),
     /* 67333 */ /*GILLT_v8s16*//*Label 1685*/ GIMT_Encode4(67409),
     /* 67337 */ /*GILLT_v16s8*//*Label 1686*/ GIMT_Encode4(67443),
     /* 67341 */ // Label 1683: @67341
     /* 67341 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(67374), // Rule ID 875 //
     /* 67346 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67367 */   // (umin:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MIN_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_D),
     /* 67372 */   GIR_RootConstrainSelectedInstOperands,
     /* 67373 */   // GIR_Coverage, 875,
     /* 67373 */   GIR_Done,
     /* 67374 */ // Label 1688: @67374
     /* 67374 */ GIM_Reject,
     /* 67375 */ // Label 1684: @67375
     /* 67375 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(67408), // Rule ID 874 //
     /* 67380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67401 */   // (umin:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MIN_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_W),
     /* 67406 */   GIR_RootConstrainSelectedInstOperands,
     /* 67407 */   // GIR_Coverage, 874,
     /* 67407 */   GIR_Done,
     /* 67408 */ // Label 1689: @67408
     /* 67408 */ GIM_Reject,
     /* 67409 */ // Label 1685: @67409
     /* 67409 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(67442), // Rule ID 873 //
     /* 67414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67435 */   // (umin:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MIN_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_H),
     /* 67440 */   GIR_RootConstrainSelectedInstOperands,
     /* 67441 */   // GIR_Coverage, 873,
     /* 67441 */   GIR_Done,
     /* 67442 */ // Label 1690: @67442
     /* 67442 */ GIM_Reject,
     /* 67443 */ // Label 1686: @67443
     /* 67443 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(67476), // Rule ID 872 //
     /* 67448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67469 */   // (umin:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MIN_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MIN_U_B),
     /* 67474 */   GIR_RootConstrainSelectedInstOperands,
     /* 67475 */   // GIR_Coverage, 872,
     /* 67475 */   GIR_Done,
     /* 67476 */ // Label 1691: @67476
     /* 67476 */ GIM_Reject,
     /* 67477 */ // Label 1687: @67477
     /* 67477 */ GIM_Reject,
     /* 67478 */ // Label 67: @67478
     /* 67478 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1696*/ GIMT_Encode4(67645),
     /* 67489 */ /*GILLT_v2s64*//*Label 1692*/ GIMT_Encode4(67509), GIMT_Encode4(0),
     /* 67497 */ /*GILLT_v4s32*//*Label 1693*/ GIMT_Encode4(67543),
     /* 67501 */ /*GILLT_v8s16*//*Label 1694*/ GIMT_Encode4(67577),
     /* 67505 */ /*GILLT_v16s8*//*Label 1695*/ GIMT_Encode4(67611),
     /* 67509 */ // Label 1692: @67509
     /* 67509 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(67542), // Rule ID 855 //
     /* 67514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 67523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67535 */   // (umax:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)  =>  (MAX_U_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws, MSA128DOpnd:{ *:[v2i64] }:$wt)
     /* 67535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_D),
     /* 67540 */   GIR_RootConstrainSelectedInstOperands,
     /* 67541 */   // GIR_Coverage, 855,
     /* 67541 */   GIR_Done,
     /* 67542 */ // Label 1697: @67542
     /* 67542 */ GIM_Reject,
     /* 67543 */ // Label 1693: @67543
     /* 67543 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(67576), // Rule ID 854 //
     /* 67548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 67557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 67569 */   // (umax:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)  =>  (MAX_U_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws, MSA128WOpnd:{ *:[v4i32] }:$wt)
     /* 67569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_W),
     /* 67574 */   GIR_RootConstrainSelectedInstOperands,
     /* 67575 */   // GIR_Coverage, 854,
     /* 67575 */   GIR_Done,
     /* 67576 */ // Label 1698: @67576
     /* 67576 */ GIM_Reject,
     /* 67577 */ // Label 1694: @67577
     /* 67577 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(67610), // Rule ID 853 //
     /* 67582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 67588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 67591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 67603 */   // (umax:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)  =>  (MAX_U_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws, MSA128HOpnd:{ *:[v8i16] }:$wt)
     /* 67603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_H),
     /* 67608 */   GIR_RootConstrainSelectedInstOperands,
     /* 67609 */   // GIR_Coverage, 853,
     /* 67609 */   GIR_Done,
     /* 67610 */ // Label 1699: @67610
     /* 67610 */ GIM_Reject,
     /* 67611 */ // Label 1695: @67611
     /* 67611 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(67644), // Rule ID 852 //
     /* 67616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 67622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 67625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 67637 */   // (umax:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)  =>  (MAX_U_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws, MSA128BOpnd:{ *:[v16i8] }:$wt)
     /* 67637 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::MAX_U_B),
     /* 67642 */   GIR_RootConstrainSelectedInstOperands,
     /* 67643 */   // GIR_Coverage, 852,
     /* 67643 */   GIR_Done,
     /* 67644 */ // Label 1700: @67644
     /* 67644 */ GIM_Reject,
     /* 67645 */ // Label 1696: @67645
     /* 67645 */ GIM_Reject,
     /* 67646 */ // Label 68: @67646
     /* 67646 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(67769),
     /* 67651 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 67654 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(67675), // Rule ID 91 //
     /* 67659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips_RelocNotPIC),
     /* 67662 */     // (br (bb:{ *:[Other] }):$target)  =>  (J (bb:{ *:[Other] }):$target)
     /* 67662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::J),
     /* 67667 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67673 */     GIR_RootConstrainSelectedInstOperands,
     /* 67674 */     // GIR_Coverage, 91,
     /* 67674 */     GIR_Done,
     /* 67675 */   // Label 1702: @67675
     /* 67675 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(67696), // Rule ID 98 //
     /* 67680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 67683 */     // (br (bb:{ *:[Other] }):$offset)  =>  (B (bb:{ *:[Other] }):$offset)
     /* 67683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::B),
     /* 67688 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67694 */     GIR_RootConstrainSelectedInstOperands,
     /* 67695 */     // GIR_Coverage, 98,
     /* 67695 */     GIR_Done,
     /* 67696 */   // Label 1703: @67696
     /* 67696 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(67717), // Rule ID 1104 //
     /* 67701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6_RelocNotPIC),
     /* 67704 */     // (br (bb:{ *:[Other] }):$target)  =>  (J_MM (bb:{ *:[Other] }):$target)
     /* 67704 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::J_MM),
     /* 67709 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67715 */     GIR_RootConstrainSelectedInstOperands,
     /* 67716 */     // GIR_Coverage, 1104,
     /* 67716 */     GIR_Done,
     /* 67717 */   // Label 1704: @67717
     /* 67717 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(67738), // Rule ID 1113 //
     /* 67722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_NotMips32r6_RelocPIC),
     /* 67725 */     // (br (bb:{ *:[Other] }):$offset)  =>  (B_MM (bb:{ *:[Other] }):$offset)
     /* 67725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::B_MM),
     /* 67730 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(Mips::AT), GIMT_Encode2(RegState::Dead),
     /* 67736 */     GIR_RootConstrainSelectedInstOperands,
     /* 67737 */     // GIR_Coverage, 1113,
     /* 67737 */     GIR_Done,
     /* 67738 */   // Label 1705: @67738
     /* 67738 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(67753), // Rule ID 1171 //
     /* 67743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_InMicroMips),
     /* 67746 */     // (br (bb:{ *:[Other] }):$offset)  =>  (BC_MMR6 (bb:{ *:[Other] }):$offset)
     /* 67746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::BC_MMR6),
     /* 67751 */     GIR_RootConstrainSelectedInstOperands,
     /* 67752 */     // GIR_Coverage, 1171,
     /* 67752 */     GIR_Done,
     /* 67753 */   // Label 1706: @67753
     /* 67753 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(67768), // Rule ID 1863 //
     /* 67758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 67761 */     // (br (bb:{ *:[Other] }):$imm16)  =>  (Bimm16 (bb:{ *:[Other] }):$imm16)
     /* 67761 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::Bimm16),
     /* 67766 */     GIR_RootConstrainSelectedInstOperands,
     /* 67767 */     // GIR_Coverage, 1863,
     /* 67767 */     GIR_Done,
     /* 67768 */   // Label 1707: @67768
     /* 67768 */   GIM_Reject,
     /* 67769 */ // Label 1701: @67769
     /* 67769 */ GIM_Reject,
     /* 67770 */ // Label 69: @67770
     /* 67770 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(9), /*)*//*default:*//*Label 1712*/ GIMT_Encode4(68333),
     /* 67781 */ /*GILLT_v2s64*//*Label 1708*/ GIMT_Encode4(67801), GIMT_Encode4(0),
     /* 67789 */ /*GILLT_v4s32*//*Label 1709*/ GIMT_Encode4(67974),
     /* 67793 */ /*GILLT_v8s16*//*Label 1710*/ GIMT_Encode4(68147),
     /* 67797 */ /*GILLT_v16s8*//*Label 1711*/ GIMT_Encode4(68240),
     /* 67801 */ // Label 1708: @67801
     /* 67801 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(67973),
     /* 67806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 67809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 67812 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(67852), // Rule ID 821 //
     /* 67817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 67823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 67839 */     // (vector_insert:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_D_VIDX_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR64Opnd:{ *:[i64] }:$fs)
     /* 67839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_D_VIDX_PSEUDO),
     /* 67842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67844 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67846 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 67848 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 67850 */     GIR_RootConstrainSelectedInstOperands,
     /* 67851 */     // GIR_Coverage, 821,
     /* 67851 */     GIR_EraseRootFromParent_Done,
     /* 67852 */   // Label 1714: @67852
     /* 67852 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(67892), // Rule ID 823 //
     /* 67857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 67863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 67875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 67879 */     // (vector_insert:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, FGR64Opnd:{ *:[f64] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_FD_VIDX_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, FGR64Opnd:{ *:[f64] }:$fs)
     /* 67879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FD_VIDX_PSEUDO),
     /* 67882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67884 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67886 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 67888 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 67890 */     GIR_RootConstrainSelectedInstOperands,
     /* 67891 */     // GIR_Coverage, 823,
     /* 67891 */     GIR_EraseRootFromParent_Done,
     /* 67892 */   // Label 1715: @67892
     /* 67892 */   GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(67932), // Rule ID 827 //
     /* 67897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 67903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67907 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67919 */     // (vector_insert:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_D_VIDX64_PSEUDO:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR64Opnd:{ *:[i64] }:$fs)
     /* 67919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_D_VIDX64_PSEUDO),
     /* 67922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67924 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67926 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 67928 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 67930 */     GIR_RootConstrainSelectedInstOperands,
     /* 67931 */     // GIR_Coverage, 827,
     /* 67931 */     GIR_EraseRootFromParent_Done,
     /* 67932 */   // Label 1716: @67932
     /* 67932 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(67972), // Rule ID 829 //
     /* 67937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 67943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 67951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 67955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 67959 */     // (vector_insert:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, FGR64Opnd:{ *:[f64] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_FD_VIDX64_PSEUDO:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, FGR64Opnd:{ *:[f64] }:$fs)
     /* 67959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FD_VIDX64_PSEUDO),
     /* 67962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 67964 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 67966 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 67968 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 67970 */     GIR_RootConstrainSelectedInstOperands,
     /* 67971 */     // GIR_Coverage, 829,
     /* 67971 */     GIR_EraseRootFromParent_Done,
     /* 67972 */   // Label 1717: @67972
     /* 67972 */   GIM_Reject,
     /* 67973 */ // Label 1713: @67973
     /* 67973 */ GIM_Reject,
     /* 67974 */ // Label 1709: @67974
     /* 67974 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(68146),
     /* 67979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 67982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 67985 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(68025), // Rule ID 820 //
     /* 67990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 67993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 67996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68012 */     // (vector_insert:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_W_VIDX_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_W_VIDX_PSEUDO),
     /* 68015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68017 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68019 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68021 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68023 */     GIR_RootConstrainSelectedInstOperands,
     /* 68024 */     // GIR_Coverage, 820,
     /* 68024 */     GIR_EraseRootFromParent_Done,
     /* 68025 */   // Label 1719: @68025
     /* 68025 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(68065), // Rule ID 822 //
     /* 68030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 68048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68052 */     // (vector_insert:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, FGR32Opnd:{ *:[f32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_FW_VIDX_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, FGR32Opnd:{ *:[f32] }:$fs)
     /* 68052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FW_VIDX_PSEUDO),
     /* 68055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68057 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68059 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68061 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68063 */     GIR_RootConstrainSelectedInstOperands,
     /* 68064 */     // GIR_Coverage, 822,
     /* 68064 */     GIR_EraseRootFromParent_Done,
     /* 68065 */   // Label 1720: @68065
     /* 68065 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(68105), // Rule ID 826 //
     /* 68070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68092 */     // (vector_insert:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_W_VIDX64_PSEUDO:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_W_VIDX64_PSEUDO),
     /* 68095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68097 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68099 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68101 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68103 */     GIR_RootConstrainSelectedInstOperands,
     /* 68104 */     // GIR_Coverage, 826,
     /* 68104 */     GIR_EraseRootFromParent_Done,
     /* 68105 */   // Label 1721: @68105
     /* 68105 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(68145), // Rule ID 828 //
     /* 68110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 68128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68132 */     // (vector_insert:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, FGR32Opnd:{ *:[f32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_FW_VIDX64_PSEUDO:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, FGR32Opnd:{ *:[f32] }:$fs)
     /* 68132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_FW_VIDX64_PSEUDO),
     /* 68135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68137 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68139 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68141 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68143 */     GIR_RootConstrainSelectedInstOperands,
     /* 68144 */     // GIR_Coverage, 828,
     /* 68144 */     GIR_EraseRootFromParent_Done,
     /* 68145 */   // Label 1722: @68145
     /* 68145 */   GIM_Reject,
     /* 68146 */ // Label 1718: @68146
     /* 68146 */ GIM_Reject,
     /* 68147 */ // Label 1710: @68147
     /* 68147 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(68239),
     /* 68152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 68155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68158 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(68198), // Rule ID 819 //
     /* 68163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68185 */     // (vector_insert:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_H_VIDX_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_H_VIDX_PSEUDO),
     /* 68188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68190 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68192 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68194 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68196 */     GIR_RootConstrainSelectedInstOperands,
     /* 68197 */     // GIR_Coverage, 819,
     /* 68197 */     GIR_EraseRootFromParent_Done,
     /* 68198 */   // Label 1724: @68198
     /* 68198 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(68238), // Rule ID 825 //
     /* 68203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68225 */     // (vector_insert:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_H_VIDX64_PSEUDO:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_H_VIDX64_PSEUDO),
     /* 68228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68230 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68232 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68234 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68236 */     GIR_RootConstrainSelectedInstOperands,
     /* 68237 */     // GIR_Coverage, 825,
     /* 68237 */     GIR_EraseRootFromParent_Done,
     /* 68238 */   // Label 1725: @68238
     /* 68238 */   GIM_Reject,
     /* 68239 */ // Label 1723: @68239
     /* 68239 */ GIM_Reject,
     /* 68240 */ // Label 1711: @68240
     /* 68240 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(68332),
     /* 68245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 68248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68251 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(68291), // Rule ID 818 //
     /* 68256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 68262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68278 */     // (vector_insert:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR32Opnd:{ *:[i32] }:$n)  =>  (INSERT_B_VIDX_PSEUDO:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_B_VIDX_PSEUDO),
     /* 68281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68283 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68285 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68287 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68289 */     GIR_RootConstrainSelectedInstOperands,
     /* 68290 */     // GIR_Coverage, 818,
     /* 68290 */     GIR_EraseRootFromParent_Done,
     /* 68291 */   // Label 1727: @68291
     /* 68291 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(68331), // Rule ID 824 //
     /* 68296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 68302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68318 */     // (vector_insert:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR32Opnd:{ *:[i32] }:$fs, GPR64Opnd:{ *:[i64] }:$n)  =>  (INSERT_B_VIDX64_PSEUDO:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$wd_in, GPR64Opnd:{ *:[i64] }:$n, GPR32Opnd:{ *:[i32] }:$fs)
     /* 68318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::INSERT_B_VIDX64_PSEUDO),
     /* 68321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wd]
     /* 68323 */     GIR_RootToRootCopy, /*OpIdx*/1, // wd_in
     /* 68325 */     GIR_RootToRootCopy, /*OpIdx*/3, // n
     /* 68327 */     GIR_RootToRootCopy, /*OpIdx*/2, // fs
     /* 68329 */     GIR_RootConstrainSelectedInstOperands,
     /* 68330 */     // GIR_Coverage, 824,
     /* 68330 */     GIR_EraseRootFromParent_Done,
     /* 68331 */   // Label 1728: @68331
     /* 68331 */   GIM_Reject,
     /* 68332 */ // Label 1726: @68332
     /* 68332 */ GIM_Reject,
     /* 68333 */ // Label 1712: @68333
     /* 68333 */ GIM_Reject,
     /* 68334 */ // Label 70: @68334
     /* 68334 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(68385), // Rule ID 1990 //
     /* 68339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA),
     /* 68342 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 68345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 68351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68359 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 68363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 68367 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_immZExt4),
     /* 68371 */   // MIs[1] Operand 1
     /* 68371 */   // No operand predicates
     /* 68371 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68373 */   // (extractelt:{ *:[i32] } MSA128W:{ *:[v4i32] }:$ws, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$idx)  =>  (COPY_S_W:{ *:[i32] } MSA128W:{ *:[v4i32] }:$ws, (imm:{ *:[i32] })<<P:Predicate_immZExt4>>:$idx)
     /* 68373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::COPY_S_W),
     /* 68376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68378 */   GIR_RootToRootCopy, /*OpIdx*/1, // ws
     /* 68380 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 68383 */   GIR_RootConstrainSelectedInstOperands,
     /* 68384 */   // GIR_Coverage, 1990,
     /* 68384 */   GIR_EraseRootFromParent_Done,
     /* 68385 */ // Label 1729: @68385
     /* 68385 */ GIM_Reject,
     /* 68386 */ // Label 71: @68386
     /* 68386 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1736*/ GIMT_Encode4(68890),
     /* 68397 */ /*GILLT_s32*//*Label 1730*/ GIMT_Encode4(68429),
     /* 68401 */ /*GILLT_s64*//*Label 1731*/ GIMT_Encode4(68638), GIMT_Encode4(0),
     /* 68409 */ /*GILLT_v2s64*//*Label 1732*/ GIMT_Encode4(68782), GIMT_Encode4(0),
     /* 68417 */ /*GILLT_v4s32*//*Label 1733*/ GIMT_Encode4(68809),
     /* 68421 */ /*GILLT_v8s16*//*Label 1734*/ GIMT_Encode4(68836),
     /* 68425 */ /*GILLT_v16s8*//*Label 1735*/ GIMT_Encode4(68863),
     /* 68429 */ // Label 1730: @68429
     /* 68429 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(68637),
     /* 68434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68441 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(68487), // Rule ID 109 //
     /* 68446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 68449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68470 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68476 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO),
     /* 68479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68485 */     GIR_RootConstrainSelectedInstOperands,
     /* 68486 */     // GIR_Coverage, 109,
     /* 68486 */     GIR_EraseRootFromParent_Done,
     /* 68487 */   // Label 1738: @68487
     /* 68487 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(68533), // Rule ID 310 //
     /* 68492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc),
     /* 68495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68516 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68522 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO_R6),
     /* 68525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68531 */     GIR_RootConstrainSelectedInstOperands,
     /* 68532 */     // GIR_Coverage, 310,
     /* 68532 */     GIR_EraseRootFromParent_Done,
     /* 68533 */   // Label 1739: @68533
     /* 68533 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(68579), // Rule ID 1100 //
     /* 68538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 68541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 68553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 68557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68562 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68568 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs, -1:{ *:[i32] }))  =>  (CLO_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::CLO_MM),
     /* 68571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68577 */     GIR_RootConstrainSelectedInstOperands,
     /* 68578 */     // GIR_Coverage, 1100,
     /* 68578 */     GIR_EraseRootFromParent_Done,
     /* 68579 */   // Label 1740: @68579
     /* 68579 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(68598), // Rule ID 108 //
     /* 68584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32_HasStdEnc_NotInMicroMips_NotMips32r6_NotMips64r6),
     /* 68587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68591 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ),
     /* 68596 */     GIR_RootConstrainSelectedInstOperands,
     /* 68597 */     // GIR_Coverage, 108,
     /* 68597 */     GIR_Done,
     /* 68598 */   // Label 1741: @68598
     /* 68598 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(68617), // Rule ID 311 //
     /* 68603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r6_HasStdEnc),
     /* 68606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68610 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ_R6:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ_R6),
     /* 68615 */     GIR_RootConstrainSelectedInstOperands,
     /* 68616 */     // GIR_Coverage, 311,
     /* 68616 */     GIR_Done,
     /* 68617 */   // Label 1742: @68617
     /* 68617 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(68636), // Rule ID 1099 //
     /* 68622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 68625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68629 */     // (ctlz:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (CLZ_MM:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::CLZ_MM),
     /* 68634 */     GIR_RootConstrainSelectedInstOperands,
     /* 68635 */     // GIR_Coverage, 1099,
     /* 68635 */     GIR_Done,
     /* 68636 */   // Label 1743: @68636
     /* 68636 */   GIM_Reject,
     /* 68637 */ // Label 1737: @68637
     /* 68637 */ GIM_Reject,
     /* 68638 */ // Label 1731: @68638
     /* 68638 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(68781),
     /* 68643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68650 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(68696), // Rule ID 264 //
     /* 68655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6),
     /* 68658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 68670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 68674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68685 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, -1:{ *:[i64] }))  =>  (DCLO:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DCLO),
     /* 68688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68694 */     GIR_RootConstrainSelectedInstOperands,
     /* 68695 */     // GIR_Coverage, 264,
     /* 68695 */     GIR_EraseRootFromParent_Done,
     /* 68696 */   // Label 1745: @68696
     /* 68696 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(68742), // Rule ID 339 //
     /* 68701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 68704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 68708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 68712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 68716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 68720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68725 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 68729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 68731 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs, -1:{ *:[i64] }))  =>  (DCLO_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DCLO_R6),
     /* 68734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 68736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /* 68740 */     GIR_RootConstrainSelectedInstOperands,
     /* 68741 */     // GIR_Coverage, 339,
     /* 68741 */     GIR_EraseRootFromParent_Done,
     /* 68742 */   // Label 1746: @68742
     /* 68742 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(68761), // Rule ID 263 //
     /* 68747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64_HasStdEnc_IsGP64bit_NotInMicroMips_NotMips64r6),
     /* 68750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68754 */     // (ctlz:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DCLZ:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68754 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DCLZ),
     /* 68759 */     GIR_RootConstrainSelectedInstOperands,
     /* 68760 */     // GIR_Coverage, 263,
     /* 68760 */     GIR_Done,
     /* 68761 */   // Label 1747: @68761
     /* 68761 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(68780), // Rule ID 340 //
     /* 68766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r6_HasStdEnc_NotInMicroMips),
     /* 68769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68773 */     // (ctlz:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DCLZ_R6:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DCLZ_R6),
     /* 68778 */     GIR_RootConstrainSelectedInstOperands,
     /* 68779 */     // GIR_Coverage, 340,
     /* 68779 */     GIR_Done,
     /* 68780 */   // Label 1748: @68780
     /* 68780 */   GIM_Reject,
     /* 68781 */ // Label 1744: @68781
     /* 68781 */ GIM_Reject,
     /* 68782 */ // Label 1732: @68782
     /* 68782 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(68808), // Rule ID 915 //
     /* 68787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 68793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 68801 */   // (ctlz:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (NLZC_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 68801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_D),
     /* 68806 */   GIR_RootConstrainSelectedInstOperands,
     /* 68807 */   // GIR_Coverage, 915,
     /* 68807 */   GIR_Done,
     /* 68808 */ // Label 1749: @68808
     /* 68808 */ GIM_Reject,
     /* 68809 */ // Label 1733: @68809
     /* 68809 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(68835), // Rule ID 914 //
     /* 68814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 68820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 68828 */   // (ctlz:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (NLZC_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 68828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_W),
     /* 68833 */   GIR_RootConstrainSelectedInstOperands,
     /* 68834 */   // GIR_Coverage, 914,
     /* 68834 */   GIR_Done,
     /* 68835 */ // Label 1750: @68835
     /* 68835 */ GIM_Reject,
     /* 68836 */ // Label 1734: @68836
     /* 68836 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(68862), // Rule ID 913 //
     /* 68841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 68847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 68855 */   // (ctlz:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (NLZC_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 68855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_H),
     /* 68860 */   GIR_RootConstrainSelectedInstOperands,
     /* 68861 */   // GIR_Coverage, 913,
     /* 68861 */   GIR_Done,
     /* 68862 */ // Label 1751: @68862
     /* 68862 */ GIM_Reject,
     /* 68863 */ // Label 1735: @68863
     /* 68863 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(68889), // Rule ID 912 //
     /* 68868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 68874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 68882 */   // (ctlz:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (NLZC_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 68882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::NLZC_B),
     /* 68887 */   GIR_RootConstrainSelectedInstOperands,
     /* 68888 */   // GIR_Coverage, 912,
     /* 68888 */   GIR_Done,
     /* 68889 */ // Label 1752: @68889
     /* 68889 */ GIM_Reject,
     /* 68890 */ // Label 1736: @68890
     /* 68890 */ GIM_Reject,
     /* 68891 */ // Label 72: @68891
     /* 68891 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 1759*/ GIMT_Encode4(69096),
     /* 68902 */ /*GILLT_s32*//*Label 1753*/ GIMT_Encode4(68934),
     /* 68906 */ /*GILLT_s64*//*Label 1754*/ GIMT_Encode4(68961), GIMT_Encode4(0),
     /* 68914 */ /*GILLT_v2s64*//*Label 1755*/ GIMT_Encode4(68988), GIMT_Encode4(0),
     /* 68922 */ /*GILLT_v4s32*//*Label 1756*/ GIMT_Encode4(69015),
     /* 68926 */ /*GILLT_v8s16*//*Label 1757*/ GIMT_Encode4(69042),
     /* 68930 */ /*GILLT_v16s8*//*Label 1758*/ GIMT_Encode4(69069),
     /* 68934 */ // Label 1753: @68934
     /* 68934 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(68960), // Rule ID 278 //
     /* 68939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 68942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 68945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 68953 */   // (ctpop:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)  =>  (POP:{ *:[i32] } GPR32Opnd:{ *:[i32] }:$rs)
     /* 68953 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::POP),
     /* 68958 */   GIR_RootConstrainSelectedInstOperands,
     /* 68959 */   // GIR_Coverage, 278,
     /* 68959 */   GIR_Done,
     /* 68960 */ // Label 1760: @68960
     /* 68960 */ GIM_Reject,
     /* 68961 */ // Label 1754: @68961
     /* 68961 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(68987), // Rule ID 279 //
     /* 68966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCnMips),
     /* 68969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 68972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 68980 */   // (ctpop:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)  =>  (DPOP:{ *:[i64] } GPR64Opnd:{ *:[i64] }:$rs)
     /* 68980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::DPOP),
     /* 68985 */   GIR_RootConstrainSelectedInstOperands,
     /* 68986 */   // GIR_Coverage, 279,
     /* 68986 */   GIR_Done,
     /* 68987 */ // Label 1761: @68987
     /* 68987 */ GIM_Reject,
     /* 68988 */ // Label 1755: @68988
     /* 68988 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(69014), // Rule ID 937 //
     /* 68993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 68996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 68999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69007 */   // (ctpop:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)  =>  (PCNT_D:{ *:[v2i64] } MSA128DOpnd:{ *:[v2i64] }:$ws)
     /* 69007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_D),
     /* 69012 */   GIR_RootConstrainSelectedInstOperands,
     /* 69013 */   // GIR_Coverage, 937,
     /* 69013 */   GIR_Done,
     /* 69014 */ // Label 1762: @69014
     /* 69014 */ GIM_Reject,
     /* 69015 */ // Label 1756: @69015
     /* 69015 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(69041), // Rule ID 936 //
     /* 69020 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69034 */   // (ctpop:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)  =>  (PCNT_W:{ *:[v4i32] } MSA128WOpnd:{ *:[v4i32] }:$ws)
     /* 69034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_W),
     /* 69039 */   GIR_RootConstrainSelectedInstOperands,
     /* 69040 */   // GIR_Coverage, 936,
     /* 69040 */   GIR_Done,
     /* 69041 */ // Label 1763: @69041
     /* 69041 */ GIM_Reject,
     /* 69042 */ // Label 1757: @69042
     /* 69042 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(69068), // Rule ID 935 //
     /* 69047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 69053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128HRegClassID),
     /* 69061 */   // (ctpop:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)  =>  (PCNT_H:{ *:[v8i16] } MSA128HOpnd:{ *:[v8i16] }:$ws)
     /* 69061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_H),
     /* 69066 */   GIR_RootConstrainSelectedInstOperands,
     /* 69067 */   // GIR_Coverage, 935,
     /* 69067 */   GIR_Done,
     /* 69068 */ // Label 1764: @69068
     /* 69068 */ GIM_Reject,
     /* 69069 */ // Label 1758: @69069
     /* 69069 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(69095), // Rule ID 934 //
     /* 69074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 69080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128BRegClassID),
     /* 69088 */   // (ctpop:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)  =>  (PCNT_B:{ *:[v16i8] } MSA128BOpnd:{ *:[v16i8] }:$ws)
     /* 69088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::PCNT_B),
     /* 69093 */   GIR_RootConstrainSelectedInstOperands,
     /* 69094 */   // GIR_Coverage, 934,
     /* 69094 */   GIR_Done,
     /* 69095 */ // Label 1765: @69095
     /* 69095 */ GIM_Reject,
     /* 69096 */ // Label 1759: @69096
     /* 69096 */ GIM_Reject,
     /* 69097 */ // Label 73: @69097
     /* 69097 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1768*/ GIMT_Encode4(69260),
     /* 69108 */ /*GILLT_s32*//*Label 1766*/ GIMT_Encode4(69116),
     /* 69112 */ /*GILLT_s64*//*Label 1767*/ GIMT_Encode4(69212),
     /* 69116 */ // Label 1766: @69116
     /* 69116 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(69211),
     /* 69121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR32RegClassID),
     /* 69132 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(69171), // Rule ID 1427 //
     /* 69137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips32r2_HasStdEnc_NotInMicroMips),
     /* 69140 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$rt)  =>  (ROTR:{ *:[i32] } (WSBH:{ *:[i32] } GPR32:{ *:[i32] }:$rt), 16:{ *:[i32] })
     /* 69140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::WSBH),
     /* 69147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR),
     /* 69161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 69169 */     GIR_RootConstrainSelectedInstOperands,
     /* 69170 */     // GIR_Coverage, 1427,
     /* 69170 */     GIR_EraseRootFromParent_Done,
     /* 69171 */   // Label 1770: @69171
     /* 69171 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(69210), // Rule ID 2187 //
     /* 69176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 69179 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$rt)  =>  (ROTR_MM:{ *:[i32] } (WSBH_MM:{ *:[i32] } GPR32:{ *:[i32] }:$rt), 16:{ *:[i32] })
     /* 69179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 69182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::WSBH_MM),
     /* 69186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::ROTR_MM),
     /* 69200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 69208 */     GIR_RootConstrainSelectedInstOperands,
     /* 69209 */     // GIR_Coverage, 2187,
     /* 69209 */     GIR_EraseRootFromParent_Done,
     /* 69210 */   // Label 1771: @69210
     /* 69210 */   GIM_Reject,
     /* 69211 */ // Label 1769: @69211
     /* 69211 */ GIM_Reject,
     /* 69212 */ // Label 1767: @69212
     /* 69212 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(69259), // Rule ID 1589 //
     /* 69217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips64r2_HasStdEnc),
     /* 69220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::GPR64RegClassID),
     /* 69231 */   // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$rt)  =>  (DSHD:{ *:[i64] } (DSBH:{ *:[i64] } GPR64:{ *:[i64] }:$rt))
     /* 69231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 69234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(Mips::DSBH),
     /* 69238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 69243 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rt
     /* 69247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 69249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(Mips::DSHD),
     /* 69252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 69254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 69257 */   GIR_RootConstrainSelectedInstOperands,
     /* 69258 */   // GIR_Coverage, 1589,
     /* 69258 */   GIR_EraseRootFromParent_Done,
     /* 69259 */ // Label 1772: @69259
     /* 69259 */ GIM_Reject,
     /* 69260 */ // Label 1768: @69260
     /* 69260 */ GIM_Reject,
     /* 69261 */ // Label 74: @69261
     /* 69261 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(7), /*)*//*default:*//*Label 1777*/ GIMT_Encode4(69500),
     /* 69272 */ /*GILLT_s32*//*Label 1773*/ GIMT_Encode4(69296),
     /* 69276 */ /*GILLT_s64*//*Label 1774*/ GIMT_Encode4(69344), GIMT_Encode4(0),
     /* 69284 */ /*GILLT_v2s64*//*Label 1775*/ GIMT_Encode4(69446), GIMT_Encode4(0),
     /* 69292 */ /*GILLT_v4s32*//*Label 1776*/ GIMT_Encode4(69473),
     /* 69296 */ // Label 1773: @69296
     /* 69296 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(69343),
     /* 69301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 69304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 69308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR32RegClassID),
     /* 69312 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(69327), // Rule ID 132 //
     /* 69317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotInMicroMips),
     /* 69320 */     // (fsqrt:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FSQRT_S:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 69320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_S),
     /* 69325 */     GIR_RootConstrainSelectedInstOperands,
     /* 69326 */     // GIR_Coverage, 132,
     /* 69326 */     GIR_Done,
     /* 69327 */   // Label 1779: @69327
     /* 69327 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(69342), // Rule ID 1162 //
     /* 69332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat),
     /* 69335 */     // (fsqrt:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)  =>  (FSQRT_S_MM:{ *:[f32] } FGR32Opnd:{ *:[f32] }:$fs)
     /* 69335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_S_MM),
     /* 69340 */     GIR_RootConstrainSelectedInstOperands,
     /* 69341 */     // GIR_Coverage, 1162,
     /* 69341 */     GIR_Done,
     /* 69342 */   // Label 1780: @69342
     /* 69342 */   GIM_Reject,
     /* 69343 */ // Label 1778: @69343
     /* 69343 */ GIM_Reject,
     /* 69344 */ // Label 1774: @69344
     /* 69344 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(69445),
     /* 69349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 69352 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(69375), // Rule ID 133 //
     /* 69357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsNotSoftFloat_NotFP64bit_NotInMicroMips),
     /* 69360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69368 */     // (fsqrt:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D32:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 69368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D32),
     /* 69373 */     GIR_RootConstrainSelectedInstOperands,
     /* 69374 */     // GIR_Coverage, 133,
     /* 69374 */     GIR_Done,
     /* 69375 */   // Label 1782: @69375
     /* 69375 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(69398), // Rule ID 134 //
     /* 69380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMips2_HasStdEnc_IsFP64bit_IsNotSoftFloat_NotInMicroMips),
     /* 69383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69391 */     // (fsqrt:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D64:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 69391 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D64),
     /* 69396 */     GIR_RootConstrainSelectedInstOperands,
     /* 69397 */     // GIR_Coverage, 134,
     /* 69397 */     GIR_Done,
     /* 69398 */   // Label 1783: @69398
     /* 69398 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(69421), // Rule ID 1148 //
     /* 69403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsNotSoftFloat_NotFP64bit),
     /* 69406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::AFGR64RegClassID),
     /* 69414 */     // (fsqrt:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D32_MM:{ *:[f64] } AFGR64Opnd:{ *:[f64] }:$fs)
     /* 69414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D32_MM),
     /* 69419 */     GIR_RootConstrainSelectedInstOperands,
     /* 69420 */     // GIR_Coverage, 1148,
     /* 69420 */     GIR_Done,
     /* 69421 */   // Label 1784: @69421
     /* 69421 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(69444), // Rule ID 1149 //
     /* 69426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips_IsFP64bit_IsNotSoftFloat),
     /* 69429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::FGR64RegClassID),
     /* 69437 */     // (fsqrt:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)  =>  (FSQRT_D64_MM:{ *:[f64] } FGR64Opnd:{ *:[f64] }:$fs)
     /* 69437 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D64_MM),
     /* 69442 */     GIR_RootConstrainSelectedInstOperands,
     /* 69443 */     // GIR_Coverage, 1149,
     /* 69443 */     GIR_Done,
     /* 69444 */   // Label 1785: @69444
     /* 69444 */   GIM_Reject,
     /* 69445 */ // Label 1781: @69445
     /* 69445 */ GIM_Reject,
     /* 69446 */ // Label 1775: @69446
     /* 69446 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(69472), // Rule ID 757 //
     /* 69451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69465 */   // (fsqrt:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FSQRT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 69465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_D),
     /* 69470 */   GIR_RootConstrainSelectedInstOperands,
     /* 69471 */   // GIR_Coverage, 757,
     /* 69471 */   GIR_Done,
     /* 69472 */ // Label 1786: @69472
     /* 69472 */ GIM_Reject,
     /* 69473 */ // Label 1776: @69473
     /* 69473 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(69499), // Rule ID 756 //
     /* 69478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69492 */   // (fsqrt:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FSQRT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 69492 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FSQRT_W),
     /* 69497 */   GIR_RootConstrainSelectedInstOperands,
     /* 69498 */   // GIR_Coverage, 756,
     /* 69498 */   GIR_Done,
     /* 69499 */ // Label 1787: @69499
     /* 69499 */ GIM_Reject,
     /* 69500 */ // Label 1777: @69500
     /* 69500 */ GIM_Reject,
     /* 69501 */ // Label 75: @69501
     /* 69501 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(7), /*)*//*default:*//*Label 1790*/ GIMT_Encode4(69578),
     /* 69512 */ /*GILLT_v2s64*//*Label 1788*/ GIMT_Encode4(69524), GIMT_Encode4(0),
     /* 69520 */ /*GILLT_v4s32*//*Label 1789*/ GIMT_Encode4(69551),
     /* 69524 */ // Label 1788: @69524
     /* 69524 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(69550), // Rule ID 739 //
     /* 69529 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69532 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 69535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69539 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128DRegClassID),
     /* 69543 */   // (frint:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)  =>  (FRINT_D:{ *:[v2f64] } MSA128DOpnd:{ *:[v2f64] }:$ws)
     /* 69543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FRINT_D),
     /* 69548 */   GIR_RootConstrainSelectedInstOperands,
     /* 69549 */   // GIR_Coverage, 739,
     /* 69549 */   GIR_Done,
     /* 69550 */ // Label 1791: @69550
     /* 69550 */ GIM_Reject,
     /* 69551 */ // Label 1789: @69551
     /* 69551 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(69577), // Rule ID 738 //
     /* 69556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMSA_HasStdEnc),
     /* 69559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 69562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(Mips::MSA128WRegClassID),
     /* 69570 */   // (frint:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)  =>  (FRINT_W:{ *:[v4f32] } MSA128WOpnd:{ *:[v4f32] }:$ws)
     /* 69570 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::FRINT_W),
     /* 69575 */   GIR_RootConstrainSelectedInstOperands,
     /* 69576 */   // GIR_Coverage, 738,
     /* 69576 */   GIR_Done,
     /* 69577 */ // Label 1792: @69577
     /* 69577 */ GIM_Reject,
     /* 69578 */ // Label 1790: @69578
     /* 69578 */ GIM_Reject,
     /* 69579 */ // Label 76: @69579
     /* 69579 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(69594), // Rule ID 90 //
     /* 69584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdEnc_NotInMicroMips),
     /* 69587 */   // (trap)  =>  (TRAP)
     /* 69587 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::TRAP),
     /* 69592 */   GIR_RootConstrainSelectedInstOperands,
     /* 69593 */   // GIR_Coverage, 90,
     /* 69593 */   GIR_Done,
     /* 69594 */ // Label 1793: @69594
     /* 69594 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(69609), // Rule ID 1115 //
     /* 69599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMicroMips),
     /* 69602 */   // (trap)  =>  (TRAP_MM)
     /* 69602 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::TRAP_MM),
     /* 69607 */   GIR_RootConstrainSelectedInstOperands,
     /* 69608 */   // GIR_Coverage, 1115,
     /* 69608 */   GIR_Done,
     /* 69609 */ // Label 1794: @69609
     /* 69609 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(69624), // Rule ID 1906 //
     /* 69614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_InMips16Mode),
     /* 69617 */   // (trap)  =>  (Break16)
     /* 69617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(Mips::Break16),
     /* 69622 */   GIR_RootConstrainSelectedInstOperands,
     /* 69623 */   // GIR_Coverage, 1906,
     /* 69623 */   GIR_Done,
     /* 69624 */ // Label 1795: @69624
     /* 69624 */ GIM_Reject,
     /* 69625 */ // Label 77: @69625
     /* 69625 */ GIM_Reject,
     /* 69626 */ }; // Size: 69626 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const MipsSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const MipsSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
